<?php
class ControllerCatalogProduct {
	private static $error = array();

	public static function index() {
		load::language('catalog/product');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('catalog/product');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_catalog_product::addProduct(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_model'])) {
				$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_price'])) {
				$url .= '&filter_price=' . request::$get['filter_price'];
			}

			if (isset(request::$get['filter_quantity'])) {
				$url .= '&filter_quantity=' . request::$get['filter_quantity'];
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('catalog/product', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('catalog/product');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_catalog_product::editProduct(request::$get['product_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_model'])) {
				$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_price'])) {
				$url .= '&filter_price=' . request::$get['filter_price'];
			}

			if (isset(request::$get['filter_quantity'])) {
				$url .= '&filter_quantity=' . request::$get['filter_quantity'];
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('catalog/product', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('catalog/product');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $product_id) {
				admin_catalog_product::deleteProduct($product_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_model'])) {
				$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_price'])) {
				$url .= '&filter_price=' . request::$get['filter_price'];
			}

			if (isset(request::$get['filter_quantity'])) {
				$url .= '&filter_quantity=' . request::$get['filter_quantity'];
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('catalog/product', $url));
		}

		self::getList();
	}

	public static function copy() {
		load::language('catalog/product');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateCopy()) {
			foreach (request::$post['selected'] as $product_id) {
				admin_catalog_product::copyProduct($product_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_model'])) {
				$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_price'])) {
				$url .= '&filter_price=' . request::$get['filter_price'];
			}

			if (isset(request::$get['filter_quantity'])) {
				$url .= '&filter_quantity=' . request::$get['filter_quantity'];
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('catalog/product', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['filter_name'])) {
			$filter_name = request::$get['filter_name'];
		} else {
			$filter_name = '';
		}

		if (isset(request::$get['filter_model'])) {
			$filter_model = request::$get['filter_model'];
		} else {
			$filter_model = '';
		}

		if (isset(request::$get['filter_price'])) {
			$filter_price = request::$get['filter_price'];
		} else {
			$filter_price = '';
		}

		if (isset(request::$get['filter_quantity'])) {
			$filter_quantity = request::$get['filter_quantity'];
		} else {
			$filter_quantity = '';
		}

		if (isset(request::$get['filter_status'])) {
			$filter_status = request::$get['filter_status'];
		} else {
			$filter_status = '';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'pd.name';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_price'])) {
			$url .= '&filter_price=' . request::$get['filter_price'];
		}

		if (isset(request::$get['filter_quantity'])) {
			$url .= '&filter_quantity=' . request::$get['filter_quantity'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('catalog/product', $url)
		);

		$data['add'] = url::link('catalog/product/add', $url);
		$data['copy'] = url::link('catalog/product/copy', $url);
		$data['delete'] = url::link('catalog/product/delete', $url);

		$data['products'] = array();

		$filter_data = array(
			'filter_name'	  => $filter_name,
			'filter_model'	  => $filter_model,
			'filter_price'	  => $filter_price,
			'filter_quantity' => $filter_quantity,
			'filter_status'   => $filter_status,
			'sort'            => $sort,
			'order'           => $order,
			'start'           => ($page - 1) * config('limit_admin'),
			'limit'           => config('limit_admin')
		);


		$product_total = admin_catalog_product::getTotalProducts($filter_data);

		$results = admin_catalog_product::getProducts($filter_data);

		foreach ($results as $result) {
			if (is_file('image/' . $result['image'])) {
				$image = admin_tool_image::resize($result['image'], 40, 40);
			} else {
				$image = admin_tool_image::resize('no_image.png', 40, 40);
			}

			$special = false;

			$product_specials = admin_catalog_product::getProductSpecials($result['product_id']);

			foreach ($product_specials  as $product_special) {
				if (($product_special['date_start'] == '0000-00-00' || strtotime($product_special['date_start']) < time()) && ($product_special['date_end'] == '0000-00-00' || strtotime($product_special['date_end']) > time())) {
					$special = currency::format($product_special['price'], config('currency'));

					break;
				}
			}

			$data['products'][] = array(
				'product_id' => $result['product_id'],
				'image'      => $image,
				'name'       => $result['name'],
				'model'      => $result['model'],
				'price'      => currency::format($result['price'], config('currency')),
				'special'    => $special,
				'quantity'   => $result['quantity'],
				'status'     => $result['status'] ? language::get('text_enabled') : language::get('text_disabled'),
				'edit'       => url::link('catalog/product/edit', '&product_id=' . $result['product_id'] . $url)
			);
		}


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_price'])) {
			$url .= '&filter_price=' . request::$get['filter_price'];
		}

		if (isset(request::$get['filter_quantity'])) {
			$url .= '&filter_quantity=' . request::$get['filter_quantity'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_name'] = url::link('catalog/product', '&sort=pd.name' . $url);
		$data['sort_model'] = url::link('catalog/product', '&sort=p.model' . $url);
		$data['sort_price'] = url::link('catalog/product', '&sort=p.price' . $url);
		$data['sort_quantity'] = url::link('catalog/product', '&sort=p.quantity' . $url);
		$data['sort_status'] = url::link('catalog/product', '&sort=p.status' . $url);
		$data['sort_order'] = url::link('catalog/product', '&sort=p.sort_order' . $url);

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_price'])) {
			$url .= '&filter_price=' . request::$get['filter_price'];
		}

		if (isset(request::$get['filter_quantity'])) {
			$url .= '&filter_quantity=' . request::$get['filter_quantity'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $product_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('catalog/product', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($product_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($product_total - config('limit_admin'))) ? $product_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $product_total, ceil($product_total / config('limit_admin')));

		$data['filter_name'] = $filter_name;
		$data['filter_model'] = $filter_model;
		$data['filter_price'] = $filter_price;
		$data['filter_quantity'] = $filter_quantity;
		$data['filter_status'] = $filter_status;

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('catalog/product_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['product_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = array();
		}

		if (isset(self::$error['meta_title'])) {
			$data['error_meta_title'] = self::$error['meta_title'];
		} else {
			$data['error_meta_title'] = array();
		}

		if (isset(self::$error['model'])) {
			$data['error_model'] = self::$error['model'];
		} else {
			$data['error_model'] = '';
		}

		if (isset(self::$error['keyword'])) {
			$data['error_keyword'] = self::$error['keyword'];
		} else {
			$data['error_keyword'] = '';
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_price'])) {
			$url .= '&filter_price=' . request::$get['filter_price'];
		}

		if (isset(request::$get['filter_quantity'])) {
			$url .= '&filter_quantity=' . request::$get['filter_quantity'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('catalog/product', $url)
		);

		if (!isset(request::$get['product_id'])) {
			$data['action'] = url::link('catalog/product/add', $url);
		} else {
			$data['action'] = url::link('catalog/product/edit', '&product_id=' . request::$get['product_id'] . $url);
		}

		$data['cancel'] = url::link('catalog/product', $url);

		if (isset(request::$get['product_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$product_info = admin_catalog_product::getProduct(request::$get['product_id']);
		}



		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['product_description'])) {
			$data['product_description'] = request::$post['product_description'];
		} elseif (isset(request::$get['product_id'])) {
			$data['product_description'] = admin_catalog_product::getProductDescriptions(request::$get['product_id']);
		} else {
			$data['product_description'] = array();
		}

		if (isset(request::$post['model'])) {
			$data['model'] = request::$post['model'];
		} elseif (!empty($product_info)) {
			$data['model'] = $product_info['model'];
		} else {
			$data['model'] = '';
		}

		if (isset(request::$post['sku'])) {
			$data['sku'] = request::$post['sku'];
		} elseif (!empty($product_info)) {
			$data['sku'] = $product_info['sku'];
		} else {
			$data['sku'] = '';
		}

		if (isset(request::$post['upc'])) {
			$data['upc'] = request::$post['upc'];
		} elseif (!empty($product_info)) {
			$data['upc'] = $product_info['upc'];
		} else {
			$data['upc'] = '';
		}

		if (isset(request::$post['ean'])) {
			$data['ean'] = request::$post['ean'];
		} elseif (!empty($product_info)) {
			$data['ean'] = $product_info['ean'];
		} else {
			$data['ean'] = '';
		}

		if (isset(request::$post['jan'])) {
			$data['jan'] = request::$post['jan'];
		} elseif (!empty($product_info)) {
			$data['jan'] = $product_info['jan'];
		} else {
			$data['jan'] = '';
		}

		if (isset(request::$post['isbn'])) {
			$data['isbn'] = request::$post['isbn'];
		} elseif (!empty($product_info)) {
			$data['isbn'] = $product_info['isbn'];
		} else {
			$data['isbn'] = '';
		}

		if (isset(request::$post['mpn'])) {
			$data['mpn'] = request::$post['mpn'];
		} elseif (!empty($product_info)) {
			$data['mpn'] = $product_info['mpn'];
		} else {
			$data['mpn'] = '';
		}

		if (isset(request::$post['location'])) {
			$data['location'] = request::$post['location'];
		} elseif (!empty($product_info)) {
			$data['location'] = $product_info['location'];
		} else {
			$data['location'] = '';
		}


		$data['stores'] = array();

		$data['stores'][] = array(
			'store_id' => 0,
			'name'     => language::get('text_default')
		);

		$stores = admin_setting_store::getStores();

		foreach ($stores as $store) {
			$data['stores'][] = array(
				'store_id' => $store['store_id'],
				'name'     => $store['name']
			);
		}

		if (isset(request::$post['product_store'])) {
			$data['product_store'] = request::$post['product_store'];
		} elseif (isset(request::$get['product_id'])) {
			$data['product_store'] = admin_catalog_product::getProductStores(request::$get['product_id']);
		} else {
			$data['product_store'] = array(0);
		}

		if (isset(request::$post['shipping'])) {
			$data['shipping'] = request::$post['shipping'];
		} elseif (!empty($product_info)) {
			$data['shipping'] = $product_info['shipping'];
		} else {
			$data['shipping'] = 1;
		}

		if (isset(request::$post['price'])) {
			$data['price'] = request::$post['price'];
		} elseif (!empty($product_info)) {
			$data['price'] = $product_info['price'];
		} else {
			$data['price'] = '';
		}


		$data['recurrings'] = admin_catalog_recurring::getRecurrings();

		if (isset(request::$post['product_recurrings'])) {
			$data['product_recurrings'] = request::$post['product_recurrings'];
		} elseif (!empty($product_info)) {
			$data['product_recurrings'] = admin_catalog_product::getRecurrings($product_info['product_id']);
		} else {
			$data['product_recurrings'] = array();
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['tax_class_id'])) {
			$data['tax_class_id'] = request::$post['tax_class_id'];
		} elseif (!empty($product_info)) {
			$data['tax_class_id'] = $product_info['tax_class_id'];
		} else {
			$data['tax_class_id'] = 0;
		}

		if (isset(request::$post['date_available'])) {
			$data['date_available'] = request::$post['date_available'];
		} elseif (!empty($product_info)) {
			$data['date_available'] = ($product_info['date_available'] != '0000-00-00') ? $product_info['date_available'] : '';
		} else {
			$data['date_available'] = date('Y-m-d');
		}

		if (isset(request::$post['quantity'])) {
			$data['quantity'] = request::$post['quantity'];
		} elseif (!empty($product_info)) {
			$data['quantity'] = $product_info['quantity'];
		} else {
			$data['quantity'] = 1;
		}

		if (isset(request::$post['minimum'])) {
			$data['minimum'] = request::$post['minimum'];
		} elseif (!empty($product_info)) {
			$data['minimum'] = $product_info['minimum'];
		} else {
			$data['minimum'] = 1;
		}

		if (isset(request::$post['subtract'])) {
			$data['subtract'] = request::$post['subtract'];
		} elseif (!empty($product_info)) {
			$data['subtract'] = $product_info['subtract'];
		} else {
			$data['subtract'] = 1;
		}

		if (isset(request::$post['sort_order'])) {
			$data['sort_order'] = request::$post['sort_order'];
		} elseif (!empty($product_info)) {
			$data['sort_order'] = $product_info['sort_order'];
		} else {
			$data['sort_order'] = 1;
		}


		$data['stock_statuses'] = admin_localisation_stock_status::getStockStatuses();

		if (isset(request::$post['stock_status_id'])) {
			$data['stock_status_id'] = request::$post['stock_status_id'];
		} elseif (!empty($product_info)) {
			$data['stock_status_id'] = $product_info['stock_status_id'];
		} else {
			$data['stock_status_id'] = 0;
		}

		if (isset(request::$post['status'])) {
			$data['status'] = request::$post['status'];
		} elseif (!empty($product_info)) {
			$data['status'] = $product_info['status'];
		} else {
			$data['status'] = true;
		}

		if (isset(request::$post['weight'])) {
			$data['weight'] = request::$post['weight'];
		} elseif (!empty($product_info)) {
			$data['weight'] = $product_info['weight'];
		} else {
			$data['weight'] = '';
		}


		$data['weight_classes'] = admin_localisation_weight_class::getWeightClasses();

		if (isset(request::$post['weight_class_id'])) {
			$data['weight_class_id'] = request::$post['weight_class_id'];
		} elseif (!empty($product_info)) {
			$data['weight_class_id'] = $product_info['weight_class_id'];
		} else {
			$data['weight_class_id'] = config('weight_class_id');
		}

		if (isset(request::$post['length'])) {
			$data['length'] = request::$post['length'];
		} elseif (!empty($product_info)) {
			$data['length'] = $product_info['length'];
		} else {
			$data['length'] = '';
		}

		if (isset(request::$post['width'])) {
			$data['width'] = request::$post['width'];
		} elseif (!empty($product_info)) {
			$data['width'] = $product_info['width'];
		} else {
			$data['width'] = '';
		}

		if (isset(request::$post['height'])) {
			$data['height'] = request::$post['height'];
		} elseif (!empty($product_info)) {
			$data['height'] = $product_info['height'];
		} else {
			$data['height'] = '';
		}


		$data['length_classes'] = admin_localisation_length_class::getLengthClasses();

		if (isset(request::$post['length_class_id'])) {
			$data['length_class_id'] = request::$post['length_class_id'];
		} elseif (!empty($product_info)) {
			$data['length_class_id'] = $product_info['length_class_id'];
		} else {
			$data['length_class_id'] = config('length_class_id');
		}


		if (isset(request::$post['manufacturer_id'])) {
			$data['manufacturer_id'] = request::$post['manufacturer_id'];
		} elseif (!empty($product_info)) {
			$data['manufacturer_id'] = $product_info['manufacturer_id'];
		} else {
			$data['manufacturer_id'] = 0;
		}

		if (isset(request::$post['manufacturer'])) {
			$data['manufacturer'] = request::$post['manufacturer'];
		} elseif (!empty($product_info)) {
			$manufacturer_info = admin_catalog_manufacturer::getManufacturer($product_info['manufacturer_id']);

			if ($manufacturer_info) {
				$data['manufacturer'] = $manufacturer_info['name'];
			} else {
				$data['manufacturer'] = '';
			}
		} else {
			$data['manufacturer'] = '';
		}

		// Categories

		if (isset(request::$post['product_category'])) {
			$categories = request::$post['product_category'];
		} elseif (isset(request::$get['product_id'])) {
			$categories = admin_catalog_product::getProductCategories(request::$get['product_id']);
		} else {
			$categories = array();
		}

		$data['product_categories'] = array();

		foreach ($categories as $category_id) {
			$category_info = admin_catalog_category::getCategory($category_id);

			if ($category_info) {
				$data['product_categories'][] = array(
					'category_id' => $category_info['category_id'],
					'name'        => ($category_info['path']) ? $category_info['path'] . ' &gt; ' . $category_info['name'] : $category_info['name']
				);
			}
		}

		// Filters

		if (isset(request::$post['product_filter'])) {
			$filters = request::$post['product_filter'];
		} elseif (isset(request::$get['product_id'])) {
			$filters = admin_catalog_product::getProductFilters(request::$get['product_id']);
		} else {
			$filters = array();
		}

		$data['product_filters'] = array();

		foreach ($filters as $filter_id) {
			$filter_info = admin_catalog_filter::getFilter($filter_id);

			if ($filter_info) {
				$data['product_filters'][] = array(
					'filter_id' => $filter_info['filter_id'],
					'name'      => $filter_info['group'] . ' &gt; ' . $filter_info['name']
				);
			}
		}

		// Attributes

		if (isset(request::$post['product_attribute'])) {
			$product_attributes = request::$post['product_attribute'];
		} elseif (isset(request::$get['product_id'])) {
			$product_attributes = admin_catalog_product::getProductAttributes(request::$get['product_id']);
		} else {
			$product_attributes = array();
		}

		$data['product_attributes'] = array();

		foreach ($product_attributes as $product_attribute) {
			$attribute_info = admin_catalog_attribute::getAttribute($product_attribute['attribute_id']);

			if ($attribute_info) {
				$data['product_attributes'][] = array(
					'attribute_id'                  => $product_attribute['attribute_id'],
					'name'                          => $attribute_info['name'],
					'product_attribute_description' => $product_attribute['product_attribute_description']
				);
			}
		}

		// Options

		if (isset(request::$post['product_option'])) {
			$product_options = request::$post['product_option'];
		} elseif (isset(request::$get['product_id'])) {
			$product_options = admin_catalog_product::getProductOptions(request::$get['product_id']);
		} else {
			$product_options = array();
		}

		$data['product_options'] = array();

		foreach ($product_options as $product_option) {
			$product_option_value_data = array();

			if (isset($product_option['product_option_value'])) {
				foreach ($product_option['product_option_value'] as $product_option_value) {
					$product_option_value_data[] = array(
						'product_option_value_id' => $product_option_value['product_option_value_id'],
						'option_value_id'         => $product_option_value['option_value_id'],
						'quantity'                => $product_option_value['quantity'],
						'subtract'                => $product_option_value['subtract'],
						'price'                   => $product_option_value['price'],
						'price_prefix'            => $product_option_value['price_prefix'],
						'points'                  => $product_option_value['points'],
						'points_prefix'           => $product_option_value['points_prefix'],
						'weight'                  => $product_option_value['weight'],
						'weight_prefix'           => $product_option_value['weight_prefix']
					);
				}
			}

			$data['product_options'][] = array(
				'product_option_id'    => $product_option['product_option_id'],
				'product_option_value' => $product_option_value_data,
				'option_id'            => $product_option['option_id'],
				'name'                 => $product_option['name'],
				'type'                 => $product_option['type'],
				'value'                => isset($product_option['value']) ? $product_option['value'] : '',
				'required'             => $product_option['required']
			);
		}

		$data['option_values'] = array();

		foreach ($data['product_options'] as $product_option) {
			if ($product_option['type'] == 'select' || $product_option['type'] == 'radio' || $product_option['type'] == 'checkbox' || $product_option['type'] == 'image') {
				if (!isset($data['option_values'][$product_option['option_id']])) {
					$data['option_values'][$product_option['option_id']] = admin_catalog_option::getOptionValues($product_option['option_id']);
				}
			}
		}


		$data['customer_groups'] = admin_customer_customer_group::getCustomerGroups();

		if (isset(request::$post['product_discount'])) {
			$product_discounts = request::$post['product_discount'];
		} elseif (isset(request::$get['product_id'])) {
			$product_discounts = admin_catalog_product::getProductDiscounts(request::$get['product_id']);
		} else {
			$product_discounts = array();
		}

		$data['product_discounts'] = array();

		foreach ($product_discounts as $product_discount) {
			$data['product_discounts'][] = array(
				'customer_group_id' => $product_discount['customer_group_id'],
				'quantity'          => $product_discount['quantity'],
				'priority'          => $product_discount['priority'],
				'price'             => $product_discount['price'],
				'date_start'        => ($product_discount['date_start'] != '0000-00-00') ? $product_discount['date_start'] : '',
				'date_end'          => ($product_discount['date_end'] != '0000-00-00') ? $product_discount['date_end'] : ''
			);
		}

		if (isset(request::$post['product_special'])) {
			$product_specials = request::$post['product_special'];
		} elseif (isset(request::$get['product_id'])) {
			$product_specials = admin_catalog_product::getProductSpecials(request::$get['product_id']);
		} else {
			$product_specials = array();
		}

		$data['product_specials'] = array();

		foreach ($product_specials as $product_special) {
			$data['product_specials'][] = array(
				'customer_group_id' => $product_special['customer_group_id'],
				'priority'          => $product_special['priority'],
				'price'             => $product_special['price'],
				'date_start'        => ($product_special['date_start'] != '0000-00-00') ? $product_special['date_start'] : '',
				'date_end'          => ($product_special['date_end'] != '0000-00-00') ? $product_special['date_end'] :  ''
			);
		}

		// Image
		if (isset(request::$post['image'])) {
			$data['image'] = request::$post['image'];
		} elseif (!empty($product_info)) {
			$data['image'] = $product_info['image'];
		} else {
			$data['image'] = '';
		}


		if (isset(request::$post['image']) && is_file('image/' . request::$post['image'])) {
			$data['thumb'] = admin_tool_image::resize(request::$post['image'], 100, 100);
		} elseif (!empty($product_info) && is_file('image/' . $product_info['image'])) {
			$data['thumb'] = admin_tool_image::resize($product_info['image'], 100, 100);
		} else {
			$data['thumb'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		$data['placeholder'] = admin_tool_image::resize('no_image.png', 100, 100);

		// Images
		if (isset(request::$post['product_image'])) {
			$product_images = request::$post['product_image'];
		} elseif (isset(request::$get['product_id'])) {
			$product_images = admin_catalog_product::getProductImages(request::$get['product_id']);
		} else {
			$product_images = array();
		}

		$data['product_images'] = array();

		foreach ($product_images as $product_image) {
			if (is_file('image/' . $product_image['image'])) {
				$image = $product_image['image'];
				$thumb = $product_image['image'];
			} else {
				$image = '';
				$thumb = 'no_image.png';
			}

			$data['product_images'][] = array(
				'image'      => $image,
				'thumb'      => admin_tool_image::resize($thumb, 100, 100),
				'sort_order' => $product_image['sort_order']
			);
		}

		// Downloads

		if (isset(request::$post['product_download'])) {
			$product_downloads = request::$post['product_download'];
		} elseif (isset(request::$get['product_id'])) {
			$product_downloads = admin_catalog_product::getProductDownloads(request::$get['product_id']);
		} else {
			$product_downloads = array();
		}

		$data['product_downloads'] = array();

		foreach ($product_downloads as $download_id) {
			$download_info = admin_catalog_download::getDownload($download_id);

			if ($download_info) {
				$data['product_downloads'][] = array(
					'download_id' => $download_info['download_id'],
					'name'        => $download_info['name']
				);
			}
		}

		if (isset(request::$post['product_related'])) {
			$products = request::$post['product_related'];
		} elseif (isset(request::$get['product_id'])) {
			$products = admin_catalog_product::getProductRelated(request::$get['product_id']);
		} else {
			$products = array();
		}

		$data['product_relateds'] = array();

		foreach ($products as $product_id) {
			$related_info = admin_catalog_product::getProduct($product_id);

			if ($related_info) {
				$data['product_relateds'][] = array(
					'product_id' => $related_info['product_id'],
					'name'       => $related_info['name']
				);
			}
		}

		if (isset(request::$post['points'])) {
			$data['points'] = request::$post['points'];
		} elseif (!empty($product_info)) {
			$data['points'] = $product_info['points'];
		} else {
			$data['points'] = '';
		}

		if (isset(request::$post['product_reward'])) {
			$data['product_reward'] = request::$post['product_reward'];
		} elseif (isset(request::$get['product_id'])) {
			$data['product_reward'] = admin_catalog_product::getProductRewards(request::$get['product_id']);
		} else {
			$data['product_reward'] = array();
		}

		if (isset(request::$post['product_seo_url'])) {
			$data['product_seo_url'] = request::$post['product_seo_url'];
		} elseif (isset(request::$get['product_id'])) {
			$data['product_seo_url'] = admin_catalog_product::getProductSeoUrls(request::$get['product_id']);
		} else {
			$data['product_seo_url'] = array();
		}

		if (isset(request::$post['product_layout'])) {
			$data['product_layout'] = request::$post['product_layout'];
		} elseif (isset(request::$get['product_id'])) {
			$data['product_layout'] = admin_catalog_product::getProductLayouts(request::$get['product_id']);
		} else {
			$data['product_layout'] = array();
		}


		$data['layouts'] = admin_design_layout::getLayouts();

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('catalog/product_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'catalog/product')) {
			self::$error['warning'] = language::get('error_permission');
		}

		foreach (request::$post['product_description'] as $language_id => $value) {
			if ((utf8_strlen($value['name']) < 1) || (utf8_strlen($value['name']) > 255)) {
				self::$error['name'][$language_id] = language::get('error_name');
			}

			if ((utf8_strlen($value['meta_title']) < 1) || (utf8_strlen($value['meta_title']) > 255)) {
				self::$error['meta_title'][$language_id] = language::get('error_meta_title');
			}
		}

		if ((utf8_strlen(request::$post['model']) < 1) || (utf8_strlen(request::$post['model']) > 64)) {
			self::$error['model'] = language::get('error_model');
		}

		if (request::$post['product_seo_url']) {

			foreach (request::$post['product_seo_url'] as $store_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						if (count(array_keys($language, $keyword)) > 1) {
							self::$error['keyword'][$store_id][$language_id] = language::get('error_unique');
						}

						$seo_urls = admin_design_seo_url::getSeoUrlsByKeyword($keyword);

						foreach ($seo_urls as $seo_url) {
							if (($seo_url['store_id'] == $store_id) && (!isset(request::$get['product_id']) || (($seo_url['query'] != 'product_id=' . request::$get['product_id'])))) {
								self::$error['keyword'][$store_id][$language_id] = language::get('error_keyword');

								break;
							}
						}
					}
				}
			}
		}

		if (self::$error && !isset(self::$error['warning'])) {
			self::$error['warning'] = language::get('error_warning');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'catalog/product')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	protected static function validateCopy() {
		if (!user::hasPermission('modify', 'catalog/product')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	public static function autocomplete() {
		$json = array();

		if (isset(request::$get['filter_name']) || isset(request::$get['filter_model'])) {

			if (isset(request::$get['filter_name'])) {
				$filter_name = request::$get['filter_name'];
			} else {
				$filter_name = '';
			}

			if (isset(request::$get['filter_model'])) {
				$filter_model = request::$get['filter_model'];
			} else {
				$filter_model = '';
			}

			if (isset(request::$get['limit'])) {
				$limit = (int)request::$get['limit'];
			} else {
				$limit = 5;
			}

			$filter_data = array(
				'filter_name'  => $filter_name,
				'filter_model' => $filter_model,
				'start'        => 0,
				'limit'        => $limit
			);

			$results = admin_catalog_product::getProducts($filter_data);

			foreach ($results as $result) {
				$option_data = array();

				$product_options = admin_catalog_product::getProductOptions($result['product_id']);

				foreach ($product_options as $product_option) {
					$option_info = admin_catalog_option::getOption($product_option['option_id']);

					if ($option_info) {
						$product_option_value_data = array();

						foreach ($product_option['product_option_value'] as $product_option_value) {
							$option_value_info = admin_catalog_option::getOptionValue($product_option_value['option_value_id']);

							if ($option_value_info) {
								$product_option_value_data[] = array(
									'product_option_value_id' => $product_option_value['product_option_value_id'],
									'option_value_id'         => $product_option_value['option_value_id'],
									'name'                    => $option_value_info['name'],
									'price'                   => (float)$product_option_value['price'] ? currency::format($product_option_value['price'], config('currency')) : false,
									'price_prefix'            => $product_option_value['price_prefix']
								);
							}
						}

						$option_data[] = array(
							'product_option_id'    => $product_option['product_option_id'],
							'product_option_value' => $product_option_value_data,
							'option_id'            => $product_option['option_id'],
							'name'                 => $option_info['name'],
							'type'                 => $option_info['type'],
							'value'                => $product_option['value'],
							'required'             => $product_option['required']
						);
					}
				}

				$json[] = array(
					'product_id' => $result['product_id'],
					'name'       => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8')),
					'model'      => $result['model'],
					'option'     => $option_data,
					'price'      => $result['price']
				);
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
