<?php
class ControllerCatalogReview {
	private static $error = array();

	public static function index() {
		load::language('catalog/review');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('catalog/review');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_catalog_review::addReview(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_product'])) {
				$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_author'])) {
				$url .= '&filter_author=' . urlencode(html_entity_decode(request::$get['filter_author'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('catalog/review', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('catalog/review');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_catalog_review::editReview(request::$get['review_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_product'])) {
				$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_author'])) {
				$url .= '&filter_author=' . urlencode(html_entity_decode(request::$get['filter_author'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('catalog/review', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('catalog/review');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $review_id) {
				admin_catalog_review::deleteReview($review_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_product'])) {
				$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_author'])) {
				$url .= '&filter_author=' . urlencode(html_entity_decode(request::$get['filter_author'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('catalog/review', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['filter_product'])) {
			$filter_product = request::$get['filter_product'];
		} else {
			$filter_product = '';
		}

		if (isset(request::$get['filter_author'])) {
			$filter_author = request::$get['filter_author'];
		} else {
			$filter_author = '';
		}

		if (isset(request::$get['filter_status'])) {
			$filter_status = request::$get['filter_status'];
		} else {
			$filter_status = '';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'DESC';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'r.date_added';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['filter_product'])) {
			$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_author'])) {
			$url .= '&filter_author=' . urlencode(html_entity_decode(request::$get['filter_author'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('catalog/review', $url)
		);

		$data['add'] = url::link('catalog/review/add', $url);
		$data['delete'] = url::link('catalog/review/delete', $url);

		$data['reviews'] = array();

		$filter_data = array(
			'filter_product'    => $filter_product,
			'filter_author'     => $filter_author,
			'filter_status'     => $filter_status,
			'filter_date_added' => $filter_date_added,
			'sort'              => $sort,
			'order'             => $order,
			'start'             => ($page - 1) * config('limit_admin'),
			'limit'             => config('limit_admin')
		);

		$review_total = admin_catalog_review::getTotalReviews($filter_data);

		$results = admin_catalog_review::getReviews($filter_data);

		foreach ($results as $result) {
			$data['reviews'][] = array(
				'review_id'  => $result['review_id'],
				'name'       => $result['name'],
				'author'     => $result['author'],
				'rating'     => $result['rating'],
				'status'     => ($result['status']) ? language::get('text_enabled') : language::get('text_disabled'),
				'date_added' => date(language::get('date_format_short'), strtotime($result['date_added'])),
				'edit'       => url::link('catalog/review/edit', '&review_id=' . $result['review_id'] . $url)
			);
		}


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_product'])) {
			$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_author'])) {
			$url .= '&filter_author=' . urlencode(html_entity_decode(request::$get['filter_author'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_product'] = url::link('catalog/review', '&sort=pd.name' . $url);
		$data['sort_author'] = url::link('catalog/review', '&sort=r.author' . $url);
		$data['sort_rating'] = url::link('catalog/review', '&sort=r.rating' . $url);
		$data['sort_status'] = url::link('catalog/review', '&sort=r.status' . $url);
		$data['sort_date_added'] = url::link('catalog/review', '&sort=r.date_added' . $url);

		$url = '';

		if (isset(request::$get['filter_product'])) {
			$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_author'])) {
			$url .= '&filter_author=' . urlencode(html_entity_decode(request::$get['filter_author'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $review_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('catalog/review', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($review_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($review_total - config('limit_admin'))) ? $review_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $review_total, ceil($review_total / config('limit_admin')));

		$data['filter_product'] = $filter_product;
		$data['filter_author'] = $filter_author;
		$data['filter_status'] = $filter_status;
		$data['filter_date_added'] = $filter_date_added;

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('catalog/review_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['review_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['product'])) {
			$data['error_product'] = self::$error['product'];
		} else {
			$data['error_product'] = '';
		}

		if (isset(self::$error['author'])) {
			$data['error_author'] = self::$error['author'];
		} else {
			$data['error_author'] = '';
		}

		if (isset(self::$error['text'])) {
			$data['error_text'] = self::$error['text'];
		} else {
			$data['error_text'] = '';
		}

		if (isset(self::$error['rating'])) {
			$data['error_rating'] = self::$error['rating'];
		} else {
			$data['error_rating'] = '';
		}

		$url = '';

		if (isset(request::$get['filter_product'])) {
			$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_author'])) {
			$url .= '&filter_author=' . urlencode(html_entity_decode(request::$get['filter_author'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('catalog/review', $url)
		);

		if (!isset(request::$get['review_id'])) {
			$data['action'] = url::link('catalog/review/add', $url);
		} else {
			$data['action'] = url::link('catalog/review/edit', '&review_id=' . request::$get['review_id'] . $url);
		}

		$data['cancel'] = url::link('catalog/review', $url);

		if (isset(request::$get['review_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$review_info = admin_catalog_review::getReview(request::$get['review_id']);
		}



		if (isset(request::$post['product_id'])) {
			$data['product_id'] = request::$post['product_id'];
		} elseif (!empty($review_info)) {
			$data['product_id'] = $review_info['product_id'];
		} else {
			$data['product_id'] = '';
		}

		if (isset(request::$post['product'])) {
			$data['product'] = request::$post['product'];
		} elseif (!empty($review_info)) {
			$data['product'] = $review_info['product'];
		} else {
			$data['product'] = '';
		}

		if (isset(request::$post['author'])) {
			$data['author'] = request::$post['author'];
		} elseif (!empty($review_info)) {
			$data['author'] = $review_info['author'];
		} else {
			$data['author'] = '';
		}

		if (isset(request::$post['text'])) {
			$data['text'] = request::$post['text'];
		} elseif (!empty($review_info)) {
			$data['text'] = $review_info['text'];
		} else {
			$data['text'] = '';
		}

		if (isset(request::$post['rating'])) {
			$data['rating'] = request::$post['rating'];
		} elseif (!empty($review_info)) {
			$data['rating'] = $review_info['rating'];
		} else {
			$data['rating'] = '';
		}

		if (isset(request::$post['date_added'])) {
			$data['date_added'] = request::$post['date_added'];
		} elseif (!empty($review_info)) {
			$data['date_added'] = ($review_info['date_added'] != '0000-00-00 00:00' ? $review_info['date_added'] : '');
		} else {
			$data['date_added'] = '';
		}

		if (isset(request::$post['status'])) {
			$data['status'] = request::$post['status'];
		} elseif (!empty($review_info)) {
			$data['status'] = $review_info['status'];
		} else {
			$data['status'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('catalog/review_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'catalog/review')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['product_id']) {
			self::$error['product'] = language::get('error_product');
		}

		if ((utf8_strlen(request::$post['author']) < 3) || (utf8_strlen(request::$post['author']) > 64)) {
			self::$error['author'] = language::get('error_author');
		}

		if (utf8_strlen(request::$post['text']) < 1) {
			self::$error['text'] = language::get('error_text');
		}

		if (!isset(request::$post['rating']) || request::$post['rating'] < 0 || request::$post['rating'] > 5) {
			self::$error['rating'] = language::get('error_rating');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'catalog/review')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}
