<?php
class ControllerCommonColumnLeft {
	public static function index() {
		if (user::isLogged()) {
			load::language('common/column_left');

			// Create a 3 level menu array
			// Level 2 can not have children

			// Menu
			$data['menus'][] = array(
				'id'       => 'menu-dashboard',
				'icon'	   => 'fa-dashboard',
				'name'	   => language::get('text_dashboard'),
				'href'     => url::link('common/dashboard'),
				'children' => array()
			);

			// Catalog
			$catalog = array();

			if (user::hasPermission('access', 'catalog/category')) {
				$catalog[] = array(
					'name'	   => language::get('text_category'),
					'href'     => url::link('catalog/category'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'catalog/product')) {
				$catalog[] = array(
					'name'	   => language::get('text_product'),
					'href'     => url::link('catalog/product'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'catalog/recurring')) {
				$catalog[] = array(
					'name'	   => language::get('text_recurring'),
					'href'     => url::link('catalog/recurring'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'catalog/filter')) {
				$catalog[] = array(
					'name'	   => language::get('text_filter'),
					'href'     => url::link('catalog/filter'),
					'children' => array()
				);
			}

			// Attributes
			$attribute = array();

			if (user::hasPermission('access', 'catalog/attribute')) {
				$attribute[] = array(
					'name'     => language::get('text_attribute'),
					'href'     => url::link('catalog/attribute'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'catalog/attribute_group')) {
				$attribute[] = array(
					'name'	   => language::get('text_attribute_group'),
					'href'     => url::link('catalog/attribute_group'),
					'children' => array()
				);
			}

			if ($attribute) {
				$catalog[] = array(
					'name'	   => language::get('text_attribute'),
					'href'     => '',
					'children' => $attribute
				);
			}

			if (user::hasPermission('access', 'catalog/option')) {
				$catalog[] = array(
					'name'	   => language::get('text_option'),
					'href'     => url::link('catalog/option'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'catalog/manufacturer')) {
				$catalog[] = array(
					'name'	   => language::get('text_manufacturer'),
					'href'     => url::link('catalog/manufacturer'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'catalog/download')) {
				$catalog[] = array(
					'name'	   => language::get('text_download'),
					'href'     => url::link('catalog/download'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'catalog/review')) {
				$catalog[] = array(
					'name'	   => language::get('text_review'),
					'href'     => url::link('catalog/review'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'catalog/information')) {
				$catalog[] = array(
					'name'	   => language::get('text_information'),
					'href'     => url::link('catalog/information'),
					'children' => array()
				);
			}

			if ($catalog) {
				$data['menus'][] = array(
					'id'       => 'menu-catalog',
					'icon'	   => 'fa-tags',
					'name'	   => language::get('text_catalog'),
					'href'     => '',
					'children' => $catalog
				);
			}

			// Extension
			$marketplace = array();

			if (user::hasPermission('access', 'marketplace/marketplace')) {
				$marketplace[] = array(
					'name'	   => language::get('text_marketplace'),
					'href'     => url::link('marketplace/marketplace'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'marketplace/installer')) {
				$marketplace[] = array(
					'name'	   => language::get('text_installer'),
					'href'     => url::link('marketplace/installer'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'marketplace/extension')) {
				$marketplace[] = array(
					'name'	   => language::get('text_extension'),
					'href'     => url::link('marketplace/extension'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'marketplace/modification')) {
				$marketplace[] = array(
					'name'	   => language::get('text_modification'),
					'href'     => url::link('marketplace/modification'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'marketplace/event')) {
				$marketplace[] = array(
					'name'	   => language::get('text_event'),
					'href'     => url::link('marketplace/event'),
					'children' => array()
				);
			}

			if ($marketplace) {
				$data['menus'][] = array(
					'id'       => 'menu-extension',
					'icon'	   => 'fa-puzzle-piece',
					'name'	   => language::get('text_extension'),
					'href'     => '',
					'children' => $marketplace
				);
			}

			// Design
			$design = array();

			if (user::hasPermission('access', 'design/layout')) {
				$design[] = array(
					'name'	   => language::get('text_layout'),
					'href'     => url::link('design/layout'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'design/theme')) {
				$design[] = array(
					'name'	   => language::get('text_theme'),
					'href'     => url::link('design/theme'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'design/translation')) {
				$design[] = array(
					'name'	   => language::get('text_language_editor'),
					'href'     => url::link('design/translation'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'design/banner')) {
				$design[] = array(
					'name'	   => language::get('text_banner'),
					'href'     => url::link('design/banner'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'design/seo_url')) {
				$design[] = array(
					'name'	   => language::get('text_seo_url'),
					'href'     => url::link('design/seo_url'),
					'children' => array()
				);
			}

			if ($design) {
				$data['menus'][] = array(
					'id'       => 'menu-design',
					'icon'	   => 'fa-television',
					'name'	   => language::get('text_design'),
					'href'     => '',
					'children' => $design
				);
			}

			// Sales
			$sale = array();

			if (user::hasPermission('access', 'sale/order')) {
				$sale[] = array(
					'name'	   => language::get('text_order'),
					'href'     => url::link('sale/order'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'sale/recurring')) {
				$sale[] = array(
					'name'	   => language::get('text_order_recurring'),
					'href'     => url::link('sale/recurring'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'sale/return')) {
				$sale[] = array(
					'name'	   => language::get('text_return'),
					'href'     => url::link('sale/return'),
					'children' => array()
				);
			}

			// Voucher
			$voucher = array();

			if (user::hasPermission('access', 'sale/voucher')) {
				$voucher[] = array(
					'name'	   => language::get('text_voucher'),
					'href'     => url::link('sale/voucher'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'sale/voucher_theme')) {
				$voucher[] = array(
					'name'	   => language::get('text_voucher_theme'),
					'href'     => url::link('sale/voucher_theme'),
					'children' => array()
				);
			}

			if ($voucher) {
				$sale[] = array(
					'name'	   => language::get('text_voucher'),
					'href'     => '',
					'children' => $voucher
				);
			}

			if ($sale) {
				$data['menus'][] = array(
					'id'       => 'menu-sale',
					'icon'	   => 'fa-shopping-cart',
					'name'	   => language::get('text_sale'),
					'href'     => '',
					'children' => $sale
				);
			}

			// Customer
			$customer = array();

			if (user::hasPermission('access', 'customer/customer')) {
				$customer[] = array(
					'name'	   => language::get('text_customer'),
					'href'     => url::link('customer/customer'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'customer/customer_group')) {
				$customer[] = array(
					'name'	   => language::get('text_customer_group'),
					'href'     => url::link('customer/customer_group'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'customer/customer_approval')) {
				$customer[] = array(
					'name'	   => language::get('text_customer_approval'),
					'href'     => url::link('customer/customer_approval'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'customer/custom_field')) {
				$customer[] = array(
					'name'	   => language::get('text_custom_field'),
					'href'     => url::link('customer/custom_field'),
					'children' => array()
				);
			}

			if ($customer) {
				$data['menus'][] = array(
					'id'       => 'menu-customer',
					'icon'	   => 'fa-user',
					'name'	   => language::get('text_customer'),
					'href'     => '',
					'children' => $customer
				);
			}

			// Marketing
			$marketing = array();

			if (user::hasPermission('access', 'marketing/marketing')) {
				$marketing[] = array(
					'name'	   => language::get('text_marketing'),
					'href'     => url::link('marketing/marketing'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'marketing/coupon')) {
				$marketing[] = array(
					'name'	   => language::get('text_coupon'),
					'href'     => url::link('marketing/coupon'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'marketing/contact')) {
				$marketing[] = array(
					'name'	   => language::get('text_contact'),
					'href'     => url::link('marketing/contact'),
					'children' => array()
				);
			}

			if ($marketing) {
				$data['menus'][] = array(
					'id'       => 'menu-marketing',
					'icon'	   => 'fa-share-alt',
					'name'	   => language::get('text_marketing'),
					'href'     => '',
					'children' => $marketing
				);
			}

			// System
			$system = array();

			if (user::hasPermission('access', 'setting/setting')) {
				$system[] = array(
					'name'	   => language::get('text_setting'),
					'href'     => url::link('setting/store'),
					'children' => array()
				);
			}

			// Users
			$user = array();

			if (user::hasPermission('access', 'user/user')) {
				$user[] = array(
					'name'	   => language::get('text_users'),
					'href'     => url::link('user/user'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'user/user_permission')) {
				$user[] = array(
					'name'	   => language::get('text_user_group'),
					'href'     => url::link('user/user_permission'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'user/api')) {
				$user[] = array(
					'name'	   => language::get('text_api'),
					'href'     => url::link('user/api'),
					'children' => array()
				);
			}

			if ($user) {
				$system[] = array(
					'name'	   => language::get('text_users'),
					'href'     => '',
					'children' => $user
				);
			}

			// Localisation
			$localisation = array();

			if (user::hasPermission('access', 'localisation/location')) {
				$localisation[] = array(
					'name'	   => language::get('text_location'),
					'href'     => url::link('localisation/location'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/language')) {
				$localisation[] = array(
					'name'	   => language::get('text_language'),
					'href'     => url::link('localisation/language'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/currency')) {
				$localisation[] = array(
					'name'	   => language::get('text_currency'),
					'href'     => url::link('localisation/currency'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/stock_status')) {
				$localisation[] = array(
					'name'	   => language::get('text_stock_status'),
					'href'     => url::link('localisation/stock_status'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/order_status')) {
				$localisation[] = array(
					'name'	   => language::get('text_order_status'),
					'href'     => url::link('localisation/order_status'),
					'children' => array()
				);
			}

			// Returns
			$return = array();

			if (user::hasPermission('access', 'localisation/return_status')) {
				$return[] = array(
					'name'	   => language::get('text_return_status'),
					'href'     => url::link('localisation/return_status'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/return_action')) {
				$return[] = array(
					'name'	   => language::get('text_return_action'),
					'href'     => url::link('localisation/return_action'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/return_reason')) {
				$return[] = array(
					'name'	   => language::get('text_return_reason'),
					'href'     => url::link('localisation/return_reason'),
					'children' => array()
				);
			}

			if ($return) {
				$localisation[] = array(
					'name'	   => language::get('text_return'),
					'href'     => '',
					'children' => $return
				);
			}

			if (user::hasPermission('access', 'localisation/country')) {
				$localisation[] = array(
					'name'	   => language::get('text_country'),
					'href'     => url::link('localisation/country'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/zone')) {
				$localisation[] = array(
					'name'	   => language::get('text_zone'),
					'href'     => url::link('localisation/zone'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/geo_zone')) {
				$localisation[] = array(
					'name'	   => language::get('text_geo_zone'),
					'href'     => url::link('localisation/geo_zone'),
					'children' => array()
				);
			}

			// Tax
			$tax = array();

			if (user::hasPermission('access', 'localisation/tax_class')) {
				$tax[] = array(
					'name'	   => language::get('text_tax_class'),
					'href'     => url::link('localisation/tax_class'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/tax_rate')) {
				$tax[] = array(
					'name'	   => language::get('text_tax_rate'),
					'href'     => url::link('localisation/tax_rate'),
					'children' => array()
				);
			}

			if ($tax) {
				$localisation[] = array(
					'name'	   => language::get('text_tax'),
					'href'     => '',
					'children' => $tax
				);
			}

			if (user::hasPermission('access', 'localisation/length_class')) {
				$localisation[] = array(
					'name'	   => language::get('text_length_class'),
					'href'     => url::link('localisation/length_class'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'localisation/weight_class')) {
				$localisation[] = array(
					'name'	   => language::get('text_weight_class'),
					'href'     => url::link('localisation/weight_class'),
					'children' => array()
				);
			}

			if ($localisation) {
				$system[] = array(
					'name'	   => language::get('text_localisation'),
					'href'     => '',
					'children' => $localisation
				);
			}

			// Tools
			$maintenance = array();

			if (user::hasPermission('access', 'tool/upgrade')) {
				$maintenance[] = array(
					'name'	   => language::get('text_upgrade'),
					'href'     => url::link('tool/upgrade'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'tool/backup')) {
				$maintenance[] = array(
					'name'	   => language::get('text_backup'),
					'href'     => url::link('tool/backup'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'tool/upload')) {
				$maintenance[] = array(
					'name'	   => language::get('text_upload'),
					'href'     => url::link('tool/upload'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'tool/log')) {
				$maintenance[] = array(
					'name'	   => language::get('text_log'),
					'href'     => url::link('tool/log'),
					'children' => array()
				);
			}

			if ($maintenance) {
				$system[] = array(
					'id'       => 'menu-maintenance',
					'icon'	   => 'fa-cog',
					'name'	   => language::get('text_maintenance'),
					'href'     => '',
					'children' => $maintenance
				);
			}

			if ($system) {
				$data['menus'][] = array(
					'id'       => 'menu-system',
					'icon'	   => 'fa-cog',
					'name'	   => language::get('text_system'),
					'href'     => '',
					'children' => $system
				);
			}

			$report = array();

			if (user::hasPermission('access', 'report/report')) {
				$report[] = array(
					'name'	   => language::get('text_reports'),
					'href'     => url::link('report/report'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'report/online')) {
				$report[] = array(
					'name'	   => language::get('text_online'),
					'href'     => url::link('report/online'),
					'children' => array()
				);
			}

			if (user::hasPermission('access', 'report/statistics')) {
				$report[] = array(
					'name'	   => language::get('text_statistics'),
					'href'     => url::link('report/statistics'),
					'children' => array()
				);
			}

			if ($report) {
				$data['menus'][] = array(
					'id'       => 'menu-report',
					'icon'	   => 'fa-bar-chart',
					'name'	   => language::get('text_reports'),
					'href'     => '',
					'children' => $report
				);
			}

			// Stats
			if (user::hasPermission('access', 'report/statistics')) {

				$order_total = (float)admin_sale_order::getTotalOrders();


				$complete_total = (float)admin_report_statistics::getValue('order_complete');

				if ($complete_total && $order_total) {
					$data['complete_status'] = round(($complete_total / $order_total) * 100);
				} else {
					$data['complete_status'] = 0;
				}

				$processing_total = (float)admin_report_statistics::getValue('order_processing');

				if ($processing_total && $order_total) {
					$data['processing_status'] = round(($processing_total / $order_total) * 100);
				} else {
					$data['processing_status'] = 0;
				}

				$other_total = (float)admin_report_statistics::getValue('order_other');

				if ($other_total && $order_total) {
					$data['other_status'] = round(($other_total / $order_total) * 100);
				} else {
					$data['other_status'] = 0;
				}

				$data['statistics_status'] = true;
			} else {
				$data['statistics_status'] = false;
			}

			return load::view('common/column_left', $data);
		}
	}
}
