<?php
class ControllerCommonForgotten {
	private static $error = array();

	public static function index() {
		if (user::isLogged()) {
			response::redirect(url::link('common/dashboard', ''));
		}

		if (!config('password')) {
			response::redirect(url::link('common/login', ''));
		}

		load::language('common/forgotten');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_user_user::editCode(request::$post['email'], token(40));

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('common/login', ''));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard', '')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('common/forgotten', 'user_token=' . '')
		);

		$data['action'] = url::link('common/forgotten', '');

		$data['cancel'] = url::link('common/login', '');

		if (isset(request::$post['email'])) {
			$data['email'] = request::$post['email'];
		} else {
			$data['email'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('common/forgotten', $data));
	}

	protected static function validate() {
		if (!isset(request::$post['email'])) {
			self::$error['warning'] = language::get('error_email');
		} elseif (!admin_user_user::getTotalUsersByEmail(request::$post['email'])) {
			self::$error['warning'] = language::get('error_email');
		}

		return !self::$error;
	}
}
