<?php
class ControllerCommonHeader {
	public static function index() {
		$data['title'] = document::getTitle();

		if (request::$server['HTTPS']) {
			$data['base'] = HTTPS_SERVER;
		} else {
			$data['base'] = HTTP_SERVER;
		}

		if (request::$server['HTTPS']) {
            $server = HTTPS_CATALOG;
        } else {
            $server = HTTP_CATALOG;
        }

        if (is_file('image/' . config('icon'))) {
			document::addLink($server . 'image/' . config('icon'), 'icon');
        }

		$data['description'] = document::getDescription();
		$data['keywords'] = document::getKeywords();
		$data['links'] = document::getLinks();
		$data['styles'] = document::getStyles();
		$data['scripts'] = document::getScripts();
		$data['lang'] = language::get('code');
		$data['direction'] = language::get('direction');

		load::language('common/header');

		$data['text_logged'] = sprintf(language::get('text_logged'), user::getUserName());

		if (!user::isLogged()) {
			$data['logged'] = '';

			$data['home'] = url::link('common/login', '');
		} else {
			$data['logged'] = true;

			$data['home'] = url::link('common/dashboard');
			$data['logout'] = url::link('common/logout');
			$data['profile'] = url::link('common/profile');



			$user_info = admin_user_user::getUser(user::getId());

			if ($user_info) {
				$data['firstname'] = $user_info['firstname'];
				$data['lastname'] = $user_info['lastname'];
				$data['username']  = $user_info['username'];
				$data['user_group'] = $user_info['user_group'];

				if (is_file('image/' . $user_info['image'])) {
					$data['image'] = admin_tool_image::resize($user_info['image'], 45, 45);
				} else {
					$data['image'] = admin_tool_image::resize('profile.png', 45, 45);
				}
			} else {
				$data['firstname'] = '';
				$data['lastname'] = '';
				$data['user_group'] = '';
				$data['image'] = '';
			}

			// Online Stores
			$data['stores'] = array();

			$data['stores'][] = array(
				'name' => config('name'),
				'href' => HTTP_CATALOG
			);


			$results = admin_setting_store::getStores();

			foreach ($results as $result) {
				$data['stores'][] = array(
					'name' => $result['name'],
					'href' => $result['url']
				);
			}
		}

		return load::view('common/header', $data);
	}
}
