<?php
class ControllerCommonReset {
	private static $error = array();

	public static function index() {
		if (user::isLogged()) {
			response::redirect(url::link('common/dashboard', ''));
		}

		if (!config('password')) {
			response::redirect(url::link('common/login', ''));
		}

		if (isset(request::$get['code'])) {
			$code = request::$get['code'];
		} else {
			$code = '';
		}


		$user_info = admin_user_user::getUserByCode($code);

		if ($user_info) {
			load::language('common/reset');

			document::setTitle(language::get('heading_title'));

			if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
				admin_user_user::editPassword($user_info['user_id'], request::$post['password']);

				admin_user_user::deleteLoginAttempts($user_info['username']);

				session::$data['success'] = language::get('text_success');

				response::redirect(url::link('common/login', ''));
			}

			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_home'),
				'href' => url::link('common/dashboard', '')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('common/reset', '')
			);

			if (isset(self::$error['password'])) {
				$data['error_password'] = self::$error['password'];
			} else {
				$data['error_password'] = '';
			}

			if (isset(self::$error['confirm'])) {
				$data['error_confirm'] = self::$error['confirm'];
			} else {
				$data['error_confirm'] = '';
			}

			$data['action'] = url::link('common/reset', 'code=' . $code);

			$data['cancel'] = url::link('common/login', '');

			if (isset(request::$post['password'])) {
				$data['password'] = request::$post['password'];
			} else {
				$data['password'] = '';
			}

			if (isset(request::$post['confirm'])) {
				$data['confirm'] = request::$post['confirm'];
			} else {
				$data['confirm'] = '';
			}

			$data['header'] = load::controller('common/header');
			$data['footer'] = load::controller('common/footer');

			response::setOutput(load::view('common/reset', $data));
		} else {

			admin_setting_setting::editSettingValue('config', 'config_password', '0');

			return 'common/login';
		}
	}

	protected static function validate() {
		if ((utf8_strlen(html_entity_decode(request::$post['password'], ENT_QUOTES, 'UTF-8')) < 4) || (utf8_strlen(html_entity_decode(request::$post['password'], ENT_QUOTES, 'UTF-8')) > 40)) {
			self::$error['password'] = language::get('error_password');
		}

		if (request::$post['confirm'] != request::$post['password']) {
			self::$error['confirm'] = language::get('error_confirm');
		}

		return !self::$error;
	}
}