<?php
class ControllerCustomerCustomer {
	private static $error = array();

	public static function index() {
		load::language('customer/customer');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('customer/customer');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_customer_customer::addCustomer(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_email'])) {
				$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_customer_group_id'])) {
				$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['filter_ip'])) {
				$url .= '&filter_ip=' . request::$get['filter_ip'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('customer/customer', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('customer/customer');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_customer_customer::editCustomer(request::$get['customer_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_email'])) {
				$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_customer_group_id'])) {
				$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['filter_ip'])) {
				$url .= '&filter_ip=' . request::$get['filter_ip'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('customer/customer', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('customer/customer');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $customer_id) {
				admin_customer_customer::deleteCustomer($customer_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_email'])) {
				$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_customer_group_id'])) {
				$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['filter_ip'])) {
				$url .= '&filter_ip=' . request::$get['filter_ip'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('customer/customer', $url));
		}

		self::getList();
	}

	public static function unlock() {
		load::language('customer/customer');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$get['email']) && self::validateUnlock()) {
			admin_customer_customer::deleteLoginAttempts(request::$get['email']);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_email'])) {
				$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_customer_group_id'])) {
				$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['filter_ip'])) {
				$url .= '&filter_ip=' . request::$get['filter_ip'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('customer/customer', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['filter_name'])) {
			$filter_name = request::$get['filter_name'];
		} else {
			$filter_name = '';
		}

		if (isset(request::$get['filter_email'])) {
			$filter_email = request::$get['filter_email'];
		} else {
			$filter_email = '';
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$filter_customer_group_id = request::$get['filter_customer_group_id'];
		} else {
			$filter_customer_group_id = '';
		}

		if (isset(request::$get['filter_status'])) {
			$filter_status = request::$get['filter_status'];
		} else {
			$filter_status = '';
		}

		if (isset(request::$get['filter_ip'])) {
			$filter_ip = request::$get['filter_ip'];
		} else {
			$filter_ip = '';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'name';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_ip'])) {
			$url .= '&filter_ip=' . request::$get['filter_ip'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('customer/customer', $url)
		);

		$data['add'] = url::link('customer/customer/add', $url);
		$data['delete'] = url::link('customer/customer/delete', $url);


		$stores = admin_setting_store::getStores();

		$data['customers'] = array();

		$filter_data = array(
			'filter_name'              => $filter_name,
			'filter_email'             => $filter_email,
			'filter_customer_group_id' => $filter_customer_group_id,
			'filter_status'            => $filter_status,
			'filter_date_added'        => $filter_date_added,
			'filter_ip'                => $filter_ip,
			'sort'                     => $sort,
			'order'                    => $order,
			'start'                    => ($page - 1) * config('limit_admin'),
			'limit'                    => config('limit_admin')
		);

		$customer_total = admin_customer_customer::getTotalCustomers($filter_data);

		$results = admin_customer_customer::getCustomers($filter_data);

		foreach ($results as $result) {
			$login_info = admin_customer_customer::getTotalLoginAttempts($result['email']);

			if ($login_info && $login_info['total'] >= config('login_attempts')) {
				$unlock = url::link('customer/customer/unlock', '&email=' . $result['email'] . $url);
			} else {
				$unlock = '';
			}

			$store_data = array();

			$store_data[] = array(
				'name' => config('name'),
				'href' => url::link('customer/customer/login', '&customer_id=' . $result['customer_id'] . '&store_id=0')
			);

			foreach ($stores as $store) {
				$store_data[] = array(
					'name' => $store['name'],
					'href' => url::link('customer/customer/login', '&customer_id=' . $result['customer_id'] . '&store_id=' . $store['store_id'])
				);
			}

			$data['customers'][] = array(
				'customer_id'    => $result['customer_id'],
				'name'           => $result['name'],
				'email'          => $result['email'],
				'customer_group' => $result['customer_group'],
				'status'         => ($result['status'] ? language::get('text_enabled') : language::get('text_disabled')),
				'ip'             => $result['ip'],
				'date_added'     => date(language::get('date_format_short'), strtotime($result['date_added'])),
				'unlock'         => $unlock,
				'store'          => $store_data,
				'edit'           => url::link('customer/customer/edit', '&customer_id=' . $result['customer_id'] . $url)
			);
		}


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_ip'])) {
			$url .= '&filter_ip=' . request::$get['filter_ip'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_name'] = url::link('customer/customer', '&sort=name' . $url);
		$data['sort_email'] = url::link('customer/customer', '&sort=c.email' . $url);
		$data['sort_customer_group'] = url::link('customer/customer', '&sort=customer_group' . $url);
		$data['sort_status'] = url::link('customer/customer', '&sort=c.status' . $url);
		$data['sort_ip'] = url::link('customer/customer', '&sort=c.ip' . $url);
		$data['sort_date_added'] = url::link('customer/customer', '&sort=c.date_added' . $url);

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_ip'])) {
			$url .= '&filter_ip=' . request::$get['filter_ip'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $customer_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('customer/customer', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($customer_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($customer_total - config('limit_admin'))) ? $customer_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $customer_total, ceil($customer_total / config('limit_admin')));

		$data['filter_name'] = $filter_name;
		$data['filter_email'] = $filter_email;
		$data['filter_customer_group_id'] = $filter_customer_group_id;
		$data['filter_status'] = $filter_status;
		$data['filter_ip'] = $filter_ip;
		$data['filter_date_added'] = $filter_date_added;


		$data['customer_groups'] = admin_customer_customer_group::getCustomerGroups();

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('customer/customer_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['customer_id']) ? language::get('text_add') : language::get('text_edit');


		if (isset(request::$get['customer_id'])) {
			$data['customer_id'] = (int)request::$get['customer_id'];
		} else {
			$data['customer_id'] = 0;
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['firstname'])) {
			$data['error_firstname'] = self::$error['firstname'];
		} else {
			$data['error_firstname'] = '';
		}

		if (isset(self::$error['lastname'])) {
			$data['error_lastname'] = self::$error['lastname'];
		} else {
			$data['error_lastname'] = '';
		}

		if (isset(self::$error['email'])) {
			$data['error_email'] = self::$error['email'];
		} else {
			$data['error_email'] = '';
		}

		if (isset(self::$error['telephone'])) {
			$data['error_telephone'] = self::$error['telephone'];
		} else {
			$data['error_telephone'] = '';
		}

		if (isset(self::$error['tracking'])) {
			$data['error_tracking'] = self::$error['tracking'];
		} else {
			$data['error_tracking'] = '';
		}

		if (isset(self::$error['cheque'])) {
			$data['error_cheque'] = self::$error['cheque'];
		} else {
			$data['error_cheque'] = '';
		}

		if (isset(self::$error['paypal'])) {
			$data['error_paypal'] = self::$error['paypal'];
		} else {
			$data['error_paypal'] = '';
		}

		if (isset(self::$error['bank_account_name'])) {
			$data['error_bank_account_name'] = self::$error['bank_account_name'];
		} else {
			$data['error_bank_account_name'] = '';
		}

		if (isset(self::$error['bank_account_number'])) {
			$data['error_bank_account_number'] = self::$error['bank_account_number'];
		} else {
			$data['error_bank_account_number'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['confirm'])) {
			$data['error_confirm'] = self::$error['confirm'];
		} else {
			$data['error_confirm'] = '';
		}

		if (isset(self::$error['custom_field'])) {
			$data['error_custom_field'] = self::$error['custom_field'];
		} else {
			$data['error_custom_field'] = array();
		}

		if (isset(self::$error['address'])) {
			$data['error_address'] = self::$error['address'];
		} else {
			$data['error_address'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_ip'])) {
			$url .= '&filter_ip=' . request::$get['filter_ip'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('customer/customer', $url)
		);

		if (!isset(request::$get['customer_id'])) {
			$data['action'] = url::link('customer/customer/add', $url);
		} else {
			$data['action'] = url::link('customer/customer/edit', '&customer_id=' . request::$get['customer_id'] . $url);
		}

		$data['cancel'] = url::link('customer/customer', $url);

		if (isset(request::$get['customer_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$customer_info = admin_customer_customer::getCustomer(request::$get['customer_id']);
		}


		$data['customer_groups'] = admin_customer_customer_group::getCustomerGroups();

		if (isset(request::$post['customer_group_id'])) {
			$data['customer_group_id'] = request::$post['customer_group_id'];
		} elseif (!empty($customer_info)) {
			$data['customer_group_id'] = $customer_info['customer_group_id'];
		} else {
			$data['customer_group_id'] = config('customer_group_id');
		}

		if (isset(request::$post['firstname'])) {
			$data['firstname'] = request::$post['firstname'];
		} elseif (!empty($customer_info)) {
			$data['firstname'] = $customer_info['firstname'];
		} else {
			$data['firstname'] = '';
		}

		if (isset(request::$post['lastname'])) {
			$data['lastname'] = request::$post['lastname'];
		} elseif (!empty($customer_info)) {
			$data['lastname'] = $customer_info['lastname'];
		} else {
			$data['lastname'] = '';
		}

		if (isset(request::$post['email'])) {
			$data['email'] = request::$post['email'];
		} elseif (!empty($customer_info)) {
			$data['email'] = $customer_info['email'];
		} else {
			$data['email'] = '';
		}

		if (isset(request::$post['telephone'])) {
			$data['telephone'] = request::$post['telephone'];
		} elseif (!empty($customer_info)) {
			$data['telephone'] = $customer_info['telephone'];
		} else {
			$data['telephone'] = '';
		}

		if (isset(request::$post['custom_field'])) {
			$data['account_custom_field'] = request::$post['custom_field'];
		} elseif (!empty($customer_info)) {
			$data['account_custom_field'] = json_decode($customer_info['custom_field'], true);
		} else {
			$data['account_custom_field'] = array();
		}

		if (isset(request::$post['address'])) {
			$data['addresses'] = request::$post['address'];
		} elseif (isset(request::$get['customer_id'])) {
			$data['addresses'] = admin_customer_customer::getAddresses(request::$get['customer_id']);
		} else {
			$data['addresses'] = array();
		}

		// Custom Fields

		$data['custom_fields'] = array();

		$filter_data = array(
			'sort'  => 'cf.sort_order',
			'order' => 'ASC'
		);

		$custom_fields = admin_customer_custom_field::getCustomFields($filter_data);

		foreach ($custom_fields as $custom_field) {
			$data['custom_fields'][] = array(
				'custom_field_id'    => $custom_field['custom_field_id'],
				'custom_field_value' => admin_customer_custom_field::getCustomFieldValues($custom_field['custom_field_id']),
				'name'               => $custom_field['name'],
				'value'              => $custom_field['value'],
				'type'               => $custom_field['type'],
				'location'           => $custom_field['location'],
				'sort_order'         => $custom_field['sort_order']
			);

			if($custom_field['type'] == 'file') {
				if(isset($data['account_custom_field'][$custom_field['custom_field_id']])) {
					$code = $data['account_custom_field'][$custom_field['custom_field_id']];

					$upload_result = admin_tool_upload::getUploadByCode($code);

					$data['account_custom_field'][$custom_field['custom_field_id']] = array();
					if($upload_result) {
						$data['account_custom_field'][$custom_field['custom_field_id']]['name'] = $upload_result['name'];
						$data['account_custom_field'][$custom_field['custom_field_id']]['code'] = $upload_result['code'];
					} else {
						$data['account_custom_field'][$custom_field['custom_field_id']]['name'] = "";
						$data['account_custom_field'][$custom_field['custom_field_id']]['code'] = $code;
					}
				}

				foreach($data['addresses'] as $address_id => $address) {
					if(isset($address['custom_field'][$custom_field['custom_field_id']])) {
						$code = $address['custom_field'][$custom_field['custom_field_id']];

						$upload_result = admin_tool_upload::getUploadByCode($code);
						
						$data['addresses'][$address_id]['custom_field'][$custom_field['custom_field_id']] = array();
						if($upload_result) {
							$data['addresses'][$address_id]['custom_field'][$custom_field['custom_field_id']]['name'] = $upload_result['name'];
							$data['addresses'][$address_id]['custom_field'][$custom_field['custom_field_id']]['code'] = $upload_result['code'];
						} else {
							$data['addresses'][$address_id]['custom_field'][$custom_field['custom_field_id']]['name'] = "";
							$data['addresses'][$address_id]['custom_field'][$custom_field['custom_field_id']]['code'] = $code;
						}
					}
				}
			}
		}

		if (isset(request::$post['newsletter'])) {
			$data['newsletter'] = request::$post['newsletter'];
		} elseif (!empty($customer_info)) {
			$data['newsletter'] = $customer_info['newsletter'];
		} else {
			$data['newsletter'] = '';
		}

		if (isset(request::$post['status'])) {
			$data['status'] = request::$post['status'];
		} elseif (!empty($customer_info)) {
			$data['status'] = $customer_info['status'];
		} else {
			$data['status'] = true;
		}

		if (isset(request::$post['safe'])) {
			$data['safe'] = request::$post['safe'];
		} elseif (!empty($customer_info)) {
			$data['safe'] = $customer_info['safe'];
		} else {
			$data['safe'] = 0;
		}

		if (isset(request::$post['password'])) {
			$data['password'] = request::$post['password'];
		} else {
			$data['password'] = '';
		}

		if (isset(request::$post['confirm'])) {
			$data['confirm'] = request::$post['confirm'];
		} else {
			$data['confirm'] = '';
		}


		$data['countries'] = admin_localisation_country::getCountries();

		if (isset(request::$post['address_id'])) {
			$data['address_id'] = request::$post['address_id'];
		} elseif (!empty($customer_info)) {
			$data['address_id'] = $customer_info['address_id'];
		} else {
			$data['address_id'] = '';
		}

		// Affliate
		if (isset(request::$get['customer_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$affiliate_info = admin_customer_customer::getAffiliate(request::$get['customer_id']);
		}

		if (isset(request::$post['affiliate'])) {
			$data['affiliate'] = request::$post['affiliate'];
		} elseif (!empty($affiliate_info)) {
			$data['affiliate'] = $affiliate_info['status'];
		} else {
			$data['affiliate'] = '';
		}

		if (isset(request::$post['company'])) {
			$data['company'] = request::$post['company'];
		} elseif (!empty($affiliate_info)) {
			$data['company'] = $affiliate_info['company'];
		} else {
			$data['company'] = '';
		}

		if (isset(request::$post['website'])) {
			$data['website'] = request::$post['website'];
		} elseif (!empty($affiliate_info)) {
			$data['website'] = $affiliate_info['website'];
		} else {
			$data['website'] = '';
		}

		if (isset(request::$post['tracking'])) {
			$data['tracking'] = request::$post['tracking'];
		} elseif (!empty($affiliate_info)) {
			$data['tracking'] = $affiliate_info['tracking'];
		} else {
			$data['tracking'] = token(10);
		}

		if (isset(request::$post['commission'])) {
			$data['commission'] = request::$post['commission'];
		} elseif (!empty($affiliate_info)) {
			$data['commission'] = $affiliate_info['commission'];
		} else {
			$data['commission'] = config('affiliate_commission');
		}

		if (isset(request::$post['tax'])) {
			$data['tax'] = request::$post['tax'];
		} elseif (!empty($affiliate_info)) {
			$data['tax'] = $affiliate_info['tax'];
		} else {
			$data['tax'] = '';
		}

		if (isset(request::$post['payment'])) {
			$data['payment'] = request::$post['payment'];
		} elseif (!empty($affiliate_info)) {
			$data['payment'] = $affiliate_info['payment'];
		} else {
			$data['payment'] = 'cheque';
		}

		if (isset(request::$post['cheque'])) {
			$data['cheque'] = request::$post['cheque'];
		} elseif (!empty($affiliate_info)) {
			$data['cheque'] = $affiliate_info['cheque'];
		} else {
			$data['cheque'] = '';
		}

		if (isset(request::$post['paypal'])) {
			$data['paypal'] = request::$post['paypal'];
		} elseif (!empty($affiliate_info)) {
			$data['paypal'] = $affiliate_info['paypal'];
		} else {
			$data['paypal'] = '';
		}

		if (isset(request::$post['bank_name'])) {
			$data['bank_name'] = request::$post['bank_name'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_name'] = $affiliate_info['bank_name'];
		} else {
			$data['bank_name'] = '';
		}

		if (isset(request::$post['bank_branch_number'])) {
			$data['bank_branch_number'] = request::$post['bank_branch_number'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_branch_number'] = $affiliate_info['bank_branch_number'];
		} else {
			$data['bank_branch_number'] = '';
		}

		if (isset(request::$post['bank_swift_code'])) {
			$data['bank_swift_code'] = request::$post['bank_swift_code'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_swift_code'] = $affiliate_info['bank_swift_code'];
		} else {
			$data['bank_swift_code'] = '';
		}

		if (isset(request::$post['bank_account_name'])) {
			$data['bank_account_name'] = request::$post['bank_account_name'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_account_name'] = $affiliate_info['bank_account_name'];
		} else {
			$data['bank_account_name'] = '';
		}

		if (isset(request::$post['bank_account_number'])) {
			$data['bank_account_number'] = request::$post['bank_account_number'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_account_number'] = $affiliate_info['bank_account_number'];
		} else {
			$data['bank_account_number'] = '';
		}

		if (isset(request::$post['custom_field'])) {
			$data['affiliate_custom_field'] = request::$post['custom_field'];
		} elseif (!empty($affiliate_info)) {
			$data['affiliate_custom_field'] = json_decode($affiliate_info['custom_field'], true);
		} else {
			$data['affiliate_custom_field'] = array();
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('customer/customer_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'customer/customer')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if ((utf8_strlen(request::$post['firstname']) < 1) || (utf8_strlen(trim(request::$post['firstname'])) > 32)) {
			self::$error['firstname'] = language::get('error_firstname');
		}

		if ((utf8_strlen(request::$post['lastname']) < 1) || (utf8_strlen(trim(request::$post['lastname'])) > 32)) {
			self::$error['lastname'] = language::get('error_lastname');
		}

		if ((utf8_strlen(request::$post['email']) > 96) || !filter_var(request::$post['email'], FILTER_VALIDATE_EMAIL)) {
			self::$error['email'] = language::get('error_email');
		}

		$customer_info = admin_customer_customer::getCustomerByEmail(request::$post['email']);

		if (!isset(request::$get['customer_id'])) {
			if ($customer_info) {
				self::$error['warning'] = language::get('error_exists');
			}
		} else {
			if ($customer_info && (request::$get['customer_id'] != $customer_info['customer_id'])) {
				self::$error['warning'] = language::get('error_exists');
			}
		}

		if ((utf8_strlen(request::$post['telephone']) < 3) || (utf8_strlen(request::$post['telephone']) > 32)) {
			self::$error['telephone'] = language::get('error_telephone');
		}

		// Custom field validation

		$custom_fields = admin_customer_custom_field::getCustomFields(array('filter_customer_group_id' => request::$post['customer_group_id']));

		foreach ($custom_fields as $custom_field) {
			if (($custom_field['location'] == 'account') && $custom_field['required'] && empty(request::$post['custom_field'][$custom_field['custom_field_id']])) {
				self::$error['custom_field'][$custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
			} elseif (($custom_field['location'] == 'account') && ($custom_field['type'] == 'text') && !empty($custom_field['validation']) && !filter_var(request::$post['custom_field'][$custom_field['custom_field_id']], FILTER_VALIDATE_REGEXP, array('options' => array('regexp' => $custom_field['validation'])))) {
				self::$error['custom_field'][$custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
			}
		}

		if (request::$post['password'] || (!isset(request::$get['customer_id']))) {
			if ((utf8_strlen(html_entity_decode(request::$post['password'], ENT_QUOTES, 'UTF-8')) < 4) || (utf8_strlen(html_entity_decode(request::$post['password'], ENT_QUOTES, 'UTF-8')) > 40)) {
				self::$error['password'] = language::get('error_password');
			}

			if (request::$post['password'] != request::$post['confirm']) {
				self::$error['confirm'] = language::get('error_confirm');
			}
		}

		if (isset(request::$post['address'])) {
			foreach (request::$post['address'] as $key => $value) {
				if ((utf8_strlen($value['firstname']) < 1) || (utf8_strlen($value['firstname']) > 32)) {
					self::$error['address'][$key]['firstname'] = language::get('error_firstname');
				}

				if ((utf8_strlen($value['lastname']) < 1) || (utf8_strlen($value['lastname']) > 32)) {
					self::$error['address'][$key]['lastname'] = language::get('error_lastname');
				}

				if ((utf8_strlen($value['address_1']) < 3) || (utf8_strlen($value['address_1']) > 128)) {
					self::$error['address'][$key]['address_1'] = language::get('error_address_1');
				}

				if ((utf8_strlen($value['city']) < 2) || (utf8_strlen($value['city']) > 128)) {
					self::$error['address'][$key]['city'] = language::get('error_city');
				}


				$country_info = admin_localisation_country::getCountry($value['country_id']);

				if ($country_info && $country_info['postcode_required'] && (utf8_strlen($value['postcode']) < 2 || utf8_strlen($value['postcode']) > 10)) {
					self::$error['address'][$key]['postcode'] = language::get('error_postcode');
				}

				if ($value['country_id'] == '') {
					self::$error['address'][$key]['country'] = language::get('error_country');
				}

				if (!isset($value['zone_id']) || $value['zone_id'] == '') {
					self::$error['address'][$key]['zone'] = language::get('error_zone');
				}

				foreach ($custom_fields as $custom_field) {
					if (($custom_field['location'] == 'address') && $custom_field['required'] && empty($value['custom_field'][$custom_field['custom_field_id']])) {
						self::$error['address'][$key]['custom_field'][$custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
					} elseif (($custom_field['location'] == 'address') && ($custom_field['type'] == 'text') && !empty($custom_field['validation']) && !filter_var($value['custom_field'][$custom_field['custom_field_id']], FILTER_VALIDATE_REGEXP, array('options' => array('regexp' => $custom_field['validation'])))) {
						self::$error['address'][$key]['custom_field'][$custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
                    }
				}
			}
		}

		if (request::$post['affiliate']) {
			if (request::$post['payment'] == 'cheque') {
				if (request::$post['cheque'] == '') {
					self::$error['cheque'] = language::get('error_cheque');
				}
			} elseif (request::$post['payment'] == 'paypal') {
				if ((utf8_strlen(request::$post['paypal']) > 96) || !filter_var(request::$post['paypal'], FILTER_VALIDATE_EMAIL)) {
					self::$error['paypal'] = language::get('error_paypal');
				}
			} elseif (request::$post['payment'] == 'bank') {
				if (request::$post['bank_account_name'] == '') {
					self::$error['bank_account_name'] = language::get('error_bank_account_name');
				}

				if (request::$post['bank_account_number'] == '') {
					self::$error['bank_account_number'] = language::get('error_bank_account_number');
				}
			}

			if (!request::$post['tracking']) {
				self::$error['tracking'] = language::get('error_tracking');
			}

			$affiliate_info = admin_customer_customer::getAffiliateByTracking(request::$post['tracking']);

			if (!isset(request::$get['customer_id'])) {
				if ($affiliate_info) {
					self::$error['tracking'] = language::get('error_tracking_exists');
				}
			} else {
				if ($affiliate_info && (request::$get['customer_id'] != $affiliate_info['customer_id'])) {
					self::$error['tracking'] = language::get('error_tracking_exists');
				}
			}

			foreach ($custom_fields as $custom_field) {
				if (($custom_field['location'] == 'affiliate') && $custom_field['required'] && empty(request::$post['custom_field']['affiliate'][$custom_field['custom_field_id']])) {
					self::$error['custom_field'][$custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
				} elseif (($custom_field['location'] == 'affiliate') && ($custom_field['type'] == 'text') && !empty($custom_field['validation']) && !filter_var(request::$post['custom_field']['affiliate'][$custom_field['custom_field_id']], FILTER_VALIDATE_REGEXP, array('options' => array('regexp' => $custom_field['validation'])))) {
					self::$error['custom_field'][$custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
				}
			}
		}

		if (self::$error && !isset(self::$error['warning'])) {
			self::$error['warning'] = language::get('error_warning');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'customer/customer')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	protected static function validateUnlock() {
		if (!user::hasPermission('modify', 'customer/customer')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	public static function login() {
		if (isset(request::$get['customer_id'])) {
			$customer_id = request::$get['customer_id'];
		} else {
			$customer_id = 0;
		}


		$customer_info = admin_customer_customer::getCustomer($customer_id);

		if ($customer_info) {
			// Create token to login with
			$token = token(64);

			admin_customer_customer::editToken($customer_id, $token);

			if (isset(request::$get['store_id'])) {
				$store_id = request::$get['store_id'];
			} else {
				$store_id = 0;
			}


			$store_info = admin_setting_store::getStore($store_id);

			if ($store_info) {
				response::redirect($store_info['url'] . 'index.php?route=account/login&token=' . $token);
			} else {
				response::redirect(HTTP_CATALOG . 'index.php?route=account/login&token=' . $token);
			}
		} else {
			load::language('error/not_found');

			document::setTitle(language::get('heading_title'));

			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_home'),
				'href' => url::link('common/dashboard')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('error/not_found')
			);

			$data['header'] = load::controller('common/header');
			$data['column_left'] = load::controller('common/column_left');
			$data['footer'] = load::controller('common/footer');

			response::setOutput(load::view('error/not_found', $data));
		}
	}

	public static function history() {
		load::language('customer/customer');


		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$limit = config('limit_admin');

		$data['histories'] = array();

		$results = admin_customer_customer::getHistories(request::$get['customer_id'], ($page - 1) * $limit, $limit);

		foreach ($results as $result) {
			$data['histories'][] = array(
				'comment'    => $result['comment'],
				'date_added' => date(language::get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$history_total = admin_customer_customer::getTotalHistories(request::$get['customer_id']);

		$pagination = new Pagination();
		$pagination::$total = $history_total;
		$pagination::$page = $page;
		$pagination::$limit = $limit;
		$pagination::$url = url::link('customer/customer/history', '&customer_id=' . request::$get['customer_id'] . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($history_total) ? (($page - 1) * $limit) + 1 : 0, ((($page - 1) * $limit) > ($history_total - $limit)) ? $history_total : ((($page - 1) * $limit) + $limit), $history_total, ceil($history_total / $limit));

		response::setOutput(load::view('customer/customer_history', $data));
	}

	public static function addHistory() {
		load::language('customer/customer');

		$json = array();

		if (!user::hasPermission('modify', 'customer/customer')) {
			$json['error'] = language::get('error_permission');
		} else {

			admin_customer_customer::addHistory(request::$get['customer_id'], request::$post['comment']);

			$json['success'] = language::get('text_success');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function transaction() {
		load::language('customer/customer');


		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$limit = config('limit_admin');

		$data['transactions'] = array();

		$results = admin_customer_customer::getTransactions(request::$get['customer_id'], ($page - 1) * $limit, $limit);

		foreach ($results as $result) {
			$data['transactions'][] = array(
				'amount'      => currency::format($result['amount'], config('currency')),
				'description' => $result['description'],
				'date_added'  => date(language::get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$data['balance'] = currency::format(admin_customer_customer::getTransactionTotal(request::$get['customer_id']), config('currency'));

		$transaction_total = admin_customer_customer::getTotalTransactions(request::$get['customer_id']);

		$pagination = new Pagination();
		$pagination::$total = $transaction_total;
		$pagination::$page = $page;
		$pagination::$limit = $limit;
		$pagination::$url = url::link('customer/customer/transaction', '&customer_id=' . request::$get['customer_id'] . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($transaction_total) ? (($page - 1) * $limit) + 1 : 0, ((($page - 1) * $limit) > ($transaction_total - $limit)) ? $transaction_total : ((($page - 1) * $limit) + $limit), $transaction_total, ceil($transaction_total / $limit));

		response::setOutput(load::view('customer/customer_transaction', $data));
	}

	public static function addTransaction() {
		load::language('customer/customer');

		$json = array();

		if (!user::hasPermission('modify', 'customer/customer')) {
			$json['error'] = language::get('error_permission');
		} else {

			admin_customer_customer::addTransaction(request::$get['customer_id'], request::$post['description'], request::$post['amount']);

			$json['success'] = language::get('text_success');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function reward() {
		load::language('customer/customer');


		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$limit = config('limit_admin');

		$data['rewards'] = array();

		$results = admin_customer_customer::getRewards(request::$get['customer_id'], ($page - 1) * $limit, $limit);

		foreach ($results as $result) {
			$data['rewards'][] = array(
				'points'      => $result['points'],
				'description' => $result['description'],
				'date_added'  => date(language::get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$data['balance'] = admin_customer_customer::getRewardTotal(request::$get['customer_id']);

		$reward_total = admin_customer_customer::getTotalRewards(request::$get['customer_id']);

		$pagination = new Pagination();
		$pagination::$total = $reward_total;
		$pagination::$page = $page;
		$pagination::$limit = $limit;
		$pagination::$url = url::link('customer/customer/reward', '&customer_id=' . request::$get['customer_id'] . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($reward_total) ? (($page - 1) * $limit) + 1 : 0, ((($page - 1) * $limit) > ($reward_total - $limit)) ? $reward_total : ((($page - 1) * $limit) + $limit), $reward_total, ceil($reward_total / $limit));

		response::setOutput(load::view('customer/customer_reward', $data));
	}

	public static function addReward() {
		load::language('customer/customer');

		$json = array();

		if (!user::hasPermission('modify', 'customer/customer')) {
			$json['error'] = language::get('error_permission');
		} else {

			admin_customer_customer::addReward(request::$get['customer_id'], request::$post['description'], request::$post['points']);

			$json['success'] = language::get('text_success');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function ip() {
		load::language('customer/customer');


		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$limit = config('limit_admin');

		$data['ips'] = array();

		$results = admin_customer_customer::getIps(request::$get['customer_id'], ($page - 1) * $limit, $limit);

		foreach ($results as $result) {
			$data['ips'][] = array(
				'ip'         => $result['ip'],
				'total'      => admin_customer_customer::getTotalCustomersByIp($result['ip']),
				'date_added' => date('d/m/y', strtotime($result['date_added'])),
				'filter_ip'  => url::link('customer/customer', '&filter_ip=' . $result['ip'])
			);
		}

		$ip_total = admin_customer_customer::getTotalIps(request::$get['customer_id']);

		$pagination = new Pagination();
		$pagination::$total = $ip_total;
		$pagination::$page = $page;
		$pagination::$limit = $limit;
		$pagination::$url = url::link('customer/customer/ip', '&customer_id=' . request::$get['customer_id'] . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($ip_total) ? (($page - 1) * $limit) + 1 : 0, ((($page - 1) * $limit) > ($ip_total - $limit)) ? $ip_total : ((($page - 1) * $limit) + $limit), $ip_total, ceil($ip_total / $limit));

		response::setOutput(load::view('customer/customer_ip', $data));
	}

	public static function autocomplete() {
		$json = array();

		if (isset(request::$get['filter_name']) || isset(request::$get['filter_email'])) {
			if (isset(request::$get['filter_name'])) {
				$filter_name = request::$get['filter_name'];
			} else {
				$filter_name = '';
			}

			if (isset(request::$get['filter_email'])) {
				$filter_email = request::$get['filter_email'];
			} else {
				$filter_email = '';
			}

			if (isset(request::$get['filter_affiliate'])) {
				$filter_affiliate = request::$get['filter_affiliate'];
			} else {
				$filter_affiliate = '';
			}


			$filter_data = array(
				'filter_name'      => $filter_name,
				'filter_email'     => $filter_email,
				'filter_affiliate' => $filter_affiliate,
				'start'            => 0,
				'limit'            => 5
			);

			$results = admin_customer_customer::getCustomers($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'customer_id'       => $result['customer_id'],
					'customer_group_id' => $result['customer_group_id'],
					'name'              => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8')),
					'customer_group'    => $result['customer_group'],
					'firstname'         => $result['firstname'],
					'lastname'          => $result['lastname'],
					'email'             => $result['email'],
					'telephone'         => $result['telephone'],
					'custom_field'      => json_decode($result['custom_field'], true),
					'address'           => admin_customer_customer::getAddresses($result['customer_id'])
				);
			}
		}

		$sort_order = array();

		foreach ($json as $key => $value) {
			$sort_order[$key] = $value['name'];
		}

		array_multisort($sort_order, SORT_ASC, $json);

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function customfield() {
		$json = array();


		// Customer Group
		if (isset(request::$get['customer_group_id'])) {
			$customer_group_id = request::$get['customer_group_id'];
		} else {
			$customer_group_id = config('customer_group_id');
		}

		$custom_fields = admin_customer_custom_field::getCustomFields(array('filter_customer_group_id' => $customer_group_id));

		foreach ($custom_fields as $custom_field) {
			$json[] = array(
				'custom_field_id' => $custom_field['custom_field_id'],
				'required'        => empty($custom_field['required']) || $custom_field['required'] == 0 ? false : true
			);
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function address() {
		$json = array();

		if (!empty(request::$get['address_id'])) {

			$json = admin_customer_customer::getAddress(request::$get['address_id']);
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
