<?php
class ControllerCustomerCustomerApproval {
	public static function index() {
		load::language('customer/customer_approval');

		document::setTitle(language::get('heading_title'));

		if (isset(request::$get['filter_name'])) {
			$filter_name = request::$get['filter_name'];
		} else {
			$filter_name = '';
		}

		if (isset(request::$get['filter_email'])) {
			$filter_email = request::$get['filter_email'];
		} else {
			$filter_email = '';
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$filter_customer_group_id = request::$get['filter_customer_group_id'];
		} else {
			$filter_customer_group_id = '';
		}

		if (isset(request::$get['filter_type'])) {
			$filter_type = request::$get['filter_type'];
		} else {
			$filter_type = '';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
		}

		if (isset(request::$get['filter_type'])) {
			$url .= '&filter_type=' . request::$get['filter_type'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('customer/customer_approval')
		);
		
		$data['filter_name'] = $filter_name;
		$data['filter_email'] = $filter_email;
		$data['filter_customer_group_id'] = $filter_customer_group_id;
		$data['filter_type'] = $filter_type;
		$data['filter_date_added'] = $filter_date_added;



		$data['customer_groups'] = admin_customer_customer_group::getCustomerGroups();

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('customer/customer_approval', $data));
	}

	public static function customer_approval() {
		load::language('customer/customer_approval');

		if (isset(request::$get['filter_name'])) {
			$filter_name = request::$get['filter_name'];
		} else {
			$filter_name = '';
		}

		if (isset(request::$get['filter_email'])) {
			$filter_email = request::$get['filter_email'];
		} else {
			$filter_email = '';
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$filter_customer_group_id = request::$get['filter_customer_group_id'];
		} else {
			$filter_customer_group_id = '';
		}

		if (isset(request::$get['filter_type'])) {
			$filter_type = request::$get['filter_type'];
		} else {
			$filter_type = '';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$data['customer_approvals'] = array();

		$filter_data = array(
			'filter_name'              => $filter_name,
			'filter_email'             => $filter_email,
			'filter_customer_group_id' => $filter_customer_group_id,
			'filter_type'              => $filter_type,
			'filter_date_added'        => $filter_date_added,
			'start'                    => ($page - 1) * config('limit_admin'),
			'limit'                    => config('limit_admin')
		);


		$customer_approval_total = admin_customer_customer_approval::getTotalCustomerApprovals($filter_data);

		$results = admin_customer_customer_approval::getCustomerApprovals($filter_data);

		foreach ($results as $result) {
			$data['customer_approvals'][] = array(
				'customer_id'    => $result['customer_id'],
				'name'           => $result['name'],
				'email'          => $result['email'],
				'customer_group' => $result['customer_group'],
				'type'           => language::get('text_' . $result['type']),
				'date_added'     => date(language::get('date_format_short'), strtotime($result['date_added'])),
				'approve'        => url::link('customer/customer_approval/approve', '&customer_id=' . $result['customer_id'] . '&type=' . $result['type']),
				'deny'           => url::link('customer/customer_approval/deny', '&customer_id=' . $result['customer_id'] . '&type=' . $result['type']),
				'edit'           => url::link('customer/customer/edit', '&customer_id=' . $result['customer_id'])
			);
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_email'])) {
			$url .= '&filter_email=' . urlencode(html_entity_decode(request::$get['filter_email'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer_group_id'])) {
			$url .= '&filter_customer_group_id=' . request::$get['filter_customer_group_id'];
		}

		if (isset(request::$get['filter_type'])) {
			$url .= '&filter_type=' . request::$get['filter_type'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		$pagination = new Pagination();
		$pagination::$total = $customer_approval_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('customer/customer_approval/customer_approval', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($customer_approval_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($customer_approval_total - config('limit_admin'))) ? $customer_approval_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $customer_approval_total, ceil($customer_approval_total / config('limit_admin')));

		response::setOutput(load::view('customer/customer_approval_list', $data));
	}

	public static function approve() {
		load::language('customer/customer_approval');

		$json = array();

		if (!user::hasPermission('modify', 'customer/customer_approval')) {
			$json['error'] = language::get('error_permission');
		} else {

			if (request::$get['type'] == 'customer') {
				admin_customer_customer_approval::approveCustomer(request::$get['customer_id']);
			} elseif (request::$get['type'] == 'affiliate') {
				admin_customer_customer_approval::approveAffiliate(request::$get['customer_id']);
			}

			$json['success'] = language::get('text_success');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function deny() {
		load::language('customer/customer_approval');

		$json = array();

		if (!user::hasPermission('modify', 'customer/customer_approval')) {
			$json['error'] = language::get('error_permission');
		} else {

			if (request::$get['type'] == 'customer') {
				admin_customer_customer_approval::denyCustomer(request::$get['customer_id']);
			} elseif (request::$get['type'] == 'affiliate') {
				admin_customer_customer_approval::denyAffiliate(request::$get['customer_id']);
			}

			$json['success'] = language::get('text_success');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
