<?php
class ControllerCustomerCustomerGroup {
	private static $error = array();

	public static function index() {
		load::language('customer/customer_group');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('customer/customer_group');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_customer_customer_group::addCustomerGroup(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('customer/customer_group', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('customer/customer_group');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_customer_customer_group::editCustomerGroup(request::$get['customer_group_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('customer/customer_group', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('customer/customer_group');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $customer_group_id) {
				admin_customer_customer_group::deleteCustomerGroup($customer_group_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('customer/customer_group', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'cgd.name';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('customer/customer_group', $url)
		);

		$data['add'] = url::link('customer/customer_group/add', $url);
		$data['delete'] = url::link('customer/customer_group/delete', $url);

		$data['customer_groups'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * config('limit_admin'),
			'limit' => config('limit_admin')
		);

		$customer_group_total = admin_customer_customer_group::getTotalCustomerGroups();

		$results = admin_customer_customer_group::getCustomerGroups($filter_data);

		foreach ($results as $result) {
			$data['customer_groups'][] = array(
				'customer_group_id' => $result['customer_group_id'],
				'name'              => $result['name'] . (($result['customer_group_id'] == config('customer_group_id')) ? language::get('text_default') : null),
				'sort_order'        => $result['sort_order'],
				'edit'              => url::link('customer/customer_group/edit', '&customer_group_id=' . $result['customer_group_id'] . $url)
			);
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_name'] = url::link('customer/customer_group', '&sort=cgd.name' . $url);
		$data['sort_sort_order'] = url::link('customer/customer_group', '&sort=cg.sort_order' . $url);

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $customer_group_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('customer/customer_group', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($customer_group_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($customer_group_total - config('limit_admin'))) ? $customer_group_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $customer_group_total, ceil($customer_group_total / config('limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('customer/customer_group_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['customer_group_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = array();
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('customer/customer_group', $url)
		);

		if (!isset(request::$get['customer_group_id'])) {
			$data['action'] = url::link('customer/customer_group/add', $url);
		} else {
			$data['action'] = url::link('customer/customer_group/edit', '&customer_group_id=' . request::$get['customer_group_id'] . $url);
		}

		$data['cancel'] = url::link('customer/customer_group', $url);

		if (isset(request::$get['customer_group_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$customer_group_info = admin_customer_customer_group::getCustomerGroup(request::$get['customer_group_id']);
		}


		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['customer_group_description'])) {
			$data['customer_group_description'] = request::$post['customer_group_description'];
		} elseif (isset(request::$get['customer_group_id'])) {
			$data['customer_group_description'] = admin_customer_customer_group::getCustomerGroupDescriptions(request::$get['customer_group_id']);
		} else {
			$data['customer_group_description'] = array();
		}

		if (isset(request::$post['approval'])) {
			$data['approval'] = request::$post['approval'];
		} elseif (!empty($customer_group_info)) {
			$data['approval'] = $customer_group_info['approval'];
		} else {
			$data['approval'] = '';
		}

		if (isset(request::$post['sort_order'])) {
			$data['sort_order'] = request::$post['sort_order'];
		} elseif (!empty($customer_group_info)) {
			$data['sort_order'] = $customer_group_info['sort_order'];
		} else {
			$data['sort_order'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('customer/customer_group_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'customer/customer_group')) {
			self::$error['warning'] = language::get('error_permission');
		}

		foreach (request::$post['customer_group_description'] as $language_id => $value) {
			if ((utf8_strlen($value['name']) < 3) || (utf8_strlen($value['name']) > 32)) {
				self::$error['name'][$language_id] = language::get('error_name');
			}
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'customer/customer_group')) {
			self::$error['warning'] = language::get('error_permission');
		}


		foreach (request::$post['selected'] as $customer_group_id) {
			if (config('customer_group_id') == $customer_group_id) {
				self::$error['warning'] = language::get('error_default');
			}

			$store_total = admin_setting_store::getTotalStoresByCustomerGroupId($customer_group_id);

			if ($store_total) {
				self::$error['warning'] = sprintf(language::get('error_store'), $store_total);
			}

			$customer_total = admin_customer_customer::getTotalCustomersByCustomerGroupId($customer_group_id);

			if ($customer_total) {
				self::$error['warning'] = sprintf(language::get('error_customer'), $customer_total);
			}
		}

		return !self::$error;
	}
}