<?php
class ControllerDesignSeoUrl {
	private static $error = array();

	public static function index() {
		load::language('design/seo_url');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('design/seo_url');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_design_seo_url::addSeoUrl(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_query'])) {
				$url .= '&filter_query=' . urlencode(html_entity_decode(request::$get['filter_query'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_keyword'])) {
				$url .= '&filter_keyword=' . urlencode(html_entity_decode(request::$get['filter_keyword'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_store_id'])) {
				$url .= '&filter_store_id=' . request::$get['filter_store_id'];
			}

			if (isset(request::$get['filter_language_id'])) {
				$url .= '&filter_language_id=' . request::$get['filter_language_id'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('design/seo_url', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('design/seo_url');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_design_seo_url::editSeoUrl(request::$get['seo_url_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_query'])) {
				$url .= '&filter_query=' . urlencode(html_entity_decode(request::$get['filter_query'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_keyword'])) {
				$url .= '&filter_keyword=' . urlencode(html_entity_decode(request::$get['filter_keyword'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_store_id'])) {
				$url .= '&filter_store_id=' . request::$get['filter_store_id'];
			}

			if (isset(request::$get['filter_language_id'])) {
				$url .= '&filter_language_id=' . request::$get['filter_language_id'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('design/seo_url', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('design/seo_url');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $seo_url_id) {
				admin_design_seo_url::deleteSeoUrl($seo_url_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_query'])) {
				$url .= '&filter_query=' . urlencode(html_entity_decode(request::$get['filter_query'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_keyword'])) {
				$url .= '&filter_keyword=' . urlencode(html_entity_decode(request::$get['filter_keyword'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_store_id'])) {
				$url .= '&filter_store_id=' . request::$get['filter_store_id'];
			}

			if (isset(request::$get['filter_language_id'])) {
				$url .= '&filter_language_id=' . request::$get['filter_language_id'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('design/seo_url', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['filter_query'])) {
			$filter_query = request::$get['filter_query'];
		} else {
			$filter_query = '';
		}

		if (isset(request::$get['filter_keyword'])) {
			$filter_keyword = request::$get['filter_keyword'];
		} else {
			$filter_keyword = '';
		}

		if (isset(request::$get['filter_store_id'])) {
			$filter_store_id = request::$get['filter_store_id'];
		} else {
			$filter_store_id = '';
		}

		if (isset(request::$get['filter_language_id'])) {
			$filter_language_id = request::$get['filter_language_id'];
		} else {
			$filter_language_id = '';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'keyword';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['filter_query'])) {
			$url .= '&filter_query=' . urlencode(html_entity_decode(request::$get['filter_query'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_keyword'])) {
			$url .= '&filter_keyword=' . urlencode(html_entity_decode(request::$get['filter_keyword'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_store_id'])) {
			$url .= '&filter_store_id=' . request::$get['filter_store_id'];
		}

		if (isset(request::$get['filter_language_id'])) {
			$url .= '&filter_language_id=' . request::$get['filter_language_id'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('design/seo_url', $url)
		);

		$data['add'] = url::link('design/seo_url/add', $url);
		$data['delete'] = url::link('design/seo_url/delete', $url);

		$data['seo_urls'] = array();

		$filter_data = array(
			'filter_query'	     => $filter_query,
			'filter_keyword'	 => $filter_keyword,
			'filter_store_id'	 => $filter_store_id,
			'filter_language_id' => $filter_language_id,
			'sort'               => $sort,
			'order'              => $order,
			'start'              => ($page - 1) * config('limit_admin'),
			'limit'              => config('limit_admin')
		);

		$seo_url_total = admin_design_seo_url::getTotalSeoUrls($filter_data);

		$results = admin_design_seo_url::getSeoUrls($filter_data);

		foreach ($results as $result) {
			$data['seo_urls'][] = array(
				'seo_url_id' => $result['seo_url_id'],
				'query'      => $result['query'],
				'keyword'    => $result['keyword'],
				'store'      => $result['store_id'] ? $result['store'] : language::get('text_default'),
				'language'   => $result['language'],
				'edit'       => url::link('design/seo_url/edit', '&seo_url_id=' . $result['seo_url_id'] . $url)
			);
		}


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_query'])) {
			$url .= '&filter_query=' . urlencode(html_entity_decode(request::$get['filter_query'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_keyword'])) {
			$url .= '&filter_keyword=' . urlencode(html_entity_decode(request::$get['filter_keyword'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_store_id'])) {
			$url .= '&filter_store_id=' . request::$get['filter_store_id'];
		}

		if (isset(request::$get['filter_language_id'])) {
			$url .= '&filter_language_id=' . request::$get['filter_language_id'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_query'] = url::link('design/seo_url', '&sort=query' . $url);
		$data['sort_keyword'] = url::link('design/seo_url', '&sort=keyword' . $url);
		$data['sort_store'] = url::link('design/seo_url', '&sort=store' . $url);
		$data['sort_language'] = url::link('design/seo_url', '&sort=language' . $url);

		$url = '';

		if (isset(request::$get['filter_query'])) {
			$url .= '&filter_query=' . urlencode(html_entity_decode(request::$get['filter_query'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_keyword'])) {
			$url .= '&filter_keyword=' . urlencode(html_entity_decode(request::$get['filter_keyword'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_store_id'])) {
			$url .= '&filter_store_id=' . request::$get['filter_store_id'];
		}

		if (isset(request::$get['filter_language_id'])) {
			$url .= '&filter_language_id=' . request::$get['filter_language_id'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $seo_url_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('design/seo_url', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($seo_url_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($seo_url_total - config('limit_admin'))) ? $seo_url_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $seo_url_total, ceil($seo_url_total / config('limit_admin')));

		$data['filter_query'] = $filter_query;
		$data['filter_keyword'] = $filter_keyword;
		$data['filter_store_id'] = $filter_store_id;
		$data['filter_language_id'] = $filter_language_id;

		$data['sort'] = $sort;
		$data['order'] = $order;


		$data['stores'] = admin_setting_store::getStores();


		$data['languages'] = admin_localisation_language::getLanguages();

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('design/seo_url_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['seo_url_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['query'])) {
			$data['error_query'] = self::$error['query'];
		} else {
			$data['error_query'] = '';
		}

		if (isset(self::$error['keyword'])) {
			$data['error_keyword'] = self::$error['keyword'];
		} else {
			$data['error_keyword'] = '';
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('design/seo_url', $url)
		);

		if (!isset(request::$get['seo_url_id'])) {
			$data['action'] = url::link('design/seo_url/add', $url);
		} else {
			$data['action'] = url::link('design/seo_url/edit', '&seo_url_id=' . request::$get['seo_url_id'] . $url);
		}

		$data['cancel'] = url::link('design/seo_url', $url);

		if (isset(request::$get['seo_url_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$seo_url_info = admin_design_seo_url::getSeoUrl(request::$get['seo_url_id']);
		}

		if (isset(request::$post['query'])) {
			$data['query'] = request::$post['query'];
		} elseif (!empty($seo_url_info)) {
			$data['query'] = $seo_url_info['query'];
		} else {
			$data['query'] = '';
		}

		if (isset(request::$post['keyword'])) {
			$data['keyword'] = request::$post['keyword'];
		} elseif (!empty($seo_url_info)) {
			$data['keyword'] = $seo_url_info['keyword'];
		} else {
			$data['keyword'] = '';
		}


		$data['stores'] = array();

		$data['stores'][] = array(
			'store_id' => 0,
			'name'     => language::get('text_default')
		);

		$stores = admin_setting_store::getStores();

		foreach ($stores as $store) {
			$data['stores'][] = array(
				'store_id' => $store['store_id'],
				'name'     => $store['name']
			);
		}

		if (isset(request::$post['store_id'])) {
			$data['store_id'] = request::$post['store_id'];
		} elseif (!empty($seo_url_info)) {
			$data['store_id'] = $seo_url_info['store_id'];
		} else {
			$data['store_id'] = '';
		}


		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['language_id'])) {
			$data['language_id'] = request::$post['language_id'];
		} elseif (!empty($seo_url_info)) {
			$data['language_id'] = $seo_url_info['language_id'];
		} else {
			$data['language_id'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('design/seo_url_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'design/seo_url')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if(isset(request::$get['seo_url_id']) && request::$get['seo_url_id']) {
			$seo_urls = admin_design_seo_url::getSeoUrlsByQueryId(request::$get['seo_url_id'], request::$post['query']);
		} else {
			$seo_urls = admin_design_seo_url::getSeoUrlsByQuery(request::$post['query']);
		}
		
		foreach ($seo_urls as $seo_url) {
			if ($seo_url['store_id'] == request::$post['store_id'] && $seo_url['query'] == request::$post['query']) {
				self::$error['query'] = language::get('error_query_exists');

				break;
			}
		}

		if (!request::$post['query']) {
			self::$error['query'] = language::get('error_query');
		}

		$seo_urls = admin_design_seo_url::getSeoUrlsByKeyword(request::$post['keyword']);

		foreach ($seo_urls as $seo_url) {
			if ($seo_url['store_id'] == request::$post['store_id'] && $seo_url['query'] != request::$post['query']) {
				self::$error['keyword'] = language::get('error_exists');

				break;
			}
		}

		if (!request::$post['keyword']) {
			self::$error['keyword'] = language::get('error_keyword');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'design/seo_url')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}
