<?php
class ControllerDesignTranslation {
	private static $error = array();

	public static function index() {
		load::language('design/translation');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('design/translation');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_design_translation::addTranslation(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('design/translation', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('design/translation');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_design_translation::editTranslation(request::$get['translation_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('design/translation', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('design/translation');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $translation_id) {
				admin_design_translation::deleteTranslation($translation_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('design/translation', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'store';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('design/translation')
		);


		$data['add'] = url::link('design/translation/add', $url);
		$data['delete'] = url::link('design/translation/delete', $url);

		$data['translations'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * config('limit_admin'),
			'limit' => config('limit_admin')
		);

		$translation_total = admin_design_translation::getTotalTranslations();

		$results = admin_design_translation::getTranslations($filter_data);

		foreach ($results as $result) {
			$data['translations'][] = array(
				'translation_id' => $result['translation_id'],
				'store'          => ($result['store_id'] ? $result['store'] : language::get('text_default')),
				'route'          => $result['route'],
				'language'       => $result['language'],
				'key'            => $result['key'],
				'value'          => $result['value'],
				'edit'           => url::link('design/translation/edit', '&translation_id=' . $result['translation_id']),
			);
		}


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_store'] = url::link('design/translation', '&sort=store' . $url);
		$data['sort_language'] = url::link('design/translation', '&sort=language' . $url);
		$data['sort_route'] = url::link('design/translation', '&sort=route' . $url);
		$data['sort_key'] = url::link('design/translation', '&sort=key' . $url);
		$data['sort_value'] = url::link('design/translation', '&sort=value' . $url);

		$pagination = new Pagination();
		$pagination::$total = $translation_total;
		$pagination::$page = $page;
		$pagination::$limit = 10;
		$pagination::$url = url::link('design/translation/history', '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($translation_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($translation_total - config('limit_admin'))) ? $translation_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $translation_total, ceil($translation_total / config('limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('design/translation_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['translation_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['key'])) {
			$data['error_key'] = self::$error['key'];
		} else {
			$data['error_key'] = '';
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('design/translation', $url)
		);

		if (!isset(request::$get['translation_id'])) {
			$data['action'] = url::link('design/translation/add', $url);
		} else {
			$data['action'] = url::link('design/translation/edit', '&translation_id=' . request::$get['translation_id'] . $url);
		}

		$data['cancel'] = url::link('design/translation', $url);


		if (isset(request::$get['translation_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$translation_info = admin_design_translation::getTranslation(request::$get['translation_id']);
		}


		$data['stores'] = admin_setting_store::getStores();

		if (isset(request::$post['store_id'])) {
			$data['store_id'] = request::$post['store_id'];
		} elseif (!empty($translation_info)) {
			$data['store_id'] = $translation_info['store_id'];
		} else {
			$data['store_id'] = '';
		}


		$data['languages'] = admin_localisation_language::getLanguages();

		if (!empty($translation_info)) {
			$language = admin_localisation_language::getLanguage($translation_info['language_id']);
			$code = $language['code'];
		} else {
			$code = config('language');
			$language = admin_localisation_language::getLanguageByCode($code);
		}

		if (isset(request::$post['language_id'])) {
			$data['language_id'] = request::$post['language_id'];
		} elseif (!empty($translation_info)) {
			$data['language_id'] = $translation_info['language_id'];
		} else {
			$data['language_id'] = $language['language_id'];
		}

		if (empty($translation_info)) {
			// Get a list of files ready to upload
			$data['paths'] = array();

			$path = glob(DIR_CATALOG . 'language/' . $code . '/*');

			while (count($path) != 0) {
				$next = array_shift($path);

				foreach ((array)glob($next) as $file) {
					if (is_dir($file)) {
						$path[] = $file . '/*';
					}

					if (substr($file, -4) == '.php') {
						$data['paths'][] = substr(substr($file, strlen(DIR_CATALOG . 'language/' . $code . '/')), 0, -4);
					}
				}
			}
		}

		if (isset(request::$post['route'])) {
			$data['route'] = request::$post['route'];
		} elseif (!empty($translation_info)) {
			$data['route'] = $translation_info['route'];
		} else {
			$data['route'] = '';
		}

		if (isset(request::$post['key'])) {
			$data['key'] = request::$post['key'];
		} elseif (!empty($translation_info)) {
			$data['key'] = $translation_info['key'];
		} else {
			$data['key'] = '';
		}

		if (!empty($translation_info)) {
			$directory = DIR_CATALOG . 'language/';

			if (is_file($directory . $code . '/' . $translation_info['route'] . '.php') && substr(str_replace('\\', '/', realpath($directory . $code . '/' . $translation_info['route'] . '.php')), 0, strlen($directory)) == str_replace('\\', '/', $directory)) {
				$_ = array();

				include($directory . $code . '/' . $translation_info['route'] . '.php');

				foreach ($_ as $key => $value) {
					if ($translation_info['key'] == $key) {
						$data['default'] = $value;
					}
				}

				if (empty($data['default'])) {
					$data['default'] = $translation_info['value'];
				}
			}
		}

		if (isset(request::$post['value'])) {
			$data['value'] = request::$post['value'];
		} elseif (!empty($translation_info)) {
			$data['value'] = $translation_info['value'];
		} else {
			$data['value'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('design/translation_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'design/translation')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if ((utf8_strlen(request::$post['key']) < 3) || (utf8_strlen(request::$post['key']) > 64)) {
			self::$error['key'] = language::get('error_key');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'design/translation')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	public static function path() {
		load::language('design/translation');

		$json = array();

		if (isset(request::$get['language_id'])) {
			$language_id = request::$get['language_id'];
		} else {
			$language_id = 0;
		}


		$language_info = admin_localisation_language::getLanguage($language_id);

		if (!empty($language_info)) {
			$path = glob(DIR_CATALOG . 'language/' . $language_info['code'] . '/*');

			while (count($path) != 0) {
				$next = array_shift($path);

				foreach ((array)glob($next) as $file) {
					if (is_dir($file)) {
						$path[] = $file . '/*';
					}

					if (substr($file, -4) == '.php') {
						$json[] = substr(substr($file, strlen(DIR_CATALOG . 'language/' . $language_info['code'] . '/')), 0, -4);
					}
				}
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function translation() {
		load::language('design/translation');

		$json = array();

		if (isset(request::$get['store_id'])) {
			$store_id = request::$get['store_id'];
		} else {
			$store_id = 0;
		}

		if (isset(request::$get['language_id'])) {
			$language_id = request::$get['language_id'];
		} else {
			$language_id = 0;
		}

		if (isset(request::$get['path'])) {
			$route = request::$get['path'];
		} else {
			$route = '';
		}


		$language_info = admin_localisation_language::getLanguage($language_id);

		$directory = DIR_CATALOG . 'language/';

		if ($language_info && is_file($directory . $language_info['code'] . '/' . $route . '.php') && substr(str_replace('\\', '/', realpath($directory . $language_info['code'] . '/' . $route . '.php')), 0, strlen($directory)) == str_replace('\\', '/', $directory)) {
			$_ = array();

			include($directory . $language_info['code'] . '/' . $route . '.php');

			foreach ($_ as $key => $value) {
				$json[] = array(
					'key'   => $key,
					'value' => $value
				);
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
