<?php
class ControllerExtensionAnalyticsGoogle {
	private static $error = array();

	public static function index() {
		load::language('extension/analytics/google');

		document::setTitle(language::get('heading_title'));

		
		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('analytics_google', request::$post, request::$get['store_id']);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=analytics'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['code'])) {
			$data['error_code'] = self::$error['code'];
		} else {
			$data['error_code'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=analytics')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/analytics/google', '&store_id=' . request::$get['store_id'])
		);

		$data['action'] = url::link('extension/analytics/google', '&store_id=' . request::$get['store_id']);

		$data['cancel'] = url::link('marketplace/extension', '&type=analytics');
		
				
		if (isset(request::$post['analytics_google_code'])) {
			$data['analytics_google_code'] = request::$post['analytics_google_code'];
		} else {
			$data['analytics_google_code'] = admin_setting_setting::getSettingValue('analytics_google_code', request::$get['store_id']);
		}
		
		if (isset(request::$post['analytics_google_status'])) {
			$data['analytics_google_status'] = request::$post['analytics_google_status'];
		} else {
			$data['analytics_google_status'] = admin_setting_setting::getSettingValue('analytics_google_status', request::$get['store_id']);
		}
		
		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/analytics/google', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/analytics/google')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['analytics_google_code']) {
			self::$error['code'] = language::get('error_code');
		}			

		return !self::$error;
	}
}
