<?php
class ControllerExtensionCaptchaBasic {
	private static $error = array();

	public static function index() {
		load::language('extension/captcha/basic');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('captcha_basic', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=captcha'));
		}
		
		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=captcha')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/captcha/basic')
		);

		$data['action'] = url::link('extension/captcha/basic');

		$data['cancel'] = url::link('marketplace/extension', '&type=captcha');

		if (isset(request::$post['captcha_basic_status'])) {
			$data['captcha_basic_status'] = request::$post['captcha_basic_status'];
		} else {
			$data['captcha_basic_status'] = config::get('captcha_basic_status');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/captcha/basic', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/captcha/basic')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}
