<?php
class ControllerExtensionCaptchaGoogle {
	private static $error = array();

	public static function index() {
		load::language('extension/captcha/google');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('captcha_google', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=captcha'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['key'])) {
			$data['error_key'] = self::$error['key'];
		} else {
			$data['error_key'] = '';
		}

		if (isset(self::$error['secret'])) {
			$data['error_secret'] = self::$error['secret'];
		} else {
			$data['error_secret'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=captcha')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/captcha/google')
		);

		$data['action'] = url::link('extension/captcha/google');

		$data['cancel'] = url::link('marketplace/extension', '&type=captcha');

		if (isset(request::$post['captcha_google_key'])) {
			$data['captcha_google_key'] = request::$post['captcha_google_key'];
		} else {
			$data['captcha_google_key'] = config::get('captcha_google_key');
		}

		if (isset(request::$post['captcha_google_secret'])) {
			$data['captcha_google_secret'] = request::$post['captcha_google_secret'];
		} else {
			$data['captcha_google_secret'] = config::get('captcha_google_secret');
		}

		if (isset(request::$post['captcha_google_status'])) {
			$data['captcha_google_status'] = request::$post['captcha_google_status'];
		} else {
			$data['captcha_google_status'] = config::get('captcha_google_status');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/captcha/google', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/captcha/google')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['captcha_google_key']) {
			self::$error['key'] = language::get('error_key');
		}

		if (!request::$post['captcha_google_secret']) {
			self::$error['secret'] = language::get('error_secret');
		}

		return !self::$error;
	}
}
