<?php
class ControllerExtensionDashboardOnline {
	private static $error = array();

	public static function index() {
		load::language('extension/dashboard/online');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('dashboard_online', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=dashboard'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/dashboard/online')
		);

		$data['action'] = url::link('extension/dashboard/online');

		$data['cancel'] = url::link('marketplace/extension', '&type=dashboard');

		if (isset(request::$post['dashboard_online_width'])) {
			$data['dashboard_online_width'] = request::$post['dashboard_online_width'];
		} else {
			$data['dashboard_online_width'] = config::get('dashboard_online_width');
		}
	
		$data['columns'] = array();
		
		for ($i = 3; $i <= 12; $i++) {
			$data['columns'][] = $i;
		}
				
		if (isset(request::$post['dashboard_online_status'])) {
			$data['dashboard_online_status'] = request::$post['dashboard_online_status'];
		} else {
			$data['dashboard_online_status'] = config::get('dashboard_online_status');
		}

		if (isset(request::$post['dashboard_online_sort_order'])) {
			$data['dashboard_online_sort_order'] = request::$post['dashboard_online_sort_order'];
		} else {
			$data['dashboard_online_sort_order'] = config::get('dashboard_online_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/dashboard/online_form', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/dashboard/online')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
	
	public static function dashboard() {
		load::language('extension/dashboard/online');


		// Total Orders

		// Customers Online
		$online_total = admin_extension_dashboard_online::getTotalOnline();

		if ($online_total > 1000000000000) {
			$data['total'] = round($online_total / 1000000000000, 1) . 'T';
		} elseif ($online_total > 1000000000) {
			$data['total'] = round($online_total / 1000000000, 1) . 'B';
		} elseif ($online_total > 1000000) {
			$data['total'] = round($online_total / 1000000, 1) . 'M';
		} elseif ($online_total > 1000) {
			$data['total'] = round($online_total / 1000, 1) . 'K';
		} else {
			$data['total'] = $online_total;
		}

		$data['online'] = url::link('report/online');

		return load::view('extension/dashboard/online_info', $data);
	}
}
