<?php
class ControllerExtensionExtensionAdvertise {
    private static $error = array();

    public static function index() {
        load::language('extension/extension/advertise');


        self::getList();
    }

    public static function install() {
        load::language('extension/extension/advertise');


        if (self::validate()) {
            admin_setting_extension::install('advertise', request::$get['extension']);


            admin_user_user_group::addPermission(user::getGroupId(), 'access', 'extension/advertise/' . request::$get['extension']);
            admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'extension/advertise/' . request::$get['extension']);
            
            // Compatibility
            admin_user_user_group::addPermission(user::getGroupId(), 'access', 'advertise/' . request::$get['extension']);
            admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'advertise/' . request::$get['extension']);

            // Call install method if it exsits
            load::controller('extension/advertise/' . request::$get['extension'] . '/install');

            session::$data['success'] = language::get('text_success');
        }

        self::getList();
    }

    public static function uninstall() {
        load::language('extension/extension/advertise');


        if (self::validate()) {
            admin_setting_extension::uninstall('advertise', request::$get['extension']);

            // Call uninstall method if it exsits
            load::controller('extension/advertise/' . request::$get['extension'] . '/uninstall');

            session::$data['success'] = language::get('text_success');
        }

        self::getList();
    }

    protected static function getList() {
        if (isset(self::$error['warning'])) {
            $data['error_warning'] = self::$error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset(session::$data['success'])) {
            $data['success'] = session::$data['success'];

            unset(session::$data['success']);
        } else {
            $data['success'] = '';
        }

        $extensions = admin_setting_extension::getInstalled('advertise');

        foreach ($extensions as $key => $value) {
            if (!is_file(DIR_APPLICATION . 'controller/extension/advertise/' . $value . '.php') && !is_file(DIR_APPLICATION . 'controller/advertise/' . $value . '.php')) {
                admin_setting_extension::uninstall('advertise', $value);

                unset($extensions[$key]);
            }
        }
        

        $stores = admin_setting_store::getStores();
        
        $data['extensions'] = array();

        // Compatibility code for old extension folders
        $files = glob(DIR_APPLICATION . 'controller/extension/advertise/*.php');

        if ($files) {
            foreach ($files as $file) {
                $extension = basename($file, '.php');
                
                // Compatibility code for old extension folders
                load::language('extension/advertise/' . $extension, 'extension');
                
                $store_data = array();

                $store_data[] = array(
                    'name'   => config('name'),
                    'edit'   => url::link('extension/advertise/' . $extension, '&store_id=0'),
                    'status' => config::get('advertise_' . $extension . '_status') ? language::get('text_enabled') : language::get('text_disabled')
                );
                
                foreach ($stores as $store) {
                    $store_data[] = array(
                        'name'   => $store['name'],
                        'edit'   => url::link('extension/advertise/' . $extension, '&store_id=' . $store['store_id']),
                        'status' => admin_setting_setting::getSettingValue('advertise_' . $extension . '_status', $store['store_id']) ? language::get('text_enabled') : language::get('text_disabled')
                    );
                }

                $data['extensions'][] = array(
                    'name'      => language::get('extension')::get('heading_title'),
                    'install'   => url::link('extension/extension/advertise/install', '&extension=' . $extension),
                    'uninstall' => url::link('extension/extension/advertise/uninstall', '&extension=' . $extension),
                    'installed' => in_array($extension, $extensions),
                    'store'     => $store_data
                );
            }
        }

        response::setOutput(load::view('extension/extension/advertise', $data));
    }

    protected static function validate() {
        if (!user::hasPermission('modify', 'extension/extension/advertise')) {
            self::$error['warning'] = language::get('error_permission');
        }

        return !self::$error;
    }
}
