<?php
class ControllerExtensionExtensionAnalytics {
	private static $error = array();

	public static function index() {
		load::language('extension/extension/analytics');


		self::getList();
	}

	public static function install() {
		load::language('extension/extension/analytics');


		if (self::validate()) {
			admin_setting_extension::install('analytics', request::$get['extension']);


			admin_user_user_group::addPermission(user::getGroupId(), 'access', 'extension/analytics/' . request::$get['extension']);
			admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'extension/analytics/' . request::$get['extension']);
			
			// Compatibility
			admin_user_user_group::addPermission(user::getGroupId(), 'access', 'analytics/' . request::$get['extension']);
			admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'analytics/' . request::$get['extension']);

			// Call install method if it exsits
			load::controller('extension/analytics/' . request::$get['extension'] . '/install');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	public static function uninstall() {
		load::language('extension/extension/analytics');


		if (self::validate()) {
			admin_setting_extension::uninstall('analytics', request::$get['extension']);

			// Call uninstall method if it exsits
			load::controller('extension/analytics/' . request::$get['extension'] . '/uninstall');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		$extensions = admin_setting_extension::getInstalled('analytics');

		foreach ($extensions as $key => $value) {
			if (!is_file(DIR_APPLICATION . 'controller/extension/analytics/' . $value . '.php') && !is_file(DIR_APPLICATION . 'controller/analytics/' . $value . '.php')) {
				admin_setting_extension::uninstall('analytics', $value);

				unset($extensions[$key]);
			}
		}
		

		$stores = admin_setting_store::getStores();
		
		$data['extensions'] = array();

		// Compatibility code for old extension folders
		$files = glob(DIR_APPLICATION . 'controller/extension/analytics/*.php');

		if ($files) {
			foreach ($files as $file) {
				$extension = basename($file, '.php');
				
				// Compatibility code for old extension folders
				load::language('extension/analytics/' . $extension, 'extension');
				
				$store_data = array();

				$store_data[] = array(
					'name'   => config('name'),
					'edit'   => url::link('extension/analytics/' . $extension, '&store_id=0'),
					'status' => config::get('analytics_' . $extension . '_status') ? language::get('text_enabled') : language::get('text_disabled')
				);
				
				foreach ($stores as $store) {
					$store_data[] = array(
						'name'   => $store['name'],
						'edit'   => url::link('extension/analytics/' . $extension, '&store_id=' . $store['store_id']),
						'status' => admin_setting_setting::getSettingValue('analytics_' . $extension . '_status', $store['store_id']) ? language::get('text_enabled') : language::get('text_disabled')
					);
				}

				$data['extensions'][] = array(
					'name'      => language::get('extension')::get('heading_title'),
					'install'   => url::link('extension/extension/analytics/install', '&extension=' . $extension),
					'uninstall' => url::link('extension/extension/analytics/uninstall', '&extension=' . $extension),
					'installed' => in_array($extension, $extensions),
					'store'     => $store_data
				);
			}
		}

		$data['promotion'] = load::controller('extension/extension/promotion');

		response::setOutput(load::view('extension/extension/analytics', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/extension/analytics')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}
