<?php
class ControllerExtensionExtensionCaptcha {
	private static $error = array();

	public static function index() {
		load::language('extension/extension/captcha');


		self::getList();
	}

	public static function install() {
		load::language('extension/extension/captcha');


		if (self::validate()) {
			admin_setting_extension::install('captcha', request::$get['extension']);


			admin_user_user_group::addPermission(user::getGroupId(), 'access', 'extension/captcha/' . request::$get['extension']);
			admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'extension/captcha/' . request::$get['extension']);

			// Compatibility
			admin_user_user_group::addPermission(user::getGroupId(), 'access', 'captcha/' . request::$get['extension']);
			admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'captcha/' . request::$get['extension']);

			// Call install method if it exsits
			load::controller('extension/captcha/' . request::$get['extension'] . '/install');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	public static function uninstall() {
		load::language('extension/extension/captcha');


		if (self::validate()) {
			admin_setting_extension::uninstall('captcha', request::$get['extension']);

			// Call uninstall method if it exsits
			load::controller('extension/captcha/' . request::$get['extension'] . '/uninstall');

			session::$data['success'] = language::get('text_success');
		}
		
		self::getList();
	}

	protected static function getList() {
		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		$extensions = admin_setting_extension::getInstalled('captcha');

		foreach ($extensions as $key => $value) {
			if (!is_file(DIR_APPLICATION . 'controller/extension/captcha/' . $value . '.php') && !is_file(DIR_APPLICATION . 'controller/captcha/' . $value . '.php')) {
				admin_setting_extension::uninstall('captcha', $value);

				unset($extensions[$key]);
			}
		}

		$data['extensions'] = array();
		
		// Compatibility code for old extension folders
		$files = glob(DIR_APPLICATION . 'controller/extension/captcha/*.php');

		if ($files) {
			foreach ($files as $file) {
				$extension = basename($file, '.php');

				load::language('extension/captcha/' . $extension, 'extension');

				$data['extensions'][] = array(
					'name'      => language::get('extension')::get('heading_title') . (($extension == config('captcha')) ? language::get('text_default') : null),
					'status'    => config::get('captcha_' . $extension . '_status') ? language::get('text_enabled') : language::get('text_disabled'),
					'install'   => url::link('extension/extension/captcha/install', '&extension=' . $extension),
					'uninstall' => url::link('extension/extension/captcha/uninstall', '&extension=' . $extension),
					'installed' => in_array($extension, $extensions),
					'edit'      => url::link('extension/captcha/' . $extension)
				);
			}
		}

		$data['promotion'] = load::controller('extension/extension/promotion');

		response::setOutput(load::view('extension/extension/captcha', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/extension/captcha')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}