<?php
class ControllerExtensionExtensionMenu {
	private static $error = array();

	public static function index() {
		load::language('extension/extension/menu');


		self::getList();
	}

	public static function install() {
		load::language('extension/extension/menu');


		if (self::validate()) {
			admin_setting_extension::install('menu', request::$get['extension']);


			admin_user_user_group::addPermission(user::getGroupId(), 'access', 'extension/menu/' . request::$get['extension']);
			admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'extension/menu/' . request::$get['extension']);

			// Call install method if it exsits
			load::controller('extension/menu/' . request::$get['extension'] . '/install');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	public static function uninstall() {
		load::language('extension/extension/menu');


		if (self::validate()) {
			admin_setting_extension::uninstall('menu', request::$get['extension']);

			// Call uninstall method if it exsits
			load::controller('extension/menu/' . request::$get['extension'] . '/uninstall');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	protected static function getList() {
		$data['text_layout'] = sprintf(language::get('text_layout'), url::link('design/layout'));

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		$extensions = admin_setting_extension::getInstalled('menu');

		foreach ($extensions as $key => $value) {
			if (!is_file(DIR_APPLICATION . 'controller/extension/menu/' . $value . '.php') && !is_file(DIR_APPLICATION . 'controller/menu/' . $value . '.php')) {
				admin_setting_extension::uninstall('menu', $value);

				unset($extensions[$key]);
			}
		}

		$data['extensions'] = array();
		
		// Compatibility code for old extension folders
		$files = glob(DIR_APPLICATION . 'controller/extension/menu/*.php');

		if ($files) {
			foreach ($files as $file) {
				$extension = basename($file, '.php');

				load::language('extension/menu/' . $extension, 'extension');

				$data['extensions'][] = array(
					'name'      => language::get('extension')::get('heading_title'),
					'status'    => config::get('menu_' . $extension . '_status') ? language::get('text_enabled') : language::get('text_disabled'),
					'install'   => url::link('extension/extension/menu/install', '&extension=' . $extension),
					'uninstall' => url::link('extension/extension/menu/uninstall', '&extension=' . $extension),
					'installed' => in_array($extension, $extensions),
					'edit'      => url::link('extension/menu/' . $extension)
				);
			}
		}

		$sort_order = array();

		foreach ($data['extensions'] as $key => $value) {
			$sort_order[$key] = $value['name'];
		}

		array_multisort($sort_order, SORT_ASC, $data['extensions']);

		$data['promotion'] = load::controller('extension/extension/promotion');

		response::setOutput(load::view('extension/extension/menu', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/extension/menu')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}
