<?php
class ControllerExtensionExtensionPayment {
	private static $error = array();

	public static function index() {
		load::language('extension/extension/payment');
		

		self::getList();
	}

	public static function install() {
		load::language('extension/extension/payment');


		if (self::validate()) {
			admin_setting_extension::install('payment', request::$get['extension']);


			admin_user_user_group::addPermission(user::getGroupId(), 'access', 'extension/payment/' . request::$get['extension']);
			admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'extension/payment/' . request::$get['extension']);

			// Call install method if it exsits
			load::controller('extension/payment/' . request::$get['extension'] . '/install');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	public static function uninstall() {
		load::language('extension/extension/payment');


		if (self::validate()) {
			admin_setting_extension::uninstall('payment', request::$get['extension']);

			// Call uninstall method if it exsits
			load::controller('extension/payment/' . request::$get['extension'] . '/uninstall');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}


		$extensions = admin_setting_extension::getInstalled('payment');

		foreach ($extensions as $key => $value) {
			if (!is_file(DIR_APPLICATION . 'controller/extension/payment/' . $value . '.php') && !is_file(DIR_APPLICATION . 'controller/payment/' . $value . '.php')) {
				admin_setting_extension::uninstall('payment', $value);

				unset($extensions[$key]);
			}
		}

		$data['extensions'] = array();
		
		// Compatibility code for old extension folders
		$files = glob(DIR_APPLICATION . 'controller/extension/payment/*.php');

		if ($files) {
			foreach ($files as $file) {
				$extension = basename($file, '.php');

				load::language('extension/payment/' . $extension, 'extension');

				$text_link = language::get('extension')::get('text_' . $extension);

				if ($text_link != 'text_' . $extension) {
					$link = $text_link;
				} else {
					$link = '';
				}

				$data['extensions'][] = array(
					'name'       => language::get('extension')::get('heading_title'),
					'link'       => $link,
					'status'     => config::get('payment_' . $extension . '_status') ? language::get('text_enabled') : language::get('text_disabled'),
					'sort_order' => config::get('payment_' . $extension . '_sort_order'),
					'install'    => url::link('extension/extension/payment/install', '&extension=' . $extension),
					'uninstall'  => url::link('extension/extension/payment/uninstall', '&extension=' . $extension),
					'installed'  => in_array($extension, $extensions),
					'edit'       => url::link('extension/payment/' . $extension)
				);
			}
		}

		$data['promotion'] = load::controller('extension/extension/promotion');

		response::setOutput(load::view('extension/extension/payment', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/extension/payment')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}