<?php
class ControllerExtensionExtensionReport {
	private static $error = array();

	public static function index() {
		load::language('extension/extension/report');


		self::getList();
	}

	public static function install() {
		load::language('extension/extension/report');


		if (self::validate()) {
			admin_setting_extension::install('report', request::$get['extension']);


			admin_user_user_group::addPermission(user::getGroupId(), 'access', 'extension/report/' . request::$get['extension']);
			admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'extension/report/' . request::$get['extension']);

			load::controller('extension/report/' . request::$get['extension'] . '/install');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	public static function uninstall() {
		load::language('extension/extension/report');


		if (self::validate()) {
			admin_setting_extension::uninstall('report', request::$get['extension']);

			load::controller('extension/report/' . request::$get['extension'] . '/uninstall');

			session::$data['success'] = language::get('text_success');
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}


		$extensions = admin_setting_extension::getInstalled('report');

		foreach ($extensions as $key => $value) {
			if (!is_file(DIR_APPLICATION . 'controller/extension/report/' . $value . '.php') && !is_file(DIR_APPLICATION . 'controller/report/' . $value . '.php')) {
				admin_setting_extension::uninstall('report', $value);

				unset($extensions[$key]);
			}
		}

		$data['extensions'] = array();
		
		// Compatibility code for old extension folders
		$files = glob(DIR_APPLICATION . 'controller/extension/report/*.php');

		if ($files) {
			foreach ($files as $file) {
				$extension = basename($file, '.php');

				load::language('extension/report/' . $extension, 'extension');

				$data['extensions'][] = array(
					'name'       => language::get('extension')::get('heading_title'),
					'status'     => config::get('report_' . $extension . '_status') ? language::get('text_enabled') : language::get('text_disabled'),
					'sort_order' => config::get('report_' . $extension . '_sort_order'),
					'install'    => url::link('extension/extension/report/install', '&extension=' . $extension),
					'uninstall'  => url::link('extension/extension/report/uninstall', '&extension=' . $extension),
					'installed'  => in_array($extension, $extensions),
					'edit'       => url::link('extension/report/' . $extension)
				);
			}
		}

		$data['promotion'] = load::controller('extension/extension/promotion');

		response::setOutput(load::view('extension/extension/report', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/extension/report')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}