<?php
class ControllerExtensionFeedGoogleSitemap {
	private static $error = array();

	public static function index() {
		load::language('extension/feed/google_sitemap');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('feed_google_sitemap', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=feed'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=feed')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/feed/google_sitemap')
		);

		$data['action'] = url::link('extension/feed/google_sitemap');

		$data['cancel'] = url::link('marketplace/extension', '&type=feed');

		if (isset(request::$post['feed_google_sitemap_status'])) {
			$data['feed_google_sitemap_status'] = request::$post['feed_google_sitemap_status'];
		} else {
			$data['feed_google_sitemap_status'] = config::get('feed_google_sitemap_status');
		}

		$data['data_feed'] = HTTP_CATALOG . 'index.php?route=extension/feed/google_sitemap';

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/feed/google_sitemap', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/feed/google_sitemap')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}