<?php
class ControllerExtensionFraudFraudLabsPro {
	private static $error = array();

	public static function index() {
		load::language('extension/fraud/fraudlabspro');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('fraud_fraudlabspro', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=fraud'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['key'])) {
			$data['error_key'] = self::$error['key'];
		} else {
			$data['error_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=fraud')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/fraud/fraudlabspro')
		);

		$data['action'] = url::link('extension/fraud/fraudlabspro');

		$data['cancel'] = url::link('marketplace/extension', '&type=fraud');

		if (isset(request::$post['fraud_fraudlabspro_key'])) {
			$data['fraud_fraudlabspro_key'] = request::$post['fraud_fraudlabspro_key'];
		} else {
			$data['fraud_fraudlabspro_key'] = config::get('fraud_fraudlabspro_key');
		}

		if (isset(request::$post['fraud_fraudlabspro_score'])) {
			$data['fraud_fraudlabspro_score'] = request::$post['fraud_fraudlabspro_score'];
		} else {
			$data['fraud_fraudlabspro_score'] = config::get('fraud_fraudlabspro_score');
		}

		if (isset(request::$post['fraud_fraudlabspro_order_status_id'])) {
			$data['fraud_fraudlabspro_order_status_id'] = request::$post['fraud_fraudlabspro_order_status_id'];
		} else {
			$data['fraud_fraudlabspro_order_status_id'] = config::get('fraud_fraudlabspro_order_status_id');
		}

		if (isset(request::$post['fraud_fraudlabspro_review_status_id'])) {
			$data['fraud_fraudlabspro_review_status_id'] = request::$post['fraud_fraudlabspro_review_status_id'];
		} else {
			$data['fraud_fraudlabspro_review_status_id'] = config::get('fraud_fraudlabspro_review_status_id');
		}

		if (isset(request::$post['fraud_fraudlabspro_approve_status_id'])) {
			$data['fraud_fraudlabspro_approve_status_id'] = request::$post['fraud_fraudlabspro_approve_status_id'];
		} else {
			$data['fraud_fraudlabspro_approve_status_id'] = config::get('fraud_fraudlabspro_approve_status_id');
		}

		if (isset(request::$post['fraud_fraudlabspro_reject_status_id'])) {
			$data['fraud_fraudlabspro_reject_status_id'] = request::$post['fraud_fraudlabspro_reject_status_id'];
		} else {
			$data['fraud_fraudlabspro_reject_status_id'] = config::get('fraud_fraudlabspro_reject_status_id');
		}

		if (isset(request::$post['fraud_fraudlabspro_simulate_ip'])) {
			$data['fraud_fraudlabspro_simulate_ip'] = request::$post['fraud_fraudlabspro_simulate_ip'];
		} else {
			$data['fraud_fraudlabspro_simulate_ip'] = config::get('fraud_fraudlabspro_simulate_ip');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['fraud_fraudlabspro_status'])) {
			$data['fraud_fraudlabspro_status'] = request::$post['fraud_fraudlabspro_status'];
		} else {
			$data['fraud_fraudlabspro_status'] = config::get('fraud_fraudlabspro_status');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/fraud/fraudlabspro', $data));
	}

	public static function install() {

		admin_extension_fraud_fraudlabspro::install();
	}

	public static function uninstall() {

		admin_extension_fraud_fraudlabspro::uninstall();
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/fraud/fraudlabspro')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['fraud_fraudlabspro_key']) {
			self::$error['key'] = language::get('error_key');
		}

		return !self::$error;
	}

	public static function order() {
		load::language('extension/fraud/fraudlabspro');


		// Action of the Approve/Reject button click
		if (isset($_POST['flp_id'])){
			$flp_status = $_POST['new_status'];
			$data['flp_status'] = $flp_status;

			//Feedback FLP status to server
			$fraud_fraudlabspro_key = config::get('fraud_fraudlabspro_key');

			for($i=0; $i<3; $i++){
				$result = @file_get_contents('https://api.fraudlabspro.com/v1/order/feedback?key=' . $fraud_fraudlabspro_key . '&format=json&id=' . $_POST['flp_id'] . '&action=' . $flp_status);

				if($result) break;
			}

			// Update fraud status into table
			db::query("UPDATE `fraudlabspro` SET fraudlabspro_status = " . esc($flp_status) . " WHERE order_id = " . db::escape(request::$get['order_id']));

			//Update history record
			if (strtolower($flp_status) == 'approve'){
				$data_temp = array(
					'order_status_id'=>config::get('fraud_fraudlabspro_approve_status_id'),
					'notify'=>0,
					'comment'=>'Approved using FraudLabs Pro.'
				);

				admin_extension_fraud_fraudlabspro::addOrderHistory(request::$get['order_id'], $data_temp);
			}
			else if (strtolower($flp_status) == "reject"){
				$data_temp = array(
					'order_status_id'=>config::get('fraud_fraudlabspro_reject_status_id'),
					'notify'=>0,
					'comment'=>'Rejected using FraudLabs Pro.'
				);

				admin_extension_fraud_fraudlabspro::addOrderHistory(request::$get['order_id'], $data_temp);
			}
		}

		if (isset(request::$get['order_id'])) {
			$order_id = request::$get['order_id'];
		} else {
			$order_id = 0;
		}

		$fraud_info = admin_extension_fraud_fraudlabspro::getOrder($order_id);

		if ($fraud_info) {
			if ($fraud_info['ip_address']) {
				$data['flp_ip_address'] = $fraud_info['ip_address'];
			} else {
				$data['flp_ip_address'] = '';
			}

			if ($fraud_info['ip_netspeed']) {
				$data['flp_ip_net_speed'] = $fraud_info['ip_netspeed'];
			} else {
				$data['flp_ip_net_speed'] = '';
			}

			if ($fraud_info['ip_isp_name']) {
				$data['flp_ip_isp_name'] = $fraud_info['ip_isp_name'];
			} else {
				$data['flp_ip_isp_name'] = '';
			}

			if ($fraud_info['ip_usage_type']) {
				$data['flp_ip_usage_type'] = $fraud_info['ip_usage_type'];
			} else {
				$data['flp_ip_usage_type'] = '';
			}

			if ($fraud_info['ip_domain']) {
				$data['flp_ip_domain'] = $fraud_info['ip_domain'];
			} else {
				$data['flp_ip_domain'] = '';
			}

			if ($fraud_info['ip_timezone']) {
				$data['flp_ip_time_zone'] = $fraud_info['ip_timezone'];
			} else {
				$data['flp_ip_time_zone'] = '';
			}

			if ($fraud_info['ip_country']) {
				$data['flp_ip_location'] = self::fix_case($fraud_info['ip_continent']) . ", " . $fraud_info['ip_country'] . ", " . $fraud_info['ip_region'] . ", " . $fraud_info['ip_city'] . " <a href=\"http://www.geolocation.com/" . $fraud_info['ip_address'] . "\" target=\"_blank\">[Map]</a>";
			} else {
				$data['flp_ip_location'] = '-';
			}

			if ($fraud_info['distance_in_mile'] != '-') {
				$data['flp_ip_distance'] = $fraud_info['distance_in_mile'] . " miles";
			} else {
				$data['flp_ip_distance'] = '';
			}

			if ($fraud_info['ip_latitude']) {
				$data['flp_ip_latitude'] = $fraud_info['ip_latitude'];
			} else {
				$data['flp_ip_latitude'] = '';
			}

			if ($fraud_info['ip_longitude']) {
				$data['flp_ip_longitude'] = $fraud_info['ip_longitude'];
			} else {
				$data['flp_ip_longitude'] = '';
			}

			if ($fraud_info['is_high_risk_country']) {
				$data['flp_risk_country'] = $fraud_info['is_high_risk_country'];
			} else {
				$data['flp_risk_country'] = '';
			}

			if ($fraud_info['is_free_email']) {
				$data['flp_free_email'] = $fraud_info['is_free_email'];
			} else {
				$data['flp_free_email'] = '';
			}

			if ($fraud_info['is_address_ship_forward']) {
				$data['flp_ship_forward'] = $fraud_info['is_address_ship_forward'];
			} else {
				$data['flp_ship_forward'] = '';
			}

			if ($fraud_info['is_proxy_ip_address']) {
				$data['flp_using_proxy'] = $fraud_info['is_proxy_ip_address'];
			} else {
				$data['flp_using_proxy'] = '';
			}

			if ($fraud_info['is_bin_found']) {
				$data['flp_bin_found'] = $fraud_info['is_bin_found'];
			} else {
				$data['flp_bin_found'] = '';
			}

			if ($fraud_info['is_email_blacklist']) {
				$data['flp_email_blacklist'] = $fraud_info['is_email_blacklist'];
			} else {
				$data['flp_email_blacklist'] = '';
			}

			if ($fraud_info['is_credit_card_blacklist']) {
				$data['flp_credit_card_blacklist'] = $fraud_info['is_credit_card_blacklist'];
			} else {
				$data['flp_credit_card_blacklist'] = '';
			}

			if ($fraud_info['fraudlabspro_score']) {
				$data['flp_score'] = $fraud_info['fraudlabspro_score'];
			} else {
				$data['flp_score'] = '';
			}

			if ($fraud_info['fraudlabspro_status']) {
				$data['flp_status'] = $fraud_info['fraudlabspro_status'];
			} else {
				$data['flp_status'] = '';
			}

			if ($fraud_info['fraudlabspro_message']) {
				$data['flp_message'] = $fraud_info['fraudlabspro_message'];
			} else {
				$data['flp_message'] = '';
			}

			if ($fraud_info['fraudlabspro_id']) {
				$data['flp_id'] = $fraud_info['fraudlabspro_id'];
				$data['flp_link'] = $fraud_info['fraudlabspro_id'];
			} else {
				$data['flp_id'] = '';
				$data['flp_link'] = '';
			}

			if ($fraud_info['fraudlabspro_credits']) {
				$data['flp_credits'] = $fraud_info['fraudlabspro_credits'];
			} else {
				$data['flp_credits'] = '';
			}

			return load::view('extension/fraud/fraudlabspro_info', $data);
		}
	}

	private static function fix_case($s) {
		$s = ucwords(strtolower($s));
		$s = preg_replace_callback("/( [ a-zA-Z]{1}')([a-zA-Z0-9]{1})/s", create_function('$matches', 'return $matches[1].strtoupper($matches[2]);'), $s);
		return $s;
	}
}