<?php
class ControllerExtensionModuleAmazonPay {
	private static $version = '3.2.1';
	private static $error = array();

	public static function index() {
		load::language('extension/module/amazon_pay');


		document::setTitle(language::get('heading_title'));

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('module_amazon_pay', request::$post);

			admin_setting_event::deleteEventByCode('amazon_pay');
			admin_setting_event::addEvent('amazon_pay', 'catalog/controller/account/logout/after', 'extension/module/amazon_pay/logout');
			
			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=module'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['heading_title'] = language::get('heading_title') . ' ' . self::$version;

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard'),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=module'),
			'separator' => ' ::$ '
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/module/amazon_pay'),
			'separator' => ' ::$ '
		);

		$data['action'] = url::link('extension/module/amazon_pay');

		$data['cancel'] = url::link('marketplace/extension', '&type=module');


		if (isset(request::$post['module_amazon_pay_button_type'])) {
			$data['module_amazon_pay_button_type'] = request::$post['module_amazon_pay_button_type'];
		} elseif (config::get('module_amazon_pay_button_type')) {
			$data['module_amazon_pay_button_type'] = config::get('module_amazon_pay_button_type');
		} else {
			$data['module_amazon_pay_button_type'] = 'PwA';
		}

		if (isset(request::$post['module_amazon_pay_button_colour'])) {
			$data['module_amazon_pay_button_colour'] = request::$post['module_amazon_pay_button_colour'];
		} elseif (config::get('module_amazon_pay_button_colour')) {
			$data['module_amazon_pay_button_colour'] = config::get('module_amazon_pay_button_colour');
		} else {
			$data['module_amazon_pay_button_colour'] = 'gold';
		}

		if (isset(request::$post['module_amazon_pay_button_size'])) {
			$data['module_amazon_pay_button_size'] = request::$post['module_amazon_pay_button_size'];
		} elseif (config::get('module_amazon_pay_button_size')) {
			$data['module_amazon_pay_button_size'] = config::get('module_amazon_pay_button_size');
		} else {
			$data['module_amazon_pay_button_size'] = 'medium';
		}

		if (isset(request::$post['module_amazon_pay_status'])) {
			$data['module_amazon_pay_status'] = request::$post['module_amazon_pay_status'];
		} else {
			$data['module_amazon_pay_status'] = config::get('module_amazon_pay_status');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/module/amazon_pay', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/module/amazon_pay')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	public static function install() {
		admin_setting_event::deleteEventByCode('amazon_pay');
	}

	public static function uninstall() {
		admin_setting_event::deleteEventByCode('amazon_pay');
	}

}
