<?php
class ControllerExtensionModuleGoogleHangouts {
	private static $error = array();

	public static function index() {
		load::language('extension/module/google_hangouts');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('module_google_hangouts', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=module'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['code'])) {
			$data['error_code'] = self::$error['code'];
		} else {
			$data['error_code'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=module')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/module/google_hangouts')
		);

		$data['action'] = url::link('extension/module/google_hangouts');

		$data['cancel'] = url::link('marketplace/extension', '&type=module');

		if (isset(request::$post['module_google_hangouts_code'])) {
			$data['module_google_hangouts_code'] = request::$post['module_google_hangouts_code'];
		} else {
			$data['module_google_hangouts_code'] = config::get('module_google_hangouts_code');
		}

		if (isset(request::$post['module_google_hangouts_status'])) {
			$data['module_google_hangouts_status'] = request::$post['module_google_hangouts_status'];
		} else {
			$data['module_google_hangouts_status'] = config::get('module_google_hangouts_status');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/module/google_hangouts', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/module/google_hangouts')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['module_google_hangouts_code']) {
			self::$error['code'] = language::get('error_code');
		}

		return !self::$error;
	}
}