<?php
class ControllerExtensionModuleHTML {
	private static $error = array();

	public static function index() {
		load::language('extension/module/html');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			if (!isset(request::$get['module_id'])) {
				admin_setting_module::addModule('html', request::$post);
			} else {
				admin_setting_module::editModule(request::$get['module_id'], request::$post);
			}

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=module'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=module')
		);

		if (!isset(request::$get['module_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('extension/module/html')
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('extension/module/html', '&module_id=' . request::$get['module_id'])
			);
		}

		if (!isset(request::$get['module_id'])) {
			$data['action'] = url::link('extension/module/html');
		} else {
			$data['action'] = url::link('extension/module/html', '&module_id=' . request::$get['module_id']);
		}

		$data['cancel'] = url::link('marketplace/extension', '&type=module');

		if (isset(request::$get['module_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$module_info = admin_setting_module::getModule(request::$get['module_id']);
		}

		if (isset(request::$post['name'])) {
			$data['name'] = request::$post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}

		if (isset(request::$post['module_description'])) {
			$data['module_description'] = request::$post['module_description'];
		} elseif (!empty($module_info)) {
			$data['module_description'] = $module_info['module_description'];
		} else {
			$data['module_description'] = array();
		}


		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['status'])) {
			$data['status'] = request::$post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/module/html', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/module/html')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if ((utf8_strlen(request::$post['name']) < 3) || (utf8_strlen(request::$post['name']) > 64)) {
			self::$error['name'] = language::get('error_name');
		}

		return !self::$error;
	}
}