<?php
class ControllerExtensionModuleLatest {
	private static $error = array();

	public static function index() {
		load::language('extension/module/latest');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			if (!isset(request::$get['module_id'])) {
				admin_setting_module::addModule('latest', request::$post);
			} else {
				admin_setting_module::editModule(request::$get['module_id'], request::$post);
			}

			cache::delete('product');

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=module'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset(self::$error['width'])) {
			$data['error_width'] = self::$error['width'];
		} else {
			$data['error_width'] = '';
		}

		if (isset(self::$error['height'])) {
			$data['error_height'] = self::$error['height'];
		} else {
			$data['error_height'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=module')
		);

		if (!isset(request::$get['module_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('extension/module/latest')
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('extension/module/latest', '&module_id=' . request::$get['module_id'])
			);
		}

		if (!isset(request::$get['module_id'])) {
			$data['action'] = url::link('extension/module/latest');
		} else {
			$data['action'] = url::link('extension/module/latest', '&module_id=' . request::$get['module_id']);
		}

		$data['cancel'] = url::link('marketplace/extension', '&type=module');

		if (isset(request::$get['module_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$module_info = admin_setting_module::getModule(request::$get['module_id']);
		}

		if (isset(request::$post['name'])) {
			$data['name'] = request::$post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}

		if (isset(request::$post['limit'])) {
			$data['limit'] = request::$post['limit'];
		} elseif (!empty($module_info)) {
			$data['limit'] = $module_info['limit'];
		} else {
			$data['limit'] = 5;
		}

		if (isset(request::$post['width'])) {
			$data['width'] = request::$post['width'];
		} elseif (!empty($module_info)) {
			$data['width'] = $module_info['width'];
		} else {
			$data['width'] = 200;
		}

		if (isset(request::$post['height'])) {
			$data['height'] = request::$post['height'];
		} elseif (!empty($module_info)) {
			$data['height'] = $module_info['height'];
		} else {
			$data['height'] = 200;
		}

		if (isset(request::$post['status'])) {
			$data['status'] = request::$post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/module/latest', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/module/latest')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if ((utf8_strlen(request::$post['name']) < 3) || (utf8_strlen(request::$post['name']) > 64)) {
			self::$error['name'] = language::get('error_name');
		}

		if (!request::$post['width']) {
			self::$error['width'] = language::get('error_width');
		}

		if (!request::$post['height']) {
			self::$error['height'] = language::get('error_height');
		}

		return !self::$error;
	}
}