<?php
class ControllerExtensionModulePayPalSmartButton {
	private static $error = array();
	
	public static function index() {
		load::language('extension/module/paypal_smart_button');


		document::setTitle(language::get('heading_title'));

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('module_paypal_smart_button', request::$post);

			session::$data['success'] = language::get('success_save');

			response::redirect(url::link('marketplace/extension', '&type=module'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extensions'),
			'href' => url::link('marketplace/extension', '&type=module')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/module/paypal_smart_button')
		);

		$data['action'] = url::link('extension/module/paypal_smart_button');
		$data['cancel'] = url::link('marketplace/extension', '&type=module');
						
		if (isset(request::$post['module_paypal_smart_button_status'])) {
			$data['status'] = request::$post['module_paypal_smart_button_status'];
		} else {
			$data['status'] = config::get('module_paypal_smart_button_status');
		}
		
		// Setting 		
		$_config = new Config();
		$_config::load('paypal_smart_button');
		
		$data['setting'] = $_config::get('paypal_smart_button_setting');
		
		if (isset(request::$post['module_paypal_smart_button_setting'])) {
			$data['setting'] = array_replace_recursive((array)$data['setting'], (array)request::$post['module_paypal_smart_button_setting']);
		} else {
			$data['setting'] = array_replace_recursive((array)$data['setting'], (array)config::get('module_paypal_smart_button_setting'));
		}
				
		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/module/paypal_smart_button', $data));
	}

	public static function install() {

		admin_extension_module_paypal_smart_button::install();
		
		$setting['module_paypal_smart_button_status'] = 0;
		
		admin_setting_setting::editSetting('module_paypal_smart_button', $setting);
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/module/paypal_smart_button')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}
