<?php
class ControllerExtensionModulePPBraintreeButton {
	public static function index() {
		load::language('extension/module/pp_braintree_button');


		document::setTitle(language::get('heading_title'));

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('module_pp_braintree_button', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=module'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=module')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/module/pp_braintree_button')
		);

		$data['action'] = url::link('extension/module/pp_braintree_button');
		$data['cancel'] = url::link('marketplace/extension', '&type=module');
		$data['layouts'] = url::link('design/layout');

		if (isset(request::$post['module_pp_braintree_button_status'])) {
			$data['module_pp_braintree_button_status'] = request::$post['module_pp_braintree_button_status'];
		} else {
			$data['module_pp_braintree_button_status'] = config::get('module_pp_braintree_button_status');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/module/pp_braintree_button', $data));
	}

	public static function install() {

		$settings['module_pp_braintree_button_status'] = 1;

		admin_setting_setting::editSetting('module_pp_braintree_button', $settings);
	}

	public static function configure() {
		load::language('extension/extension/module');

		if (!user::hasPermission('modify', 'extension/extension/module')) {
			response::redirect(url::link('marketplace/extension'));
		} else {

			admin_setting_extension::install('module', 'pp_braintree_button');

			admin_user_user_group::addPermission(user::getGroupId(), 'access', 'extension/module/pp_braintree_button');
			admin_user_user_group::addPermission(user::getGroupId(), 'modify', 'extension/module/pp_braintree_button');

			self::install();

			response::redirect(url::link('design/layout'));
		}
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/module/pp_braintree_button')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}
