<?php
class ControllerExtensionModuleStore {
	private static $error = array();

	public static function index() {
		load::language('extension/module/store');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('module_store', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=module'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=module')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/module/store')
		);

		$data['action'] = url::link('extension/module/store');

		$data['cancel'] = url::link('marketplace/extension', '&type=module');

		if (isset(request::$post['module_store_admin'])) {
			$data['module_store_admin'] = request::$post['module_store_admin'];
		} else {
			$data['module_store_admin'] = config::get('module_store_admin');
		}

		if (isset(request::$post['module_store_status'])) {
			$data['module_store_status'] = request::$post['module_store_status'];
		} else {
			$data['module_store_status'] = config::get('module_store_status');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/module/store', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/module/store')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}