<?php
class ControllerExtensionPaymentAlipay {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/alipay');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_alipay', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['app_id'])) {
			$data['error_app_id'] = self::$error['app_id'];
		} else {
			$data['error_app_id'] = '';
		}

		if (isset(self::$error['merchant_private_key'])) {
			$data['error_merchant_private_key'] = self::$error['merchant_private_key'];
		} else {
			$data['error_merchant_private_key'] = '';
		}

		if (isset(self::$error['alipay_public_key'])) {
			$data['error_alipay_public_key'] = self::$error['alipay_public_key'];
		} else {
			$data['error_alipay_public_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/alipay')
		);

		$data['action'] = url::link('extension/payment/alipay');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_alipay_app_id'])) {
			$data['payment_alipay_app_id'] = request::$post['payment_alipay_app_id'];
		} else {
			$data['payment_alipay_app_id'] = config::get('payment_alipay_app_id');
		}

		if (isset(request::$post['payment_alipay_merchant_private_key'])) {
			$data['payment_alipay_merchant_private_key'] = request::$post['payment_alipay_merchant_private_key'];
		} else {
			$data['payment_alipay_merchant_private_key'] = config::get('payment_alipay_merchant_private_key');
		}

		if (isset(request::$post['payment_alipay_alipay_public_key'])) {
			$data['payment_alipay_alipay_public_key'] = request::$post['payment_alipay_alipay_public_key'];
		} else {
			$data['payment_alipay_alipay_public_key'] = config::get('payment_alipay_alipay_public_key');
		}

		if (isset(request::$post['payment_alipay_total'])) {
			$data['payment_alipay_total'] = request::$post['payment_alipay_total'];
		} else {
			$data['payment_alipay_total'] = config::get('payment_alipay_total');
		}

		if (isset(request::$post['payment_alipay_order_status_id'])) {
			$data['payment_alipay_order_status_id'] = request::$post['payment_alipay_order_status_id'];
		} else {
			$data['payment_alipay_order_status_id'] = config::get('payment_alipay_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_alipay_geo_zone_id'])) {
			$data['payment_alipay_geo_zone_id'] = request::$post['payment_alipay_geo_zone_id'];
		} else {
			$data['payment_alipay_geo_zone_id'] = config::get('payment_alipay_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_alipay_test'])) {
			$data['payment_alipay_test'] = request::$post['payment_alipay_test'];
		} else {
			$data['payment_alipay_test'] = config::get('payment_alipay_test');
		}

		if (isset(request::$post['payment_alipay_status'])) {
			$data['payment_alipay_status'] = request::$post['payment_alipay_status'];
		} else {
			$data['payment_alipay_status'] = config::get('payment_alipay_status');
		}

		if (isset(request::$post['payment_alipay_sort_order'])) {
			$data['payment_alipay_sort_order'] = request::$post['payment_alipay_sort_order'];
		} else {
			$data['payment_alipay_sort_order'] = config::get('payment_alipay_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/alipay', $data));
	}

	private static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/alipay')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_alipay_app_id']) {
			self::$error['app_id'] = language::get('error_app_id');
		}

		if (!request::$post['payment_alipay_merchant_private_key']) {
			self::$error['merchant_private_key'] = language::get('error_merchant_private_key');
		}

		if (!request::$post['payment_alipay_alipay_public_key']) {
			self::$error['alipay_public_key'] = language::get('error_alipay_public_key');
		}

		return !self::$error;
	}
}