<?php
class ControllerExtensionPaymentAmazonLoginPay {
	private static $version = '3.2.1';
	private static $error = array();

	public static function index() {

		load::language('extension/payment/amazon_login_pay');

		document::setTitle(language::get('heading_title'));



		admin_extension_payment_amazon_login_pay::install();

		self::trimIntegrationDetails();

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_amazon_login_pay', request::$post);

			admin_extension_payment_amazon_login_pay::deleteEvents();
			admin_extension_payment_amazon_login_pay::addEvents();

			session::$data['success'] = language::get('text_success');

			if (isset(request::$post['language_reload'])) {
				response::redirect(url::link('extension/payment/amazon_login_pay'));
			} else {
				response::redirect(url::link('marketplace/extension', '&type=payment'));
			}
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['error_merchant_id'])) {
			$data['error_merchant_id'] = self::$error['error_merchant_id'];
		} else {
			$data['error_merchant_id'] = '';
		}

		if (isset(self::$error['error_access_key'])) {
			$data['error_access_key'] = self::$error['error_access_key'];
		} else {
			$data['error_access_key'] = '';
		}

		if (isset(self::$error['error_access_secret'])) {
			$data['error_access_secret'] = self::$error['error_access_secret'];
		} else {
			$data['error_access_secret'] = '';
		}

		if (isset(self::$error['error_client_secret'])) {
			$data['error_client_secret'] = self::$error['error_client_secret'];
		} else {
			$data['error_client_secret'] = '';
		}

		if (isset(self::$error['error_client_id'])) {
			$data['error_client_id'] = self::$error['error_client_id'];
		} else {
			$data['error_client_id'] = '';
		}

		if (isset(self::$error['error_minimum_total'])) {
			$data['error_minimum_total'] = self::$error['error_minimum_total'];
		} else {
			$data['error_minimum_total'] = '';
		}

		if (isset(self::$error['error_curreny'])) {
			$data['error_curreny'] = self::$error['error_curreny'];
		} else {
			$data['error_curreny'] = '';
		}

		$data['heading_title'] = language::get('heading_title') . ' ' . self::$version;

		$data['https_catalog'] = HTTPS_CATALOG;

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/amazon_login_pay')
		);

		$data['action'] = url::link('extension/payment/amazon_login_pay');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_amazon_login_pay_merchant_id'])) {
			$data['payment_amazon_login_pay_merchant_id'] = request::$post['payment_amazon_login_pay_merchant_id'];
		} elseif (config::get('payment_amazon_login_pay_merchant_id')) {
			$data['payment_amazon_login_pay_merchant_id'] = config::get('payment_amazon_login_pay_merchant_id');
		} else {
			$data['payment_amazon_login_pay_merchant_id'] = '';
		}

		if (isset(request::$post['payment_amazon_login_pay_access_key'])) {
			$data['payment_amazon_login_pay_access_key'] = request::$post['payment_amazon_login_pay_access_key'];
		} elseif (config::get('payment_amazon_login_pay_access_key')) {
			$data['payment_amazon_login_pay_access_key'] = config::get('payment_amazon_login_pay_access_key');
		} else {
			$data['payment_amazon_login_pay_access_key'] = '';
		}

		if (isset(request::$post['payment_amazon_login_pay_access_secret'])) {
			$data['payment_amazon_login_pay_access_secret'] = request::$post['payment_amazon_login_pay_access_secret'];
		} elseif (config::get('payment_amazon_login_pay_access_secret')) {
			$data['payment_amazon_login_pay_access_secret'] = config::get('payment_amazon_login_pay_access_secret');
		} else {
			$data['payment_amazon_login_pay_access_secret'] = '';
		}

		if (isset(request::$post['payment_amazon_login_pay_client_id'])) {
			$data['payment_amazon_login_pay_client_id'] = request::$post['payment_amazon_login_pay_client_id'];
		} elseif (config::get('payment_amazon_login_pay_client_id')) {
			$data['payment_amazon_login_pay_client_id'] = config::get('payment_amazon_login_pay_client_id');
		} else {
			$data['payment_amazon_login_pay_client_id'] = '';
		}

		if (isset(request::$post['payment_amazon_login_pay_client_secret'])) {
			$data['payment_amazon_login_pay_client_secret'] = request::$post['payment_amazon_login_pay_client_secret'];
		} elseif (config::get('payment_amazon_login_pay_client_secret')) {
			$data['payment_amazon_login_pay_client_secret'] = config::get('payment_amazon_login_pay_client_secret');
		} else {
			$data['payment_amazon_login_pay_client_secret'] = '';
		}

		if (isset(request::$post['payment_amazon_login_pay_test'])) {
			$data['payment_amazon_login_pay_test'] = request::$post['payment_amazon_login_pay_test'];
		} elseif (config::get('payment_amazon_login_pay_test')) {
			$data['payment_amazon_login_pay_test'] = config::get('payment_amazon_login_pay_test');
		} else {
			$data['payment_amazon_login_pay_test'] = 'sandbox';
		}

		if (isset(request::$post['payment_amazon_login_pay_mode'])) {
			$data['payment_amazon_login_pay_mode'] = request::$post['payment_amazon_login_pay_mode'];
		} elseif (config::get('payment_amazon_login_pay_mode')) {
			$data['payment_amazon_login_pay_mode'] = config::get('payment_amazon_login_pay_mode');
		} else {
			$data['payment_amazon_login_pay_mode'] = 'payment';
		}

		if (isset(request::$post['payment_amazon_login_pay_checkout'])) {
			$data['payment_amazon_login_pay_checkout'] = request::$post['payment_amazon_login_pay_checkout'];
		} elseif (config::get('payment_amazon_login_pay_checkout')) {
			$data['payment_amazon_login_pay_checkout'] = config::get('payment_amazon_login_pay_checkout');
		} else {
			$data['payment_amazon_login_pay_checkout'] = 'payment';
		}

		if (isset(request::$post['payment_amazon_login_pay_payment_region'])) {
			$data['payment_amazon_login_pay_payment_region'] = request::$post['payment_amazon_login_pay_payment_region'];
		} elseif (config::get('payment_amazon_login_pay_payment_region')) {
			$data['payment_amazon_login_pay_payment_region'] = config::get('payment_amazon_login_pay_payment_region');
		} elseif (in_array(config('currency'), array('EUR', 'GBP', 'USD'))) {
			$data['payment_amazon_login_pay_payment_region'] = config('currency');
		} else {
			$data['payment_amazon_login_pay_payment_region'] = 'USD';
		}

		if ($data['payment_amazon_login_pay_payment_region'] == 'EUR') {
			$data['payment_amazon_login_pay_language'] = 'de-DE';
			$data['sp_id'] = 'AW93DIZMWSDWS';
			$data['locale'] = 'EUR';
			$ld = 'AW93DIZMWSDWS';
		} elseif ($data['payment_amazon_login_pay_payment_region'] == 'GBP') {
			$data['payment_amazon_login_pay_language'] = 'en-GB';
			$data['sp_id'] = 'AW93DIZMWSDWS';
			$data['locale'] = 'GBP';
			$ld = 'AW93DIZMWSDWS';
		} else {
			$data['payment_amazon_login_pay_language'] = 'en-US';
			$data['sp_id'] = 'A3GK1RS09H3A7D';
			$data['locale'] = 'US';
			$ld = 'A3GK1RS09H3A7D';
		}

		if (isset(request::$post['payment_amazon_login_pay_language'])) {
			$data['payment_amazon_login_pay_language'] = request::$post['payment_amazon_login_pay_language'];
		} elseif (config::get('payment_amazon_login_pay_language')) {
			$data['payment_amazon_login_pay_language'] = config::get('payment_amazon_login_pay_language');
		}

		if (isset(request::$post['payment_amazon_login_pay_capture_status'])) {
			$data['payment_amazon_login_pay_capture_status'] = request::$post['payment_amazon_login_pay_capture_status'];
		} elseif (config::get('payment_amazon_login_pay_capture_status')) {
			$data['payment_amazon_login_pay_capture_status'] = config::get('payment_amazon_login_pay_capture_status');
		} else {
			$data['payment_amazon_login_pay_capture_status'] = '';
		}

		if (isset(request::$post['payment_amazon_login_pay_pending_status'])) {
			$data['payment_amazon_login_pay_pending_status'] = request::$post['payment_amazon_login_pay_pending_status'];
		} elseif (config::get('payment_amazon_login_pay_pending_status')) {
			$data['payment_amazon_login_pay_pending_status'] = config::get('payment_amazon_login_pay_pending_status');
		} else {
			$data['payment_amazon_login_pay_pending_status'] = '0';
		}

		if (isset(request::$post['payment_amazon_login_pay_capture_oc_status'])) {
			$data['payment_amazon_login_pay_capture_oc_status'] = request::$post['payment_amazon_login_pay_capture_oc_status'];
		} elseif (config::get('payment_amazon_login_pay_capture_oc_status')) {
			$data['payment_amazon_login_pay_capture_oc_status'] = config::get('payment_amazon_login_pay_capture_oc_status');
		} else {
			$data['payment_amazon_login_pay_capture_oc_status'] = '0';
		}

		if (isset(request::$post['payment_amazon_login_pay_ipn_token'])) {
			$data['payment_amazon_login_pay_ipn_token'] = request::$post['payment_amazon_login_pay_ipn_token'];
		} elseif (config::get('payment_amazon_login_pay_ipn_token')) {
			$data['payment_amazon_login_pay_ipn_token'] = config::get('payment_amazon_login_pay_ipn_token');
		} else {
			$data['payment_amazon_login_pay_ipn_token'] = sha1(uniqid(mt_rand(), 1));
		}

		$data['ipn_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/amazon_login_pay/ipn&token=' . $data['payment_amazon_login_pay_ipn_token'];

		if (isset(request::$post['payment_amazon_login_pay_minimum_total'])) {
			$data['payment_amazon_login_pay_minimum_total'] = request::$post['payment_amazon_login_pay_minimum_total'];
		} elseif (config::get('payment_amazon_login_pay_minimum_total')) {
			$data['payment_amazon_login_pay_minimum_total'] = config::get('payment_amazon_login_pay_minimum_total');
		} else {
			$data['payment_amazon_login_pay_minimum_total'] = '0.01';
		}

		if (isset(request::$post['payment_amazon_login_pay_geo_zone'])) {
			$data['payment_amazon_login_pay_geo_zone'] = request::$post['payment_amazon_login_pay_geo_zone'];
		} elseif (config::get('payment_amazon_login_pay_geo_zone')) {
			$data['payment_amazon_login_pay_geo_zone'] = config::get('payment_amazon_login_pay_geo_zone');
		} else {
			$data['payment_amazon_login_pay_geo_zone'] = '0';
		}
		if (isset(request::$post['payment_amazon_login_pay_buyer_multi_currency'])) {
			$data['payment_amazon_login_pay_buyer_multi_currency'] = request::$post['payment_amazon_login_pay_buyer_multi_currency'];
		} elseif (config::get('payment_amazon_login_pay_buyer_multi_currency')) {
			$data['payment_amazon_login_pay_buyer_multi_currency'] = config::get('payment_amazon_login_pay_buyer_multi_currency');
		} else {
			$data['payment_amazon_login_pay_buyer_multi_currency'] = '0';
		}
		//list available currencies for buyer multi-currency feature
		$store_buyer_currencies = array();
		$oc_currencies =  admin_localisation_currency::getCurrencies();
		$amazon_supported_currencies = array('AUD', 'GBP','DKK', 'EUR', 'HKD', 'JPY', 'NZD','NOK', 'ZAR', 'SEK', 'CHF', 'USD');
		foreach ($amazon_supported_currencies as $amazon_supported_currency) {
			if(isset($oc_currencies[$amazon_supported_currency]) && $oc_currencies[$amazon_supported_currency]['status'] == '1') {
				array_push($store_buyer_currencies,$amazon_supported_currency);
			}
		}
		load::language('common/column_left');
		$data['help_buyer_multi_currency'] = !empty($store_buyer_currencies) ? sprintf(language::get('help_buyer_multi_currency'), implode(', ', $store_buyer_currencies)) : language::get('help_buyer_multi_currency_no_available_currency');
		$data['text_info_buyer_multi_currencies'] = sprintf(language::get('text_info_buyer_multi_currencies'), session::$data['user_token'], language::get('text_system'), language::get('text_localisation'),language::get('text_currency'));
		$data['help_capture_oc_status'] = sprintf(language::get('help_capture_oc_status'), language::get('text_sale'), language::get('text_order'), language::get('button_view'));
		
		if (isset(request::$post['payment_amazon_login_pay_debug'])) {
			$data['payment_amazon_login_pay_debug'] = request::$post['payment_amazon_login_pay_debug'];
		} elseif (config::get('payment_amazon_login_pay_debug')) {
			$data['payment_amazon_login_pay_debug'] = config::get('payment_amazon_login_pay_debug');
		} else {
			$data['payment_amazon_login_pay_debug'] = '0';
		}

		if (isset(request::$post['payment_amazon_login_pay_sort_order'])) {
			$data['payment_amazon_login_pay_sort_order'] = request::$post['payment_amazon_login_pay_sort_order'];
		} elseif (config::get('payment_amazon_login_pay_sort_order')) {
			$data['payment_amazon_login_pay_sort_order'] = config::get('payment_amazon_login_pay_sort_order');
		} else {
			$data['payment_amazon_login_pay_sort_order'] = '0';
		}

		if (isset(request::$post['payment_amazon_login_pay_status'])) {
			$data['payment_amazon_login_pay_status'] = request::$post['payment_amazon_login_pay_status'];
		} elseif (config::get('payment_amazon_login_pay_status')) {
			$data['payment_amazon_login_pay_status'] = config::get('payment_amazon_login_pay_status');
		} else {
			$data['payment_amazon_login_pay_status'] = '0';
		}

		if (isset(request::$post['payment_amazon_login_pay_declined_code'])) {
			$data['payment_amazon_login_pay_declined_code'] = request::$post['payment_amazon_login_pay_declined_code'];
		} elseif (config::get('payment_amazon_login_pay_declined_code')) {
			$data['payment_amazon_login_pay_declined_code'] = config::get('payment_amazon_login_pay_declined_code');
		} else {
			$data['payment_amazon_login_pay_declined_code'] = '';
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		$data['declined_codes'] = array(language::get('text_amazon_invalid'), language::get('text_amazon_rejected'), language::get('text_amazon_timeout'));

		$data['unique_id'] = 'oc-' . str_replace(' ', '-', strtolower(config('name'))) . '_' . mt_rand();
		$data['allowed_login_domain'] = html_entity_decode(HTTPS_CATALOG);
		$data['login_redirect_urls'][] = HTTPS_CATALOG . 'index.php?route=payment/amazon_login/login';
		$data['login_redirect_urls'][] = HTTPS_CATALOG . 'index.php?route=payment/amazon_pay/login';
		$data['store_name'] = config('name');
		$data['simple_path_language'] = str_replace('-', '_', $data['payment_amazon_login_pay_language']);

		if ($data['payment_amazon_login_pay_payment_region'] == 'USD') {
			$data['registration_url'] = "https://payments.amazon.com/register?registration_source=SPPL&spId=" . $ld;

			$data['languages'] = array(
				'en-US' => language::get('text_us')
			);
		} else {
			$data['registration_url'] = "https://payments-eu.amazon.com/register?registration_source=SPPL&spId=" . $ld;

			$data['languages'] = array(
				'de-DE' => language::get('text_de'),
				'es-ES' => language::get('text_es'),
				'fr-FR' => language::get('text_fr'),
				'it-IT' => language::get('text_it'),
				'en-GB' => language::get('text_uk')
			);
		}

		$data['payment_regions'] = array(
			'EUR' => language::get('text_eu_region'),
			'GBP' => language::get('text_uk_region'),
			'USD' => language::get('text_us_region')
		);

		$data['has_ssl'] = !empty(request::$server['HTTPS']);

		$data['has_modify_permission'] = user::hasPermission('modify', 'extension/payment/amazon_login_pay');
		$data['text_generic_password'] = str_repeat('*', 32);

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/amazon_login_pay', $data));
	}

	public static function install() {
		admin_extension_payment_amazon_login_pay::install();
		admin_extension_payment_amazon_login_pay::deleteEvents();
		admin_extension_payment_amazon_login_pay::addEvents();
	}

	public static function uninstall() {
		admin_extension_payment_amazon_login_pay::uninstall();
		admin_extension_payment_amazon_login_pay::deleteEvents();
	}

	public static function order() {

		if (config::get('payment_amazon_login_pay_status')) {


			$amazon_login_pay_order = admin_extension_payment_amazon_login_pay::getOrder(request::$get['order_id']);

			if (!empty($amazon_login_pay_order)) {

				load::language('extension/payment/amazon_login_pay');

				$amazon_login_pay_order['total_captured'] = admin_extension_payment_amazon_login_pay::getTotalCaptured($amazon_login_pay_order['amazon_login_pay_order_id']);

				$amazon_login_pay_order['total_formatted'] = currency::format($amazon_login_pay_order['total'], $amazon_login_pay_order['currency_code'], true, true);
				$amazon_login_pay_order['total_captured_formatted'] = currency::format($amazon_login_pay_order['total_captured'], $amazon_login_pay_order['currency_code'], true, true);

				$data['amazon_login_pay_order'] = $amazon_login_pay_order;

				$data['order_id'] = (int)request::$get['order_id'];

				return load::view('extension/payment/amazon_login_pay_order', $data);
			}
		}
	}

	public static function cancel() {
		load::language('extension/payment/amazon_login_pay');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$amazon_login_pay_order = admin_extension_payment_amazon_login_pay::getOrder(request::$post['order_id']);

			$cancel_response = admin_extension_payment_amazon_login_pay::cancel($amazon_login_pay_order);

			admin_extension_payment_amazon_login_pay::logger($cancel_response);

			if ($cancel_response['status'] == 'Completed') {
				admin_extension_payment_amazon_login_pay::addTransaction($amazon_login_pay_order['amazon_login_pay_order_id'], 'cancel', $cancel_response['status'], 0.00);
				admin_extension_payment_amazon_login_pay::updateCancelStatus($amazon_login_pay_order['amazon_login_pay_order_id'], 1);
				$json['msg'] = language::get('text_cancel_ok');
				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['type'] = 'cancel';
				$json['data']['status'] = $cancel_response['status'];
				$json['data']['amount'] = currency::format(0.00, $amazon_login_pay_order['currency_code'], true, true);
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($cancel_response['StatuesDetail']) && !empty($cancel_response['StatuesDetail']) ? (string)$cancel_response['StatuesDetail'] : 'Unable to cancel';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_data_missing');
		}

		response::setOutput(json_encode($json));
	}

	public static function capture() {
		load::language('extension/payment/amazon_login_pay');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '' && isset(request::$post['amount']) && request::$post['amount'] > 0) {

			$amazon_login_pay_order = admin_extension_payment_amazon_login_pay::getOrder(request::$post['order_id']);

			$capture_response = admin_extension_payment_amazon_login_pay::capture($amazon_login_pay_order, request::$post['amount']);
			admin_extension_payment_amazon_login_pay::logger($capture_response);

			if ($capture_response['status'] == 'Completed' || $capture_response['status'] == 'Pending') {
				admin_extension_payment_amazon_login_pay::addTransaction($amazon_login_pay_order['amazon_login_pay_order_id'], 'capture', $capture_response['status'], request::$post['amount'], $capture_response['AmazonAuthorizationId'], $capture_response['AmazonCaptureId']);

				admin_extension_payment_amazon_login_pay::updateAuthorizationStatus($capture_response['AmazonAuthorizationId'], 'Closed');

				$total_captured = admin_extension_payment_amazon_login_pay::getTotalCaptured($amazon_login_pay_order['amazon_login_pay_order_id']);

				if ($total_captured > 0) {
					$order_reference_id = $amazon_login_pay_order['amazon_order_reference_id'];

					if (admin_extension_payment_amazon_login_pay::isOrderInState($order_reference_id, array('Open', 'Suspended'))) {
                        admin_extension_payment_amazon_login_pay::closeOrderRef($order_reference_id);
                    }
				}

				if ($total_captured >= (double)$amazon_login_pay_order['total']) {
					admin_extension_payment_amazon_login_pay::updateCaptureStatus($amazon_login_pay_order['amazon_login_pay_order_id'], 1);
					$capture_status = 1;
					$json['msg'] = language::get('text_capture_ok_order');
				} else {
					$capture_status = 0;
					$json['msg'] = language::get('text_capture_ok');
				}

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['type'] = 'capture';
				$json['data']['status'] = $capture_response['status'];
				$json['data']['amazon_authorization_id'] = $capture_response['AmazonAuthorizationId'];
				$json['data']['amazon_capture_id'] = $capture_response['AmazonCaptureId'];
				$json['data']['amount'] = currency::format(request::$post['amount'], $amazon_login_pay_order['currency_code'], true, true);
				$json['data']['capture_status'] = $capture_status;
				$json['data']['total'] = currency::format($total_captured, $amazon_login_pay_order['currency_code'], true, true);
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($capture_response['status_detail']) && !empty($capture_response['status_detail']) ? (string)$capture_response['status_detail'] : 'Unable to capture';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_data_missing');
		}

		response::setOutput(json_encode($json));
	}

	public static function refund() {
		load::language('extension/payment/amazon_login_pay');
		$json = array();

		if (isset(request::$post['order_id']) && !empty(request::$post['order_id'])) {

			$amazon_login_pay_order = admin_extension_payment_amazon_login_pay::getOrder(request::$post['order_id']);

			$refund_response = admin_extension_payment_amazon_login_pay::refund($amazon_login_pay_order, request::$post['amount']);

			admin_extension_payment_amazon_login_pay::logger($refund_response);

			$refund_status = '';
			$total_captured = '';
			$total_refunded = '';

			foreach ($refund_response as $response) {
				if ($response['status'] == 'Pending') {
					admin_extension_payment_amazon_login_pay::addTransaction($amazon_login_pay_order['amazon_login_pay_order_id'], 'refund', $response['status'], $response['amount'] * -1, $response['amazon_authorization_id'], $response['amazon_capture_id'], $response['AmazonRefundId']);

					$total_refunded = admin_extension_payment_amazon_login_pay::getTotalRefunded($amazon_login_pay_order['amazon_login_pay_order_id']);
					$total_captured = admin_extension_payment_amazon_login_pay::getTotalCaptured($amazon_login_pay_order['amazon_login_pay_order_id']);

					if ($total_captured <= 0 && $amazon_login_pay_order['capture_status'] == 1) {
						admin_extension_payment_amazon_login_pay::updateRefundStatus($amazon_login_pay_order['amazon_login_pay_order_id'], 1);
						$refund_status = 1;
						$json['msg'][] = language::get('text_refund_ok_order') . '<br />';
					} else {
						$refund_status = 0;
						$json['msg'][] = language::get('text_refund_ok') . '<br />';
					}

					$data = array();
					$data['date_added'] = date("Y-m-d H:i:s");
					$data['type'] = 'refund';
					$data['status'] = $response['status'];
					$data['amazon_authorization_id'] = $response['amazon_authorization_id'];
					$data['amazon_capture_id'] = $response['amazon_capture_id'];
					$data['amazon_refund_id'] = $response['AmazonRefundId'];
					$data['amount'] = currency::format(($response['amount'] * -1), $amazon_login_pay_order['currency_code'], true, true);
					$json['data'][] = $data;
				} else {
					$json['error'] = true;
					$json['error_msg'][] = isset($response['status_detail']) && !empty($response['status_detail']) ? (string)$response['status_detail'] : 'Unable to refund';
				}
			}
			$json['refund_status'] = $refund_status;
			$json['total_captured'] = currency::format($total_captured, $amazon_login_pay_order['currency_code'], true, true);
			$json['total_refunded'] = currency::format($total_refunded, $amazon_login_pay_order['currency_code'], true, true);
		} else {
			$json['error'] = true;
			$json['error_msg'][] = language::get('error_data_missing');
		}
		response::setOutput(json_encode($json));
	}

    protected static function trimIntegrationDetails() {
        $integration_keys = array(
            'payment_amazon_login_pay_merchant_id',
            'payment_amazon_login_pay_access_key',
            'payment_amazon_login_pay_access_secret',
            'payment_amazon_login_pay_client_id',
            'payment_amazon_login_pay_client_secret'
        );

        foreach (request::$post as $key => $value) {
            if (in_array($key, $integration_keys)) {
                request::$post[$key] = trim($value);
            }
        }
    }

	protected static function validate() {

		if (!user::hasPermission('modify', 'extension/payment/amazon_login_pay')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_amazon_login_pay_merchant_id']) {
			self::$error['error_merchant_id'] = language::get('error_merchant_id');
		}

		if (!request::$post['payment_amazon_login_pay_access_key']) {
			self::$error['error_access_key'] = language::get('error_access_key');
		}

		if (empty(self::$error)) {
			$errors = admin_extension_payment_amazon_login_pay::validateDetails(request::$post);
			if (isset($errors['error_code']) && $errors['error_code'] == 'InvalidParameterValue') {
				self::$error['error_merchant_id'] = $errors['status_detail'];
			} elseif (isset($errors['error_code']) && $errors['error_code'] == 'InvalidAccessKeyId') {
				self::$error['error_access_key'] = $errors['status_detail'];
			}
		}

		if (!request::$post['payment_amazon_login_pay_access_secret']) {
			self::$error['error_access_secret'] = language::get('error_access_secret');
		}

		if (!request::$post['payment_amazon_login_pay_client_id']) {
			self::$error['error_client_id'] = language::get('error_client_id');
		}

		if (!request::$post['payment_amazon_login_pay_client_secret']) {
			self::$error['error_client_secret'] = language::get('error_client_secret');
		}

		if (request::$post['payment_amazon_login_pay_minimum_total'] <= 0) {
			self::$error['error_minimum_total'] = language::get('error_minimum_total');
		}

		if (isset(request::$post['amazon_login_pay_region'])) {
			$currency_code = request::$post['amazon_login_pay_region'];

			$currency = admin_localisation_currency::getCurrency(currency::getId($currency_code));

			if (empty($currency) || $currency['status'] != '1') {
				self::$error['error_curreny'] = sprintf(language::get('error_curreny'), $currency_code);
			}
		}

		return !self::$error;
	}

}
