<?php
class ControllerExtensionPaymentAuthorizenetAim {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/authorizenet_aim');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_authorizenet_aim', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['login'])) {
			$data['error_login'] = self::$error['login'];
		} else {
			$data['error_login'] = '';
		}

		if (isset(self::$error['key'])) {
			$data['error_key'] = self::$error['key'];
		} else {
			$data['error_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/authorizenet_aim')
		);

		$data['action'] = url::link('extension/payment/authorizenet_aim');
		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_authorizenet_aim_login'])) {
			$data['payment_authorizenet_aim_login'] = request::$post['payment_authorizenet_aim_login'];
		} else {
			$data['payment_authorizenet_aim_login'] = config::get('payment_authorizenet_aim_login');
		}

		if (isset(request::$post['payment_authorizenet_aim_key'])) {
			$data['payment_authorizenet_aim_key'] = request::$post['payment_authorizenet_aim_key'];
		} else {
			$data['payment_authorizenet_aim_key'] = config::get('payment_authorizenet_aim_key');
		}

		if (isset(request::$post['payment_authorizenet_aim_hash'])) {
			$data['payment_authorizenet_aim_hash'] = request::$post['payment_authorizenet_aim_hash'];
		} else {
			$data['payment_authorizenet_aim_hash'] = config::get('payment_authorizenet_aim_hash');
		}

		if (isset(request::$post['payment_authorizenet_aim_server'])) {
			$data['payment_authorizenet_aim_server'] = request::$post['payment_authorizenet_aim_server'];
		} else {
			$data['payment_authorizenet_aim_server'] = config::get('payment_authorizenet_aim_server');
		}

		if (isset(request::$post['payment_authorizenet_aim_mode'])) {
			$data['payment_authorizenet_aim_mode'] = request::$post['payment_authorizenet_aim_mode'];
		} else {
			$data['payment_authorizenet_aim_mode'] = config::get('payment_authorizenet_aim_mode');
		}

		if (isset(request::$post['payment_authorizenet_aim_method'])) {
			$data['payment_authorizenet_aim_method'] = request::$post['payment_authorizenet_aim_method'];
		} else {
			$data['payment_authorizenet_aim_method'] = config::get('payment_authorizenet_aim_method');
		}

		if (isset(request::$post['payment_authorizenet_aim_total'])) {
			$data['payment_authorizenet_aim_total'] = request::$post['payment_authorizenet_aim_total'];
		} else {
			$data['payment_authorizenet_aim_total'] = config::get('payment_authorizenet_aim_total');
		}

		if (isset(request::$post['payment_authorizenet_aim_order_status_id'])) {
			$data['payment_authorizenet_aim_order_status_id'] = request::$post['payment_authorizenet_aim_order_status_id'];
		} else {
			$data['payment_authorizenet_aim_order_status_id'] = config::get('payment_authorizenet_aim_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_authorizenet_aim_geo_zone_id'])) {
			$data['payment_authorizenet_aim_geo_zone_id'] = request::$post['payment_authorizenet_aim_geo_zone_id'];
		} else {
			$data['payment_authorizenet_aim_geo_zone_id'] = config::get('payment_authorizenet_aim_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_authorizenet_aim_status'])) {
			$data['payment_authorizenet_aim_status'] = request::$post['payment_authorizenet_aim_status'];
		} else {
			$data['payment_authorizenet_aim_status'] = config::get('payment_authorizenet_aim_status');
		}

		if (isset(request::$post['payment_authorizenet_aim_sort_order'])) {
			$data['payment_authorizenet_aim_sort_order'] = request::$post['payment_authorizenet_aim_sort_order'];
		} else {
			$data['payment_authorizenet_aim_sort_order'] = config::get('payment_authorizenet_aim_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/authorizenet_aim', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/authorizenet_aim')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_authorizenet_aim_login']) {
			self::$error['login'] = language::get('error_login');
		}

		if (!request::$post['payment_authorizenet_aim_key']) {
			self::$error['key'] = language::get('error_key');
		}

		return !self::$error;
	}
}
