<?php
class ControllerExtensionPaymentAuthorizeNetSim {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/authorizenet_sim');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_authorizenet_sim', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['merchant'])) {
			$data['error_merchant'] = self::$error['merchant'];
		} else {
			$data['error_merchant'] = '';
		}

		if (isset(self::$error['key'])) {
			$data['error_key'] = self::$error['key'];
		} else {
			$data['error_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/authorizenet_sim')
		);

		$data['action'] = url::link('extension/payment/authorizenet_sim');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_authorizenet_sim_merchant'])) {
			$data['payment_authorizenet_sim_merchant'] = request::$post['payment_authorizenet_sim_merchant'];
		} else {
			$data['payment_authorizenet_sim_merchant'] = config::get('payment_authorizenet_sim_merchant');
		}

		if (isset(request::$post['payment_authorizenet_sim_key'])) {
			$data['payment_authorizenet_sim_key'] = request::$post['payment_authorizenet_sim_key'];
		} else {
			$data['payment_authorizenet_sim_key'] = config::get('payment_authorizenet_sim_key');
		}

		if (isset(request::$post['payment_authorizenet_sim_test'])) {
			$data['payment_authorizenet_sim_test'] = request::$post['payment_authorizenet_sim_test'];
		} else {
			$data['payment_authorizenet_sim_test'] = config::get('payment_authorizenet_sim_test');
		}

		$data['callback'] = HTTP_CATALOG . 'index.php?route=extension/payment/authorizenet_sim/callback';

		if (isset(request::$post['payment_authorizenet_sim_hash'])) {
			$data['payment_authorizenet_sim_hash'] = request::$post['payment_authorizenet_sim_hash'];
		} else {
			$data['payment_authorizenet_sim_hash'] = config::get('payment_authorizenet_sim_hash');
		}

		if (isset(request::$post['payment_authorizenet_sim_total'])) {
			$data['payment_authorizenet_sim_total'] = request::$post['payment_authorizenet_sim_total'];
		} else {
			$data['payment_authorizenet_sim_total'] = config::get('payment_authorizenet_sim_total');
		}

		if (isset(request::$post['payment_authorizenet_sim_order_status_id'])) {
			$data['payment_authorizenet_sim_order_status_id'] = request::$post['payment_authorizenet_sim_order_status_id'];
		} else {
			$data['payment_authorizenet_sim_order_status_id'] = config::get('payment_authorizenet_sim_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_authorizenet_sim_geo_zone_id'])) {
			$data['payment_authorizenet_sim_geo_zone_id'] = request::$post['payment_authorizenet_sim_geo_zone_id'];
		} else {
			$data['payment_authorizenet_sim_geo_zone_id'] = config::get('payment_authorizenet_sim_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_authorizenet_sim_status'])) {
			$data['payment_authorizenet_sim_status'] = request::$post['payment_authorizenet_sim_status'];
		} else {
			$data['payment_authorizenet_sim_status'] = config::get('payment_authorizenet_sim_status');
		}

		if (isset(request::$post['payment_authorizenet_sim_sort_order'])) {
			$data['payment_authorizenet_sim_sort_order'] = request::$post['payment_authorizenet_sim_sort_order'];
		} else {
			$data['payment_authorizenet_sim_sort_order'] = config::get('payment_authorizenet_sim_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/authorizenet_sim', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/authorizenet_sim')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_authorizenet_sim_merchant']) {
			self::$error['merchant'] = language::get('error_merchant');
		}

		if (!request::$post['payment_authorizenet_sim_key']) {
			self::$error['key'] = language::get('error_key');
		}

		return !self::$error;
	}
}
