<?php
class ControllerExtensionPaymentBankTransfer {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/bank_transfer');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_bank_transfer', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['bank'])) {
			$data['error_bank'] = self::$error['bank'];
		} else {
			$data['error_bank'] = array();
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/bank_transfer')
		);

		$data['action'] = url::link('extension/payment/bank_transfer');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');


		$data['payment_bank_transfer_bank'] = array();

		$languages = admin_localisation_language::getLanguages();
		
		foreach ($languages as $language) {
			if (isset(request::$post['payment_bank_transfer_bank' . $language['language_id']])) {
				$data['payment_bank_transfer_bank'][$language['language_id']] = request::$post['payment_bank_transfer_bank' . $language['language_id']];
			} else {
				$data['payment_bank_transfer_bank'][$language['language_id']] = config::get('payment_bank_transfer_bank' . $language['language_id']);
			}
		}

		$data['languages'] = $languages;

		if (isset(request::$post['payment_bank_transfer_total'])) {
			$data['payment_bank_transfer_total'] = request::$post['payment_bank_transfer_total'];
		} else {
			$data['payment_bank_transfer_total'] = config::get('payment_bank_transfer_total');
		}

		if (isset(request::$post['payment_bank_transfer_order_status_id'])) {
			$data['payment_bank_transfer_order_status_id'] = request::$post['payment_bank_transfer_order_status_id'];
		} else {
			$data['payment_bank_transfer_order_status_id'] = config::get('payment_bank_transfer_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_bank_transfer_geo_zone_id'])) {
			$data['payment_bank_transfer_geo_zone_id'] = request::$post['payment_bank_transfer_geo_zone_id'];
		} else {
			$data['payment_bank_transfer_geo_zone_id'] = config::get('payment_bank_transfer_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_bank_transfer_status'])) {
			$data['payment_bank_transfer_status'] = request::$post['payment_bank_transfer_status'];
		} else {
			$data['payment_bank_transfer_status'] = config::get('payment_bank_transfer_status');
		}

		if (isset(request::$post['payment_bank_transfer_sort_order'])) {
			$data['payment_bank_transfer_sort_order'] = request::$post['payment_bank_transfer_sort_order'];
		} else {
			$data['payment_bank_transfer_sort_order'] = config::get('payment_bank_transfer_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/bank_transfer', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/bank_transfer')) {
			self::$error['warning'] = language::get('error_permission');
		}


		$languages = admin_localisation_language::getLanguages();

		foreach ($languages as $language) {
			if (empty(request::$post['payment_bank_transfer_bank' . $language['language_id']])) {
				self::$error['bank'][$language['language_id']] = language::get('error_bank');
			}
		}

		return !self::$error;
	}
}