<?php
class ControllerExtensionPaymentBluePayHosted {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/bluepay_hosted');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_bluepay_hosted', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['account_name'])) {
			$data['error_account_name'] = self::$error['account_name'];
		} else {
			$data['error_account_name'] = '';
		}

		if (isset(self::$error['account_id'])) {
			$data['error_account_id'] = self::$error['account_id'];
		} else {
			$data['error_account_id'] = '';
		}

		if (isset(self::$error['secret_key'])) {
			$data['error_secret_key'] = self::$error['secret_key'];
		} else {
			$data['error_secret_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/bluepay_hosted')
		);

		$data['action'] = url::link('extension/payment/bluepay_hosted');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_bluepay_hosted_account_name'])) {
			$data['payment_bluepay_hosted_account_name'] = request::$post['payment_bluepay_hosted_account_name'];
		} else {
			$data['payment_bluepay_hosted_account_name'] = config::get('payment_bluepay_hosted_account_name');
		}

		if (isset(request::$post['payment_bluepay_hosted_account_id'])) {
			$data['payment_bluepay_hosted_account_id'] = request::$post['payment_bluepay_hosted_account_id'];
		} else {
			$data['payment_bluepay_hosted_account_id'] = config::get('payment_bluepay_hosted_account_id');
		}

		if (isset(request::$post['payment_bluepay_hosted_secret_key'])) {
			$data['payment_bluepay_hosted_secret_key'] = request::$post['payment_bluepay_hosted_secret_key'];
		} else {
			$data['payment_bluepay_hosted_secret_key'] = config::get('payment_bluepay_hosted_secret_key');
		}

		if (isset(request::$post['payment_bluepay_hosted_test'])) {
			$data['payment_bluepay_hosted_test'] = request::$post['payment_bluepay_hosted_test'];
		} else {
			$data['payment_bluepay_hosted_test'] = config::get('payment_bluepay_hosted_test');
		}

		if (isset(request::$post['payment_bluepay_hosted_transaction'])) {
			$data['payment_bluepay_hosted_transaction'] = request::$post['payment_bluepay_hosted_transaction'];
		} else {
			$data['payment_bluepay_hosted_transaction'] = config::get('payment_bluepay_hosted_transaction');
		}

		if (isset(request::$post['payment_bluepay_hosted_amex'])) {
			$data['payment_bluepay_hosted_amex'] = request::$post['payment_bluepay_hosted_amex'];
		} else {
			$data['payment_bluepay_hosted_amex'] = config::get('payment_bluepay_hosted_amex');
		}

		if (isset(request::$post['payment_bluepay_hosted_discover'])) {
			$data['payment_bluepay_hosted_discover'] = request::$post['payment_bluepay_hosted_discover'];
		} else {
			$data['payment_bluepay_hosted_discover'] = config::get('payment_bluepay_hosted_discover');
		}

		if (isset(request::$post['payment_bluepay_hosted_total'])) {
			$data['payment_bluepay_hosted_total'] = request::$post['payment_bluepay_hosted_total'];
		} else {
			$data['payment_bluepay_hosted_total'] = config::get('payment_bluepay_hosted_total');
		}

		if (isset(request::$post['payment_bluepay_hosted_order_status_id'])) {
			$data['payment_bluepay_hosted_order_status_id'] = request::$post['payment_bluepay_hosted_order_status_id'];
		} elseif (config::get('payment_bluepay_hosted_order_status_id')) {
			$data['payment_bluepay_hosted_order_status_id'] = config::get('payment_bluepay_hosted_order_status_id');
		} else {
			$data['payment_bluepay_hosted_order_status_id'] = 2;
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_bluepay_hosted_geo_zone_id'])) {
			$data['payment_bluepay_hosted_geo_zone_id'] = request::$post['payment_bluepay_hosted_geo_zone_id'];
		} else {
			$data['payment_bluepay_hosted_geo_zone_id'] = config::get('payment_bluepay_hosted_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_bluepay_hosted_status'])) {
			$data['payment_bluepay_hosted_status'] = request::$post['payment_bluepay_hosted_status'];
		} else {
			$data['payment_bluepay_hosted_status'] = config::get('payment_bluepay_hosted_status');
		}

		if (isset(request::$post['payment_bluepay_hosted_debug'])) {
			$data['payment_bluepay_hosted_debug'] = request::$post['payment_bluepay_hosted_debug'];
		} else {
			$data['payment_bluepay_hosted_debug'] = config::get('payment_bluepay_hosted_debug');
		}

		if (isset(request::$post['payment_bluepay_hosted_sort_order'])) {
			$data['payment_bluepay_hosted_sort_order'] = request::$post['payment_bluepay_hosted_sort_order'];
		} else {
			$data['payment_bluepay_hosted_sort_order'] = config::get('payment_bluepay_hosted_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/bluepay_hosted', $data));
	}

	public static function install() {

		admin_extension_payment_bluepay_hosted::install();
	}

	public static function uninstall() {

		admin_extension_payment_bluepay_hosted::uninstall();
	}

	public static function order() {
		if (config::get('payment_bluepay_hosted_status')) {

			$bluepay_hosted_order = admin_extension_payment_bluepay_hosted::getOrder(request::$get['order_id']);

			if (!empty($bluepay_hosted_order)) {
				load::language('extension/payment/bluepay_hosted');

				$bluepay_hosted_order['total_released'] = admin_extension_payment_bluepay_hosted::getTotalReleased($bluepay_hosted_order['bluepay_hosted_order_id']);

				$bluepay_hosted_order['total_formatted'] = currency::format($bluepay_hosted_order['total'], $bluepay_hosted_order['currency_code'], false, false);
				$bluepay_hosted_order['total_released_formatted'] = currency::format($bluepay_hosted_order['total_released'], $bluepay_hosted_order['currency_code'], false, false);

				$data['bluepay_hosted_order'] = $bluepay_hosted_order;

				$data['order_id'] = (int)request::$get['order_id'];

				return load::view('extension/payment/bluepay_hosted_order', $data);
			}
		}
	}

	public static function void() {
		load::language('extension/payment/bluepay_hosted');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$bluepay_hosted_order = admin_extension_payment_bluepay_hosted::getOrder(request::$post['order_id']);

			$void_response = admin_extension_payment_bluepay_hosted::void(request::$post['order_id']);

			admin_extension_payment_bluepay_hosted::logger('Void result:\r\n' . print_r($void_response, 1));

			if ($void_response['Result'] == 'APPROVED') {
				admin_extension_payment_bluepay_hosted::addTransaction($bluepay_hosted_order['bluepay_hosted_order_id'], 'void', $bluepay_hosted_order['total']);
				admin_extension_payment_bluepay_hosted::updateVoidStatus($bluepay_hosted_order['bluepay_hosted_order_id'], 1);

				$json['msg'] = language::get('text_void_ok');
				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['total'] = $bluepay_hosted_order['total'];
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($void_response['MESSAGE']) && !empty($void_response['MESSAGE']) ? (string)$void_response['MESSAGE'] : 'Unable to void';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function release() {
		load::language('extension/payment/bluepay_hosted');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '' && isset(request::$post['amount']) && request::$post['amount'] > 0) {

			$bluepay_hosted_order = admin_extension_payment_bluepay_hosted::getOrder(request::$post['order_id']);

			$release_response = admin_extension_payment_bluepay_hosted::release(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_bluepay_hosted::logger('Release result:\r\n' . print_r($release_response, 1));

			if ($release_response['Result'] == 'APPROVED') {
				admin_extension_payment_bluepay_hosted::addTransaction($bluepay_hosted_order['bluepay_hosted_order_id'], 'payment', request::$post['amount']);

				admin_extension_payment_bluepay_hosted::updateTransactionId($bluepay_hosted_order['bluepay_hosted_order_id'], $release_response['RRNO']);

				$total_released = admin_extension_payment_bluepay_hosted::getTotalReleased($bluepay_hosted_order['bluepay_hosted_order_id']);

				if ($total_released >= $bluepay_hosted_order['total']) {
					admin_extension_payment_bluepay_hosted::updateReleaseStatus($bluepay_hosted_order['bluepay_hosted_order_id'], 1);
					$release_status = 1;
					$json['msg'] = language::get('text_release_ok_order');
				} else {
					$release_status = 0;
					$json['msg'] = language::get('text_release_ok');
				}

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = request::$post['amount'];
				$json['data']['release_status'] = $release_status;
				$json['data']['total'] = (float)$total_released;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($release_response['MESSAGE']) && !empty($release_response['MESSAGE']) ? (string)$release_response['MESSAGE'] : 'Unable to release';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_data_missing');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function rebate() {
		load::language('extension/payment/bluepay_hosted');
		$json = array();

		if (isset(request::$post['order_id']) && !empty(request::$post['order_id'])) {

			$bluepay_hosted_order = admin_extension_payment_bluepay_hosted::getOrder(request::$post['order_id']);

			$rebate_response = admin_extension_payment_bluepay_hosted::rebate(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_bluepay_hosted::logger('Rebate result:\r\n' . print_r($rebate_response, 1));

			if ($rebate_response['Result'] == 'APPROVED') {
				admin_extension_payment_bluepay_hosted::addTransaction($bluepay_hosted_order['bluepay_hosted_order_id'], 'rebate', request::$post['amount'] * -1);

				$total_rebated = admin_extension_payment_bluepay_hosted::getTotalRebated($bluepay_hosted_order['bluepay_hosted_order_id']);
				$total_released = admin_extension_payment_bluepay_hosted::getTotalReleased($bluepay_hosted_order['bluepay_hosted_order_id']);

				if ($total_released <= 0 && $bluepay_hosted_order['release_status'] == 1) {
					admin_extension_payment_bluepay_hosted::updateRebateStatus($bluepay_hosted_order['bluepay_hosted_order_id'], 1);
					$rebate_status = 1;
					$json['msg'] = language::get('text_rebate_ok_order');
				} else {
					$rebate_status = 0;
					$json['msg'] = language::get('text_rebate_ok');
				}

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = request::$post['amount'] * -1;
				$json['data']['total_released'] = (float)$total_released;
				$json['data']['total_rebated'] = (float)$total_rebated;
				$json['data']['rebate_status'] = $rebate_status;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($rebate_response['MESSAGE']) && !empty($rebate_response['MESSAGE']) ? (string)$rebate_response['MESSAGE'] : 'Unable to rebate';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/bluepay_hosted')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_bluepay_hosted_account_name']) {
			self::$error['account_name'] = language::get('error_account_name');
		}

		if (!request::$post['payment_bluepay_hosted_account_id']) {
			self::$error['account_id'] = language::get('error_account_id');
		}

		if (!request::$post['payment_bluepay_hosted_secret_key']) {
			self::$error['secret_key'] = language::get('error_secret_key');
		}

		return !self::$error;
	}

	public static function callback() {
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode(request::$get));
	}
}