<?php
class ControllerExtensionPaymentCardConnect {
	private static $error = array();

	public static function index() {


		load::language('extension/payment/cardconnect');

		document::setTitle(language::get('heading_title'));

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_cardconnect', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/cardconnect')
		);

		$data['action'] = url::link('extension/payment/cardconnect');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_cardconnect_merchant_id'])) {
			$data['payment_cardconnect_merchant_id'] = request::$post['payment_cardconnect_merchant_id'];
		} else {
			$data['payment_cardconnect_merchant_id'] = config::get('payment_cardconnect_merchant_id');
		}

		if (isset(request::$post['cardconnect_api_username'])) {
			$data['cardconnect_api_username'] = request::$post['cardconnect_api_username'];
		} else {
			$data['cardconnect_api_username'] = config::get('cardconnect_api_username');
		}

		if (isset(request::$post['cardconnect_api_password'])) {
			$data['cardconnect_api_password'] = request::$post['cardconnect_api_password'];
		} else {
			$data['cardconnect_api_password'] = config::get('cardconnect_api_password');
		}

		if (isset(request::$post['cardconnect_token'])) {
			$data['cardconnect_token'] = request::$post['cardconnect_token'];
		} elseif (config::has('cardconnect_token')) {
			$data['cardconnect_token'] = config::get('cardconnect_token');
		} else {
			$data['cardconnect_token'] = md5(time());
		}

		if (isset(request::$post['cardconnect_transaction'])) {
			$data['cardconnect_transaction'] = request::$post['cardconnect_transaction'];
		} else {
			$data['cardconnect_transaction'] = config::get('cardconnect_transaction');
		}

		if (isset(request::$post['cardconnect_site'])) {
			$data['cardconnect_site'] = request::$post['cardconnect_site'];
		} elseif (config::has('cardconnect_site')) {
			$data['cardconnect_site'] = config::get('cardconnect_site');
		} else {
			$data['cardconnect_site'] = 'fts';
		}

		if (isset(request::$post['cardconnect_environment'])) {
			$data['cardconnect_environment'] = request::$post['cardconnect_environment'];
		} else {
			$data['cardconnect_environment'] = config::get('cardconnect_environment');
		}

		if (isset(request::$post['cardconnect_store_cards'])) {
			$data['cardconnect_store_cards'] = request::$post['cardconnect_store_cards'];
		} else {
			$data['cardconnect_store_cards'] = config::get('cardconnect_store_cards');
		}

		if (isset(request::$post['cardconnect_echeck'])) {
			$data['cardconnect_echeck'] = request::$post['cardconnect_echeck'];
		} else {
			$data['cardconnect_echeck'] = config::get('cardconnect_echeck');
		}

		if (isset(request::$post['cardconnect_total'])) {
			$data['cardconnect_total'] = request::$post['cardconnect_total'];
		} else {
			$data['cardconnect_total'] = config::get('cardconnect_total');
		}

		if (isset(request::$post['cardconnect_geo_zone'])) {
			$data['cardconnect_geo_zone'] = request::$post['cardconnect_geo_zone'];
		} else {
			$data['cardconnect_geo_zone'] = config::get('cardconnect_geo_zone');
		}

		if (isset(request::$post['cardconnect_status'])) {
			$data['cardconnect_status'] = request::$post['cardconnect_status'];
		} else {
			$data['cardconnect_status'] = config::get('cardconnect_status');
		}

		if (isset(request::$post['cardconnect_logging'])) {
			$data['cardconnect_logging'] = request::$post['cardconnect_logging'];
		} else {
			$data['cardconnect_logging'] = config::get('cardconnect_logging');
		}

		if (isset(request::$post['cardconnect_sort_order'])) {
			$data['cardconnect_sort_order'] = request::$post['cardconnect_sort_order'];
		} else {
			$data['cardconnect_sort_order'] = config::get('cardconnect_sort_order');
		}

		$data['cardconnect_cron_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/cardconnect/cron&token=' . $data['cardconnect_token'];

		if (config::get('cardconnect_cron_time')) {
			$data['cardconnect_cron_time'] = date(language::get('datetime_format'), strtotime(config::get('cardconnect_cron_time')));
		} else {
			$data['cardconnect_cron_time'] = language::get('text_no_cron_time');
		}

		if (isset(request::$post['cardconnect_order_status_id_pending'])) {
			$data['cardconnect_order_status_id_pending'] = request::$post['cardconnect_order_status_id_pending'];
		} elseif (config::has('cardconnect_order_status_id_pending')) {
			$data['cardconnect_order_status_id_pending'] = config::get('cardconnect_order_status_id_pending');
		} else {
			$data['cardconnect_order_status_id_pending'] = '1';
		}

		if (isset(request::$post['cardconnect_order_status_id_processing'])) {
			$data['cardconnect_order_status_id_processing'] = request::$post['cardconnect_order_status_id_processing'];
		} elseif (config::has('cardconnect_order_status_id_processing')) {
			$data['cardconnect_order_status_id_processing'] = config::get('cardconnect_order_status_id_processing');
		} else {
			$data['cardconnect_order_status_id_processing'] = '2';
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(self::$error['payment_cardconnect_merchant_id'])) {
			$data['error_payment_cardconnect_merchant_id'] = self::$error['payment_cardconnect_merchant_id'];
		} else {
			$data['error_payment_cardconnect_merchant_id'] = '';
		}

		if (isset(self::$error['cardconnect_api_username'])) {
			$data['error_cardconnect_api_username'] = self::$error['cardconnect_api_username'];
		} else {
			$data['error_cardconnect_api_username'] = '';
		}

		if (isset(self::$error['cardconnect_api_password'])) {
			$data['error_cardconnect_api_password'] = self::$error['cardconnect_api_password'];
		} else {
			$data['error_cardconnect_api_password'] = '';
		}

		if (isset(self::$error['cardconnect_token'])) {
			$data['error_cardconnect_token'] = self::$error['cardconnect_token'];
		} else {
			$data['error_cardconnect_token'] = '';
		}

		if (isset(self::$error['cardconnect_site'])) {
			$data['error_cardconnect_site'] = self::$error['cardconnect_site'];
		} else {
			$data['error_cardconnect_site'] = '';
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();


		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/cardconnect', $data));
	}

	public static function install() {
		if (user::hasPermission('modify', 'marketplace/extension')) {

			admin_extension_payment_cardconnect::install();
		}
	}

	public static function uninstall() {
		if (user::hasPermission('modify', 'marketplace/extension')) {

			admin_extension_payment_cardconnect::uninstall();
		}
	}

	public static function order() {
		if (config::get('cardconnect_status')) {

			$order_id = request::$get['order_id'];

			$cardconnect_order = admin_extension_payment_cardconnect::getOrder(request::$get['order_id']);

			if ($cardconnect_order) {
				load::language('extension/payment/cardconnect');

				if ($cardconnect_order['payment_method'] == 'card') {
					$cardconnect_order['payment_method'] = language::get('text_card');
				} else {
					$cardconnect_order['payment_method'] = language::get('text_echeck');
				}

				$cardconnect_order['total_formatted'] = currency::format($cardconnect_order['total'], $cardconnect_order['currency_code'], false, true);

				$cardconnect_order['total_captured'] = admin_extension_payment_cardconnect::getTotalCaptured($cardconnect_order['cardconnect_order_id']);

				$cardconnect_order['total_captured_formatted'] = currency::format($cardconnect_order['total_captured'], $cardconnect_order['currency_code'], false, true);

				foreach($cardconnect_order['transactions'] as &$transaction) {
					switch ($transaction['type']) {
						case 'payment':
							$transaction['type'] = 'Payment';
							break;
						case 'auth':
							$transaction['type'] = 'Authorize';
							break;
						case 'refund':
							$transaction['type'] = 'Refund';
							break;
						case 'void':
							$transaction['type'] = 'Void';
							break;
						default:
							$transaction['type'] = 'Payment';
					}

					$transaction['amount'] = currency::format($transaction['amount'], $cardconnect_order['currency_code'], false, true);

					if ($transaction['status'] == 'Y') {
						$transaction['status'] = 'Accepted';
					} else if ($transaction['status'] == 'N') {
						$transaction['status'] = 'Rejected';
					}

					$transaction['date_modified'] = date(language::get('datetime_format'), strtotime($transaction['date_modified']));

					$transaction['date_added'] = date(language::get('datetime_format'), strtotime($transaction['date_added']));
				}

				$data['cardconnect_order'] = $cardconnect_order;

				$data['order_id'] = (int)request::$get['order_id'];


				return load::view('extension/payment/cardconnect_order', $data);
			}
		}
	}

	public static function inquire() {
		load::language('extension/payment/cardconnect');

		$json = array();

		if (config::get('cardconnect_status')) {
			if (isset(request::$post['order_id']) && isset(request::$post['retref'])) {

				$cardconnect_order = admin_extension_payment_cardconnect::getOrder(request::$post['order_id']);

				if ($cardconnect_order) {
					$inquire_response = admin_extension_payment_cardconnect::inquire($cardconnect_order, request::$post['retref']);

					if (isset($inquire_response['respstat']) && $inquire_response['respstat'] == 'C') {
						$json['error'] = $inquire_response['resptext'];
					} else {
						admin_extension_payment_cardconnect::updateTransactionStatusByRetref(request::$post['retref'], $inquire_response['setlstat']);

						$json['status'] = $inquire_response['setlstat'];

						$json['date_modified'] = date(language::get('datetime_format'));

						$json['success'] = language::get('text_inquire_success');
					}
				} else {
					$json['error'] = language::get('error_no_order');
				}
			} else {
				$json['error'] = language::get('error_data_missing');
			}
		} else {
			$json['error'] = language::get('error_not_enabled');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function capture() {
		load::language('extension/payment/cardconnect');

		$json = array();

		if (config::get('cardconnect_status')) {
			if (isset(request::$post['order_id']) && isset(request::$post['amount'])) {
				if (request::$post['amount'] > 0) {

					$cardconnect_order = admin_extension_payment_cardconnect::getOrder(request::$post['order_id']);

					if ($cardconnect_order) {
						$capture_response = admin_extension_payment_cardconnect::capture($cardconnect_order, request::$post['amount']);

						if (!isset($capture_response['retref'])) {
							$json['error'] = language::get('error_invalid_response');
						} else if (isset($capture_response['respstat']) && $capture_response['respstat'] == 'C') {
							$json['error'] = $capture_response['resptext'];
						} else {
							admin_extension_payment_cardconnect::addTransaction($cardconnect_order['cardconnect_order_id'], 'payment', $capture_response['retref'], request::$post['amount'], $capture_response['setlstat']);

							$total_captured = admin_extension_payment_cardconnect::getTotalCaptured($cardconnect_order['cardconnect_order_id']);

							$json['retref'] = $capture_response['retref'];
							$json['amount'] = currency::format(request::$post['amount'], $cardconnect_order['currency_code'], false, true);
							$json['status'] = $capture_response['setlstat'];
							$json['date_modified'] = date(language::get('datetime_format'));
							$json['date_added'] = date(language::get('datetime_format'));
							$json['total_captured'] = currency::format($total_captured, $cardconnect_order['currency_code'], false, true);

							$json['success'] = language::get('text_capture_success');
						}
					} else {
						$json['error'] = language::get('error_no_order');
					}
				} else {
					$json['error'] = language::get('error_amount_zero');
				}
			} else {
				$json['error'] = language::get('error_data_missing');
			}
		} else {
			$json['error'] = language::get('error_not_enabled');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function refund() {
		load::language('extension/payment/cardconnect');

		$json = array();

		if (config::get('cardconnect_status')) {
			if (isset(request::$post['order_id']) && isset(request::$post['amount'])) {
				if (request::$post['amount'] > 0) {

					$cardconnect_order = admin_extension_payment_cardconnect::getOrder(request::$post['order_id']);

					if ($cardconnect_order) {
						$refund_response = admin_extension_payment_cardconnect::refund($cardconnect_order, request::$post['amount']);

						if (!isset($refund_response['retref'])) {
							$json['error'] = language::get('error_invalid_response');
						} else if (isset($refund_response['respstat']) && $refund_response['respstat'] == 'C') {
							$json['error'] = $refund_response['resptext'];
						} else {
							admin_extension_payment_cardconnect::addTransaction($cardconnect_order['cardconnect_order_id'], 'refund', $refund_response['retref'], request::$post['amount'] * -1, $refund_response['resptext']);

							$total_captured = admin_extension_payment_cardconnect::getTotalCaptured($cardconnect_order['cardconnect_order_id']);

							$json['retref'] = $refund_response['retref'];
							$json['amount'] = currency::format(request::$post['amount'] * -1, $cardconnect_order['currency_code'], false, true);
							$json['status'] = $refund_response['resptext'];
							$json['date_modified'] = date(language::get('datetime_format'));
							$json['date_added'] = date(language::get('datetime_format'));
							$json['total_captured'] = currency::format($total_captured, $cardconnect_order['currency_code'], false, true);

							$json['success'] = language::get('text_refund_success');
						}
					} else {
						$json['error'] = language::get('error_no_order');
					}
				} else {
					$json['error'] = language::get('error_amount_zero');
				}
			} else {
				$json['error'] = language::get('error_data_missing');
			}
		} else {
			$json['error'] = language::get('error_not_enabled');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function void() {
		load::language('extension/payment/cardconnect');

		$json = array();

		if (config::get('cardconnect_status')) {
			if (isset(request::$post['order_id']) && isset(request::$post['retref'])) {

				$cardconnect_order = admin_extension_payment_cardconnect::getOrder(request::$post['order_id']);

				if ($cardconnect_order) {
					$void_response = admin_extension_payment_cardconnect::void($cardconnect_order, request::$post['retref']);

					if (!isset($void_response['authcode']) || $void_response['authcode'] != 'REVERS') {
						$json['error'] = $void_response['resptext'];
					} else {
						$json['retref'] = $void_response['retref'];
						$json['amount'] = currency::format(0.00, $cardconnect_order['currency_code'], false, true);
						$json['status'] = $void_response['resptext'];
						$json['date_modified'] = date(language::get('datetime_format'));
						$json['date_added'] = date(language::get('datetime_format'));
						$json['success'] = language::get('text_void_success');
					}
				} else {
					$json['error'] = language::get('error_no_order');
				}
			} else {
				$json['error'] = language::get('error_data_missing');
			}
		} else {
			$json['error'] = language::get('error_not_enabled');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/cardconnect')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_cardconnect_merchant_id']) {
			self::$error['payment_cardconnect_merchant_id'] = language::get('error_merchant_id');
		}

		if (!request::$post['cardconnect_api_username']) {
			self::$error['cardconnect_api_username'] = language::get('error_api_username');
		}

		if (!request::$post['cardconnect_api_password']) {
			self::$error['cardconnect_api_password'] = language::get('error_api_password');
		}

		if (!request::$post['cardconnect_token']) {
			self::$error['cardconnect_token'] = language::get('error_token');
		}

		if (!request::$post['cardconnect_site']) {
			self::$error['cardconnect_site'] = language::get('error_site');
		}

		return !self::$error;
	}
}