<?php
class ControllerExtensionPaymentCheque {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/cheque');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_cheque', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['payable'])) {
			$data['error_payable'] = self::$error['payable'];
		} else {
			$data['error_payable'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/cheque')
		);

		$data['action'] = url::link('extension/payment/cheque');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_cheque_payable'])) {
			$data['payment_cheque_payable'] = request::$post['payment_cheque_payable'];
		} else {
			$data['payment_cheque_payable'] = config::get('payment_cheque_payable');
		}

		if (isset(request::$post['payment_cheque_total'])) {
			$data['payment_cheque_total'] = request::$post['payment_cheque_total'];
		} else {
			$data['payment_cheque_total'] = config::get('payment_cheque_total');
		}

		if (isset(request::$post['payment_cheque_order_status_id'])) {
			$data['payment_cheque_order_status_id'] = request::$post['payment_cheque_order_status_id'];
		} else {
			$data['payment_cheque_order_status_id'] = config::get('payment_cheque_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_cheque_geo_zone_id'])) {
			$data['payment_cheque_geo_zone_id'] = request::$post['payment_cheque_geo_zone_id'];
		} else {
			$data['payment_cheque_geo_zone_id'] = config::get('payment_cheque_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_cheque_status'])) {
			$data['payment_cheque_status'] = request::$post['payment_cheque_status'];
		} else {
			$data['payment_cheque_status'] = config::get('payment_cheque_status');
		}

		if (isset(request::$post['payment_cheque_sort_order'])) {
			$data['payment_cheque_sort_order'] = request::$post['payment_cheque_sort_order'];
		} else {
			$data['payment_cheque_sort_order'] = config::get('payment_cheque_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/cheque', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/cheque')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_cheque_payable']) {
			self::$error['payable'] = language::get('error_payable');
		}

		return !self::$error;
	}
}