<?php
class ControllerExtensionPaymentDivido {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/divido');

		document::setTitle(language::get('heading_title'));


		if (request::$server['REQUEST_METHOD'] == 'POST' && self::validate()) {
			admin_setting_setting::editSetting('payment_divido', request::$post);
			
			session::$data['success'] = language::get('text_success');
			
			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		$data['entry_plans_options'] = array(
			'all'		=> language::get('entry_plans_options_all'),
			'selected'	=> language::get('entry_plans_options_selected'),
		);

		$data['entry_products_options']= array(
			'all'		=> language::get('entry_products_options_all'),
			'selected'	=> language::get('entry_products_options_selected'),
			'threshold'	=> language::get('entry_products_options_threshold'),
		);

		$data['button_save'] = language::get('button_save');
		$data['button_cancel'] = language::get('button_cancel');


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/divido')
		);

		$data['action'] = url::link('extension/payment/divido', 'user_token=' . session::$data['user_token'], 'SSL');
		
		$data['cancel'] = url::link('marketplace/extension', '&type=payment', 'SSL');

		if (isset(request::$post['payment_divido_api_key'])) {
			$data['payment_divido_api_key'] = request::$post['payment_divido_api_key'];
		} else {
			$data['payment_divido_api_key'] = config::get('payment_divido_api_key');
		}

		if (isset(request::$post['payment_divido_order_status_id'])) {
			$data['payment_divido_order_status_id'] = request::$post['payment_divido_order_status_id'];
		} elseif (config::get('payment_divido_order_status_id')) {
			$data['payment_divido_order_status_id'] = config::get('payment_divido_order_status_id');
		} else {
			$data['payment_divido_order_status_id'] = 2;
		}

		if (isset(request::$post['payment_divido_status'])) {
			$data['payment_divido_status'] = request::$post['payment_divido_status'];
		} else {
			$data['payment_divido_status'] = config::get('payment_divido_status');
		}

		if (isset(request::$post['payment_divido_sort_order'])) {
			$data['payment_divido_sort_order'] = request::$post['payment_divido_sort_order'];
		} else {
			$data['payment_divido_sort_order'] = config::get('payment_divido_sort_order');
		}

		if (isset(request::$post['payment_divido_title'])) {
			$data['payment_divido_title'] = request::$post['payment_divido_title'];
		} else {
			$data['payment_divido_title'] = config::get('payment_divido_title');
		}

		if (isset(request::$post['payment_divido_productselection'])) {
			$data['payment_divido_productselection'] = request::$post['payment_divido_productselection'];
		} else {
			$data['payment_divido_productselection'] = config::get('payment_divido_productselection');
		}

		if (isset(request::$post['payment_divido_price_threshold'])) {
			$data['payment_divido_price_threshold'] = request::$post['payment_divido_price_threshold'];
		} else {
			$data['payment_divido_price_threshold'] = config::get('payment_divido_price_threshold');
		}

		if (isset(request::$post['payment_divido_cart_threshold'])) {
			$data['payment_divido_cart_threshold'] = request::$post['payment_divido_cart_threshold'];
		} else {
			$data['payment_divido_cart_threshold'] = config::get('payment_divido_cart_threshold');
		}

		if (isset(request::$post['payment_divido_planselection'])) {
			$data['payment_divido_planselection'] = request::$post['payment_divido_planselection'];
		} else {
			$data['payment_divido_planselection'] = config::get('payment_divido_planselection');
		}

		if (isset(request::$post['payment_divido_plans_selected'])) {
			$data['payment_divido_plans_selected'] = request::$post['payment_divido_plans_selected'];
		} elseif (config::get('payment_divido_plans_selected')) {
			$data['payment_divido_plans_selected'] = config::get('payment_divido_plans_selected');
		} else {
			$data['payment_divido_plans_selected'] = array();
		}

		if (isset(request::$post['payment_divido_categories'])) {
			$data['payment_divido_categories'] = request::$post['payment_divido_categories'];
		} elseif (config::get('payment_divido_categories')) {
			$data['payment_divido_categories'] = config::get('payment_divido_categories');
		} else {
			$data['payment_divido_categories'] = array();
		}

		$data['categories'] = array();


		foreach ($data['payment_divido_categories'] as $category_id) {
			$category_info = admin_catalog_category::getCategory($category_id);

			if ($category_info) {
				$data['categories'][] = array(
					'category_id' 	=> $category_info['category_id'],
					'name' 			=> ($category_info['path']) ? $category_info['path'] . ' &gt; ' . $category_info['name'] : $category_info['name']
				);
			}
		}

		try {
			$data['divido_plans'] = admin_extension_payment_divido::getAllPlans();
		} catch (Exception $e) {
			log::write($e::getMessage());
			$data['divido_plans'] = array();
		}


		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/divido', $data));
	}


	public static function order() {
		if (!config::get('payment_divido_status')) {
			return null;
		}

		load::language('extension/payment/divido');

		$order_id = request::$get['order_id'];

		$lookup = admin_extension_payment_divido::getLookupByOrderId($order_id);
		$proposal_id = null;
		$application_id = null;
		$deposit_amount = null;
		if ($lookup->num_rows == 1) {
			$lookup_data = $lookup->row;
			$proposal_id = $lookup_data['proposal_id'];
			$application_id = $lookup_data['application_id'];
			$deposit_amount = $lookup_data['deposit_amount'];
		}

		$data['proposal_id'] = $proposal_id;
		$data['application_id'] = $application_id;
		$data['deposit_amount'] = $deposit_amount;

		return load::view('extension/payment/divido_order', $data);
	}

	public static function install() {
		admin_extension_payment_divido::install();
	}

	public static function uninstall() {
		admin_extension_payment_divido::uninstall();
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/divido')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}
