<?php
class ControllerExtensionPaymentEway {

	private static $error = array();

	public static function index() {
		load::language('extension/payment/eway');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && (self::validate())) {
			admin_setting_setting::editSetting('payment_eway', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension'));
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['username'])) {
			$data['error_username'] = self::$error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['payment_type'])) {
			$data['error_payment_type'] = self::$error['payment_type'];
		} else {
			$data['error_payment_type'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/eway')
		);

		$data['action'] = url::link('extension/payment/eway');
		$data['cancel'] = url::link('marketplace/extension');

		if (isset(request::$post['payment_eway_payment_gateway'])) {
			$data['payment_eway_payment_gateway'] = request::$post['payment_eway_payment_gateway'];
		} else {
			$data['payment_eway_payment_gateway'] = config::get('payment_eway_payment_gateway');
		}

		if (isset(request::$post['payment_eway_paymode'])) {
			$data['payment_eway_paymode'] = request::$post['payment_eway_paymode'];
		} else {
			$data['payment_eway_paymode'] = config::get('payment_eway_paymode');
		}

		if (isset(request::$post['payment_eway_test'])) {
			$data['payment_eway_test'] = request::$post['payment_eway_test'];
		} else {
			$data['payment_eway_test'] = config::get('payment_eway_test');
		}

		if (isset(request::$post['payment_eway_payment_type'])) {
			$data['payment_eway_payment_type'] = request::$post['payment_eway_payment_type'];
		} else {
			$data['payment_eway_payment_type'] = config::get('payment_eway_payment_type');
		}

		if (isset(request::$post['payment_eway_transaction'])) {
			$data['payment_eway_transaction'] = request::$post['payment_eway_transaction'];
		} else {
			$data['payment_eway_transaction'] = config::get('payment_eway_transaction');
		}

		if (isset(request::$post['payment_eway_standard_geo_zone_id'])) {
			$data['payment_eway_standard_geo_zone_id'] = request::$post['payment_eway_standard_geo_zone_id'];
		} else {
			$data['payment_eway_standard_geo_zone_id'] = config::get('payment_eway_standard_geo_zone_id');
		}

		if (isset(request::$post['payment_eway_order_status_id'])) {
			$data['payment_eway_order_status_id'] = request::$post['payment_eway_order_status_id'];
		} else {
			$data['payment_eway_order_status_id'] = config::get('payment_eway_order_status_id');
		}

		if (isset(request::$post['payment_eway_order_status_refunded_id'])) {
			$data['payment_eway_order_status_refunded_id'] = request::$post['payment_eway_order_status_refunded_id'];
		} else {
			$data['payment_eway_order_status_refunded_id'] = config::get('payment_eway_order_status_refunded_id');
		}

		if (isset(request::$post['payment_eway_order_status_auth_id'])) {
			$data['payment_eway_order_status_auth_id'] = request::$post['payment_eway_order_status_auth_id'];
		} else {
			$data['payment_eway_order_status_auth_id'] = config::get('payment_eway_order_status_auth_id');
		}

		if (isset(request::$post['payment_eway_order_status_fraud_id'])) {
			$data['payment_eway_order_status_fraud_id'] = request::$post['payment_eway_order_status_fraud_id'];
		} else {
			$data['payment_eway_order_status_fraud_id'] = config::get('payment_eway_order_status_fraud_id');
		}

		if (isset(request::$post['payment_eway_transaction_method'])) {
			$data['payment_eway_transaction_method'] = request::$post['payment_eway_transaction_method'];
		} else {
			$data['payment_eway_transaction_method'] = config::get('payment_eway_transaction_method');
		}

		if (isset(request::$post['payment_eway_username'])) {
			$data['payment_eway_username'] = request::$post['payment_eway_username'];
		} else {
			$data['payment_eway_username'] = config::get('payment_eway_username');
		}

		if (isset(request::$post['payment_eway_password'])) {
			$data['payment_eway_password'] = request::$post['payment_eway_password'];
		} else {
			$data['payment_eway_password'] = config::get('payment_eway_password');
		}

		if (isset(request::$post['payment_eway_status'])) {
			$data['payment_eway_status'] = request::$post['payment_eway_status'];
		} else {
			$data['payment_eway_status'] = config::get('payment_eway_status');
		}

		if (isset(request::$post['payment_eway_sort_order'])) {
			$data['payment_eway_sort_order'] = request::$post['payment_eway_sort_order'];
		} else {
			$data['payment_eway_sort_order'] = config::get('payment_eway_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/eway', $data));
	}

	public static function install() {
		admin_extension_payment_eway::install();
	}

	public static function uninstall() {
		admin_extension_payment_eway::uninstall();
	}

	// Legacy 2.0.0
	public static function orderAction() {
		return self::order();
	}

	// Legacy 2.0.3
	public static function action() {
		return self::order();
	}

	public static function order() {
		if (config::get('payment_eway_status')) {

			$eway_order = admin_extension_payment_eway::getOrder(request::$get['order_id']);

			if (!empty($eway_order)) {
				load::language('extension/payment/eway');

				$eway_order['total'] = $eway_order['amount'];
				$eway_order['total_formatted'] = currency::format($eway_order['amount'], $eway_order['currency_code'], 1, true);

				$eway_order['total_captured'] = admin_extension_payment_eway::getTotalCaptured($eway_order['eway_order_id']);
				$eway_order['total_captured_formatted'] = currency::format($eway_order['total_captured'], $eway_order['currency_code'], 1, true);

				$eway_order['uncaptured'] = $eway_order['total'] - $eway_order['total_captured'];

				$eway_order['total_refunded'] = admin_extension_payment_eway::getTotalRefunded($eway_order['eway_order_id']);
				$eway_order['total_refunded_formatted'] = currency::format($eway_order['total_refunded'], $eway_order['currency_code'], 1, true);

				$eway_order['unrefunded'] = $eway_order['total_captured'] - $eway_order['total_refunded'];

				$data['text_payment_info'] = language::get('text_payment_info');
				$data['text_order_total'] = language::get('text_order_total');
				$data['text_void_status'] = language::get('text_void_status');
				$data['text_transactions'] = language::get('text_transactions');
				$data['text_column_amount'] = language::get('text_column_amount');
				$data['text_column_type'] = language::get('text_column_type');
				$data['text_column_created'] = language::get('text_column_created');
				$data['text_column_transactionid'] = language::get('text_column_transactionid');
				$data['btn_refund'] = language::get('btn_refund');
				$data['btn_capture'] = language::get('btn_capture');
				$data['text_confirm_refund'] = language::get('text_confirm_refund');
				$data['text_confirm_capture'] = language::get('text_confirm_capture');

				$data['text_total_captured'] = language::get('text_total_captured');
				$data['text_total_refunded'] = language::get('text_total_refunded');
				$data['text_capture_status'] = language::get('text_capture_status');
				$data['text_refund_status'] = language::get('text_refund_status');

				$data['text_empty_refund'] = language::get('text_empty_refund');
				$data['text_empty_capture'] = language::get('text_empty_capture');

				$data['eway_order'] = $eway_order;
				$data['order_id'] = (int)request::$get['order_id'];

				return load::view('extension/payment/eway_order', $data);
			}
		}
	}

	public static function refund() {
		load::language('extension/payment/eway');

		$order_id = request::$post['order_id'];
		$refund_amount = (double)request::$post['refund_amount'];

		if ($order_id && $refund_amount > 0) {
			$result = admin_extension_payment_eway::refund($order_id, $refund_amount);

			// Check if any error returns
			if (isset($result::$Errors) || $result === false) {
				$json['error'] = true;
				$reason = '';
				if ($result === false) {
					$reason = language::get('text_unknown_failure');
				} else {
					$errors = explode(',', $result::$Errors);
					foreach ($errors as $error) {
						$reason .= language::get('text_card_message_' . $result::$Errors);
					}
				}
				$json['message'] = language::get('text_refund_failed') . $reason;
			} else {
				$eway_order = admin_extension_payment_eway::getOrder($order_id);
				admin_extension_payment_eway::addTransaction($eway_order['eway_order_id'], $result::$Refund::$TransactionID, 'refund', $result::$Refund::$TotalAmount / 100, $eway_order['currency_code']);

				$total_captured = admin_extension_payment_eway::getTotalCaptured($eway_order['eway_order_id']);
				$total_refunded = admin_extension_payment_eway::getTotalRefunded($eway_order['eway_order_id']);
				$refund_status = 0;

				if ($total_captured == $total_refunded) {
					$refund_status = 1;
					admin_extension_payment_eway::updateRefundStatus($eway_order['eway_order_id'], $refund_status);
				}

				$json['data'] = array();
				$json['data']['transactionid'] = $result::$TransactionID;
				$json['data']['created'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = number_format($refund_amount, 2, '.', '');
				$json['data']['total_refunded_formatted'] = currency::format($total_refunded, $eway_order['currency_code'], 1, true);
				$json['data']['refund_status'] = $refund_status;
				$json['data']['remaining'] = $total_captured - $total_refunded;
				$json['message'] = language::get('text_refund_success');
				$json['error'] = false;
			}
		} else {
			$json['error'] = true;
			$json['message'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function capture() {
		load::language('extension/payment/eway');

		$order_id = request::$post['order_id'];
		$capture_amount = (double)request::$post['capture_amount'];

		if ($order_id && $capture_amount > 0) {
			$eway_order = admin_extension_payment_eway::getOrder($order_id);
			$result = admin_extension_payment_eway::capture($order_id, $capture_amount, $eway_order['currency_code']);

			// Check if any error returns
			if (isset($result::$Errors) || $result === false) {
				$json['error'] = true;
				$reason = '';
				if ($result === false) {
					$reason = language::get('text_unknown_failure');
				} else {
					$errors = explode(',', $result::$Errors);
					foreach ($errors as $error) {
						$reason .= language::get('text_card_message_' . $result::$Errors);
					}
				}
				$json['message'] = language::get('text_capture_failed') . $reason;
			} else {
				admin_extension_payment_eway::addTransaction($eway_order['eway_order_id'], $result::$TransactionID, 'payment', $capture_amount, $eway_order['currency_code']);

				$total_captured = admin_extension_payment_eway::getTotalCaptured($eway_order['eway_order_id']);
				$total_refunded = admin_extension_payment_eway::getTotalRefunded($eway_order['eway_order_id']);

				$remaining = $eway_order['amount'] - $capture_amount;
				if ($remaining <= 0) {
					$remaining = 0;
				}

				admin_extension_payment_eway::updateCaptureStatus($eway_order['eway_order_id'], 1);
				admin_extension_payment_eway::updateTransactionId($eway_order['eway_order_id'], $result::$TransactionID);

				$json['data'] = array();
				$json['data']['transactionid'] = $result::$TransactionID;
				$json['data']['created'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = number_format($capture_amount, 2, '.', '');
				$json['data']['total_captured_formatted'] = currency::format($total_captured, $eway_order['currency_code'], 1, true);
				$json['data']['capture_status'] = 1;
				$json['data']['remaining'] = $remaining;
				$json['message'] = language::get('text_capture_success');
				$json['error'] = false;
			}
		} else {
			$json['error'] = true;
			$json['message'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	private static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/eway')) {
			self::$error['warning'] = language::get('error_permission');
		}
		if (!request::$post['payment_eway_username']) {
			self::$error['username'] = language::get('error_username');
		}
		if (!request::$post['payment_eway_password']) {
			self::$error['password'] = language::get('error_password');
		}
		if (!isset(request::$post['payment_eway_payment_type'])) {
			self::$error['payment_type'] = language::get('error_payment_type');
		}

		return !self::$error;
	}

}
