<?php
class ControllerExtensionPaymentFirstdata {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/firstdata');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_firstdata', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		$data['notify_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/firstdata/notify';


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['error_merchant_id'])) {
			$data['error_merchant_id'] = self::$error['error_merchant_id'];
		} else {
			$data['error_merchant_id'] = '';
		}

		if (isset(self::$error['error_secret'])) {
			$data['error_secret'] = self::$error['error_secret'];
		} else {
			$data['error_secret'] = '';
		}

		if (isset(self::$error['error_live_url'])) {
			$data['error_live_url'] = self::$error['error_live_url'];
		} else {
			$data['error_live_url'] = '';
		}

		if (isset(self::$error['error_demo_url'])) {
			$data['error_demo_url'] = self::$error['error_demo_url'];
		} else {
			$data['error_demo_url'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/firstdata')
		);

		$data['action'] = url::link('extension/payment/firstdata');
		
		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_firstdata_merchant_id'])) {
			$data['payment_firstdata_merchant_id'] = request::$post['payment_firstdata_merchant_id'];
		} else {
			$data['payment_firstdata_merchant_id'] = config::get('payment_firstdata_merchant_id');
		}

		if (isset(request::$post['payment_firstdata_secret'])) {
			$data['payment_firstdata_secret'] = request::$post['payment_firstdata_secret'];
		} else {
			$data['payment_firstdata_secret'] = config::get('payment_firstdata_secret');
		}

		if (isset(request::$post['payment_firstdata_live_demo'])) {
			$data['payment_firstdata_live_demo'] = request::$post['payment_firstdata_live_demo'];
		} else {
			$data['payment_firstdata_live_demo'] = config::get('payment_firstdata_live_demo');
		}

		if (isset(request::$post['payment_firstdata_geo_zone_id'])) {
			$data['payment_firstdata_geo_zone_id'] = request::$post['payment_firstdata_geo_zone_id'];
		} else {
			$data['payment_firstdata_geo_zone_id'] = config::get('payment_firstdata_geo_zone_id');
		}

		if (isset(request::$post['payment_firstdata_total'])) {
			$data['payment_firstdata_total'] = request::$post['payment_firstdata_total'];
		} else {
			$data['payment_firstdata_total'] = config::get('payment_firstdata_total');
		}

		if (isset(request::$post['payment_firstdata_sort_order'])) {
			$data['payment_firstdata_sort_order'] = request::$post['payment_firstdata_sort_order'];
		} else {
			$data['payment_firstdata_sort_order'] = config::get('payment_firstdata_sort_order');
		}

		if (isset(request::$post['payment_firstdata_status'])) {
			$data['payment_firstdata_status'] = request::$post['payment_firstdata_status'];
		} else {
			$data['payment_firstdata_status'] = config::get('payment_firstdata_status');
		}

		if (isset(request::$post['payment_firstdata_debug'])) {
			$data['payment_firstdata_debug'] = request::$post['payment_firstdata_debug'];
		} else {
			$data['payment_firstdata_debug'] = config::get('payment_firstdata_debug');
		}

		if (isset(request::$post['payment_firstdata_auto_settle'])) {
			$data['payment_firstdata_auto_settle'] = request::$post['payment_firstdata_auto_settle'];
		} elseif (!isset(request::$post['payment_firstdata_auto_settle']) && config::get('payment_firstdata_auto_settle') != '') {
			$data['payment_firstdata_auto_settle'] = config::get('payment_firstdata_auto_settle');
		} else {
			$data['payment_firstdata_auto_settle'] = 1;
		}

		if (isset(request::$post['payment_firstdata_order_status_success_settled_id'])) {
			$data['payment_firstdata_order_status_success_settled_id'] = request::$post['payment_firstdata_order_status_success_settled_id'];
		} else {
			$data['payment_firstdata_order_status_success_settled_id'] = config::get('payment_firstdata_order_status_success_settled_id');
		}

		if (isset(request::$post['payment_firstdata_order_status_success_unsettled_id'])) {
			$data['payment_firstdata_order_status_success_unsettled_id'] = request::$post['payment_firstdata_order_status_success_unsettled_id'];
		} else {
			$data['payment_firstdata_order_status_success_unsettled_id'] = config::get('payment_firstdata_order_status_success_unsettled_id');
		}

		if (isset(request::$post['payment_firstdata_order_status_decline_id'])) {
			$data['payment_firstdata_order_status_decline_id'] = request::$post['payment_firstdata_order_status_decline_id'];
		} else {
			$data['payment_firstdata_order_status_decline_id'] = config::get('payment_firstdata_order_status_decline_id');
		}

		if (isset(request::$post['payment_firstdata_order_status_void_id'])) {
			$data['payment_firstdata_order_status_void_id'] = request::$post['payment_firstdata_order_status_void_id'];
		} else {
			$data['payment_firstdata_order_status_void_id'] = config::get('payment_firstdata_order_status_void_id');
		}

		if (isset(request::$post['payment_firstdata_live_url'])) {
			$data['payment_firstdata_live_url'] = request::$post['payment_firstdata_live_url'];
		} else {
			$data['payment_firstdata_live_url'] = config::get('payment_firstdata_live_url');
		}

		if (empty($data['payment_firstdata_live_url'])) {
			$data['payment_firstdata_live_url'] = 'https://ipg-online.com/connect/gateway/processing';
		}

		if (isset(request::$post['payment_firstdata_demo_url'])) {
			$data['payment_firstdata_demo_url'] = request::$post['payment_firstdata_demo_url'];
		} else {
			$data['payment_firstdata_demo_url'] = config::get('payment_firstdata_demo_url');
		}

		if (isset(request::$post['payment_firstdata_card_storage'])) {
			$data['payment_firstdata_card_storage'] = request::$post['payment_firstdata_card_storage'];
		} else {
			$data['payment_firstdata_card_storage'] = config::get('payment_firstdata_card_storage');
		}

		if (empty($data['payment_firstdata_demo_url'])) {
			$data['payment_firstdata_demo_url'] = 'https://test.ipg-online.com/connect/gateway/processing';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/firstdata', $data));
	}

	public static function install() {
		admin_extension_payment_firstdata::install();
	}

	public static function uninstall() {
		admin_extension_payment_firstdata::uninstall();
	}

	public static function order() {
		if (config::get('payment_firstdata_status')) {

			$firstdata_order = admin_extension_payment_firstdata::getOrder(request::$get['order_id']);

			if (!empty($firstdata_order)) {
				load::language('extension/payment/firstdata');

				$firstdata_order['total_captured'] = admin_extension_payment_firstdata::getTotalCaptured($firstdata_order['firstdata_order_id']);
				$firstdata_order['total_formatted'] = currency::format($firstdata_order['total'], $firstdata_order['currency_code'], 1, true);
				$firstdata_order['total_captured_formatted'] = currency::format($firstdata_order['total_captured'], $firstdata_order['currency_code'], 1, true);

				$data['firstdata_order'] = $firstdata_order;
				$data['merchant_id'] = config::get('payment_firstdata_merchant_id');
				$data['currency'] = admin_extension_payment_firstdata::mapCurrency($firstdata_order['currency_code']);
				$data['amount'] = number_format($firstdata_order['total'], 2);

				$data['request_timestamp'] = date("Y:m:d-H:i:s");

				$data['hash'] = sha1(bin2hex($data['merchant_id'] . $data['request_timestamp'] . $data['amount'] . $data['currency'] . config::get('payment_firstdata_secret')));

				$data['void_url'] = url::link('extension/payment/firstdata/void');
				$data['capture_url'] = url::link('extension/payment/firstdata/capture');
				$data['notify_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/firstdata/notify';

				if (config::get('payment_firstdata_live_demo') == 1) {
					$data['action_url'] = config::get('payment_firstdata_live_url');
				} else {
					$data['action_url'] = config::get('payment_firstdata_demo_url');
				}

				if (isset(session::$data['void_success'])) {
					$data['void_success'] = session::$data['void_success'];

					unset(session::$data['void_success']);
				} else {
					$data['void_success'] = '';
				}

				if (isset(session::$data['void_error'])) {
					$data['void_error'] = session::$data['void_error'];

					unset(session::$data['void_error']);
				} else {
					$data['void_error'] = '';
				}

				if (isset(session::$data['capture_success'])) {
					$data['capture_success'] = session::$data['capture_success'];

					unset(session::$data['capture_success']);
				} else {
					$data['capture_success'] = '';
				}

				if (isset(session::$data['capture_error'])) {
					$data['capture_error'] = session::$data['capture_error'];

					unset(session::$data['capture_error']);
				} else {
					$data['capture_error'] = '';
				}

				$data['text_payment_info'] = language::get('text_payment_info');
				$data['text_order_ref'] = language::get('text_order_ref');
				$data['text_order_total'] = language::get('text_order_total');
				$data['text_total_captured'] = language::get('text_total_captured');
				$data['text_capture_status'] = language::get('text_capture_status');
				$data['text_void_status'] = language::get('text_void_status');
				$data['text_transactions'] = language::get('text_transactions');
				$data['text_yes'] = language::get('text_yes');
				$data['text_no'] = language::get('text_no');
				$data['text_column_amount'] = language::get('text_column_amount');
				$data['text_column_type'] = language::get('text_column_type');
				$data['text_column_date_added'] = language::get('text_column_date_added');
				$data['button_capture'] = language::get('button_capture');
				$data['button_void'] = language::get('button_void');
				$data['text_confirm_void'] = language::get('text_confirm_void');
				$data['text_confirm_capture'] = language::get('text_confirm_capture');

				$data['order_id'] = (int)request::$get['order_id'];

				return load::view('extension/payment/firstdata_order', $data);
			}
		}
	}

	public static function void() {
		load::language('extension/payment/firstdata');

		if (request::$post['status'] == 'FAILED') {
			if (isset(request::$post['fail_reason'])) {
				session::$data['void_error'] = request::$post['fail_reason'];
			} else {
				session::$data['void_error'] = language::get('error_void_error');
			}
		}

		if (request::$post['status'] == 'DECLINED') {
			session::$data['void_success'] = language::get('success_void');
		}

		response::redirect(url::link('sale/order/info', 'order_id=' . request::$post['order_id'] . '&user_token=' . session::$data['user_token']));
	}

	public static function capture() {
		load::language('extension/payment/firstdata');

		if (request::$post['status'] == 'FAILED') {
			if (isset(request::$post['fail_reason'])) {
				session::$data['capture_error'] = request::$post['fail_reason'];
			} else {
				session::$data['capture_error'] = language::get('error_capture_error');
			}
		}

		if (request::$post['status'] == 'APPROVED') {
			session::$data['capture_success'] = language::get('success_capture');
		}

		response::redirect(url::link('sale/order/info', 'order_id=' . request::$post['order_id'] . '&user_token=' . session::$data['user_token']));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/firstdata')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_firstdata_merchant_id']) {
			self::$error['error_merchant_id'] = language::get('error_merchant_id');
		}

		if (!request::$post['payment_firstdata_secret']) {
			self::$error['error_secret'] = language::get('error_secret');
		}

		if (!request::$post['payment_firstdata_live_url']) {
			self::$error['error_live_url'] = language::get('error_live_url');
		}

		if (!request::$post['payment_firstdata_demo_url']) {
			self::$error['error_demo_url'] = language::get('error_demo_url');
		}

		return !self::$error;
	}
}