<?php
class ControllerExtensionPaymentFirstdataRemote {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/firstdata_remote');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_firstdata_remote', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['error_merchant_id'])) {
			$data['error_merchant_id'] = self::$error['error_merchant_id'];
		} else {
			$data['error_merchant_id'] = '';
		}

		if (isset(self::$error['error_user_id'])) {
			$data['error_user_id'] = self::$error['error_user_id'];
		} else {
			$data['error_user_id'] = '';
		}

		if (isset(self::$error['error_password'])) {
			$data['error_password'] = self::$error['error_password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['error_certificate'])) {
			$data['error_certificate'] = self::$error['error_certificate'];
		} else {
			$data['error_certificate'] = '';
		}

		if (isset(self::$error['error_key'])) {
			$data['error_key'] = self::$error['error_key'];
		} else {
			$data['error_key'] = '';
		}

		if (isset(self::$error['error_key_pw'])) {
			$data['error_key_pw'] = self::$error['error_key_pw'];
		} else {
			$data['error_key_pw'] = '';
		}

		if (isset(self::$error['error_ca'])) {
			$data['error_ca'] = self::$error['error_ca'];
		} else {
			$data['error_ca'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/firstdata_remote', '&type=payment')
		);

		$data['action'] = url::link('extension/payment/firstdata_remote');
		
		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['firstdata_remote_merchant_id'])) {
			$data['firstdata_remote_merchant_id'] = request::$post['firstdata_remote_merchant_id'];
		} else {
			$data['firstdata_remote_merchant_id'] = config::get('firstdata_remote_merchant_id');
		}

		if (isset(request::$post['firstdata_remote_user_id'])) {
			$data['firstdata_remote_user_id'] = request::$post['firstdata_remote_user_id'];
		} else {
			$data['firstdata_remote_user_id'] = config::get('firstdata_remote_user_id');
		}

		if (isset(request::$post['firstdata_remote_password'])) {
			$data['firstdata_remote_password'] = request::$post['firstdata_remote_password'];
		} else {
			$data['firstdata_remote_password'] = config::get('firstdata_remote_password');
		}

		if (isset(request::$post['firstdata_remote_certificate'])) {
			$data['firstdata_remote_certificate'] = request::$post['firstdata_remote_certificate'];
		} else {
			$data['firstdata_remote_certificate'] = config::get('firstdata_remote_certificate');
		}

		if (isset(request::$post['firstdata_remote_key'])) {
			$data['firstdata_remote_key'] = request::$post['firstdata_remote_key'];
		} else {
			$data['firstdata_remote_key'] = config::get('firstdata_remote_key');
		}

		if (isset(request::$post['firstdata_remote_key_pw'])) {
			$data['firstdata_remote_key_pw'] = request::$post['firstdata_remote_key_pw'];
		} else {
			$data['firstdata_remote_key_pw'] = config::get('firstdata_remote_key_pw');
		}

		if (isset(request::$post['firstdata_remote_ca'])) {
			$data['firstdata_remote_ca'] = request::$post['firstdata_remote_ca'];
		} else {
			$data['firstdata_remote_ca'] = config::get('firstdata_remote_ca');
		}

		if (isset(request::$post['firstdata_remote_geo_zone_id'])) {
			$data['firstdata_remote_geo_zone_id'] = request::$post['firstdata_remote_geo_zone_id'];
		} else {
			$data['firstdata_remote_geo_zone_id'] = config::get('firstdata_remote_geo_zone_id');
		}

		if (isset(request::$post['firstdata_remote_total'])) {
			$data['firstdata_remote_total'] = request::$post['firstdata_remote_total'];
		} else {
			$data['firstdata_remote_total'] = config::get('firstdata_remote_total');
		}

		if (isset(request::$post['firstdata_remote_sort_order'])) {
			$data['firstdata_remote_sort_order'] = request::$post['firstdata_remote_sort_order'];
		} else {
			$data['firstdata_remote_sort_order'] = config::get('firstdata_remote_sort_order');
		}

		if (isset(request::$post['firstdata_remote_status'])) {
			$data['firstdata_remote_status'] = request::$post['firstdata_remote_status'];
		} else {
			$data['firstdata_remote_status'] = config::get('firstdata_remote_status');
		}

		if (isset(request::$post['firstdata_remote_debug'])) {
			$data['firstdata_remote_debug'] = request::$post['firstdata_remote_debug'];
		} else {
			$data['firstdata_remote_debug'] = config::get('firstdata_remote_debug');
		}
		if (isset(request::$post['firstdata_remote_auto_settle'])) {
			$data['firstdata_remote_auto_settle'] = request::$post['firstdata_remote_auto_settle'];
		} elseif (!isset(request::$post['payment_firstdata_auto_settle']) && config::get('firstdata_remote_auto_settle') != '') {
			$data['firstdata_remote_auto_settle'] = config::get('firstdata_remote_auto_settle');
		} else {
			$data['firstdata_remote_auto_settle'] = 1;
		}

		if (isset(request::$post['firstdata_remote_3d'])) {
			$data['firstdata_remote_3d'] = request::$post['firstdata_remote_3d'];
		} else {
			$data['firstdata_remote_3d'] = config::get('firstdata_remote_3d');
		}

		if (isset(request::$post['firstdata_remote_liability'])) {
			$data['firstdata_remote_liability'] = request::$post['firstdata_remote_liability'];
		} else {
			$data['firstdata_remote_liability'] = config::get('firstdata_remote_liability');
		}

		if (isset(request::$post['firstdata_remote_order_status_success_settled_id'])) {
			$data['firstdata_remote_order_status_success_settled_id'] = request::$post['firstdata_remote_order_status_success_settled_id'];
		} else {
			$data['firstdata_remote_order_status_success_settled_id'] = config::get('firstdata_remote_order_status_success_settled_id');
		}

		if (isset(request::$post['firstdata_remote_order_status_success_unsettled_id'])) {
			$data['firstdata_remote_order_status_success_unsettled_id'] = request::$post['firstdata_remote_order_status_success_unsettled_id'];
		} else {
			$data['firstdata_remote_order_status_success_unsettled_id'] = config::get('firstdata_remote_order_status_success_unsettled_id');
		}

		if (isset(request::$post['firstdata_remote_order_status_decline_id'])) {
			$data['firstdata_remote_order_status_decline_id'] = request::$post['firstdata_remote_order_status_decline_id'];
		} else {
			$data['firstdata_remote_order_status_decline_id'] = config::get('firstdata_remote_order_status_decline_id');
		}

		if (isset(request::$post['firstdata_remote_order_status_void_id'])) {
			$data['firstdata_remote_order_status_void_id'] = request::$post['firstdata_remote_order_status_void_id'];
		} else {
			$data['firstdata_remote_order_status_void_id'] = config::get('firstdata_remote_order_status_void_id');
		}

		if (isset(request::$post['firstdata_remote_order_status_refunded_id'])) {
			$data['firstdata_remote_order_status_refunded_id'] = request::$post['firstdata_remote_order_status_refunded_id'];
		} else {
			$data['firstdata_remote_order_status_refunded_id'] = config::get('firstdata_remote_order_status_refunded_id');
		}

		if (isset(request::$post['firstdata_remote_card_storage'])) {
			$data['firstdata_remote_card_storage'] = request::$post['firstdata_remote_card_storage'];
		} else {
			$data['firstdata_remote_card_storage'] = config::get('firstdata_remote_card_storage');
		}

		$data['cards'] = array();

		$data['cards'][] = array(
			'text'  => language::get('text_mastercard'),
			'value' => 'mastercard'
		);

		$data['cards'][] = array(
			'text'  => language::get('text_visa'),
			'value' => 'visa'
		);

		$data['cards'][] = array(
			'text'  => language::get('text_diners'),
			'value' => 'diners'
		);

		$data['cards'][] = array(
			'text'  => language::get('text_amex'),
			'value' => 'amex'
		);

		$data['cards'][] = array(
			'text'  => language::get('text_maestro'),
			'value' => 'maestro'
		);

		if (isset(request::$post['firstdata_remote_cards_accepted'])) {
			$data['firstdata_remote_cards_accepted'] = request::$post['firstdata_remote_cards_accepted'];
		} elseif (config::get('firstdata_remote_cards_accepted')) {
			$data['firstdata_remote_cards_accepted'] = config::get('firstdata_remote_cards_accepted');
		} else {
			$data['firstdata_remote_cards_accepted'] = array();
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/firstdata_remote', $data));
	}

	public static function install() {
		admin_extension_payment_firstdata_remote::install();
	}

	public static function uninstall() {
		admin_extension_payment_firstdata_remote::uninstall();
	}

	public static function order() {
		if (config::get('firstdata_remote_status')) {

			$firstdata_order = admin_extension_payment_firstdata_remote::getOrder(request::$get['order_id']);

			if (!empty($firstdata_order)) {
				load::language('extension/payment/firstdata_remote');

				$firstdata_order['total_captured'] = admin_extension_payment_firstdata_remote::getTotalCaptured($firstdata_order['firstdata_remote_order_id']);

				$firstdata_order['total_formatted'] = currency::format($firstdata_order['total'], $firstdata_order['currency_code'], 1, true);
				$firstdata_order['total_captured_formatted'] = currency::format($firstdata_order['total_captured'], $firstdata_order['currency_code'], 1, true);

				$data['firstdata_order'] = $firstdata_order;

				$data['text_payment_info'] = language::get('text_payment_info');
				$data['text_order_ref'] = language::get('text_order_ref');
				$data['text_order_total'] = language::get('text_order_total');
				$data['text_total_captured'] = language::get('text_total_captured');
				$data['text_capture_status'] = language::get('text_capture_status');
				$data['text_void_status'] = language::get('text_void_status');
				$data['text_refund_status'] = language::get('text_refund_status');
				$data['text_transactions'] = language::get('text_transactions');
				$data['text_yes'] = language::get('text_yes');
				$data['text_no'] = language::get('text_no');
				$data['text_column_amount'] = language::get('text_column_amount');
				$data['text_column_type'] = language::get('text_column_type');
				$data['text_column_date_added'] = language::get('text_column_date_added');
				$data['text_confirm_void'] = language::get('text_confirm_void');
				$data['text_confirm_capture'] = language::get('text_confirm_capture');
				$data['text_confirm_refund'] = language::get('text_confirm_refund');

				$data['button_capture'] = language::get('button_capture');
				$data['button_refund'] = language::get('button_refund');
				$data['button_void'] = language::get('button_void');

				$data['order_id'] = (int)request::$get['order_id'];

				return load::view('extension/payment/firstdata_remote_order', $data);
			}
		}
	}

	public static function void() {
		load::language('extension/payment/firstdata_remote');

		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$firstdata_order = admin_extension_payment_firstdata_remote::getOrder(request::$post['order_id']);

			$void_response = admin_extension_payment_firstdata_remote::void($firstdata_order['order_ref'], $firstdata_order['tdate']);

			admin_extension_payment_firstdata_remote::logger('Void result:\r\n' . print_r($void_response, 1));

			if (strtoupper($void_response['transaction_result']) == 'APPROVED') {
				admin_extension_payment_firstdata_remote::addTransaction($firstdata_order['firstdata_remote_order_id'], 'void', 0.00);

				admin_extension_payment_firstdata_remote::updateVoidStatus($firstdata_order['firstdata_remote_order_id'], 1);

				$json['msg'] = language::get('text_void_ok');
				$json['data'] = array();
				$json['data']['column_date_added'] = date('Y-m-d H:i:s');
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($void_response['error']) && !empty($void_response['error']) ? (string)$void_response['error'] : 'Unable to void';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function capture() {
		load::language('extension/payment/firstdata');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$firstdata_order = admin_extension_payment_firstdata_remote::getOrder(request::$post['order_id']);

			$capture_response = admin_extension_payment_firstdata_remote::capture($firstdata_order['order_ref'], $firstdata_order['total'], $firstdata_order['currency_code']);

			admin_extension_payment_firstdata_remote::logger('Settle result:\r\n' . print_r($capture_response, 1));

			if (strtoupper($capture_response['transaction_result']) == 'APPROVED') {
				admin_extension_payment_firstdata_remote::addTransaction($firstdata_order['firstdata_remote_order_id'], 'payment', $firstdata_order['total']);
				$total_captured = admin_extension_payment_firstdata_remote::getTotalCaptured($firstdata_order['firstdata_remote_order_id']);

				admin_extension_payment_firstdata_remote::updateCaptureStatus($firstdata_order['firstdata_remote_order_id'], 1);
				$capture_status = 1;
				$json['msg'] = language::get('text_capture_ok_order');
				$json['data'] = array();
				$json['data']['column_date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = (float)$firstdata_order['total'];
				$json['data']['capture_status'] = $capture_status;
				$json['data']['total'] = (float)$total_captured;
				$json['data']['total_formatted'] = currency::format($total_captured, $firstdata_order['currency_code'], 1, true);
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($capture_response['error']) && !empty($capture_response['error']) ? (string)$capture_response['error'] : 'Unable to capture';

			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function refund() {
		load::language('extension/payment/firstdata_remote');

		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$firstdata_order = admin_extension_payment_firstdata_remote::getOrder(request::$post['order_id']);

			$refund_response = admin_extension_payment_firstdata_remote::refund($firstdata_order['order_ref'], $firstdata_order['total'], $firstdata_order['currency_code']);

			admin_extension_payment_firstdata_remote::logger('Refund result:\r\n' . print_r($refund_response, 1));

			if (strtoupper($refund_response['transaction_result']) == 'APPROVED') {
				admin_extension_payment_firstdata_remote::addTransaction($firstdata_order['firstdata_remote_order_id'], 'refund', $firstdata_order['total'] * -1);

				$total_refunded = admin_extension_payment_firstdata_remote::getTotalRefunded($firstdata_order['firstdata_remote_order_id']);
				$total_captured = admin_extension_payment_firstdata_remote::getTotalCaptured($firstdata_order['firstdata_remote_order_id']);

				if ($total_captured <= 0 && $firstdata_order['capture_status'] == 1) {
					admin_extension_payment_firstdata_remote::updateRefundStatus($firstdata_order['firstdata_remote_order_id'], 1);
					$refund_status = 1;
					$json['msg'] = language::get('text_refund_ok_order');
				} else {
					$refund_status = 0;
					$json['msg'] = language::get('text_refund_ok');
				}

				$json['data'] = array();
				$json['data']['column_date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = $firstdata_order['total'] * -1;
				$json['data']['total_captured'] = (float)$total_captured;
				$json['data']['total_refunded'] = (float)$total_refunded;
				$json['data']['refund_status'] = $refund_status;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($refund_response['error']) && !empty($refund_response['error']) ? (string)$refund_response['error'] : 'Unable to refund';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/firstdata_remote')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['firstdata_remote_merchant_id']) {
			self::$error['error_merchant_id'] = language::get('error_merchant_id');
		}

		if (!request::$post['firstdata_remote_user_id']) {
			self::$error['error_user_id'] = language::get('error_user_id');
		}

		if (!request::$post['firstdata_remote_password']) {
			self::$error['error_password'] = language::get('error_password');
		}

		if (!request::$post['firstdata_remote_certificate']) {
			self::$error['error_certificate'] = language::get('error_certificate');
		}

		if (!request::$post['firstdata_remote_key']) {
			self::$error['error_key'] = language::get('error_key');
		}

		if (!request::$post['firstdata_remote_key_pw']) {
			self::$error['error_key_pw'] = language::get('error_key_pw');
		}

		if (!request::$post['firstdata_remote_ca']) {
			self::$error['error_ca'] = language::get('error_ca');
		}

		return !self::$error;
	}
}