<?php
class ControllerExtensionPaymentFreeCheckout {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/free_checkout');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_free_checkout', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/free_checkout')
		);

		$data['action'] = url::link('extension/payment/free_checkout');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_free_checkout_order_status_id'])) {
			$data['payment_free_checkout_order_status_id'] = request::$post['payment_free_checkout_order_status_id'];
		} else {
			$data['payment_free_checkout_order_status_id'] = config::get('payment_free_checkout_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_free_checkout_status'])) {
			$data['payment_free_checkout_status'] = request::$post['payment_free_checkout_status'];
		} else {
			$data['payment_free_checkout_status'] = config::get('payment_free_checkout_status');
		}

		if (isset(request::$post['payment_free_checkout_sort_order'])) {
			$data['payment_free_checkout_sort_order'] = request::$post['payment_free_checkout_sort_order'];
		} else {
			$data['payment_free_checkout_sort_order'] = config::get('payment_free_checkout_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/free_checkout', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/free_checkout')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}