<?php

class ControllerExtensionPaymentG2APay {

	private static $error = array();

	public static function index() {
		load::language('extension/payment/g2apay');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_g2apay', request::$post);

			session::$data['complete'] = language::get('text_complete');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['username'])) {
			$data['error_username'] = self::$error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset(self::$error['secret'])) {
			$data['error_secret'] = self::$error['secret'];
		} else {
			$data['error_secret'] = '';
		}

		if (isset(self::$error['api_hash'])) {
			$data['error_api_hash'] = self::$error['api_hash'];
		} else {
			$data['error_api_hash'] = '';
		}

		if (isset(request::$post['payment_g2apay_order_status_id'])) {
			$data['payment_g2apay_order_status_id'] = request::$post['payment_g2apay_order_status_id'];
		} else {
			$data['payment_g2apay_order_status_id'] = config::get('payment_g2apay_order_status_id');
		}

		if (isset(request::$post['payment_g2apay_complete_status_id'])) {
			$data['payment_g2apay_complete_status_id'] = request::$post['payment_g2apay_complete_status_id'];
		} else {
			$data['payment_g2apay_complete_status_id'] = config::get('payment_g2apay_complete_status_id');
		}

		if (isset(request::$post['payment_g2apay_rejected_status_id'])) {
			$data['payment_g2apay_rejected_status_id'] = request::$post['payment_g2apay_rejected_status_id'];
		} else {
			$data['payment_g2apay_rejected_status_id'] = config::get('payment_g2apay_rejected_status_id');
		}

		if (isset(request::$post['payment_g2apay_cancelled_status_id'])) {
			$data['payment_g2apay_cancelled_status_id'] = request::$post['payment_g2apay_cancelled_status_id'];
		} else {
			$data['payment_g2apay_cancelled_status_id'] = config::get('payment_g2apay_cancelled_status_id');
		}

		if (isset(request::$post['payment_g2apay_pending_status_id'])) {
			$data['payment_g2apay_pending_status_id'] = request::$post['payment_g2apay_pending_status_id'];
		} else {
			$data['payment_g2apay_pending_status_id'] = config::get('payment_g2apay_pending_status_id');
		}

		if (isset(request::$post['payment_g2apay_refunded_status_id'])) {
			$data['payment_g2apay_refunded_status_id'] = request::$post['payment_g2apay_refunded_status_id'];
		} else {
			$data['payment_g2apay_refunded_status_id'] = config::get('payment_g2apay_refunded_status_id');
		}

		if (isset(request::$post['payment_g2apay_partially_refunded_status_id'])) {
			$data['payment_g2apay_partially_refunded_status_id'] = request::$post['payment_g2apay_partially_refunded_status_id'];
		} else {
			$data['payment_g2apay_partially_refunded_status_id'] = config::get('payment_g2apay_partially_refunded_status_id');
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/g2apay')
		);

		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		$data['action'] = url::link('extension/payment/g2apay');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_g2apay_username'])) {
			$data['payment_g2apay_username'] = request::$post['payment_g2apay_username'];
		} else {
			$data['payment_g2apay_username'] = config::get('payment_g2apay_username');
		}

		if (isset(request::$post['payment_g2apay_secret'])) {
			$data['payment_g2apay_secret'] = request::$post['payment_g2apay_secret'];
		} else {
			$data['payment_g2apay_secret'] = config::get('payment_g2apay_secret');
		}

		if (isset(request::$post['payment_g2apay_api_hash'])) {
			$data['payment_g2apay_api_hash'] = request::$post['payment_g2apay_api_hash'];
		} else {
			$data['payment_g2apay_api_hash'] = config::get('payment_g2apay_api_hash');
		}

		if (isset(request::$post['payment_g2apay_environment'])) {
			$data['payment_g2apay_environment'] = request::$post['payment_g2apay_environment'];
		} else {
			$data['payment_g2apay_environment'] = config::get('payment_g2apay_environment');
		}

		if (isset(request::$post['payment_g2apay_total'])) {
			$data['payment_g2apay_total'] = request::$post['payment_g2apay_total'];
		} else {
			$data['payment_g2apay_total'] = config::get('payment_g2apay_total');
		}

		if (isset(request::$post['payment_g2apay_secret_token'])) {
			$data['payment_g2apay_secret_token'] = request::$post['payment_g2apay_secret_token'];
		} elseif (config::get('payment_g2apay_secret_token')) {
			$data['payment_g2apay_secret_token'] = config::get('payment_g2apay_secret_token');
		} else {
			$data['payment_g2apay_secret_token'] = sha1(uniqid(mt_rand(), 1));
		}

		$data['g2apay_ipn_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/g2apay/ipn&token=' . $data['payment_g2apay_secret_token'];

		if (isset(request::$post['payment_g2apay_ipn_uri'])) {
			$data['payment_g2apay_ipn_uri'] = request::$post['payment_g2apay_ipn_uri'];
		} else {
			$data['payment_g2apay_ipn_uri'] = config::get('payment_g2apay_ipn_uri');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_g2apay_geo_zone_id'])) {
			$data['payment_g2apay_geo_zone_id'] = request::$post['payment_g2apay_geo_zone_id'];
		} else {
			$data['payment_g2apay_geo_zone_id'] = config::get('payment_g2apay_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_g2apay_status'])) {
			$data['payment_g2apay_status'] = request::$post['payment_g2apay_status'];
		} else {
			$data['payment_g2apay_status'] = config::get('payment_g2apay_status');
		}

		if (isset(request::$post['payment_g2apay_debug'])) {
			$data['payment_g2apay_debug'] = request::$post['payment_g2apay_debug'];
		} else {
			$data['payment_g2apay_debug'] = config::get('payment_g2apay_debug');
		}

		if (isset(request::$post['payment_g2apay_sort_order'])) {
			$data['payment_g2apay_sort_order'] = request::$post['payment_g2apay_sort_order'];
		} else {
			$data['payment_g2apay_sort_order'] = config::get('payment_g2apay_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/g2apay', $data));
	}

	public static function order() {

		if (config::get('payment_g2apay_status')) {


			$g2apay_order = admin_extension_payment_g2apay::getOrder(request::$get['order_id']);

			if (!empty($g2apay_order)) {
				load::language('extension/payment/g2apay');

				$g2apay_order['total_released'] = admin_extension_payment_g2apay::getTotalReleased($g2apay_order['g2apay_order_id']);

				$g2apay_order['total_formatted'] = currency::format($g2apay_order['total'], $g2apay_order['currency_code'], false);
				$g2apay_order['total_released_formatted'] = currency::format($g2apay_order['total_released'], $g2apay_order['currency_code'], false);

				$data['g2apay_order'] = $g2apay_order;

				$data['order_id'] = (int)request::$get['order_id'];
				

				return load::view('extension/payment/g2apay_order', $data);
			}
		}
	}

	public static function refund() {
		load::language('extension/payment/g2apay');
		$json = array();

		if (isset(request::$post['order_id']) && !empty(request::$post['order_id'])) {

			$g2apay_order = admin_extension_payment_g2apay::getOrder(request::$post['order_id']);

			$refund_response = admin_extension_payment_g2apay::refund($g2apay_order, request::$post['amount']);

			admin_extension_payment_g2apay::logger($refund_response);

			if ($refund_response == 'ok') {
				admin_extension_payment_g2apay::addTransaction($g2apay_order['g2apay_order_id'], 'refund', request::$post['amount'] * -1);

				$total_refunded = admin_extension_payment_g2apay::getTotalRefunded($g2apay_order['g2apay_order_id']);
				$total_released = admin_extension_payment_g2apay::getTotalReleased($g2apay_order['g2apay_order_id']);

				if ($total_released <= 0 && $g2apay_order['release_status'] == 1) {
					admin_extension_payment_g2apay::updateRefundStatus($g2apay_order['g2apay_order_id'], 1);
					$refund_status = 1;
					$json['msg'] = language::get('text_refund_ok_order');
				} else {
					$refund_status = 0;
					$json['msg'] = language::get('text_refund_ok');
				}

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = currency::format((request::$post['amount'] * -1), $g2apay_order['currency_code'], false);
				$json['data']['total_released'] = (float)$total_released;
				$json['data']['total_refunded'] = (float)$total_refunded;
				$json['data']['refund_status'] = $refund_status;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = 'Unable to refund: ' . $refund_response;
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function install() {
		admin_extension_payment_g2apay::install();
	}

	public static function uninstall() {
		admin_extension_payment_g2apay::uninstall();
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/g2apay')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_g2apay_username']) {
			self::$error['username'] = language::get('error_username');
		}

		if (!request::$post['payment_g2apay_secret']) {
			self::$error['secret'] = language::get('error_secret');
		}

		if (!request::$post['payment_g2apay_api_hash']) {
			self::$error['api_hash'] = language::get('error_api_hash');
		}

		return !self::$error;
	}

}
