<?php
class ControllerExtensionPaymentGlobalpay {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/globalpay');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_globalpay', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		$data['notify_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/globalpay/notify';

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['error_merchant_id'])) {
			$data['error_merchant_id'] = self::$error['error_merchant_id'];
		} else {
			$data['error_merchant_id'] = '';
		}

		if (isset(self::$error['error_secret'])) {
			$data['error_secret'] = self::$error['error_secret'];
		} else {
			$data['error_secret'] = '';
		}

		if (isset(self::$error['error_live_url'])) {
			$data['error_live_url'] = self::$error['error_live_url'];
		} else {
			$data['error_live_url'] = '';
		}

		if (isset(self::$error['error_demo_url'])) {
			$data['error_demo_url'] = self::$error['error_demo_url'];
		} else {
			$data['error_demo_url'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/globalpay')
		);

		$data['action'] = url::link('extension/payment/globalpay');
		
		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_globalpay_merchant_id'])) {
			$data['payment_globalpay_merchant_id'] = request::$post['payment_globalpay_merchant_id'];
		} else {
			$data['payment_globalpay_merchant_id'] = config::get('payment_globalpay_merchant_id');
		}

		if (isset(request::$post['payment_globalpay_secret'])) {
			$data['payment_globalpay_secret'] = request::$post['payment_globalpay_secret'];
		} else {
			$data['payment_globalpay_secret'] = config::get('payment_globalpay_secret');
		}

		if (isset(request::$post['payment_globalpay_rebate_password'])) {
			$data['payment_globalpay_rebate_password'] = request::$post['payment_globalpay_rebate_password'];
		} else {
			$data['payment_globalpay_rebate_password'] = config::get('payment_globalpay_rebate_password');
		}

		if (isset(request::$post['payment_globalpay_live_demo'])) {
			$data['payment_globalpay_live_demo'] = request::$post['payment_globalpay_live_demo'];
		} else {
			$data['payment_globalpay_live_demo'] = config::get('payment_globalpay_live_demo');
		}

		if (isset(request::$post['payment_globalpay_geo_zone_id'])) {
			$data['payment_globalpay_geo_zone_id'] = request::$post['payment_globalpay_geo_zone_id'];
		} else {
			$data['payment_globalpay_geo_zone_id'] = config::get('payment_globalpay_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_globalpay_total'])) {
			$data['payment_globalpay_total'] = request::$post['payment_globalpay_total'];
		} else {
			$data['payment_globalpay_total'] = config::get('payment_globalpay_total');
		}

		if (isset(request::$post['payment_globalpay_sort_order'])) {
			$data['payment_globalpay_sort_order'] = request::$post['payment_globalpay_sort_order'];
		} else {
			$data['payment_globalpay_sort_order'] = config::get('payment_globalpay_sort_order');
		}

		if (isset(request::$post['payment_globalpay_status'])) {
			$data['payment_globalpay_status'] = request::$post['payment_globalpay_status'];
		} else {
			$data['payment_globalpay_status'] = config::get('payment_globalpay_status');
		}

		if (isset(request::$post['payment_globalpay_debug'])) {
			$data['payment_globalpay_debug'] = request::$post['payment_globalpay_debug'];
		} else {
			$data['payment_globalpay_debug'] = config::get('payment_globalpay_debug');
		}

		if (isset(request::$post['payment_globalpay_account'])) {
			$data['payment_globalpay_account'] = request::$post['payment_globalpay_account'];
		} else {
			$data['payment_globalpay_account'] = config::get('payment_globalpay_account');
		}

		if (isset(request::$post['payment_globalpay_auto_settle'])) {
			$data['payment_globalpay_auto_settle'] = request::$post['payment_globalpay_auto_settle'];
		} else {
			$data['payment_globalpay_auto_settle'] = config::get('payment_globalpay_auto_settle');
		}

		if (isset(request::$post['payment_globalpay_card_select'])) {
			$data['payment_globalpay_card_select'] = request::$post['payment_globalpay_card_select'];
		} else {
			$data['payment_globalpay_card_select'] = config::get('payment_globalpay_card_select');
		}

		if (isset(request::$post['payment_globalpay_tss_check'])) {
			$data['payment_globalpay_tss_check'] = request::$post['payment_globalpay_tss_check'];
		} else {
			$data['payment_globalpay_tss_check'] = config::get('payment_globalpay_tss_check');
		}

		if (isset(request::$post['globalpay_order_status_success_settled_id'])) {
			$data['globalpay_order_status_success_settled_id'] = request::$post['globalpay_order_status_success_settled_id'];
		} else {
			$data['globalpay_order_status_success_settled_id'] = config::get('globalpay_order_status_success_settled_id');
		}

		if (isset(request::$post['payment_globalpay_order_status_success_unsettled_id'])) {
			$data['payment_globalpay_order_status_success_unsettled_id'] = request::$post['payment_globalpay_order_status_success_unsettled_id'];
		} else {
			$data['payment_globalpay_order_status_success_unsettled_id'] = config::get('payment_globalpay_order_status_success_unsettled_id');
		}

		if (isset(request::$post['payment_globalpay_order_status_decline_id'])) {
			$data['payment_globalpay_order_status_decline_id'] = request::$post['payment_globalpay_order_status_decline_id'];
		} else {
			$data['payment_globalpay_order_status_decline_id'] = config::get('payment_globalpay_order_status_decline_id');
		}

		if (isset(request::$post['payment_globalpay_order_status_decline_pending_id'])) {
			$data['payment_globalpay_order_status_decline_pending_id'] = request::$post['payment_globalpay_order_status_decline_pending_id'];
		} else {
			$data['payment_globalpay_order_status_decline_pending_id'] = config::get('payment_globalpay_order_status_decline_pending_id');
		}

		if (isset(request::$post['payment_globalpay_order_status_decline_stolen_id'])) {
			$data['payment_globalpay_order_status_decline_stolen_id'] = request::$post['payment_globalpay_order_status_decline_stolen_id'];
		} else {
			$data['payment_globalpay_order_status_decline_stolen_id'] = config::get('payment_globalpay_order_status_decline_stolen_id');
		}

		if (isset(request::$post['payment_globalpay_order_status_decline_bank_id'])) {
			$data['payment_globalpay_order_status_decline_bank_id'] = request::$post['payment_globalpay_order_status_decline_bank_id'];
		} else {
			$data['payment_globalpay_order_status_decline_bank_id'] = config::get('payment_globalpay_order_status_decline_bank_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_globalpay_live_url'])) {
			$data['payment_globalpay_live_url'] = request::$post['payment_globalpay_live_url'];
		} else {
			$data['payment_globalpay_live_url'] = config::get('payment_globalpay_live_url');
		}

		if (empty($data['payment_globalpay_live_url'])) {
			$data['payment_globalpay_live_url'] = 'https://hpp.globaliris.com/pay';
		}

		if (isset(request::$post['payment_globalpay_demo_url'])) {
			$data['payment_globalpay_demo_url'] = request::$post['payment_globalpay_demo_url'];
		} else {
			$data['payment_globalpay_demo_url'] = config::get('payment_globalpay_demo_url');
		}

		if (empty($data['payment_globalpay_demo_url'])) {
			$data['payment_globalpay_demo_url'] = 'https://hpp.sandbox.globaliris.com/pay';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/globalpay', $data));
	}

	public static function install() {

		admin_extension_payment_globalpay::install();
	}

	public static function order() {
		if (config::get('payment_globalpay_status')) {

			$globalpay_order = admin_extension_payment_globalpay::getOrder(request::$get['order_id']);

			if (!empty($globalpay_order)) {
				load::language('extension/payment/globalpay');

				$globalpay_order['total_captured'] = admin_extension_payment_globalpay::getTotalCaptured($globalpay_order['globalpay_order_id']);

				$globalpay_order['total_formatted'] = currency::format($globalpay_order['total'], $globalpay_order['currency_code'], 1, true);
				$globalpay_order['total_captured_formatted'] = currency::format($globalpay_order['total_captured'], $globalpay_order['currency_code'], 1, true);

				$data['globalpay_order'] = $globalpay_order;

				$data['auto_settle'] = $globalpay_order['settle_type'];

				$data['order_id'] = (int)request::$get['order_id'];
				

				return load::view('extension/payment/globalpay_order', $data);
			}
		}
	}

	public static function void() {
		load::language('extension/payment/globalpay');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$globalpay_order = admin_extension_payment_globalpay::getOrder(request::$post['order_id']);

			$void_response = admin_extension_payment_globalpay::void(request::$post['order_id']);

			admin_extension_payment_globalpay::logger('Void result:\r\n' . print_r($void_response, 1));

			if (isset($void_response::$result) && $void_response::$result == '00') {
				admin_extension_payment_globalpay::addTransaction($globalpay_order['globalpay_order_id'], 'void', 0.00);
				admin_extension_payment_globalpay::updateVoidStatus($globalpay_order['globalpay_order_id'], 1);

				$json['msg'] = language::get('text_void_ok');
				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($void_response::$message) && !empty($void_response::$message) ? (string)$void_response::$message : 'Unable to void';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function capture() {
		load::language('extension/payment/globalpay');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '' && isset(request::$post['amount']) && request::$post['amount'] > 0) {

			$globalpay_order = admin_extension_payment_globalpay::getOrder(request::$post['order_id']);

			$capture_response = admin_extension_payment_globalpay::capture(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_globalpay::logger('Settle result:\r\n' . print_r($capture_response, 1));

			if (isset($capture_response::$result) && $capture_response::$result == '00') {
				admin_extension_payment_globalpay::addTransaction($globalpay_order['globalpay_order_id'], 'payment', request::$post['amount']);

				$total_captured = admin_extension_payment_globalpay::getTotalCaptured($globalpay_order['globalpay_order_id']);

				if ($total_captured >= $globalpay_order['total'] || $globalpay_order['settle_type'] == 0) {
					admin_extension_payment_globalpay::updateCaptureStatus($globalpay_order['globalpay_order_id'], 1);
					$capture_status = 1;
					$json['msg'] = language::get('text_capture_ok_order');
				} else {
					$capture_status = 0;
					$json['msg'] = language::get('text_capture_ok');
				}

				admin_extension_payment_globalpay::updateForRebate($globalpay_order['globalpay_order_id'], $capture_response::$pasref, $capture_response::$orderid);

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = request::$post['amount'];
				$json['data']['capture_status'] = $capture_status;
				$json['data']['total'] = (float)$total_captured;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($capture_response::$message) && !empty($capture_response::$message) ? (string)$capture_response::$message : 'Unable to capture';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_data_missing');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function rebate() {
		load::language('extension/payment/globalpay');
		$json = array();

		if (isset(request::$post['order_id']) && !empty(request::$post['order_id'])) {

			$globalpay_order = admin_extension_payment_globalpay::getOrder(request::$post['order_id']);

			$rebate_response = admin_extension_payment_globalpay::rebate(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_globalpay::logger('Rebate result:\r\n' . print_r($rebate_response, 1));

			if (isset($rebate_response::$result) && $rebate_response::$result == '00') {
				admin_extension_payment_globalpay::addTransaction($globalpay_order['globalpay_order_id'], 'rebate', request::$post['amount']*-1);

				$total_rebated = admin_extension_payment_globalpay::getTotalRebated($globalpay_order['globalpay_order_id']);
				$total_captured = admin_extension_payment_globalpay::getTotalCaptured($globalpay_order['globalpay_order_id']);

				if ($total_captured <= 0 && $globalpay_order['capture_status'] == 1) {
					admin_extension_payment_globalpay::updateRebateStatus($globalpay_order['globalpay_order_id'], 1);
					$rebate_status = 1;
					$json['msg'] = language::get('text_rebate_ok_order');
				} else {
					$rebate_status = 0;
					$json['msg'] = language::get('text_rebate_ok');
				}

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = request::$post['amount']*-1;
				$json['data']['total_captured'] = (float)$total_captured;
				$json['data']['total_rebated'] = (float)$total_rebated;
				$json['data']['rebate_status'] = $rebate_status;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($rebate_response::$message) && !empty($rebate_response::$message) ? (string)$rebate_response::$message : 'Unable to rebate';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/globalpay')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_globalpay_merchant_id']) {
			self::$error['error_merchant_id'] = language::get('error_merchant_id');
		}

		if (!request::$post['payment_globalpay_secret']) {
			self::$error['error_secret'] = language::get('error_secret');
		}

		if (!request::$post['payment_globalpay_live_url']) {
			self::$error['error_live_url'] = language::get('error_live_url');
		}

		if (!request::$post['payment_globalpay_demo_url']) {
			self::$error['error_demo_url'] = language::get('error_demo_url');
		}

		return !self::$error;
	}
}