<?php
class ControllerExtensionPaymentLaybuy {
	private static $error = array();

	public static function index() {


		load::language('extension/payment/laybuy');

		document::setTitle(language::get('heading_title'));

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			unset(request::$post['laybuy_cron_url'], request::$post['laybuy_cron_time']);

			admin_setting_setting::editSetting('payment_laybuy', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/laybuy')
		);

		$data['action'] = url::link('extension/payment/laybuy');

		$data['fetch'] = url::link('extension/payment/laybuy/fetch', '#reportstab');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_laybuys_membership_id'])) {
			$data['payment_laybuys_membership_id'] = request::$post['payment_laybuys_membership_id'];
		} else {
			$data['payment_laybuys_membership_id'] = config::get('payment_laybuys_membership_id');
		}

		if (isset(request::$post['payment_laybuy_token'])) {
			$data['payment_laybuy_token'] = request::$post['payment_laybuy_token'];
		} elseif (config::has('payment_laybuy_token')) {
			$data['payment_laybuy_token'] = config::get('payment_laybuy_token');
		} else {
			$data['payment_laybuy_token'] = md5(time());
		}

		if (isset(request::$post['payment_laybuy_min_deposit'])) {
			$data['payment_laybuy_min_deposit'] = request::$post['payment_laybuy_min_deposit'];
		} elseif (config::get('payment_laybuy_min_deposit')) {
			$data['payment_laybuy_min_deposit'] = config::get('payment_laybuy_min_deposit');
		} else {
			$data['payment_laybuy_min_deposit'] = '20';
		}

		if (isset(request::$post['payment_laybuy_max_deposit'])) {
			$data['payment_laybuy_max_deposit'] = request::$post['payment_laybuy_max_deposit'];
		} elseif (config::get('payment_laybuy_max_deposit')) {
			$data['payment_laybuy_max_deposit'] = config::get('payment_laybuy_max_deposit');
		} else {
			$data['payment_laybuy_max_deposit'] = '50';
		}

		if (isset(request::$post['payment_laybuy_max_months'])) {
			$data['payment_laybuy_max_months'] = request::$post['payment_laybuy_max_months'];
		} elseif (config::get('payment_laybuy_max_months')) {
			$data['payment_laybuy_max_months'] = config::get('payment_laybuy_max_months');
		} else {
			$data['payment_laybuy_max_months'] = '3';
		}

		if (isset(request::$post['payment_laybuy_category'])) {
			$data['payment_laybuy_category'] = request::$post['payment_laybuy_category'];
		} elseif (config::get('payment_laybuy_category')) {
			$data['payment_laybuy_category'] = config::get('payment_laybuy_category');
		} else {
			$data['payment_laybuy_category'] = array();
		}

		$data['categories'] = array();


		foreach ($data['payment_laybuy_category'] as $category_id) {
			$category_info = admin_catalog_category::getCategory($category_id);

			if ($category_info) {
				$data['categories'][] = array(
					'category_id' 	=> $category_info['category_id'],
					'name' 			=> ($category_info['path']) ? $category_info['path'] . ' &gt; ' . $category_info['name'] : $category_info['name']
				);
			}
		}

		if (isset(request::$post['payment_laybuy_xproducts'])) {
			$data['payment_laybuy_xproducts'] = request::$post['payment_laybuy_xproducts'];
		} else {
			$data['payment_laybuy_xproducts'] = config::get('payment_laybuy_xproducts');
		}

		if (isset(request::$post['payment_laybuy_customer_group'])) {
			$data['payment_laybuy_customer_group'] = request::$post['payment_laybuy_customer_group'];
		} elseif (config::get('payment_laybuy_customer_group')) {
			$data['payment_laybuy_customer_group'] = config::get('payment_laybuy_customer_group');
		} else {
			$data['payment_laybuy_customer_group'] = array();
		}

		$data['customer_groups'] = array();


		foreach ($data['payment_laybuy_customer_group'] as $customer_group_id) {
			$customer_group_info = admin_customer_customer_group::getCustomerGroup($customer_group_id);

			if ($customer_group_info) {
				$data['customer_groups'][] = array(
					'customer_group_id' => $customer_group_info['customer_group_id'],
					'name'				=> $customer_group_info['name']
				);
			}
		}

		if (isset(request::$post['payment_laybuy_logging'])) {
			$data['payment_laybuy_logging'] = request::$post['payment_laybuy_logging'];
		} else {
			$data['payment_laybuy_logging'] = config::get('payment_laybuy_logging');
		}

		if (isset(request::$post['payment_laybuy_total'])) {
			$data['payment_laybuy_total'] = request::$post['payment_laybuy_total'];
		} else {
			$data['payment_laybuy_total'] = config::get('payment_laybuy_total');
		}

		if (isset(request::$post['payment_laybuy_order_status_id_pending'])) {
			$data['payment_laybuy_order_status_id_pending'] = request::$post['payment_laybuy_order_status_id_pending'];
		} elseif (config::get('payment_laybuy_order_status_id_pending')) {
			$data['payment_laybuy_order_status_id_pending'] = config::get('payment_laybuy_order_status_id_pending');
		} else {
			$data['payment_laybuy_order_status_id_pending'] = '1';
		}

		if (isset(request::$post['payment_laybuy_order_status_id_canceled'])) {
			$data['payment_laybuy_order_status_id_canceled'] = request::$post['payment_laybuy_order_status_id_canceled'];
		} elseif (config::get('payment_laybuy_order_status_id_canceled')) {
			$data['payment_laybuy_order_status_id_canceled'] = config::get('payment_laybuy_order_status_id_canceled');
		} else {
			$data['payment_laybuy_order_status_id_canceled'] = '7';
		}

		if (isset(request::$post['payment_laybuy_order_status_id_processing'])) {
			$data['payment_laybuy_order_status_id_processing'] = request::$post['payment_laybuy_order_status_id_processing'];
		} elseif (config::get('payment_laybuy_order_status_id_processing')) {
			$data['payment_laybuy_order_status_id_processing'] = config::get('payment_laybuy_order_status_id_processing');
		} else {
			$data['payment_laybuy_order_status_id_processing'] = '2';
		}

		if (isset(request::$post['payment_laybuy_gateway_url'])) {
			$data['payment_laybuy_gateway_url'] = request::$post['payment_laybuy_gateway_url'];
		} elseif (config::get('payment_laybuy_gateway_url')) {
			$data['payment_laybuy_gateway_url'] = config::get('payment_laybuy_gateway_url');
		} else {
			$data['payment_laybuy_gateway_url'] = 'http://lay-buys.com/gateway/';
		}

		if (isset(request::$post['payment_laybuy_api_url'])) {
			$data['payment_laybuy_api_url'] = request::$post['payment_laybuy_api_url'];
		} elseif (config::get('payment_laybuy_api_url')) {
			$data['payment_laybuy_api_url'] = config::get('payment_laybuy_api_url');
		} else {
			$data['payment_laybuy_api_url'] = 'https://lay-buys.com/report/';
		}

		if (isset(request::$post['payment_laybuy_geo_zone_id'])) {
			$data['payment_laybuy_geo_zone_id'] = request::$post['payment_laybuy_geo_zone_id'];
		} else {
			$data['payment_laybuy_geo_zone_id'] = config::get('payment_laybuy_geo_zone_id');
		}

		if (isset(request::$post['payment_laybuy_status'])) {
			$data['payment_laybuy_status'] = request::$post['payment_laybuy_status'];
		} else {
			$data['payment_laybuy_status'] = config::get('payment_laybuy_status');
		}

		if (isset(request::$post['payment_laybuy_sort_order'])) {
			$data['payment_laybuy_sort_order'] = request::$post['payment_laybuy_sort_order'];
		} else {
			$data['payment_laybuy_sort_order'] = config::get('payment_laybuy_sort_order');
		}

		$data['laybuy_cron_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/laybuy/cron&token=' . $data['payment_laybuy_token'];

		if (config::get('laybuy_cron_time')) {
			$data['laybuy_cron_time'] = date(language::get('datetime_format'), strtotime(config::get('laybuy_cron_time')));
		} else {
			$data['laybuy_cron_time'] = language::get('text_no_cron_time');
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['laybuys_membership_id'])) {
			$data['error_laybuys_membership_id'] = self::$error['laybuys_membership_id'];
		} else {
			$data['error_laybuys_membership_id'] = '';
		}

		if (isset(self::$error['laybuy_token'])) {
			$data['error_laybuy_token'] = self::$error['laybuy_token'];
		} else {
			$data['error_laybuy_token'] = '';
		}

		if (isset(self::$error['laybuy_min_deposit'])) {
			$data['error_laybuy_min_deposit'] = self::$error['laybuy_min_deposit'];
		} else {
			$data['error_laybuy_min_deposit'] = '';
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		/* Reports tab */
		if (isset(request::$get['filter_order_id'])) {
			$filter_order_id = request::$get['filter_order_id'];
		} else {
			$filter_order_id = '';
		}

		if (isset(request::$get['filter_customer'])) {
			$filter_customer = request::$get['filter_customer'];
		} else {
			$filter_customer = '';
		}

		if (isset(request::$get['filter_dp_percent'])) {
			$filter_dp_percent = request::$get['filter_dp_percent'];
		} else {
			$filter_dp_percent = '';
		}

		if (isset(request::$get['filter_months'])) {
			$filter_months = request::$get['filter_months'];
		} else {
			$filter_months = '';
		}

		if (isset(request::$get['filter_status'])) {
			$filter_status = request::$get['filter_status'];
		} else {
			$filter_status = '';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'lt.order_id';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'DESC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$data['reports'] = array();

		$filter_data = array(
			'filter_order_id'	=> $filter_order_id,
			'filter_customer'	=> $filter_customer,
			'filter_dp_percent'	=> $filter_dp_percent,
			'filter_months'		=> $filter_months,
			'filter_status'		=> $filter_status,
			'filter_date_added'	=> $filter_date_added,
			'sort'				=> $sort,
			'order'				=> $order,
			'start'				=> ($page - 1) * config('limit_admin'),
			'limit'				=> config('limit_admin')
		);

		$report_total = admin_extension_payment_laybuy::getTotalTransactions($filter_data);

		$results = admin_extension_payment_laybuy::getTransactions($filter_data);

		foreach ($results as $result) {
			$customer_url = false;

			$customer_id = admin_extension_payment_laybuy::getCustomerIdByOrderId($result['order_id']);

			if ($customer_id) {
				$customer_url = url::link('customer/customer/edit', '&customer_id=' . (int)$customer_id);
			}

			$data['reports'][] = array(
				'id'			=> $result['laybuy_transaction_id'],
				'order_id'		=> $result['order_id'],
				'order_url'		=> url::link('sale/order/info', '&order_id=' . (int)$result['order_id']),
				'customer_name'	=> $result['firstname'] . ' ' . $result['lastname'],
				'customer_url'	=> $customer_url,
				'amount'		=> currency::format($result['amount'], $result['currency']),
				'dp_percent'	=> $result['downpayment'],
				'months'		=> $result['months'],
				'dp_amount'		=> currency::format($result['downpayment_amount'], $result['currency']),
				'first_payment'	=> date(language::get('date_format_short'), strtotime($result['first_payment_due'])),
				'last_payment'	=> date(language::get('date_format_short'), strtotime($result['last_payment_due'])),
				'status'		=> admin_extension_payment_laybuy::getStatusLabel($result['status']),
				'date_added'	=> date(language::get('date_format_short'), strtotime($result['date_added'])),
				'view'			=> url::link('extension/payment/laybuy/transaction', '&id=' . (int)$result['laybuy_transaction_id'])
			);
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . urlencode(html_entity_decode(request::$get['filter_order_id'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_dp_percent'])) {
			$url .= '&filter_dp_percent=' . urlencode(html_entity_decode(request::$get['filter_dp_percent'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_months'])) {
			$url .= '&filter_months=' . request::$get['filter_months'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_order_id'] = url::link('extension/payment/laybuy', '&sort=lt.order_id' . $url . '#reportstab');
		$data['sort_customer'] = url::link('extension/payment/laybuy', '&sort=customer' . $url . '#reportstab');
		$data['sort_amount'] = url::link('extension/payment/laybuy', '&sort=lt.amount' . $url . '#reportstab');
		$data['sort_dp_percent'] = url::link('extension/payment/laybuy', '&sort=lt.downpayment' . $url . '#reportstab');
		$data['sort_months'] = url::link('extension/payment/laybuy', '&sort=lt.months' . $url . '#reportstab');
		$data['sort_dp_amount'] = url::link('extension/payment/laybuy', '&sort=lt.downpayment_amount' . $url . '#reportstab');
		$data['sort_first_payment'] = url::link('extension/payment/laybuy', '&sort=lt.first_payment_due' . $url . '#reportstab');
		$data['sort_last_payment'] = url::link('extension/payment/laybuy', '&sort=lt.last_payment_due' . $url . '#reportstab');
		$data['sort_status'] = url::link('extension/payment/laybuy', '&sort=lt.status' . $url . '#reportstab');
		$data['sort_date_added'] = url::link('extension/payment/laybuy', '&sort=lt.date_added' . $url . '#reportstab');

		$url = '';

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . request::$get['filter_customer'];
		}

		if (isset(request::$get['filter_dp_percent'])) {
			$url .= '&filter_dp_percent=' . request::$get['filter_dp_percent'];
		}

		if (isset(request::$get['filter_months'])) {
			$url .= '&filter_months=' . request::$get['filter_months'];
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $report_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('extension/payment/laybuy', $url . '&page={page}#reportstab');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($report_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($report_total - config('limit_admin'))) ? $report_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $report_total, ceil($report_total / config('limit_admin')));

		$data['filter_order_id']	= $filter_order_id;
		$data['filter_customer']	= $filter_customer;
		$data['filter_dp_percent']	= $filter_dp_percent;
		$data['filter_months']		= $filter_months;
		$data['filter_status']		= $filter_status;
		$data['filter_date_added']	= $filter_date_added;

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['transaction_statuses'] = admin_extension_payment_laybuy::getTransactionStatuses();
		/* End of Reports Tab */


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}
		
		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/laybuy', $data));
	}

	public static function fetch() {

		admin_extension_payment_laybuy::log('Fetching transactions');

		if (user::hasPermission('modify', 'extension/payment/laybuy')) {
			load::language('extension/payment/laybuy');

			$json = array();

			$fetched = 0;

			$paypal_profile_id_array = admin_extension_payment_laybuy::getPayPalProfileIds();

			if ($paypal_profile_id_array) {
				$paypal_profile_ids = '';

				foreach ($paypal_profile_id_array as $profile_id) {
					$paypal_profile_ids .= $profile_id['paypal_profile_id'] . ',';
				}

				$paypal_profile_ids = rtrim($paypal_profile_ids, ',');

				$data_string = 'mid=' . config::get('payment_laybuys_membership_id') . '&' . 'profileIds=' . $paypal_profile_ids;

				admin_extension_payment_laybuy::log('Data String: ' . $data_string);

				admin_extension_payment_laybuy::log('API URL: ' . config::get('payment_laybuy_api_url'));

				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, config::get('payment_laybuy_api_url'));
				curl_setopt($ch, CURLOPT_POST, true);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_HEADER, false);
				curl_setopt($ch, CURLOPT_TIMEOUT, 30);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				$result = curl_exec($ch);
				if (curl_errno($ch)) {
					admin_extension_payment_laybuy::log('cURL error: ' . curl_errno($ch));
				}
				curl_close($ch);

				$results = json_decode($result, true);

				admin_extension_payment_laybuy::log('Response: ' . print_r($results, true));

				if ($results) {
					foreach ($results as $laybuy_ref_id => $reports) {
						$status = $reports['status'];

						$report = $reports['report'];

						$transaction = array();

						$transaction = admin_extension_payment_laybuy::getTransactionByLayBuyRefId($laybuy_ref_id);

						$order_id = $transaction['order_id'];

						$paypal_profile_id = $transaction['paypal_profile_id'];

						$months = $transaction['months'];

						$report_content = array();

						$pending_flag = false;

						$next_payment_status = language::get('text_status_1');

						foreach ($report as $month => $payment) {
							$payment['paymentDate'] = date('Y-m-d h:i:s', strtotime(str_replace('/', '-', $payment['paymentDate'])));
							$date = date(language::get('date_format_short'), strtotime($payment['paymentDate']));
							$next_payment_date = $payment['paymentDate'];

							if ($payment['type'] == 'd') {
								$report_content[] = array(
									'instalment'	=> 0,
									'amount'		=> currency::format($payment['amount'], $transaction['currency']),
									'date'			=> $date,
									'pp_trans_id'	=> $payment['txnID'],
									'status'		=> $payment['paymentStatus']
								);
							} elseif ($payment['type'] == 'p') {
								$pending_flag = true;

								$report_content[] = array(
									'instalment'	=> $month,
									'amount'		=> currency::format($payment['amount'], $transaction['currency']),
									'date'			=> $date,
									'pp_trans_id'	=> $payment['txnID'],
									'status'		=> $payment['paymentStatus']
								);

								$next_payment_status = $payment['paymentStatus'];
							}
						}

						if ($pending_flag) {
							$start_index = $month + 1;
						} else {
							$start_index = $month + 2;
						}

						if ($month < $months) {
							for ($month = 1; $month <= $months; $month++) {
								$next_payment_date = date("Y-m-d h:i:s", strtotime($next_payment_date . " +1 month"));
								$date = date(language::get('date_format_short'), strtotime($next_payment_date));

								$report_content[] = array(
									'instalment'	=> $month,
									'amount'		=> currency::format($transaction['payment_amounts'], $transaction['currency']),
									'date'			=> $date,
									'pp_trans_id'	=> '',
									'status'		=> $next_payment_status
								);
							}
						}

						$report_content = json_encode($report_content);

						switch ($status) {
							case -1: // Cancel
								admin_extension_payment_laybuy::log('Transaction #' . $transaction['laybuy_transaction_id'] . ' canceled');
								admin_extension_payment_laybuy::updateOrderStatus($order_id, config::get('payment_laybuy_order_status_id_canceled'), language::get('text_comment'));
								admin_extension_payment_laybuy::updateTransaction($transaction['laybuy_transaction_id'], '7', $report_content, $start_index);
								$fetched++;
								break;
							case 0: // Pending
								admin_extension_payment_laybuy::log('Transaction #' . $transaction['laybuy_transaction_id'] . ' still pending');
								admin_extension_payment_laybuy::updateTransaction($transaction['laybuy_transaction_id'], $transaction['status'], $report_content, $start_index);
								$fetched++;
								break;
							case 1: // Paid
								admin_extension_payment_laybuy::log('Transaction #' . $transaction['laybuy_transaction_id'] . ' paid');
								admin_extension_payment_laybuy::updateOrderStatus($order_id, config::get('payment_laybuy_order_status_id_processing'), language::get('text_comment'));
								admin_extension_payment_laybuy::updateTransaction($transaction['laybuy_transaction_id'], '5', $report_content, $start_index);
								$fetched++;
								break;
						}
					}
				}

				if ($fetched) {
					session::$data['success'] = sprintf(language::get('text_fetched_some'), $fetched);
				} else {
					session::$data['success'] = language::get('text_fetched_none');
				}

				response::redirect(url::link('extension/payment/laybuy'));
			} else {
				admin_extension_payment_laybuy::log('No PayPal Profile IDs to update');

				session::$data['success'] = language::get('text_fetched_none');

				response::redirect(url::link('extension/payment/laybuy'));
			}
		} else {
			admin_extension_payment_laybuy::log('User does not have permission');
		}
	}

	public static function install() {
		if (user::hasPermission('modify', 'marketplace/extension')) {

			admin_extension_payment_laybuy::install();
		}
	}

	public static function uninstall() {
		if (user::hasPermission('modify', 'marketplace/extension')) {

			admin_extension_payment_laybuy::uninstall();
		}
	}

	public static function transaction($order_page = false) {

		load::language('extension/payment/laybuy');

		if (isset(request::$get['id'])) {
			$id = (int)request::$get['id'];
		} else {
			$id = 0;
		}

		$data['id'] = $id;

		if (!$order_page) {
			document::setTitle(language::get('heading_transaction_title'));
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/laybuy', '#reportstab')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_transaction_title'),
			'href' => url::link('extension/payment/laybuy/transaction', '&id=' . $id)
		);

		$data['heading_title'] = language::get('heading_transaction_title');

		$data['button_cancel'] = language::get('button_cancel');

		$data['cancel'] = url::link('extension/payment/laybuy', '#reportstab');

		$transaction_info = admin_extension_payment_laybuy::getTransaction($id);

		if ($transaction_info) {
			$data['initial_payments'] = admin_extension_payment_laybuy::getInitialPayments();

			$data['months'] = admin_extension_payment_laybuy::getMonths();

			$data['currency_symbol_left'] = currency::getSymbolLeft($transaction_info['currency']);

			$data['currency_symbol_right'] = currency::getSymbolRight($transaction_info['currency']);

			$data['store_url'] = HTTPS_CATALOG;

			$data['api_key'] = self::getApiKey();


			$order = admin_sale_order::getOrder($transaction_info['order_id']);

			$data['order_info'] = array(
				'currency_value' => $order['currency_value']
			);

			$data['total'] = admin_extension_payment_laybuy::getRemainingAmount($transaction_info['amount'], $transaction_info['downpayment_amount'], $transaction_info['payment_amounts'], $transaction_info['transaction']);

			$data['transaction'] = array(
				'paypal_profile_id'  => $transaction_info['paypal_profile_id'],
				'laybuy_ref_no' 	 => $transaction_info['laybuy_ref_no'],
				'order_id'        	 => $transaction_info['order_id'],
				'firstname'          => $transaction_info['firstname'],
				'lastname'           => $transaction_info['lastname'],
				'email'	  			 => $transaction_info['email'],
				'address'	  		 => $transaction_info['address'],
				'suburb'			 => $transaction_info['suburb'],
				'state'				 => $transaction_info['state'],
				'country' 			 => $transaction_info['country'],
				'postcode'  		 => $transaction_info['postcode'],
				'status_id'			 => $transaction_info['status'],
				'status'          	 => admin_extension_payment_laybuy::getStatusLabel($transaction_info['status']),
				'amount'          	 => currency::format($transaction_info['amount'], $transaction_info['currency']),
				'remaining'        	 => currency::format(admin_extension_payment_laybuy::getRemainingAmount($transaction_info['amount'], $transaction_info['downpayment_amount'], $transaction_info['payment_amounts'], $transaction_info['transaction']), $transaction_info['currency']),
				'downpayment'	  	 => $transaction_info['downpayment'],
				'months'	  		 => $transaction_info['months'],
				'downpayment_amount' => currency::format($transaction_info['downpayment_amount'], $transaction_info['currency']),
				'payment_amounts'	 => currency::format($transaction_info['payment_amounts'], $transaction_info['currency']),
				'first_payment_due'  => date(language::get('date_format_short'), strtotime($transaction_info['first_payment_due'])),
				'last_payment_due'   => date(language::get('date_format_short'), strtotime($transaction_info['last_payment_due'])),
				'report'        	 => json_decode($transaction_info['report'], true)
			);
		} else {
			$data['transaction'] = array();

			$data['text_not_found'] = language::get('text_not_found');
		}


		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(session::$data['error_warning'])) {
			$data['error_warning'] = session::$data['error_warning'];

			unset(session::$data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		if ($order_page) {
			return $data;
		}

		response::setOutput(load::view('extension/payment/laybuy_transaction', $data));
	}

	public static function cancel() {

		admin_extension_payment_laybuy::log('Canceling transaction');

		if (request::$get['source'] == 'order') {
			admin_extension_payment_laybuy::log('Called from order page');
		} else {
			admin_extension_payment_laybuy::log('Called from extension page');
		}

		if (user::hasPermission('modify', 'extension/payment/laybuy')) {
			load::language('extension/payment/laybuy');

			$json = array();

			$id = (int)request::$get['id'];

			$transaction_info = admin_extension_payment_laybuy::getTransaction($id);

			$cancel = false;

			if (!$transaction_info['paypal_profile_id']) {
				admin_extension_payment_laybuy::log('Transaction has no paypal_profile_id');

				$cancel = true;
			}

			if (!$cancel) {
				$data_string = 'mid=' . config::get('payment_laybuys_membership_id') . '&' . 'paypal_profile_id=' . $transaction_info['paypal_profile_id'];

				admin_extension_payment_laybuy::log('Data String: ' . $data_string);

				$ch = curl_init();
				$url = 'https://lay-buys.com/vtmob/deal5cancel.php';
				curl_setopt($ch, CURLOPT_URL, $url);
				curl_setopt($ch, CURLOPT_POST, true);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_HEADER, false);
				curl_setopt($ch, CURLOPT_TIMEOUT, 30);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				$result = curl_exec($ch);
				if (curl_errno($ch)) {
					admin_extension_payment_laybuy::log('cURL error: ' . curl_errno($ch));
				}
				curl_close($ch);

				admin_extension_payment_laybuy::log('Response: ' . $result);

				if ($result == 'success') {
					admin_extension_payment_laybuy::log('Success');

					$cancel = true;
				} else {
					admin_extension_payment_laybuy::log('Failure');
				}
			}

			if ($cancel) {
				admin_extension_payment_laybuy::log('Transaction canceled');

				$report_content = json_decode($transaction_info['report'], true);

				foreach ($report_content as &$array) {
					$array['status'] = str_replace('Pending', 'Canceled', $array['status']);
				}

				$report_content = json_encode($report_content);

				admin_extension_payment_laybuy::updateTransaction($transaction_info['laybuy_transaction_id'], '7', $report_content, $transaction_info['transaction']);

				$json['success'] = language::get('text_cancel_success');

				$json['order_id'] = $transaction_info['order_id'];

				$json['order_status_id'] = config::get('payment_laybuy_order_status_id_canceled');

				$json['comment'] = sprintf(language::get('text_comment_canceled'), $transaction_info['paypal_profile_id']);
			} else {
				$json['error'] = language::get('text_cancel_failure');
			}

			if (request::$get['source'] == 'order') {
				$json['reload'] = url::link('sale/order/info', 'order_id=' . (int)$transaction_info['order_id'] . '&user_token=' . session::$data['user_token']);
			} else {
				$json['reload'] = url::link('extension/payment/laybuy/transaction', '&id=' . $id);
			}

			response::setOutput(json_encode($json));
		} else {
			admin_extension_payment_laybuy::log('User does not have permission');
		}
	}

	public static function revise() {

		admin_extension_payment_laybuy::log('Revising transaction');

		if (request::$get['source'] == 'order') {
			admin_extension_payment_laybuy::log('Called from order page');
		} else {
			admin_extension_payment_laybuy::log('Called from extension page');
		}

		if (user::hasPermission('modify', 'extension/payment/laybuy')) {
			if (request::$server['REQUEST_METHOD'] == 'POST') {
				load::language('extension/payment/laybuy');

				$json = array();

				$payment_type = request::$post['payment_type'];

				$amount = request::$post['amount'];

				$initial = request::$post['INIT'];

				$months = request::$post['MONTHS'];

				$id = request::$get['id'];

				$transaction_info = admin_extension_payment_laybuy::getTransaction($id);

				$original = $new = $transaction_info;

				$original['transaction_id'] = $new['transaction_id'] = $transaction_info['laybuy_transaction_id'];

				$original['payment_type'] = $new['payment_type'] = $payment_type;

				$original['type'] = 'Original';

				$new['type'] = 'New';
				$new['status'] = '50';
				$new['amount'] = $amount;
				$new['downpayment'] = $initial;
				$new['months'] = $months;

				$collection = admin_extension_payment_laybuy::getRevisedTransactions($id);

				admin_extension_payment_laybuy::log('Collection: ' . print_r($collection, true));

				if (count($collection) == 2) {
					admin_extension_payment_laybuy::log('Collection == 2');

					foreach ($collection as $request) {
						admin_extension_payment_laybuy::log('request: ' . print_r($request, true));

						if ($request['type'] == 'Original') {
							admin_extension_payment_laybuy::log('Original: ' . print_r($original, true));

							admin_extension_payment_laybuy::updateRevisedTransaction($id, $original);
						} elseif ($request['type'] == 'New') {
							admin_extension_payment_laybuy::log('New: ' . print_r($new, true));

							admin_extension_payment_laybuy::updateRevisedTransaction($id, $new);

							$revised_transaction = admin_extension_payment_laybuy::getRevisedTransaction($id);
						}
					}
				} else {
					admin_extension_payment_laybuy::log('Collection != 2');

					admin_extension_payment_laybuy::addRevisedTransaction($original);

					$laybuy_revise_request_id = admin_extension_payment_laybuy::addRevisedTransaction($new);

					admin_extension_payment_laybuy::log('$laybuy_revise_request_id: ' . $laybuy_revise_request_id);

					$revised_transaction = admin_extension_payment_laybuy::getRevisedTransaction($laybuy_revise_request_id);
				}

				admin_extension_payment_laybuy::log('Revised transaction: ' . print_r($revised_transaction, true));

				if ($revised_transaction['payment_type'] == '1') {
					$pp = '1';
					$pplan = '1';
				} else {
					$pp = '0';
					$pplan = '0';
				}

				$data = array();

				$data['mid']       = config::get('payment_laybuys_membership_id');
				$data['eml']       = $revised_transaction['email'];
				$data['prc']       = $revised_transaction['amount'];
				$data['curr']      = $revised_transaction['currency'];
				$data['pp']        = $pp;
				$data['pplan']     = $pplan;
				$data['init']      = $initial;
				$data['mnth']      = $months;
				$data['convrate']  = '1';
				$data['id']        = $revised_transaction['laybuy_revise_request_id'] . '-' . $revised_transaction['order_id'] . ':' . md5(config::get('payment_laybuy_token'));
				$data['RETURNURL'] = HTTPS_CATALOG . 'index.php?route=extension/payment/laybuy/reviseCallback';
				$data['CANCELURL'] = HTTPS_CATALOG . 'index.php?route=extension/payment/laybuy/reviseCancel';

				$data_string = '';

				foreach ($data as $param => $value) {
					$data_string .= $param . '=' . $value . '&';
				}

				$data_string = rtrim($data_string, '&');

				admin_extension_payment_laybuy::log('Data String: ' . $data_string);

				$ch = curl_init();
				$url = 'https://lay-buys.com/vtmob/deal5.php';
				curl_setopt($ch, CURLOPT_URL, $url);
				curl_setopt($ch, CURLOPT_POST, true);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_HEADER, false);
				curl_setopt($ch, CURLOPT_TIMEOUT, 30);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				$result = curl_exec($ch);
				if (curl_errno($ch)) {
					admin_extension_payment_laybuy::log('cURL error: ' . curl_errno($ch));
				}
				curl_close($ch);

				if ($result == 'success') {
					admin_extension_payment_laybuy::log('Success');

					admin_extension_payment_laybuy::updateTransactionStatus($id, '50');

					$json['success'] = language::get('text_revise_success');
				} else {
					admin_extension_payment_laybuy::log('Failure');

					admin_extension_payment_laybuy::log('Response: ' . print_r($result, true));

					$json['error'] = language::get('text_revise_failure');
				}

				if (request::$get['source'] == 'order') {
					$json['reload'] = url::link('sale/order/info', 'order_id=' . (int)$transaction_info['order_id'] . '&user_token=' . session::$data['user_token']);
				} else {
					$json['reload'] = url::link('extension/payment/laybuy/transaction', '&id=' . $id);
				}

				response::setOutput(json_encode($json));
			} else {
				admin_extension_payment_laybuy::log('No $_POST data');
			}
		} else {
			admin_extension_payment_laybuy::log('User does not have permission');
		}
	}

	public static function autocomplete() {
		$json = array();

		if (isset(request::$get['filter_customer_group'])) {

			$results = admin_customer_customer_group::getCustomerGroups();

			foreach ($results as $result) {
				$json[] = array(
					'customer_group_id' => $result['customer_group_id'],
					'name'       		=> strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8'))
				);
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function order() {
		if (config::get('payment_laybuy_status')) {

			load::language('extension/payment/laybuy');

			$order_id = request::$get['order_id'];

			$transaction_info = admin_extension_payment_laybuy::getTransactionByOrderId($order_id);

			$laybuy_transaction_id = $transaction_info['laybuy_transaction_id'];

			request::$get['id'] = $laybuy_transaction_id;

			$data = self::transaction(true);

			$data['store_url'] = HTTPS_CATALOG;

			$data['api_key'] = self::getApiKey();

			return load::view('extension/payment/laybuy_order', $data);
		}
	}

	private static function getApiKey() {

		admin_extension_payment_laybuy::log('Getting API key');


		$api_info = admin_user_api::getApi(config('api_id'));

		if ($api_info) {
			admin_extension_payment_laybuy::log('API key: ' . $api_info['key']);

			return $api_info['key'];
		} else {
			admin_extension_payment_laybuy::log('No API info');

			return;
		}
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/laybuy')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_laybuys_membership_id']) {
			self::$error['laybuys_membership_id'] = language::get('error_membership_id');
		}

		if (!request::$post['payment_laybuy_token']) {
			self::$error['laybuy_token'] = language::get('error_token');
		}

		if (request::$post['payment_laybuy_min_deposit'] > request::$post['payment_laybuy_max_deposit']) {
			self::$error['laybuy_min_deposit'] = language::get('error_min_deposit');
		}

		return !self::$error;
	}
}
