<?php
class ControllerExtensionPaymentLiqPay {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/liqpay');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_liqpay', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['merchant'])) {
			$data['error_merchant'] = self::$error['merchant'];
		} else {
			$data['error_merchant'] = '';
		}

		if (isset(self::$error['signature'])) {
			$data['error_signature'] = self::$error['signature'];
		} else {
			$data['error_signature'] = '';
		}

		if (isset(self::$error['type'])) {
			$data['error_type'] = self::$error['type'];
		} else {
			$data['error_type'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/liqpay')
		);

		$data['action'] = url::link('extension/payment/liqpay');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_liqpay_merchant'])) {
			$data['payment_liqpay_merchant'] = request::$post['payment_liqpay_merchant'];
		} else {
			$data['payment_liqpay_merchant'] = config::get('payment_liqpay_merchant');
		}

		if (isset(request::$post['payment_liqpay_signature'])) {
			$data['payment_liqpay_signature'] = request::$post['payment_liqpay_signature'];
		} else {
			$data['payment_liqpay_signature'] = config::get('payment_liqpay_signature');
		}

		if (isset(request::$post['payment_liqpay_type'])) {
			$data['payment_liqpay_type'] = request::$post['payment_liqpay_type'];
		} else {
			$data['payment_liqpay_type'] = config::get('payment_liqpay_type');
		}

		if (isset(request::$post['payment_liqpay_total'])) {
			$data['payment_liqpay_total'] = request::$post['payment_liqpay_total'];
		} else {
			$data['payment_liqpay_total'] = config::get('payment_liqpay_total');
		}

		if (isset(request::$post['payment_liqpay_order_status_id'])) {
			$data['payment_liqpay_order_status_id'] = request::$post['payment_liqpay_order_status_id'];
		} else {
			$data['payment_liqpay_order_status_id'] = config::get('payment_liqpay_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_liqpay_geo_zone_id'])) {
			$data['payment_liqpay_geo_zone_id'] = request::$post['payment_liqpay_geo_zone_id'];
		} else {
			$data['payment_liqpay_geo_zone_id'] = config::get('payment_liqpay_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_liqpay_status'])) {
			$data['payment_liqpay_status'] = request::$post['payment_liqpay_status'];
		} else {
			$data['payment_liqpay_status'] = config::get('payment_liqpay_status');
		}

		if (isset(request::$post['payment_liqpay_sort_order'])) {
			$data['payment_liqpay_sort_order'] = request::$post['payment_liqpay_sort_order'];
		} else {
			$data['payment_liqpay_sort_order'] = config::get('payment_liqpay_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/liqpay', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/liqpay')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_liqpay_merchant']) {
			self::$error['merchant'] = language::get('error_merchant');
		}

		if (!request::$post['payment_liqpay_signature']) {
			self::$error['signature'] = language::get('error_signature');
		}

		return !self::$error;
	}
}