<?php
class ControllerExtensionPaymentNOCHEX {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/nochex');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_nochex', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['email'])) {
			$data['error_email'] = self::$error['email'];
		} else {
			$data['error_email'] = '';
		}

		if (isset(self::$error['merchant'])) {
			$data['error_merchant'] = self::$error['merchant'];
		} else {
			$data['error_merchant'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/nochex')
		);

		$data['action'] = url::link('extension/payment/nochex');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_nochex_email'])) {
			$data['payment_nochex_email'] = request::$post['payment_nochex_email'];
		} else {
			$data['payment_nochex_email'] = config::get('payment_nochex_email');
		}

		if (isset(request::$post['payment_nochex_account'])) {
			$data['payment_nochex_account'] = request::$post['payment_nochex_account'];
		} else {
			$data['payment_nochex_account'] = config::get('payment_nochex_account');
		}

		if (isset(request::$post['payment_nochex_merchant'])) {
			$data['payment_nochex_merchant'] = request::$post['payment_nochex_merchant'];
		} else {
			$data['payment_nochex_merchant'] = config::get('payment_nochex_merchant');
		}

		if (isset(request::$post['payment_nochex_template'])) {
			$data['payment_nochex_template'] = request::$post['payment_nochex_template'];
		} else {
			$data['payment_nochex_template'] = config::get('payment_nochex_template');
		}

		if (isset(request::$post['payment_nochex_test'])) {
			$data['payment_nochex_test'] = request::$post['payment_nochex_test'];
		} else {
			$data['payment_nochex_test'] = config::get('payment_nochex_test');
		}

		if (isset(request::$post['payment_nochex_total'])) {
			$data['payment_nochex_total'] = request::$post['payment_nochex_total'];
		} else {
			$data['payment_nochex_total'] = config::get('payment_nochex_total');
		}

		if (isset(request::$post['payment_nochex_order_status_id'])) {
			$data['payment_nochex_order_status_id'] = request::$post['payment_nochex_order_status_id'];
		} else {
			$data['payment_nochex_order_status_id'] = config::get('payment_nochex_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_nochex_geo_zone_id'])) {
			$data['payment_nochex_geo_zone_id'] = request::$post['payment_nochex_geo_zone_id'];
		} else {
			$data['payment_nochex_geo_zone_id'] = config::get('payment_nochex_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_nochex_status'])) {
			$data['payment_nochex_status'] = request::$post['payment_nochex_status'];
		} else {
			$data['payment_nochex_status'] = config::get('payment_nochex_status');
		}

		if (isset(request::$post['payment_nochex_sort_order'])) {
			$data['payment_nochex_sort_order'] = request::$post['payment_nochex_sort_order'];
		} else {
			$data['payment_nochex_sort_order'] = config::get('payment_nochex_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/nochex', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/nochex')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_nochex_email']) {
			self::$error['email'] = language::get('error_email');
		}

		if (!request::$post['payment_nochex_merchant']) {
			self::$error['merchant'] = language::get('error_merchant');
		}

		return !self::$error;
	}
}