<?php
class ControllerExtensionPaymentPayMate {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/paymate');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_paymate', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['username'])) {
			$data['error_username'] = self::$error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/paymate')
		);

		$data['action'] = url::link('extension/payment/paymate');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_paymate_username'])) {
			$data['payment_paymate_username'] = request::$post['payment_paymate_username'];
		} else {
			$data['payment_paymate_username'] = config::get('payment_paymate_username');
		}

		if (isset(request::$post['payment_paymate_password'])) {
			$data['payment_paymate_username'] = request::$post['payment_paymate_password'];
		} elseif (config::get('payment_paymate_password')) {
			$data['payment_paymate_password'] = config::get('payment_paymate_password');
		} else {
			$data['payment_paymate_password'] = token(32);
		}

		if (isset(request::$post['payment_paymate_test'])) {
			$data['payment_paymate_test'] = request::$post['payment_paymate_test'];
		} else {
			$data['payment_paymate_test'] = config::get('payment_paymate_test');
		}

		if (isset(request::$post['payment_paymate_total'])) {
			$data['payment_paymate_total'] = request::$post['payment_paymate_total'];
		} else {
			$data['payment_paymate_total'] = config::get('payment_paymate_total');
		}

		if (isset(request::$post['payment_paymate_order_status_id'])) {
			$data['payment_paymate_order_status_id'] = request::$post['payment_paymate_order_status_id'];
		} else {
			$data['payment_paymate_order_status_id'] = config::get('payment_paymate_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_paymate_geo_zone_id'])) {
			$data['payment_paymate_geo_zone_id'] = request::$post['payment_paymate_geo_zone_id'];
		} else {
			$data['payment_paymate_geo_zone_id'] = config::get('payment_paymate_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_paymate_status'])) {
			$data['payment_paymate_status'] = request::$post['payment_paymate_status'];
		} else {
			$data['payment_paymate_status'] = config::get('payment_paymate_status');
		}

		if (isset(request::$post['payment_paymate_sort_order'])) {
			$data['payment_paymate_sort_order'] = request::$post['payment_paymate_sort_order'];
		} else {
			$data['payment_paymate_sort_order'] = config::get('payment_paymate_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/paymate', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/paymate')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_paymate_username']) {
			self::$error['username'] = language::get('error_username');
		}

		if (!request::$post['payment_paymate_password']) {
			self::$error['password'] = language::get('error_password');
		}

		return !self::$error;
	}
}
