<?php
class ControllerExtensionPaymentPayPal {
	private static $error = array();
	
	public static function index() {
		load::language('extension/payment/paypal');

		document::setTitle(language::get('heading_title'));

				
		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_paypal', request::$post);
														
			session::$data['success'] = language::get('success_save');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}
			
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extensions'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/paypal')
		);
						
		$data['action'] = url::link('extension/payment/paypal');
		$data['cancel'] = url::link('marketplace/extension', '&type=payment');
		$data['partner_url'] = str_replace('&amp;', '%26', url::link('extension/payment/paypal'));
		$data['callback_url'] = str_replace('&amp;', '&', url::link('extension/payment/paypal/callback'));
		$data['configure_smart_button_url'] = url::link('extension/payment/paypal/configureSmartButton');
		
		if (isset(request::$server['HTTPS']) && ((request::$server['HTTPS'] == 'on') || (request::$server['HTTPS'] == '1'))) {
			$data['server'] = HTTPS_SERVER;
			$data['catalog'] = HTTPS_CATALOG;
		} else {
			$data['server'] = HTTP_SERVER;
			$data['catalog'] = HTTP_CATALOG;
		}
		
		// Setting 		
		$_config = new Config();
		$_config::load('paypal');
		
		$data['setting'] = $_config::get('paypal_setting');
					
		if (isset(session::$data['environment']) && isset(session::$data['authorization_code']) && isset(session::$data['shared_id']) && isset(session::$data['seller_nonce']) && isset(request::$get['merchantIdInPayPal'])) {						
			$environment = session::$data['environment'];
			
			require_once 'system/library/paypal/paypal.php';
			
			$paypal_info = array(
				'client_id' => session::$data['shared_id'],
				'environment' => $environment
			);
					
			$paypal = new PayPal($paypal_info);
			
			$token_info = array(
				'grant_type' => 'authorization_code',
				'code' => session::$data['authorization_code'],
				'code_verifier' => session::$data['seller_nonce']
			);
			
			$paypal::setAccessToken($token_info);
											
			$result = $paypal::getSellerCredentials($data['setting']['partner'][$environment]['partner_id']);
			
			if (isset($result['client_id']) && isset($result['client_secret'])) {
				$client_id = $result['client_id'];
				$secret = $result['client_secret'];
			}
						
			$webhook_info = array(
				'url' => $data['catalog'] . 'index.php?route=extension/payment/paypal/webhook',
				'event_types' => array(
					array('name' => 'PAYMENT.AUTHORIZATION.CREATED'),
					array('name' => 'PAYMENT.AUTHORIZATION.VOIDED'),
					array('name' => 'PAYMENT.CAPTURE.COMPLETED'),
					array('name' => 'PAYMENT.CAPTURE.DENIED'),
					array('name' => 'PAYMENT.CAPTURE.PENDING'),
					array('name' => 'PAYMENT.CAPTURE.REFUNDED'),
					array('name' => 'PAYMENT.CAPTURE.REVERSED'),
					array('name' => 'CHECKOUT.ORDER.COMPLETED'),
					array('name' => 'CHECKOUT.ORDER.APPROVED')
				)
			);
			
			$result = $paypal::createWebhook($webhook_info);
			
			$webhook_id = '';
		
			if (isset($result['id'])) {
				$webhook_id = $result['id'];
			}
		
			if ($paypal::hasErrors()) {
				$error_messages = array();
				
				$errors = $paypal::getErrors();
								
				foreach ($errors as $error) {
					if (isset($error['name']) && ($error['name'] == 'CURLE_OPERATION_TIMEOUTED')) {
						$error['message'] = language::get('error_timeout');
					}
					
					if (isset($error['details'][0]['description'])) {
						$error_messages[] = $error['details'][0]['description'];
					} else {
						$error_messages[] = $error['message'];
					}
					
					admin_extension_payment_paypal::log($error, $error['message']);
				}
				
				self::$error['warning'] = implode(' ', $error_messages);
			}
   			
			$merchant_id = request::$get['merchantIdInPayPal'];
						
			unset(session::$data['authorization_code']);
			unset(session::$data['shared_id']);
			unset(session::$data['seller_nonce']);
		}
		
		if (isset($environment)) {
			$data['environment'] = $environment;
		} elseif (isset(request::$post['payment_paypal_environment'])) {
			$data['environment'] = request::$post['payment_paypal_environment'];
		} elseif (config::get('payment_paypal_environment')) {
			$data['environment'] = config::get('payment_paypal_environment');
		} else {
			$data['environment'] = 'production';
		}
				
		$data['seller_nonce'] = self::token(50);
		
		$data['configure_url'] = array(
			'production' => array(
				'ppcp' => 'https://www.paypal.com/bizsignup/partner/entry?partnerId=' . $data['setting']['partner']['production']['partner_id'] . '&partnerClientId=' . $data['setting']['partner']['production']['client_id'] . '&features=PAYMENT,REFUND&product=ppcp&integrationType=FO&returnToPartnerUrl=' . $data['partner_url'] . '&displayMode=minibrowser&sellerNonce=' . $data['seller_nonce'],
				'express_checkout' => 'https://www.paypal.com/bizsignup/partner/entry?partnerId=' . $data['setting']['partner']['production']['partner_id'] . '&partnerClientId=' . $data['setting']['partner']['production']['client_id'] . '&features=PAYMENT,REFUND&product=EXPRESS_CHECKOUT&integrationType=FO&returnToPartnerUrl=' . $data['partner_url'] . '&displayMode=minibrowser&sellerNonce=' . $data['seller_nonce']
			),
			'sandbox' => array(
				'ppcp' => 'https://www.sandbox.paypal.com/bizsignup/partner/entry?partnerId=' . $data['setting']['partner']['sandbox']['partner_id'] . '&partnerClientId=' . $data['setting']['partner']['sandbox']['client_id'] . '&features=PAYMENT,REFUND&product=ppcp&integrationType=FO&returnToPartnerUrl=' . $data['partner_url'] . '&displayMode=minibrowser&sellerNonce=' . $data['seller_nonce'],
				'express_checkout' => 'https://www.sandbox.paypal.com/bizsignup/partner/entry?partnerId=' . $data['setting']['partner']['sandbox']['partner_id'] . '&partnerClientId=' . $data['setting']['partner']['sandbox']['client_id'] . '&features=PAYMENT,REFUND&product=EXPRESS_CHECKOUT&integrationType=FO&returnToPartnerUrl=' . $data['partner_url'] . '&displayMode=minibrowser&sellerNonce=' . $data['seller_nonce']
			)
		);
		
		$data['help_checkout_express'] = sprintf(language::get('help_checkout_express'), $data['configure_url'][$data['environment']]['express_checkout']);
		
		if (isset($client_id)) {
			$data['client_id'] = $client_id;
		} elseif (isset(request::$post['payment_paypal_client_id'])) {
			$data['client_id'] = request::$post['payment_paypal_client_id'];
		} else {
			$data['client_id'] = config::get('payment_paypal_client_id');
		}

		if (isset($secret)) {
			$data['secret'] = $secret;
		} elseif (isset(request::$post['payment_paypal_secret'])) {
			$data['secret'] = request::$post['payment_paypal_secret'];
		} else {
			$data['secret'] = config::get('payment_paypal_secret');
		}
		
		if (isset($merchant_id)) {
			$data['merchant_id'] = $merchant_id;
		} elseif (isset(request::$post['payment_paypal_merchant_id'])) {
			$data['merchant_id'] = request::$post['payment_paypal_merchant_id'];
		} else {
			$data['merchant_id'] = config::get('payment_paypal_merchant_id');
		}
		
		$data['text_connect'] = sprintf(language::get('text_connect'), $data['client_id'], $data['secret'], $data['merchant_id']);
		
		if (isset($webhook_id)) {
			$data['webhook_id'] = $webhook_id;
		} elseif (isset(request::$post['payment_paypal_webhook_id'])) {
			$data['webhook_id'] = request::$post['payment_paypal_webhook_id'];
		} else {
			$data['webhook_id'] = config::get('payment_paypal_webhook_id');
		}

		if (isset(request::$post['payment_paypal_debug'])) {
			$data['debug'] = request::$post['payment_paypal_debug'];
		} else {
			$data['debug'] = config::get('payment_paypal_debug');
		}
								
		if (isset(request::$post['payment_paypal_transaction_method'])) {
			$data['transaction_method'] = request::$post['payment_paypal_transaction_method'];
		} else {
			$data['transaction_method'] = config::get('payment_paypal_transaction_method');
		}

		if (isset(request::$post['payment_paypal_total'])) {
			$data['total'] = request::$post['payment_paypal_total'];
		} else {
			$data['total'] = config::get('payment_paypal_total');
		}
		

		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_paypal_geo_zone_id'])) {
			$data['geo_zone_id'] = request::$post['payment_paypal_geo_zone_id'];
		} else {
			$data['geo_zone_id'] = config::get('payment_paypal_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_paypal_status'])) {
			$data['status'] = request::$post['payment_paypal_status'];
		} else {
			$data['status'] = config::get('payment_paypal_status');
		}

		if (isset(request::$post['payment_paypal_sort_order'])) {
			$data['sort_order'] = request::$post['payment_paypal_sort_order'];
		} else {
			$data['sort_order'] = config::get('payment_paypal_sort_order');
		}
		
		if (isset(request::$post['payment_paypal_currency_code'])) {
			$data['currency_code'] = request::$post['payment_paypal_currency_code'];
		} else {
			$data['currency_code'] = config::get('payment_paypal_currency_code');
		}
		
		if (isset(request::$post['payment_paypal_currency_value'])) {
			$data['currency_value'] = request::$post['payment_paypal_currency_value'];
		} elseif (config::get('payment_paypal_currency_value')) {
			$data['currency_value'] = config::get('payment_paypal_currency_value');
		} else {
			$data['currency_value'] = '1';
		}
						
		if (isset(request::$post['payment_paypal_setting'])) {
			$data['setting'] = array_replace_recursive((array)$data['setting'], (array)request::$post['payment_paypal_setting']);
		} else {
			$data['setting'] = array_replace_recursive((array)$data['setting'], (array)config::get('payment_paypal_setting'));
		}
		
		if ($data['client_id'] && $data['secret']) {										
			require_once 'system/library/paypal/paypal.php';
			
			$paypal_info = array(
				'client_id' => $data['client_id'],
				'secret' => $data['secret'],
				'environment' => $data['environment']
			);
		
			$paypal = new PayPal($paypal_info);
			
			$token_info = array(
				'grant_type' => 'client_credentials'
			);	
				
			$paypal::setAccessToken($token_info);
		
			$data['client_token'] = $paypal::getClientToken();
									
			if ($paypal::hasErrors()) {
				$error_messages = array();
				
				$errors = $paypal::getErrors();
								
				foreach ($errors as $error) {
					if (isset($error['name']) && ($error['name'] == 'CURLE_OPERATION_TIMEOUTED')) {
						$error['message'] = language::get('error_timeout');
					}
					
					if (isset($error['details'][0]['description'])) {
						$error_messages[] = $error['details'][0]['description'];
					} else {
						$error_messages[] = $error['message'];
					}
					
					admin_extension_payment_paypal::log($error, $error['message']);
				}
				
				self::$error['warning'] = implode(' ', $error_messages);
			}
		}
		
		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}
					
		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/paypal', $data));
	}
		
	public static function callback() {
		if (isset(request::$post['environment']) && isset(request::$post['authorization_code']) && isset(request::$post['shared_id']) && isset(request::$post['seller_nonce'])) {
			session::$data['environment'] = request::$post['environment'];
			session::$data['authorization_code'] = request::$post['authorization_code'];
			session::$data['shared_id'] = request::$post['shared_id'];
			session::$data['seller_nonce'] = request::$post['seller_nonce'];
		}
		
		$data['error'] = self::$error;
				
		response::setOutput(json_encode($data));
    }
	
	public static function configureSmartButton() {
		
		admin_extension_payment_paypal::configureSmartButton();
		
		response::redirect(url::link('extension/module/paypal_smart_button'));
	}
				
	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/paypal')) {
			self::$error['warning'] = language::get('error_permission');
		}
				
		require_once 'system/library/paypal/paypal.php';
		
		$paypal_info = array(
			'client_id' => request::$post['payment_paypal_client_id'],
			'secret' => request::$post['payment_paypal_secret'],
			'environment' => request::$post['payment_paypal_environment']
		);
		
		$paypal = new PayPal($paypal_info);
		
		$token_info = array(
			'grant_type' => 'client_credentials'
		);	
							
		$paypal::setAccessToken($token_info);
				
		if ($paypal::hasErrors()) {
			$error_messages = array();
				
			$errors = $paypal::getErrors();
								
			foreach ($errors as $error) {
				if (isset($error['name']) && ($error['name'] == 'CURLE_OPERATION_TIMEOUTED')) {
					$error['message'] = language::get('error_timeout');
				}
				
				if (isset($error['details'][0]['description'])) {
					$error_messages[] = $error['details'][0]['description'];
				} else {
					$error_messages[] = $error['message'];
				}
					
				admin_extension_payment_paypal::log($error, $error['message']);
			}
				
			self::$error['warning'] = implode(' ', $error_messages);
		}
		
		return !self::$error;
	}
	
	private static function token($length = 32) {
		// Create random token
		$string = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
	
		$max = strlen($string) - 1;
	
		$token = '';
	
		for ($i = 0; $i < $length; $i++) {
			$token .= $string[mt_rand(0, $max)];
		}	
	
		return $token;
	}
}