<?php
class ControllerExtensionPaymentPayPoint {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/paypoint');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_paypoint', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['merchant'])) {
			$data['error_merchant'] = self::$error['merchant'];
		} else {
			$data['error_merchant'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/paypoint')
		);

		$data['action'] = url::link('extension/payment/paypoint');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_paypoint_merchant'])) {
			$data['payment_paypoint_merchant'] = request::$post['payment_paypoint_merchant'];
		} else {
			$data['payment_paypoint_merchant'] = config::get('payment_paypoint_merchant');
		}

		if (isset(request::$post['payment_paypoint_password'])) {
			$data['payment_paypoint_password'] = request::$post['payment_paypoint_password'];
		} else {
			$data['payment_paypoint_password'] = config::get('payment_paypoint_password');
		}

		if (isset(request::$post['payment_paypoint_test'])) {
			$data['payment_paypoint_test'] = request::$post['payment_paypoint_test'];
		} else {
			$data['payment_paypoint_test'] = config::get('payment_paypoint_test');
		}

		if (isset(request::$post['payment_paypoint_total'])) {
			$data['payment_paypoint_total'] = request::$post['payment_paypoint_total'];
		} else {
			$data['payment_paypoint_total'] = config::get('payment_paypoint_total');
		}

		if (isset(request::$post['payment_paypoint_order_status_id'])) {
			$data['payment_paypoint_order_status_id'] = request::$post['payment_paypoint_order_status_id'];
		} else {
			$data['payment_paypoint_order_status_id'] = config::get('payment_paypoint_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_paypoint_geo_zone_id'])) {
			$data['payment_paypoint_geo_zone_id'] = request::$post['payment_paypoint_geo_zone_id'];
		} else {
			$data['payment_paypoint_geo_zone_id'] = config::get('payment_paypoint_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_paypoint_status'])) {
			$data['payment_paypoint_status'] = request::$post['payment_paypoint_status'];
		} else {
			$data['payment_paypoint_status'] = config::get('payment_paypoint_status');
		}

		if (isset(request::$post['payment_paypoint_sort_order'])) {
			$data['payment_paypoint_sort_order'] = request::$post['payment_paypoint_sort_order'];
		} else {
			$data['payment_paypoint_sort_order'] = config::get('payment_paypoint_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/paypoint', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/paypoint')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_paypoint_merchant']) {
			self::$error['merchant'] = language::get('error_merchant');
		}

		return !self::$error;
	}
}