<?php
class ControllerExtensionPaymentPayza {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/payza');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_payza', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['merchant'])) {
			$data['error_merchant'] = self::$error['merchant'];
		} else {
			$data['error_merchant'] = '';
		}

		if (isset(self::$error['security'])) {
			$data['error_security'] = self::$error['security'];
		} else {
			$data['error_security'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/payza')
		);

		$data['action'] = url::link('extension/payment/payza');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_payza_merchant'])) {
			$data['payment_payza_merchant'] = request::$post['payment_payza_merchant'];
		} else {
			$data['payment_payza_merchant'] = config::get('payment_payza_merchant');
		}

		if (isset(request::$post['payment_payza_security'])) {
			$data['payment_payza_security'] = request::$post['payment_payza_security'];
		} else {
			$data['payment_payza_security'] = config::get('payment_payza_security');
		}

		$data['callback'] = HTTP_CATALOG . 'index.php?route=extension/payment/payza/callback';

		if (isset(request::$post['payment_payza_total'])) {
			$data['payment_payza_total'] = request::$post['payment_payza_total'];
		} else {
			$data['payment_payza_total'] = config::get('payment_payza_total');
		}

		if (isset(request::$post['payment_payza_order_status_id'])) {
			$data['payment_payza_order_status_id'] = request::$post['payment_payza_order_status_id'];
		} else {
			$data['payment_payza_order_status_id'] = config::get('payment_payza_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_payza_geo_zone_id'])) {
			$data['payment_payza_geo_zone_id'] = request::$post['payment_payza_geo_zone_id'];
		} else {
			$data['payment_payza_geo_zone_id'] = config::get('payment_payza_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_payza_status'])) {
			$data['payment_payza_status'] = request::$post['payment_payza_status'];
		} else {
			$data['payment_payza_status'] = config::get('payment_payza_status');
		}

		if (isset(request::$post['payment_payza_sort_order'])) {
			$data['payment_payza_sort_order'] = request::$post['payment_payza_sort_order'];
		} else {
			$data['payment_payza_sort_order'] = config::get('payment_payza_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/payza', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/payza')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_payza_merchant']) {
			self::$error['merchant'] = language::get('error_merchant');
		}

		if (!request::$post['payment_payza_security']) {
			self::$error['security'] = language::get('error_security');
		}

		return !self::$error;
	}
}