<?php
class ControllerExtensionPaymentPerpetualPayments {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/perpetual_payments');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_perpetual_payments', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['auth_id'])) {
			$data['error_auth_id'] = self::$error['auth_id'];
		} else {
			$data['error_auth_id'] = '';
		}

		if (isset(self::$error['auth_pass'])) {
			$data['error_auth_pass'] = self::$error['auth_pass'];
		} else {
			$data['error_auth_pass'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/perpetual_payments')
		);

		$data['action'] = url::link('extension/payment/perpetual_payments');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_perpetual_payments_auth_id'])) {
			$data['payment_perpetual_payments_auth_id'] = request::$post['payment_perpetual_payments_auth_id'];
		} else {
			$data['payment_perpetual_payments_auth_id'] = config::get('payment_perpetual_payments_auth_id');
		}

		if (isset(request::$post['payment_perpetual_payments_auth_pass'])) {
			$data['payment_perpetual_payments_auth_pass'] = request::$post['payment_perpetual_payments_auth_pass'];
		} else {
			$data['payment_perpetual_payments_auth_pass'] = config::get('payment_perpetual_payments_auth_pass');
		}

		if (isset(request::$post['payment_perpetual_payments_test'])) {
			$data['payment_perpetual_payments_test'] = request::$post['payment_perpetual_payments_test'];
		} else {
			$data['payment_perpetual_payments_test'] = config::get('payment_perpetual_payments_test');
		}

		if (isset(request::$post['payment_perpetual_payments_total'])) {
			$data['payment_perpetual_payments_total'] = request::$post['payment_perpetual_payments_total'];
		} else {
			$data['payment_perpetual_payments_total'] = config::get('payment_perpetual_payments_total');
		}

		if (isset(request::$post['payment_perpetual_payments_order_status_id'])) {
			$data['payment_perpetual_payments_order_status_id'] = request::$post['payment_perpetual_payments_order_status_id'];
		} else {
			$data['payment_perpetual_payments_order_status_id'] = config::get('payment_perpetual_payments_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_perpetual_payments_geo_zone_id'])) {
			$data['payment_perpetual_payments_geo_zone_id'] = request::$post['payment_perpetual_payments_geo_zone_id'];
		} else {
			$data['payment_perpetual_payments_geo_zone_id'] = config::get('payment_perpetual_payments_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_perpetual_payments_status'])) {
			$data['payment_perpetual_payments_status'] = request::$post['payment_perpetual_payments_status'];
		} else {
			$data['payment_perpetual_payments_status'] = config::get('payment_perpetual_payments_status');
		}

		if (isset(request::$post['payment_perpetual_payments_sort_order'])) {
			$data['payment_perpetual_payments_sort_order'] = request::$post['payment_perpetual_payments_sort_order'];
		} else {
			$data['payment_perpetual_payments_sort_order'] = config::get('payment_perpetual_payments_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/perpetual_payments', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/perpetual_payments')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_perpetual_payments_auth_id']) {
			self::$error['auth_id'] = language::get('error_auth_id');
		}

		if (!request::$post['payment_perpetual_payments_auth_pass']) {
			self::$error['auth_pass'] = language::get('error_auth_pass');
		}

		return !self::$error;
	}
}