<?php
class ControllerExtensionPaymentPilibaba {
	private static $error = array();

	public static function index() {


		load::language('extension/payment/pilibaba');

		document::setTitle(language::get('heading_title'));

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_pilibaba', request::$post);

			if (request::$post['payment_pilibaba_status']) {
				admin_extension_payment_pilibaba::enablePiliExpress();
			} else {
				admin_extension_payment_pilibaba::disablePiliExpress();
			}

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pilibaba')
		);

		$data['action'] = url::link('extension/payment/pilibaba');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_pilibaba_merchant_number'])) {
			$data['payment_pilibaba_merchant_number'] = request::$post['payment_pilibaba_merchant_number'];
		} else {
			$data['payment_pilibaba_merchant_number'] = config::get('payment_pilibaba_merchant_number');
		}

		if (isset(request::$post['payment_pilibaba_secret_key'])) {
			$data['payment_pilibaba_secret_key'] = request::$post['payment_pilibaba_secret_key'];
		} else {
			$data['payment_pilibaba_secret_key'] = config::get('payment_pilibaba_secret_key');
		}

		if (isset(request::$post['payment_pilibaba_environment'])) {
			$data['payment_pilibaba_environment'] = request::$post['payment_pilibaba_environment'];
		} else {
			$data['payment_pilibaba_environment'] = config::get('payment_pilibaba_environment');
		}

		if (isset(request::$post['payment_pilibaba_shipping_fee'])) {
			$data['payment_pilibaba_shipping_fee'] = request::$post['payment_pilibaba_shipping_fee'];
		} else {
			$data['payment_pilibaba_shipping_fee'] = config::get('payment_pilibaba_shipping_fee');
		}

		if (isset(request::$post['payment_pilibaba_order_status_id'])) {
			$data['payment_pilibaba_order_status_id'] = request::$post['payment_pilibaba_order_status_id'];
		} elseif (config::has('payment_pilibaba_order_status_id')) {
			$data['payment_pilibaba_order_status_id'] = config::get('payment_pilibaba_order_status_id');
		} else {
			$data['payment_pilibaba_order_status_id'] = '2';
		}

		if (isset(request::$post['payment_pilibaba_status'])) {
			$data['payment_pilibaba_status'] = request::$post['payment_pilibaba_status'];
		} else {
			$data['payment_pilibaba_status'] = config::get('payment_pilibaba_status');
		}

		if (isset(request::$post['payment_pilibaba_logging'])) {
			$data['payment_pilibaba_logging'] = request::$post['payment_pilibaba_logging'];
		} else {
			$data['payment_pilibaba_logging'] = config::get('payment_pilibaba_logging');
		}

		if (isset(request::$post['payment_pilibaba_sort_order'])) {
			$data['payment_pilibaba_sort_order'] = request::$post['payment_pilibaba_sort_order'];
		} else {
			$data['payment_pilibaba_sort_order'] = config::get('payment_pilibaba_sort_order');
		}

		if (isset(request::$post['payment_pilibaba_email_address'])) {
			$data['payment_pilibaba_email_address'] = request::$post['payment_pilibaba_email_address'];
		} elseif (config::has('payment_pilibaba_email_address')) {
			$data['payment_pilibaba_email_address'] = config::get('payment_pilibaba_email_address');
		} else {
			$data['payment_pilibaba_email_address'] = '';
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(self::$error['pilibaba_merchant_number'])) {
			$data['error_pilibaba_merchant_number'] = self::$error['pilibaba_merchant_number'];
		} else {
			$data['error_pilibaba_merchant_number'] = '';
		}

		if (isset(self::$error['pilibaba_secret_key'])) {
			$data['error_pilibaba_secret_key'] = self::$error['pilibaba_secret_key'];
		} else {
			$data['error_pilibaba_secret_key'] = '';
		}

		if (isset(self::$error['pilibaba_shipping_fee'])) {
			$data['error_pilibaba_shipping_fee'] = self::$error['pilibaba_shipping_fee'];
		} else {
			$data['error_pilibaba_shipping_fee'] = '';
		}

		if (isset($data['pilibaba_merchant_number']) && $data['pilibaba_merchant_number'] && isset($data['payment_pilibaba_secret_key']) && $data['payment_pilibaba_secret_key']) {
			$data['show_register'] = false;

			$data['currencies'] = $data['warehouses'] = $data['countries'] = array();
		} else {
			$data['show_register'] = true;

			$data['currencies'] = admin_extension_payment_pilibaba::getCurrencies();

			$data['warehouses'] = admin_extension_payment_pilibaba::getWarehouses();


			$data['countries'] = admin_localisation_country::getCountries();
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (config('weight_class_id') != '2') {
			$data['error_weight'] = sprintf(language::get('error_weight'), url::link('setting/setting'));
		} else {
			$data['error_weight'] = '';
		}

		if (config::has('payment_pilibaba_email_address') && config::get('payment_pilibaba_email_address')) {
			$data['notice_email'] = sprintf(language::get('text_email'), config::get('payment_pilibaba_email_address'));
		} else {
			$data['notice_email'] = '';
		}


		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pilibaba', $data));
	}

	public static function install() {
		if (user::hasPermission('modify', 'marketplace/extension')) {

			admin_extension_payment_pilibaba::install();
		}
	}

	public static function uninstall() {
		if (user::hasPermission('modify', 'marketplace/extension')) {

			admin_extension_payment_pilibaba::uninstall();
		}
	}

	public static function register() {
		load::language('extension/payment/pilibaba');

		$json = array();

		if (isset(request::$post['email_address']) && isset(request::$post['password']) && isset(request::$post['currency']) && isset(request::$post['warehouse']) && isset(request::$post['country']) && isset(request::$post['environment'])) {
			if (utf8_strlen(request::$post['email_address']) < 1) {
				$json['error'] = language::get('error_email_address');
			} else if (!filter_var(request::$post['email_address'], FILTER_VALIDATE_EMAIL)) {
				$json['error'] = language::get('error_email_invalid');
			} else if (utf8_strlen(request::$post['password']) < 8) {
				$json['error'] = language::get('error_password');
			} else if (utf8_strlen(request::$post['currency']) < 1) {
				$json['error'] = language::get('error_currency');
			} else if (utf8_strlen(request::$post['warehouse']) < 1) {
				$json['error'] = language::get('error_warehouse');
			} else if (request::$post['warehouse'] == 'other' && utf8_strlen(request::$post['country']) < 1) {
				$json['error'] = language::get('error_country');
			} else {

				$response = admin_extension_payment_pilibaba::register(request::$post['email_address'], request::$post['password'], request::$post['currency'], request::$post['warehouse'], request::$post['country'], request::$post['environment']);

				if (isset($response['code']) && isset($response['message'])) {
					if ($response['code'] == '0') {

						admin_setting_setting::editSetting('payment_pilibaba', array('pilibaba_merchant_number' => $response['data']['merchantNo'], 'pilibaba_secret_key' => $response['data']['privateKey'], 'pilibaba_email_address' => request::$post['email_address'], 'payment_pilibaba_environment' => request::$post['environment']), 0);

						session::$data['success'] = language::get('text_register_success');

						$json['redirect'] = url::link('extension/payment/pilibaba');
					} else {
						$json['error'] = $response['message'];
					}
				} else {
					$json['error'] = language::get('error_bad_response');
				}
			}
		} else {
			$json['error'] = language::get('error_data_missing');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function order() {
		if (config::get('payment_pilibaba_status')) {

			$order_id = request::$get['order_id'];

			$pilibaba_order = admin_extension_payment_pilibaba::getOrder(request::$get['order_id']);

			if ($pilibaba_order) {
				load::language('extension/payment/pilibaba');

				$order_info['order_id'] = $pilibaba_order['order_id'];

				$order_info['amount'] = '&yen;' . $pilibaba_order['amount'];

				$order_info['fee'] = '&yen;' . $pilibaba_order['fee'];

				$order_info['status'] = 'Success';

				$order_info['date_added'] = date(language::get('datetime_format'), strtotime($pilibaba_order['date_added']));

				$order_info['tracking'] = $pilibaba_order['tracking'];

				$data['pilibaba_order'] = $order_info;

				$data['barcode'] = url::link('extension/payment/pilibaba/barcode', '&order_id=' . request::$get['order_id']);

				$data['order_id'] = (int)request::$get['order_id'];


				return load::view('extension/payment/pilibaba_order', $data);
			}
		}
	}

	public static function tracking() {
		load::language('extension/payment/pilibaba');

		$json = array();

		if (config::get('payment_pilibaba_status')) {
			if (isset(request::$post['order_id']) && isset(request::$post['tracking'])) {
				if (utf8_strlen(request::$post['tracking']) > 0 && utf8_strlen(request::$post['tracking']) <= 50) {

					admin_extension_payment_pilibaba::updateTrackingNumber(request::$post['order_id'], request::$post['tracking'], config::get('payment_pilibaba_merchant_number'));

					$json['success'] = language::get('text_tracking_success');
				} else {
					$json['error'] = language::get('error_tracking_length');
				}
			} else {
				$json['error'] = language::get('error_data_missing');
			}
		} else {
			$json['error'] = language::get('error_not_enabled');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function barcode() {
		if (config::get('payment_pilibaba_status')) {
			if (isset(request::$get['order_id'])) {
				if (config::get('payment_pilibaba_environment') == 'live') {
					$url = 'https://www.pilibaba.com/pilipay/barCode';
				} else {
					$url = 'http://pre.pilibaba.com/pilipay/barCode';
				}

				echo '<img src="' . $url . '?orderNo=' . request::$get['order_id'] . '&merchantNo=' . config::get('payment_pilibaba_merchant_number') . '">';
			}
		}
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/pilibaba')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_pilibaba_merchant_number']) {
			self::$error['pilibaba_merchant_number'] = language::get('error_merchant_number');
		}

		if (!request::$post['payment_pilibaba_secret_key']) {
			self::$error['pilibaba_secret_key'] = language::get('error_secret_key');
		}

		if (request::$post['payment_pilibaba_shipping_fee'] != '' && strpos(request::$post['payment_pilibaba_shipping_fee'], '.') === false) {
			self::$error['pilibaba_shipping_fee'] = language::get('error_shipping_fee');
		}

		if (self::$error && !isset(self::$error['warning'])) {
			self::$error['warning'] = language::get('error_warning');
		}

		return !self::$error;
	}
}