<?php
class ControllerExtensionPaymentPPExpress {
	private static $error = array();
	private static $opencart_connect_url = 'https://www.opencart.com/index.php?route=external/paypal_auth/connect';
	private static $opencart_retrieve_url = 'https://www.opencart.com/index.php?route=external/paypal_auth/retrieve';

	public static function index() {
		load::language('extension/payment/pp_express');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_pp_express', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}


		$data['button_configure'] = url::link('extension/module/pp_button/configure');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['username'])) {
			$data['error_username'] = self::$error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['signature'])) {
			$data['error_signature'] = self::$error['signature'];
		} else {
			$data['error_signature'] = '';
		}

		if (isset(self::$error['sandbox_username'])) {
			$data['error_sandbox_username'] = self::$error['sandbox_username'];
		} else {
			$data['error_sandbox_username'] = '';
		}

		if (isset(self::$error['sandbox_password'])) {
			$data['error_sandbox_password'] = self::$error['sandbox_password'];
		} else {
			$data['error_sandbox_password'] = '';
		}

		if (isset(self::$error['sandbox_signature'])) {
			$data['error_sandbox_signature'] = self::$error['sandbox_signature'];
		} else {
			$data['error_sandbox_signature'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_express'),
		);

		$data['action'] = url::link('extension/payment/pp_express');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		$data['search'] = url::link('extension/payment/pp_express/search');

		if (isset(request::$post['payment_pp_express_username'])) {
			$data['payment_pp_express_username'] = request::$post['payment_pp_express_username'];
		} else {
			$data['payment_pp_express_username'] = config::get('payment_pp_express_username');
		}

		if (isset(request::$post['payment_pp_express_password'])) {
			$data['payment_pp_express_password'] = request::$post['payment_pp_express_password'];
		} else {
			$data['payment_pp_express_password'] = config::get('payment_pp_express_password');
		}

		if (isset(request::$post['payment_pp_express_signature'])) {
			$data['payment_pp_express_signature'] = request::$post['payment_pp_express_signature'];
		} else {
			$data['payment_pp_express_signature'] = config::get('payment_pp_express_signature');
		}

		if (isset(request::$post['payment_pp_express_sandbox_username'])) {
			$data['payment_pp_express_sandbox_username'] = request::$post['payment_pp_express_sandbox_username'];
		} else {
			$data['payment_pp_express_sandbox_username'] = config::get('payment_pp_express_sandbox_username');
		}

		if (isset(request::$post['payment_pp_express_sandbox_password'])) {
			$data['payment_pp_express_sandbox_password'] = request::$post['payment_pp_express_sandbox_password'];
		} else {
			$data['payment_pp_express_sandbox_password'] = config::get('payment_pp_express_sandbox_password');
		}

		if (isset(request::$post['payment_pp_express_sandbox_signature'])) {
			$data['payment_pp_express_sandbox_signature'] = request::$post['payment_pp_express_sandbox_signature'];
		} else {
			$data['payment_pp_express_sandbox_signature'] = config::get('payment_pp_express_sandbox_signature');
		}

		$data['ipn_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/pp_express/ipn';

		if (isset(request::$post['payment_pp_express_test'])) {
			$data['payment_pp_express_test'] = request::$post['payment_pp_express_test'];
		} else {
			$data['payment_pp_express_test'] = config::get('payment_pp_express_test');
		}

		if (isset(request::$post['payment_pp_express_debug'])) {
			$data['payment_pp_express_debug'] = request::$post['payment_pp_express_debug'];
		} else {
			$data['payment_pp_express_debug'] = config::get('payment_pp_express_debug');
		}

		if (isset(request::$post['payment_pp_express_incontext_disable'])) {
			$data['payment_pp_express_incontext_disable'] = request::$post['payment_pp_express_incontext_disable'];
		} else {
			$data['payment_pp_express_incontext_disable'] = config::get('payment_pp_express_incontext_disable');
		}

		if (isset(request::$post['payment_pp_express_currency'])) {
			$data['payment_pp_express_currency'] = request::$post['payment_pp_express_currency'];
		} else {
			$data['payment_pp_express_currency'] = config::get('payment_pp_express_currency');
		}


		$data['currencies'] = admin_extension_payment_pp_express::getCurrencies();

		if (isset(request::$post['payment_pp_express_recurring_cancel'])) {
			$data['payment_pp_express_recurring_cancel'] = request::$post['payment_pp_express_recurring_cancel'];
		} else {
			$data['payment_pp_express_recurring_cancel'] = config::get('payment_pp_express_recurring_cancel');
		}

		if (isset(request::$post['payment_pp_express_transaction'])) {
			$data['payment_pp_express_transaction'] = request::$post['payment_pp_express_transaction'];
		} else {
			$data['payment_pp_express_transaction'] = config::get('payment_pp_express_transaction');
		}

		if (isset(request::$post['payment_pp_express_total'])) {
			$data['payment_pp_express_total'] = request::$post['payment_pp_express_total'];
		} else {
			$data['payment_pp_express_total'] = config::get('payment_pp_express_total');
		}

		if (isset(request::$post['payment_pp_express_geo_zone_id'])) {
			$data['payment_pp_express_geo_zone_id'] = request::$post['payment_pp_express_geo_zone_id'];
		} else {
			$data['payment_pp_express_geo_zone_id'] = config::get('payment_pp_express_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_pp_express_status'])) {
			$data['payment_pp_express_status'] = request::$post['payment_pp_express_status'];
		} else {
			$data['payment_pp_express_status'] = config::get('payment_pp_express_status');
		}

		if (isset(request::$post['payment_pp_express_sort_order'])) {
			$data['payment_pp_express_sort_order'] = request::$post['payment_pp_express_sort_order'];
		} else {
			$data['payment_pp_express_sort_order'] = config::get('payment_pp_express_sort_order');
		}

		if (isset(request::$post['payment_pp_express_canceled_reversal_status_id'])) {
			$data['payment_pp_express_canceled_reversal_status_id'] = request::$post['payment_pp_express_canceled_reversal_status_id'];
		} else {
			$data['payment_pp_express_canceled_reversal_status_id'] = config::get('payment_pp_express_canceled_reversal_status_id');
		}

		if (isset(request::$post['payment_pp_express_completed_status_id'])) {
			$data['payment_pp_express_completed_status_id'] = request::$post['payment_pp_express_completed_status_id'];
		} else {
			$data['payment_pp_express_completed_status_id'] = config::get('payment_pp_express_completed_status_id');
		}

		if (isset(request::$post['payment_pp_express_denied_status_id'])) {
			$data['payment_pp_express_denied_status_id'] = request::$post['payment_pp_express_denied_status_id'];
		} else {
			$data['payment_pp_express_denied_status_id'] = config::get('payment_pp_express_denied_status_id');
		}

		if (isset(request::$post['payment_pp_express_expired_status_id'])) {
			$data['payment_pp_express_expired_status_id'] = request::$post['payment_pp_express_expired_status_id'];
		} else {
			$data['payment_pp_express_expired_status_id'] = config::get('payment_pp_express_expired_status_id');
		}

		if (isset(request::$post['payment_pp_express_failed_status_id'])) {
			$data['payment_pp_express_failed_status_id'] = request::$post['payment_pp_express_failed_status_id'];
		} else {
			$data['payment_pp_express_failed_status_id'] = config::get('payment_pp_express_failed_status_id');
		}

		if (isset(request::$post['payment_pp_express_pending_status_id'])) {
			$data['payment_pp_express_pending_status_id'] = request::$post['payment_pp_express_pending_status_id'];
		} else {
			$data['payment_pp_express_pending_status_id'] = config::get('payment_pp_express_pending_status_id');
		}

		if (isset(request::$post['payment_pp_express_processed_status_id'])) {
			$data['payment_pp_express_processed_status_id'] = request::$post['payment_pp_express_processed_status_id'];
		} else {
			$data['payment_pp_express_processed_status_id'] = config::get('payment_pp_express_processed_status_id');
		}

		if (isset(request::$post['payment_pp_express_refunded_status_id'])) {
			$data['payment_pp_express_refunded_status_id'] = request::$post['payment_pp_express_refunded_status_id'];
		} else {
			$data['payment_pp_express_refunded_status_id'] = config::get('payment_pp_express_refunded_status_id');
		}

		if (isset(request::$post['payment_pp_express_reversed_status_id'])) {
			$data['payment_pp_express_reversed_status_id'] = request::$post['payment_pp_express_reversed_status_id'];
		} else {
			$data['payment_pp_express_reversed_status_id'] = config::get('payment_pp_express_reversed_status_id');
		}

		if (isset(request::$post['payment_pp_express_voided_status_id'])) {
			$data['payment_pp_express_voided_status_id'] = request::$post['payment_pp_express_voided_status_id'];
		} else {
			$data['payment_pp_express_voided_status_id'] = config::get('payment_pp_express_voided_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_pp_express_allow_note'])) {
			$data['payment_pp_express_allow_note'] = request::$post['payment_pp_express_allow_note'];
		} else {
			$data['payment_pp_express_allow_note'] = config::get('payment_pp_express_allow_note');
		}

		if (isset(request::$post['payment_pp_express_colour'])) {
			$data['payment_pp_express_colour'] = str_replace('#', '', request::$post['payment_pp_express_colour']);
		} else {
			$data['payment_pp_express_colour'] = config::get('payment_pp_express_colour');
		}

		if (isset(request::$post['payment_pp_express_logo'])) {
			$data['payment_pp_express_logo'] = request::$post['payment_pp_express_logo'];
		} else {
			$data['payment_pp_express_logo'] = config::get('payment_pp_express_logo');
		}


		if (isset(request::$post['payment_pp_express_logo']) && is_file('image/' . request::$post['payment_pp_express_logo'])) {
			$data['thumb'] = admin_tool_image::resize(request::$post['payment_pp_express_logo'], 750, 90);
		} elseif (is_file('image/' . config::get('payment_pp_express_logo'))) {
			$data['thumb'] = admin_tool_image::resize(config::get('payment_pp_express_logo'), 750, 90);
		} else {
			$data['thumb'] = admin_tool_image::resize('no_image.png', 750, 90);
		}

		$data['placeholder'] = admin_tool_image::resize('no_image.png', 750, 90);

		if (isset(request::$get['retrieve_code']) && isset(request::$get['merchant_id'])) {
			$curl = curl_init(self::$opencart_retrieve_url);

			$post_data = array(
				'merchant_id' => request::$get['merchant_id'],
				'retrieve_code' => request::$get['retrieve_code'],
			);

			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
			curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);

			$curl_response = curl_exec($curl);
			$config_response = json_decode($curl_response, true);
			curl_close($curl);

			if (isset($config_response['api_user_name']) && isset($config_response['api_password']) && isset($config_response['signature'])) {
				$pp_express_settings = admin_setting_setting::getSetting('payment_pp_express');

				if ($config_response['environment'] == 'sandbox') {
					$pp_express_settings['payment_pp_express_sandbox_username'] = $config_response['api_user_name'];
					$pp_express_settings['payment_pp_express_sandbox_password'] = $config_response['api_password'];
					$pp_express_settings['payment_pp_express_sandbox_signature'] = $config_response['signature'];
					$pp_express_settings['payment_pp_express_test'] = 1;

					$data['payment_pp_express_sandbox_username'] = $config_response['api_user_name'];
					$data['payment_pp_express_sandbox_password'] = $config_response['api_password'];
					$data['payment_pp_express_sandbox_signature'] = $config_response['signature'];
					$data['payment_pp_express_test'] = 1;
				} else {
					$pp_express_settings['payment_pp_express_username'] = $config_response['api_user_name'];
					$pp_express_settings['payment_pp_express_password'] = $config_response['api_password'];
					$pp_express_settings['payment_pp_express_signature'] = $config_response['signature'];
					$pp_express_settings['payment_pp_express_test'] = 0;

					$data['payment_pp_express_username'] = $config_response['api_user_name'];
					$data['payment_pp_express_password'] = $config_response['api_password'];
					$data['payment_pp_express_signature'] = $config_response['signature'];
					$data['payment_pp_express_test'] = 0;
				}

				$data['retrieve_success'] = 1;
				$data['text_retrieve'] = language::get('text_retrieve');

				admin_setting_setting::editSetting('payment_pp_express', $pp_express_settings);
			}
		}


		$country = admin_localisation_country::getCountry(config('country_id'));

		$post_data = array(
			'return_url' => url::link('extension/payment/pp_express'),
			'store_url' => HTTPS_CATALOG,
			'store_version' => VERSION,
			'store_country' => (isset($country['iso_code_3']) ? $country['iso_code_3'] : ''),
		);

		// Create sandbox link
		$curl = curl_init(self::$opencart_connect_url);

		$post_data['environment'] = 'sandbox';

		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($post_data));

		$curl_response = curl_exec($curl);
		$curl_response = json_decode($curl_response, true);

		curl_close($curl);

		$data['auth_connect_url_sandbox'] = '';
		if (isset($curl_response['url']) && !empty($curl_response['url'])) {
			$data['auth_connect_url_sandbox'] = $curl_response['url'];
		}

		// Create Live link
		$curl = curl_init(self::$opencart_connect_url);

		$post_data['environment'] = 'live';

		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($post_data));

		$curl_response = curl_exec($curl);
		$curl_response = json_decode($curl_response, true);

		curl_close($curl);

		$data['auth_connect_url_live'] = '';
		if (isset($curl_response['url']) && !empty($curl_response['url'])) {
			$data['auth_connect_url_live'] = $curl_response['url'];
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_express', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/pp_express')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (request::$post['payment_pp_express_test']) {
			if (!request::$post['payment_pp_express_sandbox_username']) {
				self::$error['sandbox_username'] = language::get('error_sandbox_username');
			}

			if (!request::$post['payment_pp_express_sandbox_password']) {
				self::$error['sandbox_password'] = language::get('error_sandbox_password');
			}

			if (!request::$post['payment_pp_express_sandbox_signature']) {
				self::$error['sandbox_signature'] = language::get('error_sandbox_signature');
			}
		} else {
			if (!request::$post['payment_pp_express_username']) {
				self::$error['username'] = language::get('error_username');
			}

			if (!request::$post['payment_pp_express_password']) {
				self::$error['password'] = language::get('error_password');
			}

			if (!request::$post['payment_pp_express_signature']) {
				self::$error['signature'] = language::get('error_signature');
			}
		}

		return !self::$error;
	}

	public static function install() {

		admin_extension_payment_pp_express::install();
	}

	public static function uninstall() {

		admin_extension_payment_pp_express::uninstall();
	}

	public static function order() {
		if (config::get('payment_pp_express_status')) {
			load::language('extension/payment/pp_express_order');

			if (isset(request::$get['order_id'])) {
				$order_id = request::$get['order_id'];
			} else {
				$order_id = 0;
			}


			$paypal_info = admin_extension_payment_pp_express::getPayPalOrder($order_id);

			if ($paypal_info) {

				$data['order_id'] = (int)request::$get['order_id'];

				$data['capture_status'] = $paypal_info['capture_status'];

				$data['total'] = $paypal_info['total'];

				$captured = number_format(admin_extension_payment_pp_express::getCapturedTotal($paypal_info['paypal_order_id']), 2);

				$data['captured'] = $captured;

				$data['capture_remaining'] = number_format($paypal_info['total'] - $captured, 2);

				$refunded = number_format(admin_extension_payment_pp_express::getRefundedTotal($paypal_info['paypal_order_id']), 2);

				$data['refunded'] = $refunded;

				return load::view('extension/payment/pp_express_order', $data);
			}
		}
	}

	public static function transaction() {
		load::language('extension/payment/pp_express_order');

		$data['transactions'] = array();

		if (isset(request::$get['order_id'])) {
			$order_id = request::$get['order_id'];
		} else {
			$order_id = 0;
		}


		$paypal_info = admin_extension_payment_pp_express::getOrder($order_id);

		if ($paypal_info) {
			$results = admin_extension_payment_pp_express::getTransactions($paypal_info['paypal_order_id']);

			foreach ($results as $result) {
				$data['transactions'][] = array(
					'transaction_id' => $result['transaction_id'],
					'amount'         => $result['amount'],
					'payment_type'   => $result['payment_type'],
					'payment_status' => $result['payment_status'],
					'pending_reason' => $result['pending_reason'],
					'date_added'     => date(language::get('datetime_format'), strtotime($result['date_added'])),
					'view'           => url::link('extension/payment/pp_express/info', '&transaction_id=' . $result['transaction_id']),
					'refund'         => url::link('extension/payment/pp_express/refund', '&transaction_id=' . $result['transaction_id']),
					'resend'         => url::link('extension/payment/pp_express/resend', '&paypal_order_transaction_id=' . $result['paypal_order_transaction_id'])
				);
			}
		}

		response::setOutput(load::view('extension/payment/pp_express_transaction', $data));
	}

	public static function capture() {
		$json = array();

		load::language('extension/payment/pp_express_order');

		if (!isset(request::$post['amount']) && request::$post['amount'] > 0) {
			$json['error'] = language::get('error_capture');
		}

		if (!$json) {

			if (isset(request::$get['order_id'])) {
				$order_id = request::$get['order_id'];
			} else {
				$order_id = 0;
			}

			$paypal_info = admin_extension_payment_pp_express::getOrder($order_id);

			if ($paypal_info) {
				// If this is the final amount to capture or not
				if (request::$post['complete'] == 1) {
					$complete = 'Complete';
				} else {
					$complete = 'NotComplete';
				}

				$request = array(
					'METHOD'          => 'DoCapture',
					'AUTHORIZATIONID' => $paypal_info['authorization_id'],
					'AMT'             => number_format(request::$post['amount'], 2),
					'CURRENCYCODE'    => $paypal_info['currency_code'],
					'COMPLETETYPE'    => $complete,
					'MSGSUBID'        => uniqid(mt_rand(), true)
				);

				$response = admin_extension_payment_pp_express::call($request);

				if (isset($response['ACK']) && ($response['ACK'] != 'Failure') && ($response['ACK'] != 'FailureWithWarning')) {
					$transaction_data = array(
						'paypal_order_id'       => $paypal_info['paypal_order_id'],
						'transaction_id'        => $response['TRANSACTIONID'],
						'parent_id'             => $paypal_info['authorization_id'],
						'note'                  => '',
						'msgsubid'              => $response['MSGSUBID'],
						'receipt_id'            => '',
						'payment_type'          => $response['PAYMENTTYPE'],
						'payment_status'        => $response['PAYMENTSTATUS'],
						'pending_reason'        => (isset($response['PENDINGREASON']) ? $response['PENDINGREASON'] : ''),
						'transaction_entity'    => 'payment',
						'amount'                => $response['AMT'],
						'debug_data'            => json_encode($response)
					);

					admin_extension_payment_pp_express::addTransaction($transaction_data);

					$captured = number_format(admin_extension_payment_pp_express::getCapturedTotal($paypal_info['paypal_order_id']), 2);
					$refunded = number_format(admin_extension_payment_pp_express::getRefundedTotal($paypal_info['paypal_order_id']), 2);

					$json['captured'] = $captured;
					$json['refunded'] = $refunded;
					$json['remaining'] = number_format($paypal_info['total'] - $captured, 2);

					if (request::$post['complete'] == 1 || $json['remaining'] == 0.00) {
						$json['capture_status'] = language::get('text_complete');

						admin_extension_payment_pp_express::editPayPalOrderStatus($order_id, 'Complete');
					}

					$json['success'] = language::get('text_success');
				} else {
					$json['error'] = (isset($response_info['L_SHORTMESSAGE0']) ? $response_info['L_SHORTMESSAGE0'] : language::get('error_transaction'));
				}
			} else {
				$json['error'] = language::get('error_not_found');
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function refund() {
		load::language('extension/payment/pp_express_refund');

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_pp_express'),
			'href' => url::link('extension/payment/pp_express'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_express/refund'),
		);

		//button actions
		$data['action'] = url::link('extension/payment/pp_express/doRefund');
		$data['cancel'] = url::link('extension/payment/pp_express');

		$data['transaction_id'] = request::$get['transaction_id'];

		$pp_transaction = admin_extension_payment_pp_express::getTransaction(request::$get['transaction_id']);

		$data['amount_original'] = $pp_transaction['AMT'];
		$data['currency_code'] = $pp_transaction['CURRENCYCODE'];

		$refunded = number_format(admin_extension_payment_pp_express::getRefundedTotalByParentId(request::$get['transaction_id']), 2);

		if ($refunded != 0.00) {
			$data['refund_available'] = number_format($data['amount_original'] + $refunded, 2);
			$data['attention'] = language::get('text_current_refunds') . ': ' . $data['refund_available'];
		} else {
			$data['refund_available'] = '';
			$data['attention'] = '';
		}


		if (isset(session::$data['error'])) {
			$data['error'] = session::$data['error'];
			unset(session::$data['error']);
		} else {
			$data['error'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_express_refund', $data));
	}

	public static function doRefund() {
		/**
		 * used to issue a refund for a captured payment
		 *
		 * refund can be full or partial
		 */
		if (isset(request::$post['transaction_id']) && isset(request::$post['refund_full'])) {

			load::language('extension/payment/pp_express_refund');

			if (request::$post['refund_full'] == 0 && request::$post['amount'] == 0) {
				session::$data['error'] = language::get('error_partial_amt');
			} else {
				$order_id = admin_extension_payment_pp_express::getOrderId(request::$post['transaction_id']);
				$paypal_order = admin_extension_payment_pp_express::getOrder($order_id);

				if ($paypal_order) {
					$call_data = array();
					$call_data['METHOD'] = 'RefundTransaction';
					$call_data['TRANSACTIONID'] = request::$post['transaction_id'];
					$call_data['NOTE'] = urlencode(request::$post['refund_message']);
					$call_data['MSGSUBID'] = uniqid(mt_rand(), true);

					$current_transaction = admin_extension_payment_pp_express::getLocalTransaction(request::$post['transaction_id']);

					if (request::$post['refund_full'] == 1) {
						$call_data['REFUNDTYPE'] = 'Full';
					} else {
						$call_data['REFUNDTYPE'] = 'Partial';
						$call_data['AMT'] = number_format(request::$post['amount'], 2);
						$call_data['CURRENCYCODE'] = request::$post['currency_code'];
					}

					$result = admin_extension_payment_pp_express::call($call_data);

					$transaction = array(
						'paypal_order_id' => $paypal_order['paypal_order_id'],
						'transaction_id' => '',
						'parent_transaction_id' => request::$post['transaction_id'],
						'note' => request::$post['refund_message'],
						'msgsubid' => $call_data['MSGSUBID'],
						'receipt_id' => '',
						'payment_type' => '',
						'payment_status' => 'Refunded',
						'transaction_entity' => 'payment',
						'pending_reason' => '',
						'amount' => '-' . (isset($call_data['AMT']) ? $call_data['AMT'] : $current_transaction['amount']),
						'debug_data' => json_encode($result)
					);

					if ($result == false) {
						$transaction['payment_status'] = 'Failed';
						admin_extension_payment_pp_express::addTransaction($transaction, $call_data);
						response::redirect(url::link('sale/order/info', '&order_id=' . $paypal_order['order_id']));
					} else if ($result['ACK'] != 'Failure' && $result['ACK'] != 'FailureWithWarning') {

						$transaction['transaction_id'] = $result['REFUNDTRANSACTIONID'];
						$transaction['payment_type'] = $result['REFUNDSTATUS'];
						$transaction['pending_reason'] = $result['PENDINGREASON'];
						$transaction['amount'] = '-' . $result['GROSSREFUNDAMT'];

						admin_extension_payment_pp_express::addTransaction($transaction);

						//edit transaction to refunded status
						if ($result['TOTALREFUNDEDAMOUNT'] == request::$post['amount_original']) {
							db::query("UPDATE `paypal_order_transaction` SET `payment_status` = 'Refunded' WHERE `transaction_id` = " . esc(request::$post['transaction_id']) . " LIMIT 1");
						} else {
							db::query("UPDATE `paypal_order_transaction` SET `payment_status` = 'Partially-Refunded' WHERE `transaction_id` = " . esc(request::$post['transaction_id']) . " LIMIT 1");
						}

						//redirect back to the order
						response::redirect(url::link('sale/order/info', '&order_id=' . $paypal_order['order_id']));
					} else {
						admin_extension_payment_pp_express::log(json_encode($result));
						session::$data['error'] = (isset($result['L_SHORTMESSAGE0']) ? $result['L_SHORTMESSAGE0'] : 'There was an error') . (isset($result['L_LONGMESSAGE0']) ? '<br />' . $result['L_LONGMESSAGE0'] : '');
						response::redirect(url::link('extension/payment/pp_express/refund', '&transaction_id=' . request::$post['transaction_id']));
					}
				} else {
					session::$data['error'] = language::get('error_data_missing');
					response::redirect(url::link('extension/payment/pp_express/refund', '&transaction_id=' . request::$post['transaction_id']));
				}
			}
		} else {
			session::$data['error'] = language::get('error_data');
			response::redirect(url::link('extension/payment/pp_express/refund', '&transaction_id=' . request::$post['transaction_id']));
		}
	}

	/**
	 * used to void an authorised payment
	 */
	public static function void() {
		$json = array();

		load::language('extension/payment/pp_express_order');

		if (isset(request::$get['order_id'])) {
			$order_id = request::$get['order_id'];
		} else {
			$order_id = 0;
		}


		$paypal_info = admin_extension_payment_pp_express::getOrder($order_id);

		if ($paypal_info) {
			$request = array(
				'METHOD'          => 'DoVoid',
				'AUTHORIZATIONID' => $paypal_info['authorization_id'],
				'MSGSUBID'        => uniqid(mt_rand(), true)
			);

			$response_info = admin_extension_payment_pp_express::call($request);

			if (isset($response_info['ACK']) && ($response_info['ACK'] != 'Failure') && ($response_info['ACK'] != 'FailureWithWarning')) {
				$transaction = array(
					'paypal_order_id'       => $paypal_info['paypal_order_id'],
					'transaction_id'        => '',
					'parent_id'             => $paypal_info['authorization_id'],
					'note'                  => '',
					'msgsubid'              => '',
					'receipt_id'            => '',
					'payment_type'          => 'void',
					'payment_status'        => 'Void',
					'pending_reason'        => '',
					'transaction_entity'    => 'auth',
					'amount'                => '',
					'debug_data'            => json_encode($response_info)
				);

				admin_extension_payment_pp_express::addTransaction($transaction);

				admin_extension_payment_pp_express::editPayPalOrderStatus($order_id, 'Complete');

				$json['capture_status'] = 'Complete';

				$json['success'] = language::get('text_success');
			} else {
				$json['error'] = (isset($result['L_SHORTMESSAGE0']) ? $result['L_SHORTMESSAGE0'] : language::get('error_transaction'));
			}
		} else {
			$json['error'] = language::get('error_not_found');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	// Cancel an active recurring
	public static function recurringCancel() {
		$json = array();

		load::language('extension/recurring/pp_express');

		//cancel an active recurring

		if (isset(request::$get['order_recurring_id'])) {
			$order_recurring_id = request::$get['order_recurring_id'];
		} else {
			$order_recurring_id = 0;
		}

		$recurring_info = admin_account_recurring::getOrderRecurring($order_recurring_id);

		if ($recurring_info && $recurring_info['reference']) {
			if (config::get('payment_pp_express_test')) {
				$api_url = 'https://api-3t.sandbox.paypal.com/nvp';
				$api_username = config::get('payment_pp_express_sandbox_username');
				$api_password = config::get('payment_pp_express_sandbox_password');
				$api_signature = config::get('payment_pp_express_sandbox_signature');
			} else {
				$api_url = 'https://api-3t.paypal.com/nvp';
				$api_username = config::get('payment_pp_express_username');
				$api_password = config::get('payment_pp_express_password');
				$api_signature = config::get('payment_pp_express_signature');
			}

			$request = array(
				'USER'         => $api_username,
				'PWD'          => $api_password,
				'SIGNATURE'    => $api_signature,
				'VERSION'      => '109.0',
				'BUTTONSOURCE' => 'OpenCart_2.0_EC',
				'METHOD'       => 'SetExpressCheckout',
				'METHOD'       => 'ManageRecurringPaymentsProfileStatus',
				'PROFILEID'    => $recurring_info['reference'],
				'ACTION'       => 'Cancel'
			);

			$curl = curl_init($api_url);

			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_HEADER, false);
			curl_setopt($curl, CURLOPT_TIMEOUT, 30);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

			$response = curl_exec($curl);

			if (!$response) {
				self::log(sprintf(language::get('error_curl'), curl_errno($curl), curl_error($curl)));
			}

			curl_close($curl);

			$response_info = array();

			parse_str($response, $response_info);

			if (isset($response_info['PROFILEID'])) {
				admin_account_recurring::editOrderRecurringStatus($order_recurring_id, 4);
				admin_account_recurring::addOrderRecurringTransaction($order_recurring_id, 5);

				$json['success'] = language::get('text_cancelled');
			} else {
				$json['error'] = sprintf(language::get('error_not_cancelled'), $response_info['L_LONGMESSAGE0']);
			}
		} else {
			$json['error'] = language::get('error_not_found');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function resend() {
		$json = array();

		load::language('extension/payment/pp_express');

		if (isset(request::$get['paypal_order_transaction_id'])) {
			$paypal_order_transaction_id = request::$get['paypal_order_transaction_id'];
		} else {
			$paypal_order_transaction_id = 0;
		}


		$transaction = admin_extension_payment_pp_express::getFailedTransaction($paypal_order_transaction_id);

		if ($transaction) {

			$call_data = json_decode($transaction['call_data'], true);

			$result = admin_extension_payment_pp_express::call($call_data);

			if ($result) {

				$parent_transaction = admin_extension_payment_pp_express::getLocalTransaction($transaction['parent_id']);

				if ($parent_transaction['amount'] == abs($transaction['amount'])) {
					db::query("UPDATE `paypal_order_transaction` SET `payment_status` = 'Refunded' WHERE `transaction_id` = " . esc($transaction['parent_id']) . " LIMIT 1");
				} else {
					db::query("UPDATE `paypal_order_transaction` SET `payment_status` = 'Partially-Refunded' WHERE `transaction_id` = " . esc($transaction['parent_id']) . " LIMIT 1");
				}

				if (isset($result['REFUNDTRANSACTIONID'])) {
					$transaction['transaction_id'] = $result['REFUNDTRANSACTIONID'];
				} else {
					$transaction['transaction_id'] = $result['TRANSACTIONID'];
				}

				if (isset($result['PAYMENTTYPE'])) {
					$transaction['payment_type'] = $result['PAYMENTTYPE'];
				} else {
					$transaction['payment_type'] = $result['REFUNDSTATUS'];
				}

				if (isset($result['PAYMENTSTATUS'])) {
					$transaction['payment_status'] = $result['PAYMENTSTATUS'];
				} else {
					$transaction['payment_status'] = 'Refunded';
				}

				if (isset($result['AMT'])) {
					$transaction['amount'] = $result['AMT'];
				} else {
					$transaction['amount'] = $transaction['amount'];
				}

				$transaction['pending_reason'] = (isset($result['PENDINGREASON']) ? $result['PENDINGREASON'] : '');

				admin_extension_payment_pp_express::updateTransaction($transaction);

				$json['success'] = language::get('success_transaction_resent');
			} else {
				$json['error'] = language::get('error_timeout');
			}
		} else {
			$json['error'] = language::get('error_transaction_missing');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function search() {
		load::language('extension/payment/pp_express_search');

		document::setTitle(language::get('heading_title'));


		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_pp_express'),
			'href' => url::link('extension/payment/pp_express'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_express/search'),
		);


		$data['currency_codes'] = admin_extension_payment_pp_express::getCurrencies();

		$data['default_currency'] = config::get('payment_pp_express_currency');

		$data['date_start'] = date("Y-m-d", strtotime('-30 days'));
		$data['date_end'] = date("Y-m-d");
		$data['view_link'] = url::link('extension/payment/pp_express/info');

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_express_search', $data));
	}

	public static function info() {
		load::language('extension/payment/pp_express_view');

		document::setTitle(language::get('heading_title'));
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_pp_express'),
			'href' => url::link('extension/payment/pp_express'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_express/info', '&transaction_id=' . request::$get['transaction_id']),
		);


		$data['transaction'] = admin_extension_payment_pp_express::getTransaction(request::$get['transaction_id']);
		$data['lines'] = self::formatRows($data['transaction']);
		$data['view_link'] = url::link('extension/payment/pp_express/info');
		$data['cancel'] = url::link('extension/payment/pp_express/search');

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_express_view', $data));
	}

	public static function doSearch() {
		/**
		 * used to search for transactions from a user account
		 */
		if (isset(request::$post['date_start'])) {


			$call_data = array();
			$call_data['METHOD'] = 'TransactionSearch';
			$call_data['STARTDATE'] = gmdate(request::$post['date_start'] . "\TH:i:s\Z");

			if (!empty(request::$post['date_end'])) {
				$call_data['ENDDATE'] = gmdate(request::$post['date_end'] . "\TH:i:s\Z");
			}

			if (!empty(request::$post['transaction_class'])) {
				$call_data['TRANSACTIONCLASS'] = request::$post['transaction_class'];
			}

			if (!empty(request::$post['status'])) {
				$call_data['STATUS'] = request::$post['status'];
			}

			if (!empty(request::$post['buyer_email'])) {
				$call_data['EMAIL'] = request::$post['buyer_email'];
			}

			if (!empty(request::$post['merchant_email'])) {
				$call_data['RECEIVER'] = request::$post['merchant_email'];
			}

			if (!empty(request::$post['receipt_id'])) {
				$call_data['RECEIPTID'] = request::$post['receipt_id'];
			}

			if (!empty(request::$post['transaction_id'])) {
				$call_data['TRANSACTIONID'] = request::$post['transaction_id'];
			}

			if (!empty(request::$post['invoice_number'])) {
				$call_data['INVNUM'] = request::$post['invoice_number'];
			}

			if (!empty(request::$post['auction_item_number'])) {
				$call_data['AUCTIONITEMNUMBER'] = request::$post['auction_item_number'];
			}

			if (!empty(request::$post['amount'])) {
				$call_data['AMT'] = number_format(request::$post['amount'], 2);
				$call_data['CURRENCYCODE'] = request::$post['currency_code'];
			}

			if (!empty(request::$post['recurring_id'])) {
				$call_data['PROFILEID'] = request::$post['recurring_id'];
			}

			if (!empty(request::$post['name_salutation'])) {
				$call_data['SALUTATION'] = request::$post['name_salutation'];
			}

			if (!empty(request::$post['name_first'])) {
				$call_data['FIRSTNAME'] = request::$post['name_first'];
			}

			if (!empty(request::$post['name_middle'])) {
				$call_data['MIDDLENAME'] = request::$post['name_middle'];
			}

			if (!empty(request::$post['name_last'])) {
				$call_data['LASTNAME'] = request::$post['name_last'];
			}

			if (!empty(request::$post['name_suffix'])) {
				$call_data['SUFFIX'] = request::$post['name_suffix'];
			}

			$result = admin_extension_payment_pp_express::call($call_data);

			if ($result['ACK'] != 'Failure' && $result['ACK'] != 'FailureWithWarning' && $result['ACK'] != 'Warning') {
				$response['error'] = false;
				$response['result'] = self::formatRows($result);
			} else {
				$response['error'] = true;
				$response['error_msg'] = $result['L_LONGMESSAGE0'];
			}

			response::addHeader('Content-Type: application/json');
			response::setOutput(json_encode($response));
		} else {
			$response['error'] = true;
			$response['error_msg'] = 'Enter a start date';
			response::addHeader('Content-Type: application/json');
			response::setOutput(json_encode($response));
		}
	}

	public static function live() {
		if (isset(request::$get['merchantId'])) {
			load::language('extension/payment/pp_express');


			$token = admin_extension_payment_pp_express::getTokens('live');

			if (isset($token::$access_token)) {
				$user_info = admin_extension_payment_pp_express::getUserInfo(request::$get['merchantId'], 'live', $token::$access_token);
			} else {
				session::$data['error_api'] = language::get('error_api');
			}

			if (isset($user_info::$api_user_name)) {
				admin_setting_setting::editSettingValue('payment_pp_express', 'payment_pp_express_username', $user_info::$api_user_name);
				admin_setting_setting::editSettingValue('payment_pp_express', 'payment_pp_express_password', $user_info::$api_password);
				admin_setting_setting::editSettingValue('payment_pp_express', 'payment_pp_express_signature', $user_info::$signature);
			} else {
				session::$data['error_api'] = language::get('error_api');
			}
		}

		response::redirect(url::link('extension/payment/pp_express'));
	}

	public static function sandbox() {
		if (isset(request::$get['merchantId'])) {
			load::language('extension/payment/pp_express');


			$token = admin_extension_payment_pp_express::getTokens('sandbox');

			if (isset($token::$access_token)) {
				$user_info = admin_extension_payment_pp_express::getUserInfo(request::$get['merchantId'], 'sandbox', $token::$access_token);
			} else {
				session::$data['error_api'] = language::get('error_api_sandbox');
			}

			if (isset($user_info::$api_user_name)) {
				admin_setting_setting::editSettingValue('payment_pp_express', 'payment_pp_express_sandbox_username', $user_info::$api_user_name);
				admin_setting_setting::editSettingValue('payment_pp_express', 'payment_pp_express_sandbox_password', $user_info::$api_password);
				admin_setting_setting::editSettingValue('payment_pp_express', 'payment_pp_express_sandbox_signature', $user_info::$signature);
			} else {
				session::$data['error_api'] = language::get('error_api_sandbox');
			}
		}
		response::redirect(url::link('extension/payment/pp_express'));
	}

	private static function formatRows($data) {
		$return = array();

		foreach ($data as $k => $v) {
			$elements = preg_split("/(\d+)/", $k, -1, PREG_SPLIT_NO_EMPTY | PREG_SPLIT_DELIM_CAPTURE);
			if (isset($elements[1]) && isset($elements[0])) {
				if ($elements[0] == 'L_TIMESTAMP') {
					$v = str_replace('T', ' ', $v);
					$v = str_replace('Z', '', $v);
				}
				$return[$elements[1]][$elements[0]] = $v;
			}
		}

		return $return;
	}

	public static function recurringButtons() {

		$recurring = admin_sale_recurring::getRecurring(request::$get['order_recurring_id']);

		$data['buttons'] = array();

		if ($recurring['status'] == 2 || $recurring['status'] == 3) {
			$data['buttons'][] = array(
				'text' => language::get('button_cancel_recurring'),
				'link' => url::link('extension/payment/pp_express/recurringCancel', 'order_recurring_id=' . request::$get['order_recurring_id'] . '&user_token=' . request::$get['user_token'])
			);
		}

		return load::view('sale/recurring_button', $data);
	}

	public static function connectRedirect() {
		if (user::hasPermission('modify', 'extension/extension/payment') && user::hasPermission('modify', 'extension/payment/pp_express')) {
			// Install the module before doing the redirect

			admin_setting_extension::install('payment', 'pp_express');

			self::install();


			$country = admin_localisation_country::getCountry(config('country_id'));

			$post_data = array(
				'return_url' => url::link('extension/payment/pp_express'),
				'store_url' => HTTPS_CATALOG,
				'store_version' => VERSION,
				'store_country' => (isset($country['iso_code_3']) ? $country['iso_code_3'] : ''),
			);

			// Create Live link
			$curl = curl_init(self::$opencart_connect_url);

			$post_data['environment'] = 'live';

			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
			curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($post_data));

			$curl_response = curl_exec($curl);
			$curl_response = json_decode($curl_response, true);

			curl_close($curl);

			if (isset($curl_response['url']) && !empty($curl_response['url'])) {
				response::redirect($curl_response['url']);
			} else {
				response::redirect(url::link('marketplace/extension'));
			}
		} else {
			response::redirect(url::link('error/permission'));
		}
	}

	public static function preferredSolution() {
		load::language('extension/payment/pp_express');

		$data['connect_link'] = '';
		$data['module_link'] = '';

		if (config::get('payment_pp_express_username') || config::get('payment_pp_express_sandbox_username')) {
			$data['module_link'] = url::link('extension/payment/pp_express');
		} else {
			if (user::hasPermission('modify', 'extension/extension/payment')) {
				$data['connect_link'] = url::link('extension/payment/pp_express/connectRedirect');
			}
		}

		if (config::get("payment_pp_express_status") == 1) {
			$data['payment_pp_express_status'] = "enabled";
		} elseif (config::get("payment_pp_express_status") == null) {
			$data['payment_pp_express_status'] = "";
		} else {
			$data['payment_pp_express_status'] = "disabled";
		}

		return load::view('extension/payment/pp_express_preferred', $data);
	}
}
