<?php
class ControllerExtensionPaymentPPPayflow {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/pp_payflow');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_pp_payflow', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['vendor'])) {
			$data['error_vendor'] = self::$error['vendor'];
		} else {
			$data['error_vendor'] = '';
		}

		if (isset(self::$error['user'])) {
			$data['error_user'] = self::$error['user'];
		} else {
			$data['error_user'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['partner'])) {
			$data['error_partner'] = self::$error['partner'];
		} else {
			$data['error_partner'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_payflow'),
		);

		$data['action'] = url::link('extension/payment/pp_payflow');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_pp_payflow_vendor'])) {
			$data['payment_pp_payflow_vendor'] = request::$post['payment_pp_payflow_vendor'];
		} else {
			$data['payment_pp_payflow_vendor'] = config::get('payment_pp_payflow_vendor');
		}

		if (isset(request::$post['payment_pp_payflow_user'])) {
			$data['payment_pp_payflow_user'] = request::$post['payment_pp_payflow_user'];
		} else {
			$data['payment_pp_payflow_user'] = config::get('payment_pp_payflow_user');
		}

		if (isset(request::$post['payment_pp_payflow_password'])) {
			$data['payment_pp_payflow_password'] = request::$post['payment_pp_payflow_password'];
		} else {
			$data['payment_pp_payflow_password'] = config::get('payment_pp_payflow_password');
		}

		if (isset(request::$post['payment_pp_payflow_partner'])) {
			$data['payment_pp_payflow_partner'] = request::$post['payment_pp_payflow_partner'];
		} elseif (config::has('payment_pp_payflow_partner')) {
			$data['payment_pp_payflow_partner'] = config::get('payment_pp_payflow_partner');
		} else {
			$data['payment_pp_payflow_partner'] = 'PayPal';
		}

		if (isset(request::$post['payment_pp_payflow_test'])) {
			$data['payment_pp_payflow_test'] = request::$post['payment_pp_payflow_test'];
		} else {
			$data['payment_pp_payflow_test'] = config::get('payment_pp_payflow_test');
		}

		if (isset(request::$post['payment_pp_payflow_transaction'])) {
			$data['payment_pp_payflow_transaction'] = request::$post['payment_pp_payflow_transaction'];
		} else {
			$data['payment_pp_payflow_transaction'] = config::get('payment_pp_payflow_transaction');
		}

		if (isset(request::$post['payment_pp_payflow_total'])) {
			$data['payment_pp_payflow_total'] = request::$post['payment_pp_payflow_total'];
		} else {
			$data['payment_pp_payflow_total'] = config::get('payment_pp_payflow_total');
		}

		if (isset(request::$post['payment_pp_payflow_order_status_id'])) {
			$data['payment_pp_payflow_order_status_id'] = request::$post['payment_pp_payflow_order_status_id'];
		} else {
			$data['payment_pp_payflow_order_status_id'] = config::get('payment_pp_payflow_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_pp_payflow_geo_zone_id'])) {
			$data['payment_pp_payflow_geo_zone_id'] = request::$post['payment_pp_payflow_geo_zone_id'];
		} else {
			$data['payment_pp_payflow_geo_zone_id'] = config::get('payment_pp_payflow_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_pp_payflow_status'])) {
			$data['payment_pp_payflow_status'] = request::$post['payment_pp_payflow_status'];
		} else {
			$data['payment_pp_payflow_status'] = config::get('payment_pp_payflow_status');
		}

		if (isset(request::$post['payment_pp_payflow_sort_order'])) {
			$data['payment_pp_payflow_sort_order'] = request::$post['payment_pp_payflow_sort_order'];
		} else {
			$data['payment_pp_payflow_sort_order'] = config::get('payment_pp_payflow_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_payflow', $data));
	}

	private static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/pp_payflow')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_pp_payflow_vendor']) {
			self::$error['vendor'] = language::get('error_vendor');
		}

		if (!request::$post['payment_pp_payflow_user']) {
			self::$error['user'] = language::get('error_user');
		}

		if (!request::$post['payment_pp_payflow_password']) {
			self::$error['password'] = language::get('error_password');
		}

		if (!request::$post['payment_pp_payflow_partner']) {
			self::$error['partner'] = language::get('error_partner');
		}

		return !self::$error;
	}
}