<?php
class ControllerExtensionPaymentPPPayflowIframe {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/pp_payflow_iframe');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_pp_payflow_iframe', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['vendor'])) {
			$data['error_vendor'] = self::$error['vendor'];
		} else {
			$data['error_vendor'] = '';
		}

		if (isset(self::$error['user'])) {
			$data['error_user'] = self::$error['user'];
		} else {
			$data['error_user'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['partner'])) {
			$data['error_partner'] = self::$error['partner'];
		} else {
			$data['error_partner'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment'),
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_payflow_iframe'),
		);

		$data['action'] = url::link('extension/payment/pp_payflow_iframe');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_pp_payflow_iframe_vendor'])) {
			$data['payment_pp_payflow_iframe_vendor'] = request::$post['payment_pp_payflow_iframe_vendor'];
		} else {
			$data['payment_pp_payflow_iframe_vendor'] = config::get('payment_pp_payflow_iframe_vendor');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_user'])) {
			$data['payment_pp_payflow_iframe_user'] = request::$post['payment_pp_payflow_iframe_user'];
		} else {
			$data['payment_pp_payflow_iframe_user'] = config::get('payment_pp_payflow_iframe_user');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_password'])) {
			$data['payment_pp_payflow_iframe_password'] = request::$post['payment_pp_payflow_iframe_password'];
		} else {
			$data['payment_pp_payflow_iframe_password'] = config::get('payment_pp_payflow_iframe_password');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_partner'])) {
			$data['payment_pp_payflow_iframe_partner'] = request::$post['payment_pp_payflow_iframe_partner'];
		} else {
			$data['payment_pp_payflow_iframe_partner'] = config::get('payment_pp_payflow_iframe_partner');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_transaction_method'])) {
			$data['payment_pp_payflow_iframe_transaction_method'] = request::$post['payment_pp_payflow_iframe_transaction_method'];
		} else {
			$data['payment_pp_payflow_iframe_transaction_method'] = config::get('payment_pp_payflow_iframe_transaction_method');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_test'])) {
			$data['payment_pp_payflow_iframe_test'] = request::$post['payment_pp_payflow_iframe_test'];
		} else {
			$data['payment_pp_payflow_iframe_test'] = config::get('payment_pp_payflow_iframe_test');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_total'])) {
			$data['payment_pp_payflow_iframe_total'] = request::$post['payment_pp_payflow_iframe_total'];
		} else {
			$data['payment_pp_payflow_iframe_total'] = config::get('payment_pp_payflow_iframe_total');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_pp_payflow_iframe_order_status_id'])) {
			$data['payment_pp_payflow_iframe_order_status_id'] = request::$post['payment_pp_payflow_iframe_order_status_id'];
		} else {
			$data['payment_pp_payflow_iframe_order_status_id'] = config::get('payment_pp_payflow_iframe_order_status_id');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_geo_zone_id'])) {
			$data['payment_pp_payflow_iframe_geo_zone_id'] = request::$post['payment_pp_payflow_iframe_geo_zone_id'];
		} else {
			$data['payment_pp_payflow_iframe_geo_zone_id'] = config::get('payment_pp_payflow_iframe_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_pp_payflow_iframe_status'])) {
			$data['payment_pp_payflow_iframe_status'] = request::$post['payment_pp_payflow_iframe_status'];
		} else {
			$data['payment_pp_payflow_iframe_status'] = config::get('payment_pp_payflow_iframe_status');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_sort_order'])) {
			$data['payment_pp_payflow_iframe_sort_order'] = request::$post['payment_pp_payflow_iframe_sort_order'];
		} else {
			$data['payment_pp_payflow_iframe_sort_order'] = config::get('payment_pp_payflow_iframe_sort_order');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_checkout_method'])) {
			$data['payment_pp_payflow_iframe_checkout_method'] = request::$post['payment_pp_payflow_iframe_checkout_method'];
		} else {
			$data['payment_pp_payflow_iframe_checkout_method'] = config::get('payment_pp_payflow_iframe_checkout_method');
		}

		if (isset(request::$post['payment_pp_payflow_iframe_debug'])) {
			$data['payment_pp_payflow_iframe_debug'] = request::$post['payment_pp_payflow_iframe_debug'];
		} else {
			$data['payment_pp_payflow_iframe_debug'] = config::get('payment_pp_payflow_iframe_debug');
		}

		$data['post_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/pp_payflow_iframe/paymentipn';
		$data['cancel_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/pp_payflow_iframe/paymentcancel';
		$data['error_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/pp_payflow_iframe/paymenterror';
		$data['return_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/pp_payflow_iframe/paymentreturn';

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_payflow_iframe', $data));
	}

	public static function install() {

		admin_extension_payment_pp_payflow_iframe::install();
	}

	public static function uninstall() {

		admin_extension_payment_pp_payflow_iframe::uninstall();
	}

	public static function refund() {
		load::language('extension/payment/pp_payflow_iframe');

		$transaction = admin_extension_payment_pp_payflow_iframe::getTransaction(request::$get['transaction_reference']);

		if ($transaction) {
			document::setTitle(language::get('heading_refund'));

			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_home'),
				'href' => url::link('common/dashboard')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_extension'),
				'href' => url::link('marketplace/extension')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('extension/payment/pp_payflow_iframe')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_refund'),
				'href' => url::link('extension/payment/pp_payflow_iframe/refund', 'transaction_reference=' . request::$get['transaction_reference'] . '&user_token=' . session::$data['user_token'])
			);

			$data['transaction_reference'] = $transaction['transaction_reference'];
			$data['transaction_amount'] = number_format($transaction['amount'], 2);
			$data['cancel'] = url::link('sale/order/info', '&order_id=' . $transaction['order_id']);


			$data['header'] = load::controller('common/header');
			$data['column_left'] = load::controller('common/column_left');
			$data['footer'] = load::controller('common/footer');

			response::setOutput(load::view('extension/payment/pp_payflow_iframe_refund', $data));
		} else {
			return self::forward('error/not_found');
		}
	}

	public static function doRefund() {
		load::language('extension/payment/pp_payflow_iframe');
		$json = array();

		if (isset(request::$post['transaction_reference']) && isset(request::$post['amount'])) {

			$transaction = admin_extension_payment_pp_payflow_iframe::getTransaction(request::$post['transaction_reference']);

			if ($transaction) {
				$call_data = array(
					'TRXTYPE' => 'C',
					'TENDER'  => 'C',
					'ORIGID'  => $transaction['transaction_reference'],
					'AMT'     => request::$post['amount'],
				);

				$result = admin_extension_payment_pp_payflow_iframe::call($call_data);

				if ($result['RESULT'] == 0) {
					$json['success'] = language::get('text_refund_issued');

					$data = array(
						'order_id' => $transaction['order_id'],
						'type' => 'C',
						'transaction_reference' => $result['PNREF'],
						'amount' => request::$post['amount'],
					);

					admin_extension_payment_pp_payflow_iframe::addTransaction($data);
				} else {
					$json['error'] = $result['RESPMSG'];
				}
			} else {
				$json['error'] = language::get('error_missing_order');
			}
		} else {
			$json['error'] = language::get('error_missing_data');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function capture() {
		load::language('extension/payment/pp_payflow_iframe');

		if (isset(request::$post['order_id']) && isset(request::$post['amount']) && isset(request::$post['complete'])) {
			$order_id = request::$post['order_id'];
			$paypal_order = admin_extension_payment_pp_payflow_iframe::getOrder($order_id);
			$paypal_transactions = admin_extension_payment_pp_payflow_iframe::getTransactions($order_id);
			$order_info = admin_sale_order::getOrder($order_id);

			if ($paypal_order && $order_info) {
				if (request::$post['complete'] == 1) {
					$complete = 'Y';
				} else {
					$complete = 'N';
				}

				$call_data = array(
					'TRXTYPE'         => 'D',
					'TENDER'          => 'C',
					'ORIGID'          => $paypal_order['transaction_reference'],
					'AMT'             => request::$post['amount'],
					'CAPTURECOMPLETE' => $complete
				);

				$result = admin_extension_payment_pp_payflow_iframe::call($call_data);

				if ($result['RESULT'] == 0) {

					$data = array(
						'order_id'              => $order_id,
						'type'                  => 'D',
						'transaction_reference' => $result['PNREF'],
						'amount'                => request::$post['amount']
					);

					admin_extension_payment_pp_payflow_iframe::addTransaction($data);
					admin_extension_payment_pp_payflow_iframe::updateOrderStatus($order_id, request::$post['complete']);

					$actions = array();

					$actions[] = array(
						'title' => language::get('text_capture'),
						'href' => url::link('extension/payment/pp_payflow_iframe/refund', 'transaction_reference=' . $result['PNREF'] . '&user_token=' . session::$data['user_token']),
					);

					$json['success'] = array(
						'transaction_type' => language::get('text_capture'),
						'transaction_reference' => $result['PNREF'],
						'time' => date('Y-m-d H:i:s'),
						'amount' => number_format(request::$post['amount'], 2),
						'actions' => $actions,
					);
				} else {
					$json['error'] = $result['RESPMSG'];
				}
			} else {
				$json['error'] = language::get('error_missing_order');
			}
		} else {
			$json['error'] = language::get('error_missing_data');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function void() {
		load::language('extension/payment/pp_payflow_iframe');

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {
			$order_id = request::$post['order_id'];
			$paypal_order = admin_extension_payment_pp_payflow_iframe::getOrder($order_id);

			if ($paypal_order) {
				$call_data = array(
					'TRXTYPE' => 'V',
					'TENDER' => 'C',
					'ORIGID' => $paypal_order['transaction_reference'],
				);

				$result = admin_extension_payment_pp_payflow_iframe::call($call_data);

				if ($result['RESULT'] == 0) {
					$json['success'] = language::get('text_void_success');
					admin_extension_payment_pp_payflow_iframe::updateOrderStatus($order_id, 1);

					$data = array(
						'order_id' => $order_id,
						'type' => 'V',
						'transaction_reference' => $result['PNREF'],
						'amount' => '',
					);

					admin_extension_payment_pp_payflow_iframe::addTransaction($data);
					admin_extension_payment_pp_payflow_iframe::updateOrderStatus($order_id, 1);

					$json['success'] = array(
						'transaction_type' => language::get('text_void'),
						'transaction_reference' => $result['PNREF'],
						'time' => date('Y-m-d H:i:s'),
						'amount' => '0.00',
					);
				} else {
					$json['error'] = $result['RESPMSG'];
				}
			} else {
				$json['error'] = language::get('error_missing_order');
			}
		} else {
			$json['error'] = language::get('error_missing_data');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function order() {
		load::language('extension/payment/pp_payflow_iframe');

		$order_id = request::$get['order_id'];

		$paypal_order = admin_extension_payment_pp_payflow_iframe::getOrder($order_id);

		if ($paypal_order) {
			$data['complete'] = $paypal_order['complete'];
			
			$data['order_id'] = (int)request::$get['order_id'];
			

			$data['transactions'] = array();

			$transactions = admin_extension_payment_pp_payflow_iframe::getTransactions($order_id);

			foreach ($transactions as $transaction) {
				$actions = array();

				switch ($transaction['transaction_type']) {
					case 'V':
						$transaction_type = language::get('text_void');
						break;
					case 'S':
						$transaction_type = language::get('text_sale');

						$actions[] = array(
							'title' => language::get('text_refund'),
							'href' => url::link('extension/payment/pp_payflow_iframe/refund', 'transaction_reference=' . $transaction['transaction_reference'] . '&user_token=' . session::$data['user_token']),
						);
						break;
					case 'D':
						$transaction_type = language::get('text_capture');

						$actions[] = array(
							'title' => language::get('text_refund'),
							'href' => url::link('extension/payment/pp_payflow_iframe/refund', 'transaction_reference=' . $transaction['transaction_reference'] . '&user_token=' . session::$data['user_token']),
						);
						break;
					case 'A':
						$transaction_type = language::get('text_authorise');
						break;

					case 'C':
						$transaction_type = language::get('text_refund');#
						break;

					default:
						$transaction_type = '';
						break;
				}

				$data['transactions'][] = array(
					'transaction_reference' => $transaction['transaction_reference'],
					'transaction_type'      => $transaction_type,
					'time'                  => $transaction['time'],
					'amount'                => $transaction['amount'],
					'actions'               => $actions
				);
			}

			return load::view('extension/payment/pp_payflow_iframe_order', $data);
		}
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/pp_payflow_iframe')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_pp_payflow_iframe_vendor']) {
			self::$error['vendor'] = language::get('error_vendor');
		}

		if (!request::$post['payment_pp_payflow_iframe_user']) {
			self::$error['user'] = language::get('error_user');
		}

		if (!request::$post['payment_pp_payflow_iframe_password']) {
			self::$error['password'] = language::get('error_password');
		}

		if (!request::$post['payment_pp_payflow_iframe_partner']) {
			self::$error['partner'] = language::get('error_partner');
		}

		return !self::$error;
	}
}
