<?php
class ControllerExtensionPaymentPPPro {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/pp_pro');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_pp_pro', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['username'])) {
			$data['error_username'] = self::$error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['signature'])) {
			$data['error_signature'] = self::$error['signature'];
		} else {
			$data['error_signature'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_pro')
		);

		$data['action'] = url::link('extension/payment/pp_pro');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_pp_pro_username'])) {
			$data['payment_pp_pro_username'] = request::$post['payment_pp_pro_username'];
		} else {
			$data['payment_pp_pro_username'] = config::get('payment_pp_pro_username');
		}

		if (isset(request::$post['payment_pp_pro_password'])) {
			$data['payment_pp_pro_password'] = request::$post['payment_pp_pro_password'];
		} else {
			$data['payment_pp_pro_password'] = config::get('payment_pp_pro_password');
		}

		if (isset(request::$post['payment_pp_pro_signature'])) {
			$data['payment_pp_pro_signature'] = request::$post['payment_pp_pro_signature'];
		} else {
			$data['payment_pp_pro_signature'] = config::get('payment_pp_pro_signature');
		}

		if (isset(request::$post['payment_pp_pro_test'])) {
			$data['payment_pp_pro_test'] = request::$post['payment_pp_pro_test'];
		} else {
			$data['payment_pp_pro_test'] = config::get('payment_pp_pro_test');
		}

		if (isset(request::$post['payment_pp_pro_transaction'])) {
			$data['payment_pp_pro_transaction'] = request::$post['payment_pp_pro_transaction'];
		} else {
			$data['payment_pp_pro_transaction'] = config::get('payment_pp_pro_transaction');
		}

		if (isset(request::$post['payment_pp_pro_total'])) {
			$data['payment_pp_pro_total'] = request::$post['payment_pp_pro_total'];
		} else {
			$data['payment_pp_pro_total'] = config::get('payment_pp_pro_total');
		}

		if (isset(request::$post['payment_pp_pro_order_status_id'])) {
			$data['payment_pp_pro_order_status_id'] = request::$post['payment_pp_pro_order_status_id'];
		} else {
			$data['payment_pp_pro_order_status_id'] = config::get('payment_pp_pro_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_pp_pro_geo_zone_id'])) {
			$data['payment_pp_pro_geo_zone_id'] = request::$post['payment_pp_pro_geo_zone_id'];
		} else {
			$data['payment_pp_pro_geo_zone_id'] = config::get('payment_pp_pro_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_pp_pro_status'])) {
			$data['payment_pp_pro_status'] = request::$post['payment_pp_pro_status'];
		} else {
			$data['payment_pp_pro_status'] = config::get('payment_pp_pro_status');
		}

		if (isset(request::$post['payment_pp_pro_sort_order'])) {
			$data['payment_pp_pro_sort_order'] = request::$post['payment_pp_pro_sort_order'];
		} else {
			$data['payment_pp_pro_sort_order'] = config::get('payment_pp_pro_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_pro', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/pp_pro')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_pp_pro_username']) {
			self::$error['username'] = language::get('error_username');
		}

		if (!request::$post['payment_pp_pro_password']) {
			self::$error['password'] = language::get('error_password');
		}

		if (!request::$post['payment_pp_pro_signature']) {
			self::$error['signature'] = language::get('error_signature');
		}

		return !self::$error;
	}
}