<?php
class ControllerExtensionPaymentPPProIframe {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/pp_pro_iframe');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_pp_pro_iframe', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		} else {
			$data['error'] = @self::$error;
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_pro_iframe')
		);

		$data['action'] = url::link('extension/payment/pp_pro_iframe');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_pp_pro_iframe_sig'])) {
			$data['payment_pp_pro_iframe_sig'] = request::$post['payment_pp_pro_iframe_sig'];
		} else {
			$data['payment_pp_pro_iframe_sig'] = config::get('payment_pp_pro_iframe_sig');
		}

		if (isset(request::$post['payment_pp_pro_iframe_user'])) {
			$data['payment_pp_pro_iframe_user'] = request::$post['payment_pp_pro_iframe_user'];
		} else {
			$data['payment_pp_pro_iframe_user'] = config::get('payment_pp_pro_iframe_user');
		}

		if (isset(request::$post['payment_pp_pro_iframe_password'])) {
			$data['payment_pp_pro_iframe_password'] = request::$post['payment_pp_pro_iframe_password'];
		} else {
			$data['payment_pp_pro_iframe_password'] = config::get('payment_pp_pro_iframe_password');
		}

		if (isset(request::$post['payment_pp_pro_iframe_transaction_method'])) {
			$data['payment_pp_pro_iframe_transaction_method'] = request::$post['payment_pp_pro_iframe_transaction_method'];
		} else {
			$data['payment_pp_pro_iframe_transaction_method'] = config::get('payment_pp_pro_iframe_transaction_method');
		}

		if (isset(request::$post['payment_pp_pro_iframe_test'])) {
			$data['payment_pp_pro_iframe_test'] = request::$post['payment_pp_pro_iframe_test'];
		} else {
			$data['payment_pp_pro_iframe_test'] = config::get('payment_pp_pro_iframe_test');
		}

		if (isset(request::$post['payment_pp_pro_iframe_total'])) {
			$data['payment_pp_pro_iframe_total'] = request::$post['payment_pp_pro_iframe_total'];
		} else {
			$data['payment_pp_pro_iframe_total'] = config::get('payment_pp_pro_iframe_total');
		}

		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_pp_pro_iframe_canceled_reversal_status_id'])) {
			$data['payment_pp_pro_iframe_canceled_reversal_status_id'] = request::$post['payment_pp_pro_iframe_canceled_reversal_status_id'];
		} else {
			$data['payment_pp_pro_iframe_canceled_reversal_status_id'] = config::get('payment_pp_pro_iframe_canceled_reversal_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_completed_status_id'])) {
			$data['payment_pp_pro_iframe_completed_status_id'] = request::$post['payment_pp_pro_iframe_completed_status_id'];
		} else {
			$data['payment_pp_pro_iframe_completed_status_id'] = config::get('payment_pp_pro_iframe_completed_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_denied_status_id'])) {
			$data['payment_pp_pro_iframe_denied_status_id'] = request::$post['payment_pp_pro_iframe_denied_status_id'];
		} else {
			$data['payment_pp_pro_iframe_denied_status_id'] = config::get('payment_pp_pro_iframe_denied_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_expired_status_id'])) {
			$data['payment_pp_pro_iframe_expired_status_id'] = request::$post['payment_pp_pro_iframe_expired_status_id'];
		} else {
			$data['payment_pp_pro_iframe_expired_status_id'] = config::get('payment_pp_pro_iframe_expired_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_failed_status_id'])) {
			$data['payment_pp_pro_iframe_failed_status_id'] = request::$post['payment_pp_pro_iframe_failed_status_id'];
		} else {
			$data['payment_pp_pro_iframe_failed_status_id'] = config::get('payment_pp_pro_iframe_failed_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_pending_status_id'])) {
			$data['payment_pp_pro_iframe_pending_status_id'] = request::$post['payment_pp_pro_iframe_pending_status_id'];
		} else {
			$data['payment_pp_pro_iframe_pending_status_id'] = config::get('payment_pp_pro_iframe_pending_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_processed_status_id'])) {
			$data['payment_pp_pro_iframe_processed_status_id'] = request::$post['payment_pp_pro_iframe_processed_status_id'];
		} else {
			$data['payment_pp_pro_iframe_processed_status_id'] = config::get('payment_pp_pro_iframe_processed_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_processed_status_id'])) {
			$data['payment_pp_pro_iframe_processed_status_id'] = request::$post['payment_pp_pro_iframe_processed_status_id'];
		} else {
			$data['payment_pp_pro_iframe_processed_status_id'] = config::get('payment_pp_pro_iframe_processed_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_reversed_status_id'])) {
			$data['payment_pp_pro_iframe_reversed_status_id'] = request::$post['payment_pp_pro_iframe_reversed_status_id'];
		} else {
			$data['payment_pp_pro_iframe_reversed_status_id'] = config::get('payment_pp_pro_iframe_reversed_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_voided_status_id'])) {
			$data['payment_pp_pro_iframe_voided_status_id'] = request::$post['payment_pp_pro_iframe_voided_status_id'];
		} else {
			$data['payment_pp_pro_iframe_voided_status_id'] = config::get('payment_pp_pro_iframe_voided_status_id');
		}

		if (isset(request::$post['payment_pp_pro_iframe_geo_zone_id'])) {
			$data['payment_pp_pro_iframe_geo_zone_id'] = request::$post['payment_pp_pro_iframe_geo_zone_id'];
		} else {
			$data['payment_pp_pro_iframe_geo_zone_id'] = config::get('payment_pp_pro_iframe_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_pp_pro_iframe_status'])) {
			$data['payment_pp_pro_iframe_status'] = request::$post['payment_pp_pro_iframe_status'];
		} else {
			$data['payment_pp_pro_iframe_status'] = config::get('payment_pp_pro_iframe_status');
		}

		if (isset(request::$post['payment_pp_pro_iframe_sort_order'])) {
			$data['payment_pp_pro_iframe_sort_order'] = request::$post['payment_pp_pro_iframe_sort_order'];
		} else {
			$data['payment_pp_pro_iframe_sort_order'] = config::get('payment_pp_pro_iframe_sort_order');
		}

		if (isset(request::$post['payment_pp_pro_iframe_checkout_method'])) {
			$data['payment_pp_pro_iframe_checkout_method'] = request::$post['payment_pp_pro_iframe_checkout_method'];
		} else {
			$data['payment_pp_pro_iframe_checkout_method'] = config::get('payment_pp_pro_iframe_checkout_method');
		}

		if (isset(request::$post['payment_pp_pro_iframe_debug'])) {
			$data['payment_pp_pro_iframe_debug'] = request::$post['payment_pp_pro_iframe_debug'];
		} else {
			$data['payment_pp_pro_iframe_debug'] = config::get('payment_pp_pro_iframe_debug');
		}

		$data['ipn_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/pp_pro_iframe/notify';

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_pro_iframe', $data));
	}

	public static function install() {

		admin_extension_payment_pp_pro_iframe::install();
	}

	public static function uninstall() {

		admin_extension_payment_pp_pro_iframe::uninstall();
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/pp_pro_iframe')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_pp_pro_iframe_sig']) {
			self::$error['sig'] = language::get('error_sig');
		}

		if (!request::$post['payment_pp_pro_iframe_user']) {
			self::$error['user'] = language::get('error_user');
		}

		if (!request::$post['payment_pp_pro_iframe_password']) {
			self::$error['password'] = language::get('error_password');
		}

		return !self::$error;
	}

	public static function order() {
		load::language('extension/payment/pp_pro_iframe');

		$paypal_order = admin_extension_payment_pp_pro_iframe::getOrder(request::$get['order_id']);

		if ($paypal_order) {
			$data['paypal_order'] = $paypal_order;
			

			$data['order_id'] = (int)request::$get['order_id'];

			$captured = number_format(admin_extension_payment_pp_pro_iframe::getTotalCaptured($data['paypal_order']['paypal_iframe_order_id']), 2);
			$refunded = number_format(admin_extension_payment_pp_pro_iframe::getTotalRefunded($data['paypal_order']['paypal_iframe_order_id']), 2);

			$data['paypal_order']['captured'] = $captured;
			$data['paypal_order']['refunded'] = $refunded;
			$data['paypal_order']['remaining'] = number_format($data['paypal_order']['total'] - $captured, 2);

			$data['transactions'] = array();

			$data['view_link'] = url::link('extension/payment/pp_pro_iframe/info');
			$data['refund_link'] = url::link('extension/payment/pp_pro_iframe/refund');
			$data['resend_link'] = url::link('extension/payment/pp_pro_iframe/resend');

			$captured = number_format(admin_extension_payment_pp_pro_iframe::getTotalCaptured($paypal_order['paypal_iframe_order_id']), 2);
			$refunded = number_format(admin_extension_payment_pp_pro_iframe::getTotalRefunded($paypal_order['paypal_iframe_order_id']), 2);

			$data['paypal_order'] = $paypal_order;

			$data['paypal_order']['captured'] = $captured;
			$data['paypal_order']['refunded'] = $refunded;
			$data['paypal_order']['remaining'] = number_format($paypal_order['total'] - $captured, 2);

			foreach ($paypal_order['transactions'] as $transaction) {
				$data['transactions'][] = array(
					'paypal_iframe_order_transaction_id' => $transaction['paypal_iframe_order_transaction_id'],
					'transaction_id' => $transaction['transaction_id'],
					'amount' => $transaction['amount'],
					'date_added' => $transaction['date_added'],
					'payment_type' => $transaction['payment_type'],
					'payment_status' => $transaction['payment_status'],
					'pending_reason' => $transaction['pending_reason'],
					'view' => url::link('extension/payment/pp_pro_iframe/info', "&transaction_id=" . $transaction['transaction_id'] . '&order_id=' . request::$get['order_id']),
					'refund' => url::link('extension/payment/pp_pro_iframe/refund', "&transaction_id=" . $transaction['transaction_id'] . "&order_id=" . request::$get['order_id']),
					'resend' => url::link('extension/payment/pp_pro_iframe/resend', "&paypal_iframe_order_transaction_id=" . $transaction['paypal_iframe_order_transaction_id']),
				);
			}

			$data['reauthorise_link'] = url::link('extension/payment/pp_pro_iframe/reauthorise');

			return load::view('extension/payment/pp_pro_iframe_order', $data);
		}
	}

	public static function refund() {
		load::language('extension/payment/pp_pro_iframe');

		document::setTitle(language::get('text_refund'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_pro_iframe')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_refund'),
			'href' => url::link('extension/payment/pp_pro_iframe/refund')
		);

		//button actions
		$data['action'] = url::link('extension/payment/pp_pro_iframe/doRefund');

		if (isset(request::$get['order_id'])) {
			$data['cancel'] = url::link('sale/order/info', '&order_id=' . request::$get['order_id']);
		} else {
			$data['cancel'] = '';
		}

		$data['transaction_id'] = request::$get['transaction_id'];

		$pp_transaction = admin_extension_payment_pp_pro_iframe::getTransaction(request::$get['transaction_id']);

		$data['amount_original'] = $pp_transaction['AMT'];
		$data['currency_code'] = $pp_transaction['CURRENCYCODE'];

		$refunded = number_format(admin_extension_payment_pp_pro_iframe::getTotalRefundedTransaction(request::$get['transaction_id']), 2);

		if ($refunded != 0.00) {
			$data['refund_available'] = number_format($data['amount_original'] + $refunded, 2);
			$data['attention'] = language::get('text_current_refunds') . ': ' . $data['refund_available'];
		} else {
			$data['refund_available'] = '';
			$data['attention'] = '';
		}


		if (isset(session::$data['error'])) {
			$data['error'] = session::$data['error'];
			unset(session::$data['error']);
		} else {
			$data['error'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_pro_iframe_refund', $data));
	}

	public static function doRefund() {
		/**
		 * used to issue a refund for a captured payment
		 *
		 * refund can be full or partial
		 */
		if (isset(request::$post['transaction_id']) && isset(request::$post['refund_full'])) {

			load::language('extension/payment/pp_pro_iframe');

			if (request::$post['refund_full'] == 0 && request::$post['amount'] == 0) {
				session::$data['error'] = language::get('error_capture');
				response::redirect(url::link('extension/payment/pp_pro_iframe/refund', '&transaction_id=' . request::$post['transaction_id']));
			} else {
				$order_id = admin_extension_payment_pp_pro_iframe::getOrderId(request::$post['transaction_id']);
				$paypal_order = admin_extension_payment_pp_pro_iframe::getOrder($order_id);

				if ($paypal_order) {
					$call_data = array();
					$call_data['METHOD'] = 'RefundTransaction';
					$call_data['TRANSACTIONID'] = request::$post['transaction_id'];
					$call_data['NOTE'] = urlencode(request::$post['refund_message']);
					$call_data['MSGSUBID'] = uniqid(mt_rand(), true);

					$current_transaction = admin_extension_payment_pp_pro_iframe::getLocalTransaction(request::$post['transaction_id']);

					if (request::$post['refund_full'] == 1) {
						$call_data['REFUNDTYPE'] = 'Full';
					} else {
						$call_data['REFUNDTYPE'] = 'Partial';
						$call_data['AMT'] = number_format(request::$post['amount'], 2);
						$call_data['CURRENCYCODE'] = request::$post['currency_code'];
					}

					$result = admin_extension_payment_pp_pro_iframe::call($call_data);

					$transaction = array(
						'paypal_iframe_order_id' => $paypal_order['paypal_iframe_order_id'],
						'transaction_id' => '',
						'parent_id' => request::$post['transaction_id'],
						'note' => request::$post['refund_message'],
						'msgsubid' => $call_data['MSGSUBID'],
						'receipt_id' => '',
						'payment_type' => '',
						'payment_status' => 'Refunded',
						'transaction_entity' => 'payment',
						'pending_reason' => '',
						'amount' => '-' . (isset($call_data['AMT']) ? $call_data['AMT'] : $current_transaction['amount']),
						'debug_data' => json_encode($result)
					);

					if ($result == false) {
						$transaction['payment_status'] = 'Failed';
						admin_extension_payment_pp_pro_iframe::addTransaction($transaction, $call_data);
						response::redirect(url::link('sale/order/info', '&order_id=' . $paypal_order['order_id']));
					} else if ($result['ACK'] != 'Failure' && $result['ACK'] != 'FailureWithWarning') {

						$transaction['transaction_id'] = $result['REFUNDTRANSACTIONID'];
						$transaction['payment_type'] = $result['REFUNDSTATUS'];
						$transaction['pending_reason'] = $result['PENDINGREASON'];
						$transaction['amount'] = '-' . $result['GROSSREFUNDAMT'];

						admin_extension_payment_pp_pro_iframe::addTransaction($transaction);

						if ($result['TOTALREFUNDEDAMOUNT'] == request::$post['amount_original']) {
							admin_extension_payment_pp_pro_iframe::updateRefundTransaction(request::$post['transaction_id'], 'Refunded');
						} else {
							admin_extension_payment_pp_pro_iframe::updateRefundTransaction(request::$post['transaction_id'], 'Partially-Refunded');
						}

						//redirect back to the order
						response::redirect(url::link('sale/order/info', '&order_id=' . $paypal_order['order_id']));
					} else {
						if (config::get('payment_pp_pro_iframe_debug')) {
							$log = new Log('pp_pro_iframe.log');
							$log::write(json_encode($result));
						}

						session::$data['error'] = (isset($result['L_SHORTMESSAGE0']) ? $result['L_SHORTMESSAGE0'] : 'There was an error') . (isset($result['L_LONGMESSAGE0']) ? '<br />' . $result['L_LONGMESSAGE0'] : '');
						response::redirect(url::link('extension/payment/pp_pro_iframe/refund', '&transaction_id=' . request::$post['transaction_id']));
					}
				} else {
					session::$data['error'] = language::get('error_data_missing');
					response::redirect(url::link('extension/payment/pp_pro_iframe/refund', '&transaction_id=' . request::$post['transaction_id']));
				}
			}
		} else {
			session::$data['error'] = language::get('error_data');
			response::redirect(url::link('extension/payment/pp_pro_iframe/refund', '&transaction_id=' . request::$post['transaction_id']));
		}
	}

	public static function reauthorise() {
		load::language('extension/payment/pp_pro_iframe');

		$json = array();

		if (isset(request::$post['order_id'])) {
			$paypal_order = admin_extension_payment_pp_pro_iframe::getOrder(request::$post['order_id']);

			$call_data = array();
			$call_data['METHOD'] = 'DoReauthorization';
			$call_data['AUTHORIZATIONID'] = $paypal_order['authorization_id'];
			$call_data['AMT'] = number_format($paypal_order['total'], 2);
			$call_data['CURRENCYCODE'] = $paypal_order['currency_code'];

			$result = admin_extension_payment_pp_pro_iframe::call($call_data);

			if ($result['ACK'] != 'Failure' && $result['ACK'] != 'FailureWithWarning') {
				admin_extension_payment_pp_pro_iframe::updateAuthorizationId($paypal_order['paypal_iframe_order_id'], $result['AUTHORIZATIONID']);

				$transaction = array(
					'paypal_iframe_order_id' => $paypal_order['paypal_iframe_order_id'],
					'transaction_id' => '',
					'parent_id' => $paypal_order['authorization_id'],
					'note' => '',
					'msgsubid' => '',
					'receipt_id' => '',
					'payment_type' => 'instant',
					'payment_status' => $result['PAYMENTSTATUS'],
					'transaction_entity' => 'auth',
					'pending_reason' => $result['PENDINGREASON'],
					'amount' => '-' . '',
					'debug_data' => json_encode($result)
				);

				admin_extension_payment_pp_pro_iframe::addTransaction($transaction);

				$transaction['date_added'] = date("Y-m-d H:i:s");

				$json['data'] = $transaction;
				$json['error'] = false;
				$json['msg'] = 'Ok';
			} else {
				$json['error'] = true;
				$json['msg'] = (isset($result['L_SHORTMESSAGE0']) ? $result['L_SHORTMESSAGE0'] : language::get('error_general'));
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_missing_data');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function info() {
		load::language('extension/payment/pp_pro_iframe');
 
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_pro_iframe')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_transaction'),
			'href' => url::link('extension/payment/pp_pro_iframe/info', '&transaction_id=' . request::$get['transaction_id'])
		);

		$transaction = admin_extension_payment_pp_pro_iframe::getTransaction(request::$get['transaction_id']);
		$transaction = array_map('urldecode', $transaction);

		$data['transaction'] = $transaction;
		$data['view_link'] = url::link('extension/payment/pp_pro_iframe/info');

		document::setTitle(language::get('text_transaction'));

		if (isset(request::$get['order_id'])) {
			$data['back'] = url::link('sale/order/info', '&order_id=' . request::$get['order_id']);
		} else {
			$data['back'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_pro_iframe_transaction', $data));
	}

	public static function capture() {
		load::language('extension/payment/pp_pro_iframe');
		/*
		 * used to capture authorised payments
		 * capture can be full or partial amounts
		 */
		if (isset(request::$post['order_id']) && request::$post['amount'] > 0 && isset(request::$post['order_id']) && isset(request::$post['complete'])) {


			$paypal_order = admin_extension_payment_pp_pro_iframe::getOrder(request::$post['order_id']);

			if (request::$post['complete'] == 1) {
				$complete = 'Complete';
			} else {
				$complete = 'NotComplete';
			}

			$call_data = array();
			$call_data['METHOD'] = 'DoCapture';
			$call_data['AUTHORIZATIONID'] = $paypal_order['authorization_id'];
			$call_data['AMT'] = number_format(request::$post['amount'], 2);
			$call_data['CURRENCYCODE'] = $paypal_order['currency_code'];
			$call_data['COMPLETETYPE'] = $complete;
			$call_data['MSGSUBID'] = uniqid(mt_rand(), true);

			$result = admin_extension_payment_pp_pro_iframe::call($call_data);

			$transaction = array(
				'paypal_iframe_order_id' => $paypal_order['paypal_iframe_order_id'],
				'transaction_id' => '',
				'parent_id' => $paypal_order['authorization_id'],
				'note' => '',
				'msgsubid' => $call_data['MSGSUBID'],
				'receipt_id' => '',
				'payment_type' => '',
				'payment_status' => '',
				'pending_reason' => '',
				'transaction_entity' => 'payment',
				'amount' => '',
				'debug_data' => json_encode($result)
			);

			if ($result == false) {
				$transaction['amount'] = number_format(request::$post['amount'], 2);
				$paypal_iframe_order_transaction_id = admin_extension_payment_pp_pro_iframe::addTransaction($transaction, $call_data);

				$json['error'] = true;

				$json['failed_transaction']['paypal_iframe_order_transaction_id'] = $paypal_iframe_order_transaction_id;
				$json['failed_transaction']['amount'] = $transaction['amount'];
				$json['failed_transaction']['date_added'] = date("Y-m-d H:i:s");

				$json['msg'] = language::get('error_timeout');
			} else if (isset($result['ACK']) && $result['ACK'] != 'Failure' && $result['ACK'] != 'FailureWithWarning') {
				$transaction['transaction_id'] = $result['TRANSACTIONID'];
				$transaction['payment_type'] = $result['PAYMENTTYPE'];
				$transaction['payment_status'] = $result['PAYMENTSTATUS'];
				$transaction['pending_reason'] = (isset($result['PENDINGREASON']) ? $result['PENDINGREASON'] : '');
				$transaction['amount'] = $result['AMT'];

				admin_extension_payment_pp_pro_iframe::addTransaction($transaction);

				unset($transaction['debug_data']);
				$transaction['date_added'] = date("Y-m-d H:i:s");

				$captured = number_format(admin_extension_payment_pp_pro_iframe::getTotalCaptured($paypal_order['paypal_iframe_order_id']), 2);
				$refunded = number_format(admin_extension_payment_pp_pro_iframe::getTotalRefunded($paypal_order['paypal_iframe_order_id']), 2);

				$transaction['captured'] = $captured;
				$transaction['refunded'] = $refunded;
				$transaction['remaining'] = number_format($paypal_order['total'] - $captured, 2);

				$transaction['status'] = 0;
				if ($transaction['remaining'] == 0.00) {
					$transaction['status'] = 1;
					admin_extension_payment_pp_pro_iframe::updateOrder('Complete', request::$post['order_id']);
				}

				$transaction['void'] = '';

				if (request::$post['complete'] == 1 && $transaction['remaining'] > 0) {
					$transaction['void'] = array(
						'paypal_iframe_order_id' => $paypal_order['paypal_iframe_order_id'],
						'transaction_id' => '',
						'parent_id' => $paypal_order['authorization_id'],
						'note' => '',
						'msgsubid' => '',
						'receipt_id' => '',
						'payment_type' => '',
						'payment_status' => 'Void',
						'pending_reason' => '',
						'amount' => '',
						'debug_data' => 'Voided after capture',
						'transaction_entity' => 'auth',
					);

					admin_extension_payment_pp_pro_iframe::addTransaction($transaction['void']);
					admin_extension_payment_pp_pro_iframe::updateOrder('Complete', request::$post['order_id']);
					$transaction['void']['date_added'] = date("Y-m-d H:i:s");
					$transaction['status'] = 1;
				}

				$json['data'] = $transaction;
				$json['error'] = false;
				$json['msg'] = 'Ok';
			} else {
				$json['error'] = true;
				$json['msg'] = (isset($result['L_SHORTMESSAGE0']) ? $result['L_SHORTMESSAGE0'] : 'There was an error');
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function void() {
		load::language('extension/payment/pp_pro_iframe');

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$paypal_order = admin_extension_payment_pp_pro_iframe::getOrder(request::$post['order_id']);

			$call_data = array();
			$call_data['METHOD'] = 'DoVoid';
			$call_data['AUTHORIZATIONID'] = $paypal_order['authorization_id'];

			$result = admin_extension_payment_pp_pro_iframe::call($call_data);

			if ($result['ACK'] != 'Failure' && $result['ACK'] != 'FailureWithWarning') {
				$transaction = array(
					'paypal_iframe_order_id' => $paypal_order['paypal_iframe_order_id'],
					'transaction_id' => '',
					'parent_id' => $paypal_order['authorization_id'],
					'note' => '',
					'msgsubid' => '',
					'receipt_id' => '',
					'payment_type' => 'void',
					'payment_status' => 'Void',
					'pending_reason' => '',
					'transaction_entity' => 'auth',
					'amount' => '',
					'debug_data' => json_encode($result)
				);

				admin_extension_payment_pp_pro_iframe::addTransaction($transaction);
				admin_extension_payment_pp_pro_iframe::updateOrder('Complete', request::$post['order_id']);

				unset($transaction['debug_data']);
				$transaction['date_added'] = date("Y-m-d H:i:s");

				$json['data'] = $transaction;
				$json['error'] = false;
				$json['msg'] = 'Transaction void';
			} else {
				$json['error'] = true;
				$json['msg'] = (isset($result['L_SHORTMESSAGE0']) ? $result['L_SHORTMESSAGE0'] : language::get('error_general'));
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_missing_data');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function resend() {
		load::language('extension/payment/pp_pro_iframe');

		$json = array();

		if (isset(request::$get['paypal_iframe_order_transaction_id'])) {
			$transaction = admin_extension_payment_pp_pro_iframe::getFailedTransaction(request::$get['paypal_iframe_order_transaction_id']);

			if ($transaction) {
				$call_data = json_decode($transaction['call_data'], true);

				$result = admin_extension_payment_pp_pro_iframe::call($call_data);

				if ($result) {
					$parent_transaction = admin_extension_payment_pp_pro_iframe::getLocalTransaction($transaction['parent_id']);

					if ($parent_transaction['amount'] == abs($transaction['amount'])) {
						admin_extension_payment_pp_pro_iframe::updateRefundTransaction($transaction['parent_id'], 'Refunded');
					} else {
						admin_extension_payment_pp_pro_iframe::updateRefundTransaction($transaction['parent_id'], 'Partially-Refunded');
					}

					if (isset($result['REFUNDTRANSACTIONID'])) {
						$transaction['transaction_id'] = $result['REFUNDTRANSACTIONID'];
					} else {
						$transaction['transaction_id'] = $result['TRANSACTIONID'];
					}

					if (isset($result['PAYMENTTYPE'])) {
						$transaction['payment_type'] = $result['PAYMENTTYPE'];
					} else {
						$transaction['payment_type'] = $result['REFUNDSTATUS'];
					}

					if (isset($result['PAYMENTSTATUS'])) {
						$transaction['payment_status'] = $result['PAYMENTSTATUS'];
					} else {
						$transaction['payment_status'] = 'Refunded';
					}

					if (isset($result['AMT'])) {
						$transaction['amount'] = $result['AMT'];
					} else {
						$transaction['amount'] = $transaction['amount'];
					}

					$transaction['pending_reason'] = (isset($result['PENDINGREASON']) ? $result['PENDINGREASON'] : '');

					admin_extension_payment_pp_pro_iframe::updateTransaction($transaction);

					$json['success'] = language::get('success_transaction_resent');
				} else {
					$json['error'] = language::get('error_timeout');
				}
			} else {
				$json['error'] = language::get('error_transaction_missing');
			}
		} else {
			$json['error'] = language::get('error_missing_data');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}