<?php
class ControllerExtensionPaymentPPStandard {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/pp_standard');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_pp_standard', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['email'])) {
			$data['error_email'] = self::$error['email'];
		} else {
			$data['error_email'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/pp_standard')
		);

		$data['action'] = url::link('extension/payment/pp_standard');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_pp_standard_email'])) {
			$data['payment_pp_standard_email'] = request::$post['payment_pp_standard_email'];
		} else {
			$data['payment_pp_standard_email'] = config::get('payment_pp_standard_email');
		}

		if (isset(request::$post['payment_pp_standard_test'])) {
			$data['payment_pp_standard_test'] = request::$post['payment_pp_standard_test'];
		} else {
			$data['payment_pp_standard_test'] = config::get('payment_pp_standard_test');
		}

		if (isset(request::$post['payment_pp_standard_transaction'])) {
			$data['payment_pp_standard_transaction'] = request::$post['payment_pp_standard_transaction'];
		} else {
			$data['payment_pp_standard_transaction'] = config::get('payment_pp_standard_transaction');
		}

		if (isset(request::$post['payment_pp_standard_debug'])) {
			$data['payment_pp_standard_debug'] = request::$post['payment_pp_standard_debug'];
		} else {
			$data['payment_pp_standard_debug'] = config::get('payment_pp_standard_debug');
		}

		if (isset(request::$post['payment_pp_standard_total'])) {
			$data['payment_pp_standard_total'] = request::$post['payment_pp_standard_total'];
		} else {
			$data['payment_pp_standard_total'] = config::get('payment_pp_standard_total');
		}

		if (isset(request::$post['payment_pp_standard_canceled_reversal_status_id'])) {
			$data['payment_pp_standard_canceled_reversal_status_id'] = request::$post['payment_pp_standard_canceled_reversal_status_id'];
		} else {
			$data['payment_pp_standard_canceled_reversal_status_id'] = config::get('payment_pp_standard_canceled_reversal_status_id');
		}

		if (isset(request::$post['payment_pp_standard_completed_status_id'])) {
			$data['payment_pp_standard_completed_status_id'] = request::$post['payment_pp_standard_completed_status_id'];
		} else {
			$data['payment_pp_standard_completed_status_id'] = config::get('payment_pp_standard_completed_status_id');
		}

		if (isset(request::$post['payment_pp_standard_denied_status_id'])) {
			$data['payment_pp_standard_denied_status_id'] = request::$post['payment_pp_standard_denied_status_id'];
		} else {
			$data['payment_pp_standard_denied_status_id'] = config::get('payment_pp_standard_denied_status_id');
		}

		if (isset(request::$post['payment_pp_standard_expired_status_id'])) {
			$data['payment_pp_standard_expired_status_id'] = request::$post['payment_pp_standard_expired_status_id'];
		} else {
			$data['payment_pp_standard_expired_status_id'] = config::get('payment_pp_standard_expired_status_id');
		}

		if (isset(request::$post['payment_pp_standard_failed_status_id'])) {
			$data['payment_pp_standard_failed_status_id'] = request::$post['payment_pp_standard_failed_status_id'];
		} else {
			$data['payment_pp_standard_failed_status_id'] = config::get('payment_pp_standard_failed_status_id');
		}

		if (isset(request::$post['payment_pp_standard_pending_status_id'])) {
			$data['payment_pp_standard_pending_status_id'] = request::$post['payment_pp_standard_pending_status_id'];
		} else {
			$data['payment_pp_standard_pending_status_id'] = config::get('payment_pp_standard_pending_status_id');
		}

		if (isset(request::$post['payment_pp_standard_processed_status_id'])) {
			$data['payment_pp_standard_processed_status_id'] = request::$post['payment_pp_standard_processed_status_id'];
		} else {
			$data['payment_pp_standard_processed_status_id'] = config::get('payment_pp_standard_processed_status_id');
		}

		if (isset(request::$post['payment_pp_standard_refunded_status_id'])) {
			$data['payment_pp_standard_refunded_status_id'] = request::$post['payment_pp_standard_refunded_status_id'];
		} else {
			$data['payment_pp_standard_refunded_status_id'] = config::get('payment_pp_standard_refunded_status_id');
		}

		if (isset(request::$post['payment_pp_standard_reversed_status_id'])) {
			$data['payment_pp_standard_reversed_status_id'] = request::$post['payment_pp_standard_reversed_status_id'];
		} else {
			$data['payment_pp_standard_reversed_status_id'] = config::get('payment_pp_standard_reversed_status_id');
		}

		if (isset(request::$post['payment_pp_standard_voided_status_id'])) {
			$data['payment_pp_standard_voided_status_id'] = request::$post['payment_pp_standard_voided_status_id'];
		} else {
			$data['payment_pp_standard_voided_status_id'] = config::get('payment_pp_standard_voided_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_pp_standard_geo_zone_id'])) {
			$data['payment_pp_standard_geo_zone_id'] = request::$post['payment_pp_standard_geo_zone_id'];
		} else {
			$data['payment_pp_standard_geo_zone_id'] = config::get('payment_pp_standard_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_pp_standard_status'])) {
			$data['payment_pp_standard_status'] = request::$post['payment_pp_standard_status'];
		} else {
			$data['payment_pp_standard_status'] = config::get('payment_pp_standard_status');
		}

		if (isset(request::$post['payment_pp_standard_sort_order'])) {
			$data['payment_pp_standard_sort_order'] = request::$post['payment_pp_standard_sort_order'];
		} else {
			$data['payment_pp_standard_sort_order'] = config::get('payment_pp_standard_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/pp_standard', $data));
	}

	private static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/pp_standard')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_pp_standard_email']) {
			self::$error['email'] = language::get('error_email');
		}

		return !self::$error;
	}
}