<?php
class ControllerExtensionPaymentRealexRemote {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/realex_remote');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_realex_remote', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['error_merchant_id'])) {
			$data['error_merchant_id'] = self::$error['error_merchant_id'];
		} else {
			$data['error_merchant_id'] = '';
		}

		if (isset(self::$error['error_secret'])) {
			$data['error_secret'] = self::$error['error_secret'];
		} else {
			$data['error_secret'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/realex_remote')
		);

		$data['action'] = url::link('extension/payment/realex_remote');
		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_realex_remote_merchant_id'])) {
			$data['payment_realex_remote_merchant_id'] = request::$post['payment_realex_remote_merchant_id'];
		} else {
			$data['payment_realex_remote_merchant_id'] = config::get('payment_realex_remote_merchant_id');
		}

		if (isset(request::$post['payment_realex_remote_secret'])) {
			$data['payment_realex_remote_secret'] = request::$post['payment_realex_remote_secret'];
		} else {
			$data['payment_realex_remote_secret'] = config::get('payment_realex_remote_secret');
		}

		if (isset(request::$post['payment_realex_remote_rebate_password'])) {
			$data['payment_realex_remote_rebate_password'] = request::$post['payment_realex_remote_rebate_password'];
		} else {
			$data['payment_realex_remote_rebate_password'] = config::get('payment_realex_remote_rebate_password');
		}

		if (isset(request::$post['payment_realex_remote_geo_zone_id'])) {
			$data['payment_realex_remote_geo_zone_id'] = request::$post['payment_realex_remote_geo_zone_id'];
		} else {
			$data['payment_realex_remote_geo_zone_id'] = config::get('payment_realex_remote_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_realex_remote_total'])) {
			$data['payment_realex_remote_total'] = request::$post['payment_realex_remote_total'];
		} else {
			$data['payment_realex_remote_total'] = config::get('payment_realex_remote_total');
		}

		if (isset(request::$post['payment_realex_remote_sort_order'])) {
			$data['payment_realex_remote_sort_order'] = request::$post['payment_realex_remote_sort_order'];
		} else {
			$data['payment_realex_remote_sort_order'] = config::get('payment_realex_remote_sort_order');
		}

		if (isset(request::$post['payment_realex_remote_status'])) {
			$data['payment_realex_remote_status'] = request::$post['payment_realex_remote_status'];
		} else {
			$data['payment_realex_remote_status'] = config::get('payment_realex_remote_status');
		}

		if (isset(request::$post['payment_realex_remote_card_data_status'])) {
			$data['payment_realex_remote_card_data_status'] = request::$post['payment_realex_remote_card_data_status'];
		} else {
			$data['payment_realex_remote_card_data_status'] = config::get('payment_realex_remote_card_data_status');
		}

		if (isset(request::$post['payment_realex_remote_debug'])) {
			$data['payment_realex_remote_debug'] = request::$post['payment_realex_remote_debug'];
		} else {
			$data['payment_realex_remote_debug'] = config::get('payment_realex_remote_debug');
		}

		if (isset(request::$post['payment_realex_remote_account'])) {
			$data['payment_realex_remote_account'] = request::$post['payment_realex_remote_account'];
		} else {
			$data['payment_realex_remote_account'] = config::get('payment_realex_remote_account');
		}

		if (isset(request::$post['payment_realex_remote_auto_settle'])) {
			$data['payment_realex_remote_auto_settle'] = request::$post['payment_realex_remote_auto_settle'];
		} else {
			$data['payment_realex_remote_auto_settle'] = config::get('payment_realex_remote_auto_settle');
		}

		if (isset(request::$post['payment_realex_remote_tss_check'])) {
			$data['payment_realex_remote_tss_check'] = request::$post['payment_realex_remote_tss_check'];
		} else {
			$data['payment_realex_remote_tss_check'] = config::get('payment_realex_remote_tss_check');
		}

		if (isset(request::$post['payment_realex_remote_3d'])) {
			$data['payment_realex_remote_3d'] = request::$post['payment_realex_remote_3d'];
		} else {
			$data['payment_realex_remote_3d'] = config::get('payment_realex_remote_3d');
		}

		if (isset(request::$post['payment_realex_remote_liability'])) {
			$data['payment_realex_remote_liability'] = request::$post['payment_realex_remote_liability'];
		} else {
			$data['payment_realex_remote_liability'] = config::get('payment_realex_remote_liability');
		}

		if (isset(request::$post['payment_realex_remote_order_status_success_settled_id'])) {
			$data['payment_realex_remote_order_status_success_settled_id'] = request::$post['payment_realex_remote_order_status_success_settled_id'];
		} else {
			$data['payment_realex_remote_order_status_success_settled_id'] = config::get('payment_realex_remote_order_status_success_settled_id');
		}

		if (isset(request::$post['payment_realex_remote_order_status_success_unsettled_id'])) {
			$data['payment_realex_remote_order_status_success_unsettled_id'] = request::$post['payment_realex_remote_order_status_success_unsettled_id'];
		} else {
			$data['payment_realex_remote_order_status_success_unsettled_id'] = config::get('payment_realex_remote_order_status_success_unsettled_id');
		}

		if (isset(request::$post['payment_realex_remote_order_status_decline_id'])) {
			$data['payment_realex_remote_order_status_decline_id'] = request::$post['payment_realex_remote_order_status_decline_id'];
		} else {
			$data['payment_realex_remote_order_status_decline_id'] = config::get('payment_realex_remote_order_status_decline_id');
		}

		if (isset(request::$post['payment_realex_remote_order_status_decline_pending_id'])) {
			$data['payment_realex_remote_order_status_decline_pending_id'] = request::$post['payment_realex_remote_order_status_decline_pending_id'];
		} else {
			$data['payment_realex_remote_order_status_decline_pending_id'] = config::get('payment_realex_remote_order_status_decline_pending_id');
		}

		if (isset(request::$post['payment_realex_remote_order_status_decline_stolen_id'])) {
			$data['payment_realex_remote_order_status_decline_stolen_id'] = request::$post['payment_realex_remote_order_status_decline_stolen_id'];
		} else {
			$data['payment_realex_remote_order_status_decline_stolen_id'] = config::get('payment_realex_remote_order_status_decline_stolen_id');
		}

		if (isset(request::$post['payment_realex_remote_order_status_decline_bank_id'])) {
			$data['payment_realex_remote_order_status_decline_bank_id'] = request::$post['payment_realex_remote_order_status_decline_bank_id'];
		} else {
			$data['payment_realex_remote_order_status_decline_bank_id'] = config::get('payment_realex_remote_order_status_decline_bank_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/realex_remote', $data));
	}

	public static function install() {
		admin_extension_payment_realex_remote::install();
	}

	public static function order() {
		if (config::get('payment_realex_remote_status')) {

			$realex_order = admin_extension_payment_realex_remote::getOrder(request::$get['order_id']);

			if (!empty($realex_order)) {
				load::language('extension/payment/realex_remote');

				$realex_order['total_captured'] = admin_extension_payment_realex_remote::getTotalCaptured($realex_order['realex_remote_order_id']);

				$realex_order['total_formatted'] = currency::format($realex_order['total'], $realex_order['currency_code'], 1, true);
				$realex_order['total_captured_formatted'] = currency::format($realex_order['total_captured'], $realex_order['currency_code'], 1, true);

				$data['realex_order'] = $realex_order;

				$data['auto_settle'] = $realex_order['settle_type'];

				$data['order_id'] = (int)request::$get['order_id'];
				

				return load::view('extension/payment/realex_remote_order', $data);
			}
		}
	}

	public static function void() {
		load::language('extension/payment/realex_remote');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$realex_order = admin_extension_payment_realex_remote::getOrder(request::$post['order_id']);

			$void_response = admin_extension_payment_realex_remote::void(request::$post['order_id']);

			admin_extension_payment_realex_remote::logger('Void result:\r\n' . print_r($void_response, 1));

			if (isset($void_response::$result) && $void_response::$result == '00') {
				admin_extension_payment_realex_remote::addTransaction($realex_order['realex_remote_order_id'], 'void', 0.00);
				admin_extension_payment_realex_remote::updateVoidStatus($realex_order['realex_remote_order_id'], 1);

				$json['msg'] = language::get('text_void_ok');
				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($void_response::$message) && !empty($void_response::$message) ? (string)$void_response::$message : 'Unable to void';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function capture() {
		load::language('extension/payment/realex');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '' && isset(request::$post['amount']) && request::$post['amount'] > 0) {

			$realex_order = admin_extension_payment_realex_remote::getOrder(request::$post['order_id']);

			$capture_response = admin_extension_payment_realex_remote::capture(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_realex_remote::logger('Settle result:\r\n' . print_r($capture_response, 1));

			if (isset($capture_response::$result) && $capture_response::$result == '00') {
				admin_extension_payment_realex_remote::addTransaction($realex_order['realex_remote_order_id'], 'payment', request::$post['amount']);
				$total_captured = admin_extension_payment_realex_remote::getTotalCaptured($realex_order['realex_remote_order_id']);

				if ($total_captured >= $realex_order['total'] || $realex_order['settle_type'] == 0) {
					admin_extension_payment_realex_remote::updateCaptureStatus($realex_order['realex_remote_order_id'], 1);
					$capture_status = 1;
					$json['msg'] = language::get('text_capture_ok_order');
				} else {
					$capture_status = 0;
					$json['msg'] = language::get('text_capture_ok');
				}

				admin_extension_payment_realex_remote::updateForRebate($realex_order['realex_remote_order_id'], $capture_response::$pasref, $capture_response::$orderid);

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = (float)request::$post['amount'];
				$json['data']['capture_status'] = $capture_status;
				$json['data']['total'] = (float)$total_captured;
				$json['data']['total_formatted'] = currency::format($total_captured, $realex_order['currency_code'], 1, true);
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($capture_response::$message) && !empty($capture_response::$message) ? (string)$capture_response::$message : 'Unable to capture';

			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function rebate() {
		load::language('extension/payment/realex_remote');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$realex_order = admin_extension_payment_realex_remote::getOrder(request::$post['order_id']);

			$rebate_response = admin_extension_payment_realex_remote::rebate(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_realex_remote::logger('Rebate result:\r\n' . print_r($rebate_response, 1));

			if (isset($rebate_response::$result) && $rebate_response::$result == '00') {
				admin_extension_payment_realex_remote::addTransaction($realex_order['realex_remote_order_id'], 'rebate', request::$post['amount']*-1);

				$total_rebated = admin_extension_payment_realex_remote::getTotalRebated($realex_order['realex_remote_order_id']);
				$total_captured = admin_extension_payment_realex_remote::getTotalCaptured($realex_order['realex_remote_order_id']);

				if ($total_captured <= 0 && $realex_order['capture_status'] == 1) {
					admin_extension_payment_realex_remote::updateRebateStatus($realex_order['realex_remote_order_id'], 1);
					$rebate_status = 1;
					$json['msg'] = language::get('text_rebate_ok_order');
				} else {
					$rebate_status = 0;
					$json['msg'] = language::get('text_rebate_ok');
				}

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = request::$post['amount'] * -1;
				$json['data']['total_captured'] = (float)$total_captured;
				$json['data']['total_rebated'] = (float)$total_rebated;
				$json['data']['rebate_status'] = $rebate_status;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($rebate_response::$message) && !empty($rebate_response::$message) ? (string)$rebate_response::$message : 'Unable to rebate';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/realex_remote')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_realex_remote_merchant_id']) {
			self::$error['error_merchant_id'] = language::get('error_merchant_id');
		}

		if (!request::$post['payment_realex_remote_secret']) {
			self::$error['error_secret'] = language::get('error_secret');
		}

		return !self::$error;
	}
}