<?php
class ControllerExtensionPaymentSagepayServer {
	private static $error = array();

	public static function index() {

		load::language('extension/payment/sagepay_server');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_sagepay_server', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['vendor'])) {
			$data['error_vendor'] = self::$error['vendor'];
		} else {
			$data['error_vendor'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/sagepay_server')
		);

		$data['action'] = url::link('extension/payment/sagepay_server');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_sagepay_server_vendor'])) {
			$data['payment_sagepay_server_vendor'] = request::$post['payment_sagepay_server_vendor'];
		} else {
			$data['payment_sagepay_server_vendor'] = config::get('payment_sagepay_server_vendor');
		}

		if (isset(request::$post['payment_sagepay_server_password'])) {
			$data['payment_sagepay_server_password'] = request::$post['payment_sagepay_server_password'];
		} else {
			$data['payment_sagepay_server_password'] = config::get('payment_sagepay_server_password');
		}

		if (isset(request::$post['payment_sagepay_server_test'])) {
			$data['payment_sagepay_server_test'] = request::$post['payment_sagepay_server_test'];
		} else {
			$data['payment_sagepay_server_test'] = config::get('payment_sagepay_server_test');
		}

		if (isset(request::$post['payment_sagepay_server_transaction'])) {
			$data['payment_sagepay_server_transaction'] = request::$post['payment_sagepay_server_transaction'];
		} else {
			$data['payment_sagepay_server_transaction'] = config::get('payment_sagepay_server_transaction');
		}

		if (isset(request::$post['payment_sagepay_server_total'])) {
			$data['payment_sagepay_server_total'] = request::$post['payment_sagepay_server_total'];
		} else {
			$data['payment_sagepay_server_total'] = config::get('payment_sagepay_server_total');
		}

		if (isset(request::$post['payment_sagepay_server_card'])) {
			$data['payment_sagepay_server_card'] = request::$post['payment_sagepay_server_card'];
		} else {
			$data['payment_sagepay_server_card'] = config::get('payment_sagepay_server_card');
		}

		if (isset(request::$post['payment_sagepay_server_order_status_id'])) {
			$data['payment_sagepay_server_order_status_id'] = request::$post['payment_sagepay_server_order_status_id'];
		} else {
			$data['payment_sagepay_server_order_status_id'] = config::get('payment_sagepay_server_order_status_id');
		}

		if (isset(request::$post['payment_sagepay_server_cron_job_token'])) {
			$data['payment_sagepay_server_cron_job_token'] = request::$post['payment_sagepay_server_cron_job_token'];
		} elseif (config::get('payment_sagepay_server_cron_job_token')) {
			$data['payment_sagepay_server_cron_job_token'] = config::get('payment_sagepay_server_cron_job_token');
		} else {
			$data['payment_sagepay_server_cron_job_token'] = sha1(uniqid(mt_rand(), 1));
		}

		$data['sagepay_server_cron_job_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/sagepay_server/cron&token=' . $data['payment_sagepay_server_cron_job_token'];

		if (config::get('payment_sagepay_server_last_cron_job_run')) {
			$data['payment_sagepay_server_last_cron_job_run'] = config::get('payment_sagepay_server_last_cron_job_run');
		} else {
			$data['payment_sagepay_server_last_cron_job_run'] = '';
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_sagepay_server_geo_zone_id'])) {
			$data['payment_sagepay_server_geo_zone_id'] = request::$post['payment_sagepay_server_geo_zone_id'];
		} else {
			$data['payment_sagepay_server_geo_zone_id'] = config::get('payment_sagepay_server_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_sagepay_server_status'])) {
			$data['payment_sagepay_server_status'] = request::$post['payment_sagepay_server_status'];
		} else {
			$data['payment_sagepay_server_status'] = config::get('payment_sagepay_server_status');
		}

		if (isset(request::$post['payment_sagepay_server_debug'])) {
			$data['payment_sagepay_server_debug'] = request::$post['payment_sagepay_server_debug'];
		} else {
			$data['payment_sagepay_server_debug'] = config::get('payment_sagepay_server_debug');
		}

		if (isset(request::$post['payment_sagepay_server_sort_order'])) {
			$data['payment_sagepay_server_sort_order'] = request::$post['payment_sagepay_server_sort_order'];
		} else {
			$data['payment_sagepay_server_sort_order'] = config::get('payment_sagepay_server_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/sagepay_server', $data));
	}

	public static function install() {
		admin_extension_payment_sagepay_server::install();
	}

	public static function uninstall() {
		admin_extension_payment_sagepay_server::uninstall();
	}

	public static function order() {
		if (config::get('payment_sagepay_server_status')) {

			$sagepay_server_order = admin_extension_payment_sagepay_server::getOrder(request::$get['order_id']);

			if (!empty($sagepay_server_order)) {
				load::language('extension/payment/sagepay_server');

				$sagepay_server_order['total_released'] = admin_extension_payment_sagepay_server::getTotalReleased($sagepay_server_order['sagepay_server_order_id']);

				$sagepay_server_order['total_formatted'] = currency::format($sagepay_server_order['total'], $sagepay_server_order['currency_code'], false, false);
				$sagepay_server_order['total_released_formatted'] = currency::format($sagepay_server_order['total_released'], $sagepay_server_order['currency_code'], false, false);

				$data['sagepay_server_order'] = $sagepay_server_order;

				$data['auto_settle'] = $sagepay_server_order['settle_type'];

				$data['order_id'] = (int)request::$get['order_id'];
				

				return load::view('extension/payment/sagepay_server_order', $data);
			}
		}
	}

	public static function void() {
		load::language('extension/payment/sagepay_server');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$sagepay_server_order = admin_extension_payment_sagepay_server::getOrder(request::$post['order_id']);

			$void_response = admin_extension_payment_sagepay_server::void(request::$post['order_id']);

			admin_extension_payment_sagepay_server::logger('Void result', $void_response);

			if ($void_response['Status'] == 'OK') {
				admin_extension_payment_sagepay_server::addTransaction($sagepay_server_order['sagepay_server_order_id'], 'void', 0.00);
				admin_extension_payment_sagepay_server::updateVoidStatus($sagepay_server_order['sagepay_server_order_id'], 1);

				$json['msg'] = language::get('text_void_ok');

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($void_response['StatuesDetail']) && !empty($void_response['StatuesDetail']) ? (string)$void_response['StatuesDetail'] : 'Unable to void';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function release() {
		load::language('extension/payment/sagepay_server');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '' && isset(request::$post['amount']) && request::$post['amount'] > 0) {

			$sagepay_server_order = admin_extension_payment_sagepay_server::getOrder(request::$post['order_id']);

			$release_response = admin_extension_payment_sagepay_server::release(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_sagepay_server::logger('Release result', $release_response);

			if ($release_response['Status'] == 'OK') {
				admin_extension_payment_sagepay_server::addTransaction($sagepay_server_order['sagepay_server_order_id'], 'payment', request::$post['amount']);

				$total_released = admin_extension_payment_sagepay_server::getTotalReleased($sagepay_server_order['sagepay_server_order_id']);

				if ($total_released >= $sagepay_server_order['total'] || $sagepay_server_order['settle_type'] == 0) {
					admin_extension_payment_sagepay_server::updateReleaseStatus($sagepay_server_order['sagepay_server_order_id'], 1);
					$release_status = 1;
					$json['msg'] = language::get('text_release_ok_order');
				} else {
					$release_status = 0;
					$json['msg'] = language::get('text_release_ok');
				}

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = request::$post['amount'];
				$json['data']['release_status'] = $release_status;
				$json['data']['total'] = (float)$total_released;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($release_response['StatusDetail']) && !empty($release_response['StatusDetail']) ? (string)$release_response['StatusDetail'] : 'Unable to release';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_data_missing');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function rebate() {
		load::language('extension/payment/sagepay_server');
		$json = array();

		if (isset(request::$post['order_id']) && !empty(request::$post['order_id'])) {

			$sagepay_server_order = admin_extension_payment_sagepay_server::getOrder(request::$post['order_id']);

			$rebate_response = admin_extension_payment_sagepay_server::rebate(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_sagepay_server::logger('Rebate result', $rebate_response);

			if ($rebate_response['Status'] == 'OK') {
				admin_extension_payment_sagepay_server::addTransaction($sagepay_server_order['sagepay_server_order_id'], 'rebate', request::$post['amount'] * -1);

				$total_rebated = admin_extension_payment_sagepay_server::getTotalRebated($sagepay_server_order['sagepay_server_order_id']);
				$total_released = admin_extension_payment_sagepay_server::getTotalReleased($sagepay_server_order['sagepay_server_order_id']);

				if ($total_released <= 0 && $sagepay_server_order['release_status'] == 1) {
					admin_extension_payment_sagepay_server::updateRebateStatus($sagepay_server_order['sagepay_server_order_id'], 1);
					$rebate_status = 1;
					$json['msg'] = language::get('text_rebate_ok_order');
				} else {
					$rebate_status = 0;
					$json['msg'] = language::get('text_rebate_ok');
				}

				$json['data'] = array();
				$json['data']['date_added'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = request::$post['amount'] * -1;
				$json['data']['total_released'] = (float)$total_released;
				$json['data']['total_rebated'] = (float)$total_rebated;
				$json['data']['rebate_status'] = $rebate_status;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($rebate_response['StatusDetail']) && !empty($rebate_response['StatusDetail']) ? (string)$rebate_response['StatusDetail'] : 'Unable to rebate';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/sagepay_server')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_sagepay_server_vendor']) {
			self::$error['vendor'] = language::get('error_vendor');
		}

		return !self::$error;
	}
}