<?php
class ControllerExtensionPaymentSagepayUS {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/sagepay_us');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_sagepay_us', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['merchant_id'])) {
			$data['error_merchant_id'] = self::$error['merchant_id'];
		} else {
			$data['error_merchant_id'] = '';
		}

		if (isset(self::$error['merchant_key'])) {
			$data['error_merchant_key'] = self::$error['merchant_key'];
		} else {
			$data['error_merchant_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/sagepay_us')
		);

		$data['action'] = url::link('extension/payment/sagepay_us');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_sagepay_us_merchant_id'])) {
			$data['payment_sagepay_us_merchant_id'] = request::$post['payment_sagepay_us_merchant_id'];
		} else {
			$data['payment_sagepay_us_merchant_id'] = config::get('payment_sagepay_us_merchant_id');
		}

		if (isset(request::$post['payment_sagepay_us_merchant_key'])) {
			$data['payment_sagepay_us_merchant_key'] = request::$post['payment_sagepay_us_merchant_key'];
		} else {
			$data['payment_sagepay_us_merchant_key'] = config::get('payment_sagepay_us_merchant_key');
		}

		if (isset(request::$post['payment_sagepay_us_total'])) {
			$data['payment_sagepay_us_total'] = request::$post['payment_sagepay_us_total'];
		} else {
			$data['payment_sagepay_us_total'] = config::get('payment_sagepay_us_total');
		}

		if (isset(request::$post['payment_sagepay_us_order_status_id'])) {
			$data['payment_sagepay_us_order_status_id'] = request::$post['payment_sagepay_us_order_status_id'];
		} else {
			$data['payment_sagepay_us_order_status_id'] = config::get('payment_sagepay_us_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_sagepay_us_geo_zone_id'])) {
			$data['payment_sagepay_us_geo_zone_id'] = request::$post['payment_sagepay_us_geo_zone_id'];
		} else {
			$data['payment_sagepay_us_geo_zone_id'] = config::get('payment_sagepay_us_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_sagepay_us_status'])) {
			$data['payment_sagepay_us_status'] = request::$post['payment_sagepay_us_status'];
		} else {
			$data['payment_sagepay_us_status'] = config::get('payment_sagepay_us_status');
		}

		if (isset(request::$post['payment_sagepay_us_sort_order'])) {
			$data['payment_sagepay_us_sort_order'] = request::$post['payment_sagepay_us_sort_order'];
		} else {
			$data['payment_sagepay_us_sort_order'] = config::get('payment_sagepay_us_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/sagepay_us', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/sagepay_us')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_sagepay_us_merchant_id']) {
			self::$error['merchant_id'] = language::get('error_merchant_id');
		}

		if (!request::$post['payment_sagepay_us_merchant_key']) {
			self::$error['merchant_key'] = language::get('error_merchant_key');
		}

		return !self::$error;
	}
}