<?php
class ControllerExtensionPaymentSecureTradingWs {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/securetrading_ws');

		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			request::$post['payment_securetrading_ws_site_reference'] = trim(request::$post['payment_securetrading_ws_site_reference']);
			request::$post['payment_securetrading_ws_username'] = trim(request::$post['payment_securetrading_ws_username']);

			admin_setting_setting::editSetting('payment_securetrading_ws', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(request::$post['payment_securetrading_ws_site_reference'])) {
			$data['payment_securetrading_ws_site_reference'] = request::$post['payment_securetrading_ws_site_reference'];
		} else {
			$data['payment_securetrading_ws_site_reference'] = config::get('payment_securetrading_ws_site_reference');
		}

		if (isset(request::$post['payment_securetrading_ws_username'])) {
			$data['payment_securetrading_ws_username'] = request::$post['payment_securetrading_ws_username'];
		} else {
			$data['payment_securetrading_ws_username'] = config::get('payment_securetrading_ws_username');
		}

		if (isset(request::$post['payment_securetrading_ws_password'])) {
			$data['payment_securetrading_ws_password'] = request::$post['payment_securetrading_ws_password'];
		} else {
			$data['payment_securetrading_ws_password'] = config::get('payment_securetrading_ws_password');
		}

		if (isset(request::$post['payment_securetrading_ws_csv_username'])) {
			$data['payment_securetrading_ws_csv_username'] = request::$post['payment_securetrading_ws_csv_username'];
		} else {
			$data['payment_securetrading_ws_csv_username'] = config::get('payment_securetrading_ws_csv_username');
		}

		if (isset(request::$post['payment_securetrading_ws_csv_password'])) {
			$data['payment_securetrading_ws_csv_password'] = request::$post['payment_securetrading_ws_csv_password'];
		} else {
			$data['payment_securetrading_ws_csv_password'] = config::get('payment_securetrading_ws_csv_password');
		}

		config::set('payment_securetrading_ws_3d_secure', 1);

		if (isset(request::$post['payment_securetrading_ws_3d_secure'])) {
			$data['payment_securetrading_ws_3d_secure'] = request::$post['payment_securetrading_ws_3d_secure'];
		} else {
			$data['payment_securetrading_ws_3d_secure'] = config::get('payment_securetrading_ws_3d_secure');
		}

		if (isset(request::$post['payment_securetrading_ws_cards_accepted'])) {
			$data['payment_securetrading_ws_cards_accepted'] = request::$post['payment_securetrading_ws_cards_accepted'];
		} else {
			$data['payment_securetrading_ws_cards_accepted'] = config::get('payment_securetrading_ws_cards_accepted');

			if ($data['payment_securetrading_ws_cards_accepted'] == null) {
				$data['payment_securetrading_ws_cards_accepted'] = array();
			}
		}

		if (isset(request::$post['payment_securetrading_ws_order_status_id'])) {
			$data['payment_securetrading_ws_order_status_id'] = request::$post['payment_securetrading_ws_order_status_id'];
		} elseif (config::get('payment_securetrading_ws_order_status_id') != '') {
			$data['payment_securetrading_ws_order_status_id'] = config::get('payment_securetrading_ws_order_status_id');
		} else {
			$data['payment_securetrading_ws_order_status_id'] = 1;
		}

		if (isset(request::$post['payment_securetrading_ws_failed_order_status_id'])) {
			$data['payment_securetrading_ws_failed_order_status_id'] = request::$post['payment_securetrading_ws_failed_order_status_id'];
		} elseif (config::get('payment_securetrading_ws_failed_order_status_id') != '') {
			$data['payment_securetrading_ws_failed_order_status_id'] = config::get('payment_securetrading_ws_failed_order_status_id');
		} else {
			$data['payment_securetrading_ws_failed_order_status_id'] = 10;
		}

		if (isset(request::$post['payment_securetrading_ws_declined_order_status_id'])) {
			$data['payment_securetrading_ws_declined_order_status_id'] = request::$post['payment_securetrading_ws_declined_order_status_id'];
		} elseif (config::get('payment_securetrading_ws_declined_order_status_id') != '') {
			$data['payment_securetrading_ws_declined_order_status_id'] = config::get('payment_securetrading_ws_declined_order_status_id');
		} else {
			$data['payment_securetrading_ws_declined_order_status_id'] = 8;
		}

		if (isset(request::$post['payment_securetrading_ws_refunded_order_status_id'])) {
			$data['payment_securetrading_ws_refunded_order_status_id'] = request::$post['payment_securetrading_ws_refunded_order_status_id'];
		} elseif (config::get('payment_securetrading_ws_refunded_order_status_id') != '') {
			$data['payment_securetrading_ws_refunded_order_status_id'] = config::get('payment_securetrading_ws_refunded_order_status_id');
		} else {
			$data['payment_securetrading_ws_refunded_order_status_id'] = 11;
		}

		if (isset(request::$post['payment_securetrading_ws_authorisation_reversed_order_status_id'])) {
			$data['payment_securetrading_ws_authorisation_reversed_order_status_id'] = request::$post['payment_securetrading_ws_authorisation_reversed_order_status_id'];
		} elseif (config::get('payment_securetrading_ws_authorisation_reversed_order_status_id') != '') {
			$data['payment_securetrading_ws_authorisation_reversed_order_status_id'] = config::get('payment_securetrading_ws_authorisation_reversed_order_status_id');
		} else {
			$data['payment_securetrading_ws_authorisation_reversed_order_status_id'] = 12;
		}

		if (isset(request::$post['payment_securetrading_ws_settle_status'])) {
			$data['payment_securetrading_ws_settle_status'] = request::$post['payment_securetrading_ws_settle_status'];
		} else {
			$data['payment_securetrading_ws_settle_status'] = config::get('payment_securetrading_ws_settle_status');
		}

		if (isset(request::$post['payment_securetrading_ws_settle_due_date'])) {
			$data['payment_securetrading_ws_settle_due_date'] = request::$post['payment_securetrading_ws_settle_due_date'];
		} else {
			$data['payment_securetrading_ws_settle_due_date'] = config::get('payment_securetrading_ws_settle_due_date');
		}

		if (isset(request::$post['payment_securetrading_ws_geo_zone'])) {
			$data['payment_securetrading_ws_geo_zone_id'] = request::$post['payment_securetrading_ws_geo_zone_id'];
		} else {
			$data['payment_securetrading_ws_geo_zone_id'] = config::get('payment_securetrading_ws_geo_zone_id');
		}

		if (isset(request::$post['payment_securetrading_ws_status'])) {
			$data['payment_securetrading_ws_status'] = request::$post['payment_securetrading_ws_status'];
		} else {
			$data['payment_securetrading_ws_status'] = config::get('payment_securetrading_ws_status');
		}

		if (isset(request::$post['payment_securetrading_ws_sort_order'])) {
			$data['payment_securetrading_ws_sort_order'] = request::$post['payment_securetrading_ws_sort_order'];
		} else {
			$data['payment_securetrading_ws_sort_order'] = config::get('payment_securetrading_ws_sort_order');
		}

		if (isset(request::$post['payment_securetrading_ws_total'])) {
			$data['payment_securetrading_ws_total'] = request::$post['payment_securetrading_ws_total'];
		} else {
			$data['payment_securetrading_ws_total'] = config::get('payment_securetrading_ws_total');
		}

		document::setTitle(language::get('heading_title'));

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['site_reference'])) {
			$data['error_site_reference'] = self::$error['site_reference'];
		} else {
			$data['error_site_reference'] = '';
		}

		if (isset(self::$error['username'])) {
			$data['error_username'] = self::$error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['cards_accepted'])) {
			$data['error_cards_accepted'] = self::$error['cards_accepted'];
		} else {
			$data['error_cards_accepted'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/securetrading_ws')
		);

		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();
		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		$data['cards'] = array(
			'AMEX' => 'American Express',
			'VISA' => 'Visa',
			'DELTA' => 'Visa Debit',
			'ELECTRON' => 'Visa Electron',
			'PURCHASING' => 'Visa Purchasing',
			'VPAY' => 'V Pay',
			'MASTERCARD' => 'MasterCard',
			'MASTERCARDDEBIT' => 'MasterCard Debit',
			'MAESTRO' => 'Maestro',
			'PAYPAL' => 'PayPal',
		);

		$data['settlement_statuses'] = array(
			'0' => language::get('text_pending_settlement'),
			'1' => language::get('text_pending_settlement_manually_overriden'),
			'2' => language::get('text_pending_suspended'),
			'100' => language::get('text_pending_settled'),
		);

		$data['action'] = url::link('extension/payment/securetrading_ws');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		$data['myst_status'] = !empty($data['securetrading_ws_csv_username']) && !empty($data['securetrading_ws_csv_password']);
		$data['hours'] = array();

		for ($i = 0; $i < 24; $i++) {
			$data['hours'][] = str_pad($i, 2, '0', STR_PAD_LEFT);
		}

		$data['minutes'] = array();

		for ($i = 0; $i < 60; $i++) {
			$data['minutes'][] = str_pad($i, 2, '0', STR_PAD_LEFT);
		}

		$data['currencies'] = admin_localisation_currency::getCurrencies();


		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/securetrading_ws', $data));
	}

	public static function install() {
		admin_extension_payment_securetrading_ws::install();
	}

	public static function uninstall() {
		admin_extension_payment_securetrading_ws::uninstall();
	}

	public static function downloadTransactions() {
		load::language('extension/payment/securetrading_ws');

		$csv_data = request::$post;
		$csv_data['detail'] = true;

		$response = admin_extension_payment_securetrading_ws::getCsv($csv_data);

		response::addheader('Content-Type: application/octet-stream');
		response::addheader('Content-Disposition: attachment; filename="' . language::get('text_transactions') . '.csv"');
		response::addheader('Expires: 0');
		response::addheader('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		response::addheader('Pragma: public');
		response::addheader('Content-Length: ' . strlen($response));

		response::setOutput($response);
	}

	public static function showTransactions() {
		load::language('extension/payment/securetrading_ws');

		$csv_data = request::$post;
		$csv_data['detail'] = false;

		$response = admin_extension_payment_securetrading_ws::getCsv($csv_data);

		$data['transactions'] = array();

		$status_mapping = array(
			'0' => language::get('text_ok'),
			'70000' => language::get('text_denied'),
		);

		$settle_status_mapping = array(
			'0' => language::get('text_pending_settlement'),
			'1' => language::get('text_manual_settlement'),
			'2' => language::get('text_suspended'),
			'3' => language::get('text_cancelled'),
			'10' => language::get('text_settling'),
			'100' => language::get('text_settled'),
		);

		if ($response) {
			$lines = array_filter(explode("\n", $response));

			$csv = array();
			$keys = str_getcsv($lines[0]);

			for ($i = 1; $i < count($lines); $i++) {
				$csv[] = array_combine($keys, str_getcsv($lines[$i]));
			}

			foreach ($csv as $row) {
				$data['transactions'][] = array(
					'order_id' => $row['orderreference'],
					'order_href' => url::link('sale/order/info', '&order_id=' . $row['orderreference']),
					'transaction_reference' => $row['transactionreference'],
					'customer' => $row['billingfirstname'] . ' ' . $row['billinglastname'],
					'total' => $row['mainamount'],
					'currency' => $row['currencyiso3a'],
					'settle_status' => $settle_status_mapping[$row['settlestatus']],
					'status' => $status_mapping[$row['errorcode']],
					'type' => $row['requesttypedescription'],
					'payment_type' => $row['paymenttypedescription'],
				);
			}
		}

		return load::view('extension/payment/securetrading_ws_transactions', $data);
	}

	public static function order() {

		if (config::get('payment_securetrading_ws_status')) {

			$securetrading_ws_order = admin_extension_payment_securetrading_ws::getOrder(request::$get['order_id']);

			if (!empty($securetrading_ws_order)) {
				load::language('extension/payment/securetrading_ws');

				$securetrading_ws_order['total_released'] = admin_extension_payment_securetrading_ws::getTotalReleased($securetrading_ws_order['securetrading_ws_order_id']);

				$securetrading_ws_order['total_formatted'] = currency::format($securetrading_ws_order['total'], $securetrading_ws_order['currency_code'], false, false);
				$securetrading_ws_order['total_released_formatted'] = currency::format($securetrading_ws_order['total_released'], $securetrading_ws_order['currency_code'], false, false);

				$data['securetrading_ws_order'] = $securetrading_ws_order;

				$data['auto_settle'] = $securetrading_ws_order['settle_type'];

				$data['order_id'] = (int)request::$get['order_id'];
				
				
				return load::view('extension/payment/securetrading_ws_order', $data);
			}
		}
	}

	public static function void() {
		load::language('extension/payment/securetrading_ws');
		$json = array();

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '') {

			$securetrading_ws_order = admin_extension_payment_securetrading_ws::getOrder(request::$post['order_id']);

			$void_response = admin_extension_payment_securetrading_ws::void(request::$post['order_id']);

			admin_extension_payment_securetrading_ws::logger('Void result:\r\n' . print_r($void_response, 1));

			if ($void_response !== false) {
				$response_xml = simplexml_load_string($void_response);

				if ($response_xml::$response['type'] == 'ERROR' || (string)$response_xml::$response::$error::$code != '0') {
					$json['msg'] = (string)$response_xml::$response::$error::$message;
					$json['error'] = true;
				} else {

					admin_extension_payment_securetrading_ws::addTransaction($securetrading_ws_order['securetrading_ws_order_id'], 'reversed', 0.00);
					admin_extension_payment_securetrading_ws::updateVoidStatus($securetrading_ws_order['securetrading_ws_order_id'], 1);

					self::$data = array(
						'order_status_id' => config::get('payment_securetrading_ws_authorisation_reversed_order_status_id'),
						'notify' => false,
						'comment' => '',
					);


					admin_sale_order::addOrderHistory(request::$post['order_id'], self::$data);

					$json['msg'] = language::get('text_authorisation_reversed');
					$json['data']['created'] = date("Y-m-d H:i:s");
					$json['error'] = false;
				}
			} else {
				$json['msg'] = language::get('error_connection');
				$json['error'] = true;
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::setOutput(json_encode($json));
	}

	public static function release() {
		load::language('extension/payment/securetrading_ws');
		$json = array();

		$amount = number_format(request::$post['amount'], 2);

		if (isset(request::$post['order_id']) && request::$post['order_id'] != '' && isset($amount) && $amount > 0) {

			$securetrading_ws_order = admin_extension_payment_securetrading_ws::getOrder(request::$post['order_id']);

			$release_response = admin_extension_payment_securetrading_ws::release(request::$post['order_id'], $amount);

			admin_extension_payment_securetrading_ws::logger('Release result:\r\n' . print_r($release_response, 1));

			if ($release_response !== false) {
				$response_xml = simplexml_load_string($release_response);

				if ($response_xml::$response['type'] == 'ERROR' || (string)$response_xml::$response::$error::$code != '0') {
					$json['error'] = true;
					$json['msg'] = (string)$response_xml::$response::$error::$message;
				} else {
					admin_extension_payment_securetrading_ws::addTransaction($securetrading_ws_order['securetrading_ws_order_id'], 'payment', $amount);

					$total_released = admin_extension_payment_securetrading_ws::getTotalReleased($securetrading_ws_order['securetrading_ws_order_id']);

					if ($total_released >= $securetrading_ws_order['total'] || $securetrading_ws_order['settle_type'] == 100) {
						admin_extension_payment_securetrading_ws::updateReleaseStatus($securetrading_ws_order['securetrading_ws_order_id'], 1);
						$release_status = 1;
						$json['msg'] = language::get('text_release_ok_order');


						$history = array();
						$history['order_status_id'] = config::get('securetrading_ws_order_status_success_settled_id');
						$history['comment'] = '';
						$history['notify'] = '';

						admin_sale_order::addOrderHistory(request::$post['order_id'], $history);
					} else {
						$release_status = 0;
						$json['msg'] = language::get('text_release_ok');
					}

					$json['data'] = array();
					$json['data']['created'] = date("Y-m-d H:i:s");
					$json['data']['amount'] = $amount;
					$json['data']['release_status'] = $release_status;
					$json['data']['total'] = (double)$total_released;
					$json['error'] = false;
				}
			} else {
				$json['error'] = true;
				$json['msg'] = language::get('error_connection');
			}
		} else {
			$json['error'] = true;
			$json['msg'] = language::get('error_data_missing');
		}

		response::setOutput(json_encode($json));
	}

	public static function rebate() {
		load::language('extension/payment/securetrading_ws');
		$json = array();

		if (isset(request::$post['order_id']) && !empty(request::$post['order_id'])) {

			$securetrading_ws_order = admin_extension_payment_securetrading_ws::getOrder(request::$post['order_id']);

			$amount = number_format(request::$post['amount'], 2);

			$rebate_response = admin_extension_payment_securetrading_ws::rebate(request::$post['order_id'], $amount);

			admin_extension_payment_securetrading_ws::logger('Rebate result:\r\n' . print_r($rebate_response, 1));

			if ($rebate_response !== false) {
				$response_xml = simplexml_load_string($rebate_response);

				$error_code = (string)$response_xml::$response::$error::$code;

				if ($error_code == '0') {

					admin_extension_payment_securetrading_ws::addTransaction($securetrading_ws_order['securetrading_ws_order_id'], 'rebate', $amount * -1);

					$total_rebated = admin_extension_payment_securetrading_ws::getTotalRebated($securetrading_ws_order['securetrading_ws_order_id']);
					$total_released = admin_extension_payment_securetrading_ws::getTotalReleased($securetrading_ws_order['securetrading_ws_order_id']);

					if ($total_released <= 0 && $securetrading_ws_order['release_status'] == 1) {
						$json['status'] = 1;
						$json['message'] = language::get('text_refund_issued');

						admin_extension_payment_securetrading_ws::updateRebateStatus($securetrading_ws_order['securetrading_ws_order_id'], 1);
						$rebate_status = 1;
						$json['msg'] = language::get('text_rebate_ok_order');


						$history = array();
						$history['order_status_id'] = config::get('payment_securetrading_ws_refunded_order_status_id');
						$history['comment'] = '';
						$history['notify'] = '';

						admin_sale_order::addOrderHistory(request::$post['order_id'], $history);
					} else {
						$rebate_status = 0;
						$json['msg'] = language::get('text_rebate_ok');
					}

					$json['data'] = array();
					$json['data']['created'] = date("Y-m-d H:i:s");
					$json['data']['amount'] = $amount * -1;
					$json['data']['total_released'] = (double)$total_released;
					$json['data']['total_rebated'] = (double)$total_rebated;
					$json['data']['rebate_status'] = $rebate_status;
					$json['error'] = false;
				} else {
					$json['error'] = true;
					$json['msg'] = (string)$response_xml::$response::$error::$message;
				}
			} else {
				$json['status'] = 0;
				$json['message'] = language::get('error_connection');
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/securetrading_pp')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_securetrading_ws_site_reference']) {
			self::$error['site_reference'] = language::get('error_site_reference');
		}

		if (!request::$post['payment_securetrading_ws_username']) {
			self::$error['username'] = language::get('error_username');
		}

		if (!request::$post['payment_securetrading_ws_password']) {
			self::$error['password'] = language::get('error_password');
		}

		if (empty(request::$post['payment_securetrading_ws_cards_accepted'])) {
			self::$error['cards_accepted'] = language::get('error_cards_accepted');
		}

		return !self::$error;
	}
}
