<?php
class ControllerExtensionPaymentSkrill {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/skrill');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_skrill', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['email'])) {
			$data['error_email'] = self::$error['email'];
		} else {
			$data['error_email'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/skrill')
		);

		$data['action'] = url::link('extension/payment/skrill');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_skrill_email'])) {
			$data['payment_skrill_email'] = request::$post['payment_skrill_email'];
		} else {
			$data['payment_skrill_email'] = config::get('payment_skrill_email');
		}

		if (isset(request::$post['payment_skrill_secret'])) {
			$data['payment_skrill_secret'] = request::$post['payment_skrill_secret'];
		} else {
			$data['payment_skrill_secret'] = config::get('payment_skrill_secret');
		}

		if (isset(request::$post['payment_skrill_total'])) {
			$data['payment_skrill_total'] = request::$post['payment_skrill_total'];
		} else {
			$data['payment_skrill_total'] = config::get('payment_skrill_total');
		}

		if (isset(request::$post['payment_skrill_order_status_id'])) {
			$data['payment_skrill_order_status_id'] = request::$post['payment_skrill_order_status_id'];
		} else {
			$data['payment_skrill_order_status_id'] = config::get('payment_skrill_order_status_id');
		}

		if (isset(request::$post['payment_skrill_pending_status_id'])) {
			$data['payment_skrill_pending_status_id'] = request::$post['payment_skrill_pending_status_id'];
		} else {
			$data['payment_skrill_pending_status_id'] = config::get('payment_skrill_pending_status_id');
		}

		if (isset(request::$post['payment_skrill_canceled_status_id'])) {
			$data['payment_skrill_canceled_status_id'] = request::$post['payment_skrill_canceled_status_id'];
		} else {
			$data['payment_skrill_canceled_status_id'] = config::get('payment_skrill_canceled_status_id');
		}

		if (isset(request::$post['payment_skrill_failed_status_id'])) {
			$data['payment_skrill_failed_status_id'] = request::$post['payment_skrill_failed_status_id'];
		} else {
			$data['payment_skrill_failed_status_id'] = config::get('payment_skrill_failed_status_id');
		}

		if (isset(request::$post['payment_skrill_chargeback_status_id'])) {
			$data['payment_skrill_chargeback_status_id'] = request::$post['payment_skrill_chargeback_status_id'];
		} else {
			$data['payment_skrill_chargeback_status_id'] = config::get('payment_skrill_chargeback_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_skrill_geo_zone_id'])) {
			$data['payment_skrill_geo_zone_id'] = request::$post['payment_skrill_geo_zone_id'];
		} else {
			$data['payment_skrill_geo_zone_id'] = config::get('payment_skrill_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_skrill_status'])) {
			$data['payment_skrill_status'] = request::$post['payment_skrill_status'];
		} else {
			$data['payment_skrill_status'] = config::get('payment_skrill_status');
		}

		if (isset(request::$post['payment_skrill_sort_order'])) {
			$data['payment_skrill_sort_order'] = request::$post['payment_skrill_sort_order'];
		} else {
			$data['payment_skrill_sort_order'] = config::get('payment_skrill_sort_order');
		}

		if (isset(request::$post['payment_skrill_rid'])) {
			$data['payment_skrill_rid'] = request::$post['payment_skrill_rid'];
		} else {
			$data['payment_skrill_rid'] = config::get('payment_skrill_rid');
		}

		if (isset(request::$post['payment_skrill_custnote'])) {
			$data['payment_skrill_custnote'] = request::$post['payment_skrill_custnote'];
		} else {
			$data['payment_skrill_custnote'] = config::get('payment_skrill_custnote');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/skrill', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/skrill')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_skrill_email']) {
			self::$error['email'] = language::get('error_email');
		}

		return !self::$error;
	}
}