<?php
class ControllerExtensionPaymentTwoCheckout {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/twocheckout');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_twocheckout', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['account'])) {
			$data['error_account'] = self::$error['account'];
		} else {
			$data['error_account'] = '';
		}

		if (isset(self::$error['secret'])) {
			$data['error_secret'] = self::$error['secret'];
		} else {
			$data['error_secret'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/twocheckout')
		);

		$data['action'] = url::link('extension/payment/twocheckout');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_twocheckout_account'])) {
			$data['payment_twocheckout_account'] = request::$post['payment_twocheckout_account'];
		} else {
			$data['payment_twocheckout_account'] = config::get('payment_twocheckout_account');
		}

		if (isset(request::$post['payment_twocheckout_secret'])) {
			$data['payment_twocheckout_secret'] = request::$post['payment_twocheckout_secret'];
		} else {
			$data['payment_twocheckout_secret'] = config::get('payment_twocheckout_secret');
		}

		if (isset(request::$post['payment_twocheckout_display'])) {
			$data['payment_twocheckout_display'] = request::$post['payment_twocheckout_display'];
		} else {
			$data['payment_twocheckout_display'] = config::get('payment_twocheckout_display');
		}

		if (isset(request::$post['payment_twocheckout_test'])) {
			$data['payment_twocheckout_test'] = request::$post['payment_twocheckout_test'];
		} else {
			$data['payment_twocheckout_test'] = config::get('payment_twocheckout_test');
		}

		if (isset(request::$post['payment_twocheckout_total'])) {
			$data['payment_twocheckout_total'] = request::$post['payment_twocheckout_total'];
		} else {
			$data['payment_twocheckout_total'] = config::get('payment_twocheckout_total');
		}

		if (isset(request::$post['payment_twocheckout_order_status_id'])) {
			$data['payment_twocheckout_order_status_id'] = request::$post['payment_twocheckout_order_status_id'];
		} else {
			$data['payment_twocheckout_order_status_id'] = config::get('payment_twocheckout_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_twocheckout_geo_zone_id'])) {
			$data['payment_twocheckout_geo_zone_id'] = request::$post['payment_twocheckout_geo_zone_id'];
		} else {
			$data['payment_twocheckout_geo_zone_id'] = config::get('payment_twocheckout_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_twocheckout_status'])) {
			$data['payment_twocheckout_status'] = request::$post['payment_twocheckout_status'];
		} else {
			$data['payment_twocheckout_status'] = config::get('payment_twocheckout_status');
		}

		if (isset(request::$post['payment_twocheckout_sort_order'])) {
			$data['payment_twocheckout_sort_order'] = request::$post['payment_twocheckout_sort_order'];
		} else {
			$data['payment_twocheckout_sort_order'] = config::get('payment_twocheckout_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/twocheckout', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/twocheckout')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_twocheckout_account']) {
			self::$error['account'] = language::get('error_account');
		}

		if (!request::$post['payment_twocheckout_secret']) {
			self::$error['secret'] = language::get('error_secret');
		}

		return !self::$error;
	}
}