<?php
class ControllerExtensionPaymentWebPaymentSoftware {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/web_payment_software');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_web_payment_software', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['login'])) {
			$data['error_login'] = self::$error['login'];
		} else {
			$data['error_login'] = '';
		}

		if (isset(self::$error['key'])) {
			$data['error_key'] = self::$error['key'];
		} else {
			$data['error_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/web_payment_software')
		);

		$data['action'] = url::link('extension/payment/web_payment_software');
		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_web_payment_software_merchant_name'])) {
			$data['payment_web_payment_software_merchant_name'] = request::$post['payment_web_payment_software_merchant_name'];
		} else {
			$data['payment_web_payment_software_merchant_name'] = config::get('payment_web_payment_software_merchant_name');
		}

		if (isset(request::$post['payment_web_payment_software_merchant_key'])) {
			$data['payment_web_payment_software_merchant_key'] = request::$post['payment_web_payment_software_merchant_key'];
		} else {
			$data['payment_web_payment_software_merchant_key'] = config::get('payment_web_payment_software_merchant_key');
		}

		if (isset(request::$post['payment_web_payment_software_mode'])) {
			$data['payment_web_payment_software_mode'] = request::$post['payment_web_payment_software_mode'];
		} else {
			$data['payment_web_payment_software_mode'] = config::get('payment_web_payment_software_mode');
		}

		if (isset(request::$post['payment_web_payment_software_method'])) {
			$data['payment_web_payment_software_method'] = request::$post['payment_web_payment_software_method'];
		} else {
			$data['payment_web_payment_software_method'] = config::get('payment_web_payment_software_method');
		}

		if (isset(request::$post['payment_web_payment_software_order_status_id'])) {
			$data['payment_web_payment_software_order_status_id'] = request::$post['payment_web_payment_software_order_status_id'];
		} else {
			$data['payment_web_payment_software_order_status_id'] = config::get('payment_web_payment_software_order_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_web_payment_software_geo_zone_id'])) {
			$data['payment_web_payment_software_geo_zone_id'] = request::$post['payment_web_payment_software_geo_zone_id'];
		} else {
			$data['payment_web_payment_software_geo_zone_id'] = config::get('payment_web_payment_software_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['payment_web_payment_software_status'])) {
			$data['payment_web_payment_software_status'] = request::$post['payment_web_payment_software_status'];
		} else {
			$data['payment_web_payment_software_status'] = config::get('payment_web_payment_software_status');
		}

		if (isset(request::$post['payment_web_payment_software_total'])) {
			$data['payment_web_payment_software_total'] = request::$post['payment_web_payment_software_total'];
		} else {
			$data['payment_web_payment_software_total'] = config::get('payment_web_payment_software_total');
		}

		if (isset(request::$post['payment_web_payment_software_sort_order'])) {
			$data['payment_web_payment_software_sort_order'] = request::$post['payment_web_payment_software_sort_order'];
		} else {
			$data['payment_web_payment_software_sort_order'] = config::get('payment_web_payment_software_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/web_payment_software', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/web_payment_software')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_web_payment_software_merchant_name']) {
			self::$error['login'] = language::get('error_login');
		}

		if (!request::$post['payment_web_payment_software_merchant_key']) {
			self::$error['key'] = language::get('error_key');
		}

		return !self::$error;
	}
}