<?php
class ControllerExtensionPaymentWorldpay {
	private static $error = array();

	public static function index() {
		load::language('extension/payment/worldpay');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('payment_worldpay', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=payment'));
		}

		if (isset(self::$error['error_service_key'])) {
			$data['error_service_key'] = self::$error['error_service_key'];
		} else {
			$data['error_service_key'] = '';
		}

		if (isset(self::$error['error_client_key'])) {
			$data['error_client_key'] = self::$error['error_client_key'];
		} else {
			$data['error_client_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=payment')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/payment/worldpay')
		);

		$data['action'] = url::link('extension/payment/worldpay');

		$data['cancel'] = url::link('marketplace/extension', '&type=payment');

		if (isset(request::$post['payment_worldpay_service_key'])) {
			$data['payment_worldpay_service_key'] = request::$post['payment_worldpay_service_key'];
		} else {
			$data['payment_worldpay_service_key'] = config::get('payment_worldpay_service_key');
		}

		if (isset(request::$post['payment_worldpay_client_key'])) {
			$data['payment_worldpay_client_key'] = request::$post['payment_worldpay_client_key'];
		} else {
			$data['payment_worldpay_client_key'] = config::get('payment_worldpay_client_key');
		}

		if (isset(request::$post['payment_worldpay_total'])) {
			$data['payment_worldpay_total'] = request::$post['payment_worldpay_total'];
		} else {
			$data['payment_worldpay_total'] = config::get('payment_worldpay_total');
		}

		if (isset(request::$post['payment_worldpay_card'])) {
			$data['payment_worldpay_card'] = request::$post['payment_worldpay_card'];
		} else {
			$data['payment_worldpay_card'] = config::get('payment_worldpay_card');
		}

		if (isset(request::$post['payment_worldpay_order_status_id'])) {
			$data['payment_worldpay_order_status_id'] = request::$post['payment_worldpay_order_status_id'];
		} else {
			$data['payment_worldpay_order_status_id'] = config::get('payment_worldpay_order_status_id');
		}

		if (isset(request::$post['payment_worldpay_geo_zone_id'])) {
			$data['payment_worldpay_geo_zone_id'] = request::$post['payment_worldpay_geo_zone_id'];
		} else {
			$data['payment_worldpay_geo_zone_id'] = config::get('payment_worldpay_geo_zone_id');
		}

		if (isset(request::$post['payment_worldpay_status'])) {
			$data['payment_worldpay_status'] = request::$post['payment_worldpay_status'];
		} else {
			$data['payment_worldpay_status'] = config::get('payment_worldpay_status');
		}

		if (isset(request::$post['payment_worldpay_debug'])) {
			$data['payment_worldpay_debug'] = request::$post['payment_worldpay_debug'];
		} else {
			$data['payment_worldpay_debug'] = config::get('payment_worldpay_debug');
		}

		if (isset(request::$post['payment_worldpay_sort_order'])) {
			$data['payment_worldpay_sort_order'] = request::$post['payment_worldpay_sort_order'];
		} else {
			$data['payment_worldpay_sort_order'] = config::get('payment_worldpay_sort_order');
		}

		if (isset(request::$post['payment_worldpay_secret_token'])) {
			$data['payment_worldpay_secret_token'] = request::$post['payment_worldpay_secret_token'];
		} elseif (config::get('payment_worldpay_secret_token')) {
			$data['payment_worldpay_secret_token'] = config::get('payment_worldpay_secret_token');
		} else {
			$data['payment_worldpay_secret_token'] = sha1(uniqid(mt_rand(), 1));
		}

		$data['payment_worldpay_webhook_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/worldpay/webhook&token=' . $data['payment_worldpay_secret_token'];

		$data['payment_worldpay_cron_job_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/worldpay/cron&token=' . $data['payment_worldpay_secret_token'];

		if (config::get('payment_worldpay_last_cron_job_run')) {
			$data['payment_worldpay_last_cron_job_run'] = config::get('payment_worldpay_last_cron_job_run');
		} else {
			$data['payment_worldpay_last_cron_job_run'] = '';
		}
		

		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();
		

		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['payment_worldpay_success_status_id'])) {
			$data['payment_worldpay_success_status_id'] = request::$post['payment_worldpay_success_status_id'];
		} else {
			$data['payment_worldpay_success_status_id'] = config::get('payment_worldpay_success_status_id');
		}

		if (isset(request::$post['payment_worldpay_failed_status_id'])) {
			$data['payment_worldpay_failed_status_id'] = request::$post['payment_worldpay_failed_status_id'];
		} else {
			$data['payment_worldpay_failed_status_id'] = config::get('payment_worldpay_failed_status_id');
		}

		if (isset(request::$post['payment_worldpay_settled_status_id'])) {
			$data['payment_worldpay_settled_status_id'] = request::$post['payment_worldpay_settled_status_id'];
		} else {
			$data['payment_worldpay_settled_status_id'] = config::get('payment_worldpay_settled_status_id');
		}

		if (isset(request::$post['payment_worldpay_refunded_status_id'])) {
			$data['payment_worldpay_refunded_status_id'] = request::$post['payment_worldpay_refunded_status_id'];
		} else {
			$data['payment_worldpay_refunded_status_id'] = config::get('payment_worldpay_refunded_status_id');
		}

		if (isset(request::$post['payment_worldpay_partially_refunded_status_id'])) {
			$data['payment_worldpay_partially_refunded_status_id'] = request::$post['payment_worldpay_partially_refunded_status_id'];
		} else {
			$data['payment_worldpay_partially_refunded_status_id'] = config::get('payment_worldpay_partially_refunded_status_id');
		}

		if (isset(request::$post['payment_worldpay_charged_back_status_id'])) {
			$data['payment_worldpay_charged_back_status_id'] = request::$post['payment_worldpay_charged_back_status_id'];
		} else {
			$data['payment_worldpay_charged_back_status_id'] = config::get('payment_worldpay_charged_back_status_id');
		}

		if (isset(request::$post['payment_worldpay_information_requested_status_id'])) {
			$data['payment_worldpay_information_requested_status_id'] = request::$post['payment_worldpay_information_requested_status_id'];
		} else {
			$data['payment_worldpay_information_requested_status_id'] = config::get('payment_worldpay_information_requested_status_id');
		}

		if (isset(request::$post['payment_worldpay_information_supplied_status_id'])) {
			$data['payment_worldpay_information_supplied_status_id'] = request::$post['payment_worldpay_information_supplied_status_id'];
		} else {
			$data['payment_worldpay_information_supplied_status_id'] = config::get('payment_worldpay_information_supplied_status_id');
		}

		if (isset(request::$post['payment_worldpay_chargeback_reversed_status_id'])) {
			$data['payment_worldpay_chargeback_reversed_status_id'] = request::$post['payment_worldpay_chargeback_reversed_status_id'];
		} else {
			$data['payment_worldpay_chargeback_reversed_status_id'] = config::get('payment_worldpay_chargeback_reversed_status_id');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/payment/worldpay', $data));
	}

	public static function install() {
		admin_extension_payment_worldpay::install();
	}

	public static function uninstall() {
		admin_extension_payment_worldpay::uninstall();
	}

	public static function order() {

		if (config::get('payment_worldpay_status')) {


			$worldpay_order = admin_extension_payment_worldpay::getOrder(request::$get['order_id']);

			if (!empty($worldpay_order)) {
				load::language('extension/payment/worldpay');

				$worldpay_order['total_released'] = admin_extension_payment_worldpay::getTotalReleased($worldpay_order['payment_worldpay_order_id']);

				$worldpay_order['total_formatted'] = currency::format($worldpay_order['total'], $worldpay_order['currency_code'], false);
				$worldpay_order['total_released_formatted'] = currency::format($worldpay_order['total_released'], $worldpay_order['currency_code'], false);

				$data['payment_worldpay_order'] = $worldpay_order;

				$data['order_id'] = (int)request::$get['order_id'];
				

				return load::view('extension/payment/worldpay_order', $data);
			}
		}
	}

	public static function refund() {
		load::language('extension/payment/worldpay');
		$json = array();

		if (isset(request::$post['order_id']) && !empty(request::$post['order_id'])) {

			$worldpay_order = admin_extension_payment_worldpay::getOrder(request::$post['order_id']);

			$refund_response = admin_extension_payment_worldpay::refund(request::$post['order_id'], request::$post['amount']);

			admin_extension_payment_worldpay::logger('Refund result: ' . print_r($refund_response, 1));

			if ($refund_response['status'] == 'success') {
				admin_extension_payment_worldpay::addTransaction($worldpay_order['payment_worldpay_order_id'], 'refund', request::$post['amount'] * -1);

				$total_refunded = admin_extension_payment_worldpay::getTotalRefunded($worldpay_order['payment_worldpay_order_id']);
				$total_released = admin_extension_payment_worldpay::getTotalReleased($worldpay_order['payment_worldpay_order_id']);

				admin_extension_payment_worldpay::updateRefundStatus($worldpay_order['payment_worldpay_order_id'], 1);

				$json['msg'] = language::get('text_refund_ok_order');
				$json['data'] = array();
				$json['data']['created'] = date("Y-m-d H:i:s");
				$json['data']['amount'] = currency::format((request::$post['amount'] * -1), $worldpay_order['currency_code'], false);
				$json['data']['total_released'] = currency::format($total_released, $worldpay_order['currency_code'], false);
				$json['data']['total_refund'] = currency::format($total_refunded, $worldpay_order['currency_code'], false);
				$json['data']['refund_status'] = 1;
				$json['error'] = false;
			} else {
				$json['error'] = true;
				$json['msg'] = isset($refund_response['message']) && !empty($refund_response['message']) ? (string)$refund_response['message'] : 'Unable to refund';
			}
		} else {
			$json['error'] = true;
			$json['msg'] = 'Missing data';
		}

		response::setOutput(json_encode($json));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/payment/worldpay')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['payment_worldpay_service_key']) {
			self::$error['error_service_key'] = language::get('error_service_key');
		}

		if (!request::$post['payment_worldpay_client_key']) {
			self::$error['error_client_key'] = language::get('error_client_key');
		}

		return !self::$error;
	}
}
