<?php
class ControllerExtensionShippingAusPost {
	private static $error = array();

	public static function index() {
		load::language('extension/shipping/auspost');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('shipping_auspost', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=shipping'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['api'])) {
			$data['error_api'] = self::$error['api'];
		} else {
			$data['error_api'] = '';
		}

		if (isset(self::$error['postcode'])) {
			$data['error_postcode'] = self::$error['postcode'];
		} else {
			$data['error_postcode'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=shipping')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/shipping/auspost')
		);

		$data['action'] = url::link('extension/shipping/auspost');

		$data['cancel'] = url::link('marketplace/extension', '&type=shipping');

		if (isset(request::$post['shipping_auspost_postcode'])) {
			$data['shipping_auspost_postcode'] = request::$post['shipping_auspost_postcode'];
		} else {
			$data['shipping_auspost_postcode'] = config::get('shipping_auspost_postcode');
		}

		if (isset(request::$post['shipping_auspost_api'])) {
			$data['shipping_auspost_api'] = request::$post['shipping_auspost_api'];
		} else {
			$data['shipping_auspost_api'] = config::get('shipping_auspost_api');
		}

		if (isset(request::$post['shipping_auspost_weight_class_id'])) {
			$data['shipping_auspost_weight_class_id'] = request::$post['shipping_auspost_weight_class_id'];
		} else {
			$data['shipping_auspost_weight_class_id'] = config::get('shipping_auspost_weight_class_id');
		}


		$data['weight_classes'] = admin_localisation_weight_class::getWeightClasses();

		if (isset(request::$post['shipping_auspost_tax_class_id'])) {
			$data['shipping_auspost_tax_class_id'] = request::$post['shipping_auspost_tax_class_id'];
		} else {
			$data['shipping_auspost_tax_class_id'] = config::get('shipping_auspost_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['shipping_auspost_geo_zone_id'])) {
			$data['shipping_auspost_geo_zone_id'] = request::$post['shipping_auspost_geo_zone_id'];
		} else {
			$data['shipping_auspost_geo_zone_id'] = config::get('shipping_auspost_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['shipping_auspost_status'])) {
			$data['shipping_auspost_status'] = request::$post['shipping_auspost_status'];
		} else {
			$data['shipping_auspost_status'] = config::get('shipping_auspost_status');
		}

		if (isset(request::$post['shipping_auspost_sort_order'])) {
			$data['shipping_auspost_sort_order'] = request::$post['shipping_auspost_sort_order'];
		} else {
			$data['shipping_auspost_sort_order'] = config::get('shipping_auspost_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/shipping/auspost', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/shipping/auspost')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (empty(request::$post['shipping_auspost_api'])) {
			self::$error['api'] = language::get('error_api');
		}

		if (!preg_match('/^[0-9]{4}$/', request::$post['shipping_auspost_postcode'])) {
			self::$error['postcode'] = language::get('error_postcode');
		}

		return !self::$error;
	}
}