<?php
class ControllerExtensionShippingECShip {
	private static $error = array();

	public static function index() {
		load::language('extension/shipping/ec_ship');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('shipping_ec_ship', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=shipping'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['username'])) {
			$data['error_username'] = self::$error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset(self::$error['api_username'])) {
			$data['error_api_username'] = self::$error['entry_api_username'];
		} else {
			$data['error_api_username'] = '';
		}

		if (isset(self::$error['api_key'])) {
			$data['error_api_key'] = self::$error['api_key'];
		} else {
			$data['error_api_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=shipping')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/shipping/ec_ship')
		);

		$data['action'] = url::link('extension/shipping/ec_ship');

		$data['cancel'] = url::link('marketplace/extension', '&type=shipping');

		if (isset(request::$post['shipping_ec_ship_api_key'])) {
			$data['shipping_ec_ship_api_key'] = request::$post['shipping_ec_ship_api_key'];
		} else {
			$data['shipping_ec_ship_api_key'] = config::get('shipping_ec_ship_api_key');
		}

		if (isset(request::$post['shipping_ec_ship_username'])) {
			$data['shipping_ec_ship_username'] = request::$post['shipping_ec_ship_username'];
		} else {
			$data['shipping_ec_ship_username'] = config::get('shipping_ec_ship_username');
		}

		if (isset(request::$post['shipping_ec_ship_api_username'])) {
			$data['shipping_ec_ship_api_username'] = request::$post['shipping_ec_ship_api_username'];
		} else {
			$data['shipping_ec_ship_api_username'] = config::get('shipping_ec_ship_api_username');
		}

		if (isset(request::$post['shipping_ec_ship_test'])) {
			$data['shipping_ec_ship_test'] = request::$post['shipping_ec_ship_test'];
		} else {
			$data['shipping_ec_ship_test'] = config::get('shipping_ec_ship_test');
		}

		if (isset(request::$post['shipping_ec_ship_air_registered_mail'])) {
			$data['shipping_ec_ship_air_registered_mail'] = request::$post['shipping_ec_ship_air_registered_mail'];
		} else {
			$data['shipping_ec_ship_air_registered_mail'] = config::get('shipping_ec_ship_air_registered_mail');
		}

		if (isset(request::$post['shipping_ec_ship_air_parcel'])) {
			$data['shipping_ec_ship_air_parcel'] = request::$post['shipping_ec_ship_air_parcel'];
		} else {
			$data['shipping_ec_ship_air_parcel'] = config::get('shipping_ec_ship_air_parcel');
		}

		if (isset(request::$post['shipping_ec_ship_e_express_service_to_us'])) {
			$data['shipping_ec_ship_e_express_service_to_us'] = request::$post['shipping_ec_ship_e_express_service_to_us'];
		} else {
			$data['shipping_ec_ship_e_express_service_to_us'] = config::get('shipping_ec_ship_e_express_service_to_us');
		}

		if (isset(request::$post['shipping_ec_ship_e_express_service_to_canada'])) {
			$data['shipping_ec_ship_e_express_service_to_canada'] = request::$post['shipping_ec_ship_e_express_service_to_canada'];
		} else {
			$data['shipping_ec_ship_e_express_service_to_canada'] = config::get('shipping_ec_ship_e_express_service_to_canada');
		}

		if (isset(request::$post['shipping_ec_ship_e_express_service_to_united_kingdom'])) {
			$data['shipping_ec_ship_e_express_service_to_united_kingdom'] = request::$post['shipping_ec_ship_e_express_service_to_united_kingdom'];
		} else {
			$data['shipping_ec_ship_e_express_service_to_united_kingdom'] = config::get('shipping_ec_ship_e_express_service_to_united_kingdom');
		}

		if (isset(request::$post['shipping_ec_ship_e_express_service_to_russia'])) {
			$data['shipping_ec_ship_e_express_service_to_russia'] = request::$post['shipping_ec_ship_e_express_service_to_russia'];
		} else {
			$data['shipping_ec_ship_e_express_service_to_russia'] = config::get('shipping_ec_ship_e_express_service_to_russia');
		}

		if (isset(request::$post['shipping_ec_ship_e_express_service_one'])) {
			$data['shipping_ec_ship_e_express_service_one'] = request::$post['shipping_ec_ship_e_express_service_one'];
		} else {
			$data['shipping_ec_ship_e_express_service_one'] = config::get('shipping_ec_ship_e_express_service_one');
		}

		if (isset(request::$post['shipping_ec_ship_e_express_service_two'])) {
			$data['shipping_ec_ship_e_express_service_two'] = request::$post['shipping_ec_ship_e_express_service_two'];
		} else {
			$data['shipping_ec_ship_e_express_service_two'] = config::get('shipping_ec_ship_e_express_service_two');
		}

		if (isset(request::$post['shipping_ec_ship_speed_post'])) {
			$data['shipping_ec_ship_speed_post'] = request::$post['shipping_ec_ship_speed_post'];
		} else {
			$data['shipping_ec_ship_speed_post'] = config::get('shipping_ec_ship_speed_post');
		}

		if (isset(request::$post['shipping_ec_ship_smart_post'])) {
			$data['shipping_ec_ship_smart_post'] = request::$post['shipping_ec_ship_smart_post'];
		} else {
			$data['shipping_ec_ship_smart_post'] = config::get('shipping_ec_ship_smart_post');
		}

		if (isset(request::$post['shipping_ec_ship_local_courier_post'])) {
			$data['shipping_ec_ship_local_courier_post'] = request::$post['shipping_ec_ship_local_courier_post'];
		} else {
			$data['shipping_ec_ship_local_courier_post'] = config::get('shipping_ec_ship_local_courier_post');
		}

		if (isset(request::$post['shipping_ec_ship_local_parcel'])) {
			$data['shipping_ec_ship_local_parcel'] = request::$post['shipping_ec_ship_local_parcel'];
		} else {
			$data['shipping_ec_ship_local_parcel'] = config::get('shipping_ec_ship_local_parcel');
		}

		if (isset(request::$post['shipping_ec_ship_weight_class_id'])) {
			$data['shipping_ec_ship_weight_class_id'] = request::$post['shipping_ec_ship_weight_class_id'];
		} else {
			$data['shipping_ec_ship_weight_class_id'] = config::get('shipping_ec_ship_weight_class_id');
		}


		$data['weight_classes'] = admin_localisation_weight_class::getWeightClasses();

		if (isset(request::$post['shipping_ec_ship_tax_class_id'])) {
			$data['shipping_ec_ship_tax_class_id'] = request::$post['shipping_ec_ship_tax_class_id'];
		} else {
			$data['shipping_ec_ship_tax_class_id'] = config::get('shipping_ec_ship_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['shipping_ec_ship_geo_zone_id'])) {
			$data['shipping_ec_ship_geo_zone_id'] = request::$post['shipping_ec_ship_geo_zone_id'];
		} else {
			$data['shipping_ec_ship_geo_zone_id'] = config::get('shipping_ec_ship_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['shipping_ec_ship_status'])) {
			$data['shipping_ec_ship_status'] = request::$post['shipping_ec_ship_status'];
		} else {
			$data['shipping_ec_ship_status'] = config::get('shipping_ec_ship_status');
		}

		if (isset(request::$post['shipping_ec_ship_sort_order'])) {
			$data['shipping_ec_ship_sort_order'] = request::$post['shipping_ec_ship_sort_order'];
		} else {
			$data['shipping_ec_ship_sort_order'] = config::get('shipping_ec_ship_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/shipping/ec_ship', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/shipping/ec_ship')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['shipping_ec_ship_api_key']) {
			self::$error['api_key'] = language::get('error_api_key');
		}

		if (!request::$post['shipping_ec_ship_username']) {
			self::$error['username'] = language::get('error_username');
		}

		if (!request::$post['shipping_ec_ship_api_username']) {
			self::$error['api_username'] = language::get('error_api_username');
		}

		return !self::$error;
	}
}
