<?php
class ControllerExtensionShippingFedex {
	private static $error = array();

	public static function index() {
		load::language('extension/shipping/fedex');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('shipping_fedex', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=shipping'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['key'])) {
			$data['error_key'] = self::$error['key'];
		} else {
			$data['error_key'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['account'])) {
			$data['error_account'] = self::$error['account'];
		} else {
			$data['error_account'] = '';
		}

		if (isset(self::$error['meter'])) {
			$data['error_meter'] = self::$error['meter'];
		} else {
			$data['error_meter'] = '';
		}

		if (isset(self::$error['postcode'])) {
			$data['error_postcode'] = self::$error['postcode'];
		} else {
			$data['error_postcode'] = '';
		}

		if (isset(self::$error['dimension'])) {
			$data['error_dimension'] = self::$error['dimension'];
		} else {
			$data['error_dimension'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=shipping')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/shipping/fedex')
		);

		$data['action'] = url::link('extension/shipping/fedex');

		$data['cancel'] = url::link('marketplace/extension', '&type=shipping');

		if (isset(request::$post['shipping_fedex_key'])) {
			$data['shipping_fedex_key'] = request::$post['shipping_fedex_key'];
		} else {
			$data['shipping_fedex_key'] = config::get('shipping_fedex_key');
		}

		if (isset(request::$post['shipping_fedex_password'])) {
			$data['shipping_fedex_password'] = request::$post['shipping_fedex_password'];
		} else {
			$data['shipping_fedex_password'] = config::get('shipping_fedex_password');
		}

		if (isset(request::$post['shipping_fedex_account'])) {
			$data['shipping_fedex_account'] = request::$post['shipping_fedex_account'];
		} else {
			$data['shipping_fedex_account'] = config::get('shipping_fedex_account');
		}

		if (isset(request::$post['shipping_fedex_meter'])) {
			$data['shipping_fedex_meter'] = request::$post['shipping_fedex_meter'];
		} else {
			$data['shipping_fedex_meter'] = config::get('shipping_fedex_meter');
		}

		if (isset(request::$post['shipping_fedex_postcode'])) {
			$data['shipping_fedex_postcode'] = request::$post['shipping_fedex_postcode'];
		} else {
			$data['shipping_fedex_postcode'] = config::get('shipping_fedex_postcode');
		}

		if (isset(request::$post['shipping_fedex_test'])) {
			$data['shipping_fedex_test'] = request::$post['shipping_fedex_test'];
		} else {
			$data['shipping_fedex_test'] = config::get('shipping_fedex_test');
		}

		if (isset(request::$post['shipping_fedex_service'])) {
			$data['shipping_fedex_service'] = request::$post['shipping_fedex_service'];
		} elseif (config::has('shipping_fedex_service')) {
			$data['shipping_fedex_service'] = config::get('shipping_fedex_service');
		} else {
			$data['shipping_fedex_service'] = array();
		}

		$data['services'] = array();

		$data['services'][] = array(
			'text'  => language::get('text_europe_first_international_priority'),
			'value' => 'EUROPE_FIRST_INTERNATIONAL_PRIORITY'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_1_day_freight'),
			'value' => 'FEDEX_1_DAY_FREIGHT'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_2_day'),
			'value' => 'FEDEX_2_DAY'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_2_day_am'),
			'value' => 'FEDEX_2_DAY_AM'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_2_day_freight'),
			'value' => 'FEDEX_2_DAY_FREIGHT'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_3_day_freight'),
			'value' => 'FEDEX_3_DAY_FREIGHT'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_express_saver'),
			'value' => 'FEDEX_EXPRESS_SAVER'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_first_freight'),
			'value' => 'FEDEX_FIRST_FREIGHT'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_freight_economy'),
			'value' => 'FEDEX_FREIGHT_ECONOMY'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_freight_priority'),
			'value' => 'FEDEX_FREIGHT_PRIORITY'
		);

		$data['services'][] = array(
			'text'  => language::get('text_fedex_ground'),
			'value' => 'FEDEX_GROUND'
		);

		$data['services'][] = array(
			'text'  => language::get('text_first_overnight'),
			'value' => 'FIRST_OVERNIGHT'
		);

		$data['services'][] = array(
			'text'  => language::get('text_ground_home_delivery'),
			'value' => 'GROUND_HOME_DELIVERY'
		);

		$data['services'][] = array(
			'text'  => language::get('text_international_economy'),
			'value' => 'INTERNATIONAL_ECONOMY'
		);

		$data['services'][] = array(
			'text'  => language::get('text_international_economy_freight'),
			'value' => 'INTERNATIONAL_ECONOMY_FREIGHT'
		);

		$data['services'][] = array(
			'text'  => language::get('text_international_first'),
			'value' => 'INTERNATIONAL_FIRST'
		);

		$data['services'][] = array(
			'text'  => language::get('text_international_priority'),
			'value' => 'INTERNATIONAL_PRIORITY'
		);

		$data['services'][] = array(
			'text'  => language::get('text_international_priority_freight'),
			'value' => 'INTERNATIONAL_PRIORITY_FREIGHT'
		);

		$data['services'][] = array(
			'text'  => language::get('text_priority_overnight'),
			'value' => 'PRIORITY_OVERNIGHT'
		);

		$data['services'][] = array(
			'text'  => language::get('text_smart_post'),
			'value' => 'SMART_POST'
		);

		$data['services'][] = array(
			'text'  => language::get('text_standard_overnight'),
			'value' => 'STANDARD_OVERNIGHT'
		);

		if (isset(request::$post['shipping_fedex_length'])) {
			$data['shipping_fedex_length'] = request::$post['shipping_fedex_length'];
		} else {
			$data['shipping_fedex_length'] = config::get('shipping_fedex_length');
		}

		if (isset(request::$post['shipping_fedex_width'])) {
			$data['shipping_fedex_width'] = request::$post['shipping_fedex_width'];
		} else {
			$data['shipping_fedex_width'] = config::get('shipping_fedex_width');
		}

		if (isset(request::$post['shipping_fedex_height'])) {
			$data['shipping_fedex_height'] = request::$post['shipping_fedex_height'];
		} else {
			$data['shipping_fedex_height'] = config::get('shipping_fedex_height');
		}

		if (isset(request::$post['shipping_fedex_length_class_id'])) {
			$data['shipping_fedex_length_class_id'] = request::$post['shipping_fedex_length_class_id'];
		} else {
			$data['shipping_fedex_length_class_id'] = config::get('shipping_fedex_length_class_id');
		}


		$data['length_classes'] = admin_localisation_length_class::getLengthClasses();

		if (isset(request::$post['shipping_fedex_dropoff_type'])) {
			$data['shipping_fedex_dropoff_type'] = request::$post['shipping_fedex_dropoff_type'];
		} else {
			$data['shipping_fedex_dropoff_type'] = config::get('shipping_fedex_dropoff_type');
		}

		if (isset(request::$post['shipping_fedex_packaging_type'])) {
			$data['shipping_fedex_packaging_type'] = request::$post['shipping_fedex_packaging_type'];
		} else {
			$data['shipping_fedex_packaging_type'] = config::get('shipping_fedex_packaging_type');
		}

		if (isset(request::$post['shipping_fedex_rate_type'])) {
			$data['shipping_fedex_rate_type'] = request::$post['shipping_fedex_rate_type'];
		} else {
			$data['shipping_fedex_rate_type'] = config::get('shipping_fedex_rate_type');
		}

		if (isset(request::$post['shipping_fedex_destination_type'])) {
			$data['shipping_fedex_destination_type'] = request::$post['shipping_fedex_destination_type'];
		} else {
			$data['shipping_fedex_destination_type'] = config::get('shipping_fedex_destination_type');
		}

		if (isset(request::$post['shipping_fedex_display_time'])) {
			$data['shipping_fedex_display_time'] = request::$post['shipping_fedex_display_time'];
		} else {
			$data['shipping_fedex_display_time'] = config::get('shipping_fedex_display_time');
		}

		if (isset(request::$post['shipping_fedex_display_weight'])) {
			$data['shipping_fedex_display_weight'] = request::$post['shipping_fedex_display_weight'];
		} else {
			$data['shipping_fedex_display_weight'] = config::get('shipping_fedex_display_weight');
		}

		if (isset(request::$post['shipping_fedex_weight_class_id'])) {
			$data['shipping_fedex_weight_class_id'] = request::$post['shipping_fedex_weight_class_id'];
		} else {
			$data['shipping_fedex_weight_class_id'] = config::get('shipping_fedex_weight_class_id');
		}


		$data['weight_classes'] = admin_localisation_weight_class::getWeightClasses();

		if (isset(request::$post['shipping_fedex_tax_class_id'])) {
			$data['shipping_fedex_tax_class_id'] = request::$post['shipping_fedex_tax_class_id'];
		} else {
			$data['shipping_fedex_tax_class_id'] = config::get('shipping_fedex_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['shipping_fedex_geo_zone_id'])) {
			$data['shipping_fedex_geo_zone_id'] = request::$post['shipping_fedex_geo_zone_id'];
		} else {
			$data['shipping_fedex_geo_zone_id'] = config::get('shipping_fedex_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['shipping_fedex_status'])) {
			$data['shipping_fedex_status'] = request::$post['shipping_fedex_status'];
		} else {
			$data['shipping_fedex_status'] = config::get('shipping_fedex_status');
		}

		if (isset(request::$post['shipping_fedex_sort_order'])) {
			$data['shipping_fedex_sort_order'] = request::$post['shipping_fedex_sort_order'];
		} else {
			$data['shipping_fedex_sort_order'] = config::get('shipping_fedex_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/shipping/fedex', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/shipping/fedex')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['shipping_fedex_key']) {
			self::$error['key'] = language::get('error_key');
		}

		if (!request::$post['shipping_fedex_password']) {
			self::$error['password'] = language::get('error_password');
		}

		if (!request::$post['shipping_fedex_account']) {
			self::$error['account'] = language::get('error_account');
		}

		if (!request::$post['shipping_fedex_meter']) {
			self::$error['meter'] = language::get('error_meter');
		}

		if (!request::$post['shipping_fedex_postcode']) {
			self::$error['postcode'] = language::get('error_postcode');
		}

		if (!request::$post['shipping_fedex_length'] || !request::$post['shipping_fedex_width'] || !request::$post['shipping_fedex_height']) {
			self::$error['dimension'] = language::get('error_dimension');
		}

		return !self::$error;
	}
}
