<?php
class ControllerExtensionShippingItem {
	private static $error = array();

	public static function index() {
		load::language('extension/shipping/item');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('shipping_item', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=shipping'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=shipping')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/shipping/item')
		);

		$data['action'] = url::link('extension/shipping/item');

		$data['cancel'] = url::link('marketplace/extension', '&type=shipping');

		if (isset(request::$post['shipping_item_cost'])) {
			$data['shipping_item_cost'] = request::$post['shipping_item_cost'];
		} else {
			$data['shipping_item_cost'] = config::get('shipping_item_cost');
		}

		if (isset(request::$post['shipping_item_tax_class_id'])) {
			$data['shipping_item_tax_class_id'] = request::$post['shipping_item_tax_class_id'];
		} else {
			$data['shipping_item_tax_class_id'] = config::get('shipping_item_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['shipping_item_geo_zone_id'])) {
			$data['shipping_item_geo_zone_id'] = request::$post['shipping_item_geo_zone_id'];
		} else {
			$data['shipping_item_geo_zone_id'] = config::get('shipping_item_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['shipping_item_status'])) {
			$data['shipping_item_status'] = request::$post['shipping_item_status'];
		} else {
			$data['shipping_item_status'] = config::get('shipping_item_status');
		}

		if (isset(request::$post['shipping_item_sort_order'])) {
			$data['shipping_item_sort_order'] = request::$post['shipping_item_sort_order'];
		} else {
			$data['shipping_item_sort_order'] = config::get('shipping_item_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/shipping/item', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/shipping/item')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}