<?php
class ControllerExtensionShippingParcelforce48 {
	private static $error = array();

	public static function index() {
		load::language('extension/shipping/parcelforce_48');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('shipping_parcelforce_48', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=shipping'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=shipping')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/shipping/parcelforce_48')
		);

		$data['action'] = url::link('extension/shipping/parcelforce_48');

		$data['cancel'] = url::link('marketplace/extension', '&type=shipping');

		if (isset(request::$post['shipping_parcelforce_48_rate'])) {
			$data['shipping_parcelforce_48_rate'] = request::$post['shipping_parcelforce_48_rate'];
		} elseif (config::get('shipping_parcelforce_48_rate')) {
			$data['shipping_parcelforce_48_rate'] = config::get('shipping_parcelforce_48_rate');
		} else {
			$data['shipping_parcelforce_48_rate'] = '10:15.99,12:19.99,14:20.99,16:21.99,18:21.99,20:21.99,22:26.99,24:30.99,26:34.99,28:38.99,30:42.99,35:52.99,40:62.99,45:72.99,50:82.99,55:92.99,60:102.99,65:112.99,70:122.99,75:132.99,80:142.99,85:152.99,90:162.99,95:172.99,100:182.99';
		}

		if (isset(request::$post['shipping_parcelforce_48_insurance'])) {
			$data['shipping_parcelforce_48_insurance'] = request::$post['shipping_parcelforce_48_insurance'];
		} elseif (config::get('shipping_parcelforce_48_insurance')) {
			$data['shipping_parcelforce_48_insurance'] = config::get('shipping_parcelforce_48_insurance');
		} else {
			$data['shipping_parcelforce_48_insurance'] = '150:0,500:12,1000:24,1500:36,2000:48,2500:60';
		}

		if (isset(request::$post['shipping_parcelforce_48_display_weight'])) {
			$data['shipping_parcelforce_48_display_weight'] = request::$post['shipping_parcelforce_48_display_weight'];
		} else {
			$data['shipping_parcelforce_48_display_weight'] = config::get('shipping_parcelforce_48_display_weight');
		}

		if (isset(request::$post['shipping_parcelforce_48_display_insurance'])) {
			$data['shipping_parcelforce_48_display_insurance'] = request::$post['shipping_parcelforce_48_display_insurance'];
		} else {
			$data['shipping_parcelforce_48_display_insurance'] = config::get('shipping_parcelforce_48_display_insurance');
		}

		if (isset(request::$post['shipping_parcelforce_48_display_time'])) {
			$data['shipping_parcelforce_48_display_time'] = request::$post['shipping_parcelforce_48_display_time'];
		} else {
			$data['shipping_parcelforce_48_display_time'] = config::get('shipping_parcelforce_48_display_time');
		}

		if (isset(request::$post['shipping_parcelforce_48_tax_class_id'])) {
			$data['shipping_parcelforce_48_tax_class_id'] = request::$post['shipping_parcelforce_48_tax_class_id'];
		} else {
			$data['shipping_parcelforce_48_tax_class_id'] = config::get('shipping_parcelforce_48_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['shipping_parcelforce_48_geo_zone_id'])) {
			$data['shipping_parcelforce_48_geo_zone_id'] = request::$post['shipping_parcelforce_48_geo_zone_id'];
		} else {
			$data['shipping_parcelforce_48_geo_zone_id'] = config::get('shipping_parcelforce_48_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['shipping_parcelforce_48_status'])) {
			$data['shipping_parcelforce_48_status'] = request::$post['shipping_parcelforce_48_status'];
		} else {
			$data['shipping_parcelforce_48_status'] = config::get('shipping_parcelforce_48_status');
		}

		if (isset(request::$post['shipping_parcelforce_48_sort_order'])) {
			$data['shipping_parcelforce_48_sort_order'] = request::$post['shipping_parcelforce_48_sort_order'];
		} else {
			$data['shipping_parcelforce_48_sort_order'] = config::get('shipping_parcelforce_48_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/shipping/parcelforce_48', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/shipping/parcelforce_48')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}