<?php
class ControllerExtensionShippingUPS {
	private static $error = array();

	public static function index() {
		load::language('extension/shipping/ups');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('shipping_ups', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=shipping'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['key'])) {
			$data['error_key'] = self::$error['key'];
		} else {
			$data['error_key'] = '';
		}

		if (isset(self::$error['username'])) {
			$data['error_username'] = self::$error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset(self::$error['password'])) {
			$data['error_password'] = self::$error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset(self::$error['city'])) {
			$data['error_city'] = self::$error['city'];
		} else {
			$data['error_city'] = '';
		}

		if (isset(self::$error['state'])) {
			$data['error_state'] = self::$error['state'];
		} else {
			$data['error_state'] = '';
		}

		if (isset(self::$error['country'])) {
			$data['error_country'] = self::$error['country'];
		} else {
			$data['error_country'] = '';
		}

		if (isset(self::$error['dimension'])) {
			$data['error_dimension'] = self::$error['dimension'];
		} else {
			$data['error_dimension'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=shipping')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/shipping/ups')
		);

		$data['action'] = url::link('extension/shipping/ups');

		$data['cancel'] = url::link('marketplace/extension', '&type=shipping');

		if (isset(request::$post['shipping_ups_key'])) {
			$data['shipping_ups_key'] = request::$post['shipping_ups_key'];
		} else {
			$data['shipping_ups_key'] = config::get('shipping_ups_key');
		}

		if (isset(request::$post['shipping_ups_username'])) {
			$data['shipping_ups_username'] = request::$post['shipping_ups_username'];
		} else {
			$data['shipping_ups_username'] = config::get('shipping_ups_username');
		}

		if (isset(request::$post['shipping_ups_password'])) {
			$data['shipping_ups_password'] = request::$post['shipping_ups_password'];
		} else {
			$data['shipping_ups_password'] = config::get('shipping_ups_password');
		}

		if (isset(request::$post['shipping_ups_pickup'])) {
			$data['shipping_ups_pickup'] = request::$post['shipping_ups_pickup'];
		} else {
			$data['shipping_ups_pickup'] = config::get('shipping_ups_pickup');
		}

		$data['pickups'] = array();

		$data['pickups'][] = array(
			'value' => '01',
			'text'  => language::get('text_daily_pickup')
		);

		$data['pickups'][] = array(
			'value' => '03',
			'text'  => language::get('text_customer_counter')
		);

		$data['pickups'][] = array(
			'value' => '06',
			'text'  => language::get('text_one_time_pickup')
		);

		$data['pickups'][] = array(
			'value' => '07',
			'text'  => language::get('text_on_call_air_pickup')
		);

		$data['pickups'][] = array(
			'value' => '19',
			'text'  => language::get('text_letter_center')
		);

		$data['pickups'][] = array(
			'value' => '20',
			'text'  => language::get('text_air_service_center')
		);

		$data['pickups'][] = array(
			'value' => '11',
			'text'  => language::get('text_suggested_retail_rates')
		);

		if (isset(request::$post['shipping_ups_packaging'])) {
			$data['shipping_ups_packaging'] = request::$post['shipping_ups_packaging'];
		} else {
			$data['shipping_ups_packaging'] = config::get('shipping_ups_packaging');
		}

		$data['packages'] = array();

		$data['packages'][] = array(
			'value' => '02',
			'text'  => language::get('text_package')
		);

		$data['packages'][] = array(
			'value' => '01',
			'text'  => language::get('text_ups_letter')
		);

		$data['packages'][] = array(
			'value' => '03',
			'text'  => language::get('text_ups_tube')
		);

		$data['packages'][] = array(
			'value' => '04',
			'text'  => language::get('text_ups_pak')
		);

		$data['packages'][] = array(
			'value' => '21',
			'text'  => language::get('text_ups_express_box')
		);

		$data['packages'][] = array(
			'value' => '24',
			'text'  => language::get('text_ups_25kg_box')
		);

		$data['packages'][] = array(
			'value' => '25',
			'text'  => language::get('text_ups_10kg_box')
		);

		if (isset(request::$post['shipping_ups_classification'])) {
			$data['shipping_ups_classification'] = request::$post['shipping_ups_classification'];
		} else {
			$data['shipping_ups_classification'] = config::get('shipping_ups_classification');
		}

		$data['classifications'][] = array(
			'value' => '01',
			'text'  => '01'
		);

		$data['classifications'][] = array(
			'value' => '03',
			'text'  => '03'
		);

		$data['classifications'][] = array(
			'value' => '04',
			'text'  => '04'
		);

		if (isset(request::$post['shipping_ups_origin'])) {
			$data['shipping_ups_origin'] = request::$post['shipping_ups_origin'];
		} else {
			$data['shipping_ups_origin'] = config::get('shipping_ups_origin');
		}

		$data['origins'] = array();

		$data['origins'][] = array(
			'value' => 'US',
			'text'  => language::get('text_us')
		);

		$data['origins'][] = array(
			'value' => 'CA',
			'text'  => language::get('text_ca')
		);

		$data['origins'][] = array(
			'value' => 'EU',
			'text'  => language::get('text_eu')
		);

		$data['origins'][] = array(
			'value' => 'PR',
			'text'  => language::get('text_pr')
		);

		$data['origins'][] = array(
			'value' => 'MX',
			'text'  => language::get('text_mx')
		);

		$data['origins'][] = array(
			'value' => 'other',
			'text'  => language::get('text_other')
		);

		if (isset(request::$post['shipping_ups_city'])) {
			$data['shipping_ups_city'] = request::$post['shipping_ups_city'];
		} else {
			$data['shipping_ups_city'] = config::get('shipping_ups_city');
		}

		if (isset(request::$post['shipping_ups_state'])) {
			$data['shipping_ups_state'] = request::$post['shipping_ups_state'];
		} else {
			$data['shipping_ups_state'] = config::get('shipping_ups_state');
		}

		if (isset(request::$post['shipping_ups_country'])) {
			$data['shipping_ups_country'] = request::$post['shipping_ups_country'];
		} else {
			$data['shipping_ups_country'] = config::get('shipping_ups_country');
		}

		if (isset(request::$post['shipping_ups_postcode'])) {
			$data['shipping_ups_postcode'] = request::$post['shipping_ups_postcode'];
		} else {
			$data['shipping_ups_postcode'] = config::get('shipping_ups_postcode');
		}

		if (isset(request::$post['shipping_ups_test'])) {
			$data['shipping_ups_test'] = request::$post['shipping_ups_test'];
		} else {
			$data['shipping_ups_test'] = config::get('shipping_ups_test');
		}

		if (isset(request::$post['shipping_ups_quote_type'])) {
			$data['shipping_ups_quote_type'] = request::$post['shipping_ups_quote_type'];
		} else {
			$data['shipping_ups_quote_type'] = config::get('shipping_ups_quote_type');
		}

		$data['quote_types'] = array();

		$data['quote_types'][] = array(
			'value' => 'residential',
			'text'  => language::get('text_residential')
		);

		$data['quote_types'][] = array(
			'value' => 'commercial',
			'text'  => language::get('text_commercial')
		);

		// US
		if (isset(request::$post['shipping_ups_us_01'])) {
			$data['shipping_ups_us_01'] = request::$post['shipping_ups_us_01'];
		} else {
			$data['shipping_ups_us_01'] = config::get('shipping_ups_us_01');
		}

		if (isset(request::$post['shipping_ups_us_02'])) {
			$data['shipping_ups_us_02'] = request::$post['shipping_ups_us_02'];
		} else {
			$data['shipping_ups_us_02'] = config::get('shipping_ups_us_02');
		}

		if (isset(request::$post['shipping_ups_us_03'])) {
			$data['shipping_ups_us_03'] = request::$post['shipping_ups_us_03'];
		} else {
			$data['shipping_ups_us_03'] = config::get('shipping_ups_us_03');
		}

		if (isset(request::$post['shipping_ups_us_07'])) {
			$data['shipping_ups_us_07'] = request::$post['shipping_ups_us_07'];
		} else {
			$data['shipping_ups_us_07'] = config::get('shipping_ups_us_07');
		}

		if (isset(request::$post['shipping_ups_us_08'])) {
			$data['shipping_ups_us_08'] = request::$post['shipping_ups_us_08'];
		} else {
			$data['shipping_ups_us_08'] = config::get('shipping_ups_us_08');
		}

		if (isset(request::$post['shipping_ups_us_11'])) {
			$data['shipping_ups_us_11'] = request::$post['shipping_ups_us_11'];
		} else {
			$data['shipping_ups_us_11'] = config::get('shipping_ups_us_11');
		}

		if (isset(request::$post['shipping_ups_us_12'])) {
			$data['shipping_ups_us_12'] = request::$post['shipping_ups_us_12'];
		} else {
			$data['shipping_ups_us_12'] = config::get('shipping_ups_us_12');
		}

		if (isset(request::$post['shipping_ups_us_13'])) {
			$data['shipping_ups_us_13'] = request::$post['shipping_ups_us_13'];
		} else {
			$data['shipping_ups_us_13'] = config::get('shipping_ups_us_13');
		}

		if (isset(request::$post['shipping_ups_us_14'])) {
			$data['shipping_ups_us_14'] = request::$post['shipping_ups_us_14'];
		} else {
			$data['shipping_ups_us_14'] = config::get('shipping_ups_us_14');
		}

		if (isset(request::$post['shipping_ups_us_54'])) {
			$data['shipping_ups_us_54'] = request::$post['shipping_ups_us_54'];
		} else {
			$data['shipping_ups_us_54'] = config::get('shipping_ups_us_54');
		}

		if (isset(request::$post['shipping_ups_us_59'])) {
			$data['shipping_ups_us_59'] = request::$post['shipping_ups_us_59'];
		} else {
			$data['shipping_ups_us_59'] = config::get('shipping_ups_us_59');
		}

		if (isset(request::$post['shipping_ups_us_65'])) {
			$data['shipping_ups_us_65'] = request::$post['shipping_ups_us_65'];
		} else {
			$data['shipping_ups_us_65'] = config::get('shipping_ups_us_65');
		}

		// Puerto Rico
		if (isset(request::$post['shipping_ups_pr_01'])) {
			$data['shipping_ups_pr_01'] = request::$post['shipping_ups_pr_01'];
		} else {
			$data['shipping_ups_pr_01'] = config::get('shipping_ups_pr_01');
		}

		if (isset(request::$post['shipping_ups_pr_02'])) {
			$data['shipping_ups_pr_02'] = request::$post['shipping_ups_pr_02'];
		} else {
			$data['shipping_ups_pr_02'] = config::get('shipping_ups_pr_02');
		}

		if (isset(request::$post['shipping_ups_pr_03'])) {
			$data['shipping_ups_pr_03'] = request::$post['shipping_ups_pr_03'];
		} else {
			$data['shipping_ups_pr_03'] = config::get('shipping_ups_pr_03');
		}

		if (isset(request::$post['shipping_ups_pr_07'])) {
			$data['shipping_ups_pr_07'] = request::$post['shipping_ups_pr_07'];
		} else {
			$data['shipping_ups_pr_07'] = config::get('shipping_ups_pr_07');
		}

		if (isset(request::$post['shipping_ups_pr_08'])) {
			$data['shipping_ups_pr_08'] = request::$post['shipping_ups_pr_08'];
		} else {
			$data['shipping_ups_pr_08'] = config::get('shipping_ups_pr_08');
		}

		if (isset(request::$post['shipping_ups_pr_14'])) {
			$data['shipping_ups_pr_14'] = request::$post['shipping_ups_pr_14'];
		} else {
			$data['shipping_ups_pr_14'] = config::get('shipping_ups_pr_14');
		}

		if (isset(request::$post['shipping_ups_pr_54'])) {
			$data['shipping_ups_pr_54'] = request::$post['shipping_ups_pr_54'];
		} else {
			$data['shipping_ups_pr_54'] = config::get('shipping_ups_pr_54');
		}

		if (isset(request::$post['shipping_ups_pr_65'])) {
			$data['shipping_ups_pr_65'] = request::$post['shipping_ups_pr_65'];
		} else {
			$data['shipping_ups_pr_65'] = config::get('shipping_ups_pr_65');
		}

		// Canada
		if (isset(request::$post['shipping_ups_ca_01'])) {
			$data['shipping_ups_ca_01'] = request::$post['shipping_ups_ca_01'];
		} else {
			$data['shipping_ups_ca_01'] = config::get('shipping_ups_ca_01');
		}

		if (isset(request::$post['shipping_ups_ca_02'])) {
			$data['shipping_ups_ca_02'] = request::$post['shipping_ups_ca_02'];
		} else {
			$data['shipping_ups_ca_02'] = config::get('shipping_ups_ca_02');
		}

		if (isset(request::$post['shipping_ups_ca_07'])) {
			$data['shipping_ups_ca_07'] = request::$post['shipping_ups_ca_07'];
		} else {
			$data['shipping_ups_ca_07'] = config::get('shipping_ups_ca_07');
		}

		if (isset(request::$post['shipping_ups_ca_08'])) {
			$data['shipping_ups_ca_08'] = request::$post['shipping_ups_ca_08'];
		} else {
			$data['shipping_ups_ca_08'] = config::get('shipping_ups_ca_08');
		}

		if (isset(request::$post['shipping_ups_ca_11'])) {
			$data['shipping_ups_ca_11'] = request::$post['shipping_ups_ca_11'];
		} else {
			$data['shipping_ups_ca_11'] = config::get('shipping_ups_ca_11');
		}

		if (isset(request::$post['shipping_ups_ca_12'])) {
			$data['shipping_ups_ca_12'] = request::$post['shipping_ups_ca_12'];
		} else {
			$data['shipping_ups_ca_12'] = config::get('shipping_ups_ca_12');
		}

		if (isset(request::$post['shipping_ups_ca_13'])) {
			$data['shipping_ups_ca_13'] = request::$post['shipping_ups_ca_13'];
		} else {
			$data['shipping_ups_ca_13'] = config::get('shipping_ups_ca_13');
		}

		if (isset(request::$post['shipping_ups_ca_14'])) {
			$data['shipping_ups_ca_14'] = request::$post['shipping_ups_ca_14'];
		} else {
			$data['shipping_ups_ca_14'] = config::get('shipping_ups_ca_14');
		}

		if (isset(request::$post['shipping_ups_ca_54'])) {
			$data['shipping_ups_ca_54'] = request::$post['shipping_ups_ca_54'];
		} else {
			$data['shipping_ups_ca_54'] = config::get('shipping_ups_ca_54');
		}

		if (isset(request::$post['shipping_ups_ca_65'])) {
			$data['shipping_ups_ca_65'] = request::$post['shipping_ups_ca_65'];
		} else {
			$data['shipping_ups_ca_65'] = config::get('shipping_ups_ca_65');
		}

		// Mexico
		if (isset(request::$post['shipping_ups_mx_07'])) {
			$data['shipping_ups_mx_07'] = request::$post['shipping_ups_mx_07'];
		} else {
			$data['shipping_ups_mx_07'] = config::get('shipping_ups_mx_07');
		}

		if (isset(request::$post['shipping_ups_mx_08'])) {
			$data['shipping_ups_mx_08'] = request::$post['shipping_ups_mx_08'];
		} else {
			$data['shipping_ups_mx_08'] = config::get('shipping_ups_mx_08');
		}

		if (isset(request::$post['shipping_ups_mx_54'])) {
			$data['shipping_ups_mx_54'] = request::$post['shipping_ups_mx_54'];
		} else {
			$data['shipping_ups_mx_54'] = config::get('shipping_ups_mx_54');
		}

		if (isset(request::$post['shipping_ups_mx_65'])) {
			$data['shipping_ups_mx_65'] = request::$post['shipping_ups_mx_65'];
		} else {
			$data['shipping_ups_mx_65'] = config::get('shipping_ups_mx_65');
		}

		// EU
		if (isset(request::$post['shipping_ups_eu_07'])) {
			$data['shipping_ups_eu_07'] = request::$post['shipping_ups_eu_07'];
		} else {
			$data['shipping_ups_eu_07'] = config::get('shipping_ups_eu_07');
		}

		if (isset(request::$post['shipping_ups_eu_08'])) {
			$data['shipping_ups_eu_08'] = request::$post['shipping_ups_eu_08'];
		} else {
			$data['shipping_ups_eu_08'] = config::get('shipping_ups_eu_08');
		}

		if (isset(request::$post['shipping_ups_eu_11'])) {
			$data['shipping_ups_eu_11'] = request::$post['shipping_ups_eu_11'];
		} else {
			$data['shipping_ups_eu_11'] = config::get('shipping_ups_eu_11');
		}

		if (isset(request::$post['shipping_ups_eu_54'])) {
			$data['shipping_ups_eu_54'] = request::$post['shipping_ups_eu_54'];
		} else {
			$data['shipping_ups_eu_54'] = config::get('shipping_ups_eu_54');
		}

		if (isset(request::$post['shipping_ups_eu_65'])) {
			$data['shipping_ups_eu_65'] = request::$post['shipping_ups_eu_65'];
		} else {
			$data['shipping_ups_eu_65'] = config::get('shipping_ups_eu_65');
		}

		if (isset(request::$post['shipping_ups_eu_82'])) {
			$data['shipping_ups_eu_82'] = request::$post['shipping_ups_eu_82'];
		} else {
			$data['shipping_ups_eu_82'] = config::get('shipping_ups_eu_82');
		}

		if (isset(request::$post['shipping_ups_eu_83'])) {
			$data['shipping_ups_eu_83'] = request::$post['shipping_ups_eu_83'];
		} else {
			$data['shipping_ups_eu_83'] = config::get('shipping_ups_eu_83');
		}

		if (isset(request::$post['shipping_ups_eu_84'])) {
			$data['shipping_ups_eu_84'] = request::$post['shipping_ups_eu_84'];
		} else {
			$data['shipping_ups_eu_84'] = config::get('shipping_ups_eu_84');
		}

		if (isset(request::$post['shipping_ups_eu_85'])) {
			$data['shipping_ups_eu_85'] = request::$post['shipping_ups_eu_85'];
		} else {
			$data['shipping_ups_eu_85'] = config::get('shipping_ups_eu_85');
		}

		if (isset(request::$post['shipping_ups_eu_86'])) {
			$data['shipping_ups_eu_86'] = request::$post['shipping_ups_eu_86'];
		} else {
			$data['shipping_ups_eu_86'] = config::get('shipping_ups_eu_86');
		}

		// Other
		if (isset(request::$post['shipping_ups_other_07'])) {
			$data['shipping_ups_other_07'] = request::$post['shipping_ups_other_07'];
		} else {
			$data['shipping_ups_other_07'] = config::get('shipping_ups_other_07');
		}

		if (isset(request::$post['shipping_ups_other_08'])) {
			$data['shipping_ups_other_08'] = request::$post['shipping_ups_other_08'];
		} else {
			$data['shipping_ups_other_08'] = config::get('shipping_ups_other_08');
		}

		if (isset(request::$post['shipping_ups_other_11'])) {
			$data['shipping_ups_other_11'] = request::$post['shipping_ups_other_11'];
		} else {
			$data['shipping_ups_other_11'] = config::get('shipping_ups_other_11');
		}

		if (isset(request::$post['shipping_ups_other_54'])) {
			$data['shipping_ups_other_54'] = request::$post['shipping_ups_other_54'];
		} else {
			$data['shipping_ups_other_54'] = config::get('shipping_ups_other_54');
		}

		if (isset(request::$post['shipping_ups_other_65'])) {
			$data['shipping_ups_other_65'] = request::$post['shipping_ups_other_65'];
		} else {
			$data['shipping_ups_other_65'] = config::get('shipping_ups_other_65');
		}

		if (isset(request::$post['shipping_ups_display_weight'])) {
			$data['shipping_ups_display_weight'] = request::$post['shipping_ups_display_weight'];
		} else {
			$data['shipping_ups_display_weight'] = config::get('shipping_ups_display_weight');
		}

		if (isset(request::$post['shipping_ups_insurance'])) {
			$data['shipping_ups_insurance'] = request::$post['shipping_ups_insurance'];
		} else {
			$data['shipping_ups_insurance'] = config::get('shipping_ups_insurance');
		}

		if (isset(request::$post['shipping_ups_weight_class_id'])) {
			$data['shipping_ups_weight_class_id'] = request::$post['shipping_ups_weight_class_id'];
		} else {
			$data['shipping_ups_weight_class_id'] = config::get('shipping_ups_weight_class_id');
		}


		$data['weight_classes'] = admin_localisation_weight_class::getWeightClasses();

		if (isset(request::$post['shipping_ups_length_code'])) {
			$data['shipping_ups_length_code'] = request::$post['shipping_ups_length_code'];
		} else {
			$data['shipping_ups_length_code'] = config::get('shipping_ups_length_code');
		}

		if (isset(request::$post['shipping_ups_length_class_id'])) {
			$data['shipping_ups_length_class_id'] = request::$post['shipping_ups_length_class_id'];
		} else {
			$data['shipping_ups_length_class_id'] = config::get('shipping_ups_length_class_id');
		}


		$data['length_classes'] = admin_localisation_length_class::getLengthClasses();

		if (isset(request::$post['shipping_ups_length'])) {
			$data['shipping_ups_length'] = request::$post['shipping_ups_length'];
		} else {
			$data['shipping_ups_length'] = config::get('shipping_ups_length');
		}

		if (isset(request::$post['shipping_ups_width'])) {
			$data['shipping_ups_width'] = request::$post['shipping_ups_width'];
		} else {
			$data['shipping_ups_width'] = config::get('shipping_ups_width');
		}

		if (isset(request::$post['shipping_ups_height'])) {
			$data['shipping_ups_height'] = request::$post['shipping_ups_height'];
		} else {
			$data['shipping_ups_height'] = config::get('shipping_ups_height');
		}

		if (isset(request::$post['shipping_ups_tax_class_id'])) {
			$data['shipping_ups_tax_class_id'] = request::$post['shipping_ups_tax_class_id'];
		} else {
			$data['shipping_ups_tax_class_id'] = config::get('shipping_ups_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['shipping_ups_geo_zone_id'])) {
			$data['shipping_ups_geo_zone_id'] = request::$post['shipping_ups_geo_zone_id'];
		} else {
			$data['shipping_ups_geo_zone_id'] = config::get('shipping_ups_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['shipping_ups_status'])) {
			$data['shipping_ups_status'] = request::$post['shipping_ups_status'];
		} else {
			$data['shipping_ups_status'] = config::get('shipping_ups_status');
		}

		if (isset(request::$post['shipping_ups_sort_order'])) {
			$data['shipping_ups_sort_order'] = request::$post['shipping_ups_sort_order'];
		} else {
			$data['shipping_ups_sort_order'] = config::get('shipping_ups_sort_order');
		}

		if (isset(request::$post['shipping_ups_debug'])) {
			$data['shipping_ups_debug'] = request::$post['shipping_ups_debug'];
		} else {
			$data['shipping_ups_debug'] = config::get('shipping_ups_debug');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/shipping/ups', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/shipping/ups')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['shipping_ups_key']) {
			self::$error['key'] = language::get('error_key');
		}

		if (!request::$post['shipping_ups_username']) {
			self::$error['username'] = language::get('error_username');
		}

		if (!request::$post['shipping_ups_password']) {
			self::$error['password'] = language::get('error_password');
		}

		if (!request::$post['shipping_ups_city']) {
			self::$error['city'] = language::get('error_city');
		}

		if (!request::$post['shipping_ups_state']) {
			self::$error['state'] = language::get('error_state');
		}

		if (!request::$post['shipping_ups_country']) {
			self::$error['country'] = language::get('error_country');
		}

		if (empty(request::$post['shipping_ups_length'])) {
			self::$error['dimension'] = language::get('error_dimension');
		}

		if (empty(request::$post['shipping_ups_width'])) {
			self::$error['dimension'] = language::get('error_dimension');
		}

		if (empty(request::$post['shipping_ups_height'])) {
			self::$error['dimension'] = language::get('error_dimension');
		}

		return !self::$error;
	}
}