<?php
class ControllerExtensionShippingUsps {
	private static $error = array();

	public static function index() {
		load::language('extension/shipping/usps');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('shipping_usps', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=shipping'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['user_id'])) {
			$data['error_user_id'] = self::$error['user_id'];
		} else {
			$data['error_user_id'] = '';
		}

		if (isset(self::$error['postcode'])) {
			$data['error_postcode'] = self::$error['postcode'];
		} else {
			$data['error_postcode'] = '';
		}

		if (isset(self::$error['dimension'])) {
			$data['error_dimension'] = self::$error['dimension'];
		} else {
			$data['error_dimension'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=shipping')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/shipping/usps')
		);

		$data['action'] = url::link('extension/shipping/usps');

		$data['cancel'] = url::link('marketplace/extension', '&type=shipping');

		if (isset(request::$post['shipping_usps_user_id'])) {
			$data['shipping_usps_user_id'] = request::$post['shipping_usps_user_id'];
		} else {
			$data['shipping_usps_user_id'] = config::get('shipping_usps_user_id');
		}

		if (isset(request::$post['shipping_usps_postcode'])) {
			$data['shipping_usps_postcode'] = request::$post['shipping_usps_postcode'];
		} else {
			$data['shipping_usps_postcode'] = config::get('shipping_usps_postcode');
		}

		if (isset(request::$post['shipping_usps_domestic_00'])) {
			$data['shipping_usps_domestic_00'] = request::$post['shipping_usps_domestic_00'];
		} else {
			$data['shipping_usps_domestic_00'] = config::get('shipping_usps_domestic_00');
		}

		if (isset(request::$post['shipping_usps_domestic_01'])) {
			$data['shipping_usps_domestic_01'] = request::$post['shipping_usps_domestic_01'];
		} else {
			$data['shipping_usps_domestic_01'] = config::get('shipping_usps_domestic_01');
		}

		if (isset(request::$post['shipping_usps_domestic_02'])) {
			$data['shipping_usps_domestic_02'] = request::$post['shipping_usps_domestic_02'];
		} else {
			$data['shipping_usps_domestic_02'] = config::get('shipping_usps_domestic_02');
		}

		if (isset(request::$post['shipping_usps_domestic_03'])) {
			$data['shipping_usps_domestic_03'] = request::$post['shipping_usps_domestic_03'];
		} else {
			$data['shipping_usps_domestic_03'] = config::get('shipping_usps_domestic_03');
		}

		if (isset(request::$post['shipping_usps_domestic_1'])) {
			$data['shipping_usps_domestic_1'] = request::$post['shipping_usps_domestic_1'];
		} else {
			$data['shipping_usps_domestic_1'] = config::get('shipping_usps_domestic_1');
		}

		if (isset(request::$post['shipping_usps_domestic_2'])) {
			$data['shipping_usps_domestic_2'] = request::$post['shipping_usps_domestic_2'];
		} else {
			$data['shipping_usps_domestic_2'] = config::get('shipping_usps_domestic_2');
		}

		if (isset(request::$post['shipping_usps_domestic_3'])) {
			$data['shipping_usps_domestic_3'] = request::$post['shipping_usps_domestic_3'];
		} else {
			$data['shipping_usps_domestic_3'] = config::get('shipping_usps_domestic_3');
		}

		if (isset(request::$post['shipping_usps_domestic_4'])) {
			$data['shipping_usps_domestic_4'] = request::$post['shipping_usps_domestic_4'];
		} else {
			$data['shipping_usps_domestic_4'] = config::get('shipping_usps_domestic_4');
		}

		if (isset(request::$post['shipping_usps_domestic_5'])) {
			$data['shipping_usps_domestic_5'] = request::$post['shipping_usps_domestic_5'];
		} else {
			$data['shipping_usps_domestic_5'] = config::get('shipping_usps_domestic_5');
		}

		if (isset(request::$post['shipping_usps_domestic_6'])) {
			$data['shipping_usps_domestic_6'] = request::$post['shipping_usps_domestic_6'];
		} else {
			$data['shipping_usps_domestic_6'] = config::get('shipping_usps_domestic_6');
		}

		if (isset(request::$post['shipping_usps_domestic_7'])) {
			$data['shipping_usps_domestic_7'] = request::$post['shipping_usps_domestic_7'];
		} else {
			$data['shipping_usps_domestic_7'] = config::get('shipping_usps_domestic_7');
		}

		if (isset(request::$post['shipping_usps_domestic_12'])) {
			$data['shipping_usps_domestic_12'] = request::$post['shipping_usps_domestic_12'];
		} else {
			$data['shipping_usps_domestic_12'] = config::get('shipping_usps_domestic_12');
		}

		if (isset(request::$post['shipping_usps_domestic_13'])) {
			$data['shipping_usps_domestic_13'] = request::$post['shipping_usps_domestic_13'];
		} else {
			$data['shipping_usps_domestic_13'] = config::get('shipping_usps_domestic_13');
		}

		if (isset(request::$post['shipping_usps_domestic_16'])) {
			$data['shipping_usps_domestic_16'] = request::$post['shipping_usps_domestic_16'];
		} else {
			$data['shipping_usps_domestic_16'] = config::get('shipping_usps_domestic_16');
		}

		if (isset(request::$post['shipping_usps_domestic_17'])) {
			$data['shipping_usps_domestic_17'] = request::$post['shipping_usps_domestic_17'];
		} else {
			$data['shipping_usps_domestic_17'] = config::get('shipping_usps_domestic_17');
		}

		if (isset(request::$post['shipping_usps_domestic_18'])) {
			$data['shipping_usps_domestic_18'] = request::$post['shipping_usps_domestic_18'];
		} else {
			$data['shipping_usps_domestic_18'] = config::get('shipping_usps_domestic_18');
		}

		if (isset(request::$post['shipping_usps_domestic_19'])) {
			$data['shipping_usps_domestic_19'] = request::$post['shipping_usps_domestic_19'];
		} else {
			$data['shipping_usps_domestic_19'] = config::get('shipping_usps_domestic_19');
		}

		if (isset(request::$post['shipping_usps_domestic_22'])) {
			$data['shipping_usps_domestic_22'] = request::$post['shipping_usps_domestic_22'];
		} else {
			$data['shipping_usps_domestic_22'] = config::get('shipping_usps_domestic_22');
		}

		if (isset(request::$post['shipping_usps_domestic_23'])) {
			$data['shipping_usps_domestic_23'] = request::$post['shipping_usps_domestic_23'];
		} else {
			$data['shipping_usps_domestic_23'] = config::get('shipping_usps_domestic_23');
		}

		if (isset(request::$post['shipping_usps_domestic_25'])) {
			$data['shipping_usps_domestic_25'] = request::$post['shipping_usps_domestic_25'];
		} else {
			$data['shipping_usps_domestic_25'] = config::get('shipping_usps_domestic_25');
		}

		if (isset(request::$post['shipping_usps_domestic_27'])) {
			$data['shipping_usps_domestic_27'] = request::$post['shipping_usps_domestic_27'];
		} else {
			$data['shipping_usps_domestic_27'] = config::get('shipping_usps_domestic_27');
		}

		if (isset(request::$post['shipping_usps_domestic_28'])) {
			$data['shipping_usps_domestic_28'] = request::$post['shipping_usps_domestic_28'];
		} else {
			$data['shipping_usps_domestic_28'] = config::get('shipping_usps_domestic_28');
		}

		if (isset(request::$post['shipping_usps_international_1'])) {
			$data['shipping_usps_international_1'] = request::$post['shipping_usps_international_1'];
		} else {
			$data['shipping_usps_international_1'] = config::get('shipping_usps_international_1');
		}

		if (isset(request::$post['shipping_usps_international_2'])) {
			$data['shipping_usps_international_2'] = request::$post['shipping_usps_international_2'];
		} else {
			$data['shipping_usps_international_2'] = config::get('shipping_usps_international_2');
		}

		if (isset(request::$post['shipping_usps_international_4'])) {
			$data['shipping_usps_international_4'] = request::$post['shipping_usps_international_4'];
		} else {
			$data['shipping_usps_international_4'] = config::get('shipping_usps_international_4');
		}

		if (isset(request::$post['shipping_usps_international_5'])) {
			$data['shipping_usps_international_5'] = request::$post['shipping_usps_international_5'];
		} else {
			$data['shipping_usps_international_5'] = config::get('shipping_usps_international_5');
		}

		if (isset(request::$post['shipping_usps_international_6'])) {
			$data['shipping_usps_international_6'] = request::$post['shipping_usps_international_6'];
		} else {
			$data['shipping_usps_international_6'] = config::get('shipping_usps_international_6');
		}

		if (isset(request::$post['shipping_usps_international_7'])) {
			$data['shipping_usps_international_7'] = request::$post['shipping_usps_international_7'];
		} else {
			$data['shipping_usps_international_7'] = config::get('shipping_usps_international_7');
		}

		if (isset(request::$post['shipping_usps_international_8'])) {
			$data['shipping_usps_international_8'] = request::$post['shipping_usps_international_8'];
		} else {
			$data['shipping_usps_international_8'] = config::get('shipping_usps_international_8');
		}

		if (isset(request::$post['shipping_usps_international_9'])) {
			$data['shipping_usps_international_9'] = request::$post['shipping_usps_international_9'];
		} else {
			$data['shipping_usps_international_9'] = config::get('shipping_usps_international_9');
		}

		if (isset(request::$post['shipping_usps_international_10'])) {
			$data['shipping_usps_international_10'] = request::$post['shipping_usps_international_10'];
		} else {
			$data['shipping_usps_international_10'] = config::get('shipping_usps_international_10');
		}

		if (isset(request::$post['shipping_usps_international_11'])) {
			$data['shipping_usps_international_11'] = request::$post['shipping_usps_international_11'];
		} else {
			$data['shipping_usps_international_11'] = config::get('shipping_usps_international_11');
		}

		if (isset(request::$post['shipping_usps_international_12'])) {
			$data['shipping_usps_international_12'] = request::$post['shipping_usps_international_12'];
		} else {
			$data['shipping_usps_international_12'] = config::get('shipping_usps_international_12');
		}

		if (isset(request::$post['shipping_usps_international_13'])) {
			$data['shipping_usps_international_13'] = request::$post['shipping_usps_international_13'];
		} else {
			$data['shipping_usps_international_13'] = config::get('shipping_usps_international_13');
		}

		if (isset(request::$post['shipping_usps_international_14'])) {
			$data['shipping_usps_international_14'] = request::$post['shipping_usps_international_14'];
		} else {
			$data['shipping_usps_international_14'] = config::get('shipping_usps_international_14');
		}

		if (isset(request::$post['shipping_usps_international_15'])) {
			$data['shipping_usps_international_15'] = request::$post['shipping_usps_international_15'];
		} else {
			$data['shipping_usps_international_15'] = config::get('shipping_usps_international_15');
		}

		if (isset(request::$post['shipping_usps_international_16'])) {
			$data['shipping_usps_international_16'] = request::$post['shipping_usps_international_16'];
		} else {
			$data['shipping_usps_international_16'] = config::get('shipping_usps_international_16');
		}

		if (isset(request::$post['shipping_usps_international_21'])) {
			$data['shipping_usps_international_21'] = request::$post['shipping_usps_international_21'];
		} else {
			$data['shipping_usps_international_21'] = config::get('shipping_usps_international_21');
		}

		if (isset(request::$post['shipping_usps_size'])) {
			$data['shipping_usps_size'] = request::$post['shipping_usps_size'];
		} else {
			$data['shipping_usps_size'] = config::get('shipping_usps_size');
		}

		$data['sizes'] = array();

		$data['sizes'][] = array(
			'text'  => language::get('text_regular'),
			'value' => 'REGULAR'
		);

		$data['sizes'][] = array(
			'text'  => language::get('text_large'),
			'value' => 'LARGE'
		);

		if (isset(request::$post['shipping_usps_container'])) {
			$data['shipping_usps_container'] = request::$post['shipping_usps_container'];
		} else {
			$data['shipping_usps_container'] = config::get('shipping_usps_container');
		}

		$data['containers'] = array();

		$data['containers'][] = array(
			'text'  => language::get('text_rectangular'),
			'value' => 'RECTANGULAR'
		);

		$data['containers'][] = array(
			'text'  => language::get('text_non_rectangular'),
			'value' => 'NONRECTANGULAR'
		);

		$data['containers'][] = array(
			'text'  => language::get('text_variable'),
			'value' => 'VARIABLE'
		);

		if (isset(request::$post['shipping_usps_machinable'])) {
			$data['shipping_usps_machinable'] = request::$post['shipping_usps_machinable'];
		} else {
			$data['shipping_usps_machinable'] = config::get('shipping_usps_machinable');
		}

		if (isset(request::$post['shipping_usps_length'])) {
			$data['shipping_usps_length'] = request::$post['shipping_usps_length'];
		} else {
			$data['shipping_usps_length'] = config::get('shipping_usps_length');
		}

		if (isset(request::$post['shipping_usps_width'])) {
			$data['shipping_usps_width'] = request::$post['shipping_usps_width'];
		} else {
			$data['shipping_usps_width'] = config::get('shipping_usps_width');
		}

		if (isset(request::$post['shipping_usps_height'])) {
			$data['shipping_usps_height'] = request::$post['shipping_usps_height'];
		} else {
			$data['shipping_usps_height'] = config::get('shipping_usps_height');
		}

		if (isset(request::$post['shipping_usps_display_time'])) {
			$data['shipping_usps_display_time'] = request::$post['shipping_usps_display_time'];
		} else {
			$data['shipping_usps_display_time'] = config::get('shipping_usps_display_time');
		}

		if (isset(request::$post['shipping_usps_display_weight'])) {
			$data['shipping_usps_display_weight'] = request::$post['shipping_usps_display_weight'];
		} else {
			$data['shipping_usps_display_weight'] = config::get('shipping_usps_display_weight');
		}

		if (isset(request::$post['shipping_usps_weight_class_id'])) {
			$data['shipping_usps_weight_class_id'] = request::$post['shipping_usps_weight_class_id'];
		} else {
			$data['shipping_usps_weight_class_id'] = config::get('shipping_usps_weight_class_id');
		}


		$data['weight_classes'] = admin_localisation_weight_class::getWeightClasses();

		if (isset(request::$post['shipping_usps_tax_class_id'])) {
			$data['shipping_usps_tax_class_id'] = request::$post['shipping_usps_tax_class_id'];
		} else {
			$data['shipping_usps_tax_class_id'] = config::get('shipping_usps_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['shipping_usps_geo_zone_id'])) {
			$data['shipping_usps_geo_zone_id'] = request::$post['shipping_usps_geo_zone_id'];
		} else {
			$data['shipping_usps_geo_zone_id'] = config::get('shipping_usps_geo_zone_id');
		}


		$data['geo_zones'] = admin_localisation_geo_zone::getGeoZones();

		if (isset(request::$post['shipping_usps_debug'])) {
			$data['shipping_usps_debug'] = request::$post['shipping_usps_debug'];
		} else {
			$data['shipping_usps_debug'] = config::get('shipping_usps_debug');
		}

		if (isset(request::$post['shipping_usps_status'])) {
			$data['shipping_usps_status'] = request::$post['shipping_usps_status'];
		} else {
			$data['shipping_usps_status'] = config::get('shipping_usps_status');
		}

		if (isset(request::$post['shipping_usps_sort_order'])) {
			$data['shipping_usps_sort_order'] = request::$post['shipping_usps_sort_order'];
		} else {
			$data['shipping_usps_sort_order'] = config::get('shipping_usps_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/shipping/usps', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/shipping/usps')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['shipping_usps_user_id']) {
			self::$error['user_id'] = language::get('error_user_id');
		}

		if (!request::$post['shipping_usps_postcode']) {
			self::$error['postcode'] = language::get('error_postcode');
		}

		if (!request::$post['shipping_usps_width']) {
			self::$error['dimension'] = language::get('error_width');
		}

		if (!request::$post['shipping_usps_height']) {
			self::$error['dimension'] = language::get('error_height');
		}

		if (!request::$post['shipping_usps_length']) {
			self::$error['dimension'] = language::get('error_length');
		}

		return !self::$error;
	}
}
