<?php
class ControllerExtensionShippingWeight {
	private static $error = array();

	public static function index() {
		load::language('extension/shipping/weight');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('shipping_weight', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=shipping'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=shipping')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/shipping/weight')
		);

		$data['action'] = url::link('extension/shipping/weight');

		$data['cancel'] = url::link('marketplace/extension', '&type=shipping');


		$geo_zones = admin_localisation_geo_zone::getGeoZones();

		foreach ($geo_zones as $geo_zone) {
			if (isset(request::$post['shipping_weight_' . $geo_zone['geo_zone_id'] . '_rate'])) {
				$data['shipping_weight_geo_zone_rate'][$geo_zone['geo_zone_id']] = request::$post['shipping_weight_' . $geo_zone['geo_zone_id'] . '_rate'];
			} else {
				$data['shipping_weight_geo_zone_rate'][$geo_zone['geo_zone_id']] = config::get('shipping_weight_' . $geo_zone['geo_zone_id'] . '_rate');
			}

			if (isset(request::$post['shipping_weight_' . $geo_zone['geo_zone_id'] . '_status'])) {
				$data['shipping_weight_geo_zone_status'][$geo_zone['geo_zone_id']] = request::$post['shipping_weight_' . $geo_zone['geo_zone_id'] . '_status'];
			} else {
				$data['shipping_weight_geo_zone_status'][$geo_zone['geo_zone_id']] = config::get('shipping_weight_' . $geo_zone['geo_zone_id'] . '_status');
			}
		}

		$data['geo_zones'] = $geo_zones;

		if (isset(request::$post['shipping_weight_tax_class_id'])) {
			$data['shipping_weight_tax_class_id'] = request::$post['shipping_weight_tax_class_id'];
		} else {
			$data['shipping_weight_tax_class_id'] = config::get('shipping_weight_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['shipping_weight_status'])) {
			$data['shipping_weight_status'] = request::$post['shipping_weight_status'];
		} else {
			$data['shipping_weight_status'] = config::get('shipping_weight_status');
		}

		if (isset(request::$post['shipping_weight_sort_order'])) {
			$data['shipping_weight_sort_order'] = request::$post['shipping_weight_sort_order'];
		} else {
			$data['shipping_weight_sort_order'] = config::get('shipping_weight_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/shipping/weight', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/shipping/weight')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}