<?php
class ControllerExtensionThemeDefault {
	private static $error = array();

	public static function index() {
		load::language('extension/theme/default');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('theme_default', request::$post, request::$get['store_id']);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=theme'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['product_limit'])) {
			$data['error_product_limit'] = self::$error['product_limit'];
		} else {
			$data['error_product_limit'] = '';
		}

		if (isset(self::$error['product_description_length'])) {
			$data['error_product_description_length'] = self::$error['product_description_length'];
		} else {
			$data['error_product_description_length'] = '';
		}

		if (isset(self::$error['image_category'])) {
			$data['error_image_category'] = self::$error['image_category'];
		} else {
			$data['error_image_category'] = '';
		}

		if (isset(self::$error['image_thumb'])) {
			$data['error_image_thumb'] = self::$error['image_thumb'];
		} else {
			$data['error_image_thumb'] = '';
		}

		if (isset(self::$error['image_popup'])) {
			$data['error_image_popup'] = self::$error['image_popup'];
		} else {
			$data['error_image_popup'] = '';
		}

		if (isset(self::$error['image_product'])) {
			$data['error_image_product'] = self::$error['image_product'];
		} else {
			$data['error_image_product'] = '';
		}

		if (isset(self::$error['image_additional'])) {
			$data['error_image_additional'] = self::$error['image_additional'];
		} else {
			$data['error_image_additional'] = '';
		}

		if (isset(self::$error['image_related'])) {
			$data['error_image_related'] = self::$error['image_related'];
		} else {
			$data['error_image_related'] = '';
		}

		if (isset(self::$error['image_compare'])) {
			$data['error_image_compare'] = self::$error['image_compare'];
		} else {
			$data['error_image_compare'] = '';
		}

		if (isset(self::$error['image_wishlist'])) {
			$data['error_image_wishlist'] = self::$error['image_wishlist'];
		} else {
			$data['error_image_wishlist'] = '';
		}

		if (isset(self::$error['image_cart'])) {
			$data['error_image_cart'] = self::$error['image_cart'];
		} else {
			$data['error_image_cart'] = '';
		}

		if (isset(self::$error['image_location'])) {
			$data['error_image_location'] = self::$error['image_location'];
		} else {
			$data['error_image_location'] = '';
		}
		
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=theme')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/theme/default', '&store_id=' . request::$get['store_id'])
		);

		$data['action'] = url::link('extension/theme/default', '&store_id=' . request::$get['store_id']);

		$data['cancel'] = url::link('marketplace/extension', '&type=theme');

		if (isset(request::$get['store_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$setting_info = admin_setting_setting::getSetting('theme_default', request::$get['store_id']);
		}
		
		if (isset(request::$post['theme_default_directory'])) {
			$data['theme_default_directory'] = request::$post['theme_default_directory'];
		} elseif (isset($setting_info['theme_default_directory'])) {
			$data['theme_default_directory'] = $setting_info['theme_default_directory'];
		} else {
			$data['theme_default_directory'] = 'default';
		}		

		$data['directories'] = array();

		$directories = glob(DIR_CATALOG . 'view/theme/*', GLOB_ONLYDIR);

		foreach ($directories as $directory) {
			$data['directories'][] = basename($directory);
		}

		if (isset(request::$post['theme_default_product_limit'])) {
			$data['theme_default_product_limit'] = request::$post['theme_default_product_limit'];
		} elseif (isset($setting_info['theme_default_product_limit'])) {
			$data['theme_default_product_limit'] = $setting_info['theme_default_product_limit'];
		} else {
			$data['theme_default_product_limit'] = 15;
		}		
		
		if (isset(request::$post['theme_default_status'])) {
			$data['theme_default_status'] = request::$post['theme_default_status'];
		} elseif (isset($setting_info['theme_default_status'])) {
			$data['theme_default_status'] = $setting_info['theme_default_status'];
		} else {
			$data['theme_default_status'] = '';
		}
		
		if (isset(request::$post['theme_default_product_description_length'])) {
			$data['theme_default_product_description_length'] = request::$post['theme_default_product_description_length'];
		} elseif (isset($setting_info['theme_default_product_description_length'])) {
			$data['theme_default_product_description_length'] = $setting_info['theme_default_product_description_length'];
		} else {
			$data['theme_default_product_description_length'] = 100;
		}
		
		if (isset(request::$post['theme_default_image_category_width'])) {
			$data['theme_default_image_category_width'] = request::$post['theme_default_image_category_width'];
		} elseif (isset($setting_info['theme_default_image_category_width'])) {
			$data['theme_default_image_category_width'] = $setting_info['theme_default_image_category_width'];
		} else {
			$data['theme_default_image_category_width'] = 80;		
		}
		
		if (isset(request::$post['theme_default_image_category_height'])) {
			$data['theme_default_image_category_height'] = request::$post['theme_default_image_category_height'];
		} elseif (isset($setting_info['theme_default_image_category_height'])) {
			$data['theme_default_image_category_height'] = $setting_info['theme_default_image_category_height'];
		} else {
			$data['theme_default_image_category_height'] = 80;
		}
		
		if (isset(request::$post['theme_default_image_thumb_width'])) {
			$data['theme_default_image_thumb_width'] = request::$post['theme_default_image_thumb_width'];
		} elseif (isset($setting_info['theme_default_image_thumb_width'])) {
			$data['theme_default_image_thumb_width'] = $setting_info['theme_default_image_thumb_width'];
		} else {
			$data['theme_default_image_thumb_width'] = 228;
		}
		
		if (isset(request::$post['theme_default_image_thumb_height'])) {
			$data['theme_default_image_thumb_height'] = request::$post['theme_default_image_thumb_height'];
		} elseif (isset($setting_info['theme_default_image_thumb_height'])) {
			$data['theme_default_image_thumb_height'] = $setting_info['theme_default_image_thumb_height'];
		} else {
			$data['theme_default_image_thumb_height'] = 228;		
		}
		
		if (isset(request::$post['theme_default_image_popup_width'])) {
			$data['theme_default_image_popup_width'] = request::$post['theme_default_image_popup_width'];
		} elseif (isset($setting_info['theme_default_image_popup_width'])) {
			$data['theme_default_image_popup_width'] = $setting_info['theme_default_image_popup_width'];
		} else {
			$data['theme_default_image_popup_width'] = 500;
		}
		
		if (isset(request::$post['theme_default_image_popup_height'])) {
			$data['theme_default_image_popup_height'] = request::$post['theme_default_image_popup_height'];
		} elseif (isset($setting_info['theme_default_image_popup_height'])) {
			$data['theme_default_image_popup_height'] = $setting_info['theme_default_image_popup_height'];
		} else {
			$data['theme_default_image_popup_height'] = 500;
		}
		
		if (isset(request::$post['theme_default_image_product_width'])) {
			$data['theme_default_image_product_width'] = request::$post['theme_default_image_product_width'];
		} elseif (isset($setting_info['theme_default_image_product_width'])) {
			$data['theme_default_image_product_width'] = $setting_info['theme_default_image_product_width'];
		} else {
			$data['theme_default_image_product_width'] = 228;
		}
		
		if (isset(request::$post['theme_default_image_product_height'])) {
			$data['theme_default_image_product_height'] = request::$post['theme_default_image_product_height'];
		} elseif (isset($setting_info['theme_default_image_product_height'])) {
			$data['theme_default_image_product_height'] = $setting_info['theme_default_image_product_height'];
		} else {
			$data['theme_default_image_product_height'] = 228;
		}
		
		if (isset(request::$post['theme_default_image_additional_width'])) {
			$data['theme_default_image_additional_width'] = request::$post['theme_default_image_additional_width'];
		} elseif (isset($setting_info['theme_default_image_additional_width'])) {
			$data['theme_default_image_additional_width'] = $setting_info['theme_default_image_additional_width'];
		} else {
			$data['theme_default_image_additional_width'] = 74;
		}
		
		if (isset(request::$post['theme_default_image_additional_height'])) {
			$data['theme_default_image_additional_height'] = request::$post['theme_default_image_additional_height'];
		} elseif (isset($setting_info['theme_default_image_additional_height'])) {
			$data['theme_default_image_additional_height'] = $setting_info['theme_default_image_additional_height'];
		} else {
			$data['theme_default_image_additional_height'] = 74;
		}
		
		if (isset(request::$post['theme_default_image_related_width'])) {
			$data['theme_default_image_related_width'] = request::$post['theme_default_image_related_width'];
		} elseif (isset($setting_info['theme_default_image_related_width'])) {
			$data['theme_default_image_related_width'] = $setting_info['theme_default_image_related_width'];
		} else {
			$data['theme_default_image_related_width'] = 80;
		}
		
		if (isset(request::$post['theme_default_image_related_height'])) {
			$data['theme_default_image_related_height'] = request::$post['theme_default_image_related_height'];
		} elseif (isset($setting_info['theme_default_image_related_height'])) {
			$data['theme_default_image_related_height'] = $setting_info['theme_default_image_related_height'];
		} else {
			$data['theme_default_image_related_height'] = 80;
		}
		
		if (isset(request::$post['theme_default_image_compare_width'])) {
			$data['theme_default_image_compare_width'] = request::$post['theme_default_image_compare_width'];
		} elseif (isset($setting_info['theme_default_image_compare_width'])) {
			$data['theme_default_image_compare_width'] = $setting_info['theme_default_image_compare_width'];
		} else {
			$data['theme_default_image_compare_width'] = 90;
		}
		
		if (isset(request::$post['theme_default_image_compare_height'])) {
			$data['theme_default_image_compare_height'] = request::$post['theme_default_image_compare_height'];
		} elseif (isset($setting_info['theme_default_image_compare_height'])) {
			$data['theme_default_image_compare_height'] = $setting_info['theme_default_image_compare_height'];
		} else {
			$data['theme_default_image_compare_height'] = 90;
		}
		
		if (isset(request::$post['theme_default_image_wishlist_width'])) {
			$data['theme_default_image_wishlist_width'] = request::$post['theme_default_image_wishlist_width'];
		} elseif (isset($setting_info['theme_default_image_wishlist_width'])) {
			$data['theme_default_image_wishlist_width'] = $setting_info['theme_default_image_wishlist_width'];
		} else {
			$data['theme_default_image_wishlist_width'] = 47;
		}
		
		if (isset(request::$post['theme_default_image_wishlist_height'])) {
			$data['theme_default_image_wishlist_height'] = request::$post['theme_default_image_wishlist_height'];
		} elseif (isset($setting_info['theme_default_image_wishlist_height'])) {
			$data['theme_default_image_wishlist_height'] = $setting_info['theme_default_image_wishlist_height'];
		} else {
			$data['theme_default_image_wishlist_height'] = 47;
		}
		
		if (isset(request::$post['theme_default_image_cart_width'])) {
			$data['theme_default_image_cart_width'] = request::$post['theme_default_image_cart_width'];
		} elseif (isset($setting_info['theme_default_image_cart_width'])) {
			$data['theme_default_image_cart_width'] = $setting_info['theme_default_image_cart_width'];
		} else {
			$data['theme_default_image_cart_width'] = 47;
		}
		
		if (isset(request::$post['theme_default_image_cart_height'])) {
			$data['theme_default_image_cart_height'] = request::$post['theme_default_image_cart_height'];
		} elseif (isset($setting_info['theme_default_image_cart_height'])) {
			$data['theme_default_image_cart_height'] = $setting_info['theme_default_image_cart_height'];
		} else {
			$data['theme_default_image_cart_height'] = 47;
		}
		
		if (isset(request::$post['theme_default_image_location_width'])) {
			$data['theme_default_image_location_width'] = request::$post['theme_default_image_location_width'];
		} elseif (isset($setting_info['theme_default_image_location_width'])) {
			$data['theme_default_image_location_width'] = $setting_info['theme_default_image_location_width'];
		} else {
			$data['theme_default_image_location_width'] = 268;
		}
		
		if (isset(request::$post['theme_default_image_location_height'])) {
			$data['theme_default_image_location_height'] = request::$post['theme_default_image_location_height'];
		} elseif (isset($setting_info['theme_default_image_location_height'])) {
			$data['theme_default_image_location_height'] = $setting_info['theme_default_image_location_height'];
		} else {
			$data['theme_default_image_location_height'] = 50;
		}
		
		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/theme/default', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/theme/default')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['theme_default_product_limit']) {
			self::$error['product_limit'] = language::get('error_limit');
		}

		if (!request::$post['theme_default_product_description_length']) {
			self::$error['product_description_length'] = language::get('error_limit');
		}

		if (!request::$post['theme_default_image_category_width'] || !request::$post['theme_default_image_category_height']) {
			self::$error['image_category'] = language::get('error_image_category');
		}

		if (!request::$post['theme_default_image_thumb_width'] || !request::$post['theme_default_image_thumb_height']) {
			self::$error['image_thumb'] = language::get('error_image_thumb');
		}

		if (!request::$post['theme_default_image_popup_width'] || !request::$post['theme_default_image_popup_height']) {
			self::$error['image_popup'] = language::get('error_image_popup');
		}

		if (!request::$post['theme_default_image_product_width'] || !request::$post['theme_default_image_product_height']) {
			self::$error['image_product'] = language::get('error_image_product');
		}

		if (!request::$post['theme_default_image_additional_width'] || !request::$post['theme_default_image_additional_height']) {
			self::$error['image_additional'] = language::get('error_image_additional');
		}

		if (!request::$post['theme_default_image_related_width'] || !request::$post['theme_default_image_related_height']) {
			self::$error['image_related'] = language::get('error_image_related');
		}

		if (!request::$post['theme_default_image_compare_width'] || !request::$post['theme_default_image_compare_height']) {
			self::$error['image_compare'] = language::get('error_image_compare');
		}

		if (!request::$post['theme_default_image_wishlist_width'] || !request::$post['theme_default_image_wishlist_height']) {
			self::$error['image_wishlist'] = language::get('error_image_wishlist');
		}

		if (!request::$post['theme_default_image_cart_width'] || !request::$post['theme_default_image_cart_height']) {
			self::$error['image_cart'] = language::get('error_image_cart');
		}

		if (!request::$post['theme_default_image_location_width'] || !request::$post['theme_default_image_location_height']) {
			self::$error['image_location'] = language::get('error_image_location');
		}

		return !self::$error;
	}
}
