<?php
class ControllerExtensionTotalCoupon {
	private static $error = array();

	public static function index() {
		load::language('extension/total/coupon');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('total_coupon', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=total'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=total')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/total/coupon')
		);

		$data['action'] = url::link('extension/total/coupon');

		$data['cancel'] = url::link('marketplace/extension', '&type=total');

		if (isset(request::$post['total_coupon_status'])) {
			$data['total_coupon_status'] = request::$post['total_coupon_status'];
		} else {
			$data['total_coupon_status'] = config::get('total_coupon_status');
		}

		if (isset(request::$post['total_coupon_sort_order'])) {
			$data['total_coupon_sort_order'] = request::$post['total_coupon_sort_order'];
		} else {
			$data['total_coupon_sort_order'] = config::get('total_coupon_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/total/coupon', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/total/coupon')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}