<?php
class ControllerExtensionTotalKlarnaFee {
	private static $error = array();

	public static function index() {
		load::language('extension/total/klarna_fee');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			$status = false;

			foreach (request::$post['klarna_fee'] as $klarna_account) {
				if ($klarna_account['status']) {
					$status = true;

					break;
				}
			}

			admin_setting_setting::editSetting('total_klarna_fee', array_merge(request::$post, array('klarna_fee_status' => $status)));

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=total'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=total')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/total/klarna_fee')
		);

		$data['action'] = url::link('extension/total/klarna_fee');

		$data['cancel'] = url::link('marketplace/extension', '&type=total');

		$data['countries'] = array();

		$data['countries'][] = array(
			'name' => language::get('text_germany'),
			'code' => 'DEU'
		);

		$data['countries'][] = array(
			'name' => language::get('text_netherlands'),
			'code' => 'NLD'
		);

		$data['countries'][] = array(
			'name' => language::get('text_denmark'),
			'code' => 'DNK'
		);

		$data['countries'][] = array(
			'name' => language::get('text_sweden'),
			'code' => 'SWE'
		);

		$data['countries'][] = array(
			'name' => language::get('text_norway'),
			'code' => 'NOR'
		);

		$data['countries'][] = array(
			'name' => language::get('text_finland'),
			'code' => 'FIN'
		);

		if (isset(request::$post['total_klarna_fee'])) {
			$data['total_klarna_fee'] = request::$post['total_klarna_fee'];
		} else {
			$data['total_klarna_fee'] = config::get('total_klarna_fee');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/total/klarna_fee', $data));
	}

	private static function validate() {
		if (!user::hasPermission('modify', 'extension/total/klarna_fee')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}