<?php
class ControllerExtensionTotalLowOrderFee {
	private static $error = array();

	public static function index() {
		load::language('extension/total/low_order_fee');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('total_low_order_fee', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=total'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=total')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/total/low_order_fee')
		);

		$data['action'] = url::link('extension/total/low_order_fee');

		$data['cancel'] = url::link('marketplace/extension', '&type=total');

		if (isset(request::$post['total_low_order_fee_total'])) {
			$data['total_low_order_fee_total'] = request::$post['total_low_order_fee_total'];
		} else {
			$data['total_low_order_fee_total'] = config::get('total_low_order_fee_total');
		}

		if (isset(request::$post['total_low_order_fee_fee'])) {
			$data['total_low_order_fee_fee'] = request::$post['total_low_order_fee_fee'];
		} else {
			$data['total_low_order_fee_fee'] = config::get('total_low_order_fee_fee');
		}

		if (isset(request::$post['total_low_order_fee_tax_class_id'])) {
			$data['total_low_order_fee_tax_class_id'] = request::$post['total_low_order_fee_tax_class_id'];
		} else {
			$data['total_low_order_fee_tax_class_id'] = config::get('total_low_order_fee_tax_class_id');
		}


		$data['tax_classes'] = admin_localisation_tax_class::getTaxClasses();

		if (isset(request::$post['total_low_order_fee_status'])) {
			$data['total_low_order_fee_status'] = request::$post['total_low_order_fee_status'];
		} else {
			$data['total_low_order_fee_status'] = config::get('total_low_order_fee_status');
		}

		if (isset(request::$post['total_low_order_fee_sort_order'])) {
			$data['total_low_order_fee_sort_order'] = request::$post['total_low_order_fee_sort_order'];
		} else {
			$data['total_low_order_fee_sort_order'] = config::get('total_low_order_fee_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/total/low_order_fee', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/total/low_order_fee')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}