<?php
class ControllerExtensionTotalReward {
	private static $error = array();

	public static function index() {
		load::language('extension/total/reward');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('total_reward', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=total'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=total')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/total/reward')
		);

		$data['action'] = url::link('extension/total/reward');

		$data['cancel'] = url::link('marketplace/extension', '&type=total');

		if (isset(request::$post['total_reward_status'])) {
			$data['total_reward_status'] = request::$post['total_reward_status'];
		} else {
			$data['total_reward_status'] = config::get('total_reward_status');
		}

		if (isset(request::$post['total_reward_sort_order'])) {
			$data['total_reward_sort_order'] = request::$post['total_reward_sort_order'];
		} else {
			$data['total_reward_sort_order'] = config::get('total_reward_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/total/reward', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/total/reward')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}