<?php
class ControllerExtensionTotalVoucher {
	private static $error = array();

	public static function index() {
		load::language('extension/total/voucher');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('total_voucher', request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('marketplace/extension', '&type=total'));
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_extension'),
			'href' => url::link('marketplace/extension', '&type=total')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('extension/total/voucher')
		);

		$data['action'] = url::link('extension/total/voucher');

		$data['cancel'] = url::link('marketplace/extension', '&type=total');

		if (isset(request::$post['total_voucher_status'])) {
			$data['total_voucher_status'] = request::$post['total_voucher_status'];
		} else {
			$data['total_voucher_status'] = config::get('total_voucher_status');
		}

		if (isset(request::$post['total_voucher_sort_order'])) {
			$data['total_voucher_sort_order'] = request::$post['total_voucher_sort_order'];
		} else {
			$data['total_voucher_sort_order'] = config::get('total_voucher_sort_order');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('extension/total/voucher', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'extension/total/voucher')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	public static function install() {
		// Register the event triggers

		admin_setting_event::addEvent('voucher', 'catalog/model/checkout/order/addOrderHistory/after', 'extension/total/voucher/send');
	}

	public static function uninstall() {
		// delete the event triggers

		admin_setting_event::deleteEventByCode('voucher');
	}
}
