<?php
class ControllerLocalisationLocation {
	private static $error = array();

	public static function index() {
		load::language('localisation/location');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('localisation/location');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_localisation_location::addLocation(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/location', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('localisation/location');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_localisation_location::editLocation(request::$get['location_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/location', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('localisation/location');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $location_id) {
				admin_localisation_location::deleteLocation($location_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/location', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'name';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] =   array();

		$data['breadcrumbs'][] =   array(
			'text' =>  language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] =   array(
			'text' =>  language::get('heading_title'),
			'href' =>  url::link('localisation/location', $url)
		);

		$data['add'] = url::link('localisation/location/add', $url);
		$data['delete'] = url::link('localisation/location/delete', $url);

		$data['locations'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * config('limit_admin'),
			'limit' => config('limit_admin')
		);

		$location_total = admin_localisation_location::getTotalLocations();

		$results = admin_localisation_location::getLocations($filter_data);

		foreach ($results as $result) {
			$data['locations'][] =   array(
				'location_id' => $result['location_id'],
				'name'        => $result['name'],
				'address'     => $result['address'],
				'edit'        => url::link('localisation/location/edit', '&location_id=' . $result['location_id'] . $url)
			);
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_name'] = url::link('localisation/location', '&sort=name' . $url);
		$data['sort_address'] = url::link('localisation/location', '&sort=address' . $url);

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $location_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('localisation/location', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($location_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($location_total - config('limit_admin'))) ? $location_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $location_total, ceil($location_total / config('limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('localisation/location_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['location_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset(self::$error['address'])) {
			$data['error_address'] = self::$error['address'];
		} else {
			$data['error_address'] = '';
		}

		if (isset(self::$error['telephone'])) {
			$data['error_telephone'] = self::$error['telephone'];
		} else {
			$data['error_telephone'] = '';
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('localisation/location', $url)
		);

		if (!isset(request::$get['location_id'])) {
			$data['action'] = url::link('localisation/location/add', $url);
		} else {
			$data['action'] = url::link('localisation/location/edit',  '&location_id=' . request::$get['location_id'] . $url);
		}

		$data['cancel'] = url::link('localisation/location', $url);

		if (isset(request::$get['location_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$location_info = admin_localisation_location::getLocation(request::$get['location_id']);
		}



		if (isset(request::$post['name'])) {
			$data['name'] = request::$post['name'];
		} elseif (!empty($location_info)) {
			$data['name'] = $location_info['name'];
		} else {
			$data['name'] =   '';
		}

		if (isset(request::$post['address'])) {
			$data['address'] = request::$post['address'];
		} elseif (!empty($location_info)) {
			$data['address'] = $location_info['address'];
		} else {
			$data['address'] = '';
		}

		if (isset(request::$post['geocode'])) {
			$data['geocode'] = request::$post['geocode'];
		} elseif (!empty($location_info)) {
			$data['geocode'] = $location_info['geocode'];
		} else {
			$data['geocode'] = '';
		}

		if (isset(request::$post['telephone'])) {
			$data['telephone'] = request::$post['telephone'];
		} elseif (!empty($location_info)) {
			$data['telephone'] = $location_info['telephone'];
		} else {
			$data['telephone'] = '';
		}
		
		if (isset(request::$post['fax'])) {
			$data['fax'] = request::$post['fax'];
		} elseif (!empty($location_info)) {
			$data['fax'] = $location_info['fax'];
		} else {
			$data['fax'] = '';
		}
		
		if (isset(request::$post['image'])) {
			$data['image'] = request::$post['image'];
		} elseif (!empty($location_info)) {
			$data['image'] = $location_info['image'];
		} else {
			$data['image'] = '';
		}


		if (isset(request::$post['image']) && is_file('image/' . request::$post['image'])) {
			$data['thumb'] = admin_tool_image::resize(request::$post['image'], 100, 100);
		} elseif (!empty($location_info) && is_file('image/' . $location_info['image'])) {
			$data['thumb'] = admin_tool_image::resize($location_info['image'], 100, 100);
		} else {
			$data['thumb'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		$data['placeholder'] = admin_tool_image::resize('no_image.png', 100, 100);

		if (isset(request::$post['open'])) {
			$data['open'] = request::$post['open'];
		} elseif (!empty($location_info)) {
			$data['open'] = $location_info['open'];
		} else {
			$data['open'] = '';
		}

		if (isset(request::$post['comment'])) {
			$data['comment'] = request::$post['comment'];
		} elseif (!empty($location_info)) {
			$data['comment'] = $location_info['comment'];
		} else {
			$data['comment'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('localisation/location_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'localisation/location')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if ((utf8_strlen(request::$post['name']) < 3) || (utf8_strlen(request::$post['name']) > 32)) {
			self::$error['name'] = language::get('error_name');
		}

		if ((utf8_strlen(request::$post['address']) < 3) || (utf8_strlen(request::$post['address']) > 128)) {
			self::$error['address'] = language::get('error_address');
		}

		if ((utf8_strlen(request::$post['telephone']) < 3) || (utf8_strlen(request::$post['telephone']) > 32)) {
			self::$error['telephone'] = language::get('error_telephone');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'localisation/location')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}