<?php
class ControllerLocalisationOrderStatus {
	private static $error = array();

	public static function index() {
		load::language('localisation/order_status');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('localisation/order_status');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_localisation_order_status::addOrderStatus(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/order_status', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('localisation/order_status');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_localisation_order_status::editOrderStatus(request::$get['order_status_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/order_status', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('localisation/order_status');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $order_status_id) {
				admin_localisation_order_status::deleteOrderStatus($order_status_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/order_status', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'name';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('localisation/order_status', $url)
		);

		$data['add'] = url::link('localisation/order_status/add', $url);
		$data['delete'] = url::link('localisation/order_status/delete', $url);

		$data['order_statuses'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * config('limit_admin'),
			'limit' => config('limit_admin')
		);

		$order_status_total = admin_localisation_order_status::getTotalOrderStatuses();

		$results = admin_localisation_order_status::getOrderStatuses($filter_data);

		foreach ($results as $result) {
			$data['order_statuses'][] = array(
				'order_status_id' => $result['order_status_id'],
				'name'            => $result['name'] . (($result['order_status_id'] == config('order_status_id')) ? language::get('text_default') : null),
				'edit'            => url::link('localisation/order_status/edit', '&order_status_id=' . $result['order_status_id'] . $url)
			);
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_name'] = url::link('localisation/order_status', '&sort=name' . $url);

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $order_status_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('localisation/order_status', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($order_status_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($order_status_total - config('limit_admin'))) ? $order_status_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $order_status_total, ceil($order_status_total / config('limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('localisation/order_status_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['order_status_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = array();
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('localisation/order_status', $url)
		);

		if (!isset(request::$get['order_status_id'])) {
			$data['action'] = url::link('localisation/order_status/add', $url);
		} else {
			$data['action'] = url::link('localisation/order_status/edit', '&order_status_id=' . request::$get['order_status_id'] . $url);
		}

		$data['cancel'] = url::link('localisation/order_status', $url);


		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['order_status'])) {
			$data['order_status'] = request::$post['order_status'];
		} elseif (isset(request::$get['order_status_id'])) {
			$data['order_status'] = admin_localisation_order_status::getOrderStatusDescriptions(request::$get['order_status_id']);
		} else {
			$data['order_status'] = array();
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('localisation/order_status_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'localisation/order_status')) {
			self::$error['warning'] = language::get('error_permission');
		}

		foreach (request::$post['order_status'] as $language_id => $value) {
			if ((utf8_strlen($value['name']) < 3) || (utf8_strlen($value['name']) > 32)) {
				self::$error['name'][$language_id] = language::get('error_name');
			}
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'localisation/order_status')) {
			self::$error['warning'] = language::get('error_permission');
		}


		foreach (request::$post['selected'] as $order_status_id) {
			if (config('order_status_id') == $order_status_id) {
				self::$error['warning'] = language::get('error_default');
			}

			if (config('download_status_id') == $order_status_id) {
				self::$error['warning'] = language::get('error_download');
			}

			$store_total = admin_setting_store::getTotalStoresByOrderStatusId($order_status_id);

			if ($store_total) {
				self::$error['warning'] = sprintf(language::get('error_store'), $store_total);
			}

			$order_total = admin_sale_order::getTotalOrdersByOrderStatusId($order_status_id);

			if ($order_total) {
				self::$error['warning'] = sprintf(language::get('error_order'), $order_total);
			}

			$order_total = admin_sale_order::getTotalOrderHistoriesByOrderStatusId($order_status_id);

			if ($order_total) {
				self::$error['warning'] = sprintf(language::get('error_order'), $order_total);
			}
		}

		return !self::$error;
	}
}
