<?php
class ControllerLocalisationWeightClass {
	private static $error = array();

	public static function index() {
		load::language('localisation/weight_class');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('localisation/weight_class');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_localisation_weight_class::addWeightClass(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/weight_class', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('localisation/weight_class');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_localisation_weight_class::editWeightClass(request::$get['weight_class_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/weight_class', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('localisation/weight_class');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $weight_class_id) {
				admin_localisation_weight_class::deleteWeightClass($weight_class_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('localisation/weight_class', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'title';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('localisation/weight_class', $url)
		);

		$data['add'] = url::link('localisation/weight_class/add', $url);
		$data['delete'] = url::link('localisation/weight_class/delete', $url);

		$data['weight_classes'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * config('limit_admin'),
			'limit' => config('limit_admin')
		);

		$weight_class_total = admin_localisation_weight_class::getTotalWeightClasses();

		$results = admin_localisation_weight_class::getWeightClasses($filter_data);

		foreach ($results as $result) {
			$data['weight_classes'][] = array(
				'weight_class_id' => $result['weight_class_id'],
				'title'           => $result['title'] . (($result['weight_class_id'] == config('weight_class_id')) ? language::get('text_default') : null),
				'unit'            => $result['unit'],
				'value'           => $result['value'],
				'edit'            => url::link('localisation/weight_class/edit', '&weight_class_id=' . $result['weight_class_id'] . $url)
			);
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_title'] = url::link('localisation/weight_class', '&sort=title' . $url);
		$data['sort_unit'] = url::link('localisation/weight_class', '&sort=unit' . $url);
		$data['sort_value'] = url::link('localisation/weight_class', '&sort=value' . $url);

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $weight_class_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('localisation/weight_class', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($weight_class_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($weight_class_total - config('limit_admin'))) ? $weight_class_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $weight_class_total, ceil($weight_class_total / config('limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('localisation/weight_class_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['weight_class_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['title'])) {
			$data['error_title'] = self::$error['title'];
		} else {
			$data['error_title'] = array();
		}

		if (isset(self::$error['unit'])) {
			$data['error_unit'] = self::$error['unit'];
		} else {
			$data['error_unit'] = array();
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('localisation/weight_class', $url)
		);

		if (!isset(request::$get['weight_class_id'])) {
			$data['action'] = url::link('localisation/weight_class/add', $url);
		} else {
			$data['action'] = url::link('localisation/weight_class/edit', '&weight_class_id=' . request::$get['weight_class_id'] . $url);
		}

		$data['cancel'] = url::link('localisation/weight_class', $url);

		if (isset(request::$get['weight_class_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$weight_class_info = admin_localisation_weight_class::getWeightClass(request::$get['weight_class_id']);
		}


		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['weight_class_description'])) {
			$data['weight_class_description'] = request::$post['weight_class_description'];
		} elseif (isset(request::$get['weight_class_id'])) {
			$data['weight_class_description'] = admin_localisation_weight_class::getWeightClassDescriptions(request::$get['weight_class_id']);
		} else {
			$data['weight_class_description'] = array();
		}

		if (isset(request::$post['value'])) {
			$data['value'] = request::$post['value'];
		} elseif (!empty($weight_class_info)) {
			$data['value'] = $weight_class_info['value'];
		} else {
			$data['value'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('localisation/weight_class_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'localisation/weight_class')) {
			self::$error['warning'] = language::get('error_permission');
		}

		foreach (request::$post['weight_class_description'] as $language_id => $value) {
			if ((utf8_strlen($value['title']) < 3) || (utf8_strlen($value['title']) > 32)) {
				self::$error['title'][$language_id] = language::get('error_title');
			}

			if (!$value['unit'] || (utf8_strlen($value['unit']) > 4)) {
				self::$error['unit'][$language_id] = language::get('error_unit');
			}
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'localisation/weight_class')) {
			self::$error['warning'] = language::get('error_permission');
		}


		foreach (request::$post['selected'] as $weight_class_id) {
			if (config('weight_class_id') == $weight_class_id) {
				self::$error['warning'] = language::get('error_default');
			}

			$product_total = admin_catalog_product::getTotalProductsByWeightClassId($weight_class_id);

			if ($product_total) {
				self::$error['warning'] = sprintf(language::get('error_product'), $product_total);
			}
		}

		return !self::$error;
	}
}