<?php
class ControllerMailAffiliate {
	public static function approve(&$route, &$args, &$output) {

		$customer_info = admin_customer_customer::getCustomer($args[0]);

		if ($customer_info) {

			$store_info = admin_setting_store::getStore($customer_info['store_id']);

			if ($store_info) {
				$store_name = html_entity_decode($store_info['name'], ENT_QUOTES, 'UTF-8');
				$store_url = $store_info['url'];
			} else {
				$store_name = html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8');
				$store_url = HTTP_CATALOG;
			}


			$language_info = admin_localisation_language::getLanguage($customer_info['language_id']);

			if ($language_info) {
				$language_code = $language_info['code'];
			} else {
				$language_code = config('language');
			}

			$language = new Language($language_code);
			$language::load($language_code);
			$language::load('mail/affiliate_approve');

			$subject = sprintf($language::get('text_subject'), $store_name);

			$data['text_welcome'] = sprintf($language::get('text_welcome'), $store_name);

			$data['login'] = $store_url . 'index.php?route=affiliate/login';
			$data['store'] = $store_name;

			$mail = new Mail(config('mail_engine'));
			$mail::$parameter = config('mail_parameter');
			$mail::$smtp_hostname = config('mail_smtp_hostname');
			$mail::$smtp_username = config('mail_smtp_username');
			$mail::$smtp_password = html_entity_decode(config('mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail::$smtp_port = config('mail_smtp_port');
			$mail::$smtp_timeout = config('mail_smtp_timeout');

			$mail::setTo($customer_info['email']);
			$mail::setFrom(config('email'));
			$mail::setSender($store_name);
			$mail::setSubject($subject);
			$mail::setText(load::view('mail/affiliate_approve', $data));
			$mail::send();
		}
	}

	public static function deny(&$route, &$args, &$output) {

		$customer_info = admin_customer_customer::getCustomer($args[0]);

		if ($customer_info) {

			$store_info = admin_setting_store::getStore($customer_info['store_id']);

			if ($store_info) {
				$store_name = html_entity_decode($store_info['name'], ENT_QUOTES, 'UTF-8');
				$store_url = $store_info['url'];
			} else {
				$store_name = html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8');
				$store_url = HTTP_CATALOG;
			}


			$language_info = admin_localisation_language::getLanguage($customer_info['language_id']);

			if ($language_info) {
				$language_code = $language_info['code'];
			} else {
				$language_code = config('language');
			}

			$language = new Language($language_code);
			$language::load($language_code);
			$language::load('mail/affiliate_deny');

			$subject = sprintf($language::get('text_subject'), $store_name);

			$data['text_welcome'] = sprintf($language::get('text_welcome'), $store_name);

			$data['contact'] = $store_url . 'index.php?route=information/contact';
			$data['store'] = $store_name;

			$mail = new Mail(config('mail_engine'));
			$mail::$parameter = config('mail_parameter');
			$mail::$smtp_hostname = config('mail_smtp_hostname');
			$mail::$smtp_username = config('mail_smtp_username');
			$mail::$smtp_password = html_entity_decode(config('mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail::$smtp_port = config('mail_smtp_port');
			$mail::$smtp_timeout = config('mail_smtp_timeout');

			$mail::setTo($customer_info['email']);
			$mail::setFrom(config('email'));
			$mail::setSender($store_name);
			$mail::setSubject($subject);
			$mail::setText(load::view('mail/affiliate_deny', $data));
			$mail::send();
		}
	}
}