<?php
class ControllerMailTransaction {
	public static function index($route, $args, $output) {
		if (isset($args[0])) {
			$customer_id = $args[0];
		} else {
			$customer_id = '';
		}
		
		if (isset($args[1])) {
			$description = $args[1];
		} else {
			$description = '';
		}		
		
		if (isset($args[2])) {
			$amount = $args[2];
		} else {
			$amount = '';
		}
		
		if (isset($args[3])) {
			$order_id = $args[3];
		} else {
			$order_id = '';
		}
			
						
		$customer_info = admin_customer_customer::getCustomer($customer_id);

		if ($customer_info) {
			load::language('mail/transaction');


			$store_info = admin_setting_store::getStore($customer_info['store_id']);

			if ($store_info) {
				$store_name = $store_info['name'];
			} else {
				$store_name = config('name');
			}

			$data['text_received'] = sprintf(language::get('text_received'), currency::format($amount, config('currency')));
			$data['text_total'] = sprintf(language::get('text_total'), currency::format(admin_customer_customer::getTransactionTotal($customer_id), config('currency')));
			
			$mail = new Mail(config('mail_engine'));
			$mail::$parameter = config('mail_parameter');
			$mail::$smtp_hostname = config('mail_smtp_hostname');
			$mail::$smtp_username = config('mail_smtp_username');
			$mail::$smtp_password = html_entity_decode(config('mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail::$smtp_port = config('mail_smtp_port');
			$mail::$smtp_timeout = config('mail_smtp_timeout');

			$mail::setTo($customer_info['email']);
			$mail::setFrom(config('email'));
			$mail::setSender(html_entity_decode($store_name, ENT_QUOTES, 'UTF-8'));
			$mail::setSubject(sprintf(language::get('text_subject'), html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8')));
			$mail::setText(load::view('mail/transaction', $data));
			$mail::send();
		}
	}		
}	
