<?php
class ControllerMarketingCoupon {
	private static $error = array();

	public static function index() {
		load::language('marketing/coupon');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('marketing/coupon');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_marketing_coupon::addCoupon(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('marketing/coupon', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('marketing/coupon');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_marketing_coupon::editCoupon(request::$get['coupon_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('marketing/coupon', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('marketing/coupon');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $coupon_id) {
				admin_marketing_coupon::deleteCoupon($coupon_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('marketing/coupon', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'name';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('marketing/coupon', $url)
		);

		$data['add'] = url::link('marketing/coupon/add', $url);
		$data['delete'] = url::link('marketing/coupon/delete', $url);

		$data['coupons'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * config('limit_admin'),
			'limit' => config('limit_admin')
		);

		$coupon_total = admin_marketing_coupon::getTotalCoupons();

		$results = admin_marketing_coupon::getCoupons($filter_data);

		foreach ($results as $result) {
			$data['coupons'][] = array(
				'coupon_id'  => $result['coupon_id'],
				'name'       => $result['name'],
				'code'       => $result['code'],
				'discount'   => $result['discount'],
				'date_start' => date(language::get('date_format_short'), strtotime($result['date_start'])),
				'date_end'   => date(language::get('date_format_short'), strtotime($result['date_end'])),
				'status'     => ($result['status'] ? language::get('text_enabled') : language::get('text_disabled')),
				'edit'       => url::link('marketing/coupon/edit', '&coupon_id=' . $result['coupon_id'] . $url)
			);
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_name'] = url::link('marketing/coupon', '&sort=name' . $url);
		$data['sort_code'] = url::link('marketing/coupon', '&sort=code' . $url);
		$data['sort_discount'] = url::link('marketing/coupon', '&sort=discount' . $url);
		$data['sort_date_start'] = url::link('marketing/coupon', '&sort=date_start' . $url);
		$data['sort_date_end'] = url::link('marketing/coupon', '&sort=date_end' . $url);
		$data['sort_status'] = url::link('marketing/coupon', '&sort=status' . $url);

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $coupon_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('marketing/coupon', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($coupon_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($coupon_total - config('limit_admin'))) ? $coupon_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $coupon_total, ceil($coupon_total / config('limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('marketing/coupon_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['coupon_id']) ? language::get('text_add') : language::get('text_edit');


		if (isset(request::$get['coupon_id'])) {
			$data['coupon_id'] = (int)request::$get['coupon_id'];
		} else {
			$data['coupon_id'] = 0;
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset(self::$error['code'])) {
			$data['error_code'] = self::$error['code'];
		} else {
			$data['error_code'] = '';
		}

		if (isset(self::$error['date_start'])) {
			$data['error_date_start'] = self::$error['date_start'];
		} else {
			$data['error_date_start'] = '';
		}

		if (isset(self::$error['date_end'])) {
			$data['error_date_end'] = self::$error['date_end'];
		} else {
			$data['error_date_end'] = '';
		}

		$url = '';

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('marketing/coupon', $url)
		);

		if (!isset(request::$get['coupon_id'])) {
			$data['action'] = url::link('marketing/coupon/add', $url);
		} else {
			$data['action'] = url::link('marketing/coupon/edit', '&coupon_id=' . request::$get['coupon_id'] . $url);
		}

		$data['cancel'] = url::link('marketing/coupon', $url);

		if (isset(request::$get['coupon_id']) && (!request::$server['REQUEST_METHOD'] != 'POST')) {
			$coupon_info = admin_marketing_coupon::getCoupon(request::$get['coupon_id']);
		}

		if (isset(request::$post['name'])) {
			$data['name'] = request::$post['name'];
		} elseif (!empty($coupon_info)) {
			$data['name'] = $coupon_info['name'];
		} else {
			$data['name'] = '';
		}

		if (isset(request::$post['code'])) {
			$data['code'] = request::$post['code'];
		} elseif (!empty($coupon_info)) {
			$data['code'] = $coupon_info['code'];
		} else {
			$data['code'] = '';
		}

		if (isset(request::$post['type'])) {
			$data['type'] = request::$post['type'];
		} elseif (!empty($coupon_info)) {
			$data['type'] = $coupon_info['type'];
		} else {
			$data['type'] = '';
		}

		if (isset(request::$post['discount'])) {
			$data['discount'] = request::$post['discount'];
		} elseif (!empty($coupon_info)) {
			$data['discount'] = $coupon_info['discount'];
		} else {
			$data['discount'] = '';
		}

		if (isset(request::$post['logged'])) {
			$data['logged'] = request::$post['logged'];
		} elseif (!empty($coupon_info)) {
			$data['logged'] = $coupon_info['logged'];
		} else {
			$data['logged'] = '';
		}

		if (isset(request::$post['shipping'])) {
			$data['shipping'] = request::$post['shipping'];
		} elseif (!empty($coupon_info)) {
			$data['shipping'] = $coupon_info['shipping'];
		} else {
			$data['shipping'] = '';
		}

		if (isset(request::$post['total'])) {
			$data['total'] = request::$post['total'];
		} elseif (!empty($coupon_info)) {
			$data['total'] = $coupon_info['total'];
		} else {
			$data['total'] = '';
		}

		if (isset(request::$post['coupon_product'])) {
			$products = request::$post['coupon_product'];
		} elseif (isset(request::$get['coupon_id'])) {
			$products = admin_marketing_coupon::getCouponProducts(request::$get['coupon_id']);
		} else {
			$products = array();
		}


		$data['coupon_product'] = array();

		foreach ($products as $product_id) {
			$product_info = admin_catalog_product::getProduct($product_id);

			if ($product_info) {
				$data['coupon_product'][] = array(
					'product_id' => $product_info['product_id'],
					'name'       => $product_info['name']
				);
			}
		}

		if (isset(request::$post['coupon_category'])) {
			$categories = request::$post['coupon_category'];
		} elseif (isset(request::$get['coupon_id'])) {
			$categories = admin_marketing_coupon::getCouponCategories(request::$get['coupon_id']);
		} else {
			$categories = array();
		}


		$data['coupon_category'] = array();

		foreach ($categories as $category_id) {
			$category_info = admin_catalog_category::getCategory($category_id);

			if ($category_info) {
				$data['coupon_category'][] = array(
					'category_id' => $category_info['category_id'],
					'name'        => ($category_info['path'] ? $category_info['path'] . ' &gt; ' : '') . $category_info['name']
				);
			}
		}

		if (isset(request::$post['date_start'])) {
			$data['date_start'] = request::$post['date_start'];
		} elseif (!empty($coupon_info)) {
			$data['date_start'] = ($coupon_info['date_start'] != '0000-00-00' ? $coupon_info['date_start'] : '');
		} else {
			$data['date_start'] = date('Y-m-d', time());
		}

		if (isset(request::$post['date_end'])) {
			$data['date_end'] = request::$post['date_end'];
		} elseif (!empty($coupon_info)) {
			$data['date_end'] = ($coupon_info['date_end'] != '0000-00-00' ? $coupon_info['date_end'] : '');
		} else {
			$data['date_end'] = date('Y-m-d', strtotime('+1 month'));
		}

		if (isset(request::$post['uses_total'])) {
			$data['uses_total'] = request::$post['uses_total'];
		} elseif (!empty($coupon_info)) {
			$data['uses_total'] = $coupon_info['uses_total'];
		} else {
			$data['uses_total'] = 1;
		}

		if (isset(request::$post['uses_customer'])) {
			$data['uses_customer'] = request::$post['uses_customer'];
		} elseif (!empty($coupon_info)) {
			$data['uses_customer'] = $coupon_info['uses_customer'];
		} else {
			$data['uses_customer'] = 1;
		}

		if (isset(request::$post['status'])) {
			$data['status'] = request::$post['status'];
		} elseif (!empty($coupon_info)) {
			$data['status'] = $coupon_info['status'];
		} else {
			$data['status'] = true;
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('marketing/coupon_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'marketing/coupon')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if ((utf8_strlen(request::$post['name']) < 3) || (utf8_strlen(request::$post['name']) > 128)) {
			self::$error['name'] = language::get('error_name');
		}

		if ((utf8_strlen(request::$post['code']) < 3) || (utf8_strlen(request::$post['code']) > 20)) {
			self::$error['code'] = language::get('error_code');
		}

		$coupon_info = admin_marketing_coupon::getCouponByCode(request::$post['code']);

		if ($coupon_info) {
			if (!isset(request::$get['coupon_id'])) {
				self::$error['warning'] = language::get('error_exists');
			} elseif ($coupon_info['coupon_id'] != request::$get['coupon_id']) {
				self::$error['warning'] = language::get('error_exists');
			}
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'marketing/coupon')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	public static function history() {
		load::language('marketing/coupon');


		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$data['histories'] = array();

		$results = admin_marketing_coupon::getCouponHistories(request::$get['coupon_id'], ($page - 1) * 10, 10);

		foreach ($results as $result) {
			$data['histories'][] = array(
				'order_id'   => $result['order_id'],
				'customer'   => $result['customer'],
				'amount'     => $result['amount'],
				'date_added' => date(language::get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$history_total = admin_marketing_coupon::getTotalCouponHistories(request::$get['coupon_id']);

		$pagination = new Pagination();
		$pagination::$total = $history_total;
		$pagination::$page = $page;
		$pagination::$limit = 10;
		$pagination::$url = url::link('marketing/coupon/history', '&coupon_id=' . request::$get['coupon_id'] . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($history_total) ? (($page - 1) * 10) + 1 : 0, ((($page - 1) * 10) > ($history_total - 10)) ? $history_total : ((($page - 1) * 10) + 10), $history_total, ceil($history_total / 10));

		response::setOutput(load::view('marketing/coupon_history', $data));
	}
}