<?php
class ControllerMarketingMarketing {
	private static $error = array();

	public static function index() {
		load::language('marketing/marketing');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('marketing/marketing');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_marketing_marketing::addMarketing(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_code'])) {
				$url .= '&filter_code=' . request::$get['filter_code'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('marketing/marketing', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('marketing/marketing');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_marketing_marketing::editMarketing(request::$get['marketing_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_code'])) {
				$url .= '&filter_code=' . request::$get['filter_code'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('marketing/marketing', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('marketing/marketing');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $marketing_id) {
				admin_marketing_marketing::deleteMarketing($marketing_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_name'])) {
				$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_code'])) {
				$url .= '&filter_code=' . request::$get['filter_code'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('marketing/marketing', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['filter_name'])) {
			$filter_name = request::$get['filter_name'];
		} else {
			$filter_name = '';
		}

		if (isset(request::$get['filter_code'])) {
			$filter_code = request::$get['filter_code'];
		} else {
			$filter_code = '';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'm.name';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_code'])) {
			$url .= '&filter_code=' . request::$get['filter_code'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('marketing/marketing', $url)
		);

		$data['add'] = url::link('marketing/marketing/add', $url);
		$data['delete'] = url::link('marketing/marketing/delete', $url);

		$data['marketings'] = array();

		$filter_data = array(
			'filter_name'       => $filter_name,
			'filter_code'       => $filter_code,
			'filter_date_added' => $filter_date_added,
			'sort'              => $sort,
			'order'             => $order,
			'start'             => ($page - 1) * config('limit_admin'),
			'limit'             => config('limit_admin')
		);

		$marketing_total = admin_marketing_marketing::getTotalMarketings($filter_data);

		$results = admin_marketing_marketing::getMarketings($filter_data);

		foreach ($results as $result) {
			$data['marketings'][] = array(
				'marketing_id' => $result['marketing_id'],
				'name'         => $result['name'],
				'code'         => $result['code'],
				'clicks'       => $result['clicks'],
				'orders'       => $result['orders'],
				'date_added'   => date(language::get('date_format_short'), strtotime($result['date_added'])),
				'edit'         => url::link('marketing/marketing/edit', '&marketing_id=' . $result['marketing_id'] . $url)
			);
		}


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_code'])) {
			$url .= '&filter_code=' . request::$get['filter_code'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_name'] = url::link('marketing/marketing', '&sort=m.name' . $url);
		$data['sort_code'] = url::link('marketing/marketing', '&sort=m.code' . $url);
		$data['sort_date_added'] = url::link('marketing/marketing', '&sort=m.date_added' . $url);

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_code'])) {
			$url .= '&filter_code=' . request::$get['filter_code'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $marketing_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('marketing/marketing', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($marketing_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($marketing_total - config('limit_admin'))) ? $marketing_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $marketing_total, ceil($marketing_total / config('limit_admin')));

		$data['filter_name'] = $filter_name;
		$data['filter_code'] = $filter_code;
		$data['filter_date_added'] = $filter_date_added;

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('marketing/marketing_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['marketing_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset(self::$error['code'])) {
			$data['error_code'] = self::$error['code'];
		} else {
			$data['error_code'] = '';
		}

		$url = '';

		if (isset(request::$get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode(request::$get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_code'])) {
			$url .= '&filter_code=' . request::$get['filter_code'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('marketing/marketing', $url)
		);

		if (!isset(request::$get['marketing_id'])) {
			$data['action'] = url::link('marketing/marketing/add', $url);
		} else {
			$data['action'] = url::link('marketing/marketing/edit', '&marketing_id=' . request::$get['marketing_id'] . $url);
		}

		$data['cancel'] = url::link('marketing/marketing', $url);

		if (isset(request::$get['marketing_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$marketing_info = admin_marketing_marketing::getMarketing(request::$get['marketing_id']);
		}


		$data['store'] = HTTP_CATALOG;

		if (isset(request::$post['name'])) {
			$data['name'] = request::$post['name'];
		} elseif (!empty($marketing_info)) {
			$data['name'] = $marketing_info['name'];
		} else {
			$data['name'] = '';
		}

		if (isset(request::$post['description'])) {
			$data['description'] = request::$post['description'];
		} elseif (!empty($marketing_info)) {
			$data['description'] = $marketing_info['description'];
		} else {
			$data['description'] = '';
		}

		if (isset(request::$post['code'])) {
			$data['code'] = request::$post['code'];
		} elseif (!empty($marketing_info)) {
			$data['code'] = $marketing_info['code'];
		} else {
			$data['code'] = uniqid();
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('marketing/marketing_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'marketing/marketing')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if ((utf8_strlen(request::$post['name']) < 1) || (utf8_strlen(request::$post['name']) > 32)) {
			self::$error['name'] = language::get('error_name');
		}

		if (!request::$post['code']) {
			self::$error['code'] = language::get('error_code');
		}

		$marketing_info = admin_marketing_marketing::getMarketingByCode(request::$post['code']);

		if (!isset(request::$get['marketing_id'])) {
			if ($marketing_info) {
				self::$error['code'] = language::get('error_exists');
			}
		} else {
			if ($marketing_info && (request::$get['marketing_id'] != $marketing_info['marketing_id'])) {
				self::$error['code'] = language::get('error_exists');
			}
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'marketing/marketing')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
}