<?php
class ControllerMarketplaceExtension {
	private static $error = array();

	public static function index() {
		load::language('marketplace/extension');

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('marketplace/extension')
		);


		if (isset(request::$get['type'])) {
			$data['type'] = request::$get['type'];
		} else {
			$data['type'] = '';
		}
		
		$data['categories'] = array();
		
		$files = glob(DIR_APPLICATION . 'controller/extension/extension/*.php', GLOB_BRACE);
		
		foreach ($files as $file) {
			$extension = basename($file, '.php');

			if ($extension=='promotion') {
				continue;
			}

			// Compatibility code for old extension folders
			load::language('extension/extension/' . $extension, 'extension');
		
			if (user::hasPermission('access', 'extension/extension/' . $extension)) {
				$files = glob(DIR_APPLICATION . 'controller/extension/' . $extension . '/*.php', GLOB_BRACE);
		
				$data['categories'][] = array(
					'code' => $extension,
					'text' => language::get('extension')::get('heading_title') . ' (' . count($files) .')',
					'href' => url::link('extension/extension/' . $extension)
				);
			}
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('marketplace/extension', $data));
	}

	public static function refreshMenu() {
		$output = load::controller('common/column_left');
		response::setOutput($output);
	}
}
