<?php
class ControllerReportOnline {
	public static function index() {
		load::language('report/online');

		document::setTitle(language::get('heading_title'));

		if (isset(request::$get['filter_ip'])) {
			$filter_ip = request::$get['filter_ip'];
		} else {
			$filter_ip = '';
		}

		if (isset(request::$get['filter_customer'])) {
			$filter_customer = request::$get['filter_customer'];
		} else {
			$filter_customer = '';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}
		
		$url = '';

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_ip'])) {
			$url .= '&filter_ip=' . request::$get['filter_ip'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}
			
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('report/online')
		);
		
		$data['refresh'] = url::link('report/online', $url);


		$data['customers'] = array();

		$filter_data = array(
			'filter_ip'       => $filter_ip,
			'filter_customer' => $filter_customer,
			'start'           => ($page - 1) * config('limit_admin'),
			'limit'           => config('limit_admin')
		);

		$customer_total = admin_report_online::getTotalOnline($filter_data);

		$results = admin_report_online::getOnline($filter_data);

		foreach ($results as $result) {
			$customer_info = admin_customer_customer::getCustomer($result['customer_id']);

			if ($customer_info) {
				$customer = $customer_info['firstname'] . ' ' . $customer_info['lastname'];
			} else {
				$customer = language::get('text_guest');
			}

			$data['customers'][] = array(
				'customer_id' => $result['customer_id'],
				'ip'          => $result['ip'],
				'customer'    => $customer,
				'url'         => $result['url'],
				'referer'     => $result['referer'],
				'date_added'  => date(language::get('datetime_format'), strtotime($result['date_added'])),
				'edit'        => url::link('customer/customer/edit', '&customer_id=' . $result['customer_id'])
			);
		}


		$url = '';

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(request::$get['filter_customer']);
		}

		if (isset(request::$get['filter_ip'])) {
			$url .= '&filter_ip=' . request::$get['filter_ip'];
		}

		$pagination = new Pagination();
		$pagination::$total = $customer_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('report/online', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($customer_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($customer_total - config('limit_admin'))) ? $customer_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $customer_total, ceil($customer_total / config('limit_admin')));

		$data['filter_customer'] = $filter_customer;
		$data['filter_ip'] = $filter_ip;
		
		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');
		
		response::setOutput(load::view('report/online', $data));
	}
}