<?php
class ControllerReportReport {
	public static function index() {
		load::language('report/report');

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('report/report')
		);


		if (isset(request::$get['code'])) {
			$data['code'] = request::$get['code'];
		} else {
			$data['code'] = '';
		}

		// Reports
		$data['reports'] = array();
		

		// Get a list of installed modules
		$extensions = admin_setting_extension::getInstalled('report');
		
		// Add all the modules which have multiple settings for each module
		foreach ($extensions as $code) {
			if (config::get('report_' . $code . '_status') && user::hasPermission('access', 'extension/report/' . $code)) {
				load::language('extension/report/' . $code, 'extension');
				
				$data['reports'][] = array(
					'text'       => language::get('extension')::get('heading_title'),
					'code'       => $code,
					'sort_order' => config::get('report_' . $code . '_sort_order'),
					'href'       => url::link('report/report', '&code=' . $code)
				);
			}
		}
		
		$sort_order = array();

		foreach ($data['reports'] as $key => $value) {
			$sort_order[$key] = $value['sort_order'];
		}

		array_multisort($sort_order, SORT_ASC, $data['reports']);	
		
		if (isset(request::$get['code'])) {
			$data['report'] = load::controller('extension/report/' . request::$get['code'] . '/report');
		} elseif (isset($data['reports'][0])) {
			$data['report'] = load::controller('extension/report/' . $data['reports'][0]['code'] . '/report');
		} else {
			$data['report'] = '';
		}
		
		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('report/report', $data));
	}
}