<?php
class ControllerSaleOrder {
	private static $error = array();

	public static function index() {
		load::language('sale/order');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('sale/order');

		document::setTitle(language::get('heading_title'));


		self::getForm();
	}

	public static function edit() {
		load::language('sale/order');

		document::setTitle(language::get('heading_title'));


		self::getForm();
	}
	
	public static function delete() {
		load::language('sale/order');

		document::setTitle(language::get('heading_title'));

		session::$data['success'] = language::get('text_success');

		$url = '';

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_order_status'])) {
			$url .= '&filter_order_status=' . request::$get['filter_order_status'];
		}
	
		if (isset(request::$get['filter_order_status_id'])) {
			$url .= '&filter_order_status_id=' . request::$get['filter_order_status_id'];
		}
			
		if (isset(request::$get['filter_total'])) {
			$url .= '&filter_total=' . request::$get['filter_total'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		response::redirect(url::link('sale/order', $url));
	}
			
	protected static function getList() {
		if (isset(request::$get['filter_order_id'])) {
			$filter_order_id = request::$get['filter_order_id'];
		} else {
			$filter_order_id = '';
		}

		if (isset(request::$get['filter_customer'])) {
			$filter_customer = request::$get['filter_customer'];
		} else {
			$filter_customer = '';
		}

		if (isset(request::$get['filter_order_status'])) {
			$filter_order_status = request::$get['filter_order_status'];
		} else {
			$filter_order_status = '';
		}
		
		if (isset(request::$get['filter_order_status_id'])) {
			$filter_order_status_id = request::$get['filter_order_status_id'];
		} else {
			$filter_order_status_id = '';
		}
		
		if (isset(request::$get['filter_total'])) {
			$filter_total = request::$get['filter_total'];
		} else {
			$filter_total = '';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		if (isset(request::$get['filter_date_modified'])) {
			$filter_date_modified = request::$get['filter_date_modified'];
		} else {
			$filter_date_modified = '';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'o.order_id';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'DESC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_order_status'])) {
			$url .= '&filter_order_status=' . request::$get['filter_order_status'];
		}
	
		if (isset(request::$get['filter_order_status_id'])) {
			$url .= '&filter_order_status_id=' . request::$get['filter_order_status_id'];
		}
			
		if (isset(request::$get['filter_total'])) {
			$url .= '&filter_total=' . request::$get['filter_total'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('sale/order', $url)
		);

		$data['invoice'] = url::link('sale/order/invoice');
		$data['shipping'] = url::link('sale/order/shipping');
		$data['add'] = url::link('sale/order/add', $url);
		$data['delete'] = str_replace('&amp;', '&', url::link('sale/order/delete', $url));

		$data['orders'] = array();

		$filter_data = array(
			'filter_order_id'        => $filter_order_id,
			'filter_customer'	     => $filter_customer,
			'filter_order_status'    => $filter_order_status,
			'filter_order_status_id' => $filter_order_status_id,
			'filter_total'           => $filter_total,
			'filter_date_added'      => $filter_date_added,
			'filter_date_modified'   => $filter_date_modified,
			'sort'                   => $sort,
			'order'                  => $order,
			'start'                  => ($page - 1) * config('limit_admin'),
			'limit'                  => config('limit_admin')
		);

		$order_total = admin_sale_order::getTotalOrders($filter_data);

		$results = admin_sale_order::getOrders($filter_data);

		foreach ($results as $result) {
			$data['orders'][] = array(
				'order_id'      => $result['order_id'],
				'customer'      => $result['customer'],
				'order_status'  => $result['order_status'] ? $result['order_status'] : language::get('text_missing'),
				'total'         => currency::format($result['total'], $result['currency_code'], $result['currency_value']),
				'date_added'    => date(language::get('date_format_short'), strtotime($result['date_added'])),
				'date_modified' => date(language::get('date_format_short'), strtotime($result['date_modified'])),
				'shipping_code' => $result['shipping_code'],
				'view'          => url::link('sale/order/info', '&order_id=' . $result['order_id'] . $url),
				'edit'          => url::link('sale/order/edit', '&order_id=' . $result['order_id'] . $url)
			);
		}


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_order_status'])) {
			$url .= '&filter_order_status=' . request::$get['filter_order_status'];
		}
		
		if (isset(request::$get['filter_order_status_id'])) {
			$url .= '&filter_order_status_id=' . request::$get['filter_order_status_id'];
		}
			
		if (isset(request::$get['filter_total'])) {
			$url .= '&filter_total=' . request::$get['filter_total'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_order'] = url::link('sale/order', '&sort=o.order_id' . $url);
		$data['sort_customer'] = url::link('sale/order', '&sort=customer' . $url);
		$data['sort_status'] = url::link('sale/order', '&sort=order_status' . $url);
		$data['sort_total'] = url::link('sale/order', '&sort=o.total' . $url);
		$data['sort_date_added'] = url::link('sale/order', '&sort=o.date_added' . $url);
		$data['sort_date_modified'] = url::link('sale/order', '&sort=o.date_modified' . $url);

		$url = '';

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_order_status'])) {
			$url .= '&filter_order_status=' . request::$get['filter_order_status'];
		}
		
		if (isset(request::$get['filter_order_status_id'])) {
			$url .= '&filter_order_status_id=' . request::$get['filter_order_status_id'];
		}
			
		if (isset(request::$get['filter_total'])) {
			$url .= '&filter_total=' . request::$get['filter_total'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $order_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('sale/order', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($order_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($order_total - config('limit_admin'))) ? $order_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $order_total, ceil($order_total / config('limit_admin')));

		$data['filter_order_id'] = $filter_order_id;
		$data['filter_customer'] = $filter_customer;
		$data['filter_order_status'] = $filter_order_status;
		$data['filter_order_status_id'] = $filter_order_status_id;
		$data['filter_total'] = $filter_total;
		$data['filter_date_added'] = $filter_date_added;
		$data['filter_date_modified'] = $filter_date_modified;

		$data['sort'] = $sort;
		$data['order'] = $order;


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		// API login
		$data['catalog'] = request::$server['HTTPS'] ? HTTPS_CATALOG : HTTP_CATALOG;
		
		// API login

		$api_info = admin_user_api::getApi(config('api_id'));

		if ($api_info && user::hasPermission('modify', 'sale/order')) {
			$session = new Session(config::get('session_engine'));
			
			$session::start();
					
			admin_user_api::deleteApiSessionBySessionId($session::getId());
			
			admin_user_api::addApiSession($api_info['api_id'], $session::getId(), request::$server['REMOTE_ADDR']);
			
			$session::$data['api_id'] = $api_info['api_id'];

			$data['api_token'] = $session::getId();
		} else {
			$data['api_token'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('sale/order_list', $data));
	}
		
	public static function getForm() {
		$data['text_form'] = !isset(request::$get['order_id']) ? language::get('text_add') : language::get('text_edit');

		$url = '';

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_order_status'])) {
			$url .= '&filter_order_status=' . request::$get['filter_order_status'];
		}
		
		if (isset(request::$get['filter_order_status_id'])) {
			$url .= '&filter_order_status_id=' . request::$get['filter_order_status_id'];
		}
			
		if (isset(request::$get['filter_total'])) {
			$url .= '&filter_total=' . request::$get['filter_total'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('sale/order', $url)
		);

		$data['cancel'] = url::link('sale/order', $url);


		if (isset(request::$get['order_id'])) {
			$order_info = admin_sale_order::getOrder(request::$get['order_id']);
		}

		if (!empty($order_info)) {
			$data['order_id'] = (int)request::$get['order_id'];
			$data['store_id'] = $order_info['store_id'];
			$data['store_url'] = request::$server['HTTPS'] ? HTTPS_CATALOG : HTTP_CATALOG;

			$data['customer'] = $order_info['customer'];
			$data['customer_id'] = $order_info['customer_id'];
			$data['customer_group_id'] = $order_info['customer_group_id'];
			$data['firstname'] = $order_info['firstname'];
			$data['lastname'] = $order_info['lastname'];
			$data['email'] = $order_info['email'];
			$data['telephone'] = $order_info['telephone'];
			$data['account_custom_field'] = $order_info['custom_field'];


			$data['addresses'] = admin_customer_customer::getAddresses($order_info['customer_id']);

			$data['payment_firstname'] = $order_info['payment_firstname'];
			$data['payment_lastname'] = $order_info['payment_lastname'];
			$data['payment_company'] = $order_info['payment_company'];
			$data['payment_address_1'] = $order_info['payment_address_1'];
			$data['payment_address_2'] = $order_info['payment_address_2'];
			$data['payment_city'] = $order_info['payment_city'];
			$data['payment_postcode'] = $order_info['payment_postcode'];
			$data['payment_country_id'] = $order_info['payment_country_id'];
			$data['payment_zone_id'] = $order_info['payment_zone_id'];
			$data['payment_custom_field'] = $order_info['payment_custom_field'];
			$data['payment_method'] = $order_info['payment_method'];
			$data['payment_code'] = $order_info['payment_code'];

			$data['shipping_firstname'] = $order_info['shipping_firstname'];
			$data['shipping_lastname'] = $order_info['shipping_lastname'];
			$data['shipping_company'] = $order_info['shipping_company'];
			$data['shipping_address_1'] = $order_info['shipping_address_1'];
			$data['shipping_address_2'] = $order_info['shipping_address_2'];
			$data['shipping_city'] = $order_info['shipping_city'];
			$data['shipping_postcode'] = $order_info['shipping_postcode'];
			$data['shipping_country_id'] = $order_info['shipping_country_id'];
			$data['shipping_zone_id'] = $order_info['shipping_zone_id'];
			$data['shipping_custom_field'] = $order_info['shipping_custom_field'];
			$data['shipping_method'] = $order_info['shipping_method'];
			$data['shipping_code'] = $order_info['shipping_code'];

			// Products
			$data['order_products'] = array();

			$products = admin_sale_order::getOrderProducts(request::$get['order_id']);

			foreach ($products as $product) {
				$data['order_products'][] = array(
					'product_id' => $product['product_id'],
					'name'       => $product['name'],
					'model'      => $product['model'],
					'option'     => admin_sale_order::getOrderOptions(request::$get['order_id'], $product['order_product_id']),
					'quantity'   => $product['quantity'],
					'price'      => $product['price'],
					'total'      => $product['total'],
					'reward'     => $product['reward']
				);
			}

			// Vouchers
			$data['order_vouchers'] = admin_sale_order::getOrderVouchers(request::$get['order_id']);

			$data['coupon'] = '';
			$data['voucher'] = '';
			$data['reward'] = '';

			$data['order_totals'] = array();

			$order_totals = admin_sale_order::getOrderTotals(request::$get['order_id']);

			foreach ($order_totals as $order_total) {
				// If coupon, voucher or reward points
				$start = strpos($order_total['title'], '(') + 1;
				$end = strrpos($order_total['title'], ')');

				if ($start && $end) {
					$data[$order_total['code']] = substr($order_total['title'], $start, $end - $start);
				}
			}

			$data['order_status_id'] = $order_info['order_status_id'];
			$data['comment'] = $order_info['comment'];
			$data['affiliate_id'] = $order_info['affiliate_id'];
			$data['affiliate'] = $order_info['affiliate_firstname'] . ' ' . $order_info['affiliate_lastname'];
			$data['currency_code'] = $order_info['currency_code'];
		} else {
			$data['order_id'] = 0;
			$data['store_id'] = 0;
			$data['store_url'] = request::$server['HTTPS'] ? HTTPS_CATALOG : HTTP_CATALOG;
			
			$data['customer'] = '';
			$data['customer_id'] = '';
			$data['customer_group_id'] = config('customer_group_id');
			$data['firstname'] = '';
			$data['lastname'] = '';
			$data['email'] = '';
			$data['telephone'] = '';
			$data['customer_custom_field'] = array();

			$data['addresses'] = array();

			$data['payment_firstname'] = '';
			$data['payment_lastname'] = '';
			$data['payment_company'] = '';
			$data['payment_address_1'] = '';
			$data['payment_address_2'] = '';
			$data['payment_city'] = '';
			$data['payment_postcode'] = '';
			$data['payment_country_id'] = '';
			$data['payment_zone_id'] = '';
			$data['payment_custom_field'] = array();
			$data['payment_method'] = '';
			$data['payment_code'] = '';

			$data['shipping_firstname'] = '';
			$data['shipping_lastname'] = '';
			$data['shipping_company'] = '';
			$data['shipping_address_1'] = '';
			$data['shipping_address_2'] = '';
			$data['shipping_city'] = '';
			$data['shipping_postcode'] = '';
			$data['shipping_country_id'] = '';
			$data['shipping_zone_id'] = '';
			$data['shipping_custom_field'] = array();
			$data['shipping_method'] = '';
			$data['shipping_code'] = '';

			$data['order_products'] = array();
			$data['order_vouchers'] = array();
			$data['order_totals'] = array();

			$data['order_status_id'] = config('order_status_id');
			$data['comment'] = '';
			$data['affiliate_id'] = '';
			$data['affiliate'] = '';
			$data['currency_code'] = config('currency');

			$data['coupon'] = '';
			$data['voucher'] = '';
			$data['reward'] = '';
		}

		// Stores

		$data['stores'] = array();

		$data['stores'][] = array(
			'store_id' => 0,
			'name'     => language::get('text_default')
		);

		$results = admin_setting_store::getStores();

		foreach ($results as $result) {
			$data['stores'][] = array(
				'store_id' => $result['store_id'],
				'name'     => $result['name']
			);
		}

		// Customer Groups

		$data['customer_groups'] = admin_customer_customer_group::getCustomerGroups();

		// Custom Fields

		$data['custom_fields'] = array();

		$custom_field_locations = array(
			'account_custom_field',
			'payment_custom_field',
			'shipping_custom_field'
		);

		$filter_data = array(
			'sort'  => 'cf.sort_order',
			'order' => 'ASC'
		);

		$custom_fields = admin_customer_custom_field::getCustomFields($filter_data);

		foreach ($custom_fields as $custom_field) {
			$data['custom_fields'][] = array(
				'custom_field_id'    => $custom_field['custom_field_id'],
				'custom_field_value' => admin_customer_custom_field::getCustomFieldValues($custom_field['custom_field_id']),
				'name'               => $custom_field['name'],
				'value'              => $custom_field['value'],
				'type'               => $custom_field['type'],
				'location'           => $custom_field['location'],
				'sort_order'         => $custom_field['sort_order']
			);

			if($custom_field['type'] == 'file') {
				foreach($custom_field_locations as $location) {
					if(isset($data[$location][$custom_field['custom_field_id']])) {
						$code = $data[$location][$custom_field['custom_field_id']];

						$upload_result = admin_tool_upload::getUploadByCode($code);

						$data[$location][$custom_field['custom_field_id']] = array();
						if($upload_result) {
							$data[$location][$custom_field['custom_field_id']]['name'] = $upload_result['name'];
							$data[$location][$custom_field['custom_field_id']]['code'] = $upload_result['code'];
						} else {
							$data[$location][$custom_field['custom_field_id']]['name'] = "";
							$data[$location][$custom_field['custom_field_id']]['code'] = $code;
						}
					}
				}
			}
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();


		$data['countries'] = admin_localisation_country::getCountries();


		$data['currencies'] = admin_localisation_currency::getCurrencies();

		$data['voucher_min'] = config('voucher_min');


		$data['voucher_themes'] = admin_sale_voucher_theme::getVoucherThemes();

		// API login
		$data['catalog'] = request::$server['HTTPS'] ? HTTPS_CATALOG : HTTP_CATALOG;
		
		// API login

		$api_info = admin_user_api::getApi(config('api_id'));

		if ($api_info && user::hasPermission('modify', 'sale/order')) {
			$session = new Session(config::get('session_engine'));
			
			$session::start();
					
			admin_user_api::deleteApiSessionBySessionId($session::getId());
			
			admin_user_api::addApiSession($api_info['api_id'], $session::getId(), request::$server['REMOTE_ADDR']);
			
			$session::$data['api_id'] = $api_info['api_id'];

			$data['api_token'] = $session::getId();
		} else {
			$data['api_token'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('sale/order_form', $data));
	}

	public static function info() {

		if (isset(request::$get['order_id'])) {
			$order_id = request::$get['order_id'];
		} else {
			$order_id = 0;
		}

		$order_info = admin_sale_order::getOrder($order_id);

		if ($order_info) {
			load::language('sale/order');

			document::setTitle(language::get('heading_title'));

			$data['text_ip_add'] = sprintf(language::get('text_ip_add'), request::$server['REMOTE_ADDR']);
			$data['text_order'] = sprintf(language::get('text_order'), request::$get['order_id']);

			$url = '';

			if (isset(request::$get['filter_order_id'])) {
				$url .= '&filter_order_id=' . request::$get['filter_order_id'];
			}

			if (isset(request::$get['filter_customer'])) {
				$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_order_status'])) {
				$url .= '&filter_order_status=' . request::$get['filter_order_status'];
			}
			
			if (isset(request::$get['filter_order_status_id'])) {
				$url .= '&filter_order_status_id=' . request::$get['filter_order_status_id'];
			}
			
			if (isset(request::$get['filter_total'])) {
				$url .= '&filter_total=' . request::$get['filter_total'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['filter_date_modified'])) {
				$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_home'),
				'href' => url::link('common/dashboard')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('sale/order', $url)
			);

			$data['shipping'] = url::link('sale/order/shipping', '&order_id=' . (int)request::$get['order_id']);
			$data['invoice'] = url::link('sale/order/invoice', '&order_id=' . (int)request::$get['order_id']);
			$data['edit'] = url::link('sale/order/edit', '&order_id=' . (int)request::$get['order_id']);
			$data['cancel'] = url::link('sale/order', $url);


			$data['order_id'] = (int)request::$get['order_id'];

			$data['store_id'] = $order_info['store_id'];
			$data['store_name'] = $order_info['store_name'];
			
			if ($order_info['store_id'] == 0) {
				$data['store_url'] = request::$server['HTTPS'] ? HTTPS_CATALOG : HTTP_CATALOG;
			} else {
				$data['store_url'] = $order_info['store_url'];
			}

			if ($order_info['invoice_no']) {
				$data['invoice_no'] = $order_info['invoice_prefix'] . $order_info['invoice_no'];
			} else {
				$data['invoice_no'] = '';
			}

			$data['date_added'] = date(language::get('date_format_short'), strtotime($order_info['date_added']));

			$data['firstname'] = $order_info['firstname'];
			$data['lastname'] = $order_info['lastname'];

			if ($order_info['customer_id']) {
				$data['customer'] = url::link('customer/customer/edit', '&customer_id=' . $order_info['customer_id']);
			} else {
				$data['customer'] = '';
			}


			$customer_group_info = admin_customer_customer_group::getCustomerGroup($order_info['customer_group_id']);

			if ($customer_group_info) {
				$data['customer_group'] = $customer_group_info['name'];
			} else {
				$data['customer_group'] = '';
			}

			$data['email'] = $order_info['email'];
			$data['telephone'] = $order_info['telephone'];

			$data['shipping_method'] = $order_info['shipping_method'];
			$data['payment_method'] = $order_info['payment_method'];

			// Payment Address
			if ($order_info['payment_address_format']) {
				$format = $order_info['payment_address_format'];
			} else {
				$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
			}

			$find = array(
				'{firstname}',
				'{lastname}',
				'{company}',
				'{address_1}',
				'{address_2}',
				'{city}',
				'{postcode}',
				'{zone}',
				'{zone_code}',
				'{country}'
			);

			$replace = array(
				'firstname' => $order_info['payment_firstname'],
				'lastname'  => $order_info['payment_lastname'],
				'company'   => $order_info['payment_company'],
				'address_1' => $order_info['payment_address_1'],
				'address_2' => $order_info['payment_address_2'],
				'city'      => $order_info['payment_city'],
				'postcode'  => $order_info['payment_postcode'],
				'zone'      => $order_info['payment_zone'],
				'zone_code' => $order_info['payment_zone_code'],
				'country'   => $order_info['payment_country']
			);

			$data['payment_address'] = str_replace(array("\r\n", "\r", "\n"), '<br />', preg_replace(array("/\s\s+/", "/\r\r+/", "/\n\n+/"), '<br />', trim(str_replace($find, $replace, $format))));

			// Shipping Address
			if ($order_info['shipping_address_format']) {
				$format = $order_info['shipping_address_format'];
			} else {
				$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
			}

			$find = array(
				'{firstname}',
				'{lastname}',
				'{company}',
				'{address_1}',
				'{address_2}',
				'{city}',
				'{postcode}',
				'{zone}',
				'{zone_code}',
				'{country}'
			);

			$replace = array(
				'firstname' => $order_info['shipping_firstname'],
				'lastname'  => $order_info['shipping_lastname'],
				'company'   => $order_info['shipping_company'],
				'address_1' => $order_info['shipping_address_1'],
				'address_2' => $order_info['shipping_address_2'],
				'city'      => $order_info['shipping_city'],
				'postcode'  => $order_info['shipping_postcode'],
				'zone'      => $order_info['shipping_zone'],
				'zone_code' => $order_info['shipping_zone_code'],
				'country'   => $order_info['shipping_country']
			);

			$data['shipping_address'] = str_replace(array("\r\n", "\r", "\n"), '<br />', preg_replace(array("/\s\s+/", "/\r\r+/", "/\n\n+/"), '<br />', trim(str_replace($find, $replace, $format))));

			// Uploaded files

			$data['products'] = array();

			$products = admin_sale_order::getOrderProducts(request::$get['order_id']);

			foreach ($products as $product) {
				$option_data = array();

				$options = admin_sale_order::getOrderOptions(request::$get['order_id'], $product['order_product_id']);

				foreach ($options as $option) {
					if ($option['type'] != 'file') {
						$option_data[] = array(
							'name'  => $option['name'],
							'value' => $option['value'],
							'type'  => $option['type']
						);
					} else {
						$upload_info = admin_tool_upload::getUploadByCode($option['value']);

						if ($upload_info) {
							$option_data[] = array(
								'name'  => $option['name'],
								'value' => $upload_info['name'],
								'type'  => $option['type'],
								'href'  => url::link('tool/upload/download', '&code=' . $upload_info['code'])
							);
						}
					}
				}

				$data['products'][] = array(
					'order_product_id' => $product['order_product_id'],
					'product_id'       => $product['product_id'],
					'name'    	 	   => $product['name'],
					'model'    		   => $product['model'],
					'option'   		   => $option_data,
					'quantity'		   => $product['quantity'],
					'price'    		   => currency::format($product['price'] + (config('tax') ? $product['tax'] : 0), $order_info['currency_code'], $order_info['currency_value']),
					'total'    		   => currency::format($product['total'] + (config('tax') ? ($product['tax'] * $product['quantity']) : 0), $order_info['currency_code'], $order_info['currency_value']),
					'href'     		   => url::link('catalog/product/edit', '&product_id=' . $product['product_id'])
				);
			}

			$data['vouchers'] = array();

			$vouchers = admin_sale_order::getOrderVouchers(request::$get['order_id']);

			foreach ($vouchers as $voucher) {
				$data['vouchers'][] = array(
					'description' => $voucher['description'],
					'amount'      => currency::format($voucher['amount'], $order_info['currency_code'], $order_info['currency_value']),
					'href'        => url::link('sale/voucher/edit', '&voucher_id=' . $voucher['voucher_id'])
				);
			}

			$data['totals'] = array();

			$totals = admin_sale_order::getOrderTotals(request::$get['order_id']);

			foreach ($totals as $total) {
				$data['totals'][] = array(
					'title' => $total['title'],
					'text'  => currency::format($total['value'], $order_info['currency_code'], $order_info['currency_value'])
				);
			}

			$data['comment'] = nl2br($order_info['comment']);


			$data['reward'] = $order_info['reward'];

			$data['reward_total'] = admin_customer_customer::getTotalCustomerRewardsByOrderId(request::$get['order_id']);

			$data['affiliate_firstname'] = $order_info['affiliate_firstname'];
			$data['affiliate_lastname'] = $order_info['affiliate_lastname'];

			if ($order_info['affiliate_id']) {
				$data['affiliate'] = url::link('customer/customer/edit', '&customer_id=' . $order_info['affiliate_id']);
			} else {
				$data['affiliate'] = '';
			}

			$data['commission'] = currency::format($order_info['commission'], $order_info['currency_code'], $order_info['currency_value']);

			$data['commission_total'] = admin_customer_customer::getTotalTransactionsByOrderId(request::$get['order_id']);


			$order_status_info = admin_localisation_order_status::getOrderStatus($order_info['order_status_id']);

			if ($order_status_info) {
				$data['order_status'] = $order_status_info['name'];
			} else {
				$data['order_status'] = '';
			}

			$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

			$data['order_status_id'] = $order_info['order_status_id'];

			$data['account_custom_field'] = $order_info['custom_field'];

			// Custom Fields

			$data['account_custom_fields'] = array();

			$filter_data = array(
				'sort'  => 'cf.sort_order',
				'order' => 'ASC'
			);

			$custom_fields = admin_customer_custom_field::getCustomFields($filter_data);

			foreach ($custom_fields as $custom_field) {
				if ($custom_field['location'] == 'account' && isset($order_info['custom_field'][$custom_field['custom_field_id']])) {
					if ($custom_field['type'] == 'select' || $custom_field['type'] == 'radio') {
						$custom_field_value_info = admin_customer_custom_field::getCustomFieldValue($order_info['custom_field'][$custom_field['custom_field_id']]);

						if ($custom_field_value_info) {
							$data['account_custom_fields'][] = array(
								'name'  => $custom_field['name'],
								'value' => $custom_field_value_info['name']
							);
						}
					}

					if ($custom_field['type'] == 'checkbox' && is_array($order_info['custom_field'][$custom_field['custom_field_id']])) {
						foreach ($order_info['custom_field'][$custom_field['custom_field_id']] as $custom_field_value_id) {
							$custom_field_value_info = admin_customer_custom_field::getCustomFieldValue($custom_field_value_id);

							if ($custom_field_value_info) {
								$data['account_custom_fields'][] = array(
									'name'  => $custom_field['name'],
									'value' => $custom_field_value_info['name']
								);
							}
						}
					}

					if ($custom_field['type'] == 'text' || $custom_field['type'] == 'textarea' || $custom_field['type'] == 'file' || $custom_field['type'] == 'date' || $custom_field['type'] == 'datetime' || $custom_field['type'] == 'time') {
						$data['account_custom_fields'][] = array(
							'name'  => $custom_field['name'],
							'value' => $order_info['custom_field'][$custom_field['custom_field_id']]
						);
					}

					if ($custom_field['type'] == 'file') {
						$upload_info = admin_tool_upload::getUploadByCode($order_info['custom_field'][$custom_field['custom_field_id']]);

						if ($upload_info) {
							$data['account_custom_fields'][] = array(
								'name'  => $custom_field['name'],
								'value' => $upload_info['name']
							);
						}
					}
				}
			}

			// Custom fields
			$data['payment_custom_fields'] = array();

			foreach ($custom_fields as $custom_field) {
				if ($custom_field['location'] == 'address' && isset($order_info['payment_custom_field'][$custom_field['custom_field_id']])) {
					if ($custom_field['type'] == 'select' || $custom_field['type'] == 'radio') {
						$custom_field_value_info = admin_customer_custom_field::getCustomFieldValue($order_info['payment_custom_field'][$custom_field['custom_field_id']]);

						if ($custom_field_value_info) {
							$data['payment_custom_fields'][] = array(
								'name'  => $custom_field['name'],
								'value' => $custom_field_value_info['name'],
								'sort_order' => $custom_field['sort_order']
							);
						}
					}

					if ($custom_field['type'] == 'checkbox' && is_array($order_info['payment_custom_field'][$custom_field['custom_field_id']])) {
						foreach ($order_info['payment_custom_field'][$custom_field['custom_field_id']] as $custom_field_value_id) {
							$custom_field_value_info = admin_customer_custom_field::getCustomFieldValue($custom_field_value_id);

							if ($custom_field_value_info) {
								$data['payment_custom_fields'][] = array(
									'name'  => $custom_field['name'],
									'value' => $custom_field_value_info['name'],
									'sort_order' => $custom_field['sort_order']
								);
							}
						}
					}

					if ($custom_field['type'] == 'text' || $custom_field['type'] == 'textarea' || $custom_field['type'] == 'file' || $custom_field['type'] == 'date' || $custom_field['type'] == 'datetime' || $custom_field['type'] == 'time') {
						$data['payment_custom_fields'][] = array(
							'name'  => $custom_field['name'],
							'value' => $order_info['payment_custom_field'][$custom_field['custom_field_id']],
							'sort_order' => $custom_field['sort_order']
						);
					}

					if ($custom_field['type'] == 'file') {
						$upload_info = admin_tool_upload::getUploadByCode($order_info['payment_custom_field'][$custom_field['custom_field_id']]);

						if ($upload_info) {
							$data['payment_custom_fields'][] = array(
								'name'  => $custom_field['name'],
								'value' => $upload_info['name'],
								'sort_order' => $custom_field['sort_order']
							);
						}
					}
				}
			}

			// Shipping
			$data['shipping_custom_fields'] = array();

			foreach ($custom_fields as $custom_field) {
				if ($custom_field['location'] == 'address' && isset($order_info['shipping_custom_field'][$custom_field['custom_field_id']])) {
					if ($custom_field['type'] == 'select' || $custom_field['type'] == 'radio') {
						$custom_field_value_info = admin_customer_custom_field::getCustomFieldValue($order_info['shipping_custom_field'][$custom_field['custom_field_id']]);

						if ($custom_field_value_info) {
							$data['shipping_custom_fields'][] = array(
								'name'  => $custom_field['name'],
								'value' => $custom_field_value_info['name'],
								'sort_order' => $custom_field['sort_order']
							);
						}
					}

					if ($custom_field['type'] == 'checkbox' && is_array($order_info['shipping_custom_field'][$custom_field['custom_field_id']])) {
						foreach ($order_info['shipping_custom_field'][$custom_field['custom_field_id']] as $custom_field_value_id) {
							$custom_field_value_info = admin_customer_custom_field::getCustomFieldValue($custom_field_value_id);

							if ($custom_field_value_info) {
								$data['shipping_custom_fields'][] = array(
									'name'  => $custom_field['name'],
									'value' => $custom_field_value_info['name'],
									'sort_order' => $custom_field['sort_order']
								);
							}
						}
					}

					if ($custom_field['type'] == 'text' || $custom_field['type'] == 'textarea' || $custom_field['type'] == 'file' || $custom_field['type'] == 'date' || $custom_field['type'] == 'datetime' || $custom_field['type'] == 'time') {
						$data['shipping_custom_fields'][] = array(
							'name'  => $custom_field['name'],
							'value' => $order_info['shipping_custom_field'][$custom_field['custom_field_id']],
							'sort_order' => $custom_field['sort_order']
						);
					}

					if ($custom_field['type'] == 'file') {
						$upload_info = admin_tool_upload::getUploadByCode($order_info['shipping_custom_field'][$custom_field['custom_field_id']]);

						if ($upload_info) {
							$data['shipping_custom_fields'][] = array(
								'name'  => $custom_field['name'],
								'value' => $upload_info['name'],
								'sort_order' => $custom_field['sort_order']
							);
						}
					}
				}
			}

			$data['ip'] = $order_info['ip'];
			$data['forwarded_ip'] = $order_info['forwarded_ip'];
			$data['user_agent'] = $order_info['user_agent'];
			$data['accept_language'] = $order_info['accept_language'];

			// Additional Tabs
			$data['tabs'] = array();

			if (user::hasPermission('access', 'extension/payment/' . $order_info['payment_code'])) {
				if (is_file(DIR_CATALOG . 'controller/extension/payment/' . $order_info['payment_code'] . '.php')) {
					$content = load::controller('extension/payment/' . $order_info['payment_code'] . '/order');
				} else {
					$content = '';
				}

				if ($content) {
					load::language('extension/payment/' . $order_info['payment_code']);

					$data['tabs'][] = array(
						'code'    => $order_info['payment_code'],
						'title'   => language::get('heading_title'),
						'content' => $content
					);
				}
			}


			$extensions = admin_setting_extension::getInstalled('fraud');

			foreach ($extensions as $extension) {
				if (config::get('fraud_' . $extension . '_status')) {
					load::language('extension/fraud/' . $extension, 'extension');

					$content = load::controller('extension/fraud/' . $extension . '/order');

					if ($content) {
						$data['tabs'][] = array(
							'code'    => $extension,
							'title'   => language::get('extension')::get('heading_title'),
							'content' => $content
						);
					}
				}
			}
			
			// The URL we send API requests to
			$data['catalog'] = request::$server['HTTPS'] ? HTTPS_CATALOG : HTTP_CATALOG;
			
			// API login

			$api_info = admin_user_api::getApi(config('api_id'));

			if ($api_info && user::hasPermission('modify', 'sale/order')) {
				$session = new Session(config::get('session_engine'));
				
				$session::start();
				
				admin_user_api::deleteApiSessionBySessionId($session::getId());
				
				admin_user_api::addApiSession($api_info['api_id'], $session::getId(), request::$server['REMOTE_ADDR']);
				
				$session::$data['api_id'] = $api_info['api_id'];

				$data['api_token'] = $session::getId();
			} else {
				$data['api_token'] = '';
			}

			$data['header'] = load::controller('common/header');
			$data['column_left'] = load::controller('common/column_left');
			$data['footer'] = load::controller('common/footer');

			response::setOutput(load::view('sale/order_info', $data));
		} else {
			return 'error/not_found';
		}
	}
	
	protected static function validate() {
		if (!user::hasPermission('modify', 'sale/order')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}
	
	public static function createInvoiceNo() {
		load::language('sale/order');

		$json = array();

		if (!user::hasPermission('modify', 'sale/order')) {
			$json['error'] = language::get('error_permission');
		} elseif (isset(request::$get['order_id'])) {
			if (isset(request::$get['order_id'])) {
				$order_id = request::$get['order_id'];
			} else {
				$order_id = 0;
			}


			$invoice_no = admin_sale_order::createInvoiceNo($order_id);

			if ($invoice_no) {
				$json['invoice_no'] = $invoice_no;
			} else {
				$json['error'] = language::get('error_action');
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function addReward() {
		load::language('sale/order');

		$json = array();

		if (!user::hasPermission('modify', 'sale/order')) {
			$json['error'] = language::get('error_permission');
		} else {
			if (isset(request::$get['order_id'])) {
				$order_id = request::$get['order_id'];
			} else {
				$order_id = 0;
			}


			$order_info = admin_sale_order::getOrder($order_id);

			if ($order_info && $order_info['customer_id'] && ($order_info['reward'] > 0)) {

				$reward_total = admin_customer_customer::getTotalCustomerRewardsByOrderId($order_id);

				if (!$reward_total) {
					admin_customer_customer::addReward($order_info['customer_id'], language::get('text_order_id') . ' #' . $order_id, $order_info['reward'], $order_id);
				}
			}

			$json['success'] = language::get('text_reward_added');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function removeReward() {
		load::language('sale/order');

		$json = array();

		if (!user::hasPermission('modify', 'sale/order')) {
			$json['error'] = language::get('error_permission');
		} else {
			if (isset(request::$get['order_id'])) {
				$order_id = request::$get['order_id'];
			} else {
				$order_id = 0;
			}


			$order_info = admin_sale_order::getOrder($order_id);

			if ($order_info) {

				admin_customer_customer::deleteReward($order_id);
			}

			$json['success'] = language::get('text_reward_removed');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function addCommission() {
		load::language('sale/order');

		$json = array();

		if (!user::hasPermission('modify', 'sale/order')) {
			$json['error'] = language::get('error_permission');
		} else {
			if (isset(request::$get['order_id'])) {
				$order_id = request::$get['order_id'];
			} else {
				$order_id = 0;
			}


			$order_info = admin_sale_order::getOrder($order_id);

			if ($order_info) {

				$affiliate_total = admin_customer_customer::getTotalTransactionsByOrderId($order_id);

				if (!$affiliate_total) {
					admin_customer_customer::addTransaction($order_info['affiliate_id'], language::get('text_order_id') . ' #' . $order_id, $order_info['commission'], $order_id);
				}
			}

			$json['success'] = language::get('text_commission_added');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function removeCommission() {
		load::language('sale/order');

		$json = array();

		if (!user::hasPermission('modify', 'sale/order')) {
			$json['error'] = language::get('error_permission');
		} else {
			if (isset(request::$get['order_id'])) {
				$order_id = request::$get['order_id'];
			} else {
				$order_id = 0;
			}


			$order_info = admin_sale_order::getOrder($order_id);

			if ($order_info) {

				admin_customer_customer::deleteTransactionByOrderId($order_id);
			}

			$json['success'] = language::get('text_commission_removed');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function history() {
		load::language('sale/order');

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$data['histories'] = array();


		$results = admin_sale_order::getOrderHistories(request::$get['order_id'], ($page - 1) * 10, 10);

		foreach ($results as $result) {
			$data['histories'][] = array(
				'notify'     => $result['notify'] ? language::get('text_yes') : language::get('text_no'),
				'status'     => $result['status'],
				'comment'    => nl2br($result['comment']),
				'date_added' => date(language::get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$history_total = admin_sale_order::getTotalOrderHistories(request::$get['order_id']);

		$pagination = new Pagination();
		$pagination::$total = $history_total;
		$pagination::$page = $page;
		$pagination::$limit = 10;
		$pagination::$url = url::link('sale/order/history', '&order_id=' . request::$get['order_id'] . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($history_total) ? (($page - 1) * 10) + 1 : 0, ((($page - 1) * 10) > ($history_total - 10)) ? $history_total : ((($page - 1) * 10) + 10), $history_total, ceil($history_total / 10));

		response::setOutput(load::view('sale/order_history', $data));
	}

	public static function invoice() {
		load::language('sale/order');

		$data['title'] = language::get('text_invoice');

		if (request::$server['HTTPS']) {
			$data['base'] = HTTPS_SERVER;
		} else {
			$data['base'] = HTTP_SERVER;
		}

		$data['direction'] = language::get('direction');
		
		$data['lang'] = language::get('code');



		$data['orders'] = array();

		$orders = array();

		if (isset(request::$post['selected'])) {
			$orders = request::$post['selected'];
		} elseif (isset(request::$get['order_id'])) {
			$orders[] = request::$get['order_id'];
		}

		foreach ($orders as $order_id) {
			$order_info = admin_sale_order::getOrder($order_id);
			
			$text_order = sprintf(language::get('text_order'), $order_id);
			
			if ($order_info) {
				$store_info = admin_setting_setting::getSetting('config', $order_info['store_id']);

				if ($store_info) {
					$store_address = $store_info['config_address'];
					$store_email = $store_info['config_email'];
					$store_telephone = $store_info['config_telephone'];
					$store_fax = $store_info['config_fax'];
				} else {
					$store_address = config('address');
					$store_email = config('email');
					$store_telephone = config('telephone');
					$store_fax = config('fax');
				}

				if ($order_info['invoice_no']) {
					$invoice_no = $order_info['invoice_prefix'] . $order_info['invoice_no'];
				} else {
					$invoice_no = '';
				}

				if ($order_info['payment_address_format']) {
					$format = $order_info['payment_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{zone_code}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['payment_firstname'],
					'lastname'  => $order_info['payment_lastname'],
					'company'   => $order_info['payment_company'],
					'address_1' => $order_info['payment_address_1'],
					'address_2' => $order_info['payment_address_2'],
					'city'      => $order_info['payment_city'],
					'postcode'  => $order_info['payment_postcode'],
					'zone'      => $order_info['payment_zone'],
					'zone_code' => $order_info['payment_zone_code'],
					'country'   => $order_info['payment_country']
				);

				$payment_address = str_replace(array("\r\n", "\r", "\n"), '<br />', preg_replace(array("/\s\s+/", "/\r\r+/", "/\n\n+/"), '<br />', trim(str_replace($find, $replace, $format))));

				if ($order_info['shipping_address_format']) {
					$format = $order_info['shipping_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{zone_code}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['shipping_firstname'],
					'lastname'  => $order_info['shipping_lastname'],
					'company'   => $order_info['shipping_company'],
					'address_1' => $order_info['shipping_address_1'],
					'address_2' => $order_info['shipping_address_2'],
					'city'      => $order_info['shipping_city'],
					'postcode'  => $order_info['shipping_postcode'],
					'zone'      => $order_info['shipping_zone'],
					'zone_code' => $order_info['shipping_zone_code'],
					'country'   => $order_info['shipping_country']
				);

				$shipping_address = str_replace(array("\r\n", "\r", "\n"), '<br />', preg_replace(array("/\s\s+/", "/\r\r+/", "/\n\n+/"), '<br />', trim(str_replace($find, $replace, $format))));


				$product_data = array();

				$products = admin_sale_order::getOrderProducts($order_id);

				foreach ($products as $product) {
					$option_data = array();

					$options = admin_sale_order::getOrderOptions($order_id, $product['order_product_id']);

					foreach ($options as $option) {
						if ($option['type'] != 'file') {
							$value = $option['value'];
						} else {
							$upload_info = admin_tool_upload::getUploadByCode($option['value']);

							if ($upload_info) {
								$value = $upload_info['name'];
							} else {
								$value = '';
							}
						}

						$option_data[] = array(
							'name'  => $option['name'],
							'value' => $value
						);
					}

					$product_data[] = array(
						'name'     => $product['name'],
						'model'    => $product['model'],
						'option'   => $option_data,
						'quantity' => $product['quantity'],
						'price'    => currency::format($product['price'] + (config('tax') ? $product['tax'] : 0), $order_info['currency_code'], $order_info['currency_value']),
						'total'    => currency::format($product['total'] + (config('tax') ? ($product['tax'] * $product['quantity']) : 0), $order_info['currency_code'], $order_info['currency_value'])
					);
				}

				$voucher_data = array();

				$vouchers = admin_sale_order::getOrderVouchers($order_id);

				foreach ($vouchers as $voucher) {
					$voucher_data[] = array(
						'description' => $voucher['description'],
						'amount'      => currency::format($voucher['amount'], $order_info['currency_code'], $order_info['currency_value'])
					);
				}

				$total_data = array();

				$totals = admin_sale_order::getOrderTotals($order_id);

				foreach ($totals as $total) {
					$total_data[] = array(
						'title' => $total['title'],
						'text'  => currency::format($total['value'], $order_info['currency_code'], $order_info['currency_value'])
					);
				}

				$data['orders'][] = array(
					'order_id'	   => $order_id,
					'invoice_no'       => $invoice_no,
					'text_order'	   => $text_order,
					'date_added'       => date(language::get('date_format_short'), strtotime($order_info['date_added'])),
					'store_name'       => $order_info['store_name'],
					'store_url'        => rtrim($order_info['store_url'], '/'),
					'store_address'    => nl2br($store_address),
					'store_email'      => $store_email,
					'store_telephone'  => $store_telephone,
					'store_fax'        => $store_fax,
					'email'            => $order_info['email'],
					'telephone'        => $order_info['telephone'],
					'shipping_address' => $shipping_address,
					'shipping_method'  => $order_info['shipping_method'],
					'payment_address'  => $payment_address,
					'payment_method'   => $order_info['payment_method'],
					'product'          => $product_data,
					'voucher'          => $voucher_data,
					'total'            => $total_data,
					'comment'          => nl2br($order_info['comment'])
				);
			}
		}

		response::setOutput(load::view('sale/order_invoice', $data));
	}

	public static function shipping() {
		load::language('sale/order');

		$data['title'] = language::get('text_shipping');

		if (request::$server['HTTPS']) {
			$data['base'] = HTTPS_SERVER;
		} else {
			$data['base'] = HTTP_SERVER;
		}

		$data['direction'] = language::get('direction');
		$data['lang'] = language::get('code');




		$data['orders'] = array();

		$orders = array();

		if (isset(request::$post['selected'])) {
			$orders = request::$post['selected'];
		} elseif (isset(request::$get['order_id'])) {
			$orders[] = request::$get['order_id'];
		}

		foreach ($orders as $order_id) {
			$order_info = admin_sale_order::getOrder($order_id);

			// Make sure there is a shipping method
			if ($order_info && $order_info['shipping_code']) {
				$store_info = admin_setting_setting::getSetting('config', $order_info['store_id']);

				if ($store_info) {
					$store_address = $store_info['config_address'];
					$store_email = $store_info['config_email'];
					$store_telephone = $store_info['config_telephone'];
				} else {
					$store_address = config('address');
					$store_email = config('email');
					$store_telephone = config('telephone');
				}

				if ($order_info['invoice_no']) {
					$invoice_no = $order_info['invoice_prefix'] . $order_info['invoice_no'];
				} else {
					$invoice_no = '';
				}

				if ($order_info['shipping_address_format']) {
					$format = $order_info['shipping_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{zone_code}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['shipping_firstname'],
					'lastname'  => $order_info['shipping_lastname'],
					'company'   => $order_info['shipping_company'],
					'address_1' => $order_info['shipping_address_1'],
					'address_2' => $order_info['shipping_address_2'],
					'city'      => $order_info['shipping_city'],
					'postcode'  => $order_info['shipping_postcode'],
					'zone'      => $order_info['shipping_zone'],
					'zone_code' => $order_info['shipping_zone_code'],
					'country'   => $order_info['shipping_country']
				);

				$shipping_address = str_replace(array("\r\n", "\r", "\n"), '<br />', preg_replace(array("/\s\s+/", "/\r\r+/", "/\n\n+/"), '<br />', trim(str_replace($find, $replace, $format))));


				$product_data = array();

				$products = admin_sale_order::getOrderProducts($order_id);

				foreach ($products as $product) {
					$option_weight = 0;

					$product_info = admin_catalog_product::getProduct($product['product_id']);

					if ($product_info) {
						$option_data = array();

						$options = admin_sale_order::getOrderOptions($order_id, $product['order_product_id']);

						foreach ($options as $option) {
							if ($option['type'] != 'file') {
								$value = $option['value'];
							} else {
								$upload_info = admin_tool_upload::getUploadByCode($option['value']);

								if ($upload_info) {
									$value = $upload_info['name'];
								} else {
									$value = '';
								}
							}

							$option_data[] = array(
								'name'  => $option['name'],
								'value' => $value
							);

							$product_option_value_info = admin_catalog_product::getProductOptionValue($product['product_id'], $option['product_option_value_id']);

							if (!empty($product_option_value_info['weight'])) {
								if ($product_option_value_info['weight_prefix'] == '+') {
									$option_weight += $product_option_value_info['weight'];
								} elseif ($product_option_value_info['weight_prefix'] == '-') {
									$option_weight -= $product_option_value_info['weight'];
								}
							}
						}

						$product_data[] = array(
							'name'     => $product_info['name'],
							'model'    => $product_info['model'],
							'option'   => $option_data,
							'quantity' => $product['quantity'],
							'location' => $product_info['location'],
							'sku'      => $product_info['sku'],
							'upc'      => $product_info['upc'],
							'ean'      => $product_info['ean'],
							'jan'      => $product_info['jan'],
							'isbn'     => $product_info['isbn'],
							'mpn'      => $product_info['mpn'],
							'weight'   => weight::format(($product_info['weight'] + (float)$option_weight) * $product['quantity'], $product_info['weight_class_id'], language::get('decimal_point'), language::get('thousand_point'))
						);
					}
				}

				$data['orders'][] = array(
					'order_id'	       => $order_id,
					'invoice_no'       => $invoice_no,
					'date_added'       => date(language::get('date_format_short'), strtotime($order_info['date_added'])),
					'store_name'       => $order_info['store_name'],
					'store_url'        => rtrim($order_info['store_url'], '/'),
					'store_address'    => nl2br($store_address),
					'store_email'      => $store_email,
					'store_telephone'  => $store_telephone,
					'email'            => $order_info['email'],
					'telephone'        => $order_info['telephone'],
					'shipping_address' => $shipping_address,
					'shipping_method'  => $order_info['shipping_method'],
					'product'          => $product_data,
					'comment'          => nl2br($order_info['comment'])
				);
			}
		}

		response::setOutput(load::view('sale/order_shipping', $data));
	}
}
