<?php
class ControllerSaleRecurring {
	private static $error = array();

	public static function index() {
		load::language('sale/recurring');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['filter_order_recurring_id'])) {
			$filter_order_recurring_id = request::$get['filter_order_recurring_id'];
		} else {
			$filter_order_recurring_id = '';
		}

		if (isset(request::$get['filter_order_id'])) {
			$filter_order_id = request::$get['filter_order_id'];
		} else {
			$filter_order_id = '';
		}

		if (isset(request::$get['filter_reference'])) {
			$filter_reference = request::$get['filter_reference'];
		} else {
			$filter_reference = '';
		}

		if (isset(request::$get['filter_customer'])) {
			$filter_customer = request::$get['filter_customer'];
		} else {
			$filter_customer = '';
		}

		if (isset(request::$get['filter_status'])) {
			$filter_status = request::$get['filter_status'];
		} else {
			$filter_status = 0;
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'order_recurring_id';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'DESC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['filter_order_recurring_id'])) {
			$url .= '&filter_order_recurring_id=' . request::$get['filter_order_recurring_id'];
		}

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_reference'])) {
			$url .= '&filter_reference=' . request::$get['filter_reference'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('sale/recurring', $url)
		);

		$data['recurrings'] = array();

		$filter_data = array(
			'filter_order_recurring_id' => $filter_order_recurring_id,
			'filter_order_id'           => $filter_order_id,
			'filter_reference'          => $filter_reference,
			'filter_customer'           => $filter_customer,
			'filter_status'             => $filter_status,
			'filter_date_added'         => $filter_date_added,
			'order'                     => $order,
			'sort'                      => $sort,
			'start'                     => ($page - 1) * config('limit_admin'),
			'limit'                     => config('limit_admin')
		);

		$recurrings_total = admin_sale_recurring::getTotalRecurrings($filter_data);

		$results = admin_sale_recurring::getRecurrings($filter_data);

		foreach ($results as $result) {
			if ($result['status']) {
				$status	= language::get('text_status_' . $result['status']);
			} else {
				$status = '';
			}
			
			$data['recurrings'][] = array(
				'order_recurring_id' => $result['order_recurring_id'],
				'order_id'           => $result['order_id'],
				'reference'          => $result['reference'],
				'customer'           => $result['customer'],
				'status'             => $status,
				'date_added'         => date(language::get('date_format_short'), strtotime($result['date_added'])),
				'view'               => url::link('sale/recurring/info', '&order_recurring_id=' . $result['order_recurring_id'] . $url),
				'order'              => url::link('sale/order/info', '&order_id=' . $result['order_id'])
			);
		}


		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}
		
		$url = '';

		if (isset(request::$get['filter_order_recurring_id'])) {
			$url .= '&filter_order_recurring_id=' . request::$get['filter_order_recurring_id'];
		}

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_reference'])) {
			$url .= '&filter_reference=' . urlencode(html_entity_decode(request::$get['filter_reference'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_order_recurring'] = url::link('sale/recurring', '&sort=or.order_recurring_id' . $url);
		$data['sort_order'] = url::link('sale/recurring', '&sort=or.order_id' . $url);
		$data['sort_reference'] = url::link('sale/recurring', '&sort=or.reference' . $url);
		$data['sort_customer'] = url::link('sale/recurring', '&sort=customer' . $url);
		$data['sort_status'] = url::link('sale/recurring', '&sort=or.status' . $url);
		$data['sort_date_added'] = url::link('sale/recurring', '&sort=or.date_added' . $url);

		$url = '';

		if (isset(request::$get['filter_order_recurring_id'])) {
			$url .= '&filter_order_recurring_id=' . request::$get['filter_order_recurring_id'];
		}

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_reference'])) {
			$url .= '&filter_reference=' . urlencode(html_entity_decode(request::$get['filter_reference'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_status'])) {
			$url .= '&filter_status=' . request::$get['filter_status'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $recurrings_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('sale/recurring', '&page={page}' . $url);

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($recurrings_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($recurrings_total - config('limit_admin'))) ? $recurrings_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $recurrings_total, ceil($recurrings_total / config('limit_admin')));

		$data['filter_order_recurring_id'] = $filter_order_recurring_id;
		$data['filter_order_id'] = $filter_order_id;
		$data['filter_reference'] = $filter_reference;
		$data['filter_customer'] = $filter_customer;
		$data['filter_status'] = $filter_status;
		$data['filter_date_added'] = $filter_date_added;
		
		$data['sort'] = $sort;
		$data['order'] = $order;
		
		$data['recurring_statuses'] = array();
		
		$data['recurring_statuses'][0] = array(
			'text'  => '',
			'value' => 0
		);
			
		for ($i = 1; $i <= 6; $i++) {
			$data['recurring_statuses'][$i] = array(
				'text'  => language::get('text_status_' . $i),
				'value' => $i,
			);		
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('sale/recurring_list', $data));
	}

	public static function info() {
		
		if (isset(request::$get['order_recurring_id'])) {
			$order_recurring_id = request::$get['order_recurring_id'];
		} else {
			$order_recurring_id = 0;
		}
		
		$order_recurring_info = admin_sale_recurring::getRecurring($order_recurring_id);

		if ($order_recurring_info) {
			load::language('sale/recurring');
		
			document::setTitle(language::get('heading_title'));

			
			$url = '';

			if (isset(request::$get['filter_order_recurring_id'])) {
				$url .= '&filter_order_recurring_id=' . request::$get['filter_order_recurring_id'];
			}

			if (isset(request::$get['filter_order_id'])) {
				$url .= '&filter_order_id=' . request::$get['filter_order_id'];
			}

			if (isset(request::$get['filter_reference'])) {
				$url .= '&filter_reference=' . request::$get['filter_reference'];
			}

			if (isset(request::$get['filter_customer'])) {
				$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_status'])) {
				$url .= '&filter_status=' . request::$get['filter_status'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_home'),
				'href' => url::link('common/dashboard')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('sale/recurring', $url)
			);

			$data['cancel'] = url::link('sale/recurring', $url);
			
			// Recurring
			$data['order_recurring_id'] = $order_recurring_info['order_recurring_id'];
			$data['reference'] = $order_recurring_info['reference'];
			$data['recurring_name'] = $order_recurring_info['recurring_name'];
			
			if ($order_recurring_info['recurring_id']) {
				$data['recurring'] = url::link('catalog/recurring/edit', '&recurring_id=' . $order_recurring_info['recurring_id']);
			} else {
				$data['recurring'] = '';
			}			
			
			$data['recurring_description'] = $order_recurring_info['recurring_description'];
			
			if ($order_recurring_info['status']) {
				$data['recurring_status']= language::get('text_status_' . $order_recurring_info['status']);
			} else {
				$data['recurring_status'] = '';
			}
			

			$order_info = admin_sale_order::getOrder($order_recurring_info['order_id']);
			
			$data['payment_method'] = $order_info['payment_method'];
			
			// Order
			$data['order_id'] = $order_info['order_id'];
			$data['order'] = url::link('sale/order/info', '&order_id=' . $order_info['order_id']);
			$data['firstname'] = $order_info['firstname'];
			$data['lastname'] = $order_info['lastname'];
			
			if ($order_info['customer_id']) {
				$data['customer'] = url::link('customer/customer/edit', '&customer_id=' . $order_info['customer_id']);
			} else {
				$data['customer'] = '';
			}
		
			$data['email'] = $order_info['email'];
			$data['order_status'] = $order_info['order_status'];
			$data['date_added'] = date(language::get('date_format_short'), strtotime($order_info['date_added']));
			
			// Product
			$data['product'] = $order_recurring_info['product_name'];
			$data['quantity'] = $order_recurring_info['product_quantity'];

			// Transactions
			$data['transactions'] = array();
			
			$transactions = admin_sale_recurring::getRecurringTransactions($order_recurring_info['order_recurring_id']);

			foreach ($transactions as $transaction) {
				$data['transactions'][] = array(
					'date_added' => $transaction['date_added'],
					'type'       => $transaction['type'],
					'amount'     => currency::format($transaction['amount'], $order_info['currency_code'], $order_info['currency_value'])
				);
			}

			$data['buttons'] = load::controller('extension/payment/' . $order_info['payment_code'] . '/recurringButtons');

			$data['header'] = load::controller('common/header');
			$data['column_left'] = load::controller('common/column_left');
			$data['footer'] = load::controller('common/footer');

			response::setOutput(load::view('sale/recurring_info', $data));
		} else {
			return 'error/not_found';
		}
	}
}
