<?php
class ControllerSaleReturn {
	private static $error = array();

	public static function index() {
		load::language('sale/return');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('sale/return');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_sale_return::addReturn(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_return_id'])) {
				$url .= '&filter_return_id=' . request::$get['filter_return_id'];
			}

			if (isset(request::$get['filter_order_id'])) {
				$url .= '&filter_order_id=' . request::$get['filter_order_id'];
			}

			if (isset(request::$get['filter_customer'])) {
				$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_product'])) {
				$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_model'])) {
				$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_return_status_id'])) {
				$url .= '&filter_return_status_id=' . request::$get['filter_return_status_id'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['filter_date_modified'])) {
				$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('sale/return', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('sale/return');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_sale_return::editReturn(request::$get['return_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_return_id'])) {
				$url .= '&filter_return_id=' . request::$get['filter_return_id'];
			}

			if (isset(request::$get['filter_order_id'])) {
				$url .= '&filter_order_id=' . request::$get['filter_order_id'];
			}

			if (isset(request::$get['filter_customer'])) {
				$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_product'])) {
				$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_model'])) {
				$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_return_status_id'])) {
				$url .= '&filter_return_status_id=' . request::$get['filter_return_status_id'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['filter_date_modified'])) {
				$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('sale/return', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('sale/return');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $return_id) {
				admin_sale_return::deleteReturn($return_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['filter_return_id'])) {
				$url .= '&filter_return_id=' . request::$get['filter_return_id'];
			}

			if (isset(request::$get['filter_order_id'])) {
				$url .= '&filter_order_id=' . request::$get['filter_order_id'];
			}

			if (isset(request::$get['filter_customer'])) {
				$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_product'])) {
				$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_model'])) {
				$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['filter_return_status_id'])) {
				$url .= '&filter_return_status_id=' . request::$get['filter_return_status_id'];
			}

			if (isset(request::$get['filter_date_added'])) {
				$url .= '&filter_date_added=' . request::$get['filter_date_added'];
			}

			if (isset(request::$get['filter_date_modified'])) {
				$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('sale/return', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['filter_return_id'])) {
			$filter_return_id = request::$get['filter_return_id'];
		} else {
			$filter_return_id = '';
		}

		if (isset(request::$get['filter_order_id'])) {
			$filter_order_id = request::$get['filter_order_id'];
		} else {
			$filter_order_id = '';
		}

		if (isset(request::$get['filter_customer'])) {
			$filter_customer = request::$get['filter_customer'];
		} else {
			$filter_customer = '';
		}

		if (isset(request::$get['filter_product'])) {
			$filter_product = request::$get['filter_product'];
		} else {
			$filter_product = '';
		}

		if (isset(request::$get['filter_model'])) {
			$filter_model = request::$get['filter_model'];
		} else {
			$filter_model = '';
		}

		if (isset(request::$get['filter_return_status_id'])) {
			$filter_return_status_id = request::$get['filter_return_status_id'];
		} else {
			$filter_return_status_id = '';
		}

		if (isset(request::$get['filter_date_added'])) {
			$filter_date_added = request::$get['filter_date_added'];
		} else {
			$filter_date_added = '';
		}

		if (isset(request::$get['filter_date_modified'])) {
			$filter_date_modified = request::$get['filter_date_modified'];
		} else {
			$filter_date_modified = '';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'r.return_id';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'DESC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['filter_return_id'])) {
			$url .= '&filter_return_id=' . request::$get['filter_return_id'];
		}

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_product'])) {
			$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_return_status_id'])) {
			$url .= '&filter_return_status_id=' . request::$get['filter_return_status_id'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('sale/return', $url)
		);

		$data['add'] = url::link('sale/return/add', $url);
		$data['delete'] = url::link('sale/return/delete', $url);

		$data['returns'] = array();

		$filter_data = array(
			'filter_return_id'        => $filter_return_id,
			'filter_order_id'         => $filter_order_id,
			'filter_customer'         => $filter_customer,
			'filter_product'          => $filter_product,
			'filter_model'            => $filter_model,
			'filter_return_status_id' => $filter_return_status_id,
			'filter_date_added'       => $filter_date_added,
			'filter_date_modified'    => $filter_date_modified,
			'sort'                    => $sort,
			'order'                   => $order,
			'start'                   => ($page - 1) * config('limit_admin'),
			'limit'                   => config('limit_admin')
		);

		$return_total = admin_sale_return::getTotalReturns($filter_data);

		$results = admin_sale_return::getReturns($filter_data);

		foreach ($results as $result) {
			$data['returns'][] = array(
				'return_id'     => $result['return_id'],
				'order_id'      => $result['order_id'],
				'customer'      => $result['customer'],
				'product'       => $result['product'],
				'model'         => $result['model'],
				'return_status' => $result['return_status'],
				'date_added'    => date(language::get('date_format_short'), strtotime($result['date_added'])),
				'date_modified' => date(language::get('date_format_short'), strtotime($result['date_modified'])),
				'edit'          => url::link('sale/return/edit', '&return_id=' . $result['return_id'] . $url)
			);
		}


		if (isset(session::$data['error'])) {
			$data['error_warning'] = session::$data['error'];

			unset(session::$data['error']);
		} elseif (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset(request::$get['filter_return_id'])) {
			$url .= '&filter_return_id=' . request::$get['filter_return_id'];
		}

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_product'])) {
			$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_return_status_id'])) {
			$url .= '&filter_return_status_id=' . request::$get['filter_return_status_id'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_return_id'] = url::link('sale/return', '&sort=r.return_id' . $url);
		$data['sort_order_id'] = url::link('sale/return', '&sort=r.order_id' . $url);
		$data['sort_customer'] = url::link('sale/return', '&sort=customer' . $url);
		$data['sort_product'] = url::link('sale/return', '&sort=r.product' . $url);
		$data['sort_model'] = url::link('sale/return', '&sort=r.model' . $url);
		$data['sort_status'] = url::link('sale/return', '&sort=status' . $url);
		$data['sort_date_added'] = url::link('sale/return', '&sort=r.date_added' . $url);
		$data['sort_date_modified'] = url::link('sale/return', '&sort=r.date_modified' . $url);

		$url = '';

		if (isset(request::$get['filter_return_id'])) {
			$url .= '&filter_return_id=' . request::$get['filter_return_id'];
		}

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_product'])) {
			$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_return_status_id'])) {
			$url .= '&filter_return_status_id=' . request::$get['filter_return_status_id'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $return_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('sale/return', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($return_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($return_total - config('limit_admin'))) ? $return_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $return_total, ceil($return_total / config('limit_admin')));

		$data['filter_return_id'] = $filter_return_id;
		$data['filter_order_id'] = $filter_order_id;
		$data['filter_customer'] = $filter_customer;
		$data['filter_product'] = $filter_product;
		$data['filter_model'] = $filter_model;
		$data['filter_return_status_id'] = $filter_return_status_id;
		$data['filter_date_added'] = $filter_date_added;
		$data['filter_date_modified'] = $filter_date_modified;


		$data['return_statuses'] = admin_localisation_return_status::getReturnStatuses();

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('sale/return_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['return_id']) ? language::get('text_add') : language::get('text_edit');


		if (isset(request::$get['return_id'])) {
			$data['return_id'] = (int)request::$get['return_id'];
		} else {
			$data['return_id'] = 0;
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['order_id'])) {
			$data['error_order_id'] = self::$error['order_id'];
		} else {
			$data['error_order_id'] = '';
		}

		if (isset(self::$error['firstname'])) {
			$data['error_firstname'] = self::$error['firstname'];
		} else {
			$data['error_firstname'] = '';
		}

		if (isset(self::$error['lastname'])) {
			$data['error_lastname'] = self::$error['lastname'];
		} else {
			$data['error_lastname'] = '';
		}

		if (isset(self::$error['email'])) {
			$data['error_email'] = self::$error['email'];
		} else {
			$data['error_email'] = '';
		}

		if (isset(self::$error['telephone'])) {
			$data['error_telephone'] = self::$error['telephone'];
		} else {
			$data['error_telephone'] = '';
		}

		if (isset(self::$error['product'])) {
			$data['error_product'] = self::$error['product'];
		} else {
			$data['error_product'] = '';
		}

		if (isset(self::$error['model'])) {
			$data['error_model'] = self::$error['model'];
		} else {
			$data['error_model'] = '';
		}

		$url = '';

		if (isset(request::$get['filter_return_id'])) {
			$url .= '&filter_return_id=' . request::$get['filter_return_id'];
		}

		if (isset(request::$get['filter_order_id'])) {
			$url .= '&filter_order_id=' . request::$get['filter_order_id'];
		}

		if (isset(request::$get['filter_customer'])) {
			$url .= '&filter_customer=' . urlencode(html_entity_decode(request::$get['filter_customer'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_product'])) {
			$url .= '&filter_product=' . urlencode(html_entity_decode(request::$get['filter_product'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_model'])) {
			$url .= '&filter_model=' . urlencode(html_entity_decode(request::$get['filter_model'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['filter_return_status_id'])) {
			$url .= '&filter_return_status_id=' . request::$get['filter_return_status_id'];
		}

		if (isset(request::$get['filter_date_added'])) {
			$url .= '&filter_date_added=' . request::$get['filter_date_added'];
		}

		if (isset(request::$get['filter_date_modified'])) {
			$url .= '&filter_date_modified=' . request::$get['filter_date_modified'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('sale/return', $url)
		);

		if (!isset(request::$get['return_id'])) {
			$data['action'] = url::link('sale/return/add', $url);
		} else {
			$data['action'] = url::link('sale/return/edit', '&return_id=' . request::$get['return_id'] . $url);
		}

		$data['cancel'] = url::link('sale/return', $url);

		if (isset(request::$get['return_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$return_info = admin_sale_return::getReturn(request::$get['return_id']);
		}

		if (isset(request::$post['order_id'])) {
			$data['order_id'] = request::$post['order_id'];
		} elseif (!empty($return_info)) {
			$data['order_id'] = $return_info['order_id'];
		} else {
			$data['order_id'] = '';
		}

		if (isset(request::$post['date_ordered'])) {
			$data['date_ordered'] = request::$post['date_ordered'];
		} elseif (!empty($return_info)) {
			$data['date_ordered'] = ($return_info['date_ordered'] != '0000-00-00' ? $return_info['date_ordered'] : '');
		} else {
			$data['date_ordered'] = '';
		}

		if (isset(request::$post['customer'])) {
			$data['customer'] = request::$post['customer'];
		} elseif (!empty($return_info)) {
			$data['customer'] = $return_info['customer'];
		} else {
			$data['customer'] = '';
		}

		if (isset(request::$post['customer_id'])) {
			$data['customer_id'] = request::$post['customer_id'];
		} elseif (!empty($return_info)) {
			$data['customer_id'] = $return_info['customer_id'];
		} else {
			$data['customer_id'] = '';
		}

		if (isset(request::$post['firstname'])) {
			$data['firstname'] = request::$post['firstname'];
		} elseif (!empty($return_info)) {
			$data['firstname'] = $return_info['firstname'];
		} else {
			$data['firstname'] = '';
		}

		if (isset(request::$post['lastname'])) {
			$data['lastname'] = request::$post['lastname'];
		} elseif (!empty($return_info)) {
			$data['lastname'] = $return_info['lastname'];
		} else {
			$data['lastname'] = '';
		}

		if (isset(request::$post['email'])) {
			$data['email'] = request::$post['email'];
		} elseif (!empty($return_info)) {
			$data['email'] = $return_info['email'];
		} else {
			$data['email'] = '';
		}

		if (isset(request::$post['telephone'])) {
			$data['telephone'] = request::$post['telephone'];
		} elseif (!empty($return_info)) {
			$data['telephone'] = $return_info['telephone'];
		} else {
			$data['telephone'] = '';
		}

		if (isset(request::$post['product'])) {
			$data['product'] = request::$post['product'];
		} elseif (!empty($return_info)) {
			$data['product'] = $return_info['product'];
		} else {
			$data['product'] = '';
		}

		if (isset(request::$post['product_id'])) {
			$data['product_id'] = request::$post['product_id'];
		} elseif (!empty($return_info)) {
			$data['product_id'] = $return_info['product_id'];
		} else {
			$data['product_id'] = '';
		}

		if (isset(request::$post['model'])) {
			$data['model'] = request::$post['model'];
		} elseif (!empty($return_info)) {
			$data['model'] = $return_info['model'];
		} else {
			$data['model'] = '';
		}

		if (isset(request::$post['quantity'])) {
			$data['quantity'] = request::$post['quantity'];
		} elseif (!empty($return_info)) {
			$data['quantity'] = $return_info['quantity'];
		} else {
			$data['quantity'] = '';
		}

		if (isset(request::$post['opened'])) {
			$data['opened'] = request::$post['opened'];
		} elseif (!empty($return_info)) {
			$data['opened'] = $return_info['opened'];
		} else {
			$data['opened'] = '';
		}

		if (isset(request::$post['return_reason_id'])) {
			$data['return_reason_id'] = request::$post['return_reason_id'];
		} elseif (!empty($return_info)) {
			$data['return_reason_id'] = $return_info['return_reason_id'];
		} else {
			$data['return_reason_id'] = '';
		}


		$data['return_reasons'] = admin_localisation_return_reason::getReturnReasons();

		if (isset(request::$post['return_action_id'])) {
			$data['return_action_id'] = request::$post['return_action_id'];
		} elseif (!empty($return_info)) {
			$data['return_action_id'] = $return_info['return_action_id'];
		} else {
			$data['return_action_id'] = '';
		}


		$data['return_actions'] = admin_localisation_return_action::getReturnActions();

		if (isset(request::$post['comment'])) {
			$data['comment'] = request::$post['comment'];
		} elseif (!empty($return_info)) {
			$data['comment'] = $return_info['comment'];
		} else {
			$data['comment'] = '';
		}

		if (isset(request::$post['return_status_id'])) {
			$data['return_status_id'] = request::$post['return_status_id'];
		} elseif (!empty($return_info)) {
			$data['return_status_id'] = $return_info['return_status_id'];
		} else {
			$data['return_status_id'] = '';
		}


		$data['return_statuses'] = admin_localisation_return_status::getReturnStatuses();

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('sale/return_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'sale/return')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (empty(request::$post['order_id'])) {
			self::$error['order_id'] = language::get('error_order_id');
		}

		if ((utf8_strlen(trim(request::$post['firstname'])) < 1) || (utf8_strlen(trim(request::$post['firstname'])) > 32)) {
			self::$error['firstname'] = language::get('error_firstname');
		}

		if ((utf8_strlen(trim(request::$post['lastname'])) < 1) || (utf8_strlen(trim(request::$post['lastname'])) > 32)) {
			self::$error['lastname'] = language::get('error_lastname');
		}

		if ((utf8_strlen(request::$post['email']) > 96) || !filter_var(request::$post['email'], FILTER_VALIDATE_EMAIL)) {
			self::$error['email'] = language::get('error_email');
		}

		if ((utf8_strlen(request::$post['telephone']) < 3) || (utf8_strlen(request::$post['telephone']) > 32)) {
			self::$error['telephone'] = language::get('error_telephone');
		}

		if ((utf8_strlen(request::$post['product']) < 1) || (utf8_strlen(request::$post['product']) > 255)) {
			self::$error['product'] = language::get('error_product');
		}

		if ((utf8_strlen(request::$post['model']) < 1) || (utf8_strlen(request::$post['model']) > 64)) {
			self::$error['model'] = language::get('error_model');
		}

		if (empty(request::$post['return_reason_id'])) {
			self::$error['reason'] = language::get('error_reason');
		}

		if (self::$error && !isset(self::$error['warning'])) {
			self::$error['warning'] = language::get('error_warning');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'sale/return')) {
			self::$error['warning'] = language::get('error_permission');
		}

		return !self::$error;
	}

	public static function history() {
		load::language('sale/return');


		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$data['histories'] = array();

		$results = admin_sale_return::getReturnHistories(request::$get['return_id'], ($page - 1) * 10, 10);

		foreach ($results as $result) {
			$data['histories'][] = array(
				'notify'     => $result['notify'] ? language::get('text_yes') : language::get('text_no'),
				'status'     => $result['status'],
				'comment'    => nl2br($result['comment']),
				'date_added' => date(language::get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$history_total = admin_sale_return::getTotalReturnHistories(request::$get['return_id']);

		$pagination = new Pagination();
		$pagination::$total = $history_total;
		$pagination::$page = $page;
		$pagination::$limit = 10;
		$pagination::$url = url::link('sale/return/history', '&return_id=' . request::$get['return_id'] . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($history_total) ? (($page - 1) * 10) + 1 : 0, ((($page - 1) * 10) > ($history_total - 10)) ? $history_total : ((($page - 1) * 10) + 10), $history_total, ceil($history_total / 10));

		response::setOutput(load::view('sale/return_history', $data));
	}
	
	public static function addHistory() {
		load::language('sale/return');

		$json = array();

		if (!user::hasPermission('modify', 'sale/return')) {
			$json['error'] = language::get('error_permission');
		} else {

			admin_sale_return::addReturnHistory(request::$get['return_id'], request::$post['return_status_id'], request::$post['comment'], request::$post['notify']);

			$json['success'] = language::get('text_success');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}	
}