<?php
class ControllerSaleVoucherTheme {
	private static $error = array();

	public static function index() {
		load::language('sale/voucher_theme');

		document::setTitle(language::get('heading_title'));


		self::getList();
	}

	public static function add() {
		load::language('sale/voucher_theme');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_sale_voucher_theme::addVoucherTheme(request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('sale/voucher_theme', $url));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('sale/voucher_theme');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_sale_voucher_theme::editVoucherTheme(request::$get['voucher_theme_id'], request::$post);

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('sale/voucher_theme', $url));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('sale/voucher_theme');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {
			foreach (request::$post['selected'] as $voucher_theme_id) {
				admin_sale_voucher_theme::deleteVoucherTheme($voucher_theme_id);
			}

			session::$data['success'] = language::get('text_success');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			response::redirect(url::link('sale/voucher_theme', $url));
		}

		self::getList();
	}

	protected static function getList() {
		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'vtd.name';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('sale/voucher_theme', $url)
		);

		$data['add'] = url::link('sale/voucher_theme/add', $url);
		$data['delete'] = url::link('sale/voucher_theme/delete', $url);

		$data['voucher_themes'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * config('limit_admin'),
			'limit' => config('limit_admin')
		);

		$voucher_theme_total = admin_sale_voucher_theme::getTotalVoucherThemes();

		$results = admin_sale_voucher_theme::getVoucherThemes($filter_data);

		foreach ($results as $result) {
			$data['voucher_themes'][] = array(
				'voucher_theme_id' => $result['voucher_theme_id'],
				'name'             => $result['name'],
				'edit'             => url::link('sale/voucher_theme/edit', '&voucher_theme_id=' . $result['voucher_theme_id'] . $url)
			);
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['sort_name'] = url::link('sale/voucher_theme', '&sort=name' . $url);

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		$pagination = new Pagination();
		$pagination::$total = $voucher_theme_total;
		$pagination::$page = $page;
		$pagination::$limit = config('limit_admin');
		$pagination::$url = url::link('sale/voucher_theme', $url . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($voucher_theme_total) ? (($page - 1) * config('limit_admin')) + 1 : 0, ((($page - 1) * config('limit_admin')) > ($voucher_theme_total - config('limit_admin'))) ? $voucher_theme_total : ((($page - 1) * config('limit_admin')) + config('limit_admin')), $voucher_theme_total, ceil($voucher_theme_total / config('limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('sale/voucher_theme_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['voucher_theme_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = array();
		}

		if (isset(self::$error['image'])) {
			$data['error_image'] = self::$error['image'];
		} else {
			$data['error_image'] = '';
		}

		$url = '';

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('sale/voucher_theme', $url)
		);

		if (!isset(request::$get['voucher_theme_id'])) {
			$data['action'] = url::link('sale/voucher_theme/add', $url);
		} else {
			$data['action'] = url::link('sale/voucher_theme/edit', '&voucher_theme_id=' . request::$get['voucher_theme_id'] . $url);
		}

		$data['cancel'] = url::link('sale/voucher_theme', $url);

		if (isset(request::$get['voucher_theme_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {
			$voucher_theme_info = admin_sale_voucher_theme::getVoucherTheme(request::$get['voucher_theme_id']);
		}



		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['voucher_theme_description'])) {
			$data['voucher_theme_description'] = request::$post['voucher_theme_description'];
		} elseif (isset(request::$get['voucher_theme_id'])) {
			$data['voucher_theme_description'] = admin_sale_voucher_theme::getVoucherThemeDescriptions(request::$get['voucher_theme_id']);
		} else {
			$data['voucher_theme_description'] = array();
		}

		if (isset(request::$post['image'])) {
			$data['image'] = request::$post['image'];
		} elseif (!empty($voucher_theme_info)) {
			$data['image'] = $voucher_theme_info['image'];
		} else {
			$data['image'] = '';
		}


		if (isset(request::$post['image']) && is_file('image/' . request::$post['image'])) {
			$data['thumb'] = admin_tool_image::resize(request::$post['image'], 100, 100);
		} elseif (!empty($voucher_theme_info) && is_file('image/' . $voucher_theme_info['image'])) {
			$data['thumb'] = admin_tool_image::resize($voucher_theme_info['image'], 100, 100);
		} else {
			$data['thumb'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		$data['placeholder'] = admin_tool_image::resize('no_image.png', 100, 100);

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('sale/voucher_theme_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'sale/voucher_theme')) {
			self::$error['warning'] = language::get('error_permission');
		}

		foreach (request::$post['voucher_theme_description'] as $language_id => $value) {
			if ((utf8_strlen($value['name']) < 3) || (utf8_strlen($value['name']) > 32)) {
				self::$error['name'][$language_id] = language::get('error_name');
			}
		}

		if (!request::$post['image']) {
			self::$error['image'] = language::get('error_image');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'sale/voucher_theme')) {
			self::$error['warning'] = language::get('error_permission');
		}


		foreach (request::$post['selected'] as $voucher_theme_id) {
			$voucher_total = admin_sale_voucher::getTotalVouchersByVoucherThemeId($voucher_theme_id);

			if ($voucher_total) {
				self::$error['warning'] = sprintf(language::get('error_voucher'), $voucher_total);
			}
		}

		return !self::$error;
	}
}