<?php
class ControllerSettingSetting {
	private static $error = array();

	public static function index() {
		load::language('setting/setting');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			admin_setting_setting::editSetting('config', request::$post);

			if (config('currency_auto')) {

				admin_localisation_currency::refresh();
			}

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('setting/store'));
		}
		
		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset(self::$error['owner'])) {
			$data['error_owner'] = self::$error['owner'];
		} else {
			$data['error_owner'] = '';
		}

		if (isset(self::$error['address'])) {
			$data['error_address'] = self::$error['address'];
		} else {
			$data['error_address'] = '';
		}

		if (isset(self::$error['email'])) {
			$data['error_email'] = self::$error['email'];
		} else {
			$data['error_email'] = '';
		}

		if (isset(self::$error['telephone'])) {
			$data['error_telephone'] = self::$error['telephone'];
		} else {
			$data['error_telephone'] = '';
		}

		if (isset(self::$error['meta_title'])) {
			$data['error_meta_title'] = self::$error['meta_title'];
		} else {
			$data['error_meta_title'] = '';
		}

		if (isset(self::$error['country'])) {
			$data['error_country'] = self::$error['country'];
		} else {
			$data['error_country'] = '';
		}

		if (isset(self::$error['zone'])) {
			$data['error_zone'] = self::$error['zone'];
		} else {
			$data['error_zone'] = '';
		}

		if (isset(self::$error['customer_group_display'])) {
			$data['error_customer_group_display'] = self::$error['customer_group_display'];
		} else {
			$data['error_customer_group_display'] = '';
		}

		if (isset(self::$error['login_attempts'])) {
			$data['error_login_attempts'] = self::$error['login_attempts'];
		} else {
			$data['error_login_attempts'] = '';
		}

		if (isset(self::$error['voucher_min'])) {
			$data['error_voucher_min'] = self::$error['voucher_min'];
		} else {
			$data['error_voucher_min'] = '';
		}

		if (isset(self::$error['voucher_max'])) {
			$data['error_voucher_max'] = self::$error['voucher_max'];
		} else {
			$data['error_voucher_max'] = '';
		}

		if (isset(self::$error['processing_status'])) {
			$data['error_processing_status'] = self::$error['processing_status'];
		} else {
			$data['error_processing_status'] = '';
		}

		if (isset(self::$error['complete_status'])) {
			$data['error_complete_status'] = self::$error['complete_status'];
		} else {
			$data['error_complete_status'] = '';
		}

		if (isset(self::$error['log'])) {
			$data['error_log'] = self::$error['log'];
		} else {
			$data['error_log'] = '';
		}

		if (isset(self::$error['limit_admin'])) {
			$data['error_limit_admin'] = self::$error['limit_admin'];
		} else {
			$data['error_limit_admin'] = '';
		}

		if (isset(self::$error['encryption'])) {
			$data['error_encryption'] = self::$error['encryption'];
		} else {
			$data['error_encryption'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_stores'),
			'href' => url::link('setting/store')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('setting/setting')
		);

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		$data['action'] = url::link('setting/setting');

		$data['cancel'] = url::link('setting/store');


		if (isset(request::$post['config_meta_title'])) {
			$data['config_meta_title'] = request::$post['config_meta_title'];
		} else {
			$data['config_meta_title'] = config('meta_title');
		}

		if (isset(request::$post['config_meta_description'])) {
			$data['config_meta_description'] = request::$post['config_meta_description'];
		} else {
			$data['config_meta_description'] = config('meta_description');
		}

		if (isset(request::$post['config_meta_keyword'])) {
			$data['config_meta_keyword'] = request::$post['config_meta_keyword'];
		} else {
			$data['config_meta_keyword'] = config('meta_keyword');
		}

		if (isset(request::$post['config_theme'])) {
			$data['config_theme'] = request::$post['config_theme'];
		} else {
			$data['config_theme'] = config('theme');
		}

		if (request::$server['HTTPS']) {
			$data['store_url'] = HTTPS_CATALOG;
		} else {
			$data['store_url'] = HTTP_CATALOG;
		}

		$data['themes'] = array();


		$extensions = admin_setting_extension::getInstalled('theme');

		foreach ($extensions as $code) {
			load::language('extension/theme/' . $code, 'extension');
			
			$data['themes'][] = array(
				'text'  => language::get('extension')::get('heading_title'),
				'value' => $code
			);
		}
			
		if (isset(request::$post['config_layout_id'])) {
			$data['config_layout_id'] = request::$post['config_layout_id'];
		} else {
			$data['config_layout_id'] = config('layout_id');
		}


		$data['layouts'] = admin_design_layout::getLayouts();

		if (isset(request::$post['config_name'])) {
			$data['config_name'] = request::$post['config_name'];
		} else {
			$data['config_name'] = config('name');
		}

		if (isset(request::$post['config_owner'])) {
			$data['config_owner'] = request::$post['config_owner'];
		} else {
			$data['config_owner'] = config('owner');
		}

		if (isset(request::$post['config_address'])) {
			$data['config_address'] = request::$post['config_address'];
		} else {
			$data['config_address'] = config('address');
		}

		if (isset(request::$post['config_geocode'])) {
			$data['config_geocode'] = request::$post['config_geocode'];
		} else {
			$data['config_geocode'] = config('geocode');
		}

		if (isset(request::$post['config_email'])) {
			$data['config_email'] = request::$post['config_email'];
		} else {
			$data['config_email'] = config('email');
		}

		if (isset(request::$post['config_telephone'])) {
			$data['config_telephone'] = request::$post['config_telephone'];
		} else {
			$data['config_telephone'] = config('telephone');
		}
		
		if (isset(request::$post['config_fax'])) {
			$data['config_fax'] = request::$post['config_fax'];
		} else {
			$data['config_fax'] = config('fax');
		}
		
		if (isset(request::$post['config_image'])) {
			$data['config_image'] = request::$post['config_image'];
		} else {
			$data['config_image'] = config('image');
		}


		if (isset(request::$post['config_image']) && is_file('image/' . request::$post['config_image'])) {
			$data['thumb'] = admin_tool_image::resize(request::$post['config_image'], 100, 100);
		} elseif (config('image') && is_file('image/' . config('image'))) {
			$data['thumb'] = admin_tool_image::resize(config('image'), 100, 100);
		} else {
			$data['thumb'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		$data['placeholder'] = admin_tool_image::resize('no_image.png', 100, 100);

		if (isset(request::$post['config_open'])) {
			$data['config_open'] = request::$post['config_open'];
		} else {
			$data['config_open'] = config('open');
		}

		if (isset(request::$post['config_comment'])) {
			$data['config_comment'] = request::$post['config_comment'];
		} else {
			$data['config_comment'] = config('comment');
		}


		$data['locations'] = admin_localisation_location::getLocations();

		if (isset(request::$post['config_location'])) {
			$data['config_location'] = request::$post['config_location'];
		} elseif (config('location')) {
			$data['config_location'] = config('location');
		} else {
			$data['config_location'] = array();
		}

		if (isset(request::$post['config_country_id'])) {
			$data['config_country_id'] = request::$post['config_country_id'];
		} else {
			$data['config_country_id'] = config('country_id');
		}


		$data['countries'] = admin_localisation_country::getCountries();

		if (isset(request::$post['config_zone_id'])) {
			$data['config_zone_id'] = request::$post['config_zone_id'];
		} else {
			$data['config_zone_id'] = config('zone_id');
		}

		if (isset(request::$post['config_timezone'])) {
			$data['config_timezone'] = request::$post['config_timezone'];
		} elseif (config::has('config_timezone')) {
			$data['config_timezone'] = config('timezone');
		} else {
			$data['config_timezone'] = 'UTC';
		}
		// Set Time Zone
		$data['timezones'] = array();

		$timestamp = time();

		$timezones = timezone_identifiers_list();

		foreach($timezones as $timezone) {
			date_default_timezone_set($timezone);
			$hour = ' (' . date('P', $timestamp) . ')';
			$data['timezones'][] = array(
				'text'  => $timezone . $hour,
				'value' => $timezone
			);
		}

		date_default_timezone_set(config('timezone'));

		if (isset(request::$post['config_language'])) {
			$data['config_language'] = request::$post['config_language'];
		} else {
			$data['config_language'] = config('language');
		}


		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['config_admin_language'])) {
			$data['config_admin_language'] = request::$post['config_admin_language'];
		} else {
			$data['config_admin_language'] = config('admin_language');
		}

		if (isset(request::$post['config_currency'])) {
			$data['config_currency'] = request::$post['config_currency'];
		} else {
			$data['config_currency'] = config('currency');
		}

		if (isset(request::$post['config_currency_auto'])) {
			$data['config_currency_auto'] = request::$post['config_currency_auto'];
		} else {
			$data['config_currency_auto'] = config('currency_auto');
		}


		$data['currencies'] = admin_localisation_currency::getCurrencies();

		if (isset(request::$post['config_length_class_id'])) {
			$data['config_length_class_id'] = request::$post['config_length_class_id'];
		} else {
			$data['config_length_class_id'] = config('length_class_id');
		}


		$data['length_classes'] = admin_localisation_length_class::getLengthClasses();

		if (isset(request::$post['config_weight_class_id'])) {
			$data['config_weight_class_id'] = request::$post['config_weight_class_id'];
		} else {
			$data['config_weight_class_id'] = config('weight_class_id');
		}


		$data['weight_classes'] = admin_localisation_weight_class::getWeightClasses();

		if (isset(request::$post['config_limit_admin'])) {
			$data['config_limit_admin'] = request::$post['config_limit_admin'];
		} else {
			$data['config_limit_admin'] = config('limit_admin');
		}

		if (isset(request::$post['config_product_count'])) {
			$data['config_product_count'] = request::$post['config_product_count'];
		} else {
			$data['config_product_count'] = config('product_count');
		}

		if (isset(request::$post['config_review_status'])) {
			$data['config_review_status'] = request::$post['config_review_status'];
		} else {
			$data['config_review_status'] = config('review_status');
		}

		if (isset(request::$post['config_review_guest'])) {
			$data['config_review_guest'] = request::$post['config_review_guest'];
		} else {
			$data['config_review_guest'] = config('review_guest');
		}

		if (isset(request::$post['config_voucher_min'])) {
			$data['config_voucher_min'] = request::$post['config_voucher_min'];
		} else {
			$data['config_voucher_min'] = config('voucher_min');
		}

		if (isset(request::$post['config_voucher_max'])) {
			$data['config_voucher_max'] = request::$post['config_voucher_max'];
		} else {
			$data['config_voucher_max'] = config('voucher_max');
		}

		if (isset(request::$post['config_tax'])) {
			$data['config_tax'] = request::$post['config_tax'];
		} else {
			$data['config_tax'] = config('tax');
		}

		if (isset(request::$post['config_tax_default'])) {
			$data['config_tax_default'] = request::$post['config_tax_default'];
		} else {
			$data['config_tax_default'] = config('tax_default');
		}

		if (isset(request::$post['config_tax_customer'])) {
			$data['config_tax_customer'] = request::$post['config_tax_customer'];
		} else {
			$data['config_tax_customer'] = config('tax_customer');
		}

		if (isset(request::$post['config_customer_online'])) {
			$data['config_customer_online'] = request::$post['config_customer_online'];
		} else {
			$data['config_customer_online'] = config('customer_online');
		}

		if (isset(request::$post['config_customer_activity'])) {
			$data['config_customer_activity'] = request::$post['config_customer_activity'];
		} else {
			$data['config_customer_activity'] = config('customer_activity');
		}

		if (isset(request::$post['config_customer_search'])) {
			$data['config_customer_search'] = request::$post['config_customer_search'];
		} else {
			$data['config_customer_search'] = config('customer_search');
		}

		if (isset(request::$post['config_customer_group_id'])) {
			$data['config_customer_group_id'] = request::$post['config_customer_group_id'];
		} else {
			$data['config_customer_group_id'] = config('customer_group_id');
		}


		$data['customer_groups'] = admin_customer_customer_group::getCustomerGroups();

		if (isset(request::$post['config_customer_group_display'])) {
			$data['config_customer_group_display'] = request::$post['config_customer_group_display'];
		} elseif (config('customer_group_display')) {
			$data['config_customer_group_display'] = config('customer_group_display');
		} else {
			$data['config_customer_group_display'] = array();
		}

		if (isset(request::$post['config_customer_price'])) {
			$data['config_customer_price'] = request::$post['config_customer_price'];
		} else {
			$data['config_customer_price'] = config('customer_price');
		}

		if (isset(request::$post['config_login_attempts'])) {
			$data['config_login_attempts'] = request::$post['config_login_attempts'];
		} elseif (config::has('config_login_attempts')) {
			$data['config_login_attempts'] = config('login_attempts');
		} else {
			$data['config_login_attempts'] = 5;
		}

		if (isset(request::$post['config_account_id'])) {
			$data['config_account_id'] = request::$post['config_account_id'];
		} else {
			$data['config_account_id'] = config('account_id');
		}


		$data['informations'] = admin_catalog_information::getInformations();

		if (isset(request::$post['config_cart_weight'])) {
			$data['config_cart_weight'] = request::$post['config_cart_weight'];
		} else {
			$data['config_cart_weight'] = config('cart_weight');
		}

		if (isset(request::$post['config_checkout_guest'])) {
			$data['config_checkout_guest'] = request::$post['config_checkout_guest'];
		} else {
			$data['config_checkout_guest'] = config('checkout_guest');
		}

		if (isset(request::$post['config_checkout_id'])) {
			$data['config_checkout_id'] = request::$post['config_checkout_id'];
		} else {
			$data['config_checkout_id'] = config('checkout_id');
		}

		if (isset(request::$post['config_invoice_prefix'])) {
			$data['config_invoice_prefix'] = request::$post['config_invoice_prefix'];
		} elseif (config('invoice_prefix')) {
			$data['config_invoice_prefix'] = config('invoice_prefix');
		} else {
			$data['config_invoice_prefix'] = 'INV-' . date('Y') . '-00';
		}

		if (isset(request::$post['config_order_status_id'])) {
			$data['config_order_status_id'] = request::$post['config_order_status_id'];
		} else {
			$data['config_order_status_id'] = config('order_status_id');
		}

		if (isset(request::$post['config_processing_status'])) {
			$data['config_processing_status'] = request::$post['config_processing_status'];
		} elseif (config('processing_status')) {
			$data['config_processing_status'] = config('processing_status');
		} else {
			$data['config_processing_status'] = array();
		}

		if (isset(request::$post['config_complete_status'])) {
			$data['config_complete_status'] = request::$post['config_complete_status'];
		} elseif (config('complete_status')) {
			$data['config_complete_status'] = config('complete_status');
		} else {
			$data['config_complete_status'] = array();
		}

		if (isset(request::$post['config_fraud_status_id'])) {
			$data['config_fraud_status_id'] = request::$post['config_fraud_status_id'];
		} else {
			$data['config_fraud_status_id'] = config('fraud_status_id');
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['config_api_id'])) {
			$data['config_api_id'] = request::$post['config_api_id'];
		} else {
			$data['config_api_id'] = config('api_id');
		}


		$data['apis'] = admin_user_api::getApis();

		if (isset(request::$post['config_stock_display'])) {
			$data['config_stock_display'] = request::$post['config_stock_display'];
		} else {
			$data['config_stock_display'] = config('stock_display');
		}

		if (isset(request::$post['config_stock_warning'])) {
			$data['config_stock_warning'] = request::$post['config_stock_warning'];
		} else {
			$data['config_stock_warning'] = config('stock_warning');
		}

		if (isset(request::$post['config_stock_checkout'])) {
			$data['config_stock_checkout'] = request::$post['config_stock_checkout'];
		} else {
			$data['config_stock_checkout'] = config('stock_checkout');
		}

		if (isset(request::$post['config_affiliate_group_id'])) {
			$data['config_affiliate_group_id'] = request::$post['config_affiliate_group_id'];
		} else {
			$data['config_affiliate_group_id'] = config('affiliate_group_id');
		}

		if (isset(request::$post['config_affiliate_approval'])) {
			$data['config_affiliate_approval'] = request::$post['config_affiliate_approval'];
		} elseif (config::has('config_affiliate_approval')) {
			$data['config_affiliate_approval'] = config('affiliate_approval');
		} else {
			$data['config_affiliate_approval'] = '';
		}

		if (isset(request::$post['config_affiliate_auto'])) {
			$data['config_affiliate_auto'] = request::$post['config_affiliate_auto'];
		} elseif (config::has('config_affiliate_auto')) {
			$data['config_affiliate_auto'] = config('affiliate_auto');
		} else {
			$data['config_affiliate_auto'] = '';
		}

		if (isset(request::$post['config_affiliate_commission'])) {
			$data['config_affiliate_commission'] = request::$post['config_affiliate_commission'];
		} elseif (config::has('config_affiliate_commission')) {
			$data['config_affiliate_commission'] = config('affiliate_commission');
		} else {
			$data['config_affiliate_commission'] = '5.00';
		}

		if (isset(request::$post['config_affiliate_id'])) {
			$data['config_affiliate_id'] = request::$post['config_affiliate_id'];
		} else {
			$data['config_affiliate_id'] = config('affiliate_id');
		}

		if (isset(request::$post['config_return_id'])) {
			$data['config_return_id'] = request::$post['config_return_id'];
		} else {
			$data['config_return_id'] = config('return_id');
		}

		if (isset(request::$post['config_return_status_id'])) {
			$data['config_return_status_id'] = request::$post['config_return_status_id'];
		} else {
			$data['config_return_status_id'] = config('return_status_id');
		}


		$data['return_statuses'] = admin_localisation_return_status::getReturnStatuses();

		if (isset(request::$post['config_captcha'])) {
			$data['config_captcha'] = request::$post['config_captcha'];
		} else {
			$data['config_captcha'] = config('captcha');
		}
		

		$data['captchas'] = array();

		// Get a list of installed captchas
		$extensions = admin_setting_extension::getInstalled('captcha');

		foreach ($extensions as $code) {
			load::language('extension/captcha/' . $code, 'extension');

			if (config::get('captcha_' . $code . '_status')) {
				$data['captchas'][] = array(
					'text'  => language::get('extension')::get('heading_title'),
					'value' => $code
				);
			}
		}		

		if (isset(request::$post['config_captcha_page'])) {
			$data['config_captcha_page'] = request::$post['config_captcha_page'];
		} elseif (config::has('config_captcha_page')) {
		   	$data['config_captcha_page'] = config('captcha_page');
		} else {
			$data['config_captcha_page'] = array();
		}

		$data['captcha_pages'] = array();

		$data['captcha_pages'][] = array(
			'text'  => language::get('text_register'),
			'value' => 'register'
		);
		
		$data['captcha_pages'][] = array(
			'text'  => language::get('text_guest'),
			'value' => 'guest'
		);
		
		$data['captcha_pages'][] = array(
			'text'  => language::get('text_review'),
			'value' => 'review'
		);

		$data['captcha_pages'][] = array(
			'text'  => language::get('text_return'),
			'value' => 'return'
		);

		$data['captcha_pages'][] = array(
			'text'  => language::get('text_contact'),
			'value' => 'contact'
		);

		if (isset(request::$post['config_logo'])) {
			$data['config_logo'] = request::$post['config_logo'];
		} else {
			$data['config_logo'] = config('logo');
		}

		if (isset(request::$post['config_logo']) && is_file('image/' . request::$post['config_logo'])) {
			$data['logo'] = admin_tool_image::resize(request::$post['config_logo'], 100, 100);
		} elseif (config('logo') && is_file('image/' . config('logo'))) {
			$data['logo'] = admin_tool_image::resize(config('logo'), 100, 100);
		} else {
			$data['logo'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		if (isset(request::$post['config_icon'])) {
			$data['config_icon'] = request::$post['config_icon'];
		} else {
			$data['config_icon'] = config('icon');
		}

		if (isset(request::$post['config_icon']) && is_file('image/' . request::$post['config_icon'])) {
			$data['icon'] = admin_tool_image::resize(request::$post['config_icon'], 100, 100);
		} elseif (config('icon') && is_file('image/' . config('icon'))) {
			$data['icon'] = admin_tool_image::resize(config('icon'), 100, 100);
		} else {
			$data['icon'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		if (isset(request::$post['config_mail_engine'])) {
			$data['config_mail_engine'] = request::$post['config_mail_engine'];
		} else {
			$data['config_mail_engine'] = config('mail_engine');
		}

		if (isset(request::$post['config_mail_parameter'])) {
			$data['config_mail_parameter'] = request::$post['config_mail_parameter'];
		} else {
			$data['config_mail_parameter'] = config('mail_parameter');
		}

		if (isset(request::$post['config_mail_smtp_hostname'])) {
			$data['config_mail_smtp_hostname'] = request::$post['config_mail_smtp_hostname'];
		} else {
			$data['config_mail_smtp_hostname'] = config('mail_smtp_hostname');
		}

		if (isset(request::$post['config_mail_smtp_username'])) {
			$data['config_mail_smtp_username'] = request::$post['config_mail_smtp_username'];
		} else {
			$data['config_mail_smtp_username'] = config('mail_smtp_username');
		}

		if (isset(request::$post['config_mail_smtp_password'])) {
			$data['config_mail_smtp_password'] = request::$post['config_mail_smtp_password'];
		} else {
			$data['config_mail_smtp_password'] = config('mail_smtp_password');
		}

		if (isset(request::$post['config_mail_smtp_port'])) {
			$data['config_mail_smtp_port'] = request::$post['config_mail_smtp_port'];
		} elseif (config::has('config_mail_smtp_port')) {
			$data['config_mail_smtp_port'] = config('mail_smtp_port');
		} else {
			$data['config_mail_smtp_port'] = 25;
		}

		if (isset(request::$post['config_mail_smtp_timeout'])) {
			$data['config_mail_smtp_timeout'] = request::$post['config_mail_smtp_timeout'];
		} elseif (config::has('config_mail_smtp_timeout')) {
			$data['config_mail_smtp_timeout'] = config('mail_smtp_timeout');
		} else {
			$data['config_mail_smtp_timeout'] = 5;
		}

		if (isset(request::$post['config_mail_alert'])) {
			$data['config_mail_alert'] = request::$post['config_mail_alert'];
		} elseif (config::has('config_mail_alert')) {
		   	$data['config_mail_alert'] = config('mail_alert');
		} else {
			$data['config_mail_alert'] = array();
		}

		$data['mail_alerts'] = array();

		$data['mail_alerts'][] = array(
			'text'  => language::get('text_mail_account'),
			'value' => 'account'
		);

		$data['mail_alerts'][] = array(
			'text'  => language::get('text_mail_affiliate'),
			'value' => 'affiliate'
		);

		$data['mail_alerts'][] = array(
			'text'  => language::get('text_mail_order'),
			'value' => 'order'
		);

		$data['mail_alerts'][] = array(
			'text'  => language::get('text_mail_review'),
			'value' => 'review'
		);

		if (isset(request::$post['config_mail_alert_email'])) {
			$data['config_mail_alert_email'] = request::$post['config_mail_alert_email'];
		} else {
			$data['config_mail_alert_email'] = config('mail_alert_email');
		}
		
		if (isset(request::$post['config_secure'])) {
			$data['config_secure'] = request::$post['config_secure'];
		} else {
			$data['config_secure'] = config('secure');
		}

		if (isset(request::$post['config_shared'])) {
			$data['config_shared'] = request::$post['config_shared'];
		} else {
			$data['config_shared'] = config('shared');
		}

		if (isset(request::$post['config_robots'])) {
			$data['config_robots'] = request::$post['config_robots'];
		} else {
			$data['config_robots'] = config('robots');
		}

		if (isset(request::$post['config_seo_url'])) {
			$data['config_seo_url'] = request::$post['config_seo_url'];
		} else {
			$data['config_seo_url'] = config('seo_url');
		}

		if (isset(request::$post['config_file_max_size'])) {
			$data['config_file_max_size'] = request::$post['config_file_max_size'];
		} elseif (config('file_max_size')) {
			$data['config_file_max_size'] = config('file_max_size');
		} else {
			$data['config_file_max_size'] = 300000;
		}

		if (isset(request::$post['config_file_ext_allowed'])) {
			$data['config_file_ext_allowed'] = request::$post['config_file_ext_allowed'];
		} else {
			$data['config_file_ext_allowed'] = config('file_ext_allowed');
		}

		if (isset(request::$post['config_file_mime_allowed'])) {
			$data['config_file_mime_allowed'] = request::$post['config_file_mime_allowed'];
		} else {
			$data['config_file_mime_allowed'] = config('file_mime_allowed');
		}

		if (isset(request::$post['config_maintenance'])) {
			$data['config_maintenance'] = request::$post['config_maintenance'];
		} else {
			$data['config_maintenance'] = config('maintenance');
		}

		if (isset(request::$post['config_password'])) {
			$data['config_password'] = request::$post['config_password'];
		} else {
			$data['config_password'] = config('password');
		}

		if (isset(request::$post['config_encryption'])) {
			$data['config_encryption'] = request::$post['config_encryption'];
		} else {
			$data['config_encryption'] = config('encryption');
		}

		if (isset(request::$post['config_compression'])) {
			$data['config_compression'] = request::$post['config_compression'];
		} else {
			$data['config_compression'] = config('compression');
		}

		if (isset(request::$post['config_error_display'])) {
			$data['config_error_display'] = request::$post['config_error_display'];
		} else {
			$data['config_error_display'] = config('error_display');
		}

		if (isset(request::$post['config_error_log'])) {
			$data['config_error_log'] = request::$post['config_error_log'];
		} else {
			$data['config_error_log'] = config('error_log');
		}

		if (isset(request::$post['config_error_filename'])) {
			$data['config_error_filename'] = request::$post['config_error_filename'];
		} else {
			$data['config_error_filename'] = config('error_filename');
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('setting/setting', $data));
	}

	protected static function validate() {
		if (!user::hasPermission('modify', 'setting/setting')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['config_meta_title']) {
			self::$error['meta_title'] = language::get('error_meta_title');
		}

		if (!request::$post['config_name']) {
			self::$error['name'] = language::get('error_name');
		}

		if ((utf8_strlen(request::$post['config_owner']) < 3) || (utf8_strlen(request::$post['config_owner']) > 64)) {
			self::$error['owner'] = language::get('error_owner');
		}

		if ((utf8_strlen(request::$post['config_address']) < 3) || (utf8_strlen(request::$post['config_address']) > 256)) {
			self::$error['address'] = language::get('error_address');
		}

		if ((utf8_strlen(request::$post['config_email']) > 96) || !filter_var(request::$post['config_email'], FILTER_VALIDATE_EMAIL)) {
			self::$error['email'] = language::get('error_email');
		}

		if ((utf8_strlen(request::$post['config_telephone']) < 3) || (utf8_strlen(request::$post['config_telephone']) > 32)) {
			self::$error['telephone'] = language::get('error_telephone');
		}

		if (!empty(request::$post['config_customer_group_display']) && !in_array(request::$post['config_customer_group_id'], request::$post['config_customer_group_display'])) {
			self::$error['customer_group_display'] = language::get('error_customer_group_display');
		}

		if (!request::$post['config_limit_admin']) {
			self::$error['limit_admin'] = language::get('error_limit');
		}

		if (request::$post['config_login_attempts'] < 1) {
			self::$error['login_attempts'] = language::get('error_login_attempts');
		}

		if (!request::$post['config_voucher_min']) {
			self::$error['voucher_min'] = language::get('error_voucher_min');
		}

		if (!request::$post['config_voucher_max']) {
			self::$error['voucher_max'] = language::get('error_voucher_max');
		}

		if (!isset(request::$post['config_processing_status'])) {
			self::$error['processing_status'] = language::get('error_processing_status');
		}

		if (!isset(request::$post['config_complete_status'])) {
			self::$error['complete_status'] = language::get('error_complete_status');
		}
		
		if (!request::$post['config_error_filename']) {
			self::$error['log'] = language::get('error_log_required');
		} elseif (preg_match('/\.\.[\/\\\]?/', request::$post['config_error_filename'])) {
			self::$error['log'] = language::get('error_log_invalid');
		} elseif (substr(request::$post['config_error_filename'], strrpos(request::$post['config_error_filename'], '.')) != '.log') {
			self::$error['log'] = language::get('error_log_extension');
		}
		
		if ((utf8_strlen(request::$post['config_encryption']) < 32) || (utf8_strlen(request::$post['config_encryption']) > 1024)) {
			self::$error['encryption'] = language::get('error_encryption');
		}

		if (self::$error && !isset(self::$error['warning'])) {
			self::$error['warning'] = language::get('error_warning');
		}

		return !self::$error;
	}
	
	public static function theme() {
		if (request::$server['HTTPS']) {
			$server = HTTPS_CATALOG;
		} else {
			$server = HTTP_CATALOG;
		}
		
		// This is only here for compatibility with old themes.
		if (request::$get['theme'] == 'theme_default') {
			$theme = config::get('theme_default_directory');
		} else {
			$theme = basename(request::$get['theme']);
		}
		
		if (is_file(DIR_CATALOG . 'view/theme/' . $theme . '/image/' . $theme . '.png')) {
			response::setOutput($server . 'catalog/view/theme/' . $theme . '/image/' . $theme . '.png');
		} else {
			response::setOutput($server . 'image/no_image.png');
		}
	}	
}
