<?php
class ControllerSettingStore {
	private static $error = array();

	public static function index() {
		load::language('setting/store');

		document::setTitle(language::get('heading_title'));



		self::getList();
	}

	public static function add() {
		load::language('setting/store');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			$store_id = admin_setting_store::addStore(request::$post);


			admin_setting_setting::editSetting('config', request::$post, $store_id);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('setting/store'));
		}

		self::getForm();
	}

	public static function edit() {
		load::language('setting/store');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateForm()) {
			admin_setting_store::editStore(request::$get['store_id'], request::$post);


			admin_setting_setting::editSetting('config', request::$post, request::$get['store_id']);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('setting/store', '&store_id=' . request::$get['store_id']));
		}

		self::getForm();
	}

	public static function delete() {
		load::language('setting/store');

		document::setTitle(language::get('heading_title'));


		if (isset(request::$post['selected']) && self::validateDelete()) {

			foreach (request::$post['selected'] as $store_id) {
				admin_setting_store::deleteStore($store_id);

				admin_setting_setting::deleteSetting('config', $store_id);
			}

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('setting/store'));
		}

		self::getList();
	}

	protected static function getList() {
		$url = '';

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('setting/store')
		);

		$data['add'] = url::link('setting/store/add');
		$data['delete'] = url::link('setting/store/delete');

		$data['stores'] = array();

		$data['stores'][] = array(
			'store_id' => 0,
			'name'     => config('name') . language::get('text_default'),
			'url'      => config('secure') ? HTTPS_CATALOG : HTTP_CATALOG,
			'edit'     => url::link('setting/setting')
		);

		$store_total = admin_setting_store::getTotalStores();

		$results = admin_setting_store::getStores();

		foreach ($results as $result) {
			$data['stores'][] = array(
				'store_id' => $result['store_id'],
				'name'     => $result['name'],
				'url'      => $result['url'],
				'edit'     => url::link('setting/store/edit', '&store_id=' . $result['store_id'])
			);
		}

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(request::$post['selected'])) {
			$data['selected'] = (array)request::$post['selected'];
		} else {
			$data['selected'] = array();
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('setting/store_list', $data));
	}

	protected static function getForm() {
		$data['text_form'] = !isset(request::$get['store_id']) ? language::get('text_add') : language::get('text_edit');

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(self::$error['url'])) {
			$data['error_url'] = self::$error['url'];
		} else {
			$data['error_url'] = '';
		}

		if (isset(self::$error['meta_title'])) {
			$data['error_meta_title'] = self::$error['meta_title'];
		} else {
			$data['error_meta_title'] = '';
		}

		if (isset(self::$error['name'])) {
			$data['error_name'] = self::$error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset(self::$error['owner'])) {
			$data['error_owner'] = self::$error['owner'];
		} else {
			$data['error_owner'] = '';
		}

		if (isset(self::$error['address'])) {
			$data['error_address'] = self::$error['address'];
		} else {
			$data['error_address'] = '';
		}

		if (isset(self::$error['email'])) {
			$data['error_email'] = self::$error['email'];
		} else {
			$data['error_email'] = '';
		}

		if (isset(self::$error['telephone'])) {
			$data['error_telephone'] = self::$error['telephone'];
		} else {
			$data['error_telephone'] = '';
		}

		if (isset(self::$error['customer_group_display'])) {
			$data['error_customer_group_display'] = self::$error['customer_group_display'];
		} else {
			$data['error_customer_group_display'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('setting/store')
		);

		if (!isset(request::$get['store_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => language::get('text_settings'),
				'href' => url::link('setting/store/add')
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => language::get('text_settings'),
				'href' => url::link('setting/store/edit', '&store_id=' . request::$get['store_id'])
			);
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (!isset(request::$get['store_id'])) {
			$data['action'] = url::link('setting/store/add');
		} else {
			$data['action'] = url::link('setting/store/edit', '&store_id=' . request::$get['store_id']);
		}

		$data['cancel'] = url::link('setting/store');

		if (isset(request::$get['store_id']) && (request::$server['REQUEST_METHOD'] != 'POST')) {

			$store_info = admin_setting_setting::getSetting('config', request::$get['store_id']);
		}


		if (isset(request::$post['config_url'])) {
			$data['config_url'] = request::$post['config_url'];
		} elseif (isset($store_info['config_url'])) {
			$data['config_url'] = $store_info['config_url'];
		} else {
			$data['config_url'] = '';
		}

		if (isset(request::$post['config_ssl'])) {
			$data['config_ssl'] = request::$post['config_ssl'];
		} elseif (isset($store_info['config_ssl'])) {
			$data['config_ssl'] = $store_info['config_ssl'];
		} else {
			$data['config_ssl'] = '';
		}

		if (isset(request::$post['config_meta_title'])) {
			$data['config_meta_title'] = request::$post['config_meta_title'];
		} elseif (isset($store_info['config_meta_title'])) {
			$data['config_meta_title'] = $store_info['config_meta_title'];
		} else {
			$data['config_meta_title'] = '';
		}

		if (isset(request::$post['config_meta_description'])) {
			$data['config_meta_description'] = request::$post['config_meta_description'];
		} elseif (isset($store_info['config_meta_description'])) {
			$data['config_meta_description'] = $store_info['config_meta_description'];
		} else {
			$data['config_meta_description'] = '';
		}

		if (isset(request::$post['config_meta_keyword'])) {
			$data['config_meta_keyword'] = request::$post['config_meta_keyword'];
		} elseif (isset($store_info['config_meta_keyword'])) {
			$data['config_meta_keyword'] = $store_info['config_meta_keyword'];
		} else {
			$data['config_meta_keyword'] = '';
		}

		if (isset(request::$post['config_theme'])) {
			$data['config_theme'] = request::$post['config_theme'];
		} elseif (isset($store_info['config_theme'])) {
			$data['config_theme'] = $store_info['config_theme'];
		} else {
			$data['config_theme'] = '';
		}

		$data['themes'] = array();

		// Create a new language container so we don't pollute the current one
		$language = new Language(config('language'));


		$extensions = admin_setting_extension::getInstalled('theme');

		foreach ($extensions as $code) {
			load::language('extension/theme/' . $code, 'extension');

			$data['themes'][] = array(
				'text'  => language::get('extension')::get('heading_title'),
				'value' => $code
			);
		}

		if (isset(request::$post['config_layout_id'])) {
			$data['config_layout_id'] = request::$post['config_layout_id'];
		} elseif (isset($store_info['config_layout_id'])) {
			$data['config_layout_id'] = $store_info['config_layout_id'];
		} else {
			$data['config_layout_id'] = '';
		}


		$data['layouts'] = admin_design_layout::getLayouts();

		if (isset(request::$post['config_name'])) {
			$data['config_name'] = request::$post['config_name'];
		} elseif (isset($store_info['config_name'])) {
			$data['config_name'] = $store_info['config_name'];
		} else {
			$data['config_name'] = '';
		}

		if (isset(request::$post['config_owner'])) {
			$data['config_owner'] = request::$post['config_owner'];
		} elseif (isset($store_info['config_owner'])) {
			$data['config_owner'] = $store_info['config_owner'];
		} else {
			$data['config_owner'] = '';
		}

		if (isset(request::$post['config_address'])) {
			$data['config_address'] = request::$post['config_address'];
		} elseif (isset($store_info['config_address'])) {
			$data['config_address'] = $store_info['config_address'];
		} else {
			$data['config_address'] = '';
		}

		if (isset(request::$post['config_geocode'])) {
			$data['config_geocode'] = request::$post['config_geocode'];
		} elseif (isset($store_info['config_geocode'])) {
			$data['config_geocode'] = $store_info['config_geocode'];
		} else {
			$data['config_geocode'] = '';
		}

		if (isset(request::$post['config_email'])) {
			$data['config_email'] = request::$post['config_email'];
		} elseif (isset($store_info['config_email'])) {
			$data['config_email'] = $store_info['config_email'];
		} else {
			$data['config_email'] = '';
		}

		if (isset(request::$post['config_telephone'])) {
			$data['config_telephone'] = request::$post['config_telephone'];
		} elseif (isset($store_info['config_telephone'])) {
			$data['config_telephone'] = $store_info['config_telephone'];
		} else {
			$data['config_telephone'] = '';
		}

		if (isset(request::$post['config_fax'])) {
			$data['config_fax'] = request::$post['config_fax'];
		} elseif (isset($store_info['config_fax'])) {
			$data['config_fax'] = $store_info['config_fax'];
		} else {
			$data['config_fax'] = '';
		}

		if (isset(request::$post['config_image'])) {
			$data['config_image'] = request::$post['config_image'];
		} elseif (isset($store_info['config_image'])) {
			$data['config_image'] = $store_info['config_image'];
		} else {
			$data['config_image'] = '';
		}


		if (isset(request::$post['config_image']) && is_file('image/' . request::$post['config_image'])) {
			$data['thumb'] = admin_tool_image::resize(request::$post['config_image'], 100, 100);
		} elseif (isset($store_info['config_image']) && is_file('image/' . $store_info['config_image'])) {
			$data['thumb'] = admin_tool_image::resize($store_info['config_image'], 100, 100);
		} else {
			$data['thumb'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		$data['placeholder'] = admin_tool_image::resize('no_image.png', 100, 100);

		if (isset(request::$post['config_open'])) {
			$data['config_open'] = request::$post['config_open'];
		} elseif (isset($store_info['config_open'])) {
			$data['config_open'] = $store_info['config_open'];
		} else {
			$data['config_open'] = '';
		}

		if (isset(request::$post['config_comment'])) {
			$data['config_comment'] = request::$post['config_comment'];
		} elseif (isset($store_info['config_comment'])) {
			$data['config_comment'] = $store_info['config_comment'];
		} else {
			$data['config_comment'] = '';
		}


		$data['locations'] = admin_localisation_location::getLocations();

		if (isset(request::$post['config_location'])) {
			$data['config_location'] = request::$post['config_location'];
		} elseif (isset($store_info['config_location'])) {
			$data['config_location'] = $store_info['config_location'];
		} else {
			$data['config_location'] = array();
		}

		if (isset(request::$post['config_country_id'])) {
			$data['config_country_id'] = request::$post['config_country_id'];
		} elseif (isset($store_info['config_country_id'])) {
			$data['config_country_id'] = $store_info['config_country_id'];
		} else {
			$data['config_country_id'] = config('country_id');
		}


		$data['countries'] = admin_localisation_country::getCountries();

		if (isset(request::$post['config_zone_id'])) {
			$data['config_zone_id'] = request::$post['config_zone_id'];
		} elseif (isset($store_info['config_zone_id'])) {
			$data['config_zone_id'] = $store_info['config_zone_id'];
		} else {
			$data['config_zone_id'] = config('zone_id');
		}

		if (isset(request::$post['config_language'])) {
			$data['config_language'] = request::$post['config_language'];
		} elseif (isset($store_info['config_language'])) {
			$data['config_language'] = $store_info['config_language'];
		} else {
			$data['config_language'] = config('language');
		}


		$data['languages'] = admin_localisation_language::getLanguages();

		if (isset(request::$post['config_currency'])) {
			$data['config_currency'] = request::$post['config_currency'];
		} elseif (isset($store_info['config_currency'])) {
			$data['config_currency'] = $store_info['config_currency'];
		} else {
			$data['config_currency'] = config('currency');
		}


		$data['currencies'] = admin_localisation_currency::getCurrencies();

		if (isset(request::$post['config_tax'])) {
			$data['config_tax'] = request::$post['config_tax'];
		} elseif (isset($store_info['config_tax'])) {
			$data['config_tax'] = $store_info['config_tax'];
		} else {
			$data['config_tax'] = '';
		}

		if (isset(request::$post['config_tax_default'])) {
			$data['config_tax_default'] = request::$post['config_tax_default'];
		} elseif (isset($store_info['config_tax_default'])) {
			$data['config_tax_default'] = $store_info['config_tax_default'];
		} else {
			$data['config_tax_default'] = '';
		}

		if (isset(request::$post['config_tax_customer'])) {
			$data['config_tax_customer'] = request::$post['config_tax_customer'];
		} elseif (isset($store_info['config_tax_customer'])) {
			$data['config_tax_customer'] = $store_info['config_tax_customer'];
		} else {
			$data['config_tax_customer'] = '';
		}

		if (isset(request::$post['config_customer_group_id'])) {
			$data['config_customer_group_id'] = request::$post['config_customer_group_id'];
		} elseif (isset($store_info['config_customer_group_id'])) {
			$data['config_customer_group_id'] = $store_info['config_customer_group_id'];
		} else {
			$data['config_customer_group_id'] = '';
		}


		$data['customer_groups'] = admin_customer_customer_group::getCustomerGroups();

		if (isset(request::$post['config_customer_group_display'])) {
			$data['config_customer_group_display'] = request::$post['config_customer_group_display'];
		} elseif (isset($store_info['config_customer_group_display'])) {
			$data['config_customer_group_display'] = $store_info['config_customer_group_display'];
		} else {
			$data['config_customer_group_display'] = array();
		}

		if (isset(request::$post['config_customer_price'])) {
			$data['config_customer_price'] = request::$post['config_customer_price'];
		} elseif (isset($store_info['config_customer_price'])) {
			$data['config_customer_price'] = $store_info['config_customer_price'];
		} else {
			$data['config_customer_price'] = '';
		}

		if (isset(request::$post['config_account_id'])) {
			$data['config_account_id'] = request::$post['config_account_id'];
		} elseif (isset($store_info['config_account_id'])) {
			$data['config_account_id'] = $store_info['config_account_id'];
		} else {
			$data['config_account_id'] = '';
		}


		$data['informations'] = admin_catalog_information::getInformations();

		if (isset(request::$post['config_cart_weight'])) {
			$data['config_cart_weight'] = request::$post['config_cart_weight'];
		} elseif (isset($store_info['config_cart_weight'])) {
			$data['config_cart_weight'] = $store_info['config_cart_weight'];
		} else {
			$data['config_cart_weight'] = '';
		}

		if (isset(request::$post['config_checkout_guest'])) {
			$data['config_checkout_guest'] = request::$post['config_checkout_guest'];
		} elseif (isset($store_info['config_checkout_guest'])) {
			$data['config_checkout_guest'] = $store_info['config_checkout_guest'];
		} else {
			$data['config_checkout_guest'] = '';
		}

		if (isset(request::$post['config_checkout_id'])) {
			$data['config_checkout_id'] = request::$post['config_checkout_id'];
		} elseif (isset($store_info['config_checkout_id'])) {
			$data['config_checkout_id'] = $store_info['config_checkout_id'];
		} else {
			$data['config_checkout_id'] = '';
		}

		if (isset(request::$post['config_order_status_id'])) {
			$data['config_order_status_id'] = request::$post['config_order_status_id'];
		} elseif (isset($store_info['config_order_status_id'])) {
			$data['config_order_status_id'] = $store_info['config_order_status_id'];
		} else {
			$data['config_order_status_id'] = '';
		}


		$data['order_statuses'] = admin_localisation_order_status::getOrderStatuses();

		if (isset(request::$post['config_stock_display'])) {
			$data['config_stock_display'] = request::$post['config_stock_display'];
		} elseif (isset($store_info['config_stock_display'])) {
			$data['config_stock_display'] = $store_info['config_stock_display'];
		} else {
			$data['config_stock_display'] = '';
		}

		if (isset(request::$post['config_stock_checkout'])) {
			$data['config_stock_checkout'] = request::$post['config_stock_checkout'];
		} elseif (isset($store_info['config_stock_checkout'])) {
			$data['config_stock_checkout'] = $store_info['config_stock_checkout'];
		} else {
			$data['config_stock_checkout'] = '';
		}

		if (isset(request::$post['config_logo'])) {
			$data['config_logo'] = request::$post['config_logo'];
		} elseif (isset($store_info['config_logo'])) {
			$data['config_logo'] = $store_info['config_logo'];
		} else {
			$data['config_logo'] = '';
		}

		if (isset(request::$post['config_logo']) && is_file('image/' . request::$post['config_logo'])) {
			$data['logo'] = admin_tool_image::resize(request::$post['config_logo'], 100, 100);
		} elseif (isset($store_info['config_logo']) && is_file('image/' . $store_info['config_logo'])) {
			$data['logo'] = admin_tool_image::resize($store_info['config_logo'], 100, 100);
		} else {
			$data['logo'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		$data['placeholder'] = admin_tool_image::resize('no_image.png', 100, 100);

		if (isset(request::$post['config_icon'])) {
			$data['config_icon'] = request::$post['config_icon'];
		} elseif (isset($store_info['config_icon'])) {
			$data['config_icon'] = $store_info['config_icon'];
		} else {
			$data['config_icon'] = '';
		}

		if (isset(request::$post['config_icon']) && is_file('image/' . request::$post['config_icon'])) {
			$data['icon'] = admin_tool_image::resize(request::$post['config_icon'], 100, 100);
		} elseif (isset($store_info['config_icon']) && is_file('image/' . $store_info['config_icon'])) {
			$data['icon'] = admin_tool_image::resize($store_info['config_icon'], 100, 100);
		} else {
			$data['icon'] = admin_tool_image::resize('no_image.png', 100, 100);
		}

		if (isset(request::$post['config_secure'])) {
			$data['config_secure'] = request::$post['config_secure'];
		} elseif (isset($store_info['config_secure'])) {
			$data['config_secure'] = $store_info['config_secure'];
		} else {
			$data['config_secure'] = '';
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('setting/store_form', $data));
	}

	protected static function validateForm() {
		if (!user::hasPermission('modify', 'setting/store')) {
			self::$error['warning'] = language::get('error_permission');
		}

		if (!request::$post['config_url']) {
			self::$error['url'] = language::get('error_url');
		}

		if (!request::$post['config_meta_title']) {
			self::$error['meta_title'] = language::get('error_meta_title');
		}

		if (!request::$post['config_name']) {
			self::$error['name'] = language::get('error_name');
		}

		if ((utf8_strlen(request::$post['config_owner']) < 3) || (utf8_strlen(request::$post['config_owner']) > 64)) {
			self::$error['owner'] = language::get('error_owner');
		}

		if ((utf8_strlen(request::$post['config_address']) < 3) || (utf8_strlen(request::$post['config_address']) > 256)) {
			self::$error['address'] = language::get('error_address');
		}

		if ((utf8_strlen(request::$post['config_email']) > 96) || !filter_var(request::$post['config_email'], FILTER_VALIDATE_EMAIL)) {
			self::$error['email'] = language::get('error_email');
		}

		if ((utf8_strlen(request::$post['config_telephone']) < 3) || (utf8_strlen(request::$post['config_telephone']) > 32)) {
			self::$error['telephone'] = language::get('error_telephone');
		}

		if (!empty(request::$post['config_customer_group_display']) && !in_array(request::$post['config_customer_group_id'], request::$post['config_customer_group_display'])) {
			self::$error['customer_group_display'] = language::get('error_customer_group_display');
		}

		if (self::$error && !isset(self::$error['warning'])) {
			self::$error['warning'] = language::get('error_warning');
		}

		return !self::$error;
	}

	protected static function validateDelete() {
		if (!user::hasPermission('modify', 'setting/store')) {
			self::$error['warning'] = language::get('error_permission');
		}


		foreach (request::$post['selected'] as $store_id) {
			if (!$store_id) {
				self::$error['warning'] = language::get('error_default');
			}

			$store_total = admin_sale_order::getTotalOrdersByStoreId($store_id);

			if ($store_total) {
				self::$error['warning'] = sprintf(language::get('error_store'), $store_total);
			}
		}

		return !self::$error;
	}
}
