<?php
class ControllerToolLog {
	private static $error = array();

	public static function index() {		
		load::language('tool/log');
		
		document::setTitle(language::get('heading_title'));

		if (isset(session::$data['error'])) {
			$data['error_warning'] = session::$data['error'];

			unset(session::$data['error']);
		} elseif (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];

			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('tool/log')
		);

		$data['download'] = url::link('tool/log/download');
		$data['clear'] = url::link('tool/log/clear');

		$data['log'] = '';

		$file = DIR_LOGS . config('error_filename');

		if (file_exists($file)) {
			$size = filesize($file);

			if ($size >= 5242880) {
				$suffix = array(
					'B',
					'KB',
					'MB',
					'GB',
					'TB',
					'PB',
					'EB',
					'ZB',
					'YB'
				);

				$i = 0;

				while (($size / 1024) > 1) {
					$size = $size / 1024;
					$i++;
				}

				$data['error_warning'] = sprintf(language::get('error_warning'), basename($file), round(substr($size, 0, strpos($size, '.') + 4), 2) . $suffix[$i]);
			} else {
				$data['log'] = file_get_contents($file, FILE_USE_INCLUDE_PATH, null);
			}
		}

		$data['header'] = load::controller('common/header');
		$data['column_left'] = load::controller('common/column_left');
		$data['footer'] = load::controller('common/footer');

		response::setOutput(load::view('tool/log', $data));
	}

	public static function download() {
		load::language('tool/log');

		$file = DIR_LOGS . config('error_filename');

		if (file_exists($file) && filesize($file) > 0) {
			response::addheader('Pragma: public');
			response::addheader('Expires: 0');
			response::addheader('Content-Description: File Transfer');
			response::addheader('Content-Type: application/octet-stream');
			response::addheader('Content-Disposition: attachment; filename="' . config('name') . '_' . date('Y-m-d_H-i-s', time()) . '_error.log"');
			response::addheader('Content-Transfer-Encoding: binary');

			response::setOutput(file_get_contents($file, FILE_USE_INCLUDE_PATH, null));
		} else {
			session::$data['error'] = sprintf(language::get('error_warning'), basename($file), '0B');

			response::redirect(url::link('tool/log'));
		}
	}
	
	public static function clear() {
		load::language('tool/log');

		if (!user::hasPermission('modify', 'tool/log')) {
			session::$data['error'] = language::get('error_permission');
		} else {
			$file = DIR_LOGS . config('error_filename');

			$handle = fopen($file, 'w+');

			fclose($handle);

			session::$data['success'] = language::get('text_success');
		}

		response::redirect(url::link('tool/log'));
	}
}