<?php
class admin_catalog_attribute {
	public static function addAttribute($data) {
		db::query("INSERT INTO attribute SET attribute_group_id = " . (int)$data['attribute_group_id'] . ", sort_order = " . (int)$data['sort_order']);

		$attribute_id = db::getLastId();

		foreach ($data['attribute_description'] as $language_id => $value) {
			db::query("INSERT INTO attribute_description SET attribute_id = " . (int)$attribute_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		return $attribute_id;
	}

	public static function editAttribute($attribute_id, $data) {
		db::query("UPDATE attribute SET attribute_group_id = " . (int)$data['attribute_group_id'] . ", sort_order = " . (int)$data['sort_order'] . " WHERE attribute_id = " . (int)$attribute_id);

		db::query("DELETE FROM attribute_description WHERE attribute_id = " . (int)$attribute_id);

		foreach ($data['attribute_description'] as $language_id => $value) {
			db::query("INSERT INTO attribute_description SET attribute_id = " . (int)$attribute_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}
	}

	public static function deleteAttribute($attribute_id) {
		db::query("DELETE FROM attribute WHERE attribute_id = " . (int)$attribute_id);
		db::query("DELETE FROM attribute_description WHERE attribute_id = " . (int)$attribute_id);
	}

	public static function getAttribute($attribute_id) {
		$query = db::query("SELECT * FROM attribute a LEFT JOIN attribute_description ad ON (a.attribute_id = ad.attribute_id) WHERE a.attribute_id = " . (int)$attribute_id . " AND ad.language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getAttributes($data = array()) {
		$sql = "SELECT *, (SELECT agd.name FROM attribute_group_description agd WHERE agd.attribute_group_id = a.attribute_group_id AND agd.language_id = " . config('language_id') . ") AS attribute_group FROM attribute a LEFT JOIN attribute_description ad ON (a.attribute_id = ad.attribute_id) WHERE ad.language_id = " . config('language_id');

		if (!empty($data['filter_name'])) {
			$sql .= " AND ad.name LIKE '" . db::escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_attribute_group_id'])) {
			$sql .= " AND a.attribute_group_id = " . esc($data['filter_attribute_group_id']);
		}

		$sort_data = array(
			'ad.name',
			'attribute_group',
			'a.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY attribute_group, ad.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getAttributeDescriptions($attribute_id) {
		$attribute_data = array();

		$query = db::query("SELECT * FROM attribute_description WHERE attribute_id = " . (int)$attribute_id);

		foreach ($query->rows as $result) {
			$attribute_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $attribute_data;
	}

	public static function getTotalAttributes() {
		$query = db::query("SELECT COUNT(*) AS total FROM attribute");

		return $query->row['total'];
	}

	public static function getTotalAttributesByAttributeGroupId($attribute_group_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM attribute WHERE attribute_group_id = " . (int)$attribute_group_id);

		return $query->row['total'];
	}
}
