<?php
class admin_catalog_attribute_group {
	public static function addAttributeGroup($data) {
		db::query("INSERT INTO attribute_group SET sort_order = " . (int)$data['sort_order']);

		$attribute_group_id = db::getLastId();

		foreach ($data['attribute_group_description'] as $language_id => $value) {
			db::query("INSERT INTO attribute_group_description SET attribute_group_id = " . (int)$attribute_group_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		return $attribute_group_id;
	}

	public static function editAttributeGroup($attribute_group_id, $data) {
		db::query("UPDATE attribute_group SET sort_order = " . (int)$data['sort_order'] . " WHERE attribute_group_id = " . (int)$attribute_group_id);

		db::query("DELETE FROM attribute_group_description WHERE attribute_group_id = " . (int)$attribute_group_id);

		foreach ($data['attribute_group_description'] as $language_id => $value) {
			db::query("INSERT INTO attribute_group_description SET attribute_group_id = " . (int)$attribute_group_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}
	}

	public static function deleteAttributeGroup($attribute_group_id) {
		db::query("DELETE FROM attribute_group WHERE attribute_group_id = " . (int)$attribute_group_id);
		db::query("DELETE FROM attribute_group_description WHERE attribute_group_id = " . (int)$attribute_group_id);
	}

	public static function getAttributeGroup($attribute_group_id) {
		$query = db::query("SELECT * FROM attribute_group WHERE attribute_group_id = " . (int)$attribute_group_id);

		return $query->row;
	}

	public static function getAttributeGroups($data = array()) {
		$sql = "SELECT * FROM attribute_group ag LEFT JOIN attribute_group_description agd ON (ag.attribute_group_id = agd.attribute_group_id) WHERE agd.language_id = " . config('language_id');

		$sort_data = array(
			'agd.name',
			'ag.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY agd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getAttributeGroupDescriptions($attribute_group_id) {
		$attribute_group_data = array();

		$query = db::query("SELECT * FROM attribute_group_description WHERE attribute_group_id = " . (int)$attribute_group_id);

		foreach ($query->rows as $result) {
			$attribute_group_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $attribute_group_data;
	}

	public static function getTotalAttributeGroups() {
		$query = db::query("SELECT COUNT(*) AS total FROM attribute_group");

		return $query->row['total'];
	}
}