<?php
class admin_catalog_category {
	public static function addCategory($data) {
		db::query("INSERT INTO category SET parent_id = " . (int)$data['parent_id'] . ", `top` = '" . (isset($data['top']) ? (int)$data['top'] : 0) . "', `column` = " . (int)$data['column'] . ", sort_order = " . (int)$data['sort_order'] . ", status = " . (int)$data['status'] . ", date_modified = NOW(), date_added = NOW()");

		$category_id = db::getLastId();

		if (isset($data['image'])) {
			db::query("UPDATE category SET image = " . esc($data['image']) . " WHERE category_id = " . (int)$category_id);
		}

		foreach ($data['category_description'] as $language_id => $value) {
			db::query("INSERT INTO category_description SET category_id = " . (int)$category_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']) . ", description = " . esc($value['description']) . ", meta_title = " . esc($value['meta_title']) . ", meta_description = " . esc($value['meta_description']) . ", meta_keyword = " . esc($value['meta_keyword']));
		}

		// MySQL Hierarchical Data Closure Table Pattern
		$level = 0;

		$query = db::query("SELECT * FROM `category_path` WHERE category_id = " . (int)$data['parent_id'] . " ORDER BY `level` ASC");

		foreach ($query->rows as $result) {
			db::query("INSERT INTO `category_path` SET `category_id` = " . (int)$category_id . ", `path_id` = " . (int)$result['path_id'] . ", `level` = " . (int)$level);

			$level++;
		}

		db::query("INSERT INTO `category_path` SET `category_id` = " . (int)$category_id . ", `path_id` = " . (int)$category_id . ", `level` = " . (int)$level);

		if (isset($data['category_filter'])) {
			foreach ($data['category_filter'] as $filter_id) {
				db::query("INSERT INTO category_filter SET category_id = " . (int)$category_id . ", filter_id = " . (int)$filter_id);
			}
		}

		if (isset($data['category_store'])) {
			foreach ($data['category_store'] as $store_id) {
				db::query("INSERT INTO category_to_store SET category_id = " . (int)$category_id . ", store_id = " . (int)$store_id);
			}
		}
		
		if (isset($data['category_seo_url'])) {
			foreach ($data['category_seo_url'] as $store_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						db::query("INSERT INTO seo_url SET store_id = " . (int)$store_id . ", language_id = " . (int)$language_id . ", query = 'category_id=" . (int)$category_id . "', keyword = " . esc($keyword));
					}
				}
			}
		}
		
		// Set which layout to use with this category
		if (isset($data['category_layout'])) {
			foreach ($data['category_layout'] as $store_id => $layout_id) {
				db::query("INSERT INTO category_to_layout SET category_id = " . (int)$category_id . ", store_id = " . (int)$store_id . ", layout_id = " . (int)$layout_id);
			}
		}

		cache::delete('category');

		return $category_id;
	}

	public static function editCategory($category_id, $data) {
		db::query("UPDATE category SET parent_id = " . (int)$data['parent_id'] . ", `top` = '" . (isset($data['top']) ? (int)$data['top'] : 0) . "', `column` = " . (int)$data['column'] . ", sort_order = " . (int)$data['sort_order'] . ", status = " . (int)$data['status'] . ", date_modified = NOW() WHERE category_id = " . (int)$category_id);

		if (isset($data['image'])) {
			db::query("UPDATE category SET image = " . esc($data['image']) . " WHERE category_id = " . (int)$category_id);
		}

		db::query("DELETE FROM category_description WHERE category_id = " . (int)$category_id);

		foreach ($data['category_description'] as $language_id => $value) {
			db::query("INSERT INTO category_description SET category_id = " . (int)$category_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']) . ", description = " . esc($value['description']) . ", meta_title = " . esc($value['meta_title']) . ", meta_description = " . esc($value['meta_description']) . ", meta_keyword = " . esc($value['meta_keyword']));
		}

		// MySQL Hierarchical Data Closure Table Pattern
		$query = db::query("SELECT * FROM `category_path` WHERE path_id = " . (int)$category_id . " ORDER BY level ASC");

		if ($query->rows) {
			foreach ($query->rows as $category_path) {
				// Delete the path below the current one
				db::query("DELETE FROM `category_path` WHERE category_id = " . (int)$category_path['category_id'] . " AND level < " . (int)$category_path['level']);

				$path = array();

				// Get the nodes new parents
				$query = db::query("SELECT * FROM `category_path` WHERE category_id = " . (int)$data['parent_id'] . " ORDER BY level ASC");

				foreach ($query->rows as $result) {
					$path[] = $result['path_id'];
				}

				// Get whats left of the nodes current path
				$query = db::query("SELECT * FROM `category_path` WHERE category_id = " . (int)$category_path['category_id'] . " ORDER BY level ASC");

				foreach ($query->rows as $result) {
					$path[] = $result['path_id'];
				}

				// Combine the paths with a new level
				$level = 0;

				foreach ($path as $path_id) {
					db::query("REPLACE INTO `category_path` SET category_id = " . (int)$category_path['category_id'] . ", `path_id` = " . (int)$path_id . ", level = " . (int)$level);

					$level++;
				}
			}
		} else {
			// Delete the path below the current one
			db::query("DELETE FROM `category_path` WHERE category_id = " . (int)$category_id);

			// Fix for records with no paths
			$level = 0;

			$query = db::query("SELECT * FROM `category_path` WHERE category_id = " . (int)$data['parent_id'] . " ORDER BY level ASC");

			foreach ($query->rows as $result) {
				db::query("INSERT INTO `category_path` SET category_id = " . (int)$category_id . ", `path_id` = " . (int)$result['path_id'] . ", level = " . (int)$level);

				$level++;
			}

			db::query("REPLACE INTO `category_path` SET category_id = " . (int)$category_id . ", `path_id` = " . (int)$category_id . ", level = " . (int)$level);
		}

		db::query("DELETE FROM category_filter WHERE category_id = " . (int)$category_id);

		if (isset($data['category_filter'])) {
			foreach ($data['category_filter'] as $filter_id) {
				db::query("INSERT INTO category_filter SET category_id = " . (int)$category_id . ", filter_id = " . (int)$filter_id);
			}
		}

		db::query("DELETE FROM category_to_store WHERE category_id = " . (int)$category_id);

		if (isset($data['category_store'])) {
			foreach ($data['category_store'] as $store_id) {
				db::query("INSERT INTO category_to_store SET category_id = " . (int)$category_id . ", store_id = " . (int)$store_id);
			}
		}

		// SEO URL
		db::query("DELETE FROM `seo_url` WHERE query = 'category_id=" . (int)$category_id . "'");

		if (isset($data['category_seo_url'])) {
			foreach ($data['category_seo_url'] as $store_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						db::query("INSERT INTO seo_url SET store_id = " . (int)$store_id . ", language_id = " . (int)$language_id . ", query = 'category_id=" . (int)$category_id . "', keyword = " . esc($keyword));
					}
				}
			}
		}
		
		db::query("DELETE FROM category_to_layout WHERE category_id = " . (int)$category_id);

		if (isset($data['category_layout'])) {
			foreach ($data['category_layout'] as $store_id => $layout_id) {
				db::query("INSERT INTO category_to_layout SET category_id = " . (int)$category_id . ", store_id = " . (int)$store_id . ", layout_id = " . (int)$layout_id);
			}
		}

		cache::delete('category');
	}

	public static function deleteCategory($category_id) {
		db::query("DELETE FROM category_path WHERE category_id = " . (int)$category_id);

		$query = db::query("SELECT * FROM category_path WHERE path_id = " . (int)$category_id);

		foreach ($query->rows as $result) {
			self::deleteCategory($result['category_id']);
		}

		db::query("DELETE FROM category WHERE category_id = " . (int)$category_id);
		db::query("DELETE FROM category_description WHERE category_id = " . (int)$category_id);
		db::query("DELETE FROM category_filter WHERE category_id = " . (int)$category_id);
		db::query("DELETE FROM category_to_store WHERE category_id = " . (int)$category_id);
		db::query("DELETE FROM category_to_layout WHERE category_id = " . (int)$category_id);
		db::query("DELETE FROM product_to_category WHERE category_id = " . (int)$category_id);
		db::query("DELETE FROM seo_url WHERE query = 'category_id=" . (int)$category_id . "'");
		db::query("DELETE FROM coupon_category WHERE category_id = " . (int)$category_id);

		cache::delete('category');
	}

	public static function repairCategories($parent_id = 0) {
		$query = db::query("SELECT * FROM category WHERE parent_id = " . (int)$parent_id);

		foreach ($query->rows as $category) {
			// Delete the path below the current one
			db::query("DELETE FROM `category_path` WHERE category_id = " . (int)$category['category_id']);

			// Fix for records with no paths
			$level = 0;

			$query = db::query("SELECT * FROM `category_path` WHERE category_id = " . (int)$parent_id . " ORDER BY level ASC");

			foreach ($query->rows as $result) {
				db::query("INSERT INTO `category_path` SET category_id = " . (int)$category['category_id'] . ", `path_id` = " . (int)$result['path_id'] . ", level = " . (int)$level);

				$level++;
			}

			db::query("REPLACE INTO `category_path` SET category_id = " . (int)$category['category_id'] . ", `path_id` = " . (int)$category['category_id'] . ", level = " . (int)$level);

			self::repairCategories($category['category_id']);
		}
	}

	public static function getCategory($category_id) {
		$query = db::query("SELECT DISTINCT *, (SELECT GROUP_CONCAT(cd1.name ORDER BY level SEPARATOR '&nbsp;&nbsp;&gt;&nbsp;&nbsp;') FROM category_path cp LEFT JOIN category_description cd1 ON (cp.path_id = cd1.category_id AND cp.category_id != cp.path_id) WHERE cp.category_id = c.category_id AND cd1.language_id = " . config('language_id') . " GROUP BY cp.category_id) AS path FROM category c LEFT JOIN category_description cd2 ON (c.category_id = cd2.category_id) WHERE c.category_id = " . (int)$category_id . " AND cd2.language_id = " . config('language_id'));
		
		return $query->row;
	}

	public static function getCategories($data = array()) {
		$sql = "SELECT cp.category_id AS category_id, GROUP_CONCAT(cd1.name ORDER BY cp.level SEPARATOR '&nbsp;&nbsp;&gt;&nbsp;&nbsp;') AS name, c1.parent_id, c1.sort_order FROM category_path cp LEFT JOIN category c1 ON (cp.category_id = c1.category_id) LEFT JOIN category c2 ON (cp.path_id = c2.category_id) LEFT JOIN category_description cd1 ON (cp.path_id = cd1.category_id) LEFT JOIN category_description cd2 ON (cp.category_id = cd2.category_id) WHERE cd1.language_id = " . config('language_id') . " AND cd2.language_id = " . config('language_id');

		if (!empty($data['filter_name'])) {
			$sql .= " AND cd2.name LIKE '%" . db::escape($data['filter_name']) . "%'";
		}

		$sql .= " GROUP BY cp.category_id";

		$sort_data = array(
			'name',
			'sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY sort_order";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getCategoryDescriptions($category_id) {
		$category_description_data = array();

		$query = db::query("SELECT * FROM category_description WHERE category_id = " . (int)$category_id);

		foreach ($query->rows as $result) {
			$category_description_data[$result['language_id']] = array(
				'name'             => $result['name'],
				'meta_title'       => $result['meta_title'],
				'meta_description' => $result['meta_description'],
				'meta_keyword'     => $result['meta_keyword'],
				'description'      => $result['description']
			);
		}

		return $category_description_data;
	}
	
	public static function getCategoryPath($category_id) {
		$query = db::query("SELECT category_id, path_id, level FROM category_path WHERE category_id = " . (int)$category_id);

		return $query->rows;
	}
	
	public static function getCategoryFilters($category_id) {
		$category_filter_data = array();

		$query = db::query("SELECT * FROM category_filter WHERE category_id = " . (int)$category_id);

		foreach ($query->rows as $result) {
			$category_filter_data[] = $result['filter_id'];
		}

		return $category_filter_data;
	}

	public static function getCategoryStores($category_id) {
		$category_store_data = array();

		$query = db::query("SELECT * FROM category_to_store WHERE category_id = " . (int)$category_id);

		foreach ($query->rows as $result) {
			$category_store_data[] = $result['store_id'];
		}

		return $category_store_data;
	}
	
	public static function getCategorySeoUrls($category_id) {
		$category_seo_url_data = array();
		
		$query = db::query("SELECT * FROM seo_url WHERE query = 'category_id=" . (int)$category_id . "'");

		foreach ($query->rows as $result) {
			$category_seo_url_data[$result['store_id']][$result['language_id']] = $result['keyword'];
		}

		return $category_seo_url_data;
	}
	
	public static function getCategoryLayouts($category_id) {
		$category_layout_data = array();

		$query = db::query("SELECT * FROM category_to_layout WHERE category_id = " . (int)$category_id);

		foreach ($query->rows as $result) {
			$category_layout_data[$result['store_id']] = $result['layout_id'];
		}

		return $category_layout_data;
	}

	public static function getTotalCategories() {
		$query = db::query("SELECT COUNT(*) AS total FROM category");

		return $query->row['total'];
	}
	
	public static function getTotalCategoriesByLayoutId($layout_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM category_to_layout WHERE layout_id = " . (int)$layout_id);

		return $query->row['total'];
	}	
}