<?php
class admin_catalog_download {
	public static function addDownload($data) {
		db::query("INSERT INTO download SET filename = " . esc($data['filename']) . ", mask = " . esc($data['mask']) . ", date_added = NOW()");

		$download_id = db::getLastId();

		foreach ($data['download_description'] as $language_id => $value) {
			db::query("INSERT INTO download_description SET download_id = " . (int)$download_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		return $download_id;
	}

	public static function editDownload($download_id, $data) {
		db::query("UPDATE download SET filename = " . esc($data['filename']) . ", mask = " . esc($data['mask']) . " WHERE download_id = " . (int)$download_id);

		db::query("DELETE FROM download_description WHERE download_id = " . (int)$download_id);

		foreach ($data['download_description'] as $language_id => $value) {
			db::query("INSERT INTO download_description SET download_id = " . (int)$download_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}
	}

	public static function deleteDownload($download_id) {
		db::query("DELETE FROM download WHERE download_id = " . (int)$download_id);
		db::query("DELETE FROM download_description WHERE download_id = " . (int)$download_id);
	}

	public static function getDownload($download_id) {
		$query = db::query("SELECT DISTINCT * FROM download d LEFT JOIN download_description dd ON (d.download_id = dd.download_id) WHERE d.download_id = " . (int)$download_id . " AND dd.language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getDownloads($data = array()) {
		$sql = "SELECT * FROM download d LEFT JOIN download_description dd ON (d.download_id = dd.download_id) WHERE dd.language_id = " . config('language_id');

		if (!empty($data['filter_name'])) {
			$sql .= " AND dd.name LIKE '" . db::escape($data['filter_name']) . "%'";
		}

		$sort_data = array(
			'dd.name',
			'd.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY dd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getDownloadDescriptions($download_id) {
		$download_description_data = array();

		$query = db::query("SELECT * FROM download_description WHERE download_id = " . (int)$download_id);

		foreach ($query->rows as $result) {
			$download_description_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $download_description_data;
	}

	public static function getTotalDownloads() {
		$query = db::query("SELECT COUNT(*) AS total FROM download");

		return $query->row['total'];
	}
}