<?php
class admin_catalog_information {
	public static function addInformation($data) {
		db::query("INSERT INTO information SET sort_order = " . (int)$data['sort_order'] . ", bottom = '" . (isset($data['bottom']) ? (int)$data['bottom'] : 0) . "', status = " . (int)$data['status']);

		$information_id = db::getLastId();

		foreach ($data['information_description'] as $language_id => $value) {
			db::query("INSERT INTO information_description SET information_id = " . (int)$information_id . ", language_id = " . (int)$language_id . ", title = " . esc($value['title']) . ", description = " . esc($value['description']) . ", meta_title = " . esc($value['meta_title']) . ", meta_description = " . esc($value['meta_description']) . ", meta_keyword = " . esc($value['meta_keyword']));
		}

		if (isset($data['information_store'])) {
			foreach ($data['information_store'] as $store_id) {
				db::query("INSERT INTO information_to_store SET information_id = " . (int)$information_id . ", store_id = " . (int)$store_id);
			}
		}

		// SEO URL
		if (isset($data['information_seo_url'])) {
			foreach ($data['information_seo_url'] as $store_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						db::query("INSERT INTO seo_url SET store_id = " . (int)$store_id . ", language_id = " . (int)$language_id . ", query = 'information_id=" . (int)$information_id . "', keyword = " . esc($keyword));
					}
				}
			}
		}
		
		if (isset($data['information_layout'])) {
			foreach ($data['information_layout'] as $store_id => $layout_id) {
				db::query("INSERT INTO information_to_layout SET information_id = " . (int)$information_id . ", store_id = " . (int)$store_id . ", layout_id = " . (int)$layout_id);
			}
		}

		cache::delete('information');

		return $information_id;
	}

	public static function editInformation($information_id, $data) {
		db::query("UPDATE information SET sort_order = " . (int)$data['sort_order'] . ", bottom = '" . (isset($data['bottom']) ? (int)$data['bottom'] : 0) . "', status = " . (int)$data['status'] . " WHERE information_id = " . (int)$information_id);

		db::query("DELETE FROM information_description WHERE information_id = " . (int)$information_id);

		foreach ($data['information_description'] as $language_id => $value) {
			db::query("INSERT INTO information_description SET information_id = " . (int)$information_id . ", language_id = " . (int)$language_id . ", title = " . esc($value['title']) . ", description = " . esc($value['description']) . ", meta_title = " . esc($value['meta_title']) . ", meta_description = " . esc($value['meta_description']) . ", meta_keyword = " . esc($value['meta_keyword']));
		}

		db::query("DELETE FROM information_to_store WHERE information_id = " . (int)$information_id);

		if (isset($data['information_store'])) {
			foreach ($data['information_store'] as $store_id) {
				db::query("INSERT INTO information_to_store SET information_id = " . (int)$information_id . ", store_id = " . (int)$store_id);
			}
		}

		db::query("DELETE FROM seo_url WHERE query = 'information_id=" . (int)$information_id . "'");

		if (isset($data['information_seo_url'])) {
			foreach ($data['information_seo_url'] as $store_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (trim($keyword)) {
						db::query("INSERT INTO `seo_url` SET store_id = " . (int)$store_id . ", language_id = " . (int)$language_id . ", query = 'information_id=" . (int)$information_id . "', keyword = " . esc($keyword));
					}
				}
			}
		}

		db::query("DELETE FROM `information_to_layout` WHERE information_id = " . (int)$information_id);

		if (isset($data['information_layout'])) {
			foreach ($data['information_layout'] as $store_id => $layout_id) {
				db::query("INSERT INTO `information_to_layout` SET information_id = " . (int)$information_id . ", store_id = " . (int)$store_id . ", layout_id = " . (int)$layout_id);
			}
		}

		cache::delete('information');
	}

	public static function deleteInformation($information_id) {
		db::query("DELETE FROM `information` WHERE information_id = " . (int)$information_id);
		db::query("DELETE FROM `information_description` WHERE information_id = " . (int)$information_id);
		db::query("DELETE FROM `information_to_store` WHERE information_id = " . (int)$information_id);
		db::query("DELETE FROM `information_to_layout` WHERE information_id = " . (int)$information_id);
		db::query("DELETE FROM `seo_url` WHERE query = 'information_id=" . (int)$information_id . "'");

		cache::delete('information');
	}

	public static function getInformation($information_id) {
		$query = db::query("SELECT DISTINCT * FROM information WHERE information_id = " . (int)$information_id);

		return $query->row;
	}

	public static function getInformations($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM information i LEFT JOIN information_description id ON (i.information_id = id.information_id) WHERE id.language_id = " . config('language_id');

			$sort_data = array(
				'id.title',
				'i.sort_order'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY id.title";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$information_data = cache::get('information.' . config('language_id'));

			if (!$information_data) {
				$query = db::query("SELECT * FROM information i LEFT JOIN information_description id ON (i.information_id = id.information_id) WHERE id.language_id = " . config('language_id') . " ORDER BY id.title");

				$information_data = $query->rows;

				cache::set('information.' . config('language_id'), $information_data);
			}

			return $information_data;
		}
	}

	public static function getInformationDescriptions($information_id) {
		$information_description_data = array();

		$query = db::query("SELECT * FROM information_description WHERE information_id = " . (int)$information_id);

		foreach ($query->rows as $result) {
			$information_description_data[$result['language_id']] = array(
				'title'            => $result['title'],
				'description'      => $result['description'],
				'meta_title'       => $result['meta_title'],
				'meta_description' => $result['meta_description'],
				'meta_keyword'     => $result['meta_keyword']
			);
		}

		return $information_description_data;
	}

	public static function getInformationStores($information_id) {
		$information_store_data = array();

		$query = db::query("SELECT * FROM information_to_store WHERE information_id = " . (int)$information_id);

		foreach ($query->rows as $result) {
			$information_store_data[] = $result['store_id'];
		}

		return $information_store_data;
	}

	public static function getInformationSeoUrls($information_id) {
		$information_seo_url_data = array();
		
		$query = db::query("SELECT * FROM seo_url WHERE query = 'information_id=" . (int)$information_id . "'");

		foreach ($query->rows as $result) {
			$information_seo_url_data[$result['store_id']][$result['language_id']] = $result['keyword'];
		}

		return $information_seo_url_data;
	}

	public static function getInformationLayouts($information_id) {
		$information_layout_data = array();

		$query = db::query("SELECT * FROM information_to_layout WHERE information_id = " . (int)$information_id);

		foreach ($query->rows as $result) {
			$information_layout_data[$result['store_id']] = $result['layout_id'];
		}

		return $information_layout_data;
	}

	public static function getTotalInformations() {
		$query = db::query("SELECT COUNT(*) AS total FROM information");

		return $query->row['total'];
	}

	public static function getTotalInformationsByLayoutId($layout_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM information_to_layout WHERE layout_id = " . (int)$layout_id);

		return $query->row['total'];
	}
}