<?php
class admin_catalog_manufacturer {
	public static function addManufacturer($data) {
		db::query("INSERT INTO manufacturer SET name = " . esc($data['name']) . ", sort_order = " . (int)$data['sort_order']);

		$manufacturer_id = db::getLastId();

		if (isset($data['image'])) {
			db::query("UPDATE manufacturer SET image = " . esc($data['image']) . " WHERE manufacturer_id = " . (int)$manufacturer_id);
		}

		if (isset($data['manufacturer_store'])) {
			foreach ($data['manufacturer_store'] as $store_id) {
				db::query("INSERT INTO manufacturer_to_store SET manufacturer_id = " . (int)$manufacturer_id . ", store_id = " . (int)$store_id);
			}
		}
				
		// SEO URL
		if (isset($data['manufacturer_seo_url'])) {
			foreach ($data['manufacturer_seo_url'] as $store_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						db::query("INSERT INTO seo_url SET store_id = " . (int)$store_id . ", language_id = " . (int)$language_id . ", query = 'manufacturer_id=" . (int)$manufacturer_id . "', keyword = " . esc($keyword));
					}
				}
			}
		}
		
		cache::delete('manufacturer');

		return $manufacturer_id;
	}

	public static function editManufacturer($manufacturer_id, $data) {
		db::query("UPDATE manufacturer SET name = " . esc($data['name']) . ", sort_order = " . (int)$data['sort_order'] . " WHERE manufacturer_id = " . (int)$manufacturer_id);

		if (isset($data['image'])) {
			db::query("UPDATE manufacturer SET image = " . esc($data['image']) . " WHERE manufacturer_id = " . (int)$manufacturer_id);
		}

		db::query("DELETE FROM manufacturer_to_store WHERE manufacturer_id = " . (int)$manufacturer_id);

		if (isset($data['manufacturer_store'])) {
			foreach ($data['manufacturer_store'] as $store_id) {
				db::query("INSERT INTO manufacturer_to_store SET manufacturer_id = " . (int)$manufacturer_id . ", store_id = " . (int)$store_id);
			}
		}

		db::query("DELETE FROM `seo_url` WHERE query = 'manufacturer_id=" . (int)$manufacturer_id . "'");

		if (isset($data['manufacturer_seo_url'])) {
			foreach ($data['manufacturer_seo_url'] as $store_id => $language) {
				foreach ($language as $language_id => $keyword) {
					if (!empty($keyword)) {
						db::query("INSERT INTO `seo_url` SET store_id = " . (int)$store_id . ", language_id = " . (int)$language_id . ", query = 'manufacturer_id=" . (int)$manufacturer_id . "', keyword = " . esc($keyword));
					}
				}
			}
		}

		cache::delete('manufacturer');
	}

	public static function deleteManufacturer($manufacturer_id) {
		db::query("DELETE FROM `manufacturer` WHERE manufacturer_id = " . (int)$manufacturer_id);
		db::query("DELETE FROM `manufacturer_to_store` WHERE manufacturer_id = " . (int)$manufacturer_id);
		db::query("DELETE FROM `seo_url` WHERE query = 'manufacturer_id=" . (int)$manufacturer_id . "'");

		cache::delete('manufacturer');
	}

	public static function getManufacturer($manufacturer_id) {
		$query = db::query("SELECT DISTINCT * FROM manufacturer WHERE manufacturer_id = " . (int)$manufacturer_id);

		return $query->row;
	}

	public static function getManufacturers($data = array()) {
		$sql = "SELECT * FROM manufacturer";

		if (!empty($data['filter_name'])) {
			$sql .= " WHERE name LIKE '" . db::escape($data['filter_name']) . "%'";
		}

		$sort_data = array(
			'name',
			'sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getManufacturerStores($manufacturer_id) {
		$manufacturer_store_data = array();

		$query = db::query("SELECT * FROM manufacturer_to_store WHERE manufacturer_id = " . (int)$manufacturer_id);

		foreach ($query->rows as $result) {
			$manufacturer_store_data[] = $result['store_id'];
		}

		return $manufacturer_store_data;
	}
	
	public static function getManufacturerSeoUrls($manufacturer_id) {
		$manufacturer_seo_url_data = array();
		
		$query = db::query("SELECT * FROM seo_url WHERE query = 'manufacturer_id=" . (int)$manufacturer_id . "'");

		foreach ($query->rows as $result) {
			$manufacturer_seo_url_data[$result['store_id']][$result['language_id']] = $result['keyword'];
		}

		return $manufacturer_seo_url_data;
	}
	
	public static function getTotalManufacturers() {
		$query = db::query("SELECT COUNT(*) AS total FROM manufacturer");

		return $query->row['total'];
	}
}
