<?php
class admin_catalog_option {
	public static function addOption($data) {
		db::query("INSERT INTO `option` SET type = " . esc($data['type']) . ", sort_order = " . (int)$data['sort_order']);

		$option_id = db::getLastId();

		foreach ($data['option_description'] as $language_id => $value) {
			db::query("INSERT INTO option_description SET option_id = " . (int)$option_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		if (isset($data['option_value'])) {
			foreach ($data['option_value'] as $option_value) {
				db::query("INSERT INTO option_value SET option_id = " . (int)$option_id . ", image = " . esc(html_entity_decode($option_value['image'], ENT_QUOTES, 'UTF-8')) . ", sort_order = " . (int)$option_value['sort_order']);

				$option_value_id = db::getLastId();

				foreach ($option_value['option_value_description'] as $language_id => $option_value_description) {
					db::query("INSERT INTO option_value_description SET option_value_id = " . (int)$option_value_id . ", language_id = " . (int)$language_id . ", option_id = " . (int)$option_id . ", name = " . esc($option_value_description['name']));
				}
			}
		}

		return $option_id;
	}

	public static function editOption($option_id, $data) {
		db::query("UPDATE `option` SET type = " . esc($data['type']) . ", sort_order = " . (int)$data['sort_order'] . " WHERE option_id = " . (int)$option_id);

		db::query("DELETE FROM option_description WHERE option_id = " . (int)$option_id);

		foreach ($data['option_description'] as $language_id => $value) {
			db::query("INSERT INTO option_description SET option_id = " . (int)$option_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		db::query("DELETE FROM option_value WHERE option_id = " . (int)$option_id);
		db::query("DELETE FROM option_value_description WHERE option_id = " . (int)$option_id);

		if (isset($data['option_value'])) {
			foreach ($data['option_value'] as $option_value) {
				if ($option_value['option_value_id']) {
					db::query("INSERT INTO option_value SET option_value_id = " . (int)$option_value['option_value_id'] . ", option_id = " . (int)$option_id . ", image = " . esc(html_entity_decode($option_value['image'], ENT_QUOTES, 'UTF-8')) . ", sort_order = " . (int)$option_value['sort_order']);
				} else {
					db::query("INSERT INTO option_value SET option_id = " . (int)$option_id . ", image = " . esc(html_entity_decode($option_value['image'], ENT_QUOTES, 'UTF-8')) . ", sort_order = " . (int)$option_value['sort_order']);
				}

				$option_value_id = db::getLastId();

				foreach ($option_value['option_value_description'] as $language_id => $option_value_description) {
					db::query("INSERT INTO option_value_description SET option_value_id = " . (int)$option_value_id . ", language_id = " . (int)$language_id . ", option_id = " . (int)$option_id . ", name = " . esc($option_value_description['name']));
				}
			}

		}
	}

	public static function deleteOption($option_id) {
		db::query("DELETE FROM `option` WHERE option_id = " . (int)$option_id);
		db::query("DELETE FROM option_description WHERE option_id = " . (int)$option_id);
		db::query("DELETE FROM option_value WHERE option_id = " . (int)$option_id);
		db::query("DELETE FROM option_value_description WHERE option_id = " . (int)$option_id);
	}

	public static function getOption($option_id) {
		$query = db::query("SELECT * FROM `option` o LEFT JOIN option_description od ON (o.option_id = od.option_id) WHERE o.option_id = " . (int)$option_id . " AND od.language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getOptions($data = array()) {
		$sql = "SELECT * FROM `option` o LEFT JOIN option_description od ON (o.option_id = od.option_id) WHERE od.language_id = " . config('language_id');

		if (!empty($data['filter_name'])) {
			$sql .= " AND od.name LIKE '" . db::escape($data['filter_name']) . "%'";
		}

		$sort_data = array(
			'od.name',
			'o.type',
			'o.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY od.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getOptionDescriptions($option_id) {
		$option_data = array();

		$query = db::query("SELECT * FROM option_description WHERE option_id = " . (int)$option_id);

		foreach ($query->rows as $result) {
			$option_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $option_data;
	}

	public static function getOptionValue($option_value_id) {
		$query = db::query("SELECT * FROM option_value ov LEFT JOIN option_value_description ovd ON (ov.option_value_id = ovd.option_value_id) WHERE ov.option_value_id = " . (int)$option_value_id . " AND ovd.language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getOptionValues($option_id) {
		$option_value_data = array();

		$option_value_query = db::query("SELECT * FROM option_value ov LEFT JOIN option_value_description ovd ON (ov.option_value_id = ovd.option_value_id) WHERE ov.option_id = " . (int)$option_id . " AND ovd.language_id = " . config('language_id') . " ORDER BY ov.sort_order, ovd.name");

		foreach ($option_value_query->rows as $option_value) {
			$option_value_data[] = array(
				'option_value_id' => $option_value['option_value_id'],
				'name'            => $option_value['name'],
				'image'           => $option_value['image'],
				'sort_order'      => $option_value['sort_order']
			);
		}

		return $option_value_data;
	}

	public static function getOptionValueDescriptions($option_id) {
		$option_value_data = array();

		$option_value_query = db::query("SELECT * FROM option_value WHERE option_id = " . (int)$option_id . " ORDER BY sort_order");

		foreach ($option_value_query->rows as $option_value) {
			$option_value_description_data = array();

			$option_value_description_query = db::query("SELECT * FROM option_value_description WHERE option_value_id = " . (int)$option_value['option_value_id']);

			foreach ($option_value_description_query->rows as $option_value_description) {
				$option_value_description_data[$option_value_description['language_id']] = array('name' => $option_value_description['name']);
			}

			$option_value_data[] = array(
				'option_value_id'          => $option_value['option_value_id'],
				'option_value_description' => $option_value_description_data,
				'image'                    => $option_value['image'],
				'sort_order'               => $option_value['sort_order']
			);
		}

		return $option_value_data;
	}

	public static function getTotalOptions() {
		$query = db::query("SELECT COUNT(*) AS total FROM `option`");

		return $query->row['total'];
	}
}