<?php
class admin_catalog_recurring {
	public static function addRecurring($data) {
		db::query("INSERT INTO `recurring` SET `sort_order` = " . (int)$data['sort_order'] . ", `status` = " . (int)$data['status'] . ", `price` = " . (float)$data['price'] . ", `frequency` = " . esc($data['frequency']) . ", `duration` = " . (int)$data['duration'] . ", `cycle` = " . (int)$data['cycle'] . ", `trial_status` = " . (int)$data['trial_status'] . ", `trial_price` = " . (float)$data['trial_price'] . ", `trial_frequency` = " . esc($data['trial_frequency']) . ", `trial_duration` = " . (int)$data['trial_duration'] . ", `trial_cycle` = " . (int)$data['trial_cycle']);

		$recurring_id = db::getLastId();

		foreach ($data['recurring_description'] as $language_id => $recurring_description) {
			db::query("INSERT INTO `recurring_description` (`recurring_id`, `language_id`, `name`) VALUES (" . (int)$recurring_id . ", " . (int)$language_id . ", " . esc($recurring_description['name']) . ")");
		}

		return $recurring_id;
	}

	public static function editRecurring($recurring_id, $data) {
		db::query("DELETE FROM `recurring_description` WHERE recurring_id = " . (int)$recurring_id);

		db::query("UPDATE `recurring` SET `price` = '" . (float)$data['price'] . "', `frequency` = " . esc($data['frequency']) . ", `duration` = " . (int)$data['duration'] . ", `cycle` = " . (int)$data['cycle'] . ", `sort_order` = " . (int)$data['sort_order'] . ", `status` = " . (int)$data['status'] . ", `trial_price` = '" . (float)$data['trial_price'] . "', `trial_frequency` = " . esc($data['trial_frequency']) . ", `trial_duration` = " . (int)$data['trial_duration'] . ", `trial_cycle` = " . (int)$data['trial_cycle'] . ", `trial_status` = " . (int)$data['trial_status'] . " WHERE recurring_id = " . (int)$recurring_id);

		foreach ($data['recurring_description'] as $language_id => $recurring_description) {
			db::query("INSERT INTO `recurring_description` (`recurring_id`, `language_id`, `name`) VALUES (" . (int)$recurring_id . ", " . (int)$language_id . ", " . esc($recurring_description['name']) . ")");
		}
	}

	public static function copyRecurring($recurring_id) {
		$data = self::getRecurring($recurring_id);

		$data['recurring_description'] = self::getRecurringDescription($recurring_id);

		foreach ($data['recurring_description'] as &$recurring_description) {
			$recurring_description['name'] .= ' - 2';
		}

		self::addRecurring($data);
	}

	public static function deleteRecurring($recurring_id) {
		db::query("DELETE FROM `recurring` WHERE recurring_id = " . (int)$recurring_id);
		db::query("DELETE FROM `recurring_description` WHERE recurring_id = " . (int)$recurring_id);
		db::query("DELETE FROM `product_recurring` WHERE recurring_id = " . (int)$recurring_id);
		db::query("UPDATE `order_recurring` SET `recurring_id` = 0 WHERE `recurring_id` = " . (int)$recurring_id);
	}

	public static function getRecurring($recurring_id) {
		$query = db::query("SELECT * FROM `recurring` WHERE recurring_id = " . (int)$recurring_id);

		return $query->row;
	}

	public static function getRecurringDescription($recurring_id) {
		$recurring_description_data = array();

		$query = db::query("SELECT * FROM `recurring_description` WHERE `recurring_id` = " . (int)$recurring_id);

		foreach ($query->rows as $result) {
			$recurring_description_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $recurring_description_data;
	}

	public static function getRecurrings($data = array()) {
		$sql = "SELECT * FROM `recurring` r LEFT JOIN recurring_description rd ON (r.recurring_id = rd.recurring_id) WHERE rd.language_id = " . config('language_id');

		if (!empty($data['filter_name'])) {
			$sql .= " AND rd.name LIKE '" . db::escape($data['filter_name']) . "%'";
		}

		$sort_data = array(
			'rd.name',
			'r.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY rd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalRecurrings() {
		$query = db::query("SELECT COUNT(*) AS total FROM `recurring`");

		return $query->row['total'];
	}
}