<?php
class admin_catalog_review {
	public static function addReview($data) {
		db::query("INSERT INTO review SET author = " . esc($data['author']) . ", product_id = " . (int)$data['product_id'] . ", text = " . esc(strip_tags($data['text'])) . ", rating = " . (int)$data['rating'] . ", status = " . (int)$data['status'] . ", date_added = " . esc($data['date_added']));

		$review_id = db::getLastId();

		cache::delete('product');

		return $review_id;
	}

	public static function editReview($review_id, $data) {
		db::query("UPDATE review SET author = " . esc($data['author']) . ", product_id = " . (int)$data['product_id'] . ", text = " . esc(strip_tags($data['text'])) . ", rating = " . (int)$data['rating'] . ", status = " . (int)$data['status'] . ", date_added = " . esc($data['date_added']) . ", date_modified = NOW() WHERE review_id = " . (int)$review_id);

		cache::delete('product');
	}

	public static function deleteReview($review_id) {
		db::query("DELETE FROM review WHERE review_id = " . (int)$review_id);

		cache::delete('product');
	}

	public static function getReview($review_id) {
		$query = db::query("SELECT DISTINCT *, (SELECT pd.name FROM product_description pd WHERE pd.product_id = r.product_id AND pd.language_id = " . config('language_id') . ") AS product FROM review r WHERE r.review_id = " . (int)$review_id);

		return $query->row;
	}

	public static function getReviews($data = array()) {
		$sql = "SELECT r.review_id, pd.name, r.author, r.rating, r.status, r.date_added FROM review r LEFT JOIN product_description pd ON (r.product_id = pd.product_id) WHERE pd.language_id = " . config('language_id');

		if (!empty($data['filter_product'])) {
			$sql .= " AND pd.name LIKE '" . db::escape($data['filter_product']) . "%'";
		}

		if (!empty($data['filter_author'])) {
			$sql .= " AND r.author LIKE '" . db::escape($data['filter_author']) . "%'";
		}

		if (isset($data['filter_status']) && $data['filter_status'] !== '') {
			$sql .= " AND r.status = " . (int)$data['filter_status'];
		}

		if (!empty($data['filter_date_added'])) {
			$sql .= " AND DATE(r.date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		$sort_data = array(
			'pd.name',
			'r.author',
			'r.rating',
			'r.status',
			'r.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY r.date_added";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalReviews($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM review r LEFT JOIN product_description pd ON (r.product_id = pd.product_id) WHERE pd.language_id = " . config('language_id');

		if (!empty($data['filter_product'])) {
			$sql .= " AND pd.name LIKE '" . db::escape($data['filter_product']) . "%'";
		}

		if (!empty($data['filter_author'])) {
			$sql .= " AND r.author LIKE '" . db::escape($data['filter_author']) . "%'";
		}

		if (isset($data['filter_status']) && $data['filter_status'] !== '') {
			$sql .= " AND r.status = " . (int)$data['filter_status'];
		}

		if (!empty($data['filter_date_added'])) {
			$sql .= " AND DATE(r.date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		$query = db::query($sql);

		return $query->row['total'];
	}

	public static function getTotalReviewsAwaitingApproval() {
		$query = db::query("SELECT COUNT(*) AS total FROM review WHERE status = '0'");

		return $query->row['total'];
	}
}