<?php
class admin_customer_customer {
	public static function addCustomer($data) {
		db::query("INSERT INTO customer SET customer_group_id = " . (int)$data['customer_group_id'] . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", custom_field = " . esc(isset($data['custom_field']) ? json_encode($data['custom_field']) : json_encode(array())) . ", newsletter = " . (int)$data['newsletter'] . ", salt = " . esc($salt = token(9)) . ", password = " . esc(sha1($salt . sha1($salt . sha1($data['password'])))) . ", status = " . (int)$data['status'] . ", safe = " . (int)$data['safe'] . ", date_added = NOW()");

		$customer_id = db::getLastId();

		if (isset($data['address'])) {
			foreach ($data['address'] as $address) {
				db::query("INSERT INTO address SET customer_id = " . (int)$customer_id . ", firstname = " . esc($address['firstname']) . ", lastname = " . esc($address['lastname']) . ", company = " . esc($address['company']) . ", address_1 = " . esc($address['address_1']) . ", address_2 = " . esc($address['address_2']) . ", city = " . esc($address['city']) . ", postcode = " . esc($address['postcode']) . ", country_id = " . (int)$address['country_id'] . ", zone_id = " . (int)$address['zone_id'] . ", custom_field = " . esc(isset($address['custom_field']) ? json_encode($address['custom_field']) : json_encode(array())));

				if (isset($address['default'])) {
					$address_id = db::getLastId();

					db::query("UPDATE customer SET address_id = " . (int)$address_id . " WHERE customer_id = " . (int)$customer_id);
				}
			}
		}
		
		if ($data['affiliate']) {
			db::query("INSERT INTO customer_affiliate SET customer_id = " . (int)$customer_id . ", company = " . esc($data['company']) . ", website = " . esc($data['website']) . ", tracking = " . esc($data['tracking']) . ", commission = '" . (float)$data['commission'] . "', tax = " . esc($data['tax']) . ", payment = " . esc($data['payment']) . ", cheque = " . esc($data['cheque']) . ", paypal = " . esc($data['paypal']) . ", bank_name = " . esc($data['bank_name']) . ", bank_branch_number = " . esc($data['bank_branch_number']) . ", bank_swift_code = " . esc($data['bank_swift_code']) . ", bank_account_name = " . esc($data['bank_account_name']) . ", bank_account_number = " . esc($data['bank_account_number']) . ", custom_field = " . esc(isset($data['custom_field']['affiliate']) ? json_encode($data['custom_field']['affiliate']) : json_encode(array())) . ", status = " . (int)$data['affiliate'] . ", date_added = NOW()");
		}
		
		return $customer_id;
	}

	public static function editCustomer($customer_id, $data) {
		db::query("UPDATE customer SET customer_group_id = " . (int)$data['customer_group_id'] . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", custom_field = " . esc(isset($data['custom_field']) ? json_encode($data['custom_field']) : json_encode(array())) . ", newsletter = " . (int)$data['newsletter'] . ", status = " . (int)$data['status'] . ", safe = " . (int)$data['safe'] . " WHERE customer_id = " . (int)$customer_id);

		if ($data['password']) {
			db::query("UPDATE customer SET salt = " . esc($salt = token(9)) . ", password = " . esc(sha1($salt . sha1($salt . sha1($data['password'])))) . " WHERE customer_id = " . (int)$customer_id);
		}

		db::query("DELETE FROM address WHERE customer_id = " . (int)$customer_id);

		if (isset($data['address'])) {
			foreach ($data['address'] as $address) {
				db::query("INSERT INTO address SET address_id = " . (int)$address['address_id'] . ", customer_id = " . (int)$customer_id . ", firstname = " . esc($address['firstname']) . ", lastname = " . esc($address['lastname']) . ", company = " . esc($address['company']) . ", address_1 = " . esc($address['address_1']) . ", address_2 = " . esc($address['address_2']) . ", city = " . esc($address['city']) . ", postcode = " . esc($address['postcode']) . ", country_id = " . (int)$address['country_id'] . ", zone_id = " . (int)$address['zone_id'] . ", custom_field = " . esc(isset($address['custom_field']) ? json_encode($address['custom_field']) : json_encode(array())));

				if (isset($address['default'])) {
					$address_id = db::getLastId();

					db::query("UPDATE customer SET address_id = " . (int)$address_id . " WHERE customer_id = " . (int)$customer_id);
				}
			}
		}
		
		if ($data['affiliate']) {
			db::query("REPLACE INTO customer_affiliate SET customer_id = " . (int)$customer_id . ", company = " . esc($data['company']) . ", website = " . esc($data['website']) . ", tracking = " . esc($data['tracking']) . ", commission = '" . (float)$data['commission'] . "', tax = " . esc($data['tax']) . ", payment = " . esc($data['payment']) . ", cheque = " . esc($data['cheque']) . ", paypal = " . esc($data['paypal']) . ", bank_name = " . esc($data['bank_name']) . ", bank_branch_number = " . esc($data['bank_branch_number']) . ", bank_swift_code = " . esc($data['bank_swift_code']) . ", bank_account_name = " . esc($data['bank_account_name']) . ", bank_account_number = " . esc($data['bank_account_number']) . ", custom_field = " . esc(isset($data['custom_field']['affiliate']) ? json_encode($data['custom_field']['affiliate']) : json_encode(array())) . ", status = " . (int)$data['affiliate'] . ", date_added = NOW()");
		}		
	}

	public static function editToken($customer_id, $token) {
		db::query("UPDATE customer SET token = " . esc($token) . " WHERE customer_id = " . (int)$customer_id);
	}

	public static function deleteCustomer($customer_id) {
		db::query("DELETE FROM customer WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM customer_activity WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM customer_affiliate WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM customer_approval WHERE customer_id = " . (int)$customer_id);
 		db::query("DELETE FROM customer_history WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM customer_reward WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM customer_transaction WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM customer_ip WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM address WHERE customer_id = " . (int)$customer_id);
	}

	public static function getCustomer($customer_id) {
		$query = db::query("SELECT DISTINCT * FROM customer WHERE customer_id = " . (int)$customer_id);

		return $query->row;
	}

	public static function getCustomerByEmail($email) {
		$query = db::query("SELECT DISTINCT * FROM customer WHERE LCASE(email) = " . esc(utf8_strtolower($email)));

		return $query->row;
	}
	
	public static function getCustomers($data = array()) {
		$sql = "SELECT *, CONCAT(c.firstname, ' ', c.lastname) AS name, cgd.name AS customer_group FROM customer c LEFT JOIN customer_group_description cgd ON (c.customer_group_id = cgd.customer_group_id)";
		
		if (!empty($data['filter_affiliate'])) {
			$sql .= " LEFT JOIN customer_affiliate ca ON (c.customer_id = ca.customer_id)";
		}		
		
		$sql .= " WHERE cgd.language_id = " . config('language_id');
		
		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "CONCAT(c.firstname, ' ', c.lastname) LIKE '%" . db::escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_email'])) {
			$implode[] = "c.email LIKE '" . db::escape($data['filter_email']) . "%'";
		}

		if (isset($data['filter_newsletter']) && !is_null($data['filter_newsletter'])) {
			$implode[] = "c.newsletter = " . (int)$data['filter_newsletter'];
		}

		if (!empty($data['filter_customer_group_id'])) {
			$implode[] = "c.customer_group_id = " . (int)$data['filter_customer_group_id'];
		}

		if (!empty($data['filter_affiliate'])) {
			$implode[] = "ca.status = " . (int)$data['filter_affiliate'];
		}
		
		if (!empty($data['filter_ip'])) {
			$implode[] = "c.customer_id IN (SELECT customer_id FROM customer_ip WHERE ip = " . esc($data['filter_ip']) . ")";
		}

		if (isset($data['filter_status']) && $data['filter_status'] !== '') {
			$implode[] = "c.status = " . (int)$data['filter_status'];
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(c.date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " AND " . implode(" AND ", $implode);
		}

		$sort_data = array(
			'name',
			'c.email',
			'customer_group',
			'c.status',
			'c.ip',
			'c.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getAddress($address_id) {
		$address_query = db::query("SELECT * FROM address WHERE address_id = " . (int)$address_id);

		if ($address_query->num_rows) {
			$country_query = db::query("SELECT * FROM `country` WHERE country_id = " . (int)$address_query->row['country_id']);

			if ($country_query->num_rows) {
				$country = $country_query->row['name'];
				$iso_code_2 = $country_query->row['iso_code_2'];
				$iso_code_3 = $country_query->row['iso_code_3'];
				$address_format = $country_query->row['address_format'];
			} else {
				$country = '';
				$iso_code_2 = '';
				$iso_code_3 = '';
				$address_format = '';
			}

			$zone_query = db::query("SELECT * FROM `zone` WHERE zone_id = " . (int)$address_query->row['zone_id']);

			if ($zone_query->num_rows) {
				$zone = $zone_query->row['name'];
				$zone_code = $zone_query->row['code'];
			} else {
				$zone = '';
				$zone_code = '';
			}

			return array(
				'address_id'     => $address_query->row['address_id'],
				'customer_id'    => $address_query->row['customer_id'],
				'firstname'      => $address_query->row['firstname'],
				'lastname'       => $address_query->row['lastname'],
				'company'        => $address_query->row['company'],
				'address_1'      => $address_query->row['address_1'],
				'address_2'      => $address_query->row['address_2'],
				'postcode'       => $address_query->row['postcode'],
				'city'           => $address_query->row['city'],
				'zone_id'        => $address_query->row['zone_id'],
				'zone'           => $zone,
				'zone_code'      => $zone_code,
				'country_id'     => $address_query->row['country_id'],
				'country'        => $country,
				'iso_code_2'     => $iso_code_2,
				'iso_code_3'     => $iso_code_3,
				'address_format' => $address_format,
				'custom_field'   => json_decode($address_query->row['custom_field'], true)
			);
		}
	}

	public static function getAddresses($customer_id) {
		$address_data = array();

		$query = db::query("SELECT address_id FROM address WHERE customer_id = " . (int)$customer_id);

		foreach ($query->rows as $result) {
			$address_info = self::getAddress($result['address_id']);

			if ($address_info) {
				$address_data[$result['address_id']] = $address_info;
			}
		}

		return $address_data;
	}

	public static function getTotalCustomers($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM customer c";

		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "CONCAT(firstname, ' ', lastname) LIKE '%" . db::escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_email'])) {
			$implode[] = "email LIKE '" . db::escape($data['filter_email']) . "%'";
		}

		if (isset($data['filter_newsletter']) && !is_null($data['filter_newsletter'])) {
			$implode[] = "newsletter = " . (int)$data['filter_newsletter'];
		}

		if (!empty($data['filter_customer_group_id'])) {
			$implode[] = "customer_group_id = " . (int)$data['filter_customer_group_id'];
		}

		if (!empty($data['filter_ip'])) {
			$implode[] = "customer_id IN (SELECT customer_id FROM customer_ip WHERE ip = " . esc($data['filter_ip']) . ")";
		}

		if (isset($data['filter_status']) && $data['filter_status'] !== '') {
			$implode[] = "status = " . (int)$data['filter_status'];
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$query = db::query($sql);

		return $query->row['total'];
	}
        
    public static function getAffiliateByTracking($tracking) {
        $query = db::query("SELECT * FROM customer_affiliate WHERE tracking = " . esc($tracking));
                
        return $query->row;
    }
	
	public static function getAffiliate($customer_id) {
		$query = db::query("SELECT * FROM customer_affiliate WHERE customer_id = " . (int)$customer_id);

		return $query->row;
	}
	
	public static function getAffiliates($data = array()) {
		$sql = "SELECT DISTINCT *, CONCAT(c.firstname, ' ', c.lastname) AS name FROM customer_affiliate ca LEFT JOIN customer c ON (ca.customer_id = c.customer_id)";
		
		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "CONCAT(c.firstname, ' ', c.lastname) LIKE '%" . db::escape($data['filter_name']) . "%'";
		}		
		
		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}
		
		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}
						
		$query = db::query($sql . "ORDER BY name");

		return $query->rows;
	}
	
	public static function getTotalAffiliates($data = array()) {
		$sql = "SELECT DISTINCT COUNT(*) AS total FROM customer_affiliate ca LEFT JOIN customer c ON (ca.customer_id = c.customer_id)";
		
		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "CONCAT(c.firstname, ' ', c.lastname) LIKE '%" . db::escape($data['filter_name']) . "%'";
		}		
		
		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}
		
		return $query->row['total'];
	}

	public static function getTotalAddressesByCustomerId($customer_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM address WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}

	public static function getTotalAddressesByCountryId($country_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM address WHERE country_id = " . (int)$country_id);

		return $query->row['total'];
	}

	public static function getTotalAddressesByZoneId($zone_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM address WHERE zone_id = " . (int)$zone_id);

		return $query->row['total'];
	}

	public static function getTotalCustomersByCustomerGroupId($customer_group_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer WHERE customer_group_id = " . (int)$customer_group_id);

		return $query->row['total'];
	}

	public static function addHistory($customer_id, $comment) {
		db::query("INSERT INTO customer_history SET customer_id = " . (int)$customer_id . ", comment = " . esc(strip_tags($comment)) . ", date_added = NOW()");
	}

	public static function getHistories($customer_id, $start = 0, $limit = 10) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}

		$query = db::query("SELECT comment, date_added FROM customer_history WHERE customer_id = " . (int)$customer_id . " ORDER BY date_added DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalHistories($customer_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer_history WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}

	public static function addTransaction($customer_id, $description = '', $amount = '', $order_id = 0) {
		db::query("INSERT INTO customer_transaction SET customer_id = " . (int)$customer_id . ", order_id = " . (int)$order_id . ", description = " . esc($description) . ", amount = '" . (float)$amount . "', date_added = NOW()");
	}

	public static function deleteTransactionByOrderId($order_id) {
		db::query("DELETE FROM customer_transaction WHERE order_id = " . (int)$order_id);
	}

	public static function getTransactions($customer_id, $start = 0, $limit = 10) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}

		$query = db::query("SELECT * FROM customer_transaction WHERE customer_id = " . (int)$customer_id . " ORDER BY date_added DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalTransactions($customer_id) {
		$query = db::query("SELECT COUNT(*) AS total  FROM customer_transaction WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}

	public static function getTransactionTotal($customer_id) {
		$query = db::query("SELECT SUM(amount) AS total FROM customer_transaction WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}

	public static function getTotalTransactionsByOrderId($order_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer_transaction WHERE order_id = " . (int)$order_id);

		return $query->row['total'];
	}

	public static function addReward($customer_id, $description = '', $points = '', $order_id = 0) {
		db::query("INSERT INTO customer_reward SET customer_id = " . (int)$customer_id . ", order_id = " . (int)$order_id . ", points = " . (int)$points . ", description = " . esc($description) . ", date_added = NOW()");
	}

	public static function deleteReward($order_id) {
		db::query("DELETE FROM customer_reward WHERE order_id = " . (int)$order_id . " AND points > 0");
	}

	public static function getRewards($customer_id, $start = 0, $limit = 10) {
		$query = db::query("SELECT * FROM customer_reward WHERE customer_id = " . (int)$customer_id . " ORDER BY date_added DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalRewards($customer_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer_reward WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}

	public static function getRewardTotal($customer_id) {
		$query = db::query("SELECT SUM(points) AS total FROM customer_reward WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}

	public static function getTotalCustomerRewardsByOrderId($order_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer_reward WHERE order_id = " . (int)$order_id . " AND points > 0");

		return $query->row['total'];
	}

	public static function getIps($customer_id, $start = 0, $limit = 10) {
		if ($start < 0) {
			$start = 0;
		}
		if ($limit < 1) {
			$limit = 10;
		}

		$query = db::query("SELECT * FROM customer_ip WHERE customer_id = " . (int)$customer_id . " ORDER BY date_added DESC LIMIT " . (int)$start . "," . (int)$limit);
		
		return $query->rows;
	}

	public static function getTotalIps($customer_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer_ip WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}

	public static function getTotalCustomersByIp($ip) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer_ip WHERE ip = " . esc($ip));

		return $query->row['total'];
	}

	public static function getTotalLoginAttempts($email) {
		$query = db::query("SELECT * FROM `customer_login` WHERE `email` = " . esc($email));

		return $query->row;
	}

	public static function deleteLoginAttempts($email) {
		db::query("DELETE FROM `customer_login` WHERE `email` = " . esc($email));
	}
}
