<?php
class admin_customer_customer_approval {
	public static function getCustomerApprovals($data = array()) {
		$sql = "SELECT *, CONCAT(c.`firstname`, ' ', c.`lastname`) AS name, cgd.`name` AS customer_group, ca.`type` FROM `customer_approval` ca LEFT JOIN `customer` c ON (ca.`customer_id` = c.`customer_id`) LEFT JOIN `customer_group_description` cgd ON (c.`customer_group_id` = cgd.`customer_group_id`) WHERE cgd.`language_id` = " . config('language_id');

		if (!empty($data['filter_name'])) {
			$sql .= " AND CONCAT(c.`firstname`, ' ', c.`lastname`) LIKE '%" . db::escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_email'])) {
			$sql .= " AND c.`email` LIKE '" . db::escape($data['filter_email']) . "%'";
		}
		
		if (!empty($data['filter_customer_group_id'])) {
			$sql .= " AND c.`customer_group_id` = " . (int)$data['filter_customer_group_id'];
		}
		
		if (!empty($data['filter_type'])) {
			$sql .= " AND ca.`type` = " . esc($data['filter_type']);
		}
		
		if (!empty($data['filter_date_added'])) {
			$sql .= " AND DATE(c.`date_added`) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		$sql .= " ORDER BY c.`date_added` DESC";

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}
	
	public static function getCustomerApproval($customer_approval_id) {
		$query = db::query("SELECT * FROM `customer_approval` WHERE `customer_approval_id` = " . (int)$customer_approval_id);
		
		return $query->row;
	}
	
	public static function getTotalCustomerApprovals($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM `customer_approval` ca LEFT JOIN `customer` c ON (ca.`customer_id` = c.`customer_id`)";

		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "CONCAT(c.`firstname`, ' ', c.`lastname`) LIKE '%" . db::escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_email'])) {
			$implode[] = "c.`email` LIKE '" . db::escape($data['filter_email']) . "%'";
		}

		if (!empty($data['filter_customer_group_id'])) {
			$implode[] = "c.`customer_group_id` = " . (int)$data['filter_customer_group_id'];
		}
		
		if (!empty($data['filter_type'])) {
			$implode[] = "ca.`type` = " . esc($data['filter_type']);
		}
		
		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(ca.`date_added`) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$query = db::query($sql);

		return $query->row['total'];
	}
	
	public static function approveCustomer($customer_id) {
		db::query("UPDATE `customer` SET status = '1' WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM `customer_approval` WHERE customer_id = " . (int)$customer_id . " AND `type` = 'customer'");
	}

	public static function denyCustomer($customer_id) {
		db::query("DELETE FROM `customer_approval` WHERE customer_id = " . (int)$customer_id . " AND `type` = 'customer'");
	}

	public static function approveAffiliate($customer_id) {
		db::query("UPDATE `customer_affiliate` SET status = '1' WHERE customer_id = " . (int)$customer_id);
		db::query("DELETE FROM `customer_approval` WHERE customer_id = " . (int)$customer_id . " AND `type` = 'affiliate'");
	}
	
	public static function denyAffiliate($customer_id) {
		db::query("DELETE FROM `customer_approval` WHERE customer_id = " . (int)$customer_id . " AND `type` = 'affiliate'");
	}	
}