<?php
class admin_customer_customer_group {
	public static function addCustomerGroup($data) {
		db::query("INSERT INTO customer_group SET approval = " . (int)$data['approval'] . ", sort_order = " . (int)$data['sort_order']);

		$customer_group_id = db::getLastId();

		foreach ($data['customer_group_description'] as $language_id => $value) {
			db::query("INSERT INTO customer_group_description SET customer_group_id = " . (int)$customer_group_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']) . ", description = " . esc($value['description']));
		}
		
		return $customer_group_id;
	}

	public static function editCustomerGroup($customer_group_id, $data) {
		db::query("UPDATE customer_group SET approval = " . (int)$data['approval'] . ", sort_order = " . (int)$data['sort_order'] . " WHERE customer_group_id = " . (int)$customer_group_id);

		db::query("DELETE FROM customer_group_description WHERE customer_group_id = " . (int)$customer_group_id);

		foreach ($data['customer_group_description'] as $language_id => $value) {
			db::query("INSERT INTO customer_group_description SET customer_group_id = " . (int)$customer_group_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']) . ", description = " . esc($value['description']));
		}
	}

	public static function deleteCustomerGroup($customer_group_id) {
		db::query("DELETE FROM customer_group WHERE customer_group_id = " . (int)$customer_group_id);
		db::query("DELETE FROM customer_group_description WHERE customer_group_id = " . (int)$customer_group_id);
		db::query("DELETE FROM product_discount WHERE customer_group_id = " . (int)$customer_group_id);
		db::query("DELETE FROM product_special WHERE customer_group_id = " . (int)$customer_group_id);
		db::query("DELETE FROM product_reward WHERE customer_group_id = " . (int)$customer_group_id);
		db::query("DELETE FROM tax_rate_to_customer_group WHERE customer_group_id = " . (int)$customer_group_id);
	}

	public static function getCustomerGroup($customer_group_id) {
		$query = db::query("SELECT DISTINCT * FROM customer_group cg LEFT JOIN customer_group_description cgd ON (cg.customer_group_id = cgd.customer_group_id) WHERE cg.customer_group_id = " . (int)$customer_group_id . " AND cgd.language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getCustomerGroups($data = array()) {
		$sql = "SELECT * FROM customer_group cg LEFT JOIN customer_group_description cgd ON (cg.customer_group_id = cgd.customer_group_id) WHERE cgd.language_id = " . config('language_id');

		$sort_data = array(
			'cgd.name',
			'cg.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY cgd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getCustomerGroupDescriptions($customer_group_id) {
		$customer_group_data = array();

		$query = db::query("SELECT * FROM customer_group_description WHERE customer_group_id = " . (int)$customer_group_id);

		foreach ($query->rows as $result) {
			$customer_group_data[$result['language_id']] = array(
				'name'        => $result['name'],
				'description' => $result['description']
			);
		}

		return $customer_group_data;
	}

	public static function getTotalCustomerGroups() {
		$query = db::query("SELECT COUNT(*) AS total FROM customer_group");

		return $query->row['total'];
	}
}
