<?php
class admin_design_layout {
	public static function addLayout($data) {
		db::query("INSERT INTO layout SET name = " . esc($data['name']));

		$layout_id = db::getLastId();

		if (isset($data['layout_route'])) {
			foreach ($data['layout_route'] as $layout_route) {
				db::query("INSERT INTO layout_route SET layout_id = " . (int)$layout_id . ", store_id = " . (int)$layout_route['store_id'] . ", route = " . esc($layout_route['route']));
			}
		}

		if (isset($data['layout_module'])) {
			foreach ($data['layout_module'] as $layout_module) {
				db::query("INSERT INTO layout_module SET layout_id = " . (int)$layout_id . ", code = " . esc($layout_module['code']) . ", position = " . esc($layout_module['position']) . ", sort_order = " . (int)$layout_module['sort_order']);
			}
		}

		return $layout_id;
	}

	public static function editLayout($layout_id, $data) {
		db::query("UPDATE layout SET name = " . esc($data['name']) . " WHERE layout_id = " . (int)$layout_id);

		db::query("DELETE FROM layout_route WHERE layout_id = " . (int)$layout_id);

		if (isset($data['layout_route'])) {
			foreach ($data['layout_route'] as $layout_route) {
				db::query("INSERT INTO layout_route SET layout_id = " . (int)$layout_id . ", store_id = " . (int)$layout_route['store_id'] . ", route = " . esc($layout_route['route']));
			}
		}

		db::query("DELETE FROM layout_module WHERE layout_id = " . (int)$layout_id);

		if (isset($data['layout_module'])) {
			foreach ($data['layout_module'] as $layout_module) {
				db::query("INSERT INTO layout_module SET layout_id = " . (int)$layout_id . ", code = " . esc($layout_module['code']) . ", position = " . esc($layout_module['position']) . ", sort_order = " . (int)$layout_module['sort_order']);
			}
		}
	}

	public static function deleteLayout($layout_id) {
		db::query("DELETE FROM layout WHERE layout_id = " . (int)$layout_id);
		db::query("DELETE FROM layout_route WHERE layout_id = " . (int)$layout_id);
		db::query("DELETE FROM layout_module WHERE layout_id = " . (int)$layout_id);
		db::query("DELETE FROM category_to_layout WHERE layout_id = " . (int)$layout_id);
		db::query("DELETE FROM product_to_layout WHERE layout_id = " . (int)$layout_id);
		db::query("DELETE FROM information_to_layout WHERE layout_id = " . (int)$layout_id);
	}

	public static function getLayout($layout_id) {
		$query = db::query("SELECT DISTINCT * FROM layout WHERE layout_id = " . (int)$layout_id);

		return $query->row;
	}

	public static function getLayouts($data = array()) {
		$sql = "SELECT * FROM layout";

		$sort_data = array('name');

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getLayoutRoutes($layout_id) {
		$query = db::query("SELECT * FROM layout_route WHERE layout_id = " . (int)$layout_id);

		return $query->rows;
	}

	public static function getLayoutModules($layout_id) {
		$query = db::query("SELECT * FROM layout_module WHERE layout_id = " . (int)$layout_id . " ORDER BY position ASC, sort_order ASC");

		return $query->rows;
	}

	public static function getTotalLayouts() {
		$query = db::query("SELECT COUNT(*) AS total FROM layout");

		return $query->row['total'];
	}
}