<?php
class admin_design_seo_url {
	public static function addSeoUrl($data) {
		db::query("INSERT INTO `seo_url` SET store_id = " . (int)$data['store_id'] . ", language_id = " . (int)$data['language_id'] . ", query = " . esc($data['query']) . ", keyword = " . esc($data['keyword']));
	}

	public static function editSeoUrl($seo_url_id, $data) {
		db::query("UPDATE `seo_url` SET store_id = " . (int)$data['store_id'] . ", language_id = " . (int)$data['language_id'] . ", query = " . esc($data['query']) . ", keyword = " . esc($data['keyword']) . " WHERE seo_url_id = " . (int)$seo_url_id);
	}

	public static function deleteSeoUrl($seo_url_id) {
		db::query("DELETE FROM `seo_url` WHERE seo_url_id = " . (int)$seo_url_id);
	}
	
	public static function getSeoUrl($seo_url_id) {
		$query = db::query("SELECT * FROM `seo_url` WHERE seo_url_id = " . (int)$seo_url_id);

		return $query->row;
	}

	public static function getSeoUrls($data = array()) {
		$sql = "SELECT *, (SELECT `name` FROM `store` s WHERE s.store_id = su.store_id) AS store, (SELECT `name` FROM `language` l WHERE l.language_id = su.language_id) AS language FROM `seo_url` su";

		$implode = array();

		if (!empty($data['filter_query'])) {
			$implode[] = "`query` LIKE " . esc($data['filter_query']);
		}
		
		if (!empty($data['filter_keyword'])) {
			$implode[] = "`keyword` LIKE " . esc($data['filter_keyword']);
		}
		
		if (isset($data['filter_store_id']) && $data['filter_store_id'] !== '') {
			$implode[] = "`store_id` = " . (int)$data['filter_store_id'];
		}
				
		if (!empty($data['filter_language_id']) && $data['filter_language_id'] !== '') {
			$implode[] = "`language_id` = " . (int)$data['filter_language_id'];
		}
		
		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}	
		
		$sort_data = array(
			'query',
			'keyword',
			'language_id',
			'store_id'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY query";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalSeoUrls($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM `seo_url`";
		
		$implode = array();

		if (!empty($data['filter_query'])) {
			$implode[] = "query LIKE " . esc($data['filter_query']);
		}
		
		if (!empty($data['filter_keyword'])) {
			$implode[] = "keyword LIKE " . esc($data['filter_keyword']);
		}
		
		if (!empty($data['filter_store_id']) && $data['filter_store_id'] !== '') {
			$implode[] = "store_id = " . (int)$data['filter_store_id'];
		}
				
		if (!empty($data['filter_language_id']) && $data['filter_language_id'] !== '') {
			$implode[] = "language_id = " . (int)$data['filter_language_id'];
		}
		
		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}		
		
		$query = db::query($sql);

		return $query->row['total'];
	}
	
	public static function getSeoUrlsByKeyword($keyword) {
		$query = db::query("SELECT * FROM `seo_url` WHERE keyword = " . esc($keyword));

		return $query->rows;
	}	
	
	public static function getSeoUrlsByQuery($query) {
		$query = db::query("SELECT * FROM `seo_url` WHERE query = " . esc($query));

		return $query->rows;
	}
	
	public static function getSeoUrlsByQueryId($seo_url_id, $query) {
		$query = db::query("SELECT * FROM `seo_url` WHERE query = " . esc($query) . " AND seo_url_id != " . (int)$seo_url_id);

		return $query->rows;
	}	

	public static function getSeoUrlsByKeywordId($seo_url_id, $keyword) {
		$query = db::query("SELECT * FROM `seo_url` WHERE keyword = " . esc($keyword) . " AND seo_url_id != " . (int)$seo_url_id);

		return $query->rows;
	}	
}