<?php
class admin_extension_feed_google_base {
	public static function install() {
		db::query("
			CREATE TABLE `google_base_category` (
				`google_base_category_id` INT(11) NOT NULL AUTO_INCREMENT,
				`name` varchar(255) NOT NULL,
				PRIMARY KEY (`google_base_category_id`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;
		");

		db::query("
			CREATE TABLE `google_base_category_to_category` (
				`google_base_category_id` INT(11) NOT NULL,
				`category_id` INT(11) NOT NULL,
				PRIMARY KEY (`google_base_category_id`, `category_id`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;
		");
	}

	public static function uninstall() {
		db::query("DROP TABLE IF EXISTS `google_base_category`");
		db::query("DROP TABLE IF EXISTS `google_base_category_to_category`");
	}

    public static function import($string) {
        db::query("DELETE FROM google_base_category");

        $lines = explode("\n", $string);

        foreach ($lines as $line) {
			if (substr($line, 0, 1) != '#') {
	            $part = explode(' - ', $line, 2);

	            if (isset($part[1])) {
	                db::query("INSERT INTO google_base_category SET google_base_category_id = " . (int)$part[0] . ", name = " . esc($part[1]));
	            }
			}
        }
    }

    public static function getGoogleBaseCategories($data = array()) {
        $sql = "SELECT * FROM `google_base_category` WHERE name LIKE '%" . db::escape($data['filter_name']) . "%' ORDER BY name ASC";

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
    }

	public static function addCategory($data) {
		db::query("DELETE FROM google_base_category_to_category WHERE category_id = " . (int)$data['category_id']);

		db::query("INSERT INTO google_base_category_to_category SET google_base_category_id = " . (int)$data['google_base_category_id'] . ", category_id = " . (int)$data['category_id']);
	}

	public static function deleteCategory($category_id) {
		db::query("DELETE FROM google_base_category_to_category WHERE category_id = " . (int)$category_id);
	}

    public static function getCategories($data = array()) {
        $sql = "SELECT google_base_category_id, (SELECT name FROM `google_base_category` gbc WHERE gbc.google_base_category_id = gbc2c.google_base_category_id) AS google_base_category, category_id, (SELECT name FROM `category_description` cd WHERE cd.category_id = gbc2c.category_id AND cd.language_id = " . config('language_id') . ") AS category FROM `google_base_category_to_category` gbc2c ORDER BY google_base_category ASC";

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
    }

	public static function getTotalCategories() {
		$query = db::query("SELECT COUNT(*) AS total FROM `google_base_category_to_category`");

		return $query->row['total'];
    }
}
