<?php
use Cardinity\Client;
use Cardinity\Method\Payment;
use Cardinity\Method\Refund;

class admin_extension_payment_cardinity {
	public static function getOrder($order_id) {
		$query = db::query("SELECT * FROM `cardinity_order` WHERE `order_id` = " . (int)$order_id . " LIMIT 1");

		return $query->row;
	}

	public static function createClient($credentials) {
		return Client::create(array(
			'consumerKey'    => $credentials['key'],
			'consumerSecret' => $credentials['secret'],
		));
	}

	public static function verifyCredentials($client) {
		$method = new Payment\GetAll(10);

		try {
			$client::call($method);

			return true;
		} catch (Exception $e) {
			self::log($e::getMessage());

			return false;
		}
	}

	public static function getPayment($client, $payment_id) {
		$method = new Payment\Get($payment_id);

		try {
			$payment = $client::call($method);

			return $payment;
		} catch (Exception $e) {
			self::log($e::getMessage());

			return false;
		}
	}

	public static function getRefunds($client, $payment_id) {
		$method = new Refund\GetAll($payment_id);

		try {
			$refunds = $client::call($method);

			return $refunds;
		} catch (Exception $e) {
			self::log($e::getMessage());

			return false;
		}
	}

	public static function refundPayment($client, $payment_id, $amount, $description) {
		$method = new Refund\Create($payment_id, $amount, $description);

		try {
			$refund = $client::call($method);

			return $refund;
		} catch (Exception $e) {
			self::log($e::getMessage());

			return false;
		}
	}

	public static function log($data) {
		if (config::get('payment_cardinity_debug')) {
			$backtrace = debug_backtrace();
			$log = new Log('cardinity.log');
			$log::write('(' . $backtrace[1]['class'] . '::$' . $backtrace[1]['function'] . ') - ' . print_r($data, true));
		}
	}

	public static function install() {
		db::query("
			CREATE TABLE IF NOT EXISTS `cardinity_order` (
			  `cardinity_order_id` INT(11) NOT NULL AUTO_INCREMENT,
			  `order_id` INT(11) NOT NULL,
			  `payment_id` VARCHAR(255),
			  PRIMARY KEY (`cardinity_order_id`)
			) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;
		");
	}

	public static function uninstall() {
		db::query("DROP TABLE IF EXISTS `cardinity_order`;");
	}
}