<?php
class admin_extension_payment_laybuy {
	public static function addRevisedTransaction($data = array()) {
		$query = db::query("INSERT INTO `laybuy_revise_request` SET `laybuy_transaction_id` = " . (int)$data['transaction_id'] . ", `type` = " . esc($data['type']) . ", `order_id` = " . (int)$data['order_id'] . ", `firstname` = " . esc($data['firstname']) . ", `lastname` = " . esc($data['lastname']) . ", `address` = " . esc($data['address']) . ", `suburb` = " . esc($data['suburb']) . ", `state` = " . esc($data['state']) . ", `country` = " . esc($data['country']) . ", `postcode` = " . esc($data['postcode']) . ", `email` = " . esc($data['email']) . ", `amount` = '" . (float)$data['amount'] . "', `currency` = " . esc($data['currency']) . ", `downpayment` = " . esc($data['downpayment']) . ", `months` = " . (int)$data['months'] . ", `downpayment_amount` = '" . (float)$data['downpayment_amount'] . "', `payment_amounts` = '" . (float)$data['payment_amounts'] . "', `first_payment_due` = " . esc($data['first_payment_due']) . ", `last_payment_due` = " . esc($data['last_payment_due']) . ", `store_id` = " . (int)$data['store_id'] . ", `status` = " . (int)$data['status'] . ", `report` = " . esc($data['report']) . ", `transaction` = " . (int)$data['transaction'] . ", `paypal_profile_id` = " . esc($data['paypal_profile_id']) . ", `laybuy_ref_no` = " . (int)$data['laybuy_ref_no'] . ", `payment_type` = " . (int)$data['payment_type'] . ", `date_added` = NOW()");

		return db::getLastId();
	}

	public static function getCustomerIdByOrderId($order_id) {
		$query = db::query("SELECT `customer_id` FROM `order` WHERE `order_id` = " . (int)$order_id);

		if ($query->num_rows) {
			return $query->row['customer_id'];
		} else {
			return 0;
		}
	}

	public static function getInitialPayments() {
		$minimum = config::get('payment_laybuy_min_deposit') ? config::get('payment_laybuy_min_deposit') : 20;

		$maximum = config::get('payment_laybuy_max_deposit') ? config::get('payment_laybuy_max_deposit') : 50;

		$initial_payments = array();

		for ($i = $minimum; $i <= $maximum; $i += 10) {
			$initial_payments[] = $i;
		}

		return $initial_payments;
	}

	public static function getMonths() {
		load::language('extension/payment/laybuy');

		$max_months = config::get('payment_laybuy_max_months');

		if (!$max_months) {
			$max_months = 3;
		}

		if ($max_months < 1) {
			$max_months = 1;
		}

		$months = array();

		for ($i = 1; $i <= $max_months; $i++) {
			$months[] = array(
				'value' => $i,
				'label' => $i . ' ' . (($i > 1) ? language::get('text_months') : language::get('text_month'))
			);
		}

		return $months;
	}

	public static function getPayPalProfileIds() {
		$query = db::query("SELECT `paypal_profile_id` FROM `laybuy_transaction` WHERE `status` = '1'");

		return $query->rows;
	}

	public static function getRevisedTransaction($id) {
		$query = db::query("SELECT * FROM `laybuy_revise_request` WHERE `laybuy_revise_request_id` = " . (int)$id);

		return $query->row;
	}

	public static function getRemainingAmount($amount, $downpayment_amount, $payment_amounts, $transaction = 2) {
		return $amount - ($downpayment_amount + (((int)$transaction - 2) * $payment_amounts));
	}

	public static function getRevisedTransactions($id) {
		$query = db::query("SELECT * FROM `laybuy_revise_request` WHERE `laybuy_revise_request_id` = " . (int)$id);

		return $query->rows;
	}

	public static function getStatusLabel($id) {
		$statuses = self::getTransactionStatuses();

		foreach ($statuses as $status) {
			if ($status['status_id'] == $id && $status['status_name'] != '') {
				return $status['status_name'];

				break;
			}
		}

		return $id;
	}

	public static function getTransaction($id) {
		$query = db::query("SELECT * FROM `laybuy_transaction` WHERE `laybuy_transaction_id` = " . (int)$id);

		return $query->row;
	}

	public static function getTransactions($data = array()) {
		$sql = "SELECT *, CONCAT(firstname, ' ', lastname) AS `customer` FROM `laybuy_transaction` `lt` WHERE 1 = 1";

		$implode = array();

		if (!empty($data['filter_order_id'])) {
			$implode[] = "`lt`.`order_id` = " . (int)$data['filter_order_id'];
		}

		if (!empty($data['filter_customer'])) {
			$implode[] = "CONCAT(firstname, ' ', lastname) LIKE '%" . db::escape($data['filter_customer']) . "%'";
		}

		if (!empty($data['filter_dp_percent'])) {
			$implode[] = "`lt`.`downpayment` = " . (int)$data['filter_dp_percent'];
		}

		if (!empty($data['filter_months'])) {
			$implode[] = "`lt`.`months` = " . (int)$data['filter_months'];
		}

		if (!empty($data['filter_status'])) {
			$implode[] = "`lt`.`status` = " . (int)$data['filter_status'];
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(`lt`.`date_added`) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " AND " . implode(" AND ", $implode);
		}

		$sort_data = array(
			'lt.order_id',
			'customer',
			'lt.amount',
			'lt.downpayment',
			'lt.months',
			'lt.downpayment_amount',
			'lt.first_payment_due',
			'lt.last_payment_due',
			'lt.status',
			'lt.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY order_id";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['sort']) && $data['sort'] != 'lt.date_added') {
			$sql .= ", lt.date_added DESC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalTransactions($data = array()) {
		$sql = "SELECT COUNT(*) AS `total` FROM `laybuy_transaction` `lt` WHERE 1 = 1";

		$implode = array();

		if (!empty($data['filter_order_id'])) {
			$implode[] = "`lt`.`order_id` = " . (int)$data['filter_order_id'];
		}

		if (!empty($data['filter_customer'])) {
			$implode[] = "CONCAT(firstname, ' ', lastname) LIKE '%" . db::escape($data['filter_customer']) . "%'";
		}

		if (!empty($data['filter_dp_percent'])) {
			$implode[] = "`lt`.`downpayment` = " . (int)$data['filter_dp_percent'];
		}

		if (!empty($data['filter_months'])) {
			$implode[] = "`lt`.`months` = " . (int)$data['filter_months'];
		}

		if (!empty($data['filter_status'])) {
			$implode[] = "`lt`.`status` = " . (int)$data['filter_status'];
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(`lt`.`date_added`) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " AND " . implode(" AND ", $implode);
		}

		$query = db::query($sql);

		return $query->row['total'];
	}

	public static function getTransactionByLayBuyRefId($laybuy_ref_id) {
		$query = db::query("SELECT * FROM `laybuy_transaction` WHERE `laybuy_ref_no` = " . (int)$laybuy_ref_id);

		return $query->row;
	}

	public static function getTransactionByOrderId($order_id) {
		$query = db::query("SELECT * FROM `laybuy_transaction` WHERE `order_id` = " . (int)$order_id . " ORDER BY `laybuy_ref_no` DESC LIMIT 1");

		return $query->row;
	}

	public static function getTransactionStatuses() {
		load::language('extension/payment/laybuy');

		$transaction_statuses = array(
			array(
				'status_id'		=> 1,
				'status_name'	=> language::get('text_status_1')
			),
			array(
				'status_id'		=> 5,
				'status_name'	=> language::get('text_status_5')
			),
			array(
				'status_id'		=> 7,
				'status_name'	=> language::get('text_status_7')
			),
			array(
				'status_id'		=> 50,
				'status_name'	=> language::get('text_status_50')
			),
			array(
				'status_id'		=> 51,
				'status_name'	=> language::get('text_status_51')
			)
		);

		return $transaction_statuses;
	}

	public static function install() {
		db::query("CREATE TABLE IF NOT EXISTS `laybuy_transaction` (
			`laybuy_transaction_id` int(11) NOT NULL AUTO_INCREMENT,
			`order_id` int(11) NOT NULL DEFAULT '0',
			`firstname` varchar(32) NOT NULL DEFAULT '',
			`lastname` varchar(32) NOT NULL DEFAULT '',
			`address` text,
			`suburb` varchar(128) NOT NULL DEFAULT '',
			`state` varchar(128) NOT NULL DEFAULT '',
			`country` varchar(32) NOT NULL DEFAULT '',
			`postcode` varchar(10) NOT NULL DEFAULT '',
			`email` varchar(96) NOT NULL DEFAULT '',
			`amount` double NOT NULL,
			`currency` varchar(5) NOT NULL,
			`downpayment` double NOT NULL,
			`months` int(11) NOT NULL,
			`downpayment_amount` double NOT NULL,
			`payment_amounts` double NOT NULL,
			`first_payment_due` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
			`last_payment_due` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
			`store_id` int(11) NOT NULL DEFAULT '0',
			`status` int(11) NOT NULL DEFAULT '1',
			`report` text,
			`transaction` int(11) NOT NULL DEFAULT '2',
			`paypal_profile_id` varchar(250) NOT NULL DEFAULT '',
			`laybuy_ref_no` int(11) NOT NULL DEFAULT '0',
			`date_added` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
			PRIMARY KEY (`laybuy_transaction_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci");

		db::query("CREATE TABLE IF NOT EXISTS `laybuy_revise_request` (
			`laybuy_revise_request_id` int(11) NOT NULL AUTO_INCREMENT,
			`laybuy_transaction_id` int(11) DEFAULT '0',
			`type` varchar(250) NOT NULL DEFAULT '',
			`order_id` int(11) NOT NULL DEFAULT '0',
			`firstname` varchar(32) NOT NULL DEFAULT '',
			`lastname` varchar(32) NOT NULL DEFAULT '',
			`address` text,
			`suburb` varchar(128) NOT NULL DEFAULT '',
			`state` varchar(128) NOT NULL DEFAULT '',
			`country` varchar(32) NOT NULL DEFAULT '',
			`postcode` varchar(10) NOT NULL DEFAULT '',
			`email` varchar(96) NOT NULL DEFAULT '',
			`amount` double NOT NULL,
			`currency` varchar(5) NOT NULL,
			`downpayment` double NOT NULL,
			`months` int(11) NOT NULL,
			`downpayment_amount` double NOT NULL,
			`payment_amounts` double NOT NULL,
			`first_payment_due` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
			`last_payment_due` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
			`store_id` int(11) NOT NULL DEFAULT '0',
			`status` int(11) NOT NULL DEFAULT '1',
			`report` text,
			`transaction` int(11) NOT NULL DEFAULT '2',
			`paypal_profile_id` varchar(250) NOT NULL DEFAULT '',
			`laybuy_ref_no` int(11) NOT NULL DEFAULT '0',
			`payment_type` tinyint(1) NOT NULL DEFAULT '1',
			`date_added` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
			PRIMARY KEY (`laybuy_revise_request_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci");


		admin_setting_event::addEvent('laybuy', 'catalog/model/checkout/order/deleteOrder/after', 'extension/payment/laybuy/deleteOrder');
	}

	public static function log($data, $step = 6) {
		if (config::get('payment_laybuy_logging')) {
			$backtrace = debug_backtrace();

			$log = new Log('laybuy.log');

			$log::write('(' . $backtrace[$step]['class'] . '::$' . $backtrace[$step]['function'] . ') - ' . $data);
		}
	}

	public static function uninstall() {
		db::query("DROP TABLE IF EXISTS `laybuy_transaction`");

		db::query("DROP TABLE IF EXISTS `laybuy_revise_request`");


		admin_setting_event::deleteEventByCode('laybuy');
	}

	public static function updateOrderStatus($order_id, $order_status_id, $comment) {
		db::query("UPDATE `order` SET `order_status_id` = " . (int)$order_status_id . ", `date_modified` = NOW() WHERE `order_id` = " . (int)$order_id);

		db::query("INSERT INTO `order_history` SET `order_id` = " . (int)$order_id . ", `order_status_id` = " . (int)$order_status_id . ", `notify` = '0', `comment` = " . esc($comment) . ", `date_added` = NOW()");
	}

	public static function updateRevisedTransaction($id, $data = array()) {
		db::query("UPDATE `laybuy_revise_request` SET `laybuy_transaction_id` = " . (int)$data['transaction_id'] . ", `type` = " . esc($data['type']) . ", `order_id` = " . (int)$data['order_id'] . ", `firstname` = " . esc($data['firstname']) . ", `lastname` = " . esc($data['lastname']) . ", `address` = " . esc($data['address']) . ", `suburb` = " . esc($data['suburb']) . ", `state` = " . esc($data['state']) . ", `country` = " . esc($data['country']) . ", `postcode` = " . esc($data['postcode']) . ", `email` = " . esc($data['email']) . ", `amount` = '" . (float)$data['amount'] . "', `currency` = " . esc($data['currency']) . ", `downpayment` = " . esc($data['downpayment']) . ", `months` = " . (int)$data['months'] . ", `downpayment_amount` = '" . (float)$data['downpayment_amount'] . "', `payment_amounts` = '" . (float)$data['payment_amounts'] . "', `first_payment_due` = " . esc($data['first_payment_due']) . ", `last_payment_due` = " . esc($data['last_payment_due']) . ", `store_id` = " . (int)$data['store_id'] . ", `status` = " . (int)$data['status'] . ", `report` = " . esc($data['report']) . ", `transaction` = " . (int)$data['transaction'] . ", `paypal_profile_id` = " . esc($data['paypal_profile_id']) . ", `laybuy_ref_no` = " . (int)$data['laybuy_ref_no'] . ", `payment_type` = " . (int)$data['payment_type'] . ", `date_added` = NOW() WHERE `laybuy_revise_request_id` = " . (int)$id);
	}

	public static function updateTransaction($id, $status, $report, $transaction) {
		db::query("UPDATE `laybuy_transaction` SET `status` = " . (int)$status . ", `report` = " . esc($report) . ", `transaction` = " . (int)$transaction . " WHERE `laybuy_transaction_id` = " . (int)$id);
	}

	public static function updateTransactionStatus($id, $status) {
		db::query("UPDATE `laybuy_transaction` SET `status` = " . (int)$status . " WHERE `laybuy_transaction_id` = " . (int)$id);
	}
}