<?php
class admin_extension_payment_pp_payflow_iframe {
	public static function install() {
		db::query("
			CREATE TABLE `paypal_payflow_iframe_order` (
				`order_id` int(11) NOT NULL,
				`secure_token_id` varchar(255) NOT NULL,
				`transaction_reference` varchar(255) DEFAULT NULL,
				`transaction_type` varchar(1) DEFAULT NULL,
				`complete` tinyint(4) NOT NULL DEFAULT '0',
				PRIMARY KEY(`order_id`),
				KEY `secure_token_id` (`secure_token_id`)
			) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci");

		db::query("
			CREATE TABLE `paypal_payflow_iframe_order_transaction` (
				`order_id` int(11) NOT NULL,
				`transaction_reference` varchar(255) NOT NULL,
				`transaction_type` char(1) NOT NULL,
				`time` datetime NOT NULL,
				`amount` decimal(10,4) DEFAULT NULL,
				PRIMARY KEY (`transaction_reference`),
				KEY `order_id` (`order_id`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
	}

	public static function uninstall() {
		db::query("DROP TABLE IF EXISTS `paypal_payflow_iframe_order`;");
		db::query("DROP TABLE IF EXISTS `paypal_payflow_iframe_order_transaction`;");
	}

	public static function log($message) {
		if (config::get('payment_pp_payflow_iframe_debug')) {
			$log = new Log('payflow-iframe.log');
			$log::write($message);
		}
	}

	public static function getOrder($order_id) {
		$result = db::query("SELECT * FROM paypal_payflow_iframe_order WHERE order_id = " . (int)$order_id);

		if ($result->num_rows) {
			$order = $result->row;
		} else {
			$order = false;
		}

		return $order;
	}

	public static function updateOrderStatus($order_id, $status) {
		db::query("
			UPDATE paypal_payflow_iframe_order
			SET `complete` = " . (int)$status . "
			WHERE order_id = " . (int)$order_id . "
		");
	}

	public static function addTransaction($data) {
		db::query("
			INSERT INTO paypal_payflow_iframe_order_transaction
			SET order_id = " . (int)$data['order_id'] . ",
				transaction_reference = " . esc($data['transaction_reference']) . ",
				transaction_type = " . esc($data['type']) . ",
				`time` = NOW(),
				`amount` = '" . db::escape($data['amount']) .  "'
		");
	}

	public static function getTransactions($order_id) {
		return db::query("
			SELECT *
			FROM paypal_payflow_iframe_order_transaction
			WHERE order_id = " . (int)$order_id . "
			ORDER BY `time` ASC")->rows;
	}

	public static function getTransaction($transaction_reference) {
		$result = db::query("
			SELECT *
			FROM paypal_payflow_iframe_order_transaction
			WHERE transaction_reference = " . esc($transaction_reference))->row;

		if ($result) {
			$transaction = $result;
		} else {
			$transaction = false;
		}

		return $transaction;
	}

	public static function call($data) {
		$default_parameters = array(
			'USER' => config::get('payment_pp_payflow_iframe_user'),
			'VENDOR' => config::get('payment_pp_payflow_iframe_vendor'),
			'PWD' => config::get('payment_pp_payflow_iframe_password'),
			'PARTNER' => config::get('payment_pp_payflow_iframe_partner'),
			'BUTTONSOURCE' => 'OpenCart_Cart_PFP',
		);

		$call_parameters = array_merge($data, $default_parameters);

		if (config::get('payment_pp_payflow_iframe_test')) {
			$url = 'https://pilot-payflowpro.paypal.com';
		} else {
			$url = 'https://payflowpro.paypal.com';
		}

		$query_params = array();

		foreach ($call_parameters as $key => $value) {
			$query_params[] = $key . '=' . utf8_decode($value);
		}

		self::log('Call data: ' . implode('&', $query_params));

		$curl = curl_init($url);

		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, implode('&', $query_params));
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_HEADER, false);
		curl_setopt($curl, CURLOPT_TIMEOUT, 30);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

		$response = curl_exec($curl);

		self::log('Response data: ' . $response);

		$response_params = array();
		parse_str($response, $response_params);

		return $response_params;
	}
}