<?php
class admin_extension_report_customer_transaction {
	public static function getTransactions($data = array()) {
		$sql = "SELECT ct.customer_id, CONCAT(c.firstname, ' ', c.lastname) AS customer, c.email, cgd.name AS customer_group, c.status, SUM(ct.amount) AS total FROM `customer_transaction` ct LEFT JOIN `customer` c ON (ct.customer_id = c.customer_id) LEFT JOIN `customer_group_description` cgd ON (c.customer_group_id = cgd.customer_group_id) WHERE cgd.language_id = " . config('language_id');

		if (!empty($data['filter_date_start'])) {
			$sql .= " AND DATE(ct.date_added) >= DATE(" . esc($data['filter_date_start']) . ")";
		}

		if (!empty($data['filter_date_end'])) {
			$sql .= " AND DATE(ct.date_added) <= DATE(" . esc($data['filter_date_end']) . ")";
		}

		if (!empty($data['filter_customer'])) {
			$sql .= " AND CONCAT(c.firstname, ' ', c.lastname) LIKE " . esc($data['filter_customer']);
		}

		$sql .= " GROUP BY ct.customer_id ORDER BY total DESC";

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalTransactions($data = array()) {
		$sql = "SELECT COUNT(DISTINCT ct.customer_id) AS total FROM `customer_transaction` ct LEFT JOIN `customer` c ON (ct.customer_id = c.customer_id)";

		$implode = array();

		if (!empty($data['filter_date_start'])) {
			$implode[] = "DATE(ct.date_added) >= DATE(" . esc($data['filter_date_start']) . ")";
		}

		if (!empty($data['filter_date_end'])) {
			$implode[] = "DATE(ct.date_added) <= DATE(" . esc($data['filter_date_end']) . ")";
		}

		if (!empty($data['filter_customer'])) {
			$implode[] = "CONCAT(c.firstname, ' ', c.lastname) LIKE " . esc($data['filter_customer']);
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$query = db::query($sql);

		return $query->row['total'];
	}
}