<?php
class admin_extension_report_marketing {
	public static function getMarketing($data = array()) {
		$sql = "SELECT m.marketing_id, m.name AS campaign, m.code, m.clicks AS clicks, (SELECT COUNT(DISTINCT order_id) FROM `order` o1 WHERE o1.marketing_id = m.marketing_id";

		if (!empty($data['filter_order_status_id'])) {
			$sql .= " AND o1.order_status_id = " . (int)$data['filter_order_status_id'];
		} else {
			$sql .= " AND o1.order_status_id > '0'";
		}

		if (!empty($data['filter_date_start'])) {
			$sql .= " AND DATE(o1.date_added) >= DATE(" . esc($data['filter_date_start']) . ")";
		}

		if (!empty($data['filter_date_end'])) {
			$sql .= " AND DATE(o1.date_added) <= DATE(" . esc($data['filter_date_end']) . ")";
		}

		$sql .= ") AS `orders`, (SELECT SUM(total) FROM `order` o2 WHERE o2.marketing_id = m.marketing_id";

		if (!empty($data['filter_order_status_id'])) {
			$sql .= " AND o2.order_status_id = " . (int)$data['filter_order_status_id'];
		} else {
			$sql .= " AND o2.order_status_id > '0'";
		}

		if (!empty($data['filter_date_start'])) {
			$sql .= " AND DATE(o2.date_added) >= DATE(" . esc($data['filter_date_start']) . ")";
		}

		if (!empty($data['filter_date_end'])) {
			$sql .= " AND DATE(o2.date_added) <= DATE(" . esc($data['filter_date_end']) . ")";
		}

		$sql .= " GROUP BY o2.marketing_id) AS `total` FROM `marketing` m ORDER BY m.date_added ASC";

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalMarketing($data = array()) {
		$query = db::query("SELECT COUNT(*) AS total FROM `marketing`");

		return $query->row['total'];
	}
}