<?php
class admin_localisation_country {
	public static function addCountry($data) {
		db::query("INSERT INTO country SET name = " . esc($data['name']) . ", iso_code_2 = " . esc($data['iso_code_2']) . ", iso_code_3 = " . esc($data['iso_code_3']) . ", address_format = " . esc($data['address_format']) . ", postcode_required = " . (int)$data['postcode_required'] . ", status = " . (int)$data['status']);

		cache::delete('country');
		
		return db::getLastId();
	}

	public static function editCountry($country_id, $data) {
		db::query("UPDATE country SET name = " . esc($data['name']) . ", iso_code_2 = " . esc($data['iso_code_2']) . ", iso_code_3 = " . esc($data['iso_code_3']) . ", address_format = " . esc($data['address_format']) . ", postcode_required = " . (int)$data['postcode_required'] . ", status = " . (int)$data['status'] . " WHERE country_id = " . (int)$country_id);

		cache::delete('country');
	}

	public static function deleteCountry($country_id) {
		db::query("DELETE FROM country WHERE country_id = " . (int)$country_id);

		cache::delete('country');
	}

	public static function getCountry($country_id) {
		$query = db::query("SELECT DISTINCT * FROM country WHERE country_id = " . (int)$country_id);

		return $query->row;
	}

	public static function getCountries($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM country";

			$sort_data = array(
				'name',
				'iso_code_2',
				'iso_code_3'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY name";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$country_data = cache::get('country.admin');

			if (!$country_data) {
				$query = db::query("SELECT * FROM country ORDER BY name ASC");

				$country_data = $query->rows;

				cache::set('country.admin', $country_data);
			}

			return $country_data;
		}
	}

	public static function getTotalCountries() {
		$query = db::query("SELECT COUNT(*) AS total FROM country");

		return $query->row['total'];
	}
}