<?php
class admin_localisation_geo_zone {
	public static function addGeoZone($data) {
		db::query("INSERT INTO geo_zone SET name = " . esc($data['name']) . ", description = " . esc($data['description']) . ", date_added = NOW()");

		$geo_zone_id = db::getLastId();

		if (isset($data['zone_to_geo_zone'])) {
			foreach ($data['zone_to_geo_zone'] as $value) {
				db::query("DELETE FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)$geo_zone_id . " AND country_id = " . (int)$value['country_id'] . " AND zone_id = " . (int)$value['zone_id']);				

				db::query("INSERT INTO zone_to_geo_zone SET country_id = " . (int)$value['country_id'] . ", zone_id = " . (int)$value['zone_id'] . ", geo_zone_id = " . (int)$geo_zone_id . ", date_added = NOW()");
			}
		}

		cache::delete('geo_zone');
		
		return $geo_zone_id;
	}

	public static function editGeoZone($geo_zone_id, $data) {
		db::query("UPDATE geo_zone SET name = " . esc($data['name']) . ", description = " . esc($data['description']) . ", date_modified = NOW() WHERE geo_zone_id = " . (int)$geo_zone_id);

		db::query("DELETE FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)$geo_zone_id);

		if (isset($data['zone_to_geo_zone'])) {
			foreach ($data['zone_to_geo_zone'] as $value) {
				db::query("DELETE FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)$geo_zone_id . " AND country_id = " . (int)$value['country_id'] . " AND zone_id = " . (int)$value['zone_id']);				

				db::query("INSERT INTO zone_to_geo_zone SET country_id = " . (int)$value['country_id'] . ", zone_id = " . (int)$value['zone_id'] . ", geo_zone_id = " . (int)$geo_zone_id . ", date_added = NOW()");
			}
		}

		cache::delete('geo_zone');
	}

	public static function deleteGeoZone($geo_zone_id) {
		db::query("DELETE FROM geo_zone WHERE geo_zone_id = " . (int)$geo_zone_id);
		db::query("DELETE FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)$geo_zone_id);

		cache::delete('geo_zone');
	}

	public static function getGeoZone($geo_zone_id) {
		$query = db::query("SELECT DISTINCT * FROM geo_zone WHERE geo_zone_id = " . (int)$geo_zone_id);

		return $query->row;
	}

	public static function getGeoZones($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM geo_zone";

			$sort_data = array(
				'name',
				'description'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY name";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$geo_zone_data = cache::get('geo_zone');

			if (!$geo_zone_data) {
				$query = db::query("SELECT * FROM geo_zone ORDER BY name ASC");

				$geo_zone_data = $query->rows;

				cache::set('geo_zone', $geo_zone_data);
			}

			return $geo_zone_data;
		}
	}

	public static function getTotalGeoZones() {
		$query = db::query("SELECT COUNT(*) AS total FROM geo_zone");

		return $query->row['total'];
	}

	public static function getZoneToGeoZones($geo_zone_id) {
		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)$geo_zone_id);

		return $query->rows;
	}

	public static function getTotalZoneToGeoZoneByGeoZoneId($geo_zone_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)$geo_zone_id);

		return $query->row['total'];
	}

	public static function getTotalZoneToGeoZoneByCountryId($country_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM zone_to_geo_zone WHERE country_id = " . (int)$country_id);

		return $query->row['total'];
	}

	public static function getTotalZoneToGeoZoneByZoneId($zone_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM zone_to_geo_zone WHERE zone_id = " . (int)$zone_id);

		return $query->row['total'];
	}
}