<?php
class admin_localisation_language {
	public static function addLanguage($data) {
		db::query("INSERT INTO language SET name = " . esc($data['name']) . ", code = " . esc($data['code']) . ", locale = " . esc($data['locale']) . ", sort_order = " . (int)$data['sort_order'] . ", status = " . (int)$data['status']);

		cache::delete('catalog.language');
		cache::delete('admin.language');

		$language_id = db::getLastId();

		// Attribute
		$query = db::query("SELECT * FROM attribute_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $attribute) {
			db::query("INSERT INTO attribute_description SET attribute_id = " . (int)$attribute['attribute_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($attribute['name']));
		}

		// Attribute Group
		$query = db::query("SELECT * FROM attribute_group_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $attribute_group) {
			db::query("INSERT INTO attribute_group_description SET attribute_group_id = " . (int)$attribute_group['attribute_group_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($attribute_group['name']));
		}

		cache::delete('attribute');

		// Banner
		$query = db::query("SELECT * FROM banner_image WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $banner_image) {
			db::query("INSERT INTO banner_image SET banner_id = " . (int)$banner_image['banner_id'] . ", language_id = " . (int)$language_id . ", title = " . esc($banner_image['title']) . ", link = " . esc($banner_image['link']) . ", image = " . esc($banner_image['image']) . ", sort_order = " . (int)$banner_image['sort_order']);
		}

		cache::delete('banner');

		// Category
		$query = db::query("SELECT * FROM category_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $category) {
			db::query("INSERT INTO category_description SET category_id = " . (int)$category['category_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($category['name']) . ", description = " . esc($category['description']) . ", meta_title = " . esc($category['meta_title']) . ", meta_description = " . esc($category['meta_description']) . ", meta_keyword = " . esc($category['meta_keyword']));
		}

		cache::delete('category');

		// Customer Group
		$query = db::query("SELECT * FROM customer_group_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $customer_group) {
			db::query("INSERT INTO customer_group_description SET customer_group_id = " . (int)$customer_group['customer_group_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($customer_group['name']) . ", description = " . esc($customer_group['description']));
		}

		// Custom Field
		$query = db::query("SELECT * FROM custom_field_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $custom_field) {
			db::query("INSERT INTO custom_field_description SET custom_field_id = " . (int)$custom_field['custom_field_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($custom_field['name']));
		}

		// Custom Field Value
		$query = db::query("SELECT * FROM custom_field_value_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $custom_field_value) {
			db::query("INSERT INTO custom_field_value_description SET custom_field_value_id = " . (int)$custom_field_value['custom_field_value_id'] . ", language_id = " . (int)$language_id . ", custom_field_id = " . (int)$custom_field_value['custom_field_id'] . ", name = " . esc($custom_field_value['name']));
		}

		// Download
		$query = db::query("SELECT * FROM download_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $download) {
			db::query("INSERT INTO download_description SET download_id = " . (int)$download['download_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($download['name']));
		}

		// Filter
		$query = db::query("SELECT * FROM filter_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $filter) {
			db::query("INSERT INTO filter_description SET filter_id = " . (int)$filter['filter_id'] . ", language_id = " . (int)$language_id . ", filter_group_id = " . (int)$filter['filter_group_id'] . ", name = " . esc($filter['name']));
		}

		// Filter Group
		$query = db::query("SELECT * FROM filter_group_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $filter_group) {
			db::query("INSERT INTO filter_group_description SET filter_group_id = " . (int)$filter_group['filter_group_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($filter_group['name']));
		}

		// Information
		$query = db::query("SELECT * FROM information_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $information) {
			db::query("INSERT INTO information_description SET information_id = " . (int)$information['information_id'] . ", language_id = " . (int)$language_id . ", title = " . esc($information['title']) . ", description = " . esc($information['description']) . ", meta_title = " . esc($information['meta_title']) . ", meta_description = " . esc($information['meta_description']) . ", meta_keyword = " . esc($information['meta_keyword']));
		}

		cache::delete('information');

		// Length
		$query = db::query("SELECT * FROM length_class_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $length) {
			db::query("INSERT INTO length_class_description SET length_class_id = " . (int)$length['length_class_id'] . ", language_id = " . (int)$language_id . ", title = " . esc($length['title']) . ", unit = " . esc($length['unit']));
		}

		cache::delete('length_class');

		// Option
		$query = db::query("SELECT * FROM option_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $option) {
			db::query("INSERT INTO option_description SET option_id = " . (int)$option['option_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($option['name']));
		}

		// Option Value
		$query = db::query("SELECT * FROM option_value_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $option_value) {
			db::query("INSERT INTO option_value_description SET option_value_id = " . (int)$option_value['option_value_id'] . ", language_id = " . (int)$language_id . ", option_id = " . (int)$option_value['option_id'] . ", name = " . esc($option_value['name']));
		}

		// Order Status
		$query = db::query("SELECT * FROM order_status WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $order_status) {
			db::query("INSERT INTO order_status SET order_status_id = " . (int)$order_status['order_status_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($order_status['name']));
		}

		cache::delete('order_status');

		// Product
		$query = db::query("SELECT * FROM product_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $product) {
			db::query("INSERT INTO product_description SET product_id = " . (int)$product['product_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($product['name']) . ", description = " . esc($product['description']) . ", tag = '" . db::escape($product['tag']) . "', meta_title = " . esc($product['meta_title']) . ", meta_description = " . esc($product['meta_description']) . ", meta_keyword = " . esc($product['meta_keyword']));
		}

		cache::delete('product');

		// Product Attribute
		$query = db::query("SELECT * FROM product_attribute WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $product_attribute) {
			db::query("INSERT INTO product_attribute SET product_id = " . (int)$product_attribute['product_id'] . ", attribute_id = " . (int)$product_attribute['attribute_id'] . ", language_id = " . (int)$language_id . ", text = " . esc($product_attribute['text']));
		}

		// Return Action
		$query = db::query("SELECT * FROM return_action WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $return_action) {
			db::query("INSERT INTO return_action SET return_action_id = " . (int)$return_action['return_action_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($return_action['name']));
		}

		// Return Reason
		$query = db::query("SELECT * FROM return_reason WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $return_reason) {
			db::query("INSERT INTO return_reason SET return_reason_id = " . (int)$return_reason['return_reason_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($return_reason['name']));
		}

		// Return Status
		$query = db::query("SELECT * FROM return_status WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $return_status) {
			db::query("INSERT INTO return_status SET return_status_id = " . (int)$return_status['return_status_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($return_status['name']));
		}

		// Stock Status
		$query = db::query("SELECT * FROM stock_status WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $stock_status) {
			db::query("INSERT INTO stock_status SET stock_status_id = " . (int)$stock_status['stock_status_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($stock_status['name']));
		}

		cache::delete('stock_status');

		// Voucher Theme
		$query = db::query("SELECT * FROM voucher_theme_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $voucher_theme) {
			db::query("INSERT INTO voucher_theme_description SET voucher_theme_id = " . (int)$voucher_theme['voucher_theme_id'] . ", language_id = " . (int)$language_id . ", name = " . esc($voucher_theme['name']));
		}

		cache::delete('voucher_theme');

		// Weight Class
		$query = db::query("SELECT * FROM weight_class_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $weight_class) {
			db::query("INSERT INTO weight_class_description SET weight_class_id = " . (int)$weight_class['weight_class_id'] . ", language_id = " . (int)$language_id . ", title = " . esc($weight_class['title']) . ", unit = " . esc($weight_class['unit']));
		}

		cache::delete('weight_class');

		// Profiles
		$query = db::query("SELECT * FROM recurring_description WHERE language_id = " . config('language_id'));

		foreach ($query->rows as $recurring) {
			db::query("INSERT INTO recurring_description SET recurring_id = " . (int)$recurring['recurring_id'] . ", language_id = " . (int)$language_id . ", name = '" . db::escape($recurring['name'])."'");
		}

		return $language_id;
	}

	public static function editLanguage($language_id, $data) {
		$language_query = db::query("SELECT `code` FROM language WHERE language_id = " . (int)$language_id);
		
		db::query("UPDATE language SET name = " . esc($data['name']) . ", code = " . esc($data['code']) . ", locale = " . esc($data['locale']) . ", sort_order = " . (int)$data['sort_order'] . ", status = " . (int)$data['status'] . " WHERE language_id = " . (int)$language_id);

		if ($language_query->row['code'] != $data['code']) {
			db::query("UPDATE setting SET value = " . esc($data['code']) . " WHERE `key` = 'config_language' AND value = " . esc($language_query->row['code']));
			db::query("UPDATE setting SET value = " . esc($data['code']) . " WHERE `key` = 'config_admin_language' AND value = " . esc($language_query->row['code']));
		}
		
		cache::delete('catalog.language');
		cache::delete('admin.language');
	}
	
	public static function deleteLanguage($language_id) {
		db::query("DELETE FROM language WHERE language_id = " . (int)$language_id);
 		db::query("DELETE FROM seo_url WHERE language_id = " . (int)$language_id); 
		
		cache::delete('catalog.language');
		cache::delete('admin.language');

	}

	public static function getLanguage($language_id) {
		$query = db::query("SELECT DISTINCT * FROM language WHERE language_id = " . (int)$language_id);

		return $query->row;
	}

	public static function getLanguages($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM language";

			$sort_data = array(
				'name',
				'code',
				'sort_order'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY sort_order, name";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$language_data = cache::get('admin.language');

			if (!$language_data) {
				$language_data = array();

				$query = db::query("SELECT * FROM language ORDER BY sort_order, name");

				foreach ($query->rows as $result) {
					$language_data[$result['code']] = array(
						'language_id' => $result['language_id'],
						'name'        => $result['name'],
						'code'        => $result['code'],
						'locale'      => $result['locale'],
						'image'       => $result['image'],
						'directory'   => $result['directory'],
						'sort_order'  => $result['sort_order'],
						'status'      => $result['status']
					);
				}

				cache::set('admin.language', $language_data);
			}

			return $language_data;
		}
	}

	public static function getLanguageByCode($code) {
		$query = db::query("SELECT * FROM `language` WHERE code = " . esc($code));

		return $query->row;
	}

	public static function getTotalLanguages() {
		$query = db::query("SELECT COUNT(*) AS total FROM language");

		return $query->row['total'];
	}
}
