<?php
class admin_localisation_length_class {
	public static function addLengthClass($data) {
		db::query("INSERT INTO length_class SET value = '" . (float)$data['value'] . "'");

		$length_class_id = db::getLastId();

		foreach ($data['length_class_description'] as $language_id => $value) {
			db::query("INSERT INTO length_class_description SET length_class_id = " . (int)$length_class_id . ", language_id = " . (int)$language_id . ", title = " . esc($value['title']) . ", unit = " . esc($value['unit']));
		}

		cache::delete('length_class');
		
		return $length_class_id;
	}

	public static function editLengthClass($length_class_id, $data) {
		db::query("UPDATE length_class SET value = '" . (float)$data['value'] . "' WHERE length_class_id = " . (int)$length_class_id);

		db::query("DELETE FROM length_class_description WHERE length_class_id = " . (int)$length_class_id);

		foreach ($data['length_class_description'] as $language_id => $value) {
			db::query("INSERT INTO length_class_description SET length_class_id = " . (int)$length_class_id . ", language_id = " . (int)$language_id . ", title = " . esc($value['title']) . ", unit = " . esc($value['unit']));
		}

		cache::delete('length_class');
	}

	public static function deleteLengthClass($length_class_id) {
		db::query("DELETE FROM length_class WHERE length_class_id = " . (int)$length_class_id);
		db::query("DELETE FROM length_class_description WHERE length_class_id = " . (int)$length_class_id);

		cache::delete('length_class');
	}

	public static function getLengthClasses($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM length_class lc LEFT JOIN length_class_description lcd ON (lc.length_class_id = lcd.length_class_id) WHERE lcd.language_id = " . config('language_id');

			$sort_data = array(
				'title',
				'unit',
				'value'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY title";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$length_class_data = cache::get('length_class.' . config('language_id'));

			if (!$length_class_data) {
				$query = db::query("SELECT * FROM length_class lc LEFT JOIN length_class_description lcd ON (lc.length_class_id = lcd.length_class_id) WHERE lcd.language_id = " . config('language_id'));

				$length_class_data = $query->rows;

				cache::set('length_class.' . config('language_id'), $length_class_data);
			}

			return $length_class_data;
		}
	}

	public static function getLengthClass($length_class_id) {
		$query = db::query("SELECT * FROM length_class lc LEFT JOIN length_class_description lcd ON (lc.length_class_id = lcd.length_class_id) WHERE lc.length_class_id = " . (int)$length_class_id . " AND lcd.language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getLengthClassDescriptionByUnit($unit) {
		$query = db::query("SELECT * FROM length_class_description WHERE unit = " . esc($unit) . " AND language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getLengthClassDescriptions($length_class_id) {
		$length_class_data = array();

		$query = db::query("SELECT * FROM length_class_description WHERE length_class_id = " . (int)$length_class_id);

		foreach ($query->rows as $result) {
			$length_class_data[$result['language_id']] = array(
				'title' => $result['title'],
				'unit'  => $result['unit']
			);
		}

		return $length_class_data;
	}

	public static function getTotalLengthClasses() {
		$query = db::query("SELECT COUNT(*) AS total FROM length_class");

		return $query->row['total'];
	}
}