<?php
class admin_localisation_location {
	public static function addLocation($data) {
		db::query("INSERT INTO location SET name = " . esc($data['name']) . ", address = " . esc($data['address']) . ", geocode = " . esc($data['geocode']) . ", telephone = " . esc($data['telephone']) . ", fax = '" . db::escape($data['fax']) . "', image = " . esc($data['image']) . ", open = " . esc($data['open']) . ", comment = " . esc($data['comment']));
	
		return db::getLastId();
	}

	public static function editLocation($location_id, $data) {
		db::query("UPDATE location SET name = " . esc($data['name']) . ", address = " . esc($data['address']) . ", geocode = " . esc($data['geocode']) . ", telephone = " . esc($data['telephone']) . ", fax = '" . db::escape($data['fax']) . "', image = " . esc($data['image']) . ", open = " . esc($data['open']) . ", comment = " . esc($data['comment']) . " WHERE location_id = " . (int)$location_id);
	}

	public static function deleteLocation($location_id) {
		db::query("DELETE FROM location WHERE location_id = " . (int)$location_id);
	}

	public static function getLocation($location_id) {
		$query = db::query("SELECT DISTINCT * FROM location WHERE location_id = " . (int)$location_id);

		return $query->row;
	}

	public static function getLocations($data = array()) {
		$sql = "SELECT location_id, name, address FROM location";

		$sort_data = array(
			'name',
			'address',
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalLocations() {
		$query = db::query("SELECT COUNT(*) AS total FROM location");

		return $query->row['total'];
	}
}
