<?php
class admin_localisation_order_status {
	public static function addOrderStatus($data) {
		foreach ($data['order_status'] as $language_id => $value) {
			if (isset($order_status_id)) {
				db::query("INSERT INTO order_status SET order_status_id = " . (int)$order_status_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
			} else {
				db::query("INSERT INTO order_status SET language_id = " . (int)$language_id . ", name = " . esc($value['name']));

				$order_status_id = db::getLastId();
			}
		}

		cache::delete('order_status');
		
		return $order_status_id;
	}

	public static function editOrderStatus($order_status_id, $data) {
		db::query("DELETE FROM order_status WHERE order_status_id = " . (int)$order_status_id);

		foreach ($data['order_status'] as $language_id => $value) {
			db::query("INSERT INTO order_status SET order_status_id = " . (int)$order_status_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		cache::delete('order_status');
	}

	public static function deleteOrderStatus($order_status_id) {
		db::query("DELETE FROM order_status WHERE order_status_id = " . (int)$order_status_id);

		cache::delete('order_status');
	}

	public static function getOrderStatus($order_status_id) {
		$query = db::query("SELECT * FROM order_status WHERE order_status_id = " . (int)$order_status_id . " AND language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getOrderStatuses($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM order_status WHERE language_id = " . config('language_id');

			$sql .= " ORDER BY name";

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$order_status_data = cache::get('order_status.' . config('language_id'));

			if (!$order_status_data) {
				$query = db::query("SELECT order_status_id, name FROM order_status WHERE language_id = " . config('language_id') . " ORDER BY name");

				$order_status_data = $query->rows;

				cache::set('order_status.' . config('language_id'), $order_status_data);
			}

			return $order_status_data;
		}
	}

	public static function getOrderStatusDescriptions($order_status_id) {
		$order_status_data = array();

		$query = db::query("SELECT * FROM order_status WHERE order_status_id = " . (int)$order_status_id);

		foreach ($query->rows as $result) {
			$order_status_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $order_status_data;
	}

	public static function getTotalOrderStatuses() {
		$query = db::query("SELECT COUNT(*) AS total FROM order_status WHERE language_id = " . config('language_id'));

		return $query->row['total'];
	}
}