<?php
class admin_localisation_return_action {
	public static function addReturnAction($data) {
		foreach ($data['return_action'] as $language_id => $value) {
			if (isset($return_action_id)) {
				db::query("INSERT INTO return_action SET return_action_id = " . (int)$return_action_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
			} else {
				db::query("INSERT INTO return_action SET language_id = " . (int)$language_id . ", name = " . esc($value['name']));

				$return_action_id = db::getLastId();
			}
		}

		cache::delete('return_action');
		
		return $return_action_id;
	}

	public static function editReturnAction($return_action_id, $data) {
		db::query("DELETE FROM return_action WHERE return_action_id = " . (int)$return_action_id);

		foreach ($data['return_action'] as $language_id => $value) {
			db::query("INSERT INTO return_action SET return_action_id = " . (int)$return_action_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		cache::delete('return_action');
	}

	public static function deleteReturnAction($return_action_id) {
		db::query("DELETE FROM return_action WHERE return_action_id = " . (int)$return_action_id);

		cache::delete('return_action');
	}

	public static function getReturnAction($return_action_id) {
		$query = db::query("SELECT * FROM return_action WHERE return_action_id = " . (int)$return_action_id . " AND language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getReturnActions($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM return_action WHERE language_id = " . config('language_id');

			$sql .= " ORDER BY name";

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$return_action_data = cache::get('return_action.' . config('language_id'));

			if (!$return_action_data) {
				$query = db::query("SELECT return_action_id, name FROM return_action WHERE language_id = " . config('language_id') . " ORDER BY name");

				$return_action_data = $query->rows;

				cache::set('return_action.' . config('language_id'), $return_action_data);
			}

			return $return_action_data;
		}
	}

	public static function getReturnActionDescriptions($return_action_id) {
		$return_action_data = array();

		$query = db::query("SELECT * FROM return_action WHERE return_action_id = " . (int)$return_action_id);

		foreach ($query->rows as $result) {
			$return_action_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $return_action_data;
	}

	public static function getTotalReturnActions() {
		$query = db::query("SELECT COUNT(*) AS total FROM return_action WHERE language_id = " . config('language_id'));

		return $query->row['total'];
	}
}