<?php
class admin_localisation_return_reason {
	public static function addReturnReason($data) {
		foreach ($data['return_reason'] as $language_id => $value) {
			if (isset($return_reason_id)) {
				db::query("INSERT INTO return_reason SET return_reason_id = " . (int)$return_reason_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
			} else {
				db::query("INSERT INTO return_reason SET language_id = " . (int)$language_id . ", name = " . esc($value['name']));

				$return_reason_id = db::getLastId();
			}
		}

		cache::delete('return_reason');
		
		return $return_reason_id;
	}

	public static function editReturnReason($return_reason_id, $data) {
		db::query("DELETE FROM return_reason WHERE return_reason_id = " . (int)$return_reason_id);

		foreach ($data['return_reason'] as $language_id => $value) {
			db::query("INSERT INTO return_reason SET return_reason_id = " . (int)$return_reason_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		cache::delete('return_reason');
	}

	public static function deleteReturnReason($return_reason_id) {
		db::query("DELETE FROM return_reason WHERE return_reason_id = " . (int)$return_reason_id);

		cache::delete('return_reason');
	}

	public static function getReturnReason($return_reason_id) {
		$query = db::query("SELECT * FROM return_reason WHERE return_reason_id = " . (int)$return_reason_id . " AND language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getReturnReasons($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM return_reason WHERE language_id = " . config('language_id');

			$sql .= " ORDER BY name";

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$return_reason_data = cache::get('return_reason.' . config('language_id'));

			if (!$return_reason_data) {
				$query = db::query("SELECT return_reason_id, name FROM return_reason WHERE language_id = " . config('language_id') . " ORDER BY name");

				$return_reason_data = $query->rows;

				cache::set('return_reason.' . config('language_id'), $return_reason_data);
			}

			return $return_reason_data;
		}
	}

	public static function getReturnReasonDescriptions($return_reason_id) {
		$return_reason_data = array();

		$query = db::query("SELECT * FROM return_reason WHERE return_reason_id = " . (int)$return_reason_id);

		foreach ($query->rows as $result) {
			$return_reason_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $return_reason_data;
	}

	public static function getTotalReturnReasons() {
		$query = db::query("SELECT COUNT(*) AS total FROM return_reason WHERE language_id = " . config('language_id'));

		return $query->row['total'];
	}
}