<?php
class admin_localisation_return_status {
	public static function addReturnStatus($data) {
		foreach ($data['return_status'] as $language_id => $value) {
			if (isset($return_status_id)) {
				db::query("INSERT INTO return_status SET return_status_id = " . (int)$return_status_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
			} else {
				db::query("INSERT INTO return_status SET language_id = " . (int)$language_id . ", name = " . esc($value['name']));

				$return_status_id = db::getLastId();
			}
		}

		cache::delete('return_status');
		
		return $return_status_id;
	}

	public static function editReturnStatus($return_status_id, $data) {
		db::query("DELETE FROM return_status WHERE return_status_id = " . (int)$return_status_id);

		foreach ($data['return_status'] as $language_id => $value) {
			db::query("INSERT INTO return_status SET return_status_id = " . (int)$return_status_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		cache::delete('return_status');
	}

	public static function deleteReturnStatus($return_status_id) {
		db::query("DELETE FROM return_status WHERE return_status_id = " . (int)$return_status_id);

		cache::delete('return_status');
	}

	public static function getReturnStatus($return_status_id) {
		$query = db::query("SELECT * FROM return_status WHERE return_status_id = " . (int)$return_status_id . " AND language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getReturnStatuses($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM return_status WHERE language_id = " . config('language_id');

			$sql .= " ORDER BY name";

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$return_status_data = cache::get('return_status.' . config('language_id'));

			if (!$return_status_data) {
				$query = db::query("SELECT return_status_id, name FROM return_status WHERE language_id = " . config('language_id') . " ORDER BY name");

				$return_status_data = $query->rows;

				cache::set('return_status.' . config('language_id'), $return_status_data);
			}

			return $return_status_data;
		}
	}

	public static function getReturnStatusDescriptions($return_status_id) {
		$return_status_data = array();

		$query = db::query("SELECT * FROM return_status WHERE return_status_id = " . (int)$return_status_id);

		foreach ($query->rows as $result) {
			$return_status_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $return_status_data;
	}

	public static function getTotalReturnStatuses() {
		$query = db::query("SELECT COUNT(*) AS total FROM return_status WHERE language_id = " . config('language_id'));

		return $query->row['total'];
	}
}