<?php
class admin_localisation_stock_status {
	public static function addStockStatus($data) {
		foreach ($data['stock_status'] as $language_id => $value) {
			if (isset($stock_status_id)) {
				db::query("INSERT INTO stock_status SET stock_status_id = " . (int)$stock_status_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
			} else {
				db::query("INSERT INTO stock_status SET language_id = " . (int)$language_id . ", name = " . esc($value['name']));

				$stock_status_id = db::getLastId();
			}
		}

		cache::delete('stock_status');
		
		return $stock_status_id;
	}

	public static function editStockStatus($stock_status_id, $data) {
		db::query("DELETE FROM stock_status WHERE stock_status_id = " . (int)$stock_status_id);

		foreach ($data['stock_status'] as $language_id => $value) {
			db::query("INSERT INTO stock_status SET stock_status_id = " . (int)$stock_status_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		cache::delete('stock_status');
	}

	public static function deleteStockStatus($stock_status_id) {
		db::query("DELETE FROM stock_status WHERE stock_status_id = " . (int)$stock_status_id);

		cache::delete('stock_status');
	}

	public static function getStockStatus($stock_status_id) {
		$query = db::query("SELECT * FROM stock_status WHERE stock_status_id = " . (int)$stock_status_id . " AND language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getStockStatuses($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM stock_status WHERE language_id = " . config('language_id');

			$sql .= " ORDER BY name";

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$stock_status_data = cache::get('stock_status.' . config('language_id'));

			if (!$stock_status_data) {
				$query = db::query("SELECT stock_status_id, name FROM stock_status WHERE language_id = " . config('language_id') . " ORDER BY name");

				$stock_status_data = $query->rows;

				cache::set('stock_status.' . config('language_id'), $stock_status_data);
			}

			return $stock_status_data;
		}
	}

	public static function getStockStatusDescriptions($stock_status_id) {
		$stock_status_data = array();

		$query = db::query("SELECT * FROM stock_status WHERE stock_status_id = " . (int)$stock_status_id);

		foreach ($query->rows as $result) {
			$stock_status_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $stock_status_data;
	}

	public static function getTotalStockStatuses() {
		$query = db::query("SELECT COUNT(*) AS total FROM stock_status WHERE language_id = " . config('language_id'));

		return $query->row['total'];
	}
}