<?php
class admin_localisation_tax_class {
	public static function addTaxClass($data) {
		db::query("INSERT INTO tax_class SET title = " . esc($data['title']) . ", description = " . esc($data['description']) . ", date_added = NOW()");

		$tax_class_id = db::getLastId();

		if (isset($data['tax_rule'])) {
			foreach ($data['tax_rule'] as $tax_rule) {
				db::query("INSERT INTO tax_rule SET tax_class_id = " . (int)$tax_class_id . ", tax_rate_id = " . (int)$tax_rule['tax_rate_id'] . ", based = " . esc($tax_rule['based']) . ", priority = " . (int)$tax_rule['priority']);
			}
		}

		cache::delete('tax_class');
		
		return $tax_class_id;
	}

	public static function editTaxClass($tax_class_id, $data) {
		db::query("UPDATE tax_class SET title = " . esc($data['title']) . ", description = " . esc($data['description']) . ", date_modified = NOW() WHERE tax_class_id = " . (int)$tax_class_id);

		db::query("DELETE FROM tax_rule WHERE tax_class_id = " . (int)$tax_class_id);

		if (isset($data['tax_rule'])) {
			foreach ($data['tax_rule'] as $tax_rule) {
				db::query("INSERT INTO tax_rule SET tax_class_id = " . (int)$tax_class_id . ", tax_rate_id = " . (int)$tax_rule['tax_rate_id'] . ", based = " . esc($tax_rule['based']) . ", priority = " . (int)$tax_rule['priority']);
			}
		}

		cache::delete('tax_class');
	}

	public static function deleteTaxClass($tax_class_id) {
		db::query("DELETE FROM tax_class WHERE tax_class_id = " . (int)$tax_class_id);
		db::query("DELETE FROM tax_rule WHERE tax_class_id = " . (int)$tax_class_id);

		cache::delete('tax_class');
	}

	public static function getTaxClass($tax_class_id) {
		$query = db::query("SELECT * FROM tax_class WHERE tax_class_id = " . (int)$tax_class_id);

		return $query->row;
	}

	public static function getTaxClasses($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM tax_class";

			$sql .= " ORDER BY title";

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$tax_class_data = cache::get('tax_class');

			if (!$tax_class_data) {
				$query = db::query("SELECT * FROM tax_class");

				$tax_class_data = $query->rows;

				cache::set('tax_class', $tax_class_data);
			}

			return $tax_class_data;
		}
	}

	public static function getTotalTaxClasses() {
		$query = db::query("SELECT COUNT(*) AS total FROM tax_class");

		return $query->row['total'];
	}

	public static function getTaxRules($tax_class_id) {
		$query = db::query("SELECT * FROM tax_rule WHERE tax_class_id = " . (int)$tax_class_id . " ORDER BY priority ASC");

		return $query->rows;
	}

	public static function getTotalTaxRulesByTaxRateId($tax_rate_id) {
		$query = db::query("SELECT COUNT(DISTINCT tax_class_id) AS total FROM tax_rule WHERE tax_rate_id = " . (int)$tax_rate_id);

		return $query->row['total'];
	}
}