<?php
class admin_localisation_weight_class {
	public static function addWeightClass($data) {
		db::query("INSERT INTO weight_class SET value = '" . (float)$data['value'] . "'");

		$weight_class_id = db::getLastId();

		foreach ($data['weight_class_description'] as $language_id => $value) {
			db::query("INSERT INTO weight_class_description SET weight_class_id = " . (int)$weight_class_id . ", language_id = " . (int)$language_id . ", title = " . esc($value['title']) . ", unit = " . esc($value['unit']));
		}

		cache::delete('weight_class');
		
		return $weight_class_id;
	}

	public static function editWeightClass($weight_class_id, $data) {
		db::query("UPDATE weight_class SET value = '" . (float)$data['value'] . "' WHERE weight_class_id = " . (int)$weight_class_id);

		db::query("DELETE FROM weight_class_description WHERE weight_class_id = " . (int)$weight_class_id);

		foreach ($data['weight_class_description'] as $language_id => $value) {
			db::query("INSERT INTO weight_class_description SET weight_class_id = " . (int)$weight_class_id . ", language_id = " . (int)$language_id . ", title = " . esc($value['title']) . ", unit = " . esc($value['unit']));
		}

		cache::delete('weight_class');
	}

	public static function deleteWeightClass($weight_class_id) {
		db::query("DELETE FROM weight_class WHERE weight_class_id = " . (int)$weight_class_id);
		db::query("DELETE FROM weight_class_description WHERE weight_class_id = " . (int)$weight_class_id);

		cache::delete('weight_class');
	}

	public static function getWeightClasses($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM weight_class wc LEFT JOIN weight_class_description wcd ON (wc.weight_class_id = wcd.weight_class_id) WHERE wcd.language_id = " . config('language_id');

			$sort_data = array(
				'title',
				'unit',
				'value'
			);

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
				$sql .= " ORDER BY " . $data['sort'];
			} else {
				$sql .= " ORDER BY title";
			}

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$weight_class_data = cache::get('weight_class.' . config('language_id'));

			if (!$weight_class_data) {
				$query = db::query("SELECT * FROM weight_class wc LEFT JOIN weight_class_description wcd ON (wc.weight_class_id = wcd.weight_class_id) WHERE wcd.language_id = " . config('language_id'));

				$weight_class_data = $query->rows;

				cache::set('weight_class.' . config('language_id'), $weight_class_data);
			}

			return $weight_class_data;
		}
	}

	public static function getWeightClass($weight_class_id) {
		$query = db::query("SELECT * FROM weight_class wc LEFT JOIN weight_class_description wcd ON (wc.weight_class_id = wcd.weight_class_id) WHERE wc.weight_class_id = " . (int)$weight_class_id . " AND wcd.language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getWeightClassDescriptionByUnit($unit) {
		$query = db::query("SELECT * FROM weight_class_description WHERE unit = " . esc($unit) . " AND language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getWeightClassDescriptions($weight_class_id) {
		$weight_class_data = array();

		$query = db::query("SELECT * FROM weight_class_description WHERE weight_class_id = " . (int)$weight_class_id);

		foreach ($query->rows as $result) {
			$weight_class_data[$result['language_id']] = array(
				'title' => $result['title'],
				'unit'  => $result['unit']
			);
		}

		return $weight_class_data;
	}

	public static function getTotalWeightClasses() {
		$query = db::query("SELECT COUNT(*) AS total FROM weight_class");

		return $query->row['total'];
	}
}