<?php
class admin_localisation_zone {
	public static function addZone($data) {
		db::query("INSERT INTO zone SET status = " . (int)$data['status'] . ", name = " . esc($data['name']) . ", code = " . esc($data['code']) . ", country_id = " . (int)$data['country_id']);

		cache::delete('zone');
		
		return db::getLastId();
	}

	public static function editZone($zone_id, $data) {
		db::query("UPDATE zone SET status = " . (int)$data['status'] . ", name = " . esc($data['name']) . ", code = " . esc($data['code']) . ", country_id = " . (int)$data['country_id'] . " WHERE zone_id = " . (int)$zone_id);

		cache::delete('zone');
	}

	public static function deleteZone($zone_id) {
		db::query("DELETE FROM zone WHERE zone_id = " . (int)$zone_id);

		cache::delete('zone');
	}

	public static function getZone($zone_id) {
		$query = db::query("SELECT DISTINCT * FROM zone WHERE zone_id = " . (int)$zone_id);

		return $query->row;
	}

	public static function getZones($data = array()) {
		$sql = "SELECT *, z.name, c.name AS country FROM zone z LEFT JOIN country c ON (z.country_id = c.country_id)";

		$sort_data = array(
			'c.name',
			'z.name',
			'z.code'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY c.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getZonesByCountryId($country_id) {
		$zone_data = cache::get('zone.' . (int)$country_id);

		if (!$zone_data) {
			$query = db::query("SELECT * FROM zone WHERE country_id = " . (int)$country_id . " AND status = '1' ORDER BY name");

			$zone_data = $query->rows;

			cache::set('zone.' . (int)$country_id, $zone_data);
		}

		return $zone_data;
	}

	public static function getTotalZones() {
		$query = db::query("SELECT COUNT(*) AS total FROM zone");

		return $query->row['total'];
	}

	public static function getTotalZonesByCountryId($country_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM zone WHERE country_id = " . (int)$country_id);

		return $query->row['total'];
	}
}