<?php
class admin_marketing_coupon {
	public static function addCoupon($data) {
		db::query("INSERT INTO coupon SET name = " . esc($data['name']) . ", code = " . esc($data['code']) . ", discount = '" . (float)$data['discount'] . "', type = " . esc($data['type']) . ", total = '" . (float)$data['total'] . "', logged = " . (int)$data['logged'] . ", shipping = " . (int)$data['shipping'] . ", date_start = " . esc($data['date_start']) . ", date_end = " . esc($data['date_end']) . ", uses_total = " . (int)$data['uses_total'] . ", uses_customer = " . (int)$data['uses_customer'] . ", status = " . (int)$data['status'] . ", date_added = NOW()");

		$coupon_id = db::getLastId();

		if (isset($data['coupon_product'])) {
			foreach ($data['coupon_product'] as $product_id) {
				db::query("INSERT INTO coupon_product SET coupon_id = " . (int)$coupon_id . ", product_id = " . (int)$product_id);
			}
		}

		if (isset($data['coupon_category'])) {
			foreach ($data['coupon_category'] as $category_id) {
				db::query("INSERT INTO coupon_category SET coupon_id = " . (int)$coupon_id . ", category_id = " . (int)$category_id);
			}
		}

		return $coupon_id;
	}

	public static function editCoupon($coupon_id, $data) {
		db::query("UPDATE coupon SET name = " . esc($data['name']) . ", code = " . esc($data['code']) . ", discount = '" . (float)$data['discount'] . "', type = " . esc($data['type']) . ", total = '" . (float)$data['total'] . "', logged = " . (int)$data['logged'] . ", shipping = " . (int)$data['shipping'] . ", date_start = " . esc($data['date_start']) . ", date_end = " . esc($data['date_end']) . ", uses_total = " . (int)$data['uses_total'] . ", uses_customer = " . (int)$data['uses_customer'] . ", status = " . (int)$data['status'] . " WHERE coupon_id = " . (int)$coupon_id);

		db::query("DELETE FROM coupon_product WHERE coupon_id = " . (int)$coupon_id);

		if (isset($data['coupon_product'])) {
			foreach ($data['coupon_product'] as $product_id) {
				db::query("INSERT INTO coupon_product SET coupon_id = " . (int)$coupon_id . ", product_id = " . (int)$product_id);
			}
		}

		db::query("DELETE FROM coupon_category WHERE coupon_id = " . (int)$coupon_id);

		if (isset($data['coupon_category'])) {
			foreach ($data['coupon_category'] as $category_id) {
				db::query("INSERT INTO coupon_category SET coupon_id = " . (int)$coupon_id . ", category_id = " . (int)$category_id);
			}
		}
	}

	public static function deleteCoupon($coupon_id) {
		db::query("DELETE FROM coupon WHERE coupon_id = " . (int)$coupon_id);
		db::query("DELETE FROM coupon_product WHERE coupon_id = " . (int)$coupon_id);
		db::query("DELETE FROM coupon_category WHERE coupon_id = " . (int)$coupon_id);
		db::query("DELETE FROM coupon_history WHERE coupon_id = " . (int)$coupon_id);
	}

	public static function getCoupon($coupon_id) {
		$query = db::query("SELECT DISTINCT * FROM coupon WHERE coupon_id = " . (int)$coupon_id);

		return $query->row;
	}

	public static function getCouponByCode($code) {
		$query = db::query("SELECT DISTINCT * FROM coupon WHERE code = " . esc($code));

		return $query->row;
	}

	public static function getCoupons($data = array()) {
		$sql = "SELECT coupon_id, name, code, discount, date_start, date_end, status FROM coupon";

		$sort_data = array(
			'name',
			'code',
			'discount',
			'date_start',
			'date_end',
			'status'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getCouponProducts($coupon_id) {
		$coupon_product_data = array();

		$query = db::query("SELECT * FROM coupon_product WHERE coupon_id = " . (int)$coupon_id);

		foreach ($query->rows as $result) {
			$coupon_product_data[] = $result['product_id'];
		}

		return $coupon_product_data;
	}

	public static function getCouponCategories($coupon_id) {
		$coupon_category_data = array();

		$query = db::query("SELECT * FROM coupon_category WHERE coupon_id = " . (int)$coupon_id);

		foreach ($query->rows as $result) {
			$coupon_category_data[] = $result['category_id'];
		}

		return $coupon_category_data;
	}

	public static function getTotalCoupons() {
		$query = db::query("SELECT COUNT(*) AS total FROM coupon");

		return $query->row['total'];
	}

	public static function getCouponHistories($coupon_id, $start = 0, $limit = 10) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}

		$query = db::query("SELECT ch.order_id, CONCAT(c.firstname, ' ', c.lastname) AS customer, ch.amount, ch.date_added FROM coupon_history ch LEFT JOIN customer c ON (ch.customer_id = c.customer_id) WHERE ch.coupon_id = " . (int)$coupon_id . " ORDER BY ch.date_added ASC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalCouponHistories($coupon_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM coupon_history WHERE coupon_id = " . (int)$coupon_id);

		return $query->row['total'];
	}
}