<?php
class admin_marketing_marketing {
	public static function addMarketing($data) {
		db::query("INSERT INTO marketing SET name = " . esc($data['name']) . ", description = " . esc($data['description']) . ", code = " . esc($data['code']) . ", date_added = NOW()");

		return db::getLastId();
	}

	public static function editMarketing($marketing_id, $data) {
		db::query("UPDATE marketing SET name = " . esc($data['name']) . ", description = " . esc($data['description']) . ", code = " . esc($data['code']) . " WHERE marketing_id = " . (int)$marketing_id);
	}

	public static function deleteMarketing($marketing_id) {
		db::query("DELETE FROM marketing WHERE marketing_id = " . (int)$marketing_id);
	}

	public static function getMarketing($marketing_id) {
		$query = db::query("SELECT DISTINCT * FROM marketing WHERE marketing_id = " . (int)$marketing_id);

		return $query->row;
	}

	public static function getMarketingByCode($code) {
		$query = db::query("SELECT DISTINCT * FROM marketing WHERE code = " . esc($code));

		return $query->row;
	}

	public static function getMarketings($data = array()) {
		$implode = array();

		$order_statuses = config('complete_status');

		foreach ($order_statuses as $order_status_id) {
			$implode[] = "o.order_status_id = " . (int)$order_status_id;
		}

		$sql = "SELECT *, (SELECT COUNT(*) FROM `order` o WHERE (" . implode(" OR ", $implode) . ") AND o.marketing_id = m.marketing_id) AS orders FROM marketing m";

		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "m.name LIKE '" . db::escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_code'])) {
			$implode[] = "m.code = " . esc($data['filter_code']);
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(m.date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$sort_data = array(
			'm.name',
			'm.code',
			'm.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY m.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalMarketings($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM marketing";

		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "name LIKE " . esc($data['filter_name']);
		}

		if (!empty($data['filter_code'])) {
			$implode[] = "code = " . esc($data['filter_code']);
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$query = db::query($sql);

		return $query->row['total'];
	}
}