<?php
class admin_sale_return {
	public static function addReturn($data) {
		db::query("INSERT INTO `return` SET order_id = " . (int)$data['order_id'] . ", product_id = " . (int)$data['product_id'] . ", customer_id = " . (int)$data['customer_id'] . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", product = " . esc($data['product']) . ", model = " . esc($data['model']) . ", quantity = " . (int)$data['quantity'] . ", opened = " . (int)$data['opened'] . ", return_reason_id = " . (int)$data['return_reason_id'] . ", return_action_id = " . (int)$data['return_action_id'] . ", return_status_id = " . (int)$data['return_status_id'] . ", comment = " . esc($data['comment']) . ", date_ordered = " . esc($data['date_ordered']) . ", date_added = NOW(), date_modified = NOW()");
	
		return db::getLastId();
	}

	public static function editReturn($return_id, $data) {
		db::query("UPDATE `return` SET order_id = " . (int)$data['order_id'] . ", product_id = " . (int)$data['product_id'] . ", customer_id = " . (int)$data['customer_id'] . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", product = " . esc($data['product']) . ", model = " . esc($data['model']) . ", quantity = " . (int)$data['quantity'] . ", opened = " . (int)$data['opened'] . ", return_reason_id = " . (int)$data['return_reason_id'] . ", return_action_id = " . (int)$data['return_action_id'] . ", comment = " . esc($data['comment']) . ", date_ordered = " . esc($data['date_ordered']) . ", date_modified = NOW() WHERE return_id = " . (int)$return_id);
	}

	public static function deleteReturn($return_id) {
		db::query("DELETE FROM `return` WHERE `return_id` = " . (int)$return_id);
		db::query("DELETE FROM `return_history` WHERE `return_id` = " . (int)$return_id);
	}

	public static function getReturn($return_id) {
		$query = db::query("SELECT DISTINCT *, (SELECT CONCAT(c.firstname, ' ', c.lastname) FROM customer c WHERE c.customer_id = r.customer_id) AS customer, (SELECT rs.name FROM return_status rs WHERE rs.return_status_id = r.return_status_id AND rs.language_id = " . config('language_id') . ") AS return_status FROM `return` r WHERE r.return_id = " . (int)$return_id);

		return $query->row;
	}

	public static function getReturns($data = array()) {
		$sql = "SELECT *, CONCAT(r.firstname, ' ', r.lastname) AS customer, (SELECT rs.name FROM return_status rs WHERE rs.return_status_id = r.return_status_id AND rs.language_id = " . config('language_id') . ") AS return_status FROM `return` r";

		$implode = array();

		if (!empty($data['filter_return_id'])) {
			$implode[] = "r.return_id = " . (int)$data['filter_return_id'];
		}

		if (!empty($data['filter_order_id'])) {
			$implode[] = "r.order_id = " . (int)$data['filter_order_id'];
		}

		if (!empty($data['filter_customer'])) {
			$implode[] = "CONCAT(r.firstname, ' ', r.lastname) LIKE '" . db::escape($data['filter_customer']) . "%'";
		}

		if (!empty($data['filter_product'])) {
			$implode[] = "r.product = " . esc($data['filter_product']);
		}

		if (!empty($data['filter_model'])) {
			$implode[] = "r.model = " . esc($data['filter_model']);
		}

		if (!empty($data['filter_return_status_id'])) {
			$implode[] = "r.return_status_id = " . (int)$data['filter_return_status_id'];
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(r.date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if (!empty($data['filter_date_modified'])) {
			$implode[] = "DATE(r.date_modified) = DATE(" . esc($data['filter_date_modified']) . ")";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$sort_data = array(
			'r.return_id',
			'r.order_id',
			'customer',
			'r.product',
			'r.model',
			'status',
			'r.date_added',
			'r.date_modified'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY r.return_id";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalReturns($data = array()) {
		$sql = "SELECT COUNT(*) AS total FROM `return`r";

		$implode = array();

		if (!empty($data['filter_return_id'])) {
			$implode[] = "r.return_id = " . (int)$data['filter_return_id'];
		}

		if (!empty($data['filter_customer'])) {
			$implode[] = "CONCAT(r.firstname, ' ', r.lastname) LIKE '" . db::escape($data['filter_customer']) . "%'";
		}

		if (!empty($data['filter_order_id'])) {
			$implode[] = "r.order_id = " . esc($data['filter_order_id']);
		}

		if (!empty($data['filter_product'])) {
			$implode[] = "r.product = " . esc($data['filter_product']);
		}

		if (!empty($data['filter_model'])) {
			$implode[] = "r.model = " . esc($data['filter_model']);
		}

		if (!empty($data['filter_return_status_id'])) {
			$implode[] = "r.return_status_id = " . (int)$data['filter_return_status_id'];
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(r.date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if (!empty($data['filter_date_modified'])) {
			$implode[] = "DATE(r.date_modified) = DATE(" . esc($data['filter_date_modified']) . ")";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$query = db::query($sql);

		return $query->row['total'];
	}

	public static function getTotalReturnsByReturnStatusId($return_status_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM `return` WHERE return_status_id = " . (int)$return_status_id);

		return $query->row['total'];
	}

	public static function getTotalReturnsByReturnReasonId($return_reason_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM `return` WHERE return_reason_id = " . (int)$return_reason_id);

		return $query->row['total'];
	}

	public static function getTotalReturnsByReturnActionId($return_action_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM `return` WHERE return_action_id = " . (int)$return_action_id);

		return $query->row['total'];
	}
	
	public static function addReturnHistory($return_id, $return_status_id, $comment, $notify) {
		db::query("UPDATE `return` SET `return_status_id` = " . (int)$return_status_id . ", date_modified = NOW() WHERE return_id = " . (int)$return_id);
		db::query("INSERT INTO `return_history` SET `return_id` = " . (int)$return_id . ", return_status_id = " . (int)$return_status_id . ", notify = " . (int)$notify . ", comment = " . esc(strip_tags($comment)) . ", date_added = NOW()");
	}

	public static function getReturnHistories($return_id, $start = 0, $limit = 10) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}

		$query = db::query("SELECT rh.date_added, rs.name AS status, rh.comment, rh.notify FROM return_history rh LEFT JOIN return_status rs ON rh.return_status_id = rs.return_status_id WHERE rh.return_id = " . (int)$return_id . " AND rs.language_id = " . config('language_id') . " ORDER BY rh.date_added DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalReturnHistories($return_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM return_history WHERE return_id = " . (int)$return_id);

		return $query->row['total'];
	}

	public static function getTotalReturnHistoriesByReturnStatusId($return_status_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM return_history WHERE return_status_id = " . (int)$return_status_id);

		return $query->row['total'];
	}
}