<?php
class admin_sale_voucher {
	public static function addVoucher($data) {
		db::query("INSERT INTO voucher SET code = " . esc($data['code']) . ", from_name = " . esc($data['from_name']) . ", from_email = " . esc($data['from_email']) . ", to_name = " . esc($data['to_name']) . ", to_email = " . esc($data['to_email']) . ", voucher_theme_id = " . (int)$data['voucher_theme_id'] . ", message = " . esc($data['message']) . ", amount = '" . (float)$data['amount'] . "', status = " . (int)$data['status'] . ", date_added = NOW()");

		return db::getLastId();
	}

	public static function editVoucher($voucher_id, $data) {
		db::query("UPDATE voucher SET code = " . esc($data['code']) . ", from_name = " . esc($data['from_name']) . ", from_email = " . esc($data['from_email']) . ", to_name = " . esc($data['to_name']) . ", to_email = " . esc($data['to_email']) . ", voucher_theme_id = " . (int)$data['voucher_theme_id'] . ", message = " . esc($data['message']) . ", amount = '" . (float)$data['amount'] . "', status = " . (int)$data['status'] . " WHERE voucher_id = " . (int)$voucher_id);
	}

	public static function deleteVoucher($voucher_id) {
		db::query("DELETE FROM voucher WHERE voucher_id = " . (int)$voucher_id);
		db::query("DELETE FROM voucher_history WHERE voucher_id = " . (int)$voucher_id);
	}

	public static function getVoucher($voucher_id) {
		$query = db::query("SELECT DISTINCT * FROM voucher WHERE voucher_id = " . (int)$voucher_id);

		return $query->row;
	}

	public static function getVoucherByCode($code) {
		$query = db::query("SELECT DISTINCT * FROM voucher WHERE code = " . esc($code));

		return $query->row;
	}

	public static function getVouchers($data = array()) {
		$sql = "SELECT v.voucher_id, v.order_id, v.code, v.from_name, v.from_email, v.to_name, v.to_email, (SELECT vtd.name FROM voucher_theme_description vtd WHERE vtd.voucher_theme_id = v.voucher_theme_id AND vtd.language_id = " . config('language_id') . ") AS theme, v.amount, v.status, v.date_added FROM voucher v";

		$sort_data = array(
			'v.code',
			'v.from_name',
			'v.to_name',
			'theme',
			'v.amount',
			'v.status',
			'v.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY v.date_added";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalVouchers() {
		$query = db::query("SELECT COUNT(*) AS total FROM voucher");

		return $query->row['total'];
	}

	public static function getTotalVouchersByVoucherThemeId($voucher_theme_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM voucher WHERE voucher_theme_id = " . (int)$voucher_theme_id);

		return $query->row['total'];
	}

	public static function getVoucherHistories($voucher_id, $start = 0, $limit = 10) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}

		$query = db::query("SELECT vh.order_id, CONCAT(o.firstname, ' ', o.lastname) AS customer, vh.amount, vh.date_added FROM voucher_history vh LEFT JOIN `order` o ON (vh.order_id = o.order_id) WHERE vh.voucher_id = " . (int)$voucher_id . " ORDER BY vh.date_added ASC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalVoucherHistories($voucher_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM voucher_history WHERE voucher_id = " . (int)$voucher_id);

		return $query->row['total'];
	}
}
