<?php
class admin_sale_voucher_theme {
	public static function addVoucherTheme($data) {
		db::query("INSERT INTO voucher_theme SET image = " . esc($data['image']));

		$voucher_theme_id = db::getLastId();

		foreach ($data['voucher_theme_description'] as $language_id => $value) {
			db::query("INSERT INTO voucher_theme_description SET voucher_theme_id = " . (int)$voucher_theme_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		cache::delete('voucher_theme');
		
		return $voucher_theme_id;
	}

	public static function editVoucherTheme($voucher_theme_id, $data) {
		db::query("UPDATE voucher_theme SET image = " . esc($data['image']) . " WHERE voucher_theme_id = " . (int)$voucher_theme_id);

		db::query("DELETE FROM voucher_theme_description WHERE voucher_theme_id = " . (int)$voucher_theme_id);

		foreach ($data['voucher_theme_description'] as $language_id => $value) {
			db::query("INSERT INTO voucher_theme_description SET voucher_theme_id = " . (int)$voucher_theme_id . ", language_id = " . (int)$language_id . ", name = " . esc($value['name']));
		}

		cache::delete('voucher_theme');
	}

	public static function deleteVoucherTheme($voucher_theme_id) {
		db::query("DELETE FROM voucher_theme WHERE voucher_theme_id = " . (int)$voucher_theme_id);
		db::query("DELETE FROM voucher_theme_description WHERE voucher_theme_id = " . (int)$voucher_theme_id);

		cache::delete('voucher_theme');
	}

	public static function getVoucherTheme($voucher_theme_id) {
		$query = db::query("SELECT * FROM voucher_theme vt LEFT JOIN voucher_theme_description vtd ON (vt.voucher_theme_id = vtd.voucher_theme_id) WHERE vt.voucher_theme_id = " . (int)$voucher_theme_id . " AND vtd.language_id = " . config('language_id'));

		return $query->row;
	}

	public static function getVoucherThemes($data = array()) {
		if ($data) {
			$sql = "SELECT * FROM voucher_theme vt LEFT JOIN voucher_theme_description vtd ON (vt.voucher_theme_id = vtd.voucher_theme_id) WHERE vtd.language_id = " . config('language_id') . " ORDER BY vtd.name";

			if (isset($data['order']) && ($data['order'] == 'DESC')) {
				$sql .= " DESC";
			} else {
				$sql .= " ASC";
			}

			if (isset($data['start']) || isset($data['limit'])) {
				if ($data['start'] < 0) {
					$data['start'] = 0;
				}

				if ($data['limit'] < 1) {
					$data['limit'] = 20;
				}

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
			}

			$query = db::query($sql);

			return $query->rows;
		} else {
			$voucher_theme_data = cache::get('voucher_theme.' . config('language_id'));

			if (!$voucher_theme_data) {
				$query = db::query("SELECT * FROM voucher_theme vt LEFT JOIN voucher_theme_description vtd ON (vt.voucher_theme_id = vtd.voucher_theme_id) WHERE vtd.language_id = " . config('language_id') . " ORDER BY vtd.name");

				$voucher_theme_data = $query->rows;

				cache::set('voucher_theme.' . config('language_id'), $voucher_theme_data);
			}

			return $voucher_theme_data;
		}
	}

	public static function getVoucherThemeDescriptions($voucher_theme_id) {
		$voucher_theme_data = array();

		$query = db::query("SELECT * FROM voucher_theme_description WHERE voucher_theme_id = " . (int)$voucher_theme_id);

		foreach ($query->rows as $result) {
			$voucher_theme_data[$result['language_id']] = array('name' => $result['name']);
		}

		return $voucher_theme_data;
	}

	public static function getTotalVoucherThemes() {
		$query = db::query("SELECT COUNT(*) AS total FROM voucher_theme");

		return $query->row['total'];
	}
}