<?php
class admin_setting_event {
	public static function addEvent($code, $trigger, $action, $status = 1, $sort_order = 0) {
		db::query("INSERT INTO `event` SET `code` = " . esc($code) . ", `trigger` = " . esc($trigger) . ", `action` = " . esc($action) . ", `sort_order` = " . (int)$sort_order . ", `status` = " . (int)$status);
	
		return db::getLastId();
	}

	public static function deleteEvent($event_id) {
		db::query("DELETE FROM `event` WHERE `event_id` = " . (int)$event_id);
	}
	
	public static function deleteEventByCode($code) {
		db::query("DELETE FROM `event` WHERE `code` = " . esc($code));
	}

	public static function enableEvent($event_id) {
		db::query("UPDATE `event` SET `status` = '1' WHERE event_id = " . (int)$event_id);
	}
	
	public static function disableEvent($event_id) {
		db::query("UPDATE `event` SET `status` = '0' WHERE event_id = " . (int)$event_id);
	}
	
	public static function uninstall($type, $code) {
		db::query("DELETE FROM `extension` WHERE `type` = " . esc($type) . " AND `code` = " . esc($code));
		db::query("DELETE FROM `setting` WHERE `code` = " . esc($code));
	}

	public static function getEvent($event_id) {
		$query = db::query("SELECT DISTINCT * FROM `event` WHERE `event_id` = " . (int)$event_id . " LIMIT 1");

		return $query->row;
	}

	public static function getEventByCode($code) {
		$query = db::query("SELECT DISTINCT * FROM `event` WHERE `code` = " . esc($code) . " LIMIT 1");

		return $query->row;
	}
		
	public static function getEvents($data = array()) {
		$sql = "SELECT * FROM `event`";

		$sort_data = array(
			'code',
			'trigger',
			'action',
			'sort_order',
			'status',
			'date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY `" . $data['sort'] . "`";
		} else {
			$sql .= " ORDER BY `sort_order`";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalEvents() {
		$query = db::query("SELECT COUNT(*) AS total FROM `event`");

		return $query->row['total'];
	}
}