<?php
class admin_setting_extension {	
	public static function getInstalled($type) {
		$extension_data = array();

		$query = db::query("SELECT * FROM `extension` WHERE `type` = " . esc($type) . " ORDER BY `code`");

		foreach ($query->rows as $result) {
			$extension_data[] = $result['code'];
		}

		return $extension_data;
	}

	public static function install($type, $code) {
		$extensions = self::getInstalled($type);

		if (!in_array($code, $extensions)) {
			db::query("INSERT INTO `extension` SET `type` = " . esc($type) . ", `code` = " . esc($code));
		}
	}

	public static function uninstall($type, $code) {
		db::query("DELETE FROM `extension` WHERE `type` = " . esc($type) . " AND `code` = " . esc($code));
		db::query("DELETE FROM `setting` WHERE `code` = " . esc($type . '_' . $code));
	}	

	public static function addExtensionInstall($filename, $extension_download_id = 0) {
		db::query("INSERT INTO `extension_install` SET `filename` = " . esc($filename) . ", `extension_download_id` = " . (int)$extension_download_id . ", `date_added` = NOW()");
	
		return db::getLastId();
	}
	
	public static function deleteExtensionInstall($extension_install_id) {
		db::query("DELETE FROM `extension_install` WHERE `extension_install_id` = " . (int)$extension_install_id);
	}

	public static function getExtensionInstalls($start = 0, $limit = 10) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}		
		
		$query = db::query("SELECT * FROM `extension_install` ORDER BY date_added ASC LIMIT " . (int)$start . "," . (int)$limit);
	
		return $query->rows;
	}

	public static function getExtensionInstallByExtensionDownloadId($extension_download_id) {
		$query = db::query("SELECT * FROM `extension_install` WHERE `extension_download_id` = " . (int)$extension_download_id);

		return $query->row;
	}
		
	public static function getTotalExtensionInstalls() {
		$query = db::query("SELECT COUNT(*) AS total FROM `extension_install`");

		return $query->row['total'];
	}
		
	public static function addExtensionPath($extension_install_id, $path) {
		db::query("INSERT INTO `extension_path` SET `extension_install_id` = " . (int)$extension_install_id . ", `path` = " . esc($path) . ", `date_added` = NOW()");
	}
		
	public static function deleteExtensionPath($extension_path_id) {
		db::query("DELETE FROM `extension_path` WHERE `extension_path_id` = " . (int)$extension_path_id);
	}
	
	public static function getExtensionPathsByExtensionInstallId($extension_install_id) {
		$query = db::query("SELECT * FROM `extension_path` WHERE `extension_install_id` = " . (int)$extension_install_id . " ORDER BY `date_added` ASC");

		return $query->rows;
	}
}