<?php
class admin_setting_store {
	public static function addStore($data) {
		db::query("INSERT INTO store SET name = " . esc($data['config_name']) . ", `url` = " . esc($data['config_url']) . ", `ssl` = " . esc($data['config_ssl']));

		$store_id = db::getLastId();

		// Layout Route
		$query = db::query("SELECT * FROM layout_route WHERE store_id = '0'");

		foreach ($query->rows as $layout_route) {
			db::query("INSERT INTO layout_route SET layout_id = " . (int)$layout_route['layout_id'] . ", route = " . esc($layout_route['route']) . ", store_id = " . (int)$store_id);
		}

		cache::delete('store');

		return $store_id;
	}

	public static function editStore($store_id, $data) {
		db::query("UPDATE store SET name = " . esc($data['config_name']) . ", `url` = " . esc($data['config_url']) . ", `ssl` = " . esc($data['config_ssl']) . " WHERE store_id = " . (int)$store_id);

		cache::delete('store');
	}

	public static function deleteStore($store_id) {
		db::query("DELETE FROM store WHERE store_id = " . (int)$store_id);
		db::query("DELETE FROM layout_route WHERE store_id = " . (int)$store_id);

		cache::delete('store');
	}

	public static function getStore($store_id) {
		$query = db::query("SELECT DISTINCT * FROM store WHERE store_id = " . (int)$store_id);

		return $query->row;
	}

	public static function getStores($data = array()) {
		$store_data = cache::get('store');

		if (!$store_data) {
			$query = db::query("SELECT * FROM store ORDER BY url");

			$store_data = $query->rows;

			cache::set('store', $store_data);
		}

		return $store_data;
	}

	public static function getTotalStores() {
		$query = db::query("SELECT COUNT(*) AS total FROM store");

		return $query->row['total'];
	}

	public static function getTotalStoresByLayoutId($layout_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_layout_id' AND `value` = " . (int)$layout_id . " AND store_id != '0'");

		return $query->row['total'];
	}

	public static function getTotalStoresByLanguage($language) {
		$query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_language' AND `value` = " . esc($language) . " AND store_id != '0'");

		return $query->row['total'];
	}

	public static function getTotalStoresByCurrency($currency) {
		$query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_currency' AND `value` = " . esc($currency) . " AND store_id != '0'");

		return $query->row['total'];
	}

	public static function getTotalStoresByCountryId($country_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_country_id' AND `value` = " . (int)$country_id . " AND store_id != '0'");

		return $query->row['total'];
	}

	public static function getTotalStoresByZoneId($zone_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_zone_id' AND `value` = " . (int)$zone_id . " AND store_id != '0'");

		return $query->row['total'];
	}

	public static function getTotalStoresByCustomerGroupId($customer_group_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_customer_group_id' AND `value` = " . (int)$customer_group_id . " AND store_id != '0'");

		return $query->row['total'];
	}

	public static function getTotalStoresByInformationId($information_id) {
		$account_query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_account_id' AND `value` = " . (int)$information_id . " AND store_id != '0'");

		$checkout_query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_checkout_id' AND `value` = " . (int)$information_id . " AND store_id != '0'");

		return ($account_query->row['total'] + $checkout_query->row['total']);
	}

	public static function getTotalStoresByOrderStatusId($order_status_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM setting WHERE `key` = 'config_order_status_id' AND `value` = " . (int)$order_status_id . " AND store_id != '0'");

		return $query->row['total'];
	}
}