<?php
class admin_tool_image {
	public static function resize($filename, $width, $height) {
		if (!is_file('image/' . $filename) || substr(str_replace('\\', '/', realpath('image/' . $filename)), 0, strlen(DIR_IMAGE)) != str_replace('\\', '/', DIR_IMAGE)) {
			return;
		}

		$extension = pathinfo($filename, PATHINFO_EXTENSION);

		$image_old = $filename;
		$image_new = 'cache/' . utf8_substr($filename, 0, utf8_strrpos($filename, '.')) . '-' . $width . 'x' . $height . '.' . $extension;

		if (!is_file('image/' . $image_new) || (filemtime('image/' . $image_old) > filemtime('image/' . $image_new))) {
			list($width_orig, $height_orig, $image_type) = getimagesize('image/' . $image_old);
				 
			if (!in_array($image_type, array(IMAGETYPE_PNG, IMAGETYPE_JPEG, IMAGETYPE_GIF, IMAGETYPE_WEBP))) { 
				if (request::$server['HTTPS']) {
					return HTTPS_CATALOG . 'image/' . $image_old;
				} else {
					return HTTP_CATALOG . 'image/' . $image_old;
				}
			}
 
			$path = '';

			$directories = explode('/', dirname($image_new));

			foreach ($directories as $directory) {
				$path = $path . '/' . $directory;

				if (!is_dir('image/' . $path)) {
					@mkdir('image/' . $path, 0777);
				}
			}

			if ($width_orig != $width || $height_orig != $height) {
				image::init('image/' . $image_old);
				image::resize($width, $height);
				image::save('image/' . $image_new);
			} else {
				copy('image/' . $image_old, 'image/' . $image_new);
			}
		}

		if (request::$server['HTTPS']) {
			return HTTPS_CATALOG . 'image/' . $image_new;
		} else {
			return HTTP_CATALOG . 'image/' . $image_new;
		}
	}
}
