<?php
class admin_tool_upload {
	public static function addUpload($name, $filename) {
		$code = sha1(uniqid(mt_rand(), true));

		db::query("INSERT INTO `upload` SET `name` = " . esc($name) . ", `filename` = " . esc($filename) . ", `code` = " . esc($code) . ", `date_added` = NOW()");

		return $code;
	}
		
	public static function deleteUpload($upload_id) {
		db::query("DELETE FROM upload WHERE upload_id = " . (int)$upload_id);
	}

	public static function getUpload($upload_id) {
		$query = db::query("SELECT * FROM `upload` WHERE upload_id = " . (int)$upload_id);

		return $query->row;
	}

	public static function getUploadByCode($code) {
		$query = db::query("SELECT * FROM upload WHERE code = " . esc($code));

		return $query->row;
	}

	public static function getUploads($data = array()) {
		$sql = "SELECT * FROM upload";

		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "name LIKE '" . db::escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_filename'])) {
			$implode[] = "filename LIKE '" . db::escape($data['filter_filename']) . "%'";
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$sort_data = array(
			'name',
			'filename',
			'date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY date_added";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalUploads() {
		$sql = "SELECT COUNT(*) AS total FROM upload";

		$implode = array();

		if (!empty($data['filter_name'])) {
			$implode[] = "name LIKE '" . db::escape($data['filter_name']) . "%'";
		}

		if (!empty($data['filter_filename'])) {
			$implode[] = "filename LIKE '" . db::escape($data['filter_filename']) . "%'";
		}

		if (!empty($data['filter_date_added'])) {
			$implode[] = "DATE(date_added) = DATE(" . esc($data['filter_date_added']) . ")";
		}

		if ($implode) {
			$sql .= " WHERE " . implode(" AND ", $implode);
		}

		$query = db::query($sql);

		return $query->row['total'];
	}
}
