<?php
class admin_user_api {
	public static function addApi($data) {
		db::query("INSERT INTO `api` SET username = " . esc($data['username']) . ", `key` = " . esc($data['key']) . ", status = " . (int)$data['status'] . ", date_added = NOW(), date_modified = NOW()");

		$api_id = db::getLastId();

		if (isset($data['api_ip'])) {
			foreach ($data['api_ip'] as $ip) {
				if ($ip) {
					db::query("INSERT INTO `api_ip` SET api_id = " . (int)$api_id . ", ip = " . esc($ip));
				}
			}
		}
		
		return $api_id;
	}

	public static function editApi($api_id, $data) {
		db::query("UPDATE `api` SET username = " . esc($data['username']) . ", `key` = " . esc($data['key']) . ", status = " . (int)$data['status'] . ", date_modified = NOW() WHERE api_id = " . (int)$api_id);

		db::query("DELETE FROM api_ip WHERE api_id = " . (int)$api_id);

		if (isset($data['api_ip'])) {
			foreach ($data['api_ip'] as $ip) {
				if ($ip) {
					db::query("INSERT INTO `api_ip` SET api_id = " . (int)$api_id . ", ip = " . esc($ip));
				}
			}
		}
	}

	public static function deleteApi($api_id) {
		db::query("DELETE FROM `api` WHERE api_id = " . (int)$api_id);
	}

	public static function getApi($api_id) {
		$query = db::query("SELECT * FROM `api` WHERE api_id = " . (int)$api_id);

		return $query->row;
	}

	public static function getApis($data = array()) {
		$sql = "SELECT * FROM `api`";

		$sort_data = array(
			'username',
			'status',
			'date_added',
			'date_modified'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY username";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalApis() {
		$query = db::query("SELECT COUNT(*) AS total FROM `api`");

		return $query->row['total'];
	}

	public static function addApiIp($api_id, $ip) {
		db::query("INSERT INTO `api_ip` SET api_id = " . (int)$api_id . ", ip = " . esc($ip));
	}

	public static function getApiIps($api_id) {
		$query = db::query("SELECT * FROM `api_ip` WHERE api_id = " . (int)$api_id);

		return $query->rows;
	}

	public static function addApiSession($api_id, $session_id, $ip) {
		$api_ip_query = db::query("SELECT * FROM `api_ip` WHERE ip = " . esc($ip));
		
		if (!$api_ip_query->num_rows) {
			db::query("INSERT INTO `api_ip` SET api_id = " . (int)$api_id . ", ip = " . esc($ip));
		}
 		
		db::query("INSERT INTO `api_session` SET api_id = " . (int)$api_id . ", session_id = " . esc($session_id) . ", ip = '" . db::escape($ip) . "', date_added = NOW(), date_modified = NOW()");

		return db::getLastId();
	}
	
	public static function getApiSessions($api_id) {
		$query = db::query("SELECT * FROM `api_session` WHERE api_id = " . (int)$api_id);

		return $query->rows;
	}
	
	public static function deleteApiSession($api_session_id) {
		db::query("DELETE FROM `api_session` WHERE api_session_id = " . (int)$api_session_id);
	}
	
	public static function deleteApiSessionBySessionId($session_id) {
		db::query("DELETE FROM `api_session` WHERE session_id = " . esc($session_id));
	}		
}
