<?php
class admin_user_user {
	public static function addUser($data) {
		db::query("INSERT INTO `user` SET username = " . esc($data['username']) . ", user_group_id = " . (int)$data['user_group_id'] . ", salt = " . esc($salt = token(9)) . ", password = " . esc(sha1($salt . sha1($salt . sha1($data['password'])))) . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", image = " . esc($data['image']) . ", status = " . (int)$data['status'] . ", date_added = NOW()");
	
		return db::getLastId();
	}

	public static function editUser($user_id, $data) {
		db::query("UPDATE `user` SET username = " . esc($data['username']) . ", user_group_id = " . (int)$data['user_group_id'] . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", image = " . esc($data['image']) . ", status = " . (int)$data['status'] . " WHERE user_id = " . (int)$user_id);

		if ($data['password']) {
			db::query("UPDATE `user` SET salt = " . esc($salt = token(9)) . ", password = " . esc(sha1($salt . sha1($salt . sha1($data['password'])))) . " WHERE user_id = " . (int)$user_id);
		}
	}

	public static function editPassword($user_id, $password) {
		db::query("UPDATE `user` SET salt = " . esc($salt = token(9)) . ", password = " . esc(sha1($salt . sha1($salt . sha1($password)))) . ", code = '' WHERE user_id = " . (int)$user_id);
	}

	public static function editCode($email, $code) {
		db::query("UPDATE `user` SET code = " . esc($code) . " WHERE LCASE(email) = " . esc(utf8_strtolower($email)));
	}

	public static function deleteUser($user_id) {
		db::query("DELETE FROM `user` WHERE user_id = " . (int)$user_id);
	}

	public static function getUser($user_id) {
		$query = db::query("SELECT *, (SELECT ug.name FROM `user_group` ug WHERE ug.user_group_id = u.user_group_id) AS user_group FROM `user` u WHERE u.user_id = " . (int)$user_id);

		return $query->row;
	}

	public static function getUserByUsername($username) {
		$query = db::query("SELECT * FROM `user` WHERE username = " . esc($username));

		return $query->row;
	}

	public static function getUserByEmail($email) {
		$query = db::query("SELECT DISTINCT * FROM `user` WHERE LCASE(email) = " . esc(utf8_strtolower($email)));

		return $query->row;
	}

	public static function getUserByCode($code) {
		$query = db::query("SELECT * FROM `user` WHERE code = " . esc($code) . " AND code != ''");

		return $query->row;
	}

	public static function getUsers($data = array()) {
		$sql = "SELECT * FROM `user`";

		$sort_data = array(
			'username',
			'status',
			'date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY username";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalUsers() {
		$query = db::query("SELECT COUNT(*) AS total FROM `user`");

		return $query->row['total'];
	}

	public static function getTotalUsersByGroupId($user_group_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM `user` WHERE user_group_id = " . (int)$user_group_id);

		return $query->row['total'];
	}

	public static function getTotalUsersByEmail($email) {
		$query = db::query("SELECT COUNT(*) AS total FROM `user` WHERE LCASE(email) = " . esc(utf8_strtolower($email)));

		return $query->row['total'];
	}

	public static function addLoginAttempt($username) {
		$query = db::query("SELECT * FROM customer_login WHERE email = " . esc(utf8_strtolower((string)$username)));

		if (!$query->num_rows) {
			db::query("INSERT INTO customer_login SET email = " . esc(utf8_strtolower((string)$username)) . ", ip = '" . db::escape(request::$server['REMOTE_ADDR']) . "', total = 1, date_added = " . esc(date('Y-m-d H:i:s')) . ", date_modified = " . esc(date('Y-m-d H:i:s')));
		} else {
			db::query("UPDATE customer_login SET total = (total + 1), date_modified = " . esc(date('Y-m-d H:i:s')) . " WHERE customer_login_id = " . (int)$query->row['customer_login_id']);
		}
	}

	public static function getLoginAttempts($username) {
		$query = db::query("SELECT * FROM `customer_login` WHERE email = " . esc(utf8_strtolower($username)));

		return $query->row;
	}

	public static function deleteLoginAttempts($username) {
		db::query("DELETE FROM `customer_login` WHERE email = " . esc(utf8_strtolower($username)));
	}
}