<?php
class admin_user_user_group {
	public static function addUserGroup($data) {
		db::query("INSERT INTO user_group SET name = " . esc($data['name']) . ", permission = '" . (isset($data['permission']) ? db::escape(json_encode($data['permission'])) : '') . "'");
	
		return db::getLastId();
	}

	public static function editUserGroup($user_group_id, $data) {
		db::query("UPDATE user_group SET name = " . esc($data['name']) . ", permission = '" . (isset($data['permission']) ? db::escape(json_encode($data['permission'])) : '') . "' WHERE user_group_id = " . (int)$user_group_id);
	}

	public static function deleteUserGroup($user_group_id) {
		db::query("DELETE FROM user_group WHERE user_group_id = " . (int)$user_group_id);
	}

	public static function getUserGroup($user_group_id) {
		$query = db::query("SELECT DISTINCT * FROM user_group WHERE user_group_id = " . (int)$user_group_id);

		$user_group = array(
			'name'       => $query->row['name'],
			'permission' => json_decode($query->row['permission'], true)
		);

		return $user_group;
	}

	public static function getUserGroups($data = array()) {
		$sql = "SELECT * FROM user_group";

		$sql .= " ORDER BY name";

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = db::query($sql);

		return $query->rows;
	}

	public static function getTotalUserGroups() {
		$query = db::query("SELECT COUNT(*) AS total FROM user_group");

		return $query->row['total'];
	}

	public static function addPermission($user_group_id, $type, $route) {
		$user_group_query = db::query("SELECT DISTINCT * FROM user_group WHERE user_group_id = " . (int)$user_group_id);

		if ($user_group_query->num_rows) {
			$data = json_decode($user_group_query->row['permission'], true);

			$data[$type][] = $route;

			db::query("UPDATE user_group SET permission = " . esc(json_encode($data)) . " WHERE user_group_id = " . (int)$user_group_id);
		}
	}

	public static function removePermission($user_group_id, $type, $route) {
		$user_group_query = db::query("SELECT DISTINCT * FROM user_group WHERE user_group_id = " . (int)$user_group_id);

		if ($user_group_query->num_rows) {
			$data = json_decode($user_group_query->row['permission'], true);

			$data[$type] = array_diff($data[$type], array($route));

			db::query("UPDATE user_group SET permission = " . esc(json_encode($data)) . " WHERE user_group_id = " . (int)$user_group_id);
		}
	}
}