<?php
class ControllerAccountAffiliate {
	private static $error = array();

	public static function add() {
		if (!customer::isLogged()) {
			session::$data['redirect'] = url::link('account/affiliate', '');

			response::redirect(url::link('affiliate/login', ''));
		}

		load::language('account/affiliate');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			account_customer::addAffiliate(customer::getId(), request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('account/account', ''));
		}
		
		self::getForm();
	}
	
	public static function edit() {
		if (!customer::isLogged()) {
			session::$data['redirect'] = url::link('account/affiliate', '');

			response::redirect(url::link('affiliate/login', ''));
		}

		load::language('account/affiliate');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			account_customer::editAffiliate(customer::getId(), request::$post);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('account/account', ''));
		}
		
		self::getForm();
	}
		
	public static function getForm() {
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_account'),
			'href' => url::link('account/account', '')
		);

		if (request::$get['route'] == 'account/affiliate/add') {
			$data['breadcrumbs'][] = array(
				'text' => language::get('text_affiliate'),
				'href' => url::link('account/affiliate/add', '')
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => language::get('text_affiliate'),
				'href' => url::link('account/affiliate/edit', '')
			);		
		}
	
		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}
				
		if (isset(self::$error['cheque'])) {
			$data['error_cheque'] = self::$error['cheque'];
		} else {
			$data['error_cheque'] = '';
		}

		if (isset(self::$error['paypal'])) {
			$data['error_paypal'] = self::$error['paypal'];
		} else {
			$data['error_paypal'] = '';
		}

		if (isset(self::$error['bank_account_name'])) {
			$data['error_bank_account_name'] = self::$error['bank_account_name'];
		} else {
			$data['error_bank_account_name'] = '';
		}

		if (isset(self::$error['bank_account_number'])) {
			$data['error_bank_account_number'] = self::$error['bank_account_number'];
		} else {
			$data['error_bank_account_number'] = '';
		}
		
		if (isset(self::$error['custom_field'])) {
			$data['error_custom_field'] = self::$error['custom_field'];
		} else {
			$data['error_custom_field'] = array();
		}
				
		$data['action'] = url::link(request::$get['route'], '');
		
		if (request::$get['route'] == 'account/affiliate/edit' && request::$server['REQUEST_METHOD'] != 'POST') {
			$affiliate_info = account_customer::getAffiliate(customer::getId());
		}
		
		if (isset(request::$post['company'])) {
			$data['company'] = request::$post['company'];
		} elseif (!empty($affiliate_info)) {
			$data['company'] = $affiliate_info['company'];
		} else {
			$data['company'] = '';
		}
		
		if (isset(request::$post['website'])) {
			$data['website'] = request::$post['website'];
		} elseif (!empty($affiliate_info)) {
			$data['website'] = $affiliate_info['website'];
		} else {
			$data['website'] = '';
		}
				
		if (isset(request::$post['tax'])) {
			$data['tax'] = request::$post['tax'];
		} elseif (!empty($affiliate_info)) {
			$data['tax'] = $affiliate_info['tax'];
		} else {
			$data['tax'] = '';
		}

		if (isset(request::$post['payment'])) {
			$data['payment'] = request::$post['payment'];
		} elseif (!empty($affiliate_info)) {
			$data['payment'] = $affiliate_info['payment'];
		} else {
			$data['payment'] = 'cheque';
		}

		if (isset(request::$post['cheque'])) {
			$data['cheque'] = request::$post['cheque'];
		} elseif (!empty($affiliate_info)) {
			$data['cheque'] = $affiliate_info['cheque'];
		} else {
			$data['cheque'] = '';
		}

		if (isset(request::$post['paypal'])) {
			$data['paypal'] = request::$post['paypal'];
		} elseif (!empty($affiliate_info)) {
			$data['paypal'] = $affiliate_info['paypal'];
		} else {
			$data['paypal'] = '';
		}

		if (isset(request::$post['bank_name'])) {
			$data['bank_name'] = request::$post['bank_name'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_name'] = $affiliate_info['bank_name'];
		} else {
			$data['bank_name'] = '';
		}

		if (isset(request::$post['bank_branch_number'])) {
			$data['bank_branch_number'] = request::$post['bank_branch_number'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_branch_number'] = $affiliate_info['bank_branch_number'];
		} else {
			$data['bank_branch_number'] = '';
		}

		if (isset(request::$post['bank_swift_code'])) {
			$data['bank_swift_code'] = request::$post['bank_swift_code'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_swift_code'] = $affiliate_info['bank_swift_code'];
		} else {
			$data['bank_swift_code'] = '';
		}

		if (isset(request::$post['bank_account_name'])) {
			$data['bank_account_name'] = request::$post['bank_account_name'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_account_name'] = $affiliate_info['bank_account_name'];
		} else {
			$data['bank_account_name'] = '';
		}

		if (isset(request::$post['bank_account_number'])) {
			$data['bank_account_number'] = request::$post['bank_account_number'];
		} elseif (!empty($affiliate_info)) {
			$data['bank_account_number'] = $affiliate_info['bank_account_number'];
		} else {
			$data['bank_account_number'] = '';
		}

		// Custom Fields

		$data['custom_fields'] = account_custom_field::getCustomFields(config('customer_group_id'));

		if (isset(request::$post['custom_field'])) {
			$data['affiliate_custom_field'] = request::$post['custom_field'];
		} elseif (isset($affiliate_info)) {
			$data['affiliate_custom_field'] = json_decode($affiliate_info['custom_field'], true);
		} else {
			$data['affiliate_custom_field'] = array();
		}

		$affiliate_info = account_customer::getAffiliate(customer::getId());

		if (!$affiliate_info && config('affiliate_id')) {

			$information_info = catalog_information::getInformation(config('affiliate_id'));

			if ($information_info) {
				$data['text_agree'] = sprintf(language::get('text_agree'), url::link('information/information/agree', 'information_id=' . config('affiliate_id')), $information_info['title']);
			} else {
				$data['text_agree'] = '';
			}
		} else {
			$data['text_agree'] = '';
		}

		if (isset(request::$post['agree'])) {
			$data['agree'] = request::$post['agree'];
		} else {
			$data['agree'] = false;
		}
		
		$data['back'] = url::link('account/account', '');

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('account/affiliate', $data));
	}
	
	protected static function validate() {
		if (request::$post['payment'] == 'cheque' && !request::$post['cheque']) {
			self::$error['cheque'] = language::get('error_cheque');
		} elseif ((request::$post['payment'] == 'paypal') && ((utf8_strlen(request::$post['paypal']) > 96) || !filter_var(request::$post['paypal'], FILTER_VALIDATE_EMAIL))) {
			self::$error['paypal'] = language::get('error_paypal');
		} elseif (request::$post['payment'] == 'bank') {
			if (request::$post['bank_account_name'] == '') {
				self::$error['bank_account_name'] = language::get('error_bank_account_name');
			}
	
			if (request::$post['bank_account_number'] == '') {
				self::$error['bank_account_number'] = language::get('error_bank_account_number');
			}
		}
		
		// Custom field validation

		$custom_fields = account_custom_field::getCustomFields(config('customer_group_id'));

		foreach ($custom_fields as $custom_field) {
			if ($custom_field['location'] == 'affiliate') {
				if ($custom_field['required'] && empty(request::$post['custom_field'][$custom_field['location']][$custom_field['custom_field_id']])) {
					self::$error['custom_field'][$custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
				} elseif (($custom_field['type'] == 'text') && !empty($custom_field['validation']) && !filter_var(request::$post['custom_field'][$custom_field['location']][$custom_field['custom_field_id']], FILTER_VALIDATE_REGEXP, array('options' => array('regexp' => $custom_field['validation'])))) {
					self::$error['custom_field'][$custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
				}
			}
		}			
		
		// Validate agree only if customer not already an affiliate
		$affiliate_info = account_customer::getAffiliate(customer::getId());
				
		if (!$affiliate_info && config('affiliate_id')) {

			$information_info = catalog_information::getInformation(config('affiliate_id'));

			if ($information_info && !isset(request::$post['agree'])) {
				self::$error['warning'] = sprintf(language::get('error_agree'), $information_info['title']);
			}
		}

		return !self::$error;
	}	
}