<?php
class ControllerAccountForgotten {
	private static $error = array();

	public static function index() {
		if (customer::isLogged()) {
			response::redirect(url::link('account/account', ''));
		}

		load::language('account/forgotten');

		document::setTitle(language::get('heading_title'));


		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
			account_customer::editCode(request::$post['email'], token(40));

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('account/login', ''));
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_account'),
			'href' => url::link('account/account', '')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_forgotten'),
			'href' => url::link('account/forgotten', '')
		);

		if (isset(self::$error['warning'])) {
			$data['error_warning'] = self::$error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['action'] = url::link('account/forgotten', '');

		$data['back'] = url::link('account/login', '');

		if (isset(request::$post['email'])) {
			$data['email'] = request::$post['email'];
		} else {
			$data['email'] = '';
		}

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('account/forgotten', $data));
	}

	protected static function validate() {
		if (!isset(request::$post['email'])) {
			self::$error['warning'] = language::get('error_email');
		} elseif (!account_customer::getTotalCustomersByEmail(request::$post['email'])) {
			self::$error['warning'] = language::get('error_email');
		}
		
		// Check if customer has been approved.
		$customer_info = account_customer::getCustomerByEmail(request::$post['email']);

		if ($customer_info && !$customer_info['status']) {
			self::$error['warning'] = language::get('error_approved');
		}

		return !self::$error;
	}
}
