<?php
class ControllerAccountLogout {
	public static function index() {
		if (customer::isLogged()) {
			customer::logout();

			unset(session::$data['shipping_address']);
			unset(session::$data['shipping_method']);
			unset(session::$data['shipping_methods']);
			unset(session::$data['payment_address']);
			unset(session::$data['payment_method']);
			unset(session::$data['payment_methods']);
			unset(session::$data['comment']);
			unset(session::$data['order_id']);
			unset(session::$data['coupon']);
			unset(session::$data['reward']);
			unset(session::$data['voucher']);
			unset(session::$data['vouchers']);

			response::redirect(url::link('account/logout', ''));
		}

		load::language('account/logout');

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_account'),
			'href' => url::link('account/account', '')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_logout'),
			'href' => url::link('account/logout', '')
		);

		$data['continue'] = url::link('common/home');

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('common/success', $data));
	}
}
