<?php
class ControllerAccountNewsletter {
	public static function index() {
		if (!customer::isLogged()) {
			session::$data['redirect'] = url::link('account/newsletter', '');

			response::redirect(url::link('account/login', ''));
		}

		load::language('account/newsletter');

		document::setTitle(language::get('heading_title'));

		if (request::$server['REQUEST_METHOD'] == 'POST') {

			account_customer::editNewsletter(request::$post['newsletter']);

			session::$data['success'] = language::get('text_success');

			response::redirect(url::link('account/account', ''));
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_account'),
			'href' => url::link('account/account', '')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_newsletter'),
			'href' => url::link('account/newsletter', '')
		);

		$data['action'] = url::link('account/newsletter', '');

		$data['newsletter'] = customer::getNewsletter();

		$data['back'] = url::link('account/account', '');

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('account/newsletter', $data));
	}
}