<?php
class ControllerAccountReset {
	private static $error = array();

	public static function index() {
		if (customer::isLogged()) {
			response::redirect(url::link('account/account', ''));
		}

		if (isset(request::$get['code'])) {
			$code = request::$get['code'];
		} else {
			$code = '';
		}


		$customer_info = account_customer::getCustomerByCode($code);

		if ($customer_info) {
			load::language('account/reset');

			document::setTitle(language::get('heading_title'));

			if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validate()) {
				account_customer::editPassword($customer_info['email'], request::$post['password']);

				session::$data['success'] = language::get('text_success');

				response::redirect(url::link('account/login', ''));
			}

			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_home'),
				'href' => url::link('common/home')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_account'),
				'href' => url::link('account/account', '')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('account/reset', '')
			);

			if (isset(self::$error['password'])) {
				$data['error_password'] = self::$error['password'];
			} else {
				$data['error_password'] = '';
			}

			if (isset(self::$error['confirm'])) {
				$data['error_confirm'] = self::$error['confirm'];
			} else {
				$data['error_confirm'] = '';
			}

			$data['action'] = url::link('account/reset', 'code=' . $code);

			$data['back'] = url::link('account/login', '');

			if (isset(request::$post['password'])) {
				$data['password'] = request::$post['password'];
			} else {
				$data['password'] = '';
			}

			if (isset(request::$post['confirm'])) {
				$data['confirm'] = request::$post['confirm'];
			} else {
				$data['confirm'] = '';
			}

			$data['column_left'] = load::controller('common/column_left');
			$data['column_right'] = load::controller('common/column_right');
			$data['content_top'] = load::controller('common/content_top');
			$data['content_bottom'] = load::controller('common/content_bottom');
			$data['footer'] = load::controller('common/footer');
			$data['header'] = load::controller('common/header');

			response::setOutput(load::view('account/reset', $data));
		} else {
			load::language('account/reset');

			session::$data['error'] = language::get('error_code');

			return 'account/login';
		}
	}

	protected static function validate() {
		if ((utf8_strlen(html_entity_decode(request::$post['password'], ENT_QUOTES, 'UTF-8')) < 4) || (utf8_strlen(html_entity_decode(request::$post['password'], ENT_QUOTES, 'UTF-8')) > 40)) {
			self::$error['password'] = language::get('error_password');
		}

		if (request::$post['confirm'] != request::$post['password']) {
			self::$error['confirm'] = language::get('error_confirm');
		}

		return !self::$error;
	}
}
