<?php
class ControllerAccountTracking {
	public static function index() {
		if (!customer::isLogged()) {
			session::$data['redirect'] = url::link('account/tracking', '');

			response::redirect(url::link('account/login', ''));
		}


		$affiliate_info = account_customer::getAffiliate(customer::getId());
			
		if ($affiliate_info) {
			load::language('account/tracking');
	
			document::setTitle(language::get('heading_title'));
	
			$data['breadcrumbs'] = array();
	
			$data['breadcrumbs'][] = array(
				'text' => language::get('text_home'),
				'href' => url::link('common/home')
			);
	
			$data['breadcrumbs'][] = array(
				'text' => language::get('text_account'),
				'href' => url::link('account/account', '')
			);
	
			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link('account/tracking', '')
			);
	
			$data['text_description'] = sprintf(language::get('text_description'), config('name'));
	
			$data['code'] = $affiliate_info['tracking'];
	
			$data['continue'] = url::link('account/account', '');
	
			$data['column_left'] = load::controller('common/column_left');
			$data['column_right'] = load::controller('common/column_right');
			$data['content_top'] = load::controller('common/content_top');
			$data['content_bottom'] = load::controller('common/content_bottom');
			$data['footer'] = load::controller('common/footer');
			$data['header'] = load::controller('common/header');
	
			response::setOutput(load::view('account/tracking', $data));
		} else {
			return 'error/not_found';
		}
	}

	public static function autocomplete() {
		$json = array();

		if (isset(request::$get['filter_name'])) {
			if (isset(request::$get['tracking'])) {
				$tracking = request::$get['tracking'];
			} else {
				$tracking = '';
			}
			

			$filter_data = array(
				'filter_name' => request::$get['filter_name'],
				'start'       => 0,
				'limit'       => 5
			);

			$results = catalog_product::getProducts($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'name' => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8')),
					'link' => str_replace('&amp;', '&', url::link('product/product', 'product_id=' . $result['product_id'] . '&tracking=' . $tracking))
				);
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}