<?php
class ControllerAffiliateSuccess {
	public static function index() {
		load::language('affiliate/success');

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_account'),
			'href' => url::link('account/account', '')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_success'),
			'href' => url::link('affiliate/success')
		);


		$customer_group_info = account_customer_group::getCustomerGroup(config('customer_group_id'));

		if (!config('affiliate_approval') && customer::isLogged()) {
			$data['text_message'] = sprintf(language::get('text_message'), config('name'), url::link('information/contact'));
		} else {
			$data['text_message'] = sprintf(language::get('text_approval'), config('name'), url::link('information/contact'));
		}
		
		$data['button_continue'] = language::get('button_continue');

		$data['continue'] = url::link('account/account', '');

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('common/success', $data));
	}
}