<?php
class ControllerApiLogin {
	public static function index() {
		load::language('api/login');

		$json = $api_info = array();


		// Login with API Key
		if (isset(request::$post['username']) && isset(request::$post['key'])) {
			$api_info = account_api::login(request::$post['username'], request::$post['key']);
		} elseif (isset(request::$post['key'])) {
			$api_info = account_api::login('Default', request::$post['key']);
		}

		if ($api_info) {
			// Check if IP is allowed
			$ip_data = array();
	
			$results = account_api::getApiIps($api_info['api_id']);
	
			foreach ($results as $result) {
				$ip_data[] = trim($result['ip']);
			}
	
			if (!in_array(request::$server['REMOTE_ADDR'], $ip_data)) {
				$json['error']['ip'] = sprintf(language::get('error_ip'), request::$server['REMOTE_ADDR']);
			}				
				
			if (!$json) {
				$json['success'] = language::get('text_success');
				
				$session = new Session(config::get('session_engine'));
				
				$session::start();
				
				account_api::addApiSession($api_info['api_id'], $session::getId(), request::$server['REMOTE_ADDR']);
				
				$session::$data['api_id'] = $api_info['api_id'];
				
				// Create Token
				$json['api_token'] = $session::getId();
			} else {
				$json['error']['key'] = language::get('error_key');
			}
		}
		
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
