<?php
class ControllerApiReward {
	public static function index() {
		load::language('api/reward');

		// Delete past reward in case there is an error
		unset(session::$data['reward']);

		$json = array();

		if (!isset(session::$data['api_id'])) {
			$json['error'] = language::get('error_permission');
		} else {
			$points = customer::getRewardPoints();

			$points_total = 0;

			foreach (cart::getProducts() as $product) {
				if ($product['points']) {
					$points_total += $product['points'];
				}
			}

			if (empty(request::$post['reward'])) {
				$json['error'] = language::get('error_reward');
			}

			if (request::$post['reward'] > $points) {
				$json['error'] = sprintf(language::get('error_points'), request::$post['reward']);
			}

			if (request::$post['reward'] > $points_total) {
				$json['error'] = sprintf(language::get('error_maximum'), $points_total);
			}

			if (!$json) {
				session::$data['reward'] = abs(request::$post['reward']);

				$json['success'] = language::get('text_success');
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function maximum() {
		load::language('api/reward');

		$json = array();

		if (!isset(session::$data['api_id'])) {
			$json['error'] = language::get('error_permission');
		} else {
			$json['maximum'] = 0;

			foreach (cart::getProducts() as $product) {
				if ($product['points']) {
					$json['maximum'] += $product['points'];
				}
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function available() {
		load::language('api/reward');

		$json = array();

		if (!isset(session::$data['api_id'])) {
			$json['error'] = language::get('error_permission');
		} else {
			$json['points'] = customer::getRewardPoints();
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
