<?php
class ControllerCheckoutSuccess {
	public static function index() {
		load::language('checkout/success');

		if (isset(session::$data['order_id'])) {
			cart::clear();

			unset(session::$data['shipping_method']);
			unset(session::$data['shipping_methods']);
			unset(session::$data['payment_method']);
			unset(session::$data['payment_methods']);
			unset(session::$data['guest']);
			unset(session::$data['comment']);
			unset(session::$data['order_id']);
			unset(session::$data['coupon']);
			unset(session::$data['reward']);
			unset(session::$data['voucher']);
			unset(session::$data['vouchers']);
			unset(session::$data['totals']);
		}

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_basket'),
			'href' => url::link('checkout/cart')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_checkout'),
			'href' => url::link('checkout/checkout', '')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_success'),
			'href' => url::link('checkout/success')
		);

		if (customer::isLogged()) {
			$data['text_message'] = sprintf(language::get('text_customer'), url::link('account/account', ''), url::link('account/order', '', true), url::link('account/download', ''), url::link('information/contact'));
		} else {
			$data['text_message'] = sprintf(language::get('text_guest'), url::link('information/contact'));
		}

		$data['continue'] = url::link('common/home');

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('common/success', $data));
	}
}