<?php
class ControllerCommonContentBottom {
	public static function index() {

		if (isset(request::$get['route'])) {
			$route = (string)request::$get['route'];
		} else {
			$route = 'common/home';
		}

		$layout_id = 0;

		if ($route == 'product/category' && isset(request::$get['path'])) {

			$path = explode('_', (string)request::$get['path']);

			$layout_id = catalog_category::getCategoryLayoutId(end($path));
		}

		if ($route == 'product/product' && isset(request::$get['product_id'])) {

			$layout_id = catalog_product::getProductLayoutId(request::$get['product_id']);
		}

		if ($route == 'information/information' && isset(request::$get['information_id'])) {

			$layout_id = catalog_information::getInformationLayoutId(request::$get['information_id']);
		}

		if (!$layout_id) {
			$layout_id = design_layout::getLayout($route);
		}

		if (!$layout_id) {
			$layout_id = config('layout_id');
		}


		$data['modules'] = array();

		$modules = design_layout::getLayoutModules($layout_id, 'content_bottom');

		foreach ($modules as $module) {
			$part = explode('.', $module['code']);

			if (isset($part[0]) && config::get('module_' . $part[0] . '_status')) {
				$module_data = load::controller('extension/module/' . $part[0]);

				if ($module_data) {
					$data['modules'][] = $module_data;
				}
			}

			if (isset($part[1])) {
				$setting_info = setting_module::getModule($part[1]);

				if ($setting_info && $setting_info['status']) {
					$output = load::controller('extension/module/' . $part[0], $setting_info);

					if ($output) {
						$data['modules'][] = $output;
					}
				}
			}
		}

		return load::view('common/content_bottom', $data);
	}
}
