<?php
class ControllerCommonFooter {
	public static function index() {
		load::language('common/footer');


		$data['informations'] = array();

		foreach (catalog_information::getInformations() as $result) {
			if ($result['bottom']) {
				$data['informations'][] = array(
					'title' => $result['title'],
					'href'  => url::link('information/information', 'information_id=' . $result['information_id'])
				);
			}
		}

		$data['contact'] = url::link('information/contact');
		$data['return'] = url::link('account/return/add', '');
		$data['sitemap'] = url::link('information/sitemap');
		$data['tracking'] = url::link('information/tracking');
		$data['manufacturer'] = url::link('product/manufacturer');
		$data['voucher'] = url::link('account/voucher', '');
		$data['affiliate'] = url::link('affiliate/login', '');
		$data['special'] = url::link('product/special');
		$data['account'] = url::link('account/account', '');
		$data['order'] = url::link('account/order', '');
		$data['wishlist'] = url::link('account/wishlist', '');
		$data['newsletter'] = url::link('account/newsletter', '');

		$data['powered'] = sprintf(language::get('text_powered'), config('name'), date('Y', time()));

		// Whos Online
		if (config('customer_online')) {

			if (isset(request::$server['REMOTE_ADDR'])) {
				$ip = request::$server['REMOTE_ADDR'];
			} else {
				$ip = '';
			}

			if (isset(request::$server['HTTP_HOST']) && isset(request::$server['REQUEST_URI'])) {
				$url = (request::$server['HTTPS'] ? 'https://' : 'http://') . request::$server['HTTP_HOST'] . request::$server['REQUEST_URI'];
			} else {
				$url = '';
			}

			if (isset(request::$server['HTTP_REFERER'])) {
				$referer = request::$server['HTTP_REFERER'];
			} else {
				$referer = '';
			}

			tool_online::addOnline($ip, customer::getId(), $url, $referer);
		}

		$data['scripts'] = document::getScripts('footer');
		$data['styles'] = document::getStyles('footer');
		
		return load::view('common/footer', $data);
	}
}
