<?php
class ControllerCommonHeader {
	public static function index() {
		// Analytics

		$data['analytics'] = array();

		$analytics = setting_extension::getExtensions('analytics');

		foreach ($analytics as $analytic) {
			if (config::get('analytics_' . $analytic['code'] . '_status')) {
				$data['analytics'][] = load::controller('extension/analytics/' . $analytic['code'], config::get('analytics_' . $analytic['code'] . '_status'));
			}
		}

		if (request::$server['HTTPS']) {
			$server = config('ssl');
		} else {
			$server = config('url');
		}

		if (is_file('image/' . config('icon'))) {
			document::addLink($server . 'image/' . config('icon'), 'icon');
		}

		$data['title'] = document::getTitle();

		$data['base'] = $server;
		$data['description'] = document::getDescription();
		$data['keywords'] = document::getKeywords();
		$data['links'] = document::getLinks();
		$data['styles'] = document::getStyles();
		$data['scripts'] = document::getScripts('header');
		$data['lang'] = language::get('code');
		$data['direction'] = language::get('direction');

		$data['name'] = config('name');

		if (is_file('image/' . config('logo'))) {
			$data['logo'] = $server . 'image/' . config('logo');
		} else {
			$data['logo'] = '';
		}

		load::language('common/header');

		// Wishlist
		if (customer::isLogged()) {

			$data['text_wishlist'] = sprintf(language::get('text_wishlist'), account_wishlist::getTotalWishlist());
		} else {
			$data['text_wishlist'] = sprintf(language::get('text_wishlist'), (isset(session::$data['wishlist']) ? count(session::$data['wishlist']) : 0));
		}

		$data['text_logged'] = sprintf(language::get('text_logged'), url::link('account/account', ''), customer::getFirstName(), url::link('account/logout', ''));
		
		$data['home'] = url::link('common/home');
		$data['wishlist'] = url::link('account/wishlist', '');
		$data['logged'] = customer::isLogged();
		$data['account'] = url::link('account/account', '');
		$data['register'] = url::link('account/register', '');
		$data['login'] = url::link('account/login', '');
		$data['order'] = url::link('account/order', '');
		$data['transaction'] = url::link('account/transaction', '');
		$data['download'] = url::link('account/download', '');
		$data['logout'] = url::link('account/logout', '');
		$data['shopping_cart'] = url::link('checkout/cart');
		$data['checkout'] = url::link('checkout/checkout', '');
		$data['contact'] = url::link('information/contact');
		$data['telephone'] = config('telephone');
		
		$data['language'] = load::controller('common/language');
		$data['currency'] = load::controller('common/currency');
		$data['search'] = load::controller('common/search');
		$data['cart'] = load::controller('common/cart');
		$data['menu'] = load::controller('common/menu');

		return load::view('common/header', $data);
	}
}
