<?php
class ControllerCommonMenu {
	public static function index() {
		load::language('common/menu');

		// Menu


		$data['categories'] = array();

		$categories = catalog_category::getCategories(0);

		foreach ($categories as $category) {
			if ($category['top']) {
				// Level 2
				$children_data = array();

				$children = catalog_category::getCategories($category['category_id']);

				foreach ($children as $child) {
					$filter_data = array(
						'filter_category_id'  => $child['category_id'],
						'filter_sub_category' => true
					);

					$children_data[] = array(
						'name'  => $child['name'] . (config('product_count') ? ' (' . catalog_product::getTotalProducts($filter_data) . ')' : ''),
						'href'  => url::link('product/category', 'path=' . $category['category_id'] . '_' . $child['category_id'])
					);
				}

				// Level 1
				$data['categories'][] = array(
					'name'     => $category['name'],
					'children' => $children_data,
					'column'   => $category['column'] ? $category['column'] : 1,
					'href'     => url::link('product/category', 'path=' . $category['category_id'])
				);
			}
		}

		return load::view('common/menu', $data);
	}
}
