<?php
class ControllerErrorNotFound {
	public static function index() {
		load::language('error/not_found');

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		if (isset(request::$get['route'])) {
			$url_data = request::$get;

			unset($url_data['_route_']);

			$route = $url_data['route'];

			unset($url_data['route']);

			$url = '';

			if ($url_data) {
				$url = '&' . urldecode(http_build_query($url_data, '', '&'));
			}

			$data['breadcrumbs'][] = array(
				'text' => language::get('heading_title'),
				'href' => url::link($route, $url, request::$server['HTTPS'])
			);
		}

		$data['continue'] = url::link('common/home');

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::addHeader(request::$server['SERVER_PROTOCOL'] . ' 404 Not Found');

		response::setOutput(load::view('error/not_found', $data));
	}
}