<?php
class ControllerExtensionCaptchaGoogle {
    public static function index($error = array()) {
        load::language('extension/captcha/google');

        if (isset($error['captcha'])) {
			$data['error_captcha'] = $error['captcha'];
		} else {
			$data['error_captcha'] = '';
		}

		$data['site_key'] = config::get('captcha_google_key');

        $data['route'] = request::$get['route']; 

		return load::view('extension/captcha/google', $data);
    }

    public static function validate() {
		if (empty(session::$data['gcapcha'])) {
			load::language('extension/captcha/google');

			if (!isset(request::$post['g-recaptcha-response'])) {
				return language::get('error_captcha');
			}

			$recaptcha = file_get_contents('https://www.google.com/recaptcha/api/siteverify?secret=' . urlencode(config::get('captcha_google_secret')) . '&response=' . request::$post['g-recaptcha-response'] . '&remoteip=' . request::$server['REMOTE_ADDR']);

			$recaptcha = json_decode($recaptcha, true);

			if ($recaptcha['success']) {
				session::$data['gcapcha']	= true;
			} else {
				return language::get('error_captcha');
			}
		}
    }
}
