<?php
class ControllerExtensionCreditCardSagepayDirect {
	public static function index() {
		if (!customer::isLogged()) {
			session::$data['redirect'] = url::link('account/account', '');

			response::redirect(url::link('account/login', ''));
		}

		load::language('extension/credit_card/sagepay_direct');


		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_account'),
			'href' => url::link('account/account', '')
		);


		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];
			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(session::$data['error_warning'])) {
			$data['error_warning'] = session::$data['error_warning'];
			unset(session::$data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}

		if (config::get('payment_sagepay_direct_card')) {
			$data['cards'] = extension_payment_sagepay_direct::getCards(customer::getId());
			$data['delete'] = url::link('extension/credit_card/sagepay_direct/delete', 'card_id=');

			if (isset(request::$get['page'])) {
				$page = (int)request::$get['page'];
			} else {
				$page = 1;
			}

			$cards_total = count($data['cards']);

			$pagination = new Pagination();
			$pagination::$total = $cards_total;
			$pagination::$page = $page;
			$pagination::$limit = 10;
			$pagination::$url = url::link('extension/credit_card/sagepay_direct', 'page={page}');

			$data['pagination'] = $pagination::render();

			$data['results'] = sprintf(language::get('text_pagination'), ($cards_total) ? (($page - 1) * 10) + 1 : 0, ((($page - 1) * 10) > ($cards_total - 10)) ? $cards_total : ((($page - 1) * 10) + 10), $cards_total, ceil($cards_total / 10));
		} else {
			$data['cards'] = false;
			$data['pagination'] = false;
			$data['results'] = false;
		}

		$data['back'] = url::link('account/account', '');
		$data['add'] = url::link('extension/credit_card/sagepay_direct/add', '');

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('extension/credit_card/sagepay_direct_list', $data));
	}

	public static function add() {
		if (!customer::isLogged()) {
			session::$data['redirect'] = url::link('account/account', '');

			response::redirect(url::link('account/login', ''));
		}

		load::language('extension/credit_card/sagepay_direct');


		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_account'),
			'href' => url::link('account/account', '')
		);
		
		$data['add'] = url::link('extension/credit_card/sagepay_direct/addCard', '');
		$data['back'] = url::link('extension/credit_card/sagepay_direct', '');

		$data['cards'] = array();

		$data['cards'][] = array(
			'text' => 'Visa',
			'value' => 'VISA'
		);

		$data['cards'][] = array(
			'text' => 'MasterCard',
			'value' => 'MC'
		);

		$data['cards'][] = array(
			'text' => 'Visa Delta/Debit',
			'value' => 'DELTA'
		);

		$data['cards'][] = array(
			'text' => 'Solo',
			'value' => 'SOLO'
		);

		$data['cards'][] = array(
			'text' => 'Maestro',
			'value' => 'MAESTRO'
		);

		$data['cards'][] = array(
			'text' => 'Visa Electron UK Debit',
			'value' => 'UKE'
		);

		$data['cards'][] = array(
			'text' => 'American Express',
			'value' => 'AMEX'
		);

		$data['cards'][] = array(
			'text' => 'Diners Club',
			'value' => 'DC'
		);

		$data['cards'][] = array(
			'text' => 'Japan Credit Bureau',
			'value' => 'JCB'
		);

		$data['months'] = array();

		for ($i = 1; $i <= 12; $i++) {
			$data['months'][] = array(
				'text' => sprintf('%02d', $i),
				'value' => sprintf('%02d', $i)
			);
		}

		$today = getdate();

		$data['year_valid'] = array();

		for ($i = $today['year'] - 10; $i < $today['year'] + 1; $i++) {
			$data['year_valid'][] = array(
				'text'  => sprintf('%02d', $i % 100),
				'value' => sprintf('%04d', $i)
			);
		}

		$data['year_expire'] = array();

		for ($i = $today['year']; $i < $today['year'] + 11; $i++) {
			$data['year_expire'][] = array(
				'text'  => sprintf('%02d', $i % 100),
				'value' => sprintf('%04d', $i)
			);
		}

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('extension/credit_card/sagepay_direct_form', $data));
	}

	public static function delete() {
		load::language('extension/credit_card/sagepay_direct');

		$card = extension_payment_sagepay_direct::getCard(request::$get['card_id'], false);

		if (!empty($card['token'])) {
			if (config::get('payment_sagepay_direct_test') == 'live') {
				$url = 'https://live.sagepay.com/gateway/service/removetoken.vsp';
			} else {
				$url = 'https://test.sagepay.com/gateway/service/removetoken.vsp';
			}
			
			$payment_data['VPSProtocol'] = '3.00';
			$payment_data['Vendor'] = config::get('payment_sagepay_direct_vendor');
			$payment_data['TxType'] = 'REMOVETOKEN';
			$payment_data['Token'] = $card['token'];

			$response_data = extension_payment_sagepay_direct::sendCurl($url, $payment_data);
			
			if ($response_data['Status'] == 'OK') {
				extension_payment_sagepay_direct::deleteCard(request::$get['card_id']);
				
				session::$data['success'] = language::get('text_success_card');
			} else {
				session::$data['error_warning'] = language::get('text_fail_card');
			}
		} else {
			session::$data['error_warning'] = language::get('text_fail_card');
		}
		
		response::redirect(url::link('acredit_card/sagepay_direct', ''));
	}

	public static function addCard() {
		load::language('extension/credit_card/sagepay_direct');

		$payment_data = array();

		if (config::get('payment_sagepay_direct_test') == 'live') {
			$url = 'https://live.sagepay.com/gateway/service/directtoken.vsp';
		} else {
			$url = 'https://test.sagepay.com/gateway/service/directtoken.vsp';
		}
		$payment_data['VPSProtocol'] = '3.00';

		$payment_data['ReferrerID'] = 'E511AF91-E4A0-42DE-80B0-09C981A3FB61';
		$payment_data['TxType'] = 'TOKEN';
		$payment_data['Vendor'] = config::get('payment_sagepay_direct_vendor');
		$payment_data['Currency'] = session::$data['currency'];
		$payment_data['CardHolder'] = request::$post['cc_owner'];
		$payment_data['CardNumber'] = request::$post['cc_number'];
		$payment_data['ExpiryDate'] = request::$post['cc_expire_date_month'] . substr(request::$post['cc_expire_date_year'], 2);
		$payment_data['CV2'] = request::$post['cc_cvv2'];
		$payment_data['CardType'] = request::$post['cc_type'];

		$response_data = extension_payment_sagepay_direct::sendCurl($url, $payment_data);

		if ($response_data['Status'] == 'OK') {
			$card_data = array();
			$card_data['customer_id'] = customer::getId();
			$card_data['Token'] = $response_data['Token'];
			$card_data['Last4Digits'] = substr(str_replace(' ', '', $payment_data['CardNumber']), -4, 4);
			$card_data['ExpiryDate'] = request::$post['cc_expire_date_month'] . '/' . substr(request::$post['cc_expire_date_year'], 2);
			$card_data['CardType'] = $payment_data['CardType'];
			extension_payment_sagepay_direct::addCard($card_data);
			session::$data['success'] = language::get('text_success_add_card');
		} else {
			session::$data['error_warning'] = $response_data['Status'] . ': ' . $response_data['StatusDetail'];
			extension_payment_sagepay_direct::logger('Response data: ', session::$data['error_warning']);
		}

		response::redirect(url::link('extension/credit_card/sagepay_direct', ''));
	}
}
