<?php
class ControllerExtensionModuleAmazonPay {
    public static function index() {

        if (config::get('payment_amazon_login_pay_status') && config::get('module_amazon_pay_status') && !empty(request::$server['HTTPS']) && !(config::get('payment_amazon_login_pay_minimum_total') > 0 && config::get('payment_amazon_login_pay_minimum_total') > cart::getSubTotal()) && extension_payment_amazon_login_pay::isTotalPositive()) {

            // capital L in Amazon cookie name is required, do not alter for coding standards
            if (!customer::isLogged() && isset(request::$cookie['amazon_Login_state_cache'])) {
                setcookie('amazon_Login_state_cache', null, -1, '/');
            }

            $amazon_payment_js = extension_payment_amazon_login_pay::getWidgetJs();
            document::addScript($amazon_payment_js);

            $data['client_id'] = config::get('payment_amazon_login_pay_client_id');
            $data['merchant_id'] = config::get('payment_amazon_login_pay_merchant_id');
            $data['return_url'] = html_entity_decode(url::link('extension/module/amazon_login/login', 'from_amazon_pay=1'), ENT_COMPAT, "UTF-8");
            $data['button_id'] = 'AmazonPayButton';

            if (config::get('payment_amazon_login_pay_test') == 'sandbox') {
                $data['sandbox'] = isset(session::$data['user_id']); // Require an active admin panel session to show debug messages
            }

            if (config::get('module_amazon_pay_button_type')) {
                $data['button_type'] = config::get('module_amazon_pay_button_type');
            } else {
                $data['button_type'] = 'PwA';
            }

            if (config::get('module_amazon_pay_button_colour')) {
                $data['button_colour'] = config::get('module_amazon_pay_button_colour');
            } else {
                $data['button_colour'] = 'Gold';
            }

            if (config::get('module_amazon_pay_button_size')) {
                $data['button_size'] = config::get('module_amazon_pay_button_size');
            } else {
                $data['button_size'] = 'medium';
            }

                       if(!empty(session::$data['language'])) {
              $session_lang = session::$data['language'];
              $session_lang_code = current(explode('-', $session_lang));
              $language_region_mapping = array(
                'EUR' => array('de-De', 'es-ES','fr-FR', 'it-IT', 'en-GB'),
                'GBP' => array('de-De', 'es-ES','fr-FR', 'it-IT', 'en-GB'),
                'USD' =>array('en-US')
              );

              if(config::get('payment_amazon_login_pay_payment_region')) {
                $merchant_location = config::get('payment_amazon_login_pay_payment_region');
                $available_codes = $language_region_mapping[$merchant_location];
                 $data['language'] = (config::get('payment_amazon_login_pay_language')) ? config::get('payment_amazon_login_pay_language') : 'en-US';
                foreach ($available_codes as $l_code) {
                  $l_code_short = current(explode('-', $l_code));
                  if($session_lang_code == $l_code_short) {
                    $data['language'] = $l_code;
                  }
                }
              }
            } else {
              $data['language'] = (config::get('payment_amazon_login_pay_language')) ? config::get('payment_amazon_login_pay_language') : 'en-US';
            }

            return load::view('extension/module/amazon_login', $data);
        }
    }
}
