<?php
class ControllerExtensionModuleCategory {
	public static function index() {
		load::language('extension/module/category');

		if (isset(request::$get['path'])) {
			$parts = explode('_', (string)request::$get['path']);
		} else {
			$parts = array();
		}

		if (isset($parts[0])) {
			$data['category_id'] = $parts[0];
		} else {
			$data['category_id'] = 0;
		}

		if (isset($parts[1])) {
			$data['child_id'] = $parts[1];
		} else {
			$data['child_id'] = 0;
		}



		$data['categories'] = array();

		$categories = catalog_category::getCategories(0);

		foreach ($categories as $category) {
			$children_data = array();

			if ($category['category_id'] == $data['category_id']) {
				$children = catalog_category::getCategories($category['category_id']);

				foreach($children as $child) {
					$filter_data = array('filter_category_id' => $child['category_id'], 'filter_sub_category' => true);

					$children_data[] = array(
						'category_id' => $child['category_id'],
						'name' => $child['name'] . (config('product_count') ? ' (' . catalog_product::getTotalProducts($filter_data) . ')' : ''),
						'href' => url::link('product/category', 'path=' . $category['category_id'] . '_' . $child['category_id'])
					);
				}
			}

			$filter_data = array(
				'filter_category_id'  => $category['category_id'],
				'filter_sub_category' => true
			);

			$data['categories'][] = array(
				'category_id' => $category['category_id'],
				'name'        => $category['name'] . (config('product_count') ? ' (' . catalog_product::getTotalProducts($filter_data) . ')' : ''),
				'children'    => $children_data,
				'href'        => url::link('product/category', 'path=' . $category['category_id'])
			);
		}

		return load::view('extension/module/category', $data);
	}
}