<?php
class ControllerExtensionModuleDividoCalculator {
	public static function index() {
		load::language('extension/module/divido_calculator');

		$product_selection = config::get('payment_divido_productselection');
		$product_threshold = config::get('payment_divido_price_threshold');

		if (!isset(request::$get['product_id']) || !config::get('payment_divido_status') || !config::get('module_divido_calculator_status')) {
			return false;
		}

		$product_info = catalog_product::getProduct(request::$get['product_id']);

		$price = 0;
		if ((config('customer_price') && customer::isLogged()) || !config('customer_price')) {
			$base_price = !empty($product_info['special']) ? $product_info['special'] : $product_info['price'];
			$price = tax::calculate($base_price, $product_info['tax_class_id'], config('tax'));
		}

		if ($product_selection == 'threshold' && $product_threshold > $price) {
			return false;
		}

		$api_key = config::get('payment_divido_api_key');
		$key_parts = explode('.', $api_key);
		$js_key = strtolower(array_shift($key_parts));

		extension_payment_divido::setMerchant($api_key);
		$plans = extension_payment_divido::getProductPlans(request::$get['product_id']);

		if (!$plans) {
			return false;
		}

		$plans_ids = array_map(static function ($plan) {
			return $plan::$id;
		}, $plans);
		$plans_ids = array_unique($plans_ids);
		$plans_list = implode(',', $plans_ids);

		$data = array(
			'merchant_script'			=> "//cdn.divido.com/calculator/{$js_key}.js",
			'product_price'				=> $price,
			'plan_list'					=> $plans_list,
			'generic_credit_req_error'	=> 'Credit request could not be initiated',
		);

		return load::view('extension/module/divido_calculator', $data);
	}
}
