<?php
class ControllerExtensionModuleFeatured {
	public static function index($setting) {
		load::language('extension/module/featured');



		$data['products'] = array();

		if (!$setting['limit']) {
			$setting['limit'] = 4;
		}

		if (!empty($setting['product'])) {
			$products = array_slice($setting['product'], 0, (int)$setting['limit']);

			foreach ($products as $product_id) {
				$product_info = catalog_product::getProduct($product_id);

				if ($product_info) {
					if ($product_info['image']) {
						$image = tool_image::resize($product_info['image'], $setting['width'], $setting['height']);
					} else {
						$image = tool_image::resize('placeholder.png', $setting['width'], $setting['height']);
					}

					if (customer::isLogged() || !config('customer_price')) {
						$price = currency::format(tax::calculate($product_info['price'], $product_info['tax_class_id'], config('tax')), session::$data['currency']);
					} else {
						$price = false;
					}

					if (!is_null($product_info['special']) && (float)$product_info['special'] >= 0) {
						$special = currency::format(tax::calculate($product_info['special'], $product_info['tax_class_id'], config('tax')), session::$data['currency']);
						$tax_price = (float)$product_info['special'];
					} else {
						$special = false;
						$tax_price = (float)$product_info['price'];
					}
		
					if (config('tax')) {
						$tax = currency::format($tax_price, session::$data['currency']);
					} else {
						$tax = false;
					}

					if (config('review_status')) {
						$rating = $product_info['rating'];
					} else {
						$rating = false;
					}

					$data['products'][] = array(
						'product_id'  => $product_info['product_id'],
						'thumb'       => $image,
						'name'        => $product_info['name'],
						'description' => utf8_substr(strip_tags(html_entity_decode($product_info['description'], ENT_QUOTES, 'UTF-8')), 0, config::get('theme_' . config('theme') . '_product_description_length')) . '..',
						'price'       => $price,
						'special'     => $special,
						'tax'         => $tax,
						'rating'      => $rating,
						'href'        => url::link('product/product', 'product_id=' . $product_info['product_id'])
					);
				}
			}
		}

		if ($data['products']) {
			return load::view('extension/module/featured', $data);
		}
	}
}