<?php
class ControllerExtensionModuleFilter {
	public static function index() {
		if (isset(request::$get['path'])) {
			$parts = explode('_', (string)request::$get['path']);
		} else {
			$parts = array();
		}

		$category_id = end($parts);


		$category_info = catalog_category::getCategory($category_id);

		if ($category_info) {
			load::language('extension/module/filter');

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['limit'])) {
				$url .= '&limit=' . request::$get['limit'];
			}

			$data['action'] = str_replace('&amp;', '&', url::link('product/category', 'path=' . request::$get['path'] . $url));

			if (isset(request::$get['filter'])) {
				$data['filter_category'] = explode(',', request::$get['filter']);
			} else {
				$data['filter_category'] = array();
			}


			$data['filter_groups'] = array();

			$filter_groups = catalog_category::getCategoryFilters($category_id);

			if ($filter_groups) {
				foreach ($filter_groups as $filter_group) {
					$childen_data = array();

					foreach ($filter_group['filter'] as $filter) {
						$filter_data = array(
							'filter_category_id' => $category_id,
							'filter_filter'      => $filter['filter_id']
						);

						$childen_data[] = array(
							'filter_id' => $filter['filter_id'],
							'name'      => $filter['name'] . (config('product_count') ? ' (' . catalog_product::getTotalProducts($filter_data) . ')' : '')
						);
					}

					$data['filter_groups'][] = array(
						'filter_group_id' => $filter_group['filter_group_id'],
						'name'            => $filter_group['name'],
						'filter'          => $childen_data
					);
				}

				return load::view('extension/module/filter', $data);
			}
		}
	}
}