<?php
class ControllerExtensionModuleLaybuyLayout {
	public static function index() {

		$status = config::get('module_laybuy_layout_status');

		if ($status && config::get('payment_laybuy_status')) {
			if (customer::isLogged()) {
				if (isset(request::$get['order_id'])) {
					$order_id = request::$get['order_id'];

					if (extension_module_laybuy_layout::isLayBuyOrder($order_id)) {
						load::language('extension/module/laybuy_layout');

						$transaction_info = extension_module_laybuy_layout::getTransactionByOrderId($order_id);

						$data['transaction'] = array(
							'laybuy_ref_no'      => $transaction_info['laybuy_ref_no'],
							'paypal_profile_id'  => $transaction_info['paypal_profile_id'],
							'status'             => extension_module_laybuy_layout::getStatusLabel($transaction_info['status']),
							'amount'             => currency::format($transaction_info['amount'], $transaction_info['currency']),
							'downpayment'        => $transaction_info['downpayment'],
							'months'             => $transaction_info['months'],
							'downpayment_amount' => currency::format($transaction_info['downpayment_amount'], $transaction_info['currency']),
							'payment_amounts'    => currency::format($transaction_info['payment_amounts'], $transaction_info['currency']),
							'first_payment_due'  => date(language::get('date_format_short'), strtotime($transaction_info['first_payment_due'])),
							'last_payment_due'   => date(language::get('date_format_short'), strtotime($transaction_info['last_payment_due'])),
							'report'             => json_decode($transaction_info['report'], true)
						);

						return load::view('extension/module/laybuy_layout', $data);
					}
				}
			}
		}
	}
}