<?php
class ControllerExtensionModuleMeest2 extends Controller {
	public function search(){
		//$meest2 = new Meest($this->registry);
		$json = [];
		$this->load->model('extension/shipping/meest2');
		if (isset($this->request->get['service'])) {
			switch ($this->request->get['service']) {
				case 'postomat':
					$type_id = '23c4f6c1-b1bb-49f7-ad96-9b014206fe8e';
					$result = $this->model_extension_shipping_meest2->getResults($type_id,$this->request->get['filter_name']);
					foreach ($result as $branch) {
						$place = $this->place($branch);
						
						$json[] = [
							'br_id'      => $branch['br_id'],
							'name'       => sprintf('%s, %s, %s,%s - %s',$branch['num'],$branch['city'],$branch['street'],$branch['street_number'],$branch['type_public']),
							'type'       => $branch['type_public'],
							'address'    => '',
							'anyfield'   => $place
						];
					}
					break;
				break;
				case 'warehouse':
					$type_id = array('91cb8fae-6a94-4b1d-b048-dc89499e2fe5', '0c1b0075-cd44-49d1-bd3e-094da9645919');
					$result = $this->model_extension_shipping_meest2->getResults($type_id,$this->request->get['filter_name']);
					foreach ($result as $branch) {
						$place = $this->place($branch);
						$json[] = [
							'br_id'      => $branch['br_id'],
							'name'       => sprintf('%s, %s, %s,%s - %s',$branch['num'],$branch['city'],$branch['street'],$branch['street_number'], $branch['type_public']),
							'type'       => $branch['type_public'],
							'address'    => '',
							'anyfield'   => $place
						];
					}
					break;
				default:
					$json[] = [
						'br_id'      => 0,
						'name'       => 'неизвестный запрос',
						'type'       => 0,
						'address'    => '',
						'anyfield'   => 0
					];
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));		
	}
	public function index(){
		$data = $this->load->language('extension/module/meest2');
		
		return $this->load->view('extension/module/meest2', $data);
	}
	public function save(){
		if ($this->request->server['REQUEST_METHOD'] == 'POST' && !empty($this->request->post['address'])) {
			$this->session->data['shipping_address']['address_1'] = $this->request->post['address'];
            //Simple checkout
            $this->session->data['simple']['shipping_address']['address_1'] = $this->request->post['address'];
		}
	}
	private function place($branch){
		$place = '';
		if (!empty($branch['lat'])) {
			$lng = $branch['lat'];
			$d = floor( $lng);
			$m = floor(($lng - $d) * 60);
			$s = round(($lng - $d - $m/60) * 3600,2);
			$place = 'place/' . $d . '%C2%B0' . $m . "'" . $s . '%22N+';
			$lat = $branch['lng'];
			$d = floor( $lat);
			$m = floor(($lat - $d) * 60);
			$s = round(($lat - $d - $m/60) * 3600,2);
			
			$place .= $d . '%C2%B0' . $m . "'" . $s . '%22E';
		}
		return $place;

	}
}