<?php
class ControllerExtensionModulePayPalSmartButton {
	private static $error = array();
		
	public static function init() {
		parent::__construct();

		if (version_compare(phpversion(), '7.1', '>=')) {
			ini_set('precision', 14);
			ini_set('serialize_precision', 14);
		}
	}
	
	public static function index() {		
		if (config::get('payment_paypal_status') && isset(request::$get['route'])) {						
			$status = false;
			
			// Setting
			$_config = new Config();
			$_config::load('paypal');
			
			$paypal_setting = $_config::get('paypal_setting');
				
			$_config = new Config();
			$_config::load('paypal_smart_button');
			
			$config_setting = $_config::get('paypal_smart_button_setting');
		
			$setting = array_replace_recursive((array)$config_setting, (array)config::get('module_paypal_smart_button_setting'));
			
			$currency_code = config::get('payment_paypal_currency_code');
			$currency_value = config::get('payment_paypal_currency_value');
			$decimal_place = $paypal_setting['currency'][$currency_code]['decimal_place'];
			
			if ($setting['page']['product']['status'] && (request::$get['route'] == 'product/product') && isset(request::$get['product_id'])) {
				$data['insert_tag'] = html_entity_decode($setting['page']['product']['insert_tag']);
				$data['insert_type'] = $setting['page']['product']['insert_type'];
				$data['button_align'] = $setting['page']['product']['button_align'];
				$data['button_size'] = $setting['page']['product']['button_size'];
				$data['button_color'] = $setting['page']['product']['button_color'];
				$data['button_shape'] = $setting['page']['product']['button_shape'];
				$data['button_label'] = $setting['page']['product']['button_label'];
				$data['button_tagline'] = $setting['page']['product']['button_tagline'];	
				
				$data['message_status'] = $setting['page']['product']['message_status'];
				$data['message_align'] = $setting['page']['product']['message_align'];
				$data['message_size'] = $setting['page']['product']['message_size'];
				$data['message_layout'] = $setting['page']['product']['message_layout'];
				$data['message_text_color'] = $setting['page']['product']['message_text_color'];
				$data['message_text_size'] = $setting['page']['product']['message_text_size'];
				$data['message_flex_color'] = $setting['page']['product']['message_flex_color'];
				$data['message_flex_ratio'] = $setting['page']['product']['message_flex_ratio'];
				$data['message_placement'] = 'product';
				
				$product_id = (int)request::$get['product_id'];
		

				$product_info = catalog_product::getProduct($product_id);

				if ($product_info) {
					if (customer::isLogged() || !config('customer_price')) {
						if ((float)$product_info['special']) {
							$product_price = tax::calculate($product_info['special'], $product_info['tax_class_id'], config('tax'));
						} else {
							$product_price = tax::calculate($product_info['price'], $product_info['tax_class_id'], config('tax'));
						}
						
						$data['message_amount'] = number_format($product_price * $currency_value, $decimal_place, '.', '');
					} 			
				}
				
				$status = true;
			}
			
			if ($setting['page']['cart']['status'] && (request::$get['route'] == 'checkout/cart') && cart::getTotal()) {
				$data['insert_tag'] = html_entity_decode($setting['page']['cart']['insert_tag']);
				$data['insert_type'] = $setting['page']['cart']['insert_type'];
				$data['button_align'] = $setting['page']['cart']['button_align'];
				$data['button_size'] = $setting['page']['cart']['button_size'];
				$data['button_color'] = $setting['page']['cart']['button_color'];
				$data['button_shape'] = $setting['page']['cart']['button_shape'];
				$data['button_label'] = $setting['page']['cart']['button_label'];
				$data['button_tagline'] = $setting['page']['cart']['button_tagline'];
				
				$data['message_status'] = $setting['page']['cart']['message_status'];
				$data['message_align'] = $setting['page']['cart']['message_align'];
				$data['message_size'] = $setting['page']['cart']['message_size'];
				$data['message_layout'] = $setting['page']['cart']['message_layout'];
				$data['message_text_color'] = $setting['page']['cart']['message_text_color'];
				$data['message_text_size'] = $setting['page']['cart']['message_text_size'];
				$data['message_flex_color'] = $setting['page']['cart']['message_flex_color'];
				$data['message_flex_ratio'] = $setting['page']['cart']['message_flex_ratio'];
				$data['message_placement'] = 'cart';
				
				$item_total = 0;
				
				foreach (cart::getProducts() as $product) {
					$product_price = number_format($product['price'] * $currency_value, $decimal_place, '.', '');
				
					$item_total += $product_price * $product['quantity'];
				}
			
				$item_total = number_format($item_total, $decimal_place, '.', '');
				$sub_total = cart::getSubTotal();
				$total = cart::getTotal();
				$tax_total = number_format(($total - $sub_total) * $currency_value, $decimal_place, '.', '');
				$data['message_amount'] = number_format($item_total + $tax_total, $decimal_place, '.', '');
					
				$status = true;
			}
			
			if ($status) {				
		
				$country = localisation_country::getCountry(config('country_id'));
		
				$data['client_id'] = config::get('payment_paypal_client_id');
				$data['merchant_id'] = config::get('payment_paypal_merchant_id');
				$data['environment'] = config::get('payment_paypal_environment');
				$data['partner_id'] = $paypal_setting['partner'][$data['environment']]['partner_id'];
				$data['transaction_method'] = config::get('payment_paypal_transaction_method');					
				$data['locale'] = preg_replace('/-(.+?)+/', '', config('language')) . '_' . $country['iso_code_2'];
				$data['currency_code'] = config::get('payment_paypal_currency_code');
						
				$data['button_width'] = $setting['button_width'][$data['button_size']];
				$data['message_width'] = $setting['message_width'][$data['message_size']];
												
				return load::view('extension/module/paypal_smart_button', $data);
			}
		}
	}
	
	public static function createOrder() {
		load::language('extension/module/paypal_smart_button');
		
		
		$errors = array();
		
		$data['order_id'] = '';
		
		if (isset(request::$post['product_id'])) {
			$product_id = (int)request::$post['product_id'];
		

			$product_info = catalog_product::getProduct($product_id);

			if ($product_info) {
				if (isset(request::$post['quantity'])) {
					$quantity = (int)request::$post['quantity'];
				} else {
					$quantity = 1;
				}

				if (isset(request::$post['option'])) {
					$option = array_filter(request::$post['option']);
				} else {
					$option = array();
				}

				$product_options = catalog_product::getProductOptions(request::$post['product_id']);

				foreach ($product_options as $product_option) {
					if ($product_option['required'] && empty($option[$product_option['product_option_id']])) {
						$errors[] = sprintf(language::get('error_required'), $product_option['name']);
					}
				}

				if (isset(request::$post['recurring_id'])) {
					$recurring_id = request::$post['recurring_id'];
				} else {
					$recurring_id = 0;
				}

				$recurrings = catalog_product::getProfiles($product_info['product_id']);

				if ($recurrings) {
					$recurring_ids = array();

					foreach ($recurrings as $recurring) {
						$recurring_ids[] = $recurring['recurring_id'];
					}

					if (!in_array($recurring_id, $recurring_ids)) {
						$errors[] = language::get('error_recurring_required');
					}
				}

				if (!$errors) {					
					if (!extension_module_paypal_smart_button::hasProductInCart(request::$post['product_id'], $option, $recurring_id)) {
						cart::add(request::$post['product_id'], $quantity, $option, $recurring_id);
					}
					
					// Unset all shipping and payment methods
					unset(session::$data['shipping_method']);
					unset(session::$data['shipping_methods']);
					unset(session::$data['payment_method']);
					unset(session::$data['payment_methods']);
				}					
			}
		}
		
		if (!$errors) {					
			// Setting
			$_config = new Config();
			$_config::load('paypal');
			
			$config_setting = $_config::get('paypal_setting');
		
			$setting = array_replace_recursive((array)$config_setting, (array)config::get('payment_paypal_setting'));
		
			$client_id = config::get('payment_paypal_client_id');
			$secret = config::get('payment_paypal_secret');
			$environment = config::get('payment_paypal_environment');
			$partner_id = $setting['partner'][$environment]['partner_id'];
			$transaction_method = config::get('payment_paypal_transaction_method');	
			$currency_code = config::get('payment_paypal_currency_code');
			$currency_value = config::get('payment_paypal_currency_value');
			$decimal_place = $setting['currency'][$currency_code]['decimal_place'];
			
			require_once 'system/library/paypal/paypal.php';
		
			$paypal_info = array(
				'partner_id' => $partner_id,
				'client_id' => $client_id,
				'secret' => $secret,
				'environment' => $environment
			);
		
			$paypal = new PayPal($paypal_info);
			
			$token_info = array(
				'grant_type' => 'client_credentials'
			);	
				
			$paypal::setAccessToken($token_info);
						
			$item_info = array();
			
			$item_total = 0;
				
			foreach (cart::getProducts() as $product) {
				$product_price = number_format($product['price'] * $currency_value, $decimal_place, '.', '');
				
				$item_info[] = array(
					'name' => $product['name'],
					'sku' => $product['model'],
					'url' => url::link('product/product', 'product_id=' . $product['product_id']),
					'quantity' => $product['quantity'],
					'unit_amount' => array(
						'currency_code' => $currency_code,
						'value' => $product_price
					)
				);
				
				$item_total += $product_price * $product['quantity'];
			}
			
			$item_total = number_format($item_total, $decimal_place, '.', '');
			$sub_total = cart::getSubTotal();
			$total = cart::getTotal();
			$tax_total = number_format(($total - $sub_total) * $currency_value, $decimal_place, '.', '');
			$order_total = number_format($item_total + $tax_total, $decimal_place, '.', '');
						
			$amount_info = array(
				'currency_code' => $currency_code,
				'value' => $order_total,
				'breakdown' => array(
					'item_total' => array(
						'currency_code' => $currency_code,
						'value' => $item_total
					),
					'tax_total' => array(
						'currency_code' => $currency_code,
						'value' => $tax_total
					)
				)
			);
			
			if (cart::hasShipping()) {			
				$shipping_preference = 'GET_FROM_FILE';
			} else {
				$shipping_preference = 'NO_SHIPPING';
			}
				
			$order_info = array(
				'intent' => strtoupper($transaction_method),
				'purchase_units' => array(
					array(
						'reference_id' => 'default',
						'items' => $item_info,
						'amount' => $amount_info
					)
				),
				'application_context' => array(
					'shipping_preference' => $shipping_preference
				)
			);
					
			$result = $paypal::createOrder($order_info);
						
			if (isset($result['id'])) {
				$data['order_id'] = $result['id'];
			}
			
			if ($paypal::hasErrors()) {
				$error_messages = array();
				
				$errors = $paypal::getErrors();
								
				foreach ($errors as $error) {
					if (isset($error['name']) && ($error['name'] == 'CURLE_OPERATION_TIMEOUTED')) {
						$error['message'] = language::get('error_timeout');
					}
					
					if (isset($error['details'][0]['description'])) {
						$error_messages[] = $error['details'][0]['description'];
					} else {
						$error_messages[] = $error['message'];
					}
					
					extension_module_paypal_smart_button::log($error, $error['message']);
				}
				
				self::$error['warning'] = implode(' ', $error_messages);
			}
		} else {
			self::$error['warning'] = implode(' ', $errors);
		}
				
		$data['error'] = self::$error;
		
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($data));		
	}
	
	public static function approveOrder() {
		load::language('extension/module/paypal_smart_button');
		
		
		if (isset(request::$post['order_id'])) {
			session::$data['paypal_order_id'] = request::$post['order_id'];
		} else {	
			$data['url'] = url::link('checkout/cart', '');
			
			response::addHeader('Content-Type: application/json');
			response::setOutput(json_encode($data));
		}
		
		// check checkout can continue due to stock checks or vouchers
		if ((!cart::hasProducts() && empty(session::$data['vouchers'])) || (!cart::hasStock() && !config('stock_checkout'))) {
			$data['url'] = url::link('checkout/cart', '');
			
			response::addHeader('Content-Type: application/json');
			response::setOutput(json_encode($data));
		}

		// if user not logged in check that the guest checkout is allowed
		if (!customer::isLogged() && (!config('checkout_guest') || config('customer_price') || cart::hasDownload() || cart::hasRecurringProducts())) {
			$data['url'] = url::link('checkout/cart', '');
			
			response::addHeader('Content-Type: application/json');
			response::setOutput(json_encode($data));
		}
		
		// Setting
		$_config = new Config();
		$_config::load('paypal');
			
		$config_setting = $_config::get('paypal_setting');
		
		$setting = array_replace_recursive((array)$config_setting, (array)config::get('payment_paypal_setting'));
				
		$client_id = config::get('payment_paypal_client_id');
		$secret = config::get('payment_paypal_secret');
		$environment = config::get('payment_paypal_environment');
		$partner_id = $setting['partner'][$environment]['partner_id'];
		$transaction_method = config::get('payment_paypal_transaction_method');

		$order_id = session::$data['paypal_order_id'];

		require_once 'system/library/paypal/paypal.php';
		
		$paypal_info = array(
			'partner_id' => $partner_id,
			'client_id' => $client_id,
			'secret' => $secret,
			'environment' => $environment
		);
		
		$paypal = new PayPal($paypal_info);
		
		$token_info = array(
			'grant_type' => 'client_credentials'
		);	
						
		$paypal::setAccessToken($token_info);
			
		$order_info = $paypal::getOrder($order_id);
								
		if ($paypal::hasErrors()) {
			$error_messages = array();
				
			$errors = $paypal::getErrors();
								
			foreach ($errors as $error) {
				if (isset($error['name']) && ($error['name'] == 'CURLE_OPERATION_TIMEOUTED')) {
					$error['message'] = language::get('error_timeout');
				}
					
				if (isset($error['details'][0]['description'])) {
					$error_messages[] = $error['details'][0]['description'];
				} else {
					$error_messages[] = $error['message'];
				}
					
				extension_module_paypal_smart_button::log($error, $error['message']);
			}
				
			self::$error['warning'] = implode(' ', $error_messages);
		}
		
		if ($order_info && !self::$error) {
			
			unset(session::$data['shipping_method']);
			unset(session::$data['shipping_methods']);
			unset(session::$data['payment_method']);
			unset(session::$data['payment_methods']);
			
			if (customer::isLogged()) {
				$customer_info = account_customer::getCustomer(customer::getId());

				session::$data['guest']['customer_id'] = customer::getId();
				session::$data['guest']['customer_group_id'] = $customer_info['customer_group_id'];
				session::$data['guest']['firstname'] = $customer_info['firstname'];
				session::$data['guest']['lastname'] = $customer_info['lastname'];
				session::$data['guest']['email'] = $customer_info['email'];
				session::$data['guest']['telephone'] = $customer_info['telephone'];
				session::$data['guest']['custom_field'] = json_decode($customer_info['custom_field'], true);
			} else {
				session::$data['guest']['customer_id'] = 0;
				session::$data['guest']['customer_group_id'] = config('customer_group_id');
				session::$data['guest']['firstname'] = (isset($order_info['payer']['name']['given_name']) ? $order_info['payer']['name']['given_name'] : '');
				session::$data['guest']['lastname'] = (isset($order_info['payer']['name']['surname']) ? $order_info['payer']['name']['surname'] : '');
				session::$data['guest']['email'] = (isset($order_info['payer']['email_address']) ? $order_info['payer']['email_address'] : '');
				session::$data['guest']['telephone'] = '';
				session::$data['guest']['custom_field'] = array();
			}
								
			if (customer::isLogged() && customer::getAddressId()) {
				session::$data['payment_address'] = account_address::getAddress(customer::getAddressId());
			} else {
				session::$data['payment_address']['firstname'] = (isset($order_info['payer']['name']['given_name']) ? $order_info['payer']['name']['given_name'] : '');
				session::$data['payment_address']['lastname'] = (isset($order_info['payer']['name']['surname']) ? $order_info['payer']['name']['surname'] : '');
				session::$data['payment_address']['company'] = '';
				session::$data['payment_address']['address_1'] = '';
				session::$data['payment_address']['address_2'] = '';
				session::$data['payment_address']['city'] = '';
				session::$data['payment_address']['postcode'] = '';
				session::$data['payment_address']['country'] = '';
				session::$data['payment_address']['country_id'] = '';
				session::$data['payment_address']['address_format'] = '';
				session::$data['payment_address']['zone'] = '';
				session::$data['payment_address']['zone_id'] = '';
				session::$data['payment_address']['custom_field'] = array();
			
				if (isset($order_info['payer']['address']['country_code'])) {
					$country_info = extension_module_paypal_smart_button::getCountryByCode($order_info['payer']['address']['country_code']);
			
					if ($country_info) {
						session::$data['payment_address']['country'] = $country_info['name'];
						session::$data['payment_address']['country_id'] = $country_info['country_id'];
					}
				}
			}
				
			if (cart::hasShipping()) {
				if (customer::isLogged() && customer::getAddressId()) {
					session::$data['shipping_address'] = account_address::getAddress(customer::getAddressId());
				} else {
					if (isset($order_info['purchase_units'][0]['shipping']['name']['full_name'])) {
						$shipping_name = explode(' ', $order_info['purchase_units'][0]['shipping']['name']['full_name']);
						$shipping_firstname = $shipping_name[0];
						unset($shipping_name[0]);
						$shipping_lastname = implode(' ', $shipping_name);
					}
					
					session::$data['shipping_address']['firstname'] = (isset($shipping_firstname) ? $shipping_firstname : '');
					session::$data['shipping_address']['lastname'] = (isset($shipping_lastname) ? $shipping_lastname : '');
					session::$data['shipping_address']['company'] = '';
					session::$data['shipping_address']['address_1'] = (isset($order_info['purchase_units'][0]['shipping']['address']['address_line_1']) ? $order_info['purchase_units'][0]['shipping']['address']['address_line_1'] : '');
					session::$data['shipping_address']['address_2'] = (isset($order_info['purchase_units'][0]['shipping']['address']['address_line_2']) ? $order_info['purchase_units'][0]['shipping']['address']['address_line_2'] : '');
					session::$data['shipping_address']['city'] = (isset($order_info['purchase_units'][0]['shipping']['address']['admin_area_2']) ? $order_info['purchase_units'][0]['shipping']['address']['admin_area_2'] : '');
					session::$data['shipping_address']['postcode'] = (isset($order_info['purchase_units'][0]['shipping']['address']['postal_code']) ? $order_info['purchase_units'][0]['shipping']['address']['postal_code'] : '');
					session::$data['shipping_address']['country'] = '';
					session::$data['shipping_address']['country_id'] = '';
					session::$data['shipping_address']['address_format'] = '';
					session::$data['shipping_address']['zone'] = '';
					session::$data['shipping_address']['zone_id'] = '';
					session::$data['shipping_address']['custom_field'] = array();
									
					if (isset($order_info['purchase_units'][0]['shipping']['address']['country_code'])) {
						$country_info = extension_module_paypal_smart_button::getCountryByCode($order_info['purchase_units'][0]['shipping']['address']['country_code']);
			
						if ($country_info) {
							session::$data['shipping_address']['country_id'] = $country_info['country_id'];
							session::$data['shipping_address']['country'] = $country_info['name'];
							session::$data['shipping_address']['address_format'] = $country_info['address_format'];
													
							if (isset($order_info['purchase_units'][0]['shipping']['address']['admin_area_1'])) {
								$zone_info = extension_module_paypal_smart_button::getZoneByCode($country_info['country_id'], $order_info['purchase_units'][0]['shipping']['address']['admin_area_1']);
			
								if ($zone_info) {
									session::$data['shipping_address']['zone_id'] = $zone_info['zone_id'];
									session::$data['shipping_address']['zone'] = $zone_info['name'];
								}
							}
						}
					}
				}
			}

			$data['url'] = url::link('extension/module/paypal_smart_button/confirmOrder', '');			
		}
		
		$data['error'] = self::$error;
		
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($data));
	}
	
	public static function confirmOrder() {
		load::language('extension/module/paypal_smart_button');
		load::language('checkout/cart');

		
		if (!isset(session::$data['paypal_order_id'])) {
			response::redirect(url::link('checkout/cart', ''));
		}
			
		// Coupon
		if (isset(request::$post['coupon']) && self::validateCoupon()) {
			session::$data['coupon'] = request::$post['coupon'];

			session::$data['success'] = language::get('text_coupon');

			response::redirect(url::link('extension/module/paypal_smart_button/confirmOrder', ''));
		}

		// Voucher
		if (isset(request::$post['voucher']) && self::validateVoucher()) {
			session::$data['voucher'] = request::$post['voucher'];

			session::$data['success'] = language::get('text_voucher');

			response::redirect(url::link('extension/module/paypal_smart_button/confirmOrder', ''));
		}

		// Reward
		if (isset(request::$post['reward']) && self::validateReward()) {
			session::$data['reward'] = abs(request::$post['reward']);

			session::$data['success'] = language::get('text_reward');

			response::redirect(url::link('extension/module/paypal_smart_button/confirmOrder', ''));
		}
		
		document::setTitle(language::get('text_title'));
		
		document::addScript('catalog/view/javascript/jquery/datetimepicker/moment/moment.min.js');
		document::addScript('catalog/view/javascript/jquery/datetimepicker/moment/moment-with-locales.min.js');
		document::addScript('catalog/view/javascript/jquery/datetimepicker/bootstrap-datetimepicker.min.js');
		document::addStyle('catalog/view/javascript/jquery/datetimepicker/bootstrap-datetimepicker.min.css');

		$data['heading_title'] = language::get('text_title');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home', '')
		);
		
		$data['breadcrumbs'][] = array(
			'text' => language::get('text_cart'),
			'href' => url::link('checkout/cart', '')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_title'),
			'href' => url::link('extension/module/paypal_smart_button/confirmOrder', '')
		);

		$points_total = 0;

		foreach (cart::getProducts() as $product) {
			if ($product['points']) {
				$points_total += $product['points'];
			}
		}
		
		if (isset(request::$post['next'])) {
			$data['next'] = request::$post['next'];
		} else {
			$data['next'] = '';
		}


		$products = cart::getProducts();

		if (empty($products)) {
			response::redirect(url::link('checkout/cart', ''));
		}

		foreach ($products as $product) {
			$product_total = 0;

			foreach ($products as $product_2) {
				if ($product_2['product_id'] == $product['product_id']) {
					$product_total += $product_2['quantity'];
				}
			}

			if ($product['minimum'] > $product_total) {
				$data['error_warning'] = sprintf(language::get('error_minimum'), $product['name'], $product['minimum']);
			}

			if ($product['image']) {
				$image = tool_image::resize($product['image'], config::get('theme_' . config('theme') . '_image_cart_width'), config::get('theme_' . config('theme') . '_image_cart_height'));
			} else {
				$image = '';
			}

			$option_data = array();

			foreach ($product['option'] as $option) {
				if ($option['type'] != 'file') {
					$value = $option['value'];
				} else {
					$upload_info = tool_upload::getUploadByCode($option['value']);

					if ($upload_info) {
						$value = $upload_info['name'];
					} else {
						$value = '';
					}
				}

				$option_data[] = array(
					'name'  => $option['name'],
					'value' => (utf8_strlen($value) > 20 ? utf8_substr($value, 0, 20) . '..' : $value)
				);
			}

			// Display prices
			if (customer::isLogged() || !config('customer_price')) {
				$unit_price = tax::calculate($product['price'], $product['tax_class_id'], config('tax'));

				$price = currency::format($unit_price, session::$data['currency']);
				$total = currency::format($unit_price * $product['quantity'], session::$data['currency']);
			} else {
				$price = false;
				$total = false;
			}
			
			$recurring = '';

			if ($product['recurring']) {
				$frequencies = array(
					'day'        => language::get('text_day'),
					'week'       => language::get('text_week'),
					'semi_month' => language::get('text_semi_month'),
					'month'      => language::get('text_month'),
					'year'       => language::get('text_year'),
				);

				if ($product['recurring']['trial']) {
					$recurring = sprintf(language::get('text_trial_description'), currency::format(tax::calculate($product['recurring']['trial_price'] * $product['quantity'], $product['tax_class_id'], config('tax')), session::$data['currency']), $product['recurring']['trial_cycle'], $frequencies[$product['recurring']['trial_frequency']], $product['recurring']['trial_duration']) . ' ';
				}

				if ($product['recurring']['duration']) {
					$recurring .= sprintf(language::get('text_payment_description'), currency::format(tax::calculate($product['recurring']['price'] * $product['quantity'], $product['tax_class_id'], config('tax')), session::$data['currency']), $product['recurring']['cycle'], $frequencies[$product['recurring']['frequency']], $product['recurring']['duration']);
				} else {
					$recurring .= sprintf(language::get('text_payment_cancel'), currency::format(tax::calculate($product['recurring']['price'] * $product['quantity'], $product['tax_class_id'], config('tax')), session::$data['currency']), $product['recurring']['cycle'], $frequencies[$product['recurring']['frequency']], $product['recurring']['duration']);
				}
			}

			$data['products'][] = array(
				'cart_id'               => $product['cart_id'],
				'thumb'                 => $image,
				'name'                  => $product['name'],
				'model'                 => $product['model'],
				'option'                => $option_data,
				'recurring' 			=> $recurring,
				'quantity'              => $product['quantity'],
				'stock'                 => $product['stock'] ? true : !(!config('stock_checkout') || config('stock_warning')),
				'reward'                => ($product['reward'] ? sprintf(language::get('text_points'), $product['reward']) : ''),
				'price'                 => $price,
				'total'                 => $total,
				'href'                  => url::link('product/product', 'product_id=' . $product['product_id'])
			);
		}

		// Gift Voucher
		$data['vouchers'] = array();

		if (!empty(session::$data['vouchers'])) {
			foreach (session::$data['vouchers'] as $key => $voucher) {
				$data['vouchers'][] = array(
					'key'         => $key,
					'description' => $voucher['description'],
					'amount'      => currency::format($voucher['amount'], session::$data['currency']),
					'remove'      => url::link('checkout/cart', 'remove=' . $key)
				);
			}
		}
		
		
		if (cart::hasShipping()) {
			$data['has_shipping'] = true;
			
			$data['shipping_address'] = isset(session::$data['shipping_address']) ? session::$data['shipping_address'] : array();
			
			if (!empty($data['shipping_address'])) {
				// Shipping Methods
				$quote_data = array();

				$results = setting_extension::getExtensions('shipping');

				if (!empty($results)) {
					foreach ($results as $result) {
						if (config::get('shipping_' . $result['code'] . '_status')) {

							$quote = call_model_method('extension_shipping_' . $result['code'], 'getQuote', $data['shipping_address']);

							if ($quote) {
								$quote_data[$result['code']] = array(
									'title'      => $quote['title'],
									'quote'      => $quote['quote'],
									'sort_order' => $quote['sort_order'],
									'error'      => $quote['error']
								);
							}
						}
					}

					if (!empty($quote_data)) {
						$sort_order = array();

						foreach ($quote_data as $key => $value) {
							$sort_order[$key] = $value['sort_order'];
						}

						array_multisort($sort_order, SORT_ASC, $quote_data);

						session::$data['shipping_methods'] = $quote_data;
						$data['shipping_methods'] = $quote_data;

						if (!isset(session::$data['shipping_method'])) {
							//default the shipping to the very first option.
							$key1 = key($quote_data);
							$key2 = key($quote_data[$key1]['quote']);
							session::$data['shipping_method'] = $quote_data[$key1]['quote'][$key2];
						}

						$data['code'] = session::$data['shipping_method']['code'];
						$data['action_shipping'] = url::link('extension/module/paypal_smart_button/confirmShipping', '');
					} else {
						unset(session::$data['shipping_methods']);
						unset(session::$data['shipping_method']);
						
						$data['error_no_shipping'] = language::get('error_no_shipping');
					}
				} else {
					unset(session::$data['shipping_methods']);
					unset(session::$data['shipping_method']);
					
					$data['error_no_shipping'] = language::get('error_no_shipping');
				}
			}
		} else {
			$data['has_shipping'] = false;
		}
				
		$data['guest'] = isset(session::$data['guest']) ? session::$data['guest'] : array();
		$data['payment_address'] = isset(session::$data['payment_address']) ? session::$data['payment_address'] : array();	
		
		/**
		 * Payment methods
		 */
		$method_data = array();

		$results = setting_extension::getExtensions('payment');

		foreach ($results as $result) {
			if (config::get('payment_' . $result['code'] . '_status')) {

				$method = call_model_method('extension_payment_' . $result['code'], 'getMethod', $data['payment_address'], $total);

				if ($method) {
					$method_data[$result['code']] = $method;
				}
			}
		}

		$sort_order = array();

		foreach ($method_data as $key => $value) {
			$sort_order[$key] = $value['sort_order'];
		}

		array_multisort($sort_order, SORT_ASC, $method_data);
		
		session::$data['payment_methods'] = $method_data;
		$data['payment_methods'] = $method_data;

		if (!isset($method_data['paypal'])) {
			session::$data['error_warning'] = language::get('error_unavailable');
			
			response::redirect(url::link('checkout/checkout', ''));
		}

		session::$data['payment_methods'] = $method_data;
		session::$data['payment_method'] = $method_data['paypal'];
		
		// Custom Fields

		$data['custom_fields'] = account_custom_field::getCustomFields();

		// Totals
		$totals = array();
		$taxes = cart::getTaxes();
		$total = 0;

		// Because __call can not keep var references so we put them into an array.
		$total_data = array(
			'totals' => &$totals,
			'taxes'  => &$taxes,
			'total'  => &$total
		);

		// Display prices
		if (customer::isLogged() || !config('customer_price')) {
			$sort_order = array();

			$results = setting_extension::getExtensions('total');

			foreach ($results as $key => $value) {
				$sort_order[$key] = config::get('total_' . $value['code'] . '_sort_order');
			}

			array_multisort($sort_order, SORT_ASC, $results);

			foreach ($results as $result) {
				if (config::get('total_' . $result['code'] . '_status')) {

					// We have to put the totals in an array so that they pass by reference.
					call_model_method('extension_total_' . $result['code'], 'getTotal', $total_data);
				}
			}

			$sort_order = array();

			foreach ($totals as $key => $value) {
				$sort_order[$key] = $value['sort_order'];
			}

			array_multisort($sort_order, SORT_ASC, $totals);
		}

		$data['totals'] = array();

		foreach ($totals as $total) {
			$data['totals'][] = array(
				'title' => $total['title'],
				'text'  => currency::format($total['value'], session::$data['currency']),
			);
		}

		$data['action_confirm'] = url::link('extension/module/paypal_smart_button/completeOrder', '');

		if (isset(session::$data['error_warning'])) {
			$data['error_warning'] = session::$data['error_warning'];
			unset(session::$data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}

		if (isset(session::$data['success'])) {
			$data['success'] = session::$data['success'];
			unset(session::$data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset(session::$data['attention'])) {
			$data['attention'] = session::$data['attention'];
			unset(session::$data['attention']);
		} else {
			$data['attention'] = '';
		}

		$data['coupon'] = load::controller('extension/total/coupon');
		$data['voucher'] = load::controller('extension/total/voucher');
		$data['reward'] = load::controller('extension/total/reward');
		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('extension/module/paypal_smart_button/confirm', $data));
	}
	
	public static function completeOrder() {		
		load::language('extension/module/paypal_smart_button');
						
				
		// Validate if payment address has been set.
		if (empty(session::$data['payment_address'])) {
			response::redirect(url::link('checkout/checkout', ''));
		}

		// Validate if payment method has been set.
		if (!isset(session::$data['payment_method'])) {
			response::redirect(url::link('checkout/checkout', ''));
		}
		
		if (cart::hasShipping()) {
			// Validate if shipping address has been set.
			if (empty(session::$data['shipping_address'])) {
				response::redirect(url::link('checkout/checkout', ''));
			}

			// Validate if shipping method has been set.
			if (!isset(session::$data['shipping_method'])) {
				response::redirect(url::link('checkout/checkout', ''));
			}
		} else {
			unset(session::$data['shipping_method']);
			unset(session::$data['shipping_methods']);
		}

		// Validate cart has products and has stock.
		if ((!cart::hasProducts() && empty(session::$data['vouchers'])) || (!cart::hasStock() && !config('stock_checkout'))) {
			response::redirect(url::link('checkout/cart', ''));
		}
		
		if (isset(session::$data['paypal_order_id'])) {			
			$order_data = array();

			$totals = array();
			$taxes = cart::getTaxes();
			$total = 0;

			// Because __call can not keep var references so we put them into an array.
			$total_data = array(
				'totals' => &$totals,
				'taxes'  => &$taxes,
				'total'  => &$total
			);


			$sort_order = array();

			$results = setting_extension::getExtensions('total');

			foreach ($results as $key => $value) {
				$sort_order[$key] = config::get('total_' . $value['code'] . '_sort_order');
			}

			array_multisort($sort_order, SORT_ASC, $results);

			foreach ($results as $result) {
				if (config::get('total_' . $result['code'] . '_status')) {

					// We have to put the totals in an array so that they pass by reference.
					call_model_method('extension_total_' . $result['code'], 'getTotal', $total_data);
				}
			}

			$sort_order = array();

			foreach ($totals as $key => $value) {
				$sort_order[$key] = $value['sort_order'];
			}

			array_multisort($sort_order, SORT_ASC, $totals);
		
			$order_data['totals'] = $totals;

			$order_data['invoice_prefix'] = config('invoice_prefix');
			$order_data['store_id'] = config('store_id');
			$order_data['store_name'] = config('name');

			if ($order_data['store_id']) {
				$order_data['store_url'] = config('url');
			} else {
				if (request::$server['HTTPS']) {
					$order_data['store_url'] = HTTPS_SERVER;
				} else {
					$order_data['store_url'] = HTTP_SERVER;
				}
			}
										
			$order_data['customer_id'] = session::$data['guest']['customer_id'];
			$order_data['customer_group_id'] = session::$data['guest']['customer_group_id'];
			$order_data['firstname'] = session::$data['guest']['firstname'];
			$order_data['lastname'] = session::$data['guest']['lastname'];
			$order_data['email'] = session::$data['guest']['email'];
			$order_data['telephone'] = session::$data['guest']['telephone'];
			$order_data['custom_field'] = session::$data['guest']['custom_field'];
						
			$order_data['payment_firstname'] = session::$data['payment_address']['firstname'];
			$order_data['payment_lastname'] = session::$data['payment_address']['lastname'];
			$order_data['payment_company'] = session::$data['payment_address']['company'];
			$order_data['payment_address_1'] = session::$data['payment_address']['address_1'];
			$order_data['payment_address_2'] = session::$data['payment_address']['address_2'];
			$order_data['payment_city'] = session::$data['payment_address']['city'];
			$order_data['payment_postcode'] = session::$data['payment_address']['postcode'];
			$order_data['payment_zone'] = session::$data['payment_address']['zone'];
			$order_data['payment_zone_id'] = session::$data['payment_address']['zone_id'];
			$order_data['payment_country'] = session::$data['payment_address']['country'];
			$order_data['payment_country_id'] = session::$data['payment_address']['country_id'];
			$order_data['payment_address_format'] = session::$data['payment_address']['address_format'];
			$order_data['payment_custom_field'] = (isset(session::$data['payment_address']['custom_field']) ? session::$data['payment_address']['custom_field'] : array());

			if (isset(session::$data['payment_method']['title'])) {
				$order_data['payment_method'] = session::$data['payment_method']['title'];
			} else {
				$order_data['payment_method'] = '';
			}

			if (isset(session::$data['payment_method']['code'])) {
				$order_data['payment_code'] = session::$data['payment_method']['code'];
			} else {
				$order_data['payment_code'] = '';
			}			

			if (cart::hasShipping()) {
				$order_data['shipping_firstname'] = session::$data['shipping_address']['firstname'];
				$order_data['shipping_lastname'] = session::$data['shipping_address']['lastname'];
				$order_data['shipping_company'] = session::$data['shipping_address']['company'];
				$order_data['shipping_address_1'] = session::$data['shipping_address']['address_1'];
				$order_data['shipping_address_2'] = session::$data['shipping_address']['address_2'];
				$order_data['shipping_city'] = session::$data['shipping_address']['city'];
				$order_data['shipping_postcode'] = session::$data['shipping_address']['postcode'];
				$order_data['shipping_zone'] = session::$data['shipping_address']['zone'];
				$order_data['shipping_zone_id'] = session::$data['shipping_address']['zone_id'];
				$order_data['shipping_country'] = session::$data['shipping_address']['country'];
				$order_data['shipping_country_id'] = session::$data['shipping_address']['country_id'];
				$order_data['shipping_address_format'] = session::$data['shipping_address']['address_format'];
				$order_data['shipping_custom_field'] = (isset(session::$data['shipping_address']['custom_field']) ? session::$data['shipping_address']['custom_field'] : array());

				if (isset(session::$data['shipping_method']['title'])) {
					$order_data['shipping_method'] = session::$data['shipping_method']['title'];
				} else {
					$order_data['shipping_method'] = '';
				}

				if (isset(session::$data['shipping_method']['code'])) {
					$order_data['shipping_code'] = session::$data['shipping_method']['code'];
				} else {
					$order_data['shipping_code'] = '';
				}
			} else {
				$order_data['shipping_firstname'] = '';
				$order_data['shipping_lastname'] = '';
				$order_data['shipping_company'] = '';
				$order_data['shipping_address_1'] = '';
				$order_data['shipping_address_2'] = '';
				$order_data['shipping_city'] = '';
				$order_data['shipping_postcode'] = '';
				$order_data['shipping_zone'] = '';
				$order_data['shipping_zone_id'] = '';
				$order_data['shipping_country'] = '';
				$order_data['shipping_country_id'] = '';
				$order_data['shipping_address_format'] = '';
				$order_data['shipping_custom_field'] = array();
				$order_data['shipping_method'] = '';
				$order_data['shipping_code'] = '';
			}

			$order_data['products'] = array();

			foreach (cart::getProducts() as $product) {
				$option_data = array();

				foreach ($product['option'] as $option) {
					$option_data[] = array(
						'product_option_id'       => $option['product_option_id'],
						'product_option_value_id' => $option['product_option_value_id'],
						'option_id'               => $option['option_id'],
						'option_value_id'         => $option['option_value_id'],
						'name'                    => $option['name'],
						'value'                   => $option['value'],
						'type'                    => $option['type']
					);
				}

				$order_data['products'][] = array(
					'product_id' => $product['product_id'],
					'name'       => $product['name'],
					'model'      => $product['model'],
					'option'     => $option_data,
					'download'   => $product['download'],
					'quantity'   => $product['quantity'],
					'subtract'   => $product['subtract'],
					'price'      => $product['price'],
					'total'      => $product['total'],
					'tax'        => tax::getTax($product['price'], $product['tax_class_id']),
					'reward'     => $product['reward']
				);
			}

			// Gift Voucher
			$order_data['vouchers'] = array();

			if (!empty(session::$data['vouchers'])) {
				foreach (session::$data['vouchers'] as $voucher) {
					$order_data['vouchers'][] = array(
						'description'      => $voucher['description'],
						'code'             => token(10),
						'to_name'          => $voucher['to_name'],
						'to_email'         => $voucher['to_email'],
						'from_name'        => $voucher['from_name'],
						'from_email'       => $voucher['from_email'],
						'voucher_theme_id' => $voucher['voucher_theme_id'],
						'message'          => $voucher['message'],
						'amount'           => $voucher['amount']
					);
				}
			}

			$order_data['comment'] = (isset(session::$data['comment']) ? session::$data['comment'] : '');
			$order_data['total'] = $total_data['total'];

			if (isset(request::$cookie['tracking'])) {
				$order_data['tracking'] = request::$cookie['tracking'];

				$sub_total = cart::getSubTotal();

				// Affiliate
				
				$affiliate_info = account_customer::getAffiliateByTracking(request::$cookie['tracking']);

				if ($affiliate_info) {
					$order_data['affiliate_id'] = $affiliate_info['customer_id'];
					$order_data['commission'] = ($sub_total / 100) * $affiliate_info['commission'];
				} else {
					$order_data['affiliate_id'] = 0;
					$order_data['commission'] = 0;
				}

				// Marketing

				$marketing_info = checkout_marketing::getMarketingByCode(request::$cookie['tracking']);

				if ($marketing_info) {
					$order_data['marketing_id'] = $marketing_info['marketing_id'];
				} else {
					$order_data['marketing_id'] = 0;
				}
			} else {
				$order_data['affiliate_id'] = 0;
				$order_data['commission'] = 0;
				$order_data['marketing_id'] = 0;
				$order_data['tracking'] = '';
			}

			$order_data['language_id'] = config('language_id');
			$order_data['currency_id'] = currency::getId(session::$data['currency']);
			$order_data['currency_code'] = session::$data['currency'];
			$order_data['currency_value'] = currency::getValue(session::$data['currency']);
			$order_data['ip'] = request::$server['REMOTE_ADDR'];

			if (!empty(request::$server['HTTP_X_FORWARDED_FOR'])) {
				$order_data['forwarded_ip'] = request::$server['HTTP_X_FORWARDED_FOR'];
			} elseif (!empty(request::$server['HTTP_CLIENT_IP'])) {
				$order_data['forwarded_ip'] = request::$server['HTTP_CLIENT_IP'];
			} else {
				$order_data['forwarded_ip'] = '';
			}

			if (isset(request::$server['HTTP_USER_AGENT'])) {
				$order_data['user_agent'] = request::$server['HTTP_USER_AGENT'];
			} else {
				$order_data['user_agent'] = '';
			}

			if (isset(request::$server['HTTP_ACCEPT_LANGUAGE'])) {
				$order_data['accept_language'] = request::$server['HTTP_ACCEPT_LANGUAGE'];
			} else {
				$order_data['accept_language'] = '';
			}
			

			session::$data['order_id'] = checkout_order::addOrder($order_data);
			
			// Setting
			$_config = new Config();
			$_config::load('paypal');
			
			$config_setting = $_config::get('paypal_setting');
		
			$setting = array_replace_recursive((array)$config_setting, (array)config::get('payment_paypal_setting'));
			
			$client_id = config::get('payment_paypal_client_id');
			$secret = config::get('payment_paypal_secret');
			$environment = config::get('payment_paypal_environment');
			$partner_id = $setting['partner'][$environment]['partner_id'];
			$transaction_method = config::get('payment_paypal_transaction_method');
			$currency_code = config::get('payment_paypal_currency_code');
			$currency_value = config::get('payment_paypal_currency_value');
			$decimal_place = $setting['currency'][$currency_code]['decimal_place'];

			require_once 'system/library/paypal/paypal.php';
		
			$paypal_info = array(
				'partner_id' => $partner_id,
				'client_id' => $client_id,
				'secret' => $secret,
				'environment' => $environment
			);
		
			$paypal = new PayPal($paypal_info);
			
			$token_info = array(
				'grant_type' => 'client_credentials'
			);	
				
			$paypal::setAccessToken($token_info);
			
			$order_id = session::$data['paypal_order_id'];
			
			$order_info = array();
			
			$order_info[] = array(
				'op' => 'add',
				'path' => '/purchase_units/@reference_id==\'default\'/description',
				'value' => 'Your order ' . session::$data['order_id']
			);
			
			$order_info[] = array(
				'op' => 'add',
				'path' => '/purchase_units/@reference_id==\'default\'/invoice_id',
				'value' => session::$data['order_id']
			);
						
			$shipping_info = array();

			if (cart::hasShipping()) {
				$shipping_info['name']['full_name'] = (isset(session::$data['shipping_address']['firstname']) ? session::$data['shipping_address']['firstname'] : '');
				$shipping_info['name']['full_name'] .= (isset(session::$data['shipping_address']['lastname']) ? (' ' . session::$data['shipping_address']['lastname']) : '');			
				$shipping_info['address']['address_line_1'] = (isset(session::$data['shipping_address']['address_1']) ? session::$data['shipping_address']['address_1'] : '');
				$shipping_info['address']['address_line_2'] = (isset(session::$data['shipping_address']['address_2']) ? session::$data['shipping_address']['address_2'] : '');			
				$shipping_info['address']['admin_area_1'] = (isset(session::$data['shipping_address']['zone']) ? session::$data['shipping_address']['zone'] : '');
				$shipping_info['address']['admin_area_2'] = (isset(session::$data['shipping_address']['city']) ? session::$data['shipping_address']['city'] : '');
				$shipping_info['address']['postal_code'] = (isset(session::$data['shipping_address']['postcode']) ? session::$data['shipping_address']['postcode'] : '');
			
				if (isset(session::$data['shipping_address']['country_id'])) {
				
					$country_info = localisation_country::getCountry(session::$data['shipping_address']['country_id']);
			
					if ($country_info) {
						$shipping_info['address']['country_code'] = $country_info['iso_code_2'];
					}
				}
				
				$order_info[] = array(
					'op' => 'replace',
					'path' => '/purchase_units/@reference_id==\'default\'/shipping/name',
					'value' => $shipping_info['name']
				);
				
				$order_info[] = array(
					'op' => 'replace',
					'path' => '/purchase_units/@reference_id==\'default\'/shipping/address',
					'value' => $shipping_info['address']
				);
			}
												
			$item_total = 0;
				
			foreach (cart::getProducts() as $product) {
				$product_price = number_format($product['price'] * $currency_value, $decimal_place, '.', '');
				
				$item_total += $product_price * $product['quantity'];
			}
												
			$item_total = number_format($item_total, 2, '.', '');
			$sub_total = cart::getSubTotal();
			$total = cart::getTotal();
			$tax_total = number_format(($total - $sub_total) * $currency_value, $decimal_place, '.', '');
						
			$discount_total = 0;
			$handling_total = 0;
			$shipping_total = 0;
		
			if (isset(session::$data['shipping_method'])) {
				$shipping_total = tax::calculate(session::$data['shipping_method']['cost'], session::$data['shipping_method']['tax_class_id'], config('tax'));
				$shipping_total = number_format($shipping_total * $currency_value, $decimal_place, '.', '');
			}
		
			$order_total = number_format($order_data['total'] * $currency_value, $decimal_place, '.', '');
		
			$rebate = number_format($item_total + $tax_total + $shipping_total - $order_total, $decimal_place, '.', '');
		
			if ($rebate > 0) {
				$discount_total = $rebate;
			} elseif ($rebate < 0) {
				$handling_total = -$rebate;
			}

			$amount_info = array(
				'currency_code' => $currency_code,
				'value' => $order_total,
				'breakdown' => array(
					'item_total' => array(
						'currency_code' => $currency_code,
						'value' => $item_total
					),
					'tax_total' => array(
						'currency_code' => $currency_code,
						'value' => $tax_total
					),
					'shipping' => array(
						'currency_code' => $currency_code,
						'value' => $shipping_total
					),
					'handling' => array(
						'currency_code' => $currency_code,
						'value' => $handling_total
					),
					'discount' => array(
						'currency_code' => $currency_code,
						'value' => $discount_total
					)
				)
			);
			
			$order_info[] = array(
				'op' => 'replace',
				'path' => '/purchase_units/@reference_id==\'default\'/amount',
				'value' => $amount_info
			);
					
			$result = $paypal::updateOrder($order_id, $order_info);
			
			if ($transaction_method == 'authorize') {
				$result = $paypal::setOrderAuthorize($order_id);
				
				if (isset($result['purchase_units'][0]['payments']['authorizations'][0]['seller_protection'])) {
					$seller_protection_status = $result['purchase_units'][0]['payments']['authorizations'][0]['seller_protection']['status'];
				}
			} else {
				$result = $paypal::setOrderCapture($order_id);
				
				if (isset($result['purchase_units'][0]['payments']['captures'][0]['seller_protection'])) {
					$seller_protection_status = $result['purchase_units'][0]['payments']['captures'][0]['seller_protection']['status'];
				}
			}
			
			if (!cart::hasShipping()) {
				$seller_protection_status = 'NOT_ELIGIBLE';
			}
			
			if ($paypal::hasErrors()) {
				$error_messages = array();
				
				$errors = $paypal::getErrors();
								
				foreach ($errors as $error) {
					if (isset($error['name']) && ($error['name'] == 'CURLE_OPERATION_TIMEOUTED')) {
						$error['message'] = language::get('error_timeout');
					}
					
					if (isset($error['details'][0]['description'])) {
						$error_messages[] = $error['details'][0]['description'];
					} else {
						$error_messages[] = $error['message'];
					}
					
					extension_module_paypal_smart_button::log($error, $error['message']);
				}
				
				self::$error['warning'] = implode(' ', $error_messages);
			}
		
			unset(session::$data['paypal_order_id']);
			
			if (!self::$error) {								
				$message = sprintf(language::get('text_order_message'), $seller_protection_status);
				
				checkout_order::addOrderHistory(session::$data['order_id'], config('order_status_id'), $message);
				
				response::redirect(url::link('checkout/success', ''));
			} else {
				session::$data['error'] = self::$error['warning'];
				
				response::redirect(url::link('checkout/checkout', ''));
			}
		}	
		
		response::redirect(url::link('checkout/cart', ''));
	}
	
	public static function paymentAddress() {
		load::language('extension/module/paypal_smart_button');
		
		$data['guest'] = isset(session::$data['guest']) ? session::$data['guest'] : array();
		$data['payment_address'] = isset(session::$data['payment_address']) ? session::$data['payment_address'] : array();
		

		$data['countries'] = localisation_country::getCountries();
		

		$data['custom_fields'] = account_custom_field::getCustomFields();
		
		response::setOutput(load::view('extension/module/paypal_smart_button/payment_address', $data));
	}
	
	public static function shippingAddress() {
		load::language('extension/module/paypal_smart_button');
		
		$data['shipping_address'] = isset(session::$data['shipping_address']) ? session::$data['shipping_address'] : array();
				

		$data['countries'] = localisation_country::getCountries();
		

		$data['custom_fields'] = account_custom_field::getCustomFields();
		
		response::setOutput(load::view('extension/module/paypal_smart_button/shipping_address', $data));
	}
	
	public static function confirmShipping() {
		self::validateShipping(request::$post['shipping_method']);

		response::redirect(url::link('extension/module/paypal_smart_button/confirmOrder', ''));
	}
	
	public static function confirmPaymentAddress() {
		load::language('extension/module/paypal_smart_button');
		
		$data['url'] = '';
		
		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validatePaymentAddress()) {			
			session::$data['guest']['firstname'] = request::$post['firstname'];
			session::$data['guest']['lastname'] = request::$post['lastname'];
			session::$data['guest']['email'] = request::$post['email'];
			session::$data['guest']['telephone'] = request::$post['telephone'];

			if (isset(request::$post['custom_field']['account'])) {
				session::$data['guest']['custom_field'] = request::$post['custom_field']['account'];
			} else {
				session::$data['guest']['custom_field'] = array();
			}

			session::$data['payment_address']['firstname'] = request::$post['firstname'];
			session::$data['payment_address']['lastname'] = request::$post['lastname'];
			session::$data['payment_address']['company'] = request::$post['company'];
			session::$data['payment_address']['address_1'] = request::$post['address_1'];
			session::$data['payment_address']['address_2'] = request::$post['address_2'];
			session::$data['payment_address']['postcode'] = request::$post['postcode'];
			session::$data['payment_address']['city'] = request::$post['city'];
			session::$data['payment_address']['country_id'] = request::$post['country_id'];
			session::$data['payment_address']['zone_id'] = request::$post['zone_id'];


			$country_info = localisation_country::getCountry(request::$post['country_id']);

			if ($country_info) {
				session::$data['payment_address']['country'] = $country_info['name'];
				session::$data['payment_address']['iso_code_2'] = $country_info['iso_code_2'];
				session::$data['payment_address']['iso_code_3'] = $country_info['iso_code_3'];
				session::$data['payment_address']['address_format'] = $country_info['address_format'];
			} else {
				session::$data['payment_address']['country'] = '';
				session::$data['payment_address']['iso_code_2'] = '';
				session::$data['payment_address']['iso_code_3'] = '';
				session::$data['payment_address']['address_format'] = '';
			}

			if (isset(request::$post['custom_field']['address'])) {
				session::$data['payment_address']['custom_field'] = request::$post['custom_field']['address'];
			} else {
				session::$data['payment_address']['custom_field'] = array();
			}


			$zone_info = localisation_zone::getZone(request::$post['zone_id']);

			if ($zone_info) {
				session::$data['payment_address']['zone'] = $zone_info['name'];
				session::$data['payment_address']['zone_code'] = $zone_info['code'];
			} else {
				session::$data['payment_address']['zone'] = '';
				session::$data['payment_address']['zone_code'] = '';
			}
			
			$data['url'] = url::link('extension/module/paypal_smart_button/confirmOrder', '');
		}

		$data['error'] = self::$error;
		
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($data));
	}
	
	public static function confirmShippingAddress() {
		load::language('extension/module/paypal_smart_button');
		
		if ((request::$server['REQUEST_METHOD'] == 'POST') && self::validateShippingAddress()) {			
			session::$data['shipping_address']['firstname'] = request::$post['firstname'];
			session::$data['shipping_address']['lastname'] = request::$post['lastname'];
			session::$data['shipping_address']['company'] = request::$post['company'];
			session::$data['shipping_address']['address_1'] = request::$post['address_1'];
			session::$data['shipping_address']['address_2'] = request::$post['address_2'];
			session::$data['shipping_address']['postcode'] = request::$post['postcode'];
			session::$data['shipping_address']['city'] = request::$post['city'];
			session::$data['shipping_address']['country_id'] = request::$post['country_id'];
			session::$data['shipping_address']['zone_id'] = request::$post['zone_id'];


			$country_info = localisation_country::getCountry(request::$post['country_id']);

			if ($country_info) {
				session::$data['shipping_address']['country'] = $country_info['name'];
				session::$data['shipping_address']['iso_code_2'] = $country_info['iso_code_2'];
				session::$data['shipping_address']['iso_code_3'] = $country_info['iso_code_3'];
				session::$data['shipping_address']['address_format'] = $country_info['address_format'];
			} else {
				session::$data['shipping_address']['country'] = '';
				session::$data['shipping_address']['iso_code_2'] = '';
				session::$data['shipping_address']['iso_code_3'] = '';
				session::$data['shipping_address']['address_format'] = '';
			}


			$zone_info = localisation_zone::getZone(request::$post['zone_id']);

			if ($zone_info) {
				session::$data['shipping_address']['zone'] = $zone_info['name'];
				session::$data['shipping_address']['zone_code'] = $zone_info['code'];
			} else {
				session::$data['shipping_address']['zone'] = '';
				session::$data['shipping_address']['zone_code'] = '';
			}

			if (isset(request::$post['custom_field'])) {
				session::$data['shipping_address']['custom_field'] = request::$post['custom_field']['address'];
			} else {
				session::$data['shipping_address']['custom_field'] = array();
			}
			
			$data['url'] = url::link('extension/module/paypal_smart_button/confirmOrder', '');
		}
		
		$data['error'] = self::$error;
		
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($data));
	}
		
	private static function validateShipping($code) {
		load::language('checkout/cart');
		load::language('extension/module/paypal_smart_button');

		if (empty($code)) {
			session::$data['error_warning'] = language::get('error_shipping');
			
			return false;
		} else {
			$shipping = explode('.', $code);

			if (!isset($shipping[0]) || !isset($shipping[1]) || !isset(session::$data['shipping_methods'][$shipping[0]]['quote'][$shipping[1]])) {
				session::$data['error_warning'] = language::get('error_shipping');
				
				return false;
			} else {
				session::$data['shipping_method'] = session::$data['shipping_methods'][$shipping[0]]['quote'][$shipping[1]];
				session::$data['success'] = language::get('text_shipping_updated');
				
				return true;
			}
		}
	}
	
	private static function validatePaymentAddress() {
		if ((utf8_strlen(trim(request::$post['firstname'])) < 1) || (utf8_strlen(trim(request::$post['firstname'])) > 32)) {
			self::$error['firstname'] = language::get('error_firstname');
		}

		if ((utf8_strlen(trim(request::$post['lastname'])) < 1) || (utf8_strlen(trim(request::$post['lastname'])) > 32)) {
			self::$error['lastname'] = language::get('error_lastname');
		}

		if ((utf8_strlen(request::$post['email']) > 96) || !filter_var(request::$post['email'], FILTER_VALIDATE_EMAIL)) {
			self::$error['email'] = language::get('error_email');
		}

		if ((utf8_strlen(request::$post['telephone']) < 3) || (utf8_strlen(request::$post['telephone']) > 32)) {
			self::$error['telephone'] = language::get('error_telephone');
		}

		if ((utf8_strlen(trim(request::$post['address_1'])) < 3) || (utf8_strlen(trim(request::$post['address_1'])) > 128)) {
			self::$error['address_1'] = language::get('error_address_1');
		}

		if ((utf8_strlen(trim(request::$post['city'])) < 2) || (utf8_strlen(trim(request::$post['city'])) > 128)) {
			self::$error['city'] = language::get('error_city');
		}


		$country_info = localisation_country::getCountry(request::$post['country_id']);

		if ($country_info && $country_info['postcode_required'] && (utf8_strlen(trim(request::$post['postcode'])) < 2 || utf8_strlen(trim(request::$post['postcode'])) > 10)) {
			self::$error['postcode'] = language::get('error_postcode');
		}

		if (request::$post['country_id'] == '') {
			self::$error['country'] = language::get('error_country');
		}

		if (!isset(request::$post['zone_id']) || request::$post['zone_id'] == '' || !is_numeric(request::$post['zone_id'])) {
			self::$error['zone'] = language::get('error_zone');
		}
		
		// Customer Group
		if (isset(request::$post['customer_group_id']) && is_array(config('customer_group_display')) && in_array(request::$post['customer_group_id'], config('customer_group_display'))) {
			$customer_group_id = request::$post['customer_group_id'];
		} else {
			$customer_group_id = config('customer_group_id');
		}
		
		// Custom field validation

		$custom_fields = account_custom_field::getCustomFields($customer_group_id);

		foreach ($custom_fields as $custom_field) {
			if ($custom_field['required'] && empty(request::$post['custom_field'][$custom_field['location']][$custom_field['custom_field_id']])) {
				self::$error['custom_field' . $custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
			} elseif (($custom_field['type'] == 'text') && !empty($custom_field['validation']) && !filter_var(request::$post['custom_field'][$custom_field['location']][$custom_field['custom_field_id']], FILTER_VALIDATE_REGEXP, array('options' => array('regexp' => $custom_field['validation'])))) {
                self::$error['custom_field' . $custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
            }
		}
		
		return !self::$error;
	}
	
	private static function validateShippingAddress() {
		if ((utf8_strlen(trim(request::$post['firstname'])) < 1) || (utf8_strlen(trim(request::$post['firstname'])) > 32)) {
			self::$error['firstname'] = language::get('error_firstname');
		}

		if ((utf8_strlen(trim(request::$post['lastname'])) < 1) || (utf8_strlen(trim(request::$post['lastname'])) > 32)) {
			self::$error['lastname'] = language::get('error_lastname');
		}

		if ((utf8_strlen(trim(request::$post['address_1'])) < 3) || (utf8_strlen(trim(request::$post['address_1'])) > 128)) {
			self::$error['address_1'] = language::get('error_address_1');
		}

		if ((utf8_strlen(trim(request::$post['city'])) < 2) || (utf8_strlen(trim(request::$post['city'])) > 128)) {
			self::$error['city'] = language::get('error_city');
		}


		$country_info = localisation_country::getCountry(request::$post['country_id']);

		if ($country_info && $country_info['postcode_required'] && (utf8_strlen(trim(request::$post['postcode'])) < 2 || utf8_strlen(trim(request::$post['postcode'])) > 10)) {
			self::$error['postcode'] = language::get('error_postcode');
		}

		if (request::$post['country_id'] == '') {
			self::$error['country'] = language::get('error_country');
		}

		if (!isset(request::$post['zone_id']) || request::$post['zone_id'] == '' || !is_numeric(request::$post['zone_id'])) {
			self::$error['zone'] = language::get('error_zone');
		}
		
		// Customer Group
		if (isset(request::$post['customer_group_id']) && is_array(config('customer_group_display')) && in_array(request::$post['customer_group_id'], config('customer_group_display'))) {
			$customer_group_id = request::$post['customer_group_id'];
		} else {
			$customer_group_id = config('customer_group_id');
		}
		
		// Custom field validation

		$custom_fields = account_custom_field::getCustomFields($customer_group_id);

		foreach ($custom_fields as $custom_field) {
			if ($custom_field['location'] == 'address') { 
				if ($custom_field['required'] && empty(request::$post['custom_field'][$custom_field['location']][$custom_field['custom_field_id']])) {
					self::$error['custom_field' . $custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
				} elseif (($custom_field['type'] == 'text') && !empty($custom_field['validation']) && !filter_var(request::$post['custom_field'][$custom_field['location']][$custom_field['custom_field_id']], FILTER_VALIDATE_REGEXP, array('options' => array('regexp' => $custom_field['validation'])))) {
					self::$error['custom_field' . $custom_field['custom_field_id']] = sprintf(language::get('error_custom_field'), $custom_field['name']);
				}
			}
		}
		
		return !self::$error;
	}
		
	private static function validateCoupon() {

		$coupon_info = extension_total_coupon::getCoupon(request::$post['coupon']);

		if ($coupon_info) {
			return true;
		} else {
			session::$data['error_warning'] = language::get('error_coupon');
			
			return false;
		}
	}

	private static function validateVoucher() {

		$voucher_info = extension_total_voucher::getVoucher(request::$post['voucher']);

		if ($voucher_info) {
			return true;
		} else {
			session::$data['error_warning'] = language::get('error_voucher');
			
			return false;
		}
	}

	private static function validateReward() {
		$points = customer::getRewardPoints();

		$points_total = 0;

		foreach (cart::getProducts() as $product) {
			if ($product['points']) {
				$points_total += $product['points'];
			}
		}

		$error = '';

		if (empty(request::$post['reward'])) {
			$error = language::get('error_reward');
		}

		if (request::$post['reward'] > $points) {
			$error = sprintf(language::get('error_points'), request::$post['reward']);
		}

		if (request::$post['reward'] > $points_total) {
			$error = sprintf(language::get('error_maximum'), $points_total);
		}

		if (!$error) {
			return true;
		} else {
			session::$data['error_warning'] = $error;
			
			return false;
		}
	}
}
