<?php
class ControllerExtensionModulePPBraintreeButton {
	private static $gateway = null;

	public static function index() {
		if (config::get('payment_pp_braintree_status') == 1) {
			self::initialise();

			$status = true;

			if ((!cart::hasProducts() && empty(session::$data['vouchers'])) || (!cart::hasStock() && !config('stock_checkout')) || (!customer::isLogged() && (cart::hasRecurringProducts() || cart::hasDownload()))) {
				$status = false;
			}

			if ($status) {

				$create_token = array();

				$data['client_token'] = extension_payment_pp_braintree::generateToken(self::$gateway, $create_token);

				$data['payment_pp_braintree_settlement_immediate'] = config::get('payment_pp_braintree_settlement_immediate');
				$data['payment_pp_braintree_paypal_button_colour'] = config::get('payment_pp_braintree_paypal_button_colour');
				$data['payment_pp_braintree_paypal_button_size'] = config::get('payment_pp_braintree_paypal_button_size');
				$data['payment_pp_braintree_paypal_button_shape'] = config::get('payment_pp_braintree_paypal_button_shape');

				/*
				 * The auth total is just a guess as to what the end total will be since the user has not
				 * selected a shipping option yet. The user does not see this amount during checkout but the figure
				 * may be too low if buying a low value item and shipping is more than 50% of the item value.
				 */
				$data['auth_total'] = cart::getTotal() * 1.5;
				$data['currency_code'] = session::$data['currency'];
				$data['action'] = url::link('extension/payment/pp_braintree/expressConfirm', '');

				return load::view('extension/module/pp_braintree_button', $data);
			}
		}
	}

	private static function initialise() {

		if (config::get('payment_pp_braintree_access_token') != '') {
			self::$gateway = extension_payment_pp_braintree::setGateway(config::get('payment_pp_braintree_access_token'));
		} else {
			extension_payment_pp_braintree::setCredentials();
		}
	}
}
