<?php
class ControllerExtensionModuleSpecial {
	public static function index($setting) {
		load::language('extension/module/special');



		$data['products'] = array();

		$filter_data = array(
			'sort'  => 'pd.name',
			'order' => 'ASC',
			'start' => 0,
			'limit' => $setting['limit']
		);

		$results = catalog_product::getProductSpecials($filter_data);

		if ($results) {
			foreach ($results as $result) {
				if ($result['image']) {
					$image = tool_image::resize($result['image'], $setting['width'], $setting['height']);
				} else {
					$image = tool_image::resize('placeholder.png', $setting['width'], $setting['height']);
				}

				if (customer::isLogged() || !config('customer_price')) {
					$price = currency::format(tax::calculate($result['price'], $result['tax_class_id'], config('tax')), session::$data['currency']);
				} else {
					$price = false;
				}

				if (!is_null($result['special']) && (float)$result['special'] >= 0) {
					$special = currency::format(tax::calculate($result['special'], $result['tax_class_id'], config('tax')), session::$data['currency']);
					$tax_price = (float)$result['special'];
				} else {
					$special = false;
					$tax_price = (float)$result['price'];
				}
	
				if (config('tax')) {
					$tax = currency::format($tax_price, session::$data['currency']);
				} else {
					$tax = false;
				}

				if (config('review_status')) {
					$rating = $result['rating'];
				} else {
					$rating = false;
				}

				$data['products'][] = array(
					'product_id'  => $result['product_id'],
					'thumb'       => $image,
					'name'        => $result['name'],
					'description' => utf8_substr(trim(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8'))), 0, config::get('theme_' . config('theme') . '_product_description_length')) . '..',
					'price'       => $price,
					'special'     => $special,
					'tax'         => $tax,
					'rating'      => $rating,
					'href'        => url::link('product/product', 'product_id=' . $result['product_id'])
				);
			}

			return load::view('extension/module/special', $data);
		}
	}
}