<?php
class ControllerExtensionPaymentAlipay {
	public static function index() {
		$data['button_confirm'] = language::get('button_confirm');


		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$config = array (
			'app_id'               => config::get('payment_alipay_app_id'),
			'merchant_private_key' => config::get('payment_alipay_merchant_private_key'),
			'notify_url'           => HTTPS_SERVER . "payment_callback/alipay",
			'return_url'           => url::link('checkout/success'),
			'charset'              => "UTF-8",
			'sign_type'            => "RSA2",
			'gateway_url'          => config::get('payment_alipay_test') == "sandbox" ? "https://openapi.alipaydev.com/gateway.do" : "https://openapi.alipay.com/gateway.do",
			'alipay_public_key'    => config::get('payment_alipay_alipay_public_key'),
		);
		$out_trade_no = trim($order_info['order_id']);
		$subject = trim(config('name'));
		$total_amount = trim(currency::format($order_info['total'], 'CNY', '', false));
		$body = '';//trim($_POST['WIDbody']);

		$payRequestBuilder = array(
			'body'         => $body,
			'subject'      => $subject,
			'total_amount' => $total_amount,
			'out_trade_no' => $out_trade_no,
			'product_code' => 'FAST_INSTANT_TRADE_PAY'
		);


		$response = extension_payment_alipay::pagePay($payRequestBuilder,$config);
		$data['action'] = $config['gateway_url'] . "?charset=" . extension_payment_alipay::getPostCharset();
		$data['form_params'] = $response;

		return load::view('extension/payment/alipay', $data);
	}

	public static function callback() {
		log::write('alipay pay notify:');
		$arr = $_POST;
		$config = array (
			'app_id'               => config::get('payment_alipay_app_id'),
			'merchant_private_key' => config::get('payment_alipay_merchant_private_key'),
			'notify_url'           => HTTPS_SERVER . "payment_callback/alipay",
			'return_url'           => url::link('checkout/success'),
			'charset'              => "UTF-8",
			'sign_type'            => "RSA2",
			'gateway_url'          => config::get('payment_alipay_test') == "sandbox" ? "https://openapi.alipaydev.com/gateway.do" : "https://openapi.alipay.com/gateway.do",
			'alipay_public_key'    => config::get('payment_alipay_alipay_public_key'),
		);
		log::write('POST' . var_export($_POST,true));
		$result = extension_payment_alipay::check($arr, $config);

		if($result) {//check successed
			log::write('Alipay check successed');
			$order_id = $_POST['out_trade_no'];
			if($_POST['trade_status'] == 'TRADE_FINISHED') {
			}
			else if ($_POST['trade_status'] == 'TRADE_SUCCESS') {
				checkout_order::addOrderHistory($order_id, config::get('payment_alipay_order_status_id'));
			}
			echo "success";	//Do not modified or deleted
		}else {
			log::write('Alipay check failed');
			//chedk failed
			echo "fail";

		}
	}
}