<?php
class ControllerExtensionPaymentAlipayCross {
	var $alipay_gateway = 'https://mapi.alipay.com/gateway.do?';
	var $alipay_gateway_test = 'https://openapi.alipaydev.com/gateway.do?';

	public static function index() {
		$data['button_confirm'] = language::get('button_confirm');


		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$out_trade_no = str_pad($order_info['order_id'], 7, "0",STR_PAD_LEFT); // Length must be greater than 7
		$subject = trim(config('name'));
		$currency = config::get('payment_alipay_cross_currency');
		$total_fee = trim(currency::format($order_info['total'], $currency, '', false));
		$total_fee_cny = trim(currency::format($order_info['total'], 'CNY', '', false));
		$body = trim(config('name'));

		$alipay_config = array (
			'partner'              => config::get('payment_alipay_cross_app_id'),
			'key'                  => config::get('payment_alipay_cross_merchant_private_key'),
			'notify_url'           => HTTPS_SERVER . "payment_callback/alipay_cross",
			'return_url'           => url::link('checkout/success'),
			'sign_type'            => strtoupper('MD5'),
			'input_charset'        => strtolower('utf-8'),
			'cacert'               => getcwd().'/cacert.pem',
			'transport'            => 'https',
			'service'              => 'create_forex_trade'
		);

		$parameter = array(
			"service"        => $alipay_config['service'],
			"partner"        => $alipay_config['partner'],
			"notify_url"     => $alipay_config['notify_url'],
			"return_url"     => $alipay_config['return_url'],

			"out_trade_no"   => $out_trade_no,
			"subject"        => $subject,
			"body"           => $body,
			"currency"       => $currency,
			"_input_charset" => trim(strtolower($alipay_config['input_charset']))
		);
		if (isset(session::$data['currency']) && session::$data['currency'] == 'CNY') {
			$parameter['rmb_fee'] = $total_fee_cny;
		} else {
			$parameter['total_fee'] = $total_fee;
		}

		$data['params'] = extension_payment_alipay_cross::buildRequestPara($alipay_config, $parameter);
		$gateway = config::get('payment_alipay_cross_test') == "sandbox" ? self::$alipay_gateway_test : self::$alipay_gateway;
		$data['action'] = $gateway . "_input_charset=".trim($alipay_config['input_charset']);

		return load::view('extension/payment/alipay_cross', $data);
	}

	public static function callback() {
		log::write('alipay cross payment notify:');
		$alipay_config = array (
			'partner'              => config::get('payment_alipay_cross_app_id'),
			'key'                  => config::get('payment_alipay_cross_merchant_private_key'),
			'sign_type'            => strtoupper('MD5'),
			'input_charset'        => strtolower('utf-8'),
			'cacert'               => getcwd().'/cacert.pem'
		);
		log::write('config: ' . var_export($alipay_config,true));
		$verify_result = extension_payment_alipay_cross::verifyNotify($alipay_config);

		if($verify_result) {//check successed
			log::write('Alipay cross check successed');
			$order_id = $_POST['out_trade_no'];
			if($_POST['trade_status'] == 'TRADE_FINISHED') {
				checkout_order::addOrderHistory($order_id, config::get('payment_alipay_cross_order_status_id'));
			} else if ($_POST['trade_status'] == 'TRADE_SUCCESS') {
			}
			echo "success"; //Do not modified or deleted
		} else {
			log::write('Alipay cross check failed');
			//chedk failed
			echo "fail";

		}
	}
}
