<?php
class ControllerExtensionPaymentBluePayHosted {
	public static function index() {
		load::language('extension/payment/bluepay_hosted');

		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$data['ORDER_ID'] = session::$data['order_id'];
		$data['NAME1'] = $order_info['payment_firstname'];
		$data['NAME2'] = $order_info['payment_lastname'];
		$data['ADDR1'] = $order_info['payment_address_1'];
		$data['ADDR2'] = $order_info['payment_address_2'];
		$data['CITY'] = $order_info['payment_city'];
		$data['STATE'] = $order_info['payment_zone'];
		$data['ZIPCODE'] = $order_info['payment_postcode'];
		$data['COUNTRY'] = $order_info['payment_country'];
		$data['PHONE'] = $order_info['telephone'];
		$data['EMAIL'] = $order_info['email'];

		$data['SHPF_FORM_ID'] = 'opencart01';
		$data['DBA'] = config::get('payment_bluepay_hosted_account_name');
		$data['MERCHANT'] = config::get('payment_bluepay_hosted_account_id');
		$data['SHPF_ACCOUNT_ID'] = config::get('payment_bluepay_hosted_account_id');
		$data["TRANSACTION_TYPE"] = config::get('payment_bluepay_hosted_transaction');
		$data["MODE"] = strtoupper(config::get('payment_bluepay_hosted_test'));

		$data['CARD_TYPES'] = 'vi-mc';

		if (config::get('payment_bluepay_hosted_discover') == 1) {
			$data['CARD_TYPES'] .= '-di';
		}

		if (config::get('payment_bluepay_hosted_amex') == 1) {
			$data['CARD_TYPES'] .= '-am';
		}

		$data["AMOUNT"] = currency::format($order_info['total'], $order_info['currency_code'], false, false);
		$data['APPROVED_URL'] = url::link('extension/payment/bluepay_hosted/callback', '');
		$data['DECLINED_URL'] = url::link('extension/payment/bluepay_hosted/callback', '');
		$data['MISSING_URL'] = url::link('extension/payment/bluepay_hosted/callback', '');
		$data['REDIRECT_URL'] = url::link('extension/payment/bluepay_hosted/callback', '');

		$data['TPS_DEF'] = "MERCHANT APPROVED_URL DECLINED_URL MISSING_URL MODE TRANSACTION_TYPE TPS_DEF AMOUNT";
		$data['TAMPER_PROOF_SEAL'] = md5(config::get('payment_bluepay_hosted_secret_key') . $data['MERCHANT'] . $data['APPROVED_URL'] . $data['DECLINED_URL'] . $data['MISSING_URL'] . $data['MODE'] . $data['TRANSACTION_TYPE'] . $data['TPS_DEF'] . $data['AMOUNT']);

		$data['SHPF_TPS_DEF'] = "SHPF_FORM_ID SHPF_ACCOUNT_ID DBA TAMPER_PROOF_SEAL CARD_TYPES TPS_DEF SHPF_TPS_DEF AMOUNT";
		$data['SHPF_TPS'] = md5(config::get('payment_bluepay_hosted_secret_key') . $data['SHPF_FORM_ID'] . $data['SHPF_ACCOUNT_ID'] . $data['DBA'] . $data['TAMPER_PROOF_SEAL'] . $data['CARD_TYPES'] . $data['TPS_DEF'] . $data['SHPF_TPS_DEF'] . $data['AMOUNT']);

		$data['button_confirm'] = language::get('button_confirm');
		$data['text_loading'] = language::get('text_loading');

		return load::view('extension/payment/bluepay_hosted', $data);
	}

	public static function callback() {
		load::language('extension/payment/bluepay_hosted');



		$response_data = request::$get;

		if (isset(session::$data['order_id'])) {
			$order_info = checkout_order::getOrder(session::$data['order_id']);

			if ($response_data['Result'] == 'APPROVED') {
				$bluepay_hosted_order_id = extension_payment_bluepay_hosted::addOrder($order_info, $response_data);

				if (config::get('payment_bluepay_hosted_transaction') == 'SALE') {
					extension_payment_bluepay_hosted::addTransaction($bluepay_hosted_order_id, 'payment', $order_info);
				} else {
					extension_payment_bluepay_hosted::addTransaction($bluepay_hosted_order_id, 'auth', $order_info);
				}

				checkout_order::addOrderHistory(session::$data['order_id'], config::get('payment_bluepay_hosted_order_status_id'));

				response::redirect(url::link('checkout/success', ''));
			} else {
				session::$data['error'] = $response_data['Result'] . ' : ' . $response_data['MESSAGE'];

				response::redirect(url::link('checkout/checkout', ''));
			}
		} else {
			response::redirect(url::link('account/login', ''));
		}
	}

	public static function adminCallback() {
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode(request::$get));
	}
}