<?php
class ControllerExtensionPaymentBluePayRedirect {
	public static function index() {
		load::language('extension/payment/bluepay_redirect');

		$data['months'] = array();

		for ($i = 1; $i <= 12; $i++) {
			$data['months'][] = array(
				'text' => sprintf('%02d', $i),
				'value' => sprintf('%02d', $i)
			);
		}

		$today = getdate();

		$data['year_expire'] = array();

		for ($i = $today['year']; $i < $today['year'] + 11; $i++) {
			$data['year_expire'][] = array(
				'text' => sprintf('%02d', $i % 100),
				'value' => sprintf('%04d', $i)
			);
		}

		if (config::get('payment_bluepay_redirect_card') == '1') {
			$data['bluepay_redirect_card'] = true;
		} else {
			$data['bluepay_redirect_card'] = false;
		}

		$data['existing_cards'] = array();
		if (customer::isLogged() && $data['bluepay_redirect_card']) {

			$cards = extension_payment_bluepay_redirect::getCards(customer::getId());

			$data['existing_cards'] = $cards;
		}

		return load::view('extension/payment/bluepay_redirect', $data);
	}

	public static function send() {
		load::language('extension/payment/bluepay_redirect');



		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);
		$post_data = request::$post;

		$post_data['MERCHANT'] = config::get('payment_bluepay_redirect_account_id');
		$post_data["TRANSACTION_TYPE"] = config::get('payment_bluepay_redirect_transaction');
		$post_data["MODE"] = strtoupper(config::get('payment_bluepay_redirect_test'));
		$post_data["AMOUNT"] = currency::format($order_info['total'], $order_info['currency_code'], false, false);

		if (isset(request::$post['RRNO'])) {
			$post_data["RRNO"] = request::$post['RRNO'];
		} else {
			$post_data["RRNO"] = '';
		}

		$post_data["NAME"] = substr($order_info['payment_firstname'], 0, 20) . ' ' . substr($order_info['payment_lastname'], 0, 20);
		$post_data["ADDR1"] = $post_data['BillingAddress1'] = substr($order_info['payment_address_1'], 0, 100);
		$post_data["CITY"] = $order_info['payment_city'];
		$post_data['STATE'] = $order_info['payment_zone_code'];
		$post_data["PHONE"] = substr($order_info['telephone'], 0, 20);
		$post_data["EMAIL"] = substr($order_info['email'], 0, 255);
		$post_data["ORDER_ID"] = session::$data['order_id'];
		$post_data['ZIPCODE'] = substr($order_info['payment_postcode'], 0, 10);

		$post_data['APPROVED_URL'] = url::link('extension/payment/bluepay_redirect/callback', '');
		$post_data['DECLINED_URL'] = url::link('extension/payment/bluepay_redirect/callback', '');
		$post_data['MISSING_URL'] = url::link('extension/payment/bluepay_redirect/callback', '');

		if (isset(request::$server["REMOTE_ADDR"])) {
			$post_data["REMOTE_IP"] = request::$server["REMOTE_ADDR"];
		}

		$tamper_proof_data = config::get('payment_bluepay_redirect_secret_key') . $post_data['MERCHANT'] . $post_data["TRANSACTION_TYPE"] . $post_data['AMOUNT'] . $post_data["RRNO"] . $post_data["MODE"];

		$post_data["TAMPER_PROOF_SEAL"] = md5($tamper_proof_data);

		$response_data = extension_payment_bluepay_redirect::sendCurl("https://secure.bluepay.com/interfaces/bp10emu", $post_data);

		if ($response_data['Result'] == 'APPROVED') {
			$bluepay_redirect_order_id = extension_payment_bluepay_redirect::addOrder($order_info, $response_data);

			if (config::get('payment_bluepay_redirect_transaction') == 'SALE') {
				extension_payment_bluepay_redirect::addTransaction($bluepay_redirect_order_id, 'payment', $order_info);
			} else {
				extension_payment_bluepay_redirect::addTransaction($bluepay_redirect_order_id, 'auth', $order_info);
			}

			checkout_order::addOrderHistory(session::$data['order_id'], config::get('payment_bluepay_redirect_order_status_id'));

			$json['redirect'] = url::link('checkout/success', '');
		} else {
			$json['error'] = $response_data['Result'] . ' : ' . $response_data['MESSAGE'];
		}

		if (isset($post_data['CreateToken']) && $response_data['Result'] == 'APPROVED') {
			$card_data['customer_id'] = customer::getId();
			$card_data['Last4Digits'] = substr(str_replace(' ', '', $post_data['CC_NUM']), -4, 4);
			$card_data['ExpiryDate'] = $post_data['CC_EXPIRES_MONTH'] . '/' . substr($post_data['CC_EXPIRES_YEAR'], 2);
			$card_data['CardType'] = $response_data['CARD_TYPE'];
			$card_data['Token'] = $response_data['RRNO'];

			extension_payment_bluepay_redirect::addCard($card_data);
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function callback() {
		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode(request::$get));
	}
}