<?php
class ControllerExtensionPaymentFirstdata {
	public static function index() {
		load::language('extension/payment/firstdata');


		$order_info = checkout_order::getOrder(session::$data['order_id']);

		if (config::get('payment_firstdata_live_demo') == 1) {
			$data['action'] = config::get('payment_firstdata_live_url');
		} else {
			$data['action'] = config::get('payment_firstdata_demo_url');
		}

		$data['amount'] = currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$data['currency'] = extension_payment_firstdata::mapCurrency($order_info['currency_code']);
		$data['merchant_id'] = config::get('payment_firstdata_merchant_id');
		$data['timestamp'] = date('Y:m:d-H:i:s');
		$data['order_id'] = 'CON-' . session::$data['order_id'] . 'T' . $data['timestamp'] . mt_rand(1, 999);
		$data['url_success'] = url::link('checkout/success', '');
		$data['url_fail'] = url::link('extension/payment/firstdata/fail', '');
		$data['url_notify'] = url::link('extension/payment/firstdata/notify', '');

		if (preg_match("/Mobile|Android|BlackBerry|iPhone|Windows Phone/", request::$server['HTTP_USER_AGENT'])) {
			$data['mobile'] = true;
		} else {
			$data['mobile'] = false;
		}

		if (config::get('payment_firstdata_auto_settle') == 1) {
			$data['txntype'] = 'sale';
		} else {
			$data['txntype'] = 'preauth';
		}

		$tmp = $data['merchant_id'] . $data['timestamp'] . $data['amount'] . $data['currency'] . config::get('payment_firstdata_secret');
		$ascii = bin2hex($tmp);
		$data['hash'] = sha1($ascii);

		$data['version'] = 'OPENCART-C-' . VERSION;

		$data['bcompany'] = $order_info['payment_company'];
		$data['bname'] = $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
		$data['baddr1'] = substr($order_info['payment_address_1'], 0, 30);
		$data['baddr2'] = substr($order_info['payment_address_2'], 0, 30);
		$data['bcity'] = substr($order_info['payment_city'], 0, 30);
		$data['bstate'] = substr($order_info['payment_zone'], 0, 30);
		$data['bcountry'] = $order_info['payment_iso_code_2'];
		$data['bzip'] = $order_info['payment_postcode'];
		$data['email'] = $order_info['email'];

		if (cart::hasShipping()) {
			$data['sname'] = $order_info['shipping_firstname'] . ' ' . $order_info['shipping_lastname'];
			$data['saddr1'] = substr($order_info['shipping_address_1'], 0, 30);
			$data['saddr2'] = substr($order_info['shipping_address_2'], 0, 30);
			$data['scity'] = substr($order_info['shipping_city'], 0, 30);
			$data['sstate'] = substr($order_info['shipping_zone'], 0, 30);
			$data['scountry'] = $order_info['shipping_iso_code_2'];
			$data['szip'] = $order_info['shipping_postcode'];
		} else {
			$data['sname'] = $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
			$data['saddr1'] = substr($order_info['payment_address_1'], 0, 30);
			$data['saddr2'] = substr($order_info['payment_address_2'], 0, 30);
			$data['scity'] = substr($order_info['payment_city'], 0, 30);
			$data['sstate'] = substr($order_info['payment_zone'], 0, 30);
			$data['scountry'] = $order_info['payment_iso_code_2'];
			$data['szip'] = $order_info['payment_postcode'];
		}

		if (config::get('payment_firstdata_card_storage') == 1 && customer::isLogged()) {
			$data['card_storage'] = 1;
			$data['stored_cards'] = extension_payment_firstdata::getStoredCards();
			$data['new_hosted_id'] = sha1(customer::getId()  . '-' . date("Y-m-d-H-i-s") . rand(10, 500));
		} else {
			$data['card_storage'] = 0;
			$data['stored_cards'] = array();
		}

		return load::view('extension/payment/firstdata', $data);
	}

	public static function notify() {


		load::language('extension/payment/firstdata');

		$message = '';

		if (config::get('payment_firstdata_debug') == 1) {
			extension_payment_firstdata::logger(print_r(request::$post, 1));
		}

		if (isset(request::$post['txntype']) && isset(request::$post['notification_hash']) && isset(request::$post['oid'])) {
			$local_hash = extension_payment_firstdata::responseHash(request::$post['chargetotal'], request::$post['currency'], request::$post['txndatetime'], request::$post['approval_code']);

			if ($local_hash == request::$post['notification_hash']) {
				$order_id_parts = explode('T', request::$post['oid']);

				$order_id = str_replace("CON-","",$order_id_parts[0]);

				$order_info = checkout_order::getOrder($order_id);

				if (request::$post['txntype'] == 'preauth' || request::$post['txntype'] == 'sale') {
					if (isset(request::$post['approval_code'])) {
						$response_parts = explode(':', request::$post['approval_code']);

						$address_codes = array(
							'PPX' => language::get('text_address_ppx'),
							'YYY' => language::get('text_address_yyy'),
							'YNA' => language::get('text_address_yna'),
							'NYZ' => language::get('text_address_nyz'),
							'NNN' => language::get('text_address_nnn'),
							'YPX' => language::get('text_address_ypx'),
							'PYX' => language::get('text_address_pyx'),
							'XXU' => language::get('text_address_xxu')
						);

						$cvv_codes = array(
							'M'    => language::get('text_card_code_m'),
							'N'    => language::get('text_card_code_n'),
							'P'    => language::get('text_card_code_p'),
							'S'    => language::get('text_card_code_s'),
							'U'    => language::get('text_card_code_u'),
							'X'    => language::get('text_card_code_x'),
							'NONE' => language::get('text_card_code_blank')
						);

						$card_types = array(
							'M'         => language::get('text_card_type_m'),
							'V'         => language::get('text_card_type_v'),
							'C'         => language::get('text_card_type_c'),
							'A'         => language::get('text_card_type_a'),
							'MA'        => language::get('text_card_type_ma'),
							'MAESTROUK' => language::get('text_card_type_mauk')
						);

						if ($response_parts[0] == 'Y') {
							if (isset($response_parts[3])) {
								if (strlen($response_parts[3]) == 4) {
									$address_pass = strtoupper(substr($response_parts[3], 0, 3));
									$cvv_pass = strtoupper(substr($response_parts[3], -1));

									if (!array_key_exists($cvv_pass, $cvv_codes)) {
										$cvv_pass = 'NONE';
									}
								} else {
									$address_pass = $response_parts[3];
									$cvv_pass = 'NONE';
								}

								$message .= language::get('text_address_response') . $address_codes[$address_pass] . '<br />';
								$message .= language::get('text_card_code_verify') . $cvv_codes[$cvv_pass] . '<br />';
								$message .= language::get('text_response_code_full') . request::$post['approval_code'] . '<br />';
								$message .= language::get('text_response_code') . $response_parts[1] . '<br />';

								if (isset(request::$post['cardnumber'])) {
									$message .= language::get('text_response_card') . request::$post['cardnumber'] . '<br />';
								}

								if (isset(request::$post['processor_response_code'])) {
									$message .= language::get('text_response_proc_code') . request::$post['processor_response_code'] . '<br />';
								}

								if (isset(request::$post['refnumber'])) {
									$message .= language::get('text_response_ref') . request::$post['refnumber'] . '<br />';
								}

								if (isset(request::$post['paymentMethod'])) {
									$message .= language::get('text_response_card_type') . $card_types[strtoupper(request::$post['paymentMethod'])] . '<br />';
								}
							}

							if (isset(request::$post['hosteddataid']) && $order_info['customer_id'] != 0) {
								extension_payment_firstdata::storeCard(request::$post['hosteddataid'], $order_info['customer_id'], request::$post['expmonth'], request::$post['expyear'], request::$post['cardnumber']);
							}

							$fd_order_id = extension_payment_firstdata::addOrder($order_info, request::$post['oid'], request::$post['tdate']);

							if (config::get('payment_firstdata_auto_settle') == 1) {
								extension_payment_firstdata::addTransaction($fd_order_id, 'payment', $order_info);

								checkout_order::addOrderHistory($order_id, config::get('payment_firstdata_order_status_success_settled_id'), $message, false);
							} else {
								extension_payment_firstdata::addTransaction($fd_order_id, 'auth');

								checkout_order::addOrderHistory($order_id, config::get('payment_firstdata_order_status_success_unsettled_id'), $message, false);
							}
						} else {
							$message = request::$post['fail_reason'] . '<br />';
							$message .= language::get('text_response_code_full') . request::$post['approval_code'];

							checkout_order::addOrderHistory($order_id, config::get('payment_firstdata_order_status_decline_id'), $message);
						}
					}
				}

				if (request::$post['txntype'] == 'void') {
					if (request::$post['status'] == 'DECLINED') {
						$fd_order = extension_payment_firstdata::getOrder($order_id);

						extension_payment_firstdata::updateVoidStatus($order_id, 1);

						extension_payment_firstdata::addTransaction($fd_order['firstdata_order_id'], 'void');

						checkout_order::addOrderHistory($order_id, config::get('payment_firstdata_order_status_void_id'), $message, false);
					}
				}

				if (request::$post['txntype'] == 'postauth') {
					if (request::$post['status'] == 'APPROVED') {
						$fd_order = extension_payment_firstdata::getOrder($order_id);

						extension_payment_firstdata::updateCaptureStatus($order_id, 1);

						extension_payment_firstdata::addTransaction($fd_order['firstdata_order_id'], 'payment', $order_info);

						checkout_order::addOrderHistory($order_id, config::get('payment_firstdata_order_status_success_settled_id'), $message, false);
					}
				}
			} else {
				extension_payment_firstdata::logger('Hash does not match! Received: ' . request::$post['notification_hash'] . ', calculated: ' . $local_hash);
			}
		} else {
			extension_payment_firstdata::logger('Data is missing from request . ');
		}
	}

	public static function fail() {
		load::language('extension/payment/firstdata');

		if (isset(request::$post['fail_reason']) && !empty(request::$post['fail_reason'])) {
			session::$data['error'] = request::$post['fail_reason'];
		} else {
			session::$data['error'] = language::get('error_failed');
		}

		response::redirect(url::link('checkout/checkout', ''));
	}
}