<?php
class ControllerExtensionPaymentLiqPay {
	public static function index() {
		$data['button_confirm'] = language::get('button_confirm');


		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$data['action'] = 'https://liqpay.ua/?do=clickNbuy';

		$xml  = '<request>';
		$xml .= '	<version>1.2</version>';
		$xml .= '	<result_url>' . url::link('checkout/success', '') . '</result_url>';
		$xml .= '	<server_url>' . url::link('extension/payment/liqpay/callback', '') . '</server_url>';
		$xml .= '	<merchant_id>' . config::get('payment_liqpay_merchant') . '</merchant_id>';
		$xml .= '	<order_id>' . session::$data['order_id'] . '</order_id>';
		$xml .= '	<amount>' . currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false) . '</amount>';
		$xml .= '	<currency>' . $order_info['currency_code'] . '</currency>';
		$xml .= '	<description>' . config('name') . ' ' . $order_info['payment_firstname'] . ' ' . $order_info['payment_address_1'] . ' ' . $order_info['payment_address_2'] . ' ' . $order_info['payment_city'] . ' ' . $order_info['email'] . '</description>';
		$xml .= '	<default_phone></default_phone>';
		$xml .= '	<pay_way>' . config::get('payment_liqpay_type') . '</pay_way>';
		$xml .= '</request>';

		$data['xml'] = base64_encode($xml);
		$data['signature'] = base64_encode(sha1(config::get('payment_liqpay_signature') . $xml . config::get('payment_liqpay_signature'), true));

		return load::view('extension/payment/liqpay', $data);
	}

	public static function callback() {
		$xml = base64_decode(request::$post['operation_xml']);
		$signature = base64_encode(sha1(config::get('payment_liqpay_signature') . $xml . config::get('payment_liqpay_signature'), true));

		$posleft = strpos($xml, 'order_id');
		$posright = strpos($xml, '/order_id');

		$order_id = substr($xml, $posleft + 9, $posright - $posleft - 10);

		if ($signature == request::$post['signature']) {

			checkout_order::addOrderHistory($order_id, config('order_status_id'));
		}
	}
}