<?php
class ControllerExtensionPaymentPaymate {
	public static function index() {
		if (!config::get('payment_paymate_test')) {
			$data['action'] = 'https://www.paymate.com/PayMate/ExpressPayment';
		} else {
			$data['action'] = 'https://www.paymate.com.au/PayMate/TestExpressPayment';
		}


		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$data['mid'] = config::get('payment_paymate_username');
		$data['amt'] = currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);

		$data['currency'] = $order_info['currency_code'];
		$data['ref'] = $order_info['order_id'];

		$data['pmt_sender_email'] = $order_info['email'];
		$data['pmt_contact_firstname'] = $order_info['payment_firstname'];
		$data['pmt_contact_surname'] = $order_info['payment_lastname'];
		$data['pmt_contact_phone'] = $order_info['telephone'];
		$data['pmt_country'] = $order_info['payment_iso_code_2'];

		$data['regindi_address1'] = $order_info['payment_address_1'];
		$data['regindi_address2'] = $order_info['payment_address_2'];
		$data['regindi_sub'] = $order_info['payment_city'];
		$data['regindi_state'] = $order_info['payment_zone'];
		$data['regindi_pcode'] = $order_info['payment_postcode'];

		$data['return'] = url::link('extension/payment/paymate/callback', 'hash=' . md5($order_info['order_id'] . currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value']) . $order_info['currency_code'] . config::get('payment_paymate_password')));

		return load::view('extension/payment/paymate', $data);
	}

	public static function callback() {
		load::language('extension/payment/paymate');

		if (isset(request::$post['ref'])) {
			$order_id = request::$post['ref'];
		} else {
			$order_id = 0;
		}


		$order_info = checkout_order::getOrder($order_id);

		if ($order_info) {
			$error = '';

			if (!isset(request::$post['responseCode']) || !isset(request::$get['hash'])) {
				$error = language::get('text_unable');
			} elseif (request::$get['hash'] != md5($order_info['order_id'] . currency::format(request::$post['paymentAmount'], request::$post['currency'], 1.0000000, false) . request::$post['currency'] . config::get('payment_paymate_password'))) {
				$error = language::get('text_unable');
			} elseif (request::$post['responseCode'] != 'PA' && request::$post['responseCode'] != 'PP') {
				$error = language::get('text_declined');
			}
		} else {
			$error = language::get('text_unable');
		}

		if ($error) {
			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_home'),
				'href' => url::link('common/home')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_basket'),
				'href' => url::link('checkout/cart')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_checkout'),
				'href' => url::link('checkout/checkout', '')
			);

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_failed'),
				'href' => url::link('checkout/success')
			);

			$data['text_message'] = sprintf(language::get('text_failed_message'), $error, url::link('information/contact'));

			$data['continue'] = url::link('common/home');

			$data['column_left'] = load::controller('common/column_left');
			$data['column_right'] = load::controller('common/column_right');
			$data['content_top'] = load::controller('common/content_top');
			$data['content_bottom'] = load::controller('common/content_bottom');
			$data['footer'] = load::controller('common/footer');
			$data['header'] = load::controller('common/header');

			response::setOutput(load::view('common/success', $data));
		} else {
			checkout_order::addOrderHistory($order_id, config::get('payment_paymate_order_status_id'));

			response::redirect(url::link('checkout/success'));
		}
	}
}