<?php
class ControllerExtensionPaymentPayza {
	public static function index() {
		$data['button_confirm'] = language::get('button_confirm');


		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$data['action'] = 'https://secure.payza.com/checkout';

		$data['ap_merchant'] = config::get('payment_payza_merchant');
		$data['ap_amount'] = currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$data['ap_currency'] = $order_info['currency_code'];
		$data['ap_purchasetype'] = 'Item';
		$data['ap_itemname'] = config('name') . ' - #' . session::$data['order_id'];
		$data['ap_itemcode'] = session::$data['order_id'];
		$data['ap_returnurl'] = url::link('checkout/success');
		$data['ap_cancelurl'] = url::link('checkout/checkout', '');

		return load::view('extension/payment/payza', $data);
	}

	public static function callback() {
		if (isset(request::$post['ap_securitycode']) && (request::$post['ap_securitycode'] == config::get('payment_payza_security'))) {

			checkout_order::addOrderHistory(request::$post['ap_itemcode'], config::get('payment_payza_order_status_id'));
		}
	}
}