<?php
class ControllerExtensionPaymentPPPayflow {
	public static function index() {
		load::language('extension/payment/pp_payflow');

		$data['text_credit_card'] = language::get('text_credit_card');
		$data['text_start_date'] = language::get('text_start_date');
		$data['text_issue'] = language::get('text_issue');
		$data['text_loading'] = language::get('text_loading');

		$data['entry_cc_owner'] = language::get('entry_cc_owner');
		$data['entry_cc_type'] = language::get('entry_cc_type');
		$data['entry_cc_number'] = language::get('entry_cc_number');
		$data['entry_cc_start_date'] = language::get('entry_cc_start_date');
		$data['entry_cc_expire_date'] = language::get('entry_cc_expire_date');
		$data['entry_cc_cvv2'] = language::get('entry_cc_cvv2');
		$data['entry_cc_issue'] = language::get('entry_cc_issue');

		$data['button_confirm'] = language::get('button_confirm');


		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$data['owner'] = $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];

		$data['cards'] = array();

		$data['cards'][] = array(
			'text'  => 'Visa',
			'value' => '0'
		);

		$data['cards'][] = array(
			'text'  => 'MasterCard',
			'value' => '1'
		);

		$data['cards'][] = array(
			'text'  => 'Maestro',
			'value' => '9'
		);

		$data['cards'][] = array(
			'text'  => 'Solo',
			'value' => 'S'
		);

		$data['months'] = array();

		for ($i = 1; $i <= 12; $i++) {
			$data['months'][] = array(
				'text'  => sprintf('%02d', $i),
				'value' => sprintf('%02d', $i)
			);
		}

		$today = getdate();

		$data['year_valid'] = array();

		for ($i = $today['year'] - 10; $i < $today['year'] + 1; $i++) {
			$data['year_valid'][] = array(
				'text'  => sprintf('%02d', $i % 100),
				'value' => sprintf('%04d', $i)
			);
		}

		$data['year_expire'] = array();

		for ($i = $today['year']; $i < $today['year'] + 11; $i++) {
			$data['year_expire'][] = array(
				'text'  => sprintf('%02d', $i % 100),
				'value' => sprintf('%04d', $i)
			);
		}

		return load::view('extension/payment/pp_payflow', $data);
	}

	public static function send() {
		load::language('extension/payment/pp_payflow');


		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		if (!config::get('payment_pp_payflow_transaction')) {
			$payment_type = 'A';
		} else {
			$payment_type = 'S';
		}

		$request  = 'USER=' . urlencode(config::get('payment_pp_payflow_user'));
		$request .= '&VENDOR=' . urlencode(config::get('payment_pp_payflow_vendor'));
		$request .= '&PARTNER=' . urlencode(config::get('payment_pp_payflow_partner'));
		$request .= '&PWD=' . urlencode(config::get('payment_pp_payflow_password'));
		$request .= '&TENDER=C';
		$request .= '&TRXTYPE=' . $payment_type;
		$request .= '&AMT=' . currency::format($order_info['total'], $order_info['currency_code'], false, false);
		$request .= '&CURRENCY=' . urlencode($order_info['currency_code']);
		$request .= '&NAME=' . urlencode(request::$post['cc_owner']);
		$request .= '&STREET=' . urlencode($order_info['payment_address_1']);
		$request .= '&CITY=' . urlencode($order_info['payment_city']);
		$request .= '&STATE=' . urlencode(($order_info['payment_iso_code_2'] != 'US') ? $order_info['payment_zone'] : $order_info['payment_zone_code']);
		$request .= '&COUNTRY=' . urlencode($order_info['payment_iso_code_2']);
		$request .= '&ZIP=' . urlencode(str_replace(' ', '', $order_info['payment_postcode']));
		$request .= '&CLIENTIP=' . urlencode(request::$server['REMOTE_ADDR']);
		$request .= '&EMAIL=' . urlencode($order_info['email']);
		$request .= '&ACCT=' . urlencode(str_replace(' ', '', request::$post['cc_number']));
		$request .= '&ACCTTYPE=' . urlencode(request::$post['cc_type']);
		$request .= '&CARDSTART=' . urlencode(request::$post['cc_start_date_month'] . substr(request::$post['cc_start_date_year'], - 2, 2));
		$request .= '&EXPDATE=' . urlencode(request::$post['cc_expire_date_month'] . substr(request::$post['cc_expire_date_year'], - 2, 2));
		$request .= '&CVV2=' . urlencode(request::$post['cc_cvv2']);
		$request .= '&CARDISSUE=' . urlencode(request::$post['cc_issue']);
		$request .= '&BUTTONSOURCE=' . urlencode('OpenCart_2.0_PFP');

		if (!config::get('payment_pp_payflow_test')) {
			$curl = curl_init('https://payflowpro.paypal.com');
		} else {
			$curl = curl_init('https://pilot-payflowpro.paypal.com');
		}

		curl_setopt($curl, CURLOPT_PORT, 443);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
		curl_setopt($curl, CURLOPT_HTTPHEADER, array('X-VPS-REQUEST-ID: ' . md5(session::$data['order_id'] . mt_rand())));

		$response = curl_exec($curl);

		curl_close($curl);

		if (!$response) {
			log::write('DoDirectPayment failed: ' . curl_error($curl) . '(' . curl_errno($curl) . ')');
		}

		$response_info = array();

		parse_str($response, $response_info);

		$json = array();

		if ($response_info['RESULT'] == '0') {
			$message = '';

			if (isset($response_info['AVSCODE'])) {
				$message .= 'AVSCODE: ' . $response_info['AVSCODE'] . "\n";
			}

			if (isset($response_info['CVV2MATCH'])) {
				$message .= 'CVV2MATCH: ' . $response_info['CVV2MATCH'] . "\n";
			}

			if (isset($response_info['TRANSACTIONID'])) {
				$message .= 'TRANSACTIONID: ' . $response_info['TRANSACTIONID'] . "\n";
			}

			checkout_order::addOrderHistory(session::$data['order_id'], config::get('payment_pp_payflow_order_status_id'), $message, false);

			$json['success'] = url::link('checkout/success');
		} else {
			switch ($response_info['RESULT']) {
				case '1':
				case '26':
					$json['error'] = language::get('error_config');
					break;
				case '7':
					$json['error'] = language::get('error_address');
					break;
				case '12':
					$json['error'] = language::get('error_declined');
					break;
				case '23':
				case '24':
					$json['error'] = language::get('error_invalid');
					break;
				default:
					$json['error'] = language::get('error_general');
					break;
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}