<?php
class ControllerExtensionPaymentSagepayServer {
	public static function index() {
		load::language('extension/payment/sagepay_server');
		$data['text_credit_card'] = language::get('text_credit_card');
		$data['text_card_name'] = language::get('text_card_name');
		$data['text_card_type'] = language::get('text_card_type');
		$data['text_card_digits'] = language::get('text_card_digits');
		$data['text_card_expiry'] = language::get('text_card_expiry');
		$data['text_loading'] = language::get('text_loading');
		$data['text_confirm_delete'] = language::get('text_confirm_delete');

		$data['entry_card'] = language::get('entry_card');
		$data['entry_card_existing'] = language::get('entry_card_existing');
		$data['entry_card_new'] = language::get('entry_card_new');
		$data['entry_card_save'] = language::get('entry_card_save');
		$data['entry_cc_choice'] = language::get('entry_cc_choice');

		$data['button_confirm'] = language::get('button_confirm');
		$data['button_delete_card'] = language::get('button_delete_card');

		$data['action'] = url::link('extension/payment/sagepay_server/send', '');

		if (config::get('payment_sagepay_server_card') == '1') {
			$data['sagepay_server_card'] = true;
		} else {
			$data['sagepay_server_card'] = false;
		}

		$data['cards'] = array();

		if (customer::isLogged() && $data['sagepay_server_card']) {

			$data['cards'] = extension_payment_sagepay_server::getCards(customer::getId());
		}

		return load::view('extension/payment/sagepay_server', $data);
	}

	public static function send() {

		$payment_data = array();

		if (config::get('payment_sagepay_server_test') == 'live') {
			$url = 'https://live.sagepay.com/gateway/service/vspserver-register.vsp';

			$payment_data['VPSProtocol'] = '3.00';
		} elseif (config::get('payment_sagepay_server_test') == 'test') {
			$url = 'https://test.sagepay.com/gateway/service/vspserver-register.vsp';

			$payment_data['VPSProtocol'] = '3.00';
		} elseif (config::get('payment_sagepay_server_test') == 'sim') {
			$url = 'https://test.sagepay.com/Simulator/VSPServerGateway.asp?Service=VendorRegisterTx';

			$payment_data['VPSProtocol'] = '2.23';
		}


		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$payment_data['ReferrerID'] = 'E511AF91-E4A0-42DE-80B0-09C981A3FB61';
		$payment_data['Vendor'] = config::get('payment_sagepay_server_vendor');
		$payment_data['VendorTxCode'] = session::$data['order_id'] . 'T' . date("YmdHis") . mt_rand(1, 999);
		$payment_data['Amount'] = currency::format($order_info['total'], $order_info['currency_code'], false, false);
		$payment_data['Currency'] = session::$data['currency'];
		$payment_data['Description'] = substr(config('name'), 0, 100);
		$payment_data['NotificationURL'] = url::link('extension/payment/sagepay_server/callback', '');
		$payment_data['TxType'] = config::get('payment_sagepay_server_transaction');

		$payment_data['BillingSurname'] = substr($order_info['payment_lastname'], 0, 20);
		$payment_data['BillingFirstnames'] = substr($order_info['payment_firstname'], 0, 20);
		$payment_data['BillingAddress1'] = substr($order_info['payment_address_1'], 0, 100);

		if ($order_info['payment_address_2']) {
			$payment_data['BillingAddress2'] = $order_info['payment_address_2'];
		}

		$payment_data['BillingCity'] = substr($order_info['payment_city'], 0, 40);
		$payment_data['BillingPostCode'] = substr($order_info['payment_postcode'], 0, 10);
		$payment_data['BillingCountry'] = $order_info['payment_iso_code_2'];

		if ($order_info['payment_iso_code_2'] == 'US') {
			$payment_data['BillingState'] = $order_info['payment_zone_code'];
		}

		$payment_data['BillingPhone'] = substr($order_info['telephone'], 0, 20);

		if (cart::hasShipping()) {
			$payment_data['DeliverySurname'] = substr($order_info['shipping_lastname'], 0, 20);
			$payment_data['DeliveryFirstnames'] = substr($order_info['shipping_firstname'], 0, 20);
			$payment_data['DeliveryAddress1'] = substr($order_info['shipping_address_1'], 0, 100);

			if ($order_info['shipping_address_2']) {
				$payment_data['DeliveryAddress2'] = $order_info['shipping_address_2'];
			}

			$payment_data['DeliveryCity'] = substr($order_info['shipping_city'], 0, 40);
			$payment_data['DeliveryPostCode'] = substr($order_info['shipping_postcode'], 0, 10);
			$payment_data['DeliveryCountry'] = $order_info['shipping_iso_code_2'];

			if ($order_info['shipping_iso_code_2'] == 'US') {
				$payment_data['DeliveryState'] = $order_info['shipping_zone_code'];
			}

			$payment_data['CustomerName'] = substr($order_info['firstname'] . ' ' . $order_info['lastname'], 0, 100);
			$payment_data['DeliveryPhone'] = substr($order_info['telephone'], 0, 20);
		} else {
			$payment_data['DeliveryFirstnames'] = $order_info['payment_firstname'];
			$payment_data['DeliverySurname'] = $order_info['payment_lastname'];
			$payment_data['DeliveryAddress1'] = $order_info['payment_address_1'];

			if ($order_info['payment_address_2']) {
				$payment_data['DeliveryAddress2'] = $order_info['payment_address_2'];
			}

			$payment_data['DeliveryCity'] = $order_info['payment_city'];
			$payment_data['DeliveryPostCode'] = $order_info['payment_postcode'];
			$payment_data['DeliveryCountry'] = $order_info['payment_iso_code_2'];

			if ($order_info['payment_iso_code_2'] == 'US') {
				$payment_data['DeliveryState'] = $order_info['payment_zone_code'];
			}

			$payment_data['DeliveryPhone'] = $order_info['telephone'];
		}

		$order_products = checkout_order::getOrderProducts(session::$data['order_id']);
		$cart_rows = 0;
		$str_basket = "";
		foreach ($order_products as $product) {
			$str_basket .=
					":" . str_replace(":", " ", $product['name'] . " " . $product['model']) .
					":" . $product['quantity'] .
					":" . currency::format($product['price'], $order_info['currency_code'], false, false) .
					":" . currency::format($product['tax'], $order_info['currency_code'], false, false) .
					":" . currency::format(($product['price'] + $product['tax']), $order_info['currency_code'], false, false) .
					":" . currency::format(($product['price'] + $product['tax']) * $product['quantity'], $order_info['currency_code'], false, false);
			$cart_rows++;
		}

		$order_totals = checkout_order::getOrderTotals(session::$data['order_id']);
		
		foreach ($order_totals as $total) {
			$str_basket .= ":" . str_replace(":", " ", $total['title']) . "::$::$:" . currency::format($total['value'], $order_info['currency_code'], false, false);
			$cart_rows++;
		}
		
		$str_basket = $cart_rows . $str_basket;

		$payment_data['Basket'] = $str_basket;

		$payment_data['CustomerEMail'] = substr($order_info['email'], 0, 255);
		$payment_data['Apply3DSecure'] = '0';

		if (isset(request::$post['CreateToken'])) {
			$payment_data['CreateToken'] = request::$post['CreateToken'];
			$payment_data['StoreToken'] = 1;
		}

		if (isset(request::$post['Token'])) {
			$payment_data['Token'] = request::$post['Token'];
			$payment_data['StoreToken'] = 1;
		}

		$response_data = extension_payment_sagepay_server::sendCurl($url, $payment_data);

		$json = array();

		if ((substr($response_data['Status'], 0, 2) == "OK") || $response_data['Status'] == 'AUTHENTICATED' || $response_data['Status'] == 'REGISTERED') {
			$json['redirect'] = $response_data['NextURL'];
			$json['Status'] = $response_data['Status'];
			$json['StatusDetail'] = $response_data['StatusDetail'];

			$response_data['order_id'] = session::$data['order_id'];
			$response_data['VendorTxCode'] = $payment_data['VendorTxCode'];

			$order_info = array_merge($order_info, $response_data);

			extension_payment_sagepay_server::addOrder($order_info);

			if (config::get('payment_sagepay_server_transaction') == 'PAYMENT') {
				$recurring_products = cart::getRecurringProducts();

				//loop through any products that are recurring items
				foreach ($recurring_products as $item) {
					extension_payment_sagepay_server::addRecurringPayment($item, $payment_data['VendorTxCode']);
				}
			}
		} else {
			$json['error'] = $response_data['StatusDetail'];
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function callback() {

		$success_page = url::link('extension/payment/sagepay_server/success', '');
		$error_page = url::link('extension/payment/sagepay_server/failure', '');
		$end_ln = chr(13) . chr(10);

		if (isset(request::$post['VendorTxCode'])) {
			$vendor_tx_code = request::$post['VendorTxCode'];
			$order_id_parts = explode('T', request::$post['VendorTxCode']);
			$order_id = (int)$order_id_parts[0];
		} else {
			$vendor_tx_code = '';
			$order_id = '';
		}

		if (isset(request::$post['Status'])) {
			$str_status = request::$post['Status'];
		} else {
			$str_status = '';
		}

		if (isset(request::$post['VPSSignature'])) {
			$str_vps_signature = request::$post['VPSSignature'];
		} else {
			$str_vps_signature = '';
		}
		if (isset(request::$post['StatusDetail'])) {
			$str_status_detail = request::$post['StatusDetail'];
		} else {
			$str_status_detail = '';
		}

		if (isset(request::$post['VPSTxId'])) {
			$str_vps_tx_id = request::$post['VPSTxId'];
		} else {
			$str_vps_tx_id = '';
		}

		if (isset(request::$post['TxAuthNo'])) {
			$str_tx_auth_no = request::$post['TxAuthNo'];
		} else {
			$str_tx_auth_no = '';
		}

		if (isset(request::$post['AVSCV2'])) {
			$str_avs_cv2 = request::$post['AVSCV2'];
		} else {
			$str_avs_cv2 = '';
		}

		if (isset(request::$post['AddressResult'])) {
			$str_address_result = request::$post['AddressResult'];
		} else {
			$str_address_result = '';
		}

		if (isset(request::$post['PostCodeResult'])) {
			$str_postcode_result = request::$post['PostCodeResult'];
		} else {
			$str_postcode_result = '';
		}

		if (isset(request::$post['CV2Result'])) {
			$str_cv2_result = request::$post['CV2Result'];
		} else {
			$str_cv2_result = '';
		}

		if (isset(request::$post['GiftAid'])) {
			$str_gift_aid = request::$post['GiftAid'];
		} else {
			$str_gift_aid = '';
		}

		if (isset(request::$post['3DSecureStatus'])) {
			$str_3d_secure_status = request::$post['3DSecureStatus'];
		} else {
			$str_3d_secure_status = '';
		}

		if (isset(request::$post['CAVV'])) {
			$str_cavv = request::$post['CAVV'];
		} else {
			$str_cavv = '';
		}

		if (isset(request::$post['AddressStatus'])) {
			$str_address_status = request::$post['AddressStatus'];
		} else {
			$str_address_status = '';
		}

		if (isset(request::$post['PayerStatus'])) {
			$str_payer_status = request::$post['PayerStatus'];
		} else {
			$str_payer_status = '';
		}

		if (isset(request::$post['CardType'])) {
			$str_card_type = request::$post['CardType'];
		} else {
			$str_card_type = '';
		}

		if (isset(request::$post['Last4Digits'])) {
			$str_last_4_digits = request::$post['Last4Digits'];
		} else {
			$str_last_4_digits = '';
		}

		if (isset(request::$post['ExpiryDate'])) {
			$str_expiry_date = request::$post['ExpiryDate'];
		} else {
			$str_expiry_date = '';
		}

		if (isset(request::$post['Token'])) {
			$str_token = request::$post['Token'];
		} else {
			$str_token = '';
		}

		if (isset(request::$post['DeclineCode'])) {
			$str_decline_code = request::$post['DeclineCode'];
		} else {
			$str_decline_code = '';
		}

		if (isset(request::$post['BankAuthCode'])) {
			$str_bank_auth_code = request::$post['BankAuthCode'];
		} else {
			$str_bank_auth_code = '';
		}

		$order_info = checkout_order::getOrder($order_id);

		$transaction_info = extension_payment_sagepay_server::getOrder($order_id);

		extension_payment_sagepay_server::logger('$order_id', $order_id);
		extension_payment_sagepay_server::logger('$order_info', $order_info);
		extension_payment_sagepay_server::logger('$transaction_info', $transaction_info);
		extension_payment_sagepay_server::logger('$strStatus', $str_status);

		//Check if order we have saved in database maches with callback sagepay does
		if (!isset($transaction_info['order_id']) || $transaction_info['order_id'] != $order_id) {
			echo "Status=INVALID" . $end_ln;
			echo "StatusDetail= Order IDs could not be matched. Order might be tampered with." . $end_ln;
			echo "RedirectURL=" . $error_page . $end_ln;

			extension_payment_sagepay_server::logger('StatusDetail', 'Order IDs could not be matched. Order might be tampered with');

			exit;
		}

		if (isset($transaction_info['SecurityKey'])) {
			$str_security_key = $transaction_info['SecurityKey'];
		} else {
			$str_security_key = '';
		}

		/** Now we rebuilt the POST message, including our security key, and use the MD5 Hash **
		 * * component that is included to create our own signature to compare with **
		 * * the contents of the VPSSignature field in the POST.  Check the Sage Pay Server protocol **
		 * * if you need clarification on this process * */
		$str_message = $str_vps_tx_id . $vendor_tx_code . $str_status . $str_tx_auth_no . config::get('payment_sagepay_server_vendor') . urldecode($str_avs_cv2) . $str_security_key
				. $str_address_result . $str_postcode_result . $str_cv2_result . $str_gift_aid . $str_3d_secure_status . $str_cavv
				. $str_address_status . $str_payer_status . $str_card_type . $str_last_4_digits . $str_decline_code . $str_expiry_date . $str_bank_auth_code;

		$str_my_signature = strtoupper(md5($str_message));

		/** We can now compare our MD5 Hash signature with that from Sage Pay Server * */
		if ($str_my_signature != $str_vps_signature) {
			extension_payment_sagepay_server::deleteOrder($order_id);

			echo "Status=INVALID" . $end_ln;
			echo "StatusDetail= Cannot match the MD5 Hash. Order might be tampered with." . $end_ln;
			echo "RedirectURL=" . $error_page . $end_ln;

			extension_payment_sagepay_server::logger('StatusDetail', 'Cannot match the MD5 Hash. Order might be tampered with');
			exit;
		}

		if (($str_status != "OK" && $str_status != "REGISTERED" && $str_status != "AUTHENTICATED") || !$order_info) {
			extension_payment_sagepay_server::deleteOrder($order_id);

			echo "Status=INVALID" . $end_ln;
			echo "StatusDetail= Either status invalid or order info was not found.";
			echo "RedirectURL=" . $error_page . $end_ln;

			extension_payment_sagepay_server::logger('StatusDetail', 'Either status invalid or order info was not found');
			exit;
		}

		$comment = "Paid with Sagepay Server<br><br>";
		$comment .= "<b>Transaction details</b><br>";
		$comment .= "Status: " . $str_status . "<br>";
		$comment .= "AVS and CV2 checks: " . $str_avs_cv2 . "<br>";
		$comment .= "3D Secure checks: " . $str_3d_secure_status . "<br>";
		$comment .= "Card type: " . $str_card_type . "<br>";

		if ($str_card_type == "PAYPAL") {
			$comment .= "Paypal address status: " . $str_address_status . "<br>";
			$comment .= "Paypal payer status: " . $str_payer_status . "<br>";
		}
		$comment .= "Last 4 digits: " . $str_last_4_digits . "<br>";

		checkout_order::addOrderHistory($order_id, config::get('payment_sagepay_server_order_status_id'), $comment);

		extension_payment_sagepay_server::updateOrder($order_info, $str_vps_tx_id, $str_tx_auth_no);

		extension_payment_sagepay_server::addTransaction($transaction_info['sagepay_server_order_id'], config::get('payment_sagepay_server_transaction'), $order_info);

		if (!empty($str_token)) {
			$data['customer_id'] = $order_info['customer_id'];
			$data['ExpiryDate'] = substr($str_expiry_date, -4, 2) . '/' . substr($str_expiry_date, 2);
			$data['Token'] = $str_token;
			$data['CardType'] = $str_card_type;
			$data['Last4Digits'] = $str_last_4_digits;

			extension_payment_sagepay_server::addCard($data);
		}

		echo "Status=OK" . $end_ln;
		echo "RedirectURL=" . $success_page . $end_ln;
	}

	public static function success() {

		if (isset(session::$data['order_id'])) {
			$order_details = extension_payment_sagepay_server::getOrder(session::$data['order_id']);

			if (config::get('payment_sagepay_server_transaction') == 'PAYMENT') {
				$recurring_products = extension_payment_sagepay_server::getRecurringOrders(session::$data['order_id']);

				//loop through any products that are recurring items
				foreach ($recurring_products as $item) {
					extension_payment_sagepay_server::updateRecurringPayment($item, $order_details);
				}
			}

			response::redirect(url::link('checkout/success', ''));
		} else {
			response::redirect(url::link('account/login', ''));
		}
	}

	public static function failure() {
		load::language('extension/payment/sagepay_server');

		session::$data['error'] = language::get('text_generic_error');

		response::redirect(url::link('checkout/checkout', ''));
	}

	public static function delete() {
		load::language('account/sagepay_server_cards');


		$card = extension_payment_sagepay_server::getCard(false, request::$post['Token']);

		if (!empty($card['token'])) {
			if (config::get('payment_sagepay_server_test') == 'live') {
				$url = 'https://live.sagepay.com/gateway/service/removetoken.vsp';
			} else {
				$url = 'https://test.sagepay.com/gateway/service/removetoken.vsp';
			}
			$payment_data['VPSProtocol'] = '3.00';
			$payment_data['Vendor'] = config::get('payment_sagepay_server_vendor');
			$payment_data['TxType'] = 'REMOVETOKEN';
			$payment_data['Token'] = $card['token'];

			$response_data = extension_payment_sagepay_server::sendCurl($url, $payment_data);
			if ($response_data['Status'] == 'OK') {
				extension_payment_sagepay_server::deleteCard($card['card_id']);
				session::$data['success'] = language::get('text_success_card');
				$json['success'] = true;
			} else {
				$json['error'] = language::get('text_fail_card');
			}
		} else {
			$json['error'] = language::get('text_fail_card');
		}
		response::setOutput(json_encode($json));
	}

	public static function cron() {
		if (isset(request::$get['token']) && hash_equals(config::get('payment_sagepay_server_cron_job_token'), request::$get['token'])) {

			$orders = extension_payment_sagepay_server::cronPayment();

			extension_payment_sagepay_server::updateCronJobRunTime();

			extension_payment_sagepay_server::logger('Repeat Orders', $orders);
		}
	}

}