<?php
class ControllerExtensionPaymentSkrill {
	public static function index() {

		load::language('extension/payment/skrill');

		if(!isset(session::$data['order_id'])) {
			return false;
		}

		$data['button_confirm'] = language::get('button_confirm');

		$data['action'] = 'https://www.moneybookers.com/app/payment.pl?p=OpenCart';

		$data['pay_to_email'] = config::get('payment_skrill_email');
		$data['platform'] = '31974336';
		$data['description'] = config('name');
		$data['transaction_id'] = session::$data['order_id'];
		$data['return_url'] = url::link('checkout/success');
		$data['cancel_url'] = url::link('checkout/checkout', '');
		$data['status_url'] = url::link('extension/payment/skrill/callback');
		$data['language'] = session::$data['language'];
		$data['logo'] = config('url') . 'image/' . config('logo');

		$order_info = checkout_order::getOrder(session::$data['order_id']);

		$data['pay_from_email'] = $order_info['email'];
		$data['firstname'] = $order_info['payment_firstname'];
		$data['lastname'] = $order_info['payment_lastname'];
		$data['address'] = $order_info['payment_address_1'];
		$data['address2'] = $order_info['payment_address_2'];
		$data['phone_number'] = $order_info['telephone'];
		$data['postal_code'] = $order_info['payment_postcode'];
		$data['city'] = $order_info['payment_city'];
		$data['state'] = $order_info['payment_zone'];
		$data['country'] = $order_info['payment_iso_code_3'];
		$data['amount'] = currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$data['currency'] = $order_info['currency_code'];

		$products = '';

		foreach (cart::getProducts() as $product) {
			$products .= $product['quantity'] . ' x ' . $product['name'] . ', ';
		}

		$data['detail1_text'] = $products;

		$data['order_id'] = session::$data['order_id'];

		return load::view('extension/payment/skrill', $data);
	}

	public static function callback() {
		if (isset(request::$post['order_id'])) {
			$order_id = request::$post['order_id'];
		} else {
			$order_id = 0;
		}


		$order_info = checkout_order::getOrder($order_id);

		if ($order_info) {
			checkout_order::addOrderHistory($order_id, config('order_status_id'));

			$verified = true;

			// md5sig validation
			if (config::get('payment_skrill_secret')) {
				$hash  = request::$post['merchant_id'];
				$hash .= request::$post['transaction_id'];
				$hash .= strtoupper(md5(config::get('payment_skrill_secret')));
				$hash .= request::$post['mb_amount'];
				$hash .= request::$post['mb_currency'];
				$hash .= request::$post['status'];

				$md5hash = strtoupper(md5($hash));
				$md5sig = request::$post['md5sig'];

				if (($md5hash != $md5sig) || (strtolower(request::$post['pay_to_email']) != strtolower(config('moneybookers_email'))) || ((float)request::$post['amount'] != currency::format((float)$order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false))) {
					$verified = false;
				}
			}

			if ($verified) {
				switch(request::$post['status']) {
					case '2':
						checkout_order::addOrderHistory($order_id, config::get('payment_skrill_order_status_id'), '', true);
						break;
					case '0':
						checkout_order::addOrderHistory($order_id, config::get('payment_skrill_pending_status_id'), '', true);
						break;
					case '-1':
						checkout_order::addOrderHistory($order_id, config::get('payment_skrill_canceled_status_id'), '', true);
						break;
					case '-2':
						checkout_order::addOrderHistory($order_id, config::get('payment_skrill_failed_status_id'), '', true);
						break;
					case '-3':
						checkout_order::addOrderHistory($order_id, config::get('payment_skrill_chargeback_status_id'), '', true);
						break;
				}
			} else {
				log::write('md5sig returned (' + $md5sig + ') does not match generated (' + $md5hash + '). Verify Manually. Current order state: ' . config('order_status_id'));
			}
		}
	}
}