<?php
class ControllerExtensionTotalCoupon {
	public static function index() {
		if (config::get('total_coupon_status')) {
			load::language('extension/total/coupon');

			if (isset(session::$data['coupon'])) {
				$data['coupon'] = session::$data['coupon'];
			} else {
				$data['coupon'] = '';
			}

			return load::view('extension/total/coupon', $data);
		}
	}

	public static function coupon() {
		load::language('extension/total/coupon');

		$json = array();


		if (isset(request::$post['coupon'])) {
			$coupon = request::$post['coupon'];
		} else {
			$coupon = '';
		}

		$coupon_info = extension_total_coupon::getCoupon($coupon);

		if (empty(request::$post['coupon'])) {
			$json['error'] = language::get('error_empty');

			unset(session::$data['coupon']);
		} elseif ($coupon_info) {
			session::$data['coupon'] = request::$post['coupon'];

			session::$data['success'] = language::get('text_success');

			$json['redirect'] = url::link('checkout/cart');
		} else {
			$json['error'] = language::get('error_coupon');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
