<?php
class ControllerExtensionTotalReward {
	public static function index() {
		$points = customer::getRewardPoints();

		$points_total = 0;

		foreach (cart::getProducts() as $product) {
			if ($product['points']) {
				$points_total += $product['points'];
			}
		}

		if ($points && $points_total && config::get('total_reward_status')) {
			load::language('extension/total/reward');

			$data['heading_title'] = sprintf(language::get('heading_title'), $points);

			$data['entry_reward'] = sprintf(language::get('entry_reward'), $points_total);

			if (isset(session::$data['reward'])) {
				$data['reward'] = session::$data['reward'];
			} else {
				$data['reward'] = '';
			}

			return load::view('extension/total/reward', $data);
		}
	}

	public static function reward() {
		load::language('extension/total/reward');

		$json = array();

		$points = customer::getRewardPoints();

		$points_total = 0;

		foreach (cart::getProducts() as $product) {
			if ($product['points']) {
				$points_total += $product['points'];
			}
		}

		if (!isset(request::$post['reward']) || !filter_var(request::$post['reward'], FILTER_VALIDATE_INT) || (request::$post['reward'] <= 0)) {
			$json['error'] = language::get('error_reward');
		}

		if (request::$post['reward'] > $points) {
			$json['error'] = sprintf(language::get('error_points'), request::$post['reward']);
		}

		if (request::$post['reward'] > $points_total) {
			$json['error'] = sprintf(language::get('error_maximum'), $points_total);
		}

		if (!$json) {
			session::$data['reward'] = abs(request::$post['reward']);

			session::$data['success'] = language::get('text_success');

			if (isset(request::$post['redirect'])) {
				$json['redirect'] = url::link(request::$post['redirect']);
			} else {
				$json['redirect'] = url::link('checkout/cart');
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
