<?php
class ControllerExtensionTotalVoucher {
	public static function index() {
		if (config::get('total_voucher_status')) {
			load::language('extension/total/voucher');

			if (isset(session::$data['voucher'])) {
				$data['voucher'] = session::$data['voucher'];
			} else {
				$data['voucher'] = '';
			}

			return load::view('extension/total/voucher', $data);
		}
	}

	public static function voucher() {
		load::language('extension/total/voucher');

		$json = array();


		if (isset(request::$post['voucher'])) {
			$voucher = request::$post['voucher'];
		} else {
			$voucher = '';
		}

		$voucher_info = extension_total_voucher::getVoucher($voucher);

		if (empty(request::$post['voucher'])) {
			$json['error'] = language::get('error_empty');
		} elseif ($voucher_info) {
			session::$data['voucher'] = request::$post['voucher'];

			session::$data['success'] = language::get('text_success');

			$json['redirect'] = url::link('checkout/cart');
		} else {
			$json['error'] = language::get('error_voucher');
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function send($route, $args, $output) {

		$order_info = checkout_order::getOrder($args[0]);

		// If order status in the complete range create any vouchers that where in the order need to be made available.
		if (in_array($order_info['order_status_id'], config('complete_status'))) {
			$voucher_query = db::query("SELECT *, vtd.name AS theme FROM `voucher` v LEFT JOIN voucher_theme vt ON (v.voucher_theme_id = vt.voucher_theme_id) LEFT JOIN voucher_theme_description vtd ON (vt.voucher_theme_id = vtd.voucher_theme_id) WHERE v.order_id = " . (int)$order_info['order_id'] . " AND vtd.language_id = " . (int)$order_info['language_id']);

			if ($voucher_query->num_rows) {
				// Send out any gift voucher mails
				$language = new Language($order_info['language_code']);
				$language::load($order_info['language_code']);
				$language::load('mail/voucher');

				foreach ($voucher_query->rows as $voucher) {
					// HTML Mail
					$data = array();

					$data['title'] = sprintf($language::get('text_subject'), $voucher['from_name']);

					$data['text_greeting'] = sprintf($language::get('text_greeting'), currency::format($voucher['amount'], $order_info['currency_code'], $order_info['currency_value']));
					$data['text_from'] = sprintf($language::get('text_from'), $voucher['from_name']);
					$data['text_message'] = $language::get('text_message');
					$data['text_redeem'] = sprintf($language::get('text_redeem'), $voucher['code']);
					$data['text_footer'] = $language::get('text_footer');

					if (is_file('image/' . $voucher['image'])) {
						$data['image'] = config('url') . 'image/' . $voucher['image'];
					} else {
						$data['image'] = '';
					}

					$data['store_name'] = $order_info['store_name'];
					$data['store_url'] = $order_info['store_url'];
					$data['message'] = nl2br($voucher['message']);

					$mail = new Mail(config('mail_engine'));
					$mail::$parameter = config('mail_parameter');
					$mail::$smtp_hostname = config('mail_smtp_hostname');
					$mail::$smtp_username = config('mail_smtp_username');
					$mail::$smtp_password = html_entity_decode(config('mail_smtp_password'), ENT_QUOTES, 'UTF-8');
					$mail::$smtp_port = config('mail_smtp_port');
					$mail::$smtp_timeout = config('mail_smtp_timeout');

					$mail::setTo($voucher['to_email']);
					$mail::setFrom(config('email'));
					$mail::setSender(html_entity_decode($order_info['store_name'], ENT_QUOTES, 'UTF-8'));
					$mail::setSubject(html_entity_decode(sprintf($language::get('text_subject'), $voucher['from_name']), ENT_QUOTES, 'UTF-8'));
					$mail::setHtml(load::view('mail/voucher', $data));
					$mail::send();
				}
			}
		}
	}
}
