<?php
class ControllerInformationInformation {
	public static function index() {
		load::language('information/information');


		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		if (isset(request::$get['information_id'])) {
			$information_id = (int)request::$get['information_id'];
		} else {
			$information_id = 0;
		}

		$information_info = catalog_information::getInformation($information_id);

		if ($information_info) {
			document::setTitle($information_info['meta_title']);
			document::setDescription($information_info['meta_description']);
			document::setKeywords($information_info['meta_keyword']);

			$data['breadcrumbs'][] = array(
				'text' => $information_info['title'],
				'href' => url::link('information/information', 'information_id=' .  $information_id)
			);

			$data['heading_title'] = $information_info['title'];

			$data['description'] = html_entity_decode($information_info['description'], ENT_QUOTES, 'UTF-8');

			$data['continue'] = url::link('common/home');

			$data['column_left'] = load::controller('common/column_left');
			$data['column_right'] = load::controller('common/column_right');
			$data['content_top'] = load::controller('common/content_top');
			$data['content_bottom'] = load::controller('common/content_bottom');
			$data['footer'] = load::controller('common/footer');
			$data['header'] = load::controller('common/header');

			response::setOutput(load::view('information/information', $data));
		} else {
			$data['breadcrumbs'][] = array(
				'text' => language::get('text_error'),
				'href' => url::link('information/information', 'information_id=' . $information_id)
			);

			document::setTitle(language::get('text_error'));

			$data['heading_title'] = language::get('text_error');

			$data['text_error'] = language::get('text_error');

			$data['continue'] = url::link('common/home');

			response::addHeader(request::$server['SERVER_PROTOCOL'] . ' 404 Not Found');

			$data['column_left'] = load::controller('common/column_left');
			$data['column_right'] = load::controller('common/column_right');
			$data['content_top'] = load::controller('common/content_top');
			$data['content_bottom'] = load::controller('common/content_bottom');
			$data['footer'] = load::controller('common/footer');
			$data['header'] = load::controller('common/header');

			response::setOutput(load::view('error/not_found', $data));
		}
	}

	public static function agree() {

		if (isset(request::$get['information_id'])) {
			$information_id = (int)request::$get['information_id'];
		} else {
			$information_id = 0;
		}

		$output = '';

		$information_info = catalog_information::getInformation($information_id);

		if ($information_info) {
			$output .= html_entity_decode($information_info['description'], ENT_QUOTES, 'UTF-8') . "\n";
		}

		response::addHeader('X-Robots-Tag: noindex');

		response::setOutput($output);
	}
}
