<?php
class ControllerInformationSitemap {
	public static function index() {
		load::language('information/sitemap');

		document::setTitle(language::get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('information/sitemap')
		);


		$data['categories'] = array();

		$categories_1 = catalog_category::getCategories(0);

		foreach ($categories_1 as $category_1) {
			$level_2_data = array();

			$categories_2 = catalog_category::getCategories($category_1['category_id']);

			foreach ($categories_2 as $category_2) {
				$level_3_data = array();

				$categories_3 = catalog_category::getCategories($category_2['category_id']);

				foreach ($categories_3 as $category_3) {
					$level_3_data[] = array(
						'name' => $category_3['name'],
						'href' => url::link('product/category', 'path=' . $category_1['category_id'] . '_' . $category_2['category_id'] . '_' . $category_3['category_id'])
					);
				}

				$level_2_data[] = array(
					'name'     => $category_2['name'],
					'children' => $level_3_data,
					'href'     => url::link('product/category', 'path=' . $category_1['category_id'] . '_' . $category_2['category_id'])
				);
			}

			$data['categories'][] = array(
				'name'     => $category_1['name'],
				'children' => $level_2_data,
				'href'     => url::link('product/category', 'path=' . $category_1['category_id'])
			);
		}

		$data['special'] = url::link('product/special');
		$data['account'] = url::link('account/account', '');
		$data['edit'] = url::link('account/edit', '');
		$data['password'] = url::link('account/password', '');
		$data['address'] = url::link('account/address', '');
		$data['history'] = url::link('account/order', '');
		$data['download'] = url::link('account/download', '');
		$data['cart'] = url::link('checkout/cart');
		$data['checkout'] = url::link('checkout/checkout', '');
		$data['search'] = url::link('product/search');
		$data['contact'] = url::link('information/contact');


		$data['informations'] = array();

		foreach (catalog_information::getInformations() as $result) {
			$data['informations'][] = array(
				'title' => $result['title'],
				'href'  => url::link('information/information', 'information_id=' . $result['information_id'])
			);
		}

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('information/sitemap', $data));
	}
}