<?php
class ControllerMailTransaction {
	public static function index(&$route, &$args, &$output) {
		load::language('mail/transaction');

		
		$customer_info = account_customer::getCustomer($args[0]);

		if ($customer_info) {
			$data['text_received'] = sprintf(language::get('text_received'), config('name'));
			$data['text_amount'] = language::get('text_amount');
			$data['text_total'] = language::get('text_total');
			
			$data['amount'] = currency::format($args[2], config('currency'));
			$data['total'] = currency::format(account_customer::getTransactionTotal($args[0]), config('currency'));
	
			$mail = new Mail(config('mail_engine'));
			$mail::$parameter = config('mail_parameter');
			$mail::$smtp_hostname = config('mail_smtp_hostname');
			$mail::$smtp_username = config('mail_smtp_username');
			$mail::$smtp_password = html_entity_decode(config('mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail::$smtp_port = config('mail_smtp_port');
			$mail::$smtp_timeout = config('mail_smtp_timeout');
	
			$mail::setTo($customer_info['email']);
			$mail::setFrom(config('email'));
			$mail::setSender(html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8'));
			$mail::setSubject(html_entity_decode(sprintf(language::get('text_subject'), config('name')), ENT_QUOTES, 'UTF-8'));
			$mail::setText(load::view('mail/transaction', $data));
			$mail::send();
		}
	}
}



