<?php
class ControllerProductProduct {
	private static $error = array();

	public static function index() {
		load::language('product/product');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);


		if (isset(request::$get['path'])) {
			$path = '';

			$parts = explode('_', (string)request::$get['path']);

			$category_id = (int)array_pop($parts);

			foreach ($parts as $path_id) {
				if (!$path) {
					$path = $path_id;
				} else {
					$path .= '_' . $path_id;
				}

				$category_info = catalog_category::getCategory($path_id);

				if ($category_info) {
					$data['breadcrumbs'][] = array(
						'text' => $category_info['name'],
						'href' => url::link('product/category', 'path=' . $path)
					);
				}
			}

			// Set the last category breadcrumb
			$category_info = catalog_category::getCategory($category_id);

			if ($category_info) {
				$url = '';

				if (isset(request::$get['sort'])) {
					$url .= '&sort=' . request::$get['sort'];
				}

				if (isset(request::$get['order'])) {
					$url .= '&order=' . request::$get['order'];
				}

				if (isset(request::$get['page'])) {
					$url .= '&page=' . request::$get['page'];
				}

				if (isset(request::$get['limit'])) {
					$url .= '&limit=' . request::$get['limit'];
				}

				$data['breadcrumbs'][] = array(
					'text' => $category_info['name'],
					'href' => url::link('product/category', 'path=' . request::$get['path'] . $url)
				);
			}
		}


		if (isset(request::$get['manufacturer_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => language::get('text_brand'),
				'href' => url::link('product/manufacturer')
			);

			$url = '';

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			if (isset(request::$get['limit'])) {
				$url .= '&limit=' . request::$get['limit'];
			}

			$manufacturer_info = catalog_manufacturer::getManufacturer(request::$get['manufacturer_id']);

			if ($manufacturer_info) {
				$data['breadcrumbs'][] = array(
					'text' => $manufacturer_info['name'],
					'href' => url::link('product/manufacturer/info', 'manufacturer_id=' . request::$get['manufacturer_id'] . $url)
				);
			}
		}

		if (isset(request::$get['search']) || isset(request::$get['tag'])) {
			$url = '';

			if (isset(request::$get['search'])) {
				$url .= '&search=' . request::$get['search'];
			}

			if (isset(request::$get['tag'])) {
				$url .= '&tag=' . request::$get['tag'];
			}

			if (isset(request::$get['description'])) {
				$url .= '&description=' . request::$get['description'];
			}

			if (isset(request::$get['category_id'])) {
				$url .= '&category_id=' . request::$get['category_id'];
			}

			if (isset(request::$get['sub_category'])) {
				$url .= '&sub_category=' . request::$get['sub_category'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			if (isset(request::$get['limit'])) {
				$url .= '&limit=' . request::$get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_search'),
				'href' => url::link('product/search', $url)
			);
		}

		if (isset(request::$get['product_id'])) {
			$product_id = (int)request::$get['product_id'];
		} else {
			$product_id = 0;
		}


		$product_info = catalog_product::getProduct($product_id);

		//check product page open from cateory page
		if (isset(request::$get['path'])) {
			$parts = explode('_', (string)request::$get['path']);
						
			if(empty(catalog_product::checkProductCategory($product_id, $parts))) {
				$product_info = array();
			}
		}

		//check product page open from manufacturer page
		if (isset(request::$get['manufacturer_id']) && !empty($product_info)) {
			if($product_info['manufacturer_id'] !=  request::$get['manufacturer_id']) {
				$product_info = array();
			}
		}

		if ($product_info) {
			$url = '';

			if (isset(request::$get['path'])) {
				$url .= '&path=' . request::$get['path'];
			}

			if (isset(request::$get['filter'])) {
				$url .= '&filter=' . request::$get['filter'];
			}

			if (isset(request::$get['manufacturer_id'])) {
				$url .= '&manufacturer_id=' . request::$get['manufacturer_id'];
			}

			if (isset(request::$get['search'])) {
				$url .= '&search=' . request::$get['search'];
			}

			if (isset(request::$get['tag'])) {
				$url .= '&tag=' . request::$get['tag'];
			}

			if (isset(request::$get['description'])) {
				$url .= '&description=' . request::$get['description'];
			}

			if (isset(request::$get['category_id'])) {
				$url .= '&category_id=' . request::$get['category_id'];
			}

			if (isset(request::$get['sub_category'])) {
				$url .= '&sub_category=' . request::$get['sub_category'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			if (isset(request::$get['limit'])) {
				$url .= '&limit=' . request::$get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => $product_info['name'],
				'href' => url::link('product/product', $url . '&product_id=' . request::$get['product_id'])
			);

			document::setTitle($product_info['meta_title']);
			document::setDescription($product_info['meta_description']);
			document::setKeywords($product_info['meta_keyword']);
			document::addLink(url::link('product/product', 'product_id=' . request::$get['product_id']), 'canonical');
			document::addScript('catalog/view/javascript/jquery/magnific/jquery.magnific-popup.min.js');
			document::addStyle('catalog/view/javascript/jquery/magnific/magnific-popup.css');
			document::addScript('catalog/view/javascript/jquery/datetimepicker/moment/moment.min.js');
			document::addScript('catalog/view/javascript/jquery/datetimepicker/moment/moment-with-locales.min.js');
			document::addScript('catalog/view/javascript/jquery/datetimepicker/bootstrap-datetimepicker.min.js');
			document::addStyle('catalog/view/javascript/jquery/datetimepicker/bootstrap-datetimepicker.min.css');

			$data['heading_title'] = $product_info['name'];

			$data['text_minimum'] = sprintf(language::get('text_minimum'), $product_info['minimum']);
			$data['text_login'] = sprintf(language::get('text_login'), url::link('account/login', ''), url::link('account/register', '', true));


			$data['tab_review'] = sprintf(language::get('tab_review'), $product_info['reviews']);

			$data['product_id'] = (int)request::$get['product_id'];
			$data['manufacturer'] = $product_info['manufacturer'];
			$data['manufacturers'] = url::link('product/manufacturer/info', 'manufacturer_id=' . $product_info['manufacturer_id']);
			$data['model'] = $product_info['model'];
			$data['reward'] = $product_info['reward'];
			$data['points'] = $product_info['points'];
			$data['description'] = html_entity_decode($product_info['description'], ENT_QUOTES, 'UTF-8');

			if ($product_info['quantity'] <= 0) {
				$data['stock'] = $product_info['stock_status'];
			} elseif (config('stock_display')) {
				$data['stock'] = $product_info['quantity'];
			} else {
				$data['stock'] = language::get('text_instock');
			}


			if ($product_info['image']) {
				$data['popup'] = tool_image::resize($product_info['image'], config::get('theme_' . config('theme') . '_image_popup_width'), config::get('theme_' . config('theme') . '_image_popup_height'));
			} else {
				$data['popup'] = '';
			}

			if ($product_info['image']) {
				$data['thumb'] = tool_image::resize($product_info['image'], config::get('theme_' . config('theme') . '_image_thumb_width'), config::get('theme_' . config('theme') . '_image_thumb_height'));
			} else {
				$data['thumb'] = '';
			}

			$data['images'] = array();

			$results = catalog_product::getProductImages(request::$get['product_id']);

			foreach ($results as $result) {
				$data['images'][] = array(
					'popup' => tool_image::resize($result['image'], config::get('theme_' . config('theme') . '_image_popup_width'), config::get('theme_' . config('theme') . '_image_popup_height')),
					'thumb' => tool_image::resize($result['image'], config::get('theme_' . config('theme') . '_image_additional_width'), config::get('theme_' . config('theme') . '_image_additional_height'))
				);
			}

			if (customer::isLogged() || !config('customer_price')) {
				$data['price'] = currency::format(tax::calculate($product_info['price'], $product_info['tax_class_id'], config('tax')), session::$data['currency']);
			} else {
				$data['price'] = false;
			}

			if (!is_null($product_info['special']) && (float)$product_info['special'] >= 0) {
				$data['special'] = currency::format(tax::calculate($product_info['special'], $product_info['tax_class_id'], config('tax')), session::$data['currency']);
				$tax_price = (float)$product_info['special'];
			} else {
				$data['special'] = false;
				$tax_price = (float)$product_info['price'];
			}

			if (config('tax')) {
				$data['tax'] = currency::format($tax_price, session::$data['currency']);
			} else {
				$data['tax'] = false;
			}

			$discounts = catalog_product::getProductDiscounts(request::$get['product_id']);

			$data['discounts'] = array();

			foreach ($discounts as $discount) {
				$data['discounts'][] = array(
					'quantity' => $discount['quantity'],
					'price'    => currency::format(tax::calculate($discount['price'], $product_info['tax_class_id'], config('tax')), session::$data['currency'])
				);
			}

			$data['options'] = array();

			foreach (catalog_product::getProductOptions(request::$get['product_id']) as $option) {
				$product_option_value_data = array();

				foreach ($option['product_option_value'] as $option_value) {
					if (!$option_value['subtract'] || ($option_value['quantity'] > 0)) {
						if (((config('customer_price') && customer::isLogged()) || !config('customer_price')) && (float)$option_value['price']) {
							$price = currency::format(tax::calculate($option_value['price'], $product_info['tax_class_id'], config('tax') ? 'P' : false), session::$data['currency']);
						} else {
							$price = false;
						}

						$product_option_value_data[] = array(
							'product_option_value_id' => $option_value['product_option_value_id'],
							'option_value_id'         => $option_value['option_value_id'],
							'name'                    => $option_value['name'],
							'image'                   => tool_image::resize($option_value['image'], 50, 50),
							'price'                   => $price,
							'price_prefix'            => $option_value['price_prefix']
						);
					}
				}

				$data['options'][] = array(
					'product_option_id'    => $option['product_option_id'],
					'product_option_value' => $product_option_value_data,
					'option_id'            => $option['option_id'],
					'name'                 => $option['name'],
					'type'                 => $option['type'],
					'value'                => $option['value'],
					'required'             => $option['required']
				);
			}

			if ($product_info['minimum']) {
				$data['minimum'] = $product_info['minimum'];
			} else {
				$data['minimum'] = 1;
			}

			$data['review_status'] = config('review_status');

			if (config('review_guest') || customer::isLogged()) {
				$data['review_guest'] = true;
			} else {
				$data['review_guest'] = false;
			}

			if (customer::isLogged()) {
				$data['customer_name'] = customer::getFirstName() . '&nbsp;' . customer::getLastName();
			} else {
				$data['customer_name'] = '';
			}

			$data['reviews'] = sprintf(language::get('text_reviews'), (int)$product_info['reviews']);
			$data['rating'] = (int)$product_info['rating'];

			// Captcha
			if (config::get('captcha_' . config('captcha') . '_status') && in_array('review', (array)config('captcha_page'))) {
				$data['captcha'] = load::controller('extension/captcha/' . config('captcha'));
			} else {
				$data['captcha'] = '';
			}

			$data['share'] = url::link('product/product', 'product_id=' . (int)request::$get['product_id']);

			$data['attribute_groups'] = catalog_product::getProductAttributes(request::$get['product_id']);

			$data['products'] = array();

			$results = catalog_product::getProductRelated(request::$get['product_id']);

			foreach ($results as $result) {
				if ($result['image']) {
					$image = tool_image::resize($result['image'], config::get('theme_' . config('theme') . '_image_related_width'), config::get('theme_' . config('theme') . '_image_related_height'));
				} else {
					$image = tool_image::resize('placeholder.png', config::get('theme_' . config('theme') . '_image_related_width'), config::get('theme_' . config('theme') . '_image_related_height'));
				}

				if (customer::isLogged() || !config('customer_price')) {
					$price = currency::format(tax::calculate($result['price'], $result['tax_class_id'], config('tax')), session::$data['currency']);
				} else {
					$price = false;
				}

				if (!is_null($result['special']) && (float)$result['special'] >= 0) {
					$special = currency::format(tax::calculate($result['special'], $result['tax_class_id'], config('tax')), session::$data['currency']);
					$tax_price = (float)$result['special'];
				} else {
					$special = false;
					$tax_price = (float)$result['price'];
				}
	
				if (config('tax')) {
					$tax = currency::format($tax_price, session::$data['currency']);
				} else {
					$tax = false;
				}

				if (config('review_status')) {
					$rating = (int)$result['rating'];
				} else {
					$rating = false;
				}

				$data['products'][] = array(
					'product_id'  => $result['product_id'],
					'thumb'       => $image,
					'name'        => $result['name'],
					'description' => utf8_substr(trim(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8'))), 0, config::get('theme_' . config('theme') . '_product_description_length')) . '..',
					'price'       => $price,
					'special'     => $special,
					'tax'         => $tax,
					'minimum'     => $result['minimum'] > 0 ? $result['minimum'] : 1,
					'rating'      => $rating,
					'href'        => url::link('product/product', 'product_id=' . $result['product_id'])
				);
			}

			$data['tags'] = array();

			if ($product_info['tag']) {
				$tags = explode(',', $product_info['tag']);

				foreach ($tags as $tag) {
					$data['tags'][] = array(
						'tag'  => trim($tag),
						'href' => url::link('product/search', 'tag=' . trim($tag))
					);
				}
			}

			$data['recurrings'] = catalog_product::getProfiles(request::$get['product_id']);

			catalog_product::updateViewed(request::$get['product_id']);
			
			$data['column_left'] = load::controller('common/column_left');
			$data['column_right'] = load::controller('common/column_right');
			$data['content_top'] = load::controller('common/content_top');
			$data['content_bottom'] = load::controller('common/content_bottom');
			$data['footer'] = load::controller('common/footer');
			$data['header'] = load::controller('common/header');

			response::setOutput(load::view('product/product', $data));
		} else {
			$url = '';

			if (isset(request::$get['path'])) {
				$url .= '&path=' . request::$get['path'];
			}

			if (isset(request::$get['filter'])) {
				$url .= '&filter=' . request::$get['filter'];
			}

			if (isset(request::$get['manufacturer_id'])) {
				$url .= '&manufacturer_id=' . request::$get['manufacturer_id'];
			}

			if (isset(request::$get['search'])) {
				$url .= '&search=' . request::$get['search'];
			}

			if (isset(request::$get['tag'])) {
				$url .= '&tag=' . request::$get['tag'];
			}

			if (isset(request::$get['description'])) {
				$url .= '&description=' . request::$get['description'];
			}

			if (isset(request::$get['category_id'])) {
				$url .= '&category_id=' . request::$get['category_id'];
			}

			if (isset(request::$get['sub_category'])) {
				$url .= '&sub_category=' . request::$get['sub_category'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['page'])) {
				$url .= '&page=' . request::$get['page'];
			}

			if (isset(request::$get['limit'])) {
				$url .= '&limit=' . request::$get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => language::get('text_error'),
				'href' => url::link('product/product', $url . '&product_id=' . $product_id)
			);

			document::setTitle(language::get('text_error'));

			$data['continue'] = url::link('common/home');

			response::addHeader(request::$server['SERVER_PROTOCOL'] . ' 404 Not Found');

			$data['column_left'] = load::controller('common/column_left');
			$data['column_right'] = load::controller('common/column_right');
			$data['content_top'] = load::controller('common/content_top');
			$data['content_bottom'] = load::controller('common/content_bottom');
			$data['footer'] = load::controller('common/footer');
			$data['header'] = load::controller('common/header');

			response::setOutput(load::view('error/not_found', $data));
		}
	}

	public static function review() {
		load::language('product/product');


		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		$data['reviews'] = array();

		$review_total = catalog_review::getTotalReviewsByProductId(request::$get['product_id']);

		$results = catalog_review::getReviewsByProductId(request::$get['product_id'], ($page - 1) * 5, 5);

		foreach ($results as $result) {
			$data['reviews'][] = array(
				'author'     => $result['author'],
				'text'       => nl2br($result['text']),
				'rating'     => (int)$result['rating'],
				'date_added' => date(language::get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$pagination = new Pagination();
		$pagination::$total = $review_total;
		$pagination::$page = $page;
		$pagination::$limit = 5;
		$pagination::$url = url::link('product/product/review', 'product_id=' . request::$get['product_id'] . '&page={page}');

		$data['pagination'] = $pagination::render();

		$data['results'] = sprintf(language::get('text_pagination'), ($review_total) ? (($page - 1) * 5) + 1 : 0, ((($page - 1) * 5) > ($review_total - 5)) ? $review_total : ((($page - 1) * 5) + 5), $review_total, ceil($review_total / 5));

		response::setOutput(load::view('product/review', $data));
	}

	public static function write() {
		load::language('product/product');

		$json = array();

		if (isset(request::$get['product_id']) && request::$get['product_id']) {
			if (request::$server['REQUEST_METHOD'] == 'POST') {
				if ((utf8_strlen(request::$post['name']) < 3) || (utf8_strlen(request::$post['name']) > 25)) {
					$json['error'] = language::get('error_name');
				}

				if ((utf8_strlen(request::$post['text']) < 25) || (utf8_strlen(request::$post['text']) > 1000)) {
					$json['error'] = language::get('error_text');
				}
			
				if (empty(request::$post['rating']) || request::$post['rating'] < 0 || request::$post['rating'] > 5) {
					$json['error'] = language::get('error_rating');
				}

				// Captcha
				if (config::get('captcha_' . config('captcha') . '_status') && in_array('review', (array)config('captcha_page'))) {
					$captcha = load::controller('extension/captcha/' . config('captcha') . '/validate');

					if ($captcha) {
						$json['error'] = $captcha;
					}
				}

				if (!isset($json['error'])) {

					catalog_review::addReview(request::$get['product_id'], request::$post);

					$json['success'] = language::get('text_success');
				}
			}
		} else {
			$json['error'] = language::get('error_product');
		} 

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}

	public static function getRecurringDescription() {
		load::language('product/product');

		if (isset(request::$post['product_id'])) {
			$product_id = request::$post['product_id'];
		} else {
			$product_id = 0;
		}

		if (isset(request::$post['recurring_id'])) {
			$recurring_id = request::$post['recurring_id'];
		} else {
			$recurring_id = 0;
		}

		if (isset(request::$post['quantity'])) {
			$quantity = request::$post['quantity'];
		} else {
			$quantity = 1;
		}

		$product_info = catalog_product::getProduct($product_id);
		
		$recurring_info = catalog_product::getProfile($product_id, $recurring_id);

		$json = array();

		if ($product_info && $recurring_info) {
			if (!$json) {
				$frequencies = array(
					'day'        => language::get('text_day'),
					'week'       => language::get('text_week'),
					'semi_month' => language::get('text_semi_month'),
					'month'      => language::get('text_month'),
					'year'       => language::get('text_year'),
				);

				if ($recurring_info['trial_status'] == 1) {
					$price = currency::format(tax::calculate($recurring_info['trial_price'] * $quantity, $product_info['tax_class_id'], config('tax')), session::$data['currency']);
					$trial_text = sprintf(language::get('text_trial_description'), $price, $recurring_info['trial_cycle'], $frequencies[$recurring_info['trial_frequency']], $recurring_info['trial_duration']) . ' ';
				} else {
					$trial_text = '';
				}

				$price = currency::format(tax::calculate($recurring_info['price'] * $quantity, $product_info['tax_class_id'], config('tax')), session::$data['currency']);

				if ($recurring_info['duration']) {
					$text = $trial_text . sprintf(language::get('text_payment_description'), $price, $recurring_info['cycle'], $frequencies[$recurring_info['frequency']], $recurring_info['duration']);
				} else {
					$text = $trial_text . sprintf(language::get('text_payment_cancel'), $price, $recurring_info['cycle'], $frequencies[$recurring_info['frequency']], $recurring_info['duration']);
				}

				$json['success'] = $text;
			}
		}

		response::addHeader('Content-Type: application/json');
		response::setOutput(json_encode($json));
	}
}
