<?php
class ControllerProductSearch {
	public static function index() {
		load::language('product/search');




		if (isset(request::$get['search'])) {
			$search = request::$get['search'];
		} else {
			$search = '';
		}

		if (isset(request::$get['tag'])) {
			$tag = request::$get['tag'];
		} elseif (isset(request::$get['search'])) {
			$tag = request::$get['search'];
		} else {
			$tag = '';
		}

		if (isset(request::$get['description'])) {
			$description = request::$get['description'];
		} else {
			$description = '';
		}

		if (isset(request::$get['category_id'])) {
			$category_id = request::$get['category_id'];
		} else {
			$category_id = 0;
		}

		if (isset(request::$get['sub_category'])) {
			$sub_category = request::$get['sub_category'];
		} else {
			$sub_category = '';
		}

		if (isset(request::$get['sort'])) {
			$sort = request::$get['sort'];
		} else {
			$sort = 'p.sort_order';
		}

		if (isset(request::$get['order'])) {
			$order = request::$get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset(request::$get['page'])) {
			$page = (int)request::$get['page'];
		} else {
			$page = 1;
		}

		if (isset(request::$get['limit'])) {
			$limit = (int)request::$get['limit'];
		} else {
			$limit = config::get('theme_' . config('theme') . '_product_limit');
		}

		if (isset(request::$get['search'])) {
			document::setTitle(language::get('heading_title') .  ' - ' . request::$get['search']);
		} elseif (isset(request::$get['tag'])) {
			document::setTitle(language::get('heading_title') .  ' - ' . language::get('heading_tag') . request::$get['tag']);
		} else {
			document::setTitle(language::get('heading_title'));
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => language::get('text_home'),
			'href' => url::link('common/home')
		);

		$url = '';

		if (isset(request::$get['search'])) {
			$url .= '&search=' . urlencode(html_entity_decode(request::$get['search'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['tag'])) {
			$url .= '&tag=' . urlencode(html_entity_decode(request::$get['tag'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset(request::$get['description'])) {
			$url .= '&description=' . request::$get['description'];
		}

		if (isset(request::$get['category_id'])) {
			$url .= '&category_id=' . request::$get['category_id'];
		}

		if (isset(request::$get['sub_category'])) {
			$url .= '&sub_category=' . request::$get['sub_category'];
		}

		if (isset(request::$get['sort'])) {
			$url .= '&sort=' . request::$get['sort'];
		}

		if (isset(request::$get['order'])) {
			$url .= '&order=' . request::$get['order'];
		}

		if (isset(request::$get['page'])) {
			$url .= '&page=' . request::$get['page'];
		}

		if (isset(request::$get['limit'])) {
			$url .= '&limit=' . request::$get['limit'];
		}

		$data['breadcrumbs'][] = array(
			'text' => language::get('heading_title'),
			'href' => url::link('product/search', $url)
		);

		if (isset(request::$get['search'])) {
			$data['heading_title'] = language::get('heading_title') .  ' - ' . request::$get['search'];
		} else {
			$data['heading_title'] = language::get('heading_title');
		}

		$data['text_compare'] = sprintf(language::get('text_compare'), (isset(session::$data['compare']) ? count(session::$data['compare']) : 0));

		$data['compare'] = url::link('product/compare');

		// 3 Level Category Search
		$data['categories'] = array();

		$categories_1 = catalog_category::getCategories(0);

		foreach ($categories_1 as $category_1) {
			$level_2_data = array();

			$categories_2 = catalog_category::getCategories($category_1['category_id']);

			foreach ($categories_2 as $category_2) {
				$level_3_data = array();

				$categories_3 = catalog_category::getCategories($category_2['category_id']);

				foreach ($categories_3 as $category_3) {
					$level_3_data[] = array(
						'category_id' => $category_3['category_id'],
						'name'        => $category_3['name'],
					);
				}

				$level_2_data[] = array(
					'category_id' => $category_2['category_id'],
					'name'        => $category_2['name'],
					'children'    => $level_3_data
				);
			}

			$data['categories'][] = array(
				'category_id' => $category_1['category_id'],
				'name'        => $category_1['name'],
				'children'    => $level_2_data
			);
		}

		$data['products'] = array();

		if (isset(request::$get['search']) || isset(request::$get['tag'])) {
			$filter_data = array(
				'filter_name'         => $search,
				'filter_tag'          => $tag,
				'filter_description'  => $description,
				'filter_category_id'  => $category_id,
				'filter_sub_category' => $sub_category,
				'sort'                => $sort,
				'order'               => $order,
				'start'               => ($page - 1) * $limit,
				'limit'               => $limit
			);

			$product_total = catalog_product::getTotalProducts($filter_data);

			$results = catalog_product::getProducts($filter_data);

			foreach ($results as $result) {
				if ($result['image']) {
					$image = tool_image::resize($result['image'], config::get('theme_' . config('theme') . '_image_product_width'), config::get('theme_' . config('theme') . '_image_product_height'));
				} else {
					$image = tool_image::resize('placeholder.png', config::get('theme_' . config('theme') . '_image_product_width'), config::get('theme_' . config('theme') . '_image_product_height'));
				}

				if (customer::isLogged() || !config('customer_price')) {
					$price = currency::format(tax::calculate($result['price'], $result['tax_class_id'], config('tax')), session::$data['currency']);
				} else {
					$price = false;
				}

				if (!is_null($result['special']) && (float)$result['special'] >= 0) {
					$special = currency::format(tax::calculate($result['special'], $result['tax_class_id'], config('tax')), session::$data['currency']);
					$tax_price = (float)$result['special'];
				} else {
					$special = false;
					$tax_price = (float)$result['price'];
				}
	
				if (config('tax')) {
					$tax = currency::format($tax_price, session::$data['currency']);
				} else {
					$tax = false;
				}

				if (config('review_status')) {
					$rating = (int)$result['rating'];
				} else {
					$rating = false;
				}

				$data['products'][] = array(
					'product_id'  => $result['product_id'],
					'thumb'       => $image,
					'name'        => $result['name'],
					'description' => utf8_substr(trim(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8'))), 0, config::get('theme_' . config('theme') . '_product_description_length')) . '..',
					'price'       => $price,
					'special'     => $special,
					'tax'         => $tax,
					'minimum'     => $result['minimum'] > 0 ? $result['minimum'] : 1,
					'rating'      => $result['rating'],
					'href'        => url::link('product/product', 'product_id=' . $result['product_id'] . $url)
				);
			}

			$url = '';

			if (isset(request::$get['search'])) {
				$url .= '&search=' . urlencode(html_entity_decode(request::$get['search'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['tag'])) {
				$url .= '&tag=' . urlencode(html_entity_decode(request::$get['tag'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['description'])) {
				$url .= '&description=' . request::$get['description'];
			}

			if (isset(request::$get['category_id'])) {
				$url .= '&category_id=' . request::$get['category_id'];
			}

			if (isset(request::$get['sub_category'])) {
				$url .= '&sub_category=' . request::$get['sub_category'];
			}

			if (isset(request::$get['limit'])) {
				$url .= '&limit=' . request::$get['limit'];
			}

			$data['sorts'] = array();

			$data['sorts'][] = array(
				'text'  => language::get('text_default'),
				'value' => 'p.sort_order-ASC',
				'href'  => url::link('product/search', 'sort=p.sort_order&order=ASC' . $url)
			);

			$data['sorts'][] = array(
				'text'  => language::get('text_name_asc'),
				'value' => 'pd.name-ASC',
				'href'  => url::link('product/search', 'sort=pd.name&order=ASC' . $url)
			);

			$data['sorts'][] = array(
				'text'  => language::get('text_name_desc'),
				'value' => 'pd.name-DESC',
				'href'  => url::link('product/search', 'sort=pd.name&order=DESC' . $url)
			);

			$data['sorts'][] = array(
				'text'  => language::get('text_price_asc'),
				'value' => 'p.price-ASC',
				'href'  => url::link('product/search', 'sort=p.price&order=ASC' . $url)
			);

			$data['sorts'][] = array(
				'text'  => language::get('text_price_desc'),
				'value' => 'p.price-DESC',
				'href'  => url::link('product/search', 'sort=p.price&order=DESC' . $url)
			);

			if (config('review_status')) {
				$data['sorts'][] = array(
					'text'  => language::get('text_rating_desc'),
					'value' => 'rating-DESC',
					'href'  => url::link('product/search', 'sort=rating&order=DESC' . $url)
				);

				$data['sorts'][] = array(
					'text'  => language::get('text_rating_asc'),
					'value' => 'rating-ASC',
					'href'  => url::link('product/search', 'sort=rating&order=ASC' . $url)
				);
			}

			$data['sorts'][] = array(
				'text'  => language::get('text_model_asc'),
				'value' => 'p.model-ASC',
				'href'  => url::link('product/search', 'sort=p.model&order=ASC' . $url)
			);

			$data['sorts'][] = array(
				'text'  => language::get('text_model_desc'),
				'value' => 'p.model-DESC',
				'href'  => url::link('product/search', 'sort=p.model&order=DESC' . $url)
			);

			$url = '';

			if (isset(request::$get['search'])) {
				$url .= '&search=' . urlencode(html_entity_decode(request::$get['search'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['tag'])) {
				$url .= '&tag=' . urlencode(html_entity_decode(request::$get['tag'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['description'])) {
				$url .= '&description=' . request::$get['description'];
			}

			if (isset(request::$get['category_id'])) {
				$url .= '&category_id=' . request::$get['category_id'];
			}

			if (isset(request::$get['sub_category'])) {
				$url .= '&sub_category=' . request::$get['sub_category'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			$data['limits'] = array();

			$limits = array_unique(array(config::get('theme_' . config('theme') . '_product_limit'), 25, 50, 75, 100));

			sort($limits);

			foreach($limits as $value) {
				$data['limits'][] = array(
					'text'  => $value,
					'value' => $value,
					'href'  => url::link('product/search', $url . '&limit=' . $value)
				);
			}

			$url = '';

			if (isset(request::$get['search'])) {
				$url .= '&search=' . urlencode(html_entity_decode(request::$get['search'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['tag'])) {
				$url .= '&tag=' . urlencode(html_entity_decode(request::$get['tag'], ENT_QUOTES, 'UTF-8'));
			}

			if (isset(request::$get['description'])) {
				$url .= '&description=' . request::$get['description'];
			}

			if (isset(request::$get['category_id'])) {
				$url .= '&category_id=' . request::$get['category_id'];
			}

			if (isset(request::$get['sub_category'])) {
				$url .= '&sub_category=' . request::$get['sub_category'];
			}

			if (isset(request::$get['sort'])) {
				$url .= '&sort=' . request::$get['sort'];
			}

			if (isset(request::$get['order'])) {
				$url .= '&order=' . request::$get['order'];
			}

			if (isset(request::$get['limit'])) {
				$url .= '&limit=' . request::$get['limit'];
			}

			$pagination = new Pagination();
			$pagination::$total = $product_total;
			$pagination::$page = $page;
			$pagination::$limit = $limit;
			$pagination::$url = url::link('product/search', $url . '&page={page}');

			$data['pagination'] = $pagination::render();

			$data['results'] = sprintf(language::get('text_pagination'), ($product_total) ? (($page - 1) * $limit) + 1 : 0, ((($page - 1) * $limit) > ($product_total - $limit)) ? $product_total : ((($page - 1) * $limit) + $limit), $product_total, ceil($product_total / $limit));

			if (isset(request::$get['search']) && config('customer_search')) {

				if (customer::isLogged()) {
					$customer_id = customer::getId();
				} else {
					$customer_id = 0;
				}

				if (isset(request::$server['REMOTE_ADDR'])) {
					$ip = request::$server['REMOTE_ADDR'];
				} else {
					$ip = '';
				}

				$search_data = array(
					'keyword'       => $search,
					'category_id'   => $category_id,
					'sub_category'  => $sub_category,
					'description'   => $description,
					'products'      => $product_total,
					'customer_id'   => $customer_id,
					'ip'            => $ip
				);

				account_search::addSearch($search_data);
			}
		}

		$data['search'] = $search;
		$data['description'] = $description;
		$data['category_id'] = $category_id;
		$data['sub_category'] = $sub_category;

		$data['sort'] = $sort;
		$data['order'] = $order;
		$data['limit'] = $limit;

		$data['column_left'] = load::controller('common/column_left');
		$data['column_right'] = load::controller('common/column_right');
		$data['content_top'] = load::controller('common/content_top');
		$data['content_bottom'] = load::controller('common/content_bottom');
		$data['footer'] = load::controller('common/footer');
		$data['header'] = load::controller('common/header');

		response::setOutput(load::view('product/search', $data));
	}
}
