<?php
class ControllerStartupSeoUrl {
	public static function index() {
		// Add rewrite to url class
		if (config('seo_url')) {
			url::addRewrite($this);
		}

		// Decode URL
		if (isset(request::$get['_route_'])) {
			$parts = explode('/', request::$get['_route_']);

			// remove any empty arrays from trailing
			if (utf8_strlen(end($parts)) == 0) {
				array_pop($parts);
			}

			foreach ($parts as $part) {
				$query = db::query("SELECT * FROM seo_url WHERE keyword = " . esc($part) . " AND store_id = " . config('store_id'));

				if ($query->num_rows) {
					$url = explode('=', $query->row['query']);

					if ($url[0] == 'product_id') {
						request::$get['product_id'] = $url[1];
					}

					if ($url[0] == 'category_id') {
						if (!isset(request::$get['path'])) {
							request::$get['path'] = $url[1];
						} else {
							request::$get['path'] .= '_' . $url[1];
						}
					}

					if ($url[0] == 'manufacturer_id') {
						request::$get['manufacturer_id'] = $url[1];
					}

					if ($url[0] == 'information_id') {
						request::$get['information_id'] = $url[1];
					}

					if ($query->row['query'] && $url[0] != 'information_id' && $url[0] != 'manufacturer_id' && $url[0] != 'category_id' && $url[0] != 'product_id') {
						request::$get['route'] = $query->row['query'];
					}
				} else {
					request::$get['route'] = 'error/not_found';

					break;
				}
			}

			if (!isset(request::$get['route'])) {
				if (isset(request::$get['product_id'])) {
					request::$get['route'] = 'product/product';
				} elseif (isset(request::$get['path'])) {
					request::$get['route'] = 'product/category';
				} elseif (isset(request::$get['manufacturer_id'])) {
					request::$get['route'] = 'product/manufacturer/info';
				} elseif (isset(request::$get['information_id'])) {
					request::$get['route'] = 'information/information';
				}
			}
		}
	}

	public static function rewrite($link) {
		$url_info = parse_url(str_replace('&amp;', '&', $link));

		$url = '';

		$data = array();

		parse_str($url_info['query'], $data);

		foreach ($data as $key => $value) {
			if (isset($data['route'])) {
				if (($data['route'] == 'product/product' && $key == 'product_id') || (($data['route'] == 'product/manufacturer/info' || $data['route'] == 'product/product') && $key == 'manufacturer_id') || ($data['route'] == 'information/information' && $key == 'information_id')) {
					$query = db::query("SELECT * FROM seo_url WHERE `query` = " . esc($key . '=' . (int)$value) . " AND store_id = " . config('store_id') . " AND language_id = " . config('language_id'));

					if ($query->num_rows && $query->row['keyword']) {
						$url .= '/' . $query->row['keyword'];

						unset($data[$key]);
					}
				} elseif ($key == 'path') {
					$categories = explode('_', $value);

					foreach ($categories as $category) {
						$query = db::query("SELECT * FROM seo_url WHERE `query` = 'category_id=" . (int)$category . "' AND store_id = " . config('store_id') . " AND language_id = " . config('language_id'));

						if ($query->num_rows && $query->row['keyword']) {
							$url .= '/' . $query->row['keyword'];
						} else {
							$url = '';

							break;
						}
					}

					unset($data[$key]);
				}
			}
		}

		if ($url) {
			unset($data['route']);

			$query = '';

			if ($data) {
				foreach ($data as $key => $value) {
					$query .= '&' . rawurlencode((string)$key) . '=' . rawurlencode((is_array($value) ? http_build_query($value) : (string)$value));
				}

				if ($query) {
					$query = '?' . str_replace('&', '&amp;', trim($query, '&'));
				}
			}

			return $url_info['scheme'] . '://' . $url_info['host'] . (isset($url_info['port']) ? ':' . $url_info['port'] : '') . str_replace('/index.php', '', $url_info['path']) . $url . $query;
		} else {
			return $link;
		}
	}
}
