<?php
class ControllerStartupStartup {

	public static function index() {
		// Store
		if (request::$server['HTTPS']) {
			$query = db::query("SELECT * FROM store WHERE REPLACE(`ssl`, 'www.', '') = " . esc('https://' . str_replace('www.', '', $_SERVER['HTTP_HOST']) . rtrim(dirname($_SERVER['PHP_SELF']), '/.\\') . '/'));
		} else {
			$query = db::query("SELECT * FROM store WHERE REPLACE(`url`, 'www.', '') = " . esc('http://' . str_replace('www.', '', $_SERVER['HTTP_HOST']) . rtrim(dirname($_SERVER['PHP_SELF']), '/.\\') . '/'));
		}
		
		if (isset(request::$get['store_id'])) {
			config::set('config_store_id', (int)request::$get['store_id']);
		} else if ($query->num_rows) {
			config::set('config_store_id', $query->row['store_id']);
		} else {
			config::set('config_store_id', 0);
		}
		
		if (!$query->num_rows) {
			config::set('config_url', HTTP_SERVER);
			config::set('config_ssl', HTTPS_SERVER);
		}
		
		// Settings
		$query = db::query("SELECT * FROM `setting` WHERE store_id = '0' OR store_id = " . config('store_id') . " ORDER BY store_id ASC");
		
		foreach ($query->rows as $result) {
			if (!$result['serialized']) {
				config::set($result['key'], $result['value']);
			} else {
				config::set($result['key'], json_decode($result['value'], true));
			}
		}

		// Set time zone
		if (config('timezone')) {
			date_default_timezone_set(config('timezone'));

			// Sync PHP and DB time zones.
			db::query("SET time_zone = " . esc(date('P')));
		}

		// Theme
		config::set('template_cache', config::get('developer_theme'));
		
		// Url
		
		// Language
		$code = '';
		
		
		$languages = localisation_language::getLanguages();
		
		if (isset(session::$data['language'])) {
			$code = session::$data['language'];
		}
				
		if (isset(request::$cookie['language']) && !array_key_exists($code, $languages)) {
			$code = request::$cookie['language'];
		}
		
		// Language Detection
		if (!empty(request::$server['HTTP_ACCEPT_LANGUAGE']) && !array_key_exists($code, $languages)) {
			$detect = '';
			
			$browser_languages = explode(',', request::$server['HTTP_ACCEPT_LANGUAGE']);
			
			// Try using local to detect the language
			foreach ($browser_languages as $browser_language) {
				foreach ($languages as $key => $value) {
					if ($value['status']) {
						$locale = explode(',', $value['locale']);
						
						if (in_array($browser_language, $locale)) {
							$detect = $key;
							break 2;
						}
					}
				}	
			}			
			
			if (!$detect) { 
				// Try using language folder to detect the language
				foreach ($browser_languages as $browser_language) {
					if (array_key_exists(strtolower($browser_language), $languages)) {
						$detect = strtolower($browser_language);
						
						break;
					}
				}
			}
			
			$code = $detect ? $detect : '';
		}
		
		if (!array_key_exists($code, $languages)) {
			$code = config('language');
		}
		
		if (!isset(session::$data['language']) || session::$data['language'] != $code) {
			session::$data['language'] = $code;
		}
				
		if (!isset(request::$cookie['language']) || request::$cookie['language'] != $code) {
			setcookie('language', $code, time() + 60 * 60 * 24 * 30, '/', request::$server['HTTP_HOST']);
		}
				
		// Overwrite the default language object
		language::load($code);
		
		
		// Set the config language_id
		config::set('config_language_id', $languages[$code]['language_id']);	

		// Customer
		$customer = new Customer();
		
		// Customer Group
		if (isset(session::$data['customer']) && isset(session::$data['customer']['customer_group_id'])) {
			// For API calls
			config::set('config_customer_group_id', session::$data['customer']['customer_group_id']);
		} elseif (customer::isLogged()) {
			// Logged in customers
			config::set('config_customer_group_id', customer::getGroupId());
		} elseif (isset(session::$data['guest']) && isset(session::$data['guest']['customer_group_id'])) {
			config::set('config_customer_group_id', session::$data['guest']['customer_group_id']);
		} else {
			config::set('config_customer_group_id', config('customer_group_id'));
		}
		
		// Tracking Code
		if (isset(request::$get['tracking'])) {
			setcookie('tracking', request::$get['tracking'], time() + 3600 * 24 * 1000, '/');
		
			db::query("UPDATE `marketing` SET clicks = (clicks + 1) WHERE code = " . esc(request::$get['tracking']));
		}		
		
		// Currency
		$code = '';
		
		
		$currencies = localisation_currency::getCurrencies();
		
		if (isset(session::$data['currency'])) {
			$code = session::$data['currency'];
		}
		
		if (isset(request::$cookie['currency']) && !array_key_exists($code, $currencies)) {
			$code = request::$cookie['currency'];
		}
		
		if (!array_key_exists($code, $currencies)) {
			$code = config('currency');
		}
		
		if (!isset(session::$data['currency']) || session::$data['currency'] != $code) {
			session::$data['currency'] = $code;
		}
		
		if (!isset(request::$cookie['currency']) || request::$cookie['currency'] != $code) {
			setcookie('currency', $code, time() + 60 * 60 * 24 * 30, '/', request::$server['HTTP_HOST']);
		}		
		
		
		// Tax
		
		// PHP v7.4+ validation compatibility.
		if (isset(session::$data['shipping_address']['country_id']) && isset(session::$data['shipping_address']['zone_id'])) {
			tax::setShippingAddress(session::$data['shipping_address']['country_id'], session::$data['shipping_address']['zone_id']);
		} elseif (config('tax_default') == 'shipping') {
			tax::setShippingAddress(config('country_id'), config('zone_id'));
		}

		if (isset(session::$data['payment_address']['country_id']) && isset(session::$data['payment_address']['zone_id'])) {
			tax::setPaymentAddress(session::$data['payment_address']['country_id'], session::$data['payment_address']['zone_id']);
		} elseif (config('tax_default') == 'payment') {
			tax::setPaymentAddress(config('country_id'), config('zone_id'));
		}

		tax::setStoreAddress(config('country_id'), config('zone_id'));
		
		// Weight
		
		// Length
		
		// Cart
		
		// Encryption
	}
}
