<?php
class account_address {
	public static function addAddress($customer_id, $data) {
		db::query("INSERT INTO address SET customer_id = " . (int)$customer_id . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", company = " . esc($data['company']) . ", address_1 = " . esc($data['address_1']) . ", address_2 = " . esc($data['address_2']) . ", postcode = " . esc($data['postcode']) . ", city = " . esc($data['city']) . ", zone_id = " . (int)$data['zone_id'] . ", country_id = " . (int)$data['country_id'] . ", custom_field = " . esc(isset($data['custom_field']['address']) ? json_encode($data['custom_field']['address']) : ''));

		$address_id = db::getLastId();

		if (!empty($data['default'])) {
			db::query("UPDATE customer SET address_id = " . (int)$address_id . " WHERE customer_id = " . (int)$customer_id);
		}

		return $address_id;
	}

	public static function editAddress($address_id, $data) {
		db::query("UPDATE address SET firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", company = " . esc($data['company']) . ", address_1 = " . esc($data['address_1']) . ", address_2 = " . esc($data['address_2']) . ", postcode = " . esc($data['postcode']) . ", city = " . esc($data['city']) . ", zone_id = " . (int)$data['zone_id'] . ", country_id = " . (int)$data['country_id'] . ", custom_field = " . esc(isset($data['custom_field']['address']) ? json_encode($data['custom_field']['address']) : '') . " WHERE address_id  = " . (int)$address_id . " AND customer_id = " . (int)customer::getId());

		if (!empty($data['default'])) {
			db::query("UPDATE customer SET address_id = " . (int)$address_id . " WHERE customer_id = " . (int)customer::getId());
		}
	}

	public static function deleteAddress($address_id) {
		db::query("DELETE FROM address WHERE address_id = " . (int)$address_id . " AND customer_id = " . (int)customer::getId());
		$default_query = db::query("SELECT address_id FROM customer WHERE address_id = " . (int)$address_id . " AND customer_id = " . (int)customer::getId());
		if ($default_query->num_rows) {
			db::query("UPDATE customer SET address_id = 0 WHERE customer_id = " . (int)customer::getId());
		}
	}

	public static function getAddress($address_id) {
		$address_query = db::query("SELECT DISTINCT * FROM address WHERE address_id = " . (int)$address_id . " AND customer_id = " . (int)customer::getId());

		if ($address_query->num_rows) {
			$country_query = db::query("SELECT * FROM `country` WHERE country_id = " . (int)$address_query->row['country_id']);

			if ($country_query->num_rows) {
				$country = $country_query->row['name'];
				$iso_code_2 = $country_query->row['iso_code_2'];
				$iso_code_3 = $country_query->row['iso_code_3'];
				$address_format = $country_query->row['address_format'];
			} else {
				$country = '';
				$iso_code_2 = '';
				$iso_code_3 = '';
				$address_format = '';
			}

			$zone_query = db::query("SELECT * FROM `zone` WHERE zone_id = " . (int)$address_query->row['zone_id']);

			if ($zone_query->num_rows) {
				$zone = $zone_query->row['name'];
				$zone_code = $zone_query->row['code'];
			} else {
				$zone = '';
				$zone_code = '';
			}

			$address_data = array(
				'address_id'     => $address_query->row['address_id'],
				'firstname'      => $address_query->row['firstname'],
				'lastname'       => $address_query->row['lastname'],
				'company'        => $address_query->row['company'],
				'address_1'      => $address_query->row['address_1'],
				'address_2'      => $address_query->row['address_2'],
				'postcode'       => $address_query->row['postcode'],
				'city'           => $address_query->row['city'],
				'zone_id'        => $address_query->row['zone_id'],
				'zone'           => $zone,
				'zone_code'      => $zone_code,
				'country_id'     => $address_query->row['country_id'],
				'country'        => $country,
				'iso_code_2'     => $iso_code_2,
				'iso_code_3'     => $iso_code_3,
				'address_format' => $address_format,
				'custom_field'   => json_decode($address_query->row['custom_field'], true)
			);

			return $address_data;
		} else {
			return false;
		}
	}

	public static function getAddresses() {
		$address_data = array();

		$query = db::query("SELECT * FROM address WHERE customer_id = " . (int)customer::getId());

		foreach ($query->rows as $result) {
			$country_query = db::query("SELECT * FROM `country` WHERE country_id = " . (int)$result['country_id']);

			if ($country_query->num_rows) {
				$country = $country_query->row['name'];
				$iso_code_2 = $country_query->row['iso_code_2'];
				$iso_code_3 = $country_query->row['iso_code_3'];
				$address_format = $country_query->row['address_format'];
			} else {
				$country = '';
				$iso_code_2 = '';
				$iso_code_3 = '';
				$address_format = '';
			}

			$zone_query = db::query("SELECT * FROM `zone` WHERE zone_id = " . (int)$result['zone_id']);

			if ($zone_query->num_rows) {
				$zone = $zone_query->row['name'];
				$zone_code = $zone_query->row['code'];
			} else {
				$zone = '';
				$zone_code = '';
			}

			$address_data[$result['address_id']] = array(
				'address_id'     => $result['address_id'],
				'firstname'      => $result['firstname'],
				'lastname'       => $result['lastname'],
				'company'        => $result['company'],
				'address_1'      => $result['address_1'],
				'address_2'      => $result['address_2'],
				'postcode'       => $result['postcode'],
				'city'           => $result['city'],
				'zone_id'        => $result['zone_id'],
				'zone'           => $zone,
				'zone_code'      => $zone_code,
				'country_id'     => $result['country_id'],
				'country'        => $country,
				'iso_code_2'     => $iso_code_2,
				'iso_code_3'     => $iso_code_3,
				'address_format' => $address_format,
				'custom_field'   => json_decode($result['custom_field'], true)

			);
		}

		return $address_data;
	}

	public static function getTotalAddresses() {
		$query = db::query("SELECT COUNT(*) AS total FROM address WHERE customer_id = " . (int)customer::getId());

		return $query->row['total'];
	}
}
