<?php
class account_customer {
	public static function addCustomer($data) {
		if (isset($data['customer_group_id']) && is_array(config('customer_group_display')) && in_array($data['customer_group_id'], config('customer_group_display'))) {
			$customer_group_id = $data['customer_group_id'];
		} else {
			$customer_group_id = config('customer_group_id');
		}


		$customer_group_info = account_customer_group::getCustomerGroup($customer_group_id);

		db::query("INSERT INTO customer SET customer_group_id = " . (int)$customer_group_id . ", store_id = " . config('store_id') . ", language_id = " . config('language_id') . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", custom_field = " . esc(isset($data['custom_field']['account']) ? json_encode($data['custom_field']['account']) : '') . ", salt = " . esc($salt = token(9)) . ", password = " . esc(sha1($salt . sha1($salt . sha1($data['password'])))) . ", newsletter = '" . (isset($data['newsletter']) ? (int)$data['newsletter'] : 0) . "', ip = " . esc(request::$server['REMOTE_ADDR']) . ", status = " . (int)!$customer_group_info['approval'] . ", date_added = NOW()");

		$customer_id = db::getLastId();

		if ($customer_group_info['approval']) {
			db::query("INSERT INTO `customer_approval` SET customer_id = " . (int)$customer_id . ", type = 'customer', date_added = NOW()");
		}
		
		return $customer_id;
	}

	public static function editCustomer($customer_id, $data) {
		db::query("UPDATE customer SET firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", custom_field = " . esc(isset($data['custom_field']['account']) ? json_encode($data['custom_field']['account']) : '') . " WHERE customer_id = " . (int)$customer_id);
	}

	public static function editPassword($email, $password) {
		db::query("UPDATE customer SET salt = " . esc($salt = token(9)) . ", password = " . esc(sha1($salt . sha1($salt . sha1($password)))) . ", code = '' WHERE LOWER(email) = " . esc(utf8_strtolower($email)));
	}

	public static function editAddressId($customer_id, $address_id) {
		db::query("UPDATE customer SET address_id = " . (int)$address_id . " WHERE customer_id = " . (int)$customer_id);
	}
	
	public static function editCode($email, $code) {
		db::query("UPDATE `customer` SET code = " . esc($code) . " WHERE LCASE(email) = " . esc(utf8_strtolower($email)));
	}

	public static function editNewsletter($newsletter) {
		db::query("UPDATE customer SET newsletter = " . (int)$newsletter . " WHERE customer_id = " . (int)customer::getId());
	}

	public static function getCustomer($customer_id) {
		$query = db::query("SELECT * FROM customer WHERE customer_id = " . (int)$customer_id);

		return $query->row;
	}

	public static function getCustomerByEmail($email) {
		$query = db::query("SELECT * FROM customer WHERE LOWER(email) = " . esc(utf8_strtolower($email)));

		return $query->row;
	}

	public static function getCustomerByCode($code) {
		$query = db::query("SELECT customer_id, firstname, lastname, email FROM `customer` WHERE code = " . esc($code) . " AND code != ''");

		return $query->row;
	}

	public static function getCustomerByToken($token) {
		$query = db::query("SELECT * FROM customer WHERE token = " . esc($token) . " AND token != ''");

		db::query("UPDATE customer SET token = ''");

		return $query->row;
	}
	
	public static function getTotalCustomersByEmail($email) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer WHERE LOWER(email) = " . esc(utf8_strtolower($email)));

		return $query->row['total'];
	}

	public static function addTransaction($customer_id, $description, $amount = '', $order_id = 0) {
		db::query("INSERT INTO customer_transaction SET customer_id = " . (int)$customer_id . ", order_id = '" . (float)$order_id . "', description = " . esc($description) . ", amount = '" . (float)$amount . "', date_added = NOW()");
	}

	public static function deleteTransactionByOrderId($order_id) {
		db::query("DELETE FROM customer_transaction WHERE order_id = " . (int)$order_id);
	}

	public static function getTransactionTotal($customer_id) {
		$query = db::query("SELECT SUM(amount) AS total FROM customer_transaction WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}
	
	public static function getTotalTransactionsByOrderId($order_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM customer_transaction WHERE order_id = " . (int)$order_id);

		return $query->row['total'];
	}
	
	public static function getRewardTotal($customer_id) {
		$query = db::query("SELECT SUM(points) AS total FROM customer_reward WHERE customer_id = " . (int)$customer_id);

		return $query->row['total'];
	}

	public static function getIps($customer_id) {
		$query = db::query("SELECT * FROM `customer_ip` WHERE customer_id = " . (int)$customer_id);

		return $query->rows;
	}

	public static function addLoginAttempt($email) {
		$query = db::query("SELECT * FROM customer_login WHERE email = " . esc(utf8_strtolower((string)$email)));

		if (!$query->num_rows) {
			db::query("INSERT INTO customer_login SET email = " . esc(utf8_strtolower((string)$email)) . ", ip = '" . db::escape(request::$server['REMOTE_ADDR']) . "', total = 1, date_added = " . esc(date('Y-m-d H:i:s')) . ", date_modified = " . esc(date('Y-m-d H:i:s')));
		} else {
			db::query("UPDATE customer_login SET total = (total + 1), date_modified = " . esc(date('Y-m-d H:i:s')) . " WHERE customer_login_id = " . (int)$query->row['customer_login_id']);
		}
	}

	public static function getLoginAttempts($email) {
		$query = db::query("SELECT * FROM `customer_login` WHERE email = " . esc(utf8_strtolower($email)));

		return $query->row;
	}

	public static function deleteLoginAttempts($email) {
		db::query("DELETE FROM `customer_login` WHERE email = " . esc(utf8_strtolower($email)));
	}
	
	public static function addAffiliate($customer_id, $data) {
		db::query("INSERT INTO customer_affiliate SET `customer_id` = " . (int)$customer_id . ", `company` = " . esc($data['company']) . ", `website` = " . esc($data['website']) . ", `tracking` = " . esc(token(64)) . ", `commission` = '" . (float)config('affiliate_commission') . "', `tax` = " . esc($data['tax']) . ", `payment` = " . esc($data['payment']) . ", `cheque` = " . esc($data['cheque']) . ", `paypal` = " . esc($data['paypal']) . ", `bank_name` = " . esc($data['bank_name']) . ", `bank_branch_number` = " . esc($data['bank_branch_number']) . ", `bank_swift_code` = " . esc($data['bank_swift_code']) . ", `bank_account_name` = " . esc($data['bank_account_name']) . ", `bank_account_number` = " . esc($data['bank_account_number']) . ", custom_field = " . esc(isset($data['custom_field']['affiliate']) ? json_encode($data['custom_field']['affiliate']) : json_encode(array())) . ", `status` = " . (int)!config('affiliate_approval'));
		
		if (config('affiliate_approval')) {
			db::query("INSERT INTO `customer_approval` SET customer_id = " . (int)$customer_id . ", type = 'affiliate', date_added = NOW()");
		}		
	}
		
	public static function editAffiliate($customer_id, $data) {
		db::query("UPDATE customer_affiliate SET `company` = " . esc($data['company']) . ", `website` = " . esc($data['website']) . ", `commission` = '" . (float)config('affiliate_commission') . "', `tax` = " . esc($data['tax']) . ", `payment` = " . esc($data['payment']) . ", `cheque` = " . esc($data['cheque']) . ", `paypal` = " . esc($data['paypal']) . ", `bank_name` = " . esc($data['bank_name']) . ", `bank_branch_number` = " . esc($data['bank_branch_number']) . ", `bank_swift_code` = " . esc($data['bank_swift_code']) . ", `bank_account_name` = " . esc($data['bank_account_name']) . ", `bank_account_number` = " . esc($data['bank_account_number']) . ", custom_field = " . esc(isset($data['custom_field']['affiliate']) ? json_encode($data['custom_field']['affiliate']) : json_encode(array())) . " WHERE `customer_id` = " . (int)$customer_id);
	}
	
	public static function getAffiliate($customer_id) {
		$query = db::query("SELECT * FROM `customer_affiliate` WHERE `customer_id` = " . (int)$customer_id);

		return $query->row;
	}
	
	public static function getAffiliateByTracking($tracking) {
		$query = db::query("SELECT * FROM `customer_affiliate` WHERE `tracking` = " . esc($tracking));

		return $query->row;
	}			
}
