<?php
class catalog_product {
	public static function updateViewed($product_id) {
		db::query("UPDATE product SET viewed = (viewed + 1) WHERE product_id = " . (int)$product_id);
	}

	public static function getProduct($product_id) {
		$query = db::query("SELECT DISTINCT *, pd.name AS name, p.image, m.name AS manufacturer, (SELECT price FROM product_discount pd2 WHERE pd2.product_id = p.product_id AND pd2.customer_group_id = " . config('customer_group_id') . " AND pd2.quantity = '1' AND ((pd2.date_start = '0000-00-00' OR pd2.date_start < NOW()) AND (pd2.date_end = '0000-00-00' OR pd2.date_end > NOW())) ORDER BY pd2.priority ASC, pd2.price ASC LIMIT 1) AS discount, (SELECT price FROM product_special ps WHERE ps.product_id = p.product_id AND ps.customer_group_id = " . config('customer_group_id') . " AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW())) ORDER BY ps.priority ASC, ps.price ASC LIMIT 1) AS special, (SELECT points FROM product_reward pr WHERE pr.product_id = p.product_id AND pr.customer_group_id = " . config('customer_group_id') . ") AS reward, (SELECT ss.name FROM stock_status ss WHERE ss.stock_status_id = p.stock_status_id AND ss.language_id = " . config('language_id') . ") AS stock_status, (SELECT wcd.unit FROM weight_class_description wcd WHERE p.weight_class_id = wcd.weight_class_id AND wcd.language_id = " . config('language_id') . ") AS weight_class, (SELECT lcd.unit FROM length_class_description lcd WHERE p.length_class_id = lcd.length_class_id AND lcd.language_id = " . config('language_id') . ") AS length_class, (SELECT AVG(rating) AS total FROM review r1 WHERE r1.product_id = p.product_id AND r1.status = '1' GROUP BY r1.product_id) AS rating, (SELECT COUNT(*) AS total FROM review r2 WHERE r2.product_id = p.product_id AND r2.status = '1' GROUP BY r2.product_id) AS reviews, p.sort_order FROM product p LEFT JOIN product_description pd ON (p.product_id = pd.product_id) LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) LEFT JOIN manufacturer m ON (p.manufacturer_id = m.manufacturer_id) WHERE p.product_id = " . (int)$product_id . " AND pd.language_id = " . config('language_id') . " AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id'));

		if ($query->num_rows) {
			return array(
				'product_id'       => $query->row['product_id'],
				'name'             => $query->row['name'],
				'description'      => $query->row['description'],
				'meta_title'       => $query->row['meta_title'],
				'meta_description' => $query->row['meta_description'],
				'meta_keyword'     => $query->row['meta_keyword'],
				'tag'              => $query->row['tag'],
				'model'            => $query->row['model'],
				'sku'              => $query->row['sku'],
				'upc'              => $query->row['upc'],
				'ean'              => $query->row['ean'],
				'jan'              => $query->row['jan'],
				'isbn'             => $query->row['isbn'],
				'mpn'              => $query->row['mpn'],
				'location'         => $query->row['location'],
				'quantity'         => $query->row['quantity'],
				'stock_status'     => $query->row['stock_status'],
				'image'            => $query->row['image'],
				'manufacturer_id'  => $query->row['manufacturer_id'],
				'manufacturer'     => $query->row['manufacturer'],
				'price'            => ($query->row['discount'] ? $query->row['discount'] : $query->row['price']),
				'special'          => $query->row['special'],
				'reward'           => $query->row['reward'],
				'points'           => $query->row['points'],
				'tax_class_id'     => $query->row['tax_class_id'],
				'date_available'   => $query->row['date_available'],
				'weight'           => $query->row['weight'],
				'weight_class_id'  => $query->row['weight_class_id'],
				'length'           => $query->row['length'],
				'width'            => $query->row['width'],
				'height'           => $query->row['height'],
				'length_class_id'  => $query->row['length_class_id'],
				'subtract'         => $query->row['subtract'],
				'rating'           => round(($query->row['rating']===null) ? 0 : $query->row['rating']),
				'reviews'          => $query->row['reviews'] ? $query->row['reviews'] : 0,
				'minimum'          => $query->row['minimum'],
				'sort_order'       => $query->row['sort_order'],
				'status'           => $query->row['status'],
				'date_added'       => $query->row['date_added'],
				'date_modified'    => $query->row['date_modified'],
				'viewed'           => $query->row['viewed']
			);
		} else {
			return false;
		}
	}

	public static function getProducts($data = array()) {
		$sql = "SELECT p.product_id, (SELECT AVG(rating) AS total FROM review r1 WHERE r1.product_id = p.product_id AND r1.status = '1' GROUP BY r1.product_id) AS rating, (SELECT price FROM product_discount pd2 WHERE pd2.product_id = p.product_id AND pd2.customer_group_id = " . config('customer_group_id') . " AND pd2.quantity = '1' AND ((pd2.date_start = '0000-00-00' OR pd2.date_start < NOW()) AND (pd2.date_end = '0000-00-00' OR pd2.date_end > NOW())) ORDER BY pd2.priority ASC, pd2.price ASC LIMIT 1) AS discount, (SELECT price FROM product_special ps WHERE ps.product_id = p.product_id AND ps.customer_group_id = " . config('customer_group_id') . " AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW())) ORDER BY ps.priority ASC, ps.price ASC LIMIT 1) AS special";

		if (!empty($data['filter_category_id'])) {
			if (!empty($data['filter_sub_category'])) {
				$sql .= " FROM category_path cp LEFT JOIN product_to_category p2c ON (cp.category_id = p2c.category_id)";
			} else {
				$sql .= " FROM product_to_category p2c";
			}

			if (!empty($data['filter_filter'])) {
				$sql .= " LEFT JOIN product_filter pf ON (p2c.product_id = pf.product_id) LEFT JOIN product p ON (pf.product_id = p.product_id)";
			} else {
				$sql .= " LEFT JOIN product p ON (p2c.product_id = p.product_id)";
			}
		} else {
			$sql .= " FROM product p";
		}

		$sql .= " LEFT JOIN product_description pd ON (p.product_id = pd.product_id) LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) WHERE pd.language_id = " . config('language_id') . " AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id');

		if (!empty($data['filter_category_id'])) {
			if (!empty($data['filter_sub_category'])) {
				$sql .= " AND cp.path_id = " . (int)$data['filter_category_id'];
			} else {
				$sql .= " AND p2c.category_id = " . (int)$data['filter_category_id'];
			}

			if (!empty($data['filter_filter'])) {
				$implode = array();

				$filters = explode(',', $data['filter_filter']);

				foreach ($filters as $filter_id) {
					$implode[] = (int)$filter_id;
				}

				$sql .= " AND pf.filter_id IN (" . implode(',', $implode) . ")";
			}
		}

		if (!empty($data['filter_name']) || !empty($data['filter_tag'])) {
			$sql .= " AND (";

			if (!empty($data['filter_name'])) {
				$implode = array();

				$words = explode(' ', trim(preg_replace('/\s+/', ' ', $data['filter_name'])));

				foreach ($words as $word) {
					$implode[] = "pd.name LIKE '%" . db::escape($word) . "%'";
				}

				if ($implode) {
					$sql .= " " . implode(" AND ", $implode);
				}

				if (!empty($data['filter_description'])) {
					$sql .= " OR pd.description LIKE '%" . db::escape($data['filter_name']) . "%'";
				}
			}

			if (!empty($data['filter_name']) && !empty($data['filter_tag'])) {
				$sql .= " OR ";
			}

			if (!empty($data['filter_tag'])) {
				$implode = array();

				$words = explode(' ', trim(preg_replace('/\s+/', ' ', $data['filter_tag'])));

				foreach ($words as $word) {
					$implode[] = "pd.tag LIKE '%" . db::escape($word) . "%'";
				}

				if ($implode) {
					$sql .= " " . implode(" AND ", $implode);
				}
			}

			if (!empty($data['filter_name'])) {
				$sql .= " OR LCASE(p.model) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.sku) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.upc) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.ean) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.jan) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.isbn) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.mpn) = " . esc(utf8_strtolower($data['filter_name']));
			}

			$sql .= ")";
		}

		if (!empty($data['filter_manufacturer_id'])) {
			$sql .= " AND p.manufacturer_id = " . (int)$data['filter_manufacturer_id'];
		}

		$sql .= " GROUP BY p.product_id";

		$sort_data = array(
			'pd.name',
			'p.model',
			'p.quantity',
			'p.price',
			'rating',
			'p.sort_order',
			'p.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			if ($data['sort'] == 'pd.name' || $data['sort'] == 'p.model') {
				$sql .= " ORDER BY LCASE(" . $data['sort'] . ")";
			} elseif ($data['sort'] == 'p.price') {
				$sql .= " ORDER BY (CASE WHEN special IS NOT NULL THEN special WHEN discount IS NOT NULL THEN discount ELSE p.price END)";
			} else {
				$sql .= " ORDER BY " . $data['sort'];
			}
		} else {
			$sql .= " ORDER BY p.sort_order";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC, LCASE(pd.name) DESC";
		} else {
			$sql .= " ASC, LCASE(pd.name) ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$product_data = array();

		$query = db::query($sql);

		foreach ($query->rows as $result) {
			$product_data[$result['product_id']] = self::getProduct($result['product_id']);
		}

		return $product_data;
	}

	public static function getProductSpecials($data = array()) {
		$sql = "SELECT DISTINCT ps.product_id, (SELECT AVG(rating) FROM review r1 WHERE r1.product_id = ps.product_id AND r1.status = '1' GROUP BY r1.product_id) AS rating FROM product_special ps LEFT JOIN product p ON (ps.product_id = p.product_id) LEFT JOIN product_description pd ON (p.product_id = pd.product_id) LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) WHERE p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id') . " AND ps.customer_group_id = " . config('customer_group_id') . " AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW())) GROUP BY ps.product_id";

		$sort_data = array(
			'pd.name',
			'p.model',
			'ps.price',
			'rating',
			'p.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			if ($data['sort'] == 'pd.name' || $data['sort'] == 'p.model') {
				$sql .= " ORDER BY LCASE(" . $data['sort'] . ")";
			} else {
				$sql .= " ORDER BY " . $data['sort'];
			}
		} else {
			$sql .= " ORDER BY p.sort_order";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC, LCASE(pd.name) DESC";
		} else {
			$sql .= " ASC, LCASE(pd.name) ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$product_data = array();

		$query = db::query($sql);

		foreach ($query->rows as $result) {
			$product_data[$result['product_id']] = self::getProduct($result['product_id']);
		}

		return $product_data;
	}

	public static function getLatestProducts($limit) {
		$product_data = cache::get('product.latest.' . config('language_id') . '.' . config('store_id') . '.' . config('customer_group_id') . '.' . (int)$limit);

		if (!$product_data) {
			$product_data = array();
			$query = db::query("SELECT p.product_id FROM product p LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) WHERE p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id') . " ORDER BY p.date_added DESC LIMIT " . (int)$limit);

			foreach ($query->rows as $result) {
				$product_data[$result['product_id']] = self::getProduct($result['product_id']);
			}

			cache::set('product.latest.' . config('language_id') . '.' . config('store_id') . '.' . config('customer_group_id') . '.' . (int)$limit, $product_data);
		}

		return $product_data;
	}

	public static function getPopularProducts($limit) {
		$product_data = cache::get('product.popular.' . config('language_id') . '.' . config('store_id') . '.' . config('customer_group_id') . '.' . (int)$limit);
	
		if (!$product_data) {
			$product_data = array();
			$query = db::query("SELECT p.product_id FROM product p LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) WHERE p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id') . " ORDER BY p.viewed DESC, p.date_added DESC LIMIT " . (int)$limit);
	
			foreach ($query->rows as $result) {
				$product_data[$result['product_id']] = self::getProduct($result['product_id']);
			}
			
			cache::set('product.popular.' . config('language_id') . '.' . config('store_id') . '.' . config('customer_group_id') . '.' . (int)$limit, $product_data);
		}
		
		return $product_data;
	}

	public static function getBestSellerProducts($limit) {
		$product_data = cache::get('product.bestseller.' . config('language_id') . '.' . config('store_id') . '.' . config('customer_group_id') . '.' . (int)$limit);

		if (!$product_data) {
			$product_data = array();

			$query = db::query("SELECT op.product_id, SUM(op.quantity) AS total FROM order_product op LEFT JOIN `order` o ON (op.order_id = o.order_id) LEFT JOIN `product` p ON (op.product_id = p.product_id) LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) WHERE o.order_status_id > '0' AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id') . " GROUP BY op.product_id ORDER BY total DESC LIMIT " . (int)$limit);

			foreach ($query->rows as $result) {
				$product_data[$result['product_id']] = self::getProduct($result['product_id']);
			}

			cache::set('product.bestseller.' . config('language_id') . '.' . config('store_id') . '.' . config('customer_group_id') . '.' . (int)$limit, $product_data);
		}

		return $product_data;
	}

	public static function getProductAttributes($product_id) {
		$product_attribute_group_data = array();

		$product_attribute_group_query = db::query("SELECT ag.attribute_group_id, agd.name FROM product_attribute pa LEFT JOIN attribute a ON (pa.attribute_id = a.attribute_id) LEFT JOIN attribute_group ag ON (a.attribute_group_id = ag.attribute_group_id) LEFT JOIN attribute_group_description agd ON (ag.attribute_group_id = agd.attribute_group_id) WHERE pa.product_id = " . (int)$product_id . " AND agd.language_id = " . config('language_id') . " GROUP BY ag.attribute_group_id ORDER BY ag.sort_order, agd.name");

		foreach ($product_attribute_group_query->rows as $product_attribute_group) {
			$product_attribute_data = array();

			$product_attribute_query = db::query("SELECT a.attribute_id, ad.name, pa.text FROM product_attribute pa LEFT JOIN attribute a ON (pa.attribute_id = a.attribute_id) LEFT JOIN attribute_description ad ON (a.attribute_id = ad.attribute_id) WHERE pa.product_id = " . (int)$product_id . " AND a.attribute_group_id = " . (int)$product_attribute_group['attribute_group_id'] . " AND ad.language_id = " . config('language_id') . " AND pa.language_id = " . config('language_id') . " ORDER BY a.sort_order, ad.name");

			foreach ($product_attribute_query->rows as $product_attribute) {
				$product_attribute_data[] = array(
					'attribute_id' => $product_attribute['attribute_id'],
					'name'         => $product_attribute['name'],
					'text'         => $product_attribute['text']
				);
			}

			$product_attribute_group_data[] = array(
				'attribute_group_id' => $product_attribute_group['attribute_group_id'],
				'name'               => $product_attribute_group['name'],
				'attribute'          => $product_attribute_data
			);
		}

		return $product_attribute_group_data;
	}

	public static function getProductOptions($product_id) {
		$product_option_data = array();

		$product_option_query = db::query("SELECT * FROM product_option po LEFT JOIN `option` o ON (po.option_id = o.option_id) LEFT JOIN option_description od ON (o.option_id = od.option_id) WHERE po.product_id = " . (int)$product_id . " AND od.language_id = " . config('language_id') . " ORDER BY o.sort_order");

		foreach ($product_option_query->rows as $product_option) {
			$product_option_value_data = array();

			$product_option_value_query = db::query("SELECT * FROM product_option_value pov LEFT JOIN option_value ov ON (pov.option_value_id = ov.option_value_id) LEFT JOIN option_value_description ovd ON (ov.option_value_id = ovd.option_value_id) WHERE pov.product_id = " . (int)$product_id . " AND pov.product_option_id = " . (int)$product_option['product_option_id'] . " AND ovd.language_id = " . config('language_id') . " ORDER BY ov.sort_order");

			foreach ($product_option_value_query->rows as $product_option_value) {
				$product_option_value_data[] = array(
					'product_option_value_id' => $product_option_value['product_option_value_id'],
					'option_value_id'         => $product_option_value['option_value_id'],
					'name'                    => $product_option_value['name'],
					'image'                   => $product_option_value['image'],
					'quantity'                => $product_option_value['quantity'],
					'subtract'                => $product_option_value['subtract'],
					'price'                   => $product_option_value['price'],
					'price_prefix'            => $product_option_value['price_prefix'],
					'weight'                  => $product_option_value['weight'],
					'weight_prefix'           => $product_option_value['weight_prefix']
				);
			}

			$product_option_data[] = array(
				'product_option_id'    => $product_option['product_option_id'],
				'product_option_value' => $product_option_value_data,
				'option_id'            => $product_option['option_id'],
				'name'                 => $product_option['name'],
				'type'                 => $product_option['type'],
				'value'                => $product_option['value'],
				'required'             => $product_option['required']
			);
		}

		return $product_option_data;
	}

	public static function getProductDiscounts($product_id) {
		$query = db::query("SELECT * FROM product_discount WHERE product_id = " . (int)$product_id . " AND customer_group_id = " . config('customer_group_id') . " AND quantity > 1 AND ((date_start = '0000-00-00' OR date_start < NOW()) AND (date_end = '0000-00-00' OR date_end > NOW())) ORDER BY quantity ASC, priority ASC, price ASC");

		return $query->rows;
	}

	public static function getProductImages($product_id) {
		$query = db::query("SELECT * FROM product_image WHERE product_id = " . (int)$product_id . " ORDER BY sort_order ASC");

		return $query->rows;
	}

	public static function getProductRelated($product_id) {
		$product_data = array();

		$query = db::query("SELECT * FROM product_related pr LEFT JOIN product p ON (pr.related_id = p.product_id) LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) WHERE pr.product_id = " . (int)$product_id . " AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id'));

		foreach ($query->rows as $result) {
			$product_data[$result['related_id']] = self::getProduct($result['related_id']);
		}

		return $product_data;
	}

	public static function getProductLayoutId($product_id) {
		$query = db::query("SELECT * FROM product_to_layout WHERE product_id = " . (int)$product_id . " AND store_id = " . config('store_id'));

		if ($query->num_rows) {
			return (int)$query->row['layout_id'];
		} else {
			return 0;
		}
	}

	public static function getCategories($product_id) {
		$query = db::query("SELECT * FROM product_to_category WHERE product_id = " . (int)$product_id);

		return $query->rows;
	}

	public static function getTotalProducts($data = array()) {
		$sql = "SELECT COUNT(DISTINCT p.product_id) AS total";

		if (!empty($data['filter_category_id'])) {
			if (!empty($data['filter_sub_category'])) {
				$sql .= " FROM category_path cp LEFT JOIN product_to_category p2c ON (cp.category_id = p2c.category_id)";
			} else {
				$sql .= " FROM product_to_category p2c";
			}

			if (!empty($data['filter_filter'])) {
				$sql .= " LEFT JOIN product_filter pf ON (p2c.product_id = pf.product_id) LEFT JOIN product p ON (pf.product_id = p.product_id)";
			} else {
				$sql .= " LEFT JOIN product p ON (p2c.product_id = p.product_id)";
			}
		} else {
			$sql .= " FROM product p";
		}

		$sql .= " LEFT JOIN product_description pd ON (p.product_id = pd.product_id) LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) WHERE pd.language_id = " . config('language_id') . " AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id');

		if (!empty($data['filter_category_id'])) {
			if (!empty($data['filter_sub_category'])) {
				$sql .= " AND cp.path_id = " . (int)$data['filter_category_id'];
			} else {
				$sql .= " AND p2c.category_id = " . (int)$data['filter_category_id'];
			}

			if (!empty($data['filter_filter'])) {
				$implode = array();

				$filters = explode(',', $data['filter_filter']);

				foreach ($filters as $filter_id) {
					$implode[] = (int)$filter_id;
				}

				$sql .= " AND pf.filter_id IN (" . implode(',', $implode) . ")";
			}
		}

		if (!empty($data['filter_name']) || !empty($data['filter_tag'])) {
			$sql .= " AND (";

			if (!empty($data['filter_name'])) {
				$implode = array();

				$words = explode(' ', trim(preg_replace('/\s+/', ' ', $data['filter_name'])));

				foreach ($words as $word) {
					$implode[] = "pd.name LIKE '%" . db::escape($word) . "%'";
				}

				if ($implode) {
					$sql .= " " . implode(" AND ", $implode);
				}

				if (!empty($data['filter_description'])) {
					$sql .= " OR pd.description LIKE '%" . db::escape($data['filter_name']) . "%'";
				}
			}

			if (!empty($data['filter_name']) && !empty($data['filter_tag'])) {
				$sql .= " OR ";
			}

			if (!empty($data['filter_tag'])) {
				$implode = array();

				$words = explode(' ', trim(preg_replace('/\s+/', ' ', $data['filter_tag'])));

				foreach ($words as $word) {
					$implode[] = "pd.tag LIKE '%" . db::escape($word) . "%'";
				}

				if ($implode) {
					$sql .= " " . implode(" AND ", $implode);
				}
			}

			if (!empty($data['filter_name'])) {
				$sql .= " OR LCASE(p.model) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.sku) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.upc) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.ean) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.jan) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.isbn) = " . esc(utf8_strtolower($data['filter_name']));
				$sql .= " OR LCASE(p.mpn) = " . esc(utf8_strtolower($data['filter_name']));
			}

			$sql .= ")";
		}

		if (!empty($data['filter_manufacturer_id'])) {
			$sql .= " AND p.manufacturer_id = " . (int)$data['filter_manufacturer_id'];
		}

		$query = db::query($sql);

		return $query->row['total'];
	}

	public static function getProfile($product_id, $recurring_id) {
		$query = db::query("SELECT * FROM recurring r JOIN product_recurring pr ON (pr.recurring_id = r.recurring_id AND pr.product_id = " . (int)$product_id . ") WHERE pr.recurring_id = " . (int)$recurring_id . " AND status = '1' AND pr.customer_group_id = " . config('customer_group_id'));

		return $query->row;
	}

	public static function getProfiles($product_id) {
		$query = db::query("SELECT rd.* FROM product_recurring pr JOIN recurring_description rd ON (rd.language_id = " . config('language_id') . " AND rd.recurring_id = pr.recurring_id) JOIN recurring r ON r.recurring_id = rd.recurring_id WHERE pr.product_id = " . (int)$product_id . " AND status = '1' AND pr.customer_group_id = " . config('customer_group_id') . " ORDER BY sort_order ASC");

		return $query->rows;
	}

	public static function getTotalProductSpecials() {
		$query = db::query("SELECT COUNT(DISTINCT ps.product_id) AS total FROM product_special ps LEFT JOIN product p ON (ps.product_id = p.product_id) LEFT JOIN product_to_store p2s ON (p.product_id = p2s.product_id) WHERE p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = " . config('store_id') . " AND ps.customer_group_id = " . config('customer_group_id') . " AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW()))");

		if (isset($query->row['total'])) {
			return $query->row['total'];
		} else {
			return 0;
		}
	}

	public static function checkProductCategory($product_id, $category_ids) {
		
		$implode = array();

		foreach ($category_ids as $category_id) {
			$implode[] = (int)$category_id;
		}
		
		$query = db::query("SELECT * FROM product_to_category WHERE product_id = " . (int)$product_id . " AND category_id IN(" . implode(',', $implode) . ")");
  	    return $query->row;
	}
}
