<?php
class catalog_review {
	public static function addReview($product_id, $data) {
		db::query("INSERT INTO review SET author = " . esc($data['name']) . ", customer_id = " . (int)customer::getId() . ", product_id = " . (int)$product_id . ", text = " . esc($data['text']) . ", rating = " . (int)$data['rating'] . ", date_added = NOW()");

		$review_id = db::getLastId();

		if (in_array('review', (array)config('mail_alert'))) {
			load::language('mail/review');
			
			$product_info = catalog_product::getProduct($product_id);

			$subject = sprintf(language::get('text_subject'), html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8'));

			$message  = language::get('text_waiting') . "\n";
			$message .= sprintf(language::get('text_product'), html_entity_decode($product_info['name'], ENT_QUOTES, 'UTF-8')) . "\n";
			$message .= sprintf(language::get('text_reviewer'), html_entity_decode($data['name'], ENT_QUOTES, 'UTF-8')) . "\n";
			$message .= sprintf(language::get('text_rating'), $data['rating']) . "\n";
			$message .= language::get('text_review') . "\n";
			$message .= html_entity_decode($data['text'], ENT_QUOTES, 'UTF-8') . "\n\n";

			$mail = new Mail(config('mail_engine'));
			$mail::$parameter = config('mail_parameter');
			$mail::$smtp_hostname = config('mail_smtp_hostname');
			$mail::$smtp_username = config('mail_smtp_username');
			$mail::$smtp_password = html_entity_decode(config('mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail::$smtp_port = config('mail_smtp_port');
			$mail::$smtp_timeout = config('mail_smtp_timeout');

			$mail::setTo(config('email'));
			$mail::setFrom(config('email'));
			$mail::setSender(html_entity_decode(config('name'), ENT_QUOTES, 'UTF-8'));
			$mail::setSubject($subject);
			$mail::setText($message);
			$mail::send();

			// Send to additional alert emails
			$emails = explode(',', config('mail_alert_email'));

			foreach ($emails as $email) {
				if ($email && filter_var($email, FILTER_VALIDATE_EMAIL)) {
					$mail::setTo($email);
					$mail::send();
				}
			}
		}
	}

	public static function getReviewsByProductId($product_id, $start = 0, $limit = 20) {
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 20;
		}

		$query = db::query("SELECT r.review_id, r.author, r.rating, r.text, p.product_id, pd.name, p.price, p.image, r.date_added FROM review r LEFT JOIN product p ON (r.product_id = p.product_id) LEFT JOIN product_description pd ON (p.product_id = pd.product_id) WHERE p.product_id = " . (int)$product_id . " AND p.date_available <= NOW() AND p.status = '1' AND r.status = '1' AND pd.language_id = " . config('language_id') . " ORDER BY r.date_added DESC LIMIT " . (int)$start . "," . (int)$limit);

		return $query->rows;
	}

	public static function getTotalReviewsByProductId($product_id) {
		$query = db::query("SELECT COUNT(*) AS total FROM review r LEFT JOIN product p ON (r.product_id = p.product_id) LEFT JOIN product_description pd ON (p.product_id = pd.product_id) WHERE p.product_id = " . (int)$product_id . " AND p.date_available <= NOW() AND p.status = '1' AND r.status = '1' AND pd.language_id = " . config('language_id'));

		return $query->row['total'];
	}
}