<?php
class checkout_order {
	public static function addOrder($data) {
		db::query("INSERT INTO `order` SET invoice_prefix = " . esc($data['invoice_prefix']) . ", store_id = " . (int)$data['store_id'] . ", store_name = " . esc($data['store_name']) . ", store_url = " . esc($data['store_url']) . ", customer_id = " . (int)$data['customer_id'] . ", customer_group_id = " . (int)$data['customer_group_id'] . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", custom_field = " . esc(isset($data['custom_field']) ? json_encode($data['custom_field']) : '') . ", payment_firstname = " . esc($data['payment_firstname']) . ", payment_lastname = " . esc($data['payment_lastname']) . ", payment_company = " . esc($data['payment_company']) . ", payment_address_1 = " . esc($data['payment_address_1']) . ", payment_address_2 = " . esc($data['payment_address_2']) . ", payment_city = " . esc($data['payment_city']) . ", payment_postcode = " . esc($data['payment_postcode']) . ", payment_country = " . esc($data['payment_country']) . ", payment_country_id = " . (int)$data['payment_country_id'] . ", payment_zone = " . esc($data['payment_zone']) . ", payment_zone_id = " . (int)$data['payment_zone_id'] . ", payment_address_format = " . esc($data['payment_address_format']) . ", payment_custom_field = " . esc(isset($data['payment_custom_field']) ? json_encode($data['payment_custom_field']) : '') . ", payment_method = " . esc($data['payment_method']) . ", payment_code = " . esc($data['payment_code']) . ", shipping_firstname = " . esc($data['shipping_firstname']) . ", shipping_lastname = " . esc($data['shipping_lastname']) . ", shipping_company = " . esc($data['shipping_company']) . ", shipping_address_1 = " . esc($data['shipping_address_1']) . ", shipping_address_2 = " . esc($data['shipping_address_2']) . ", shipping_city = " . esc($data['shipping_city']) . ", shipping_postcode = " . esc($data['shipping_postcode']) . ", shipping_country = " . esc($data['shipping_country']) . ", shipping_country_id = " . (int)$data['shipping_country_id'] . ", shipping_zone = " . esc($data['shipping_zone']) . ", shipping_zone_id = " . (int)$data['shipping_zone_id'] . ", shipping_address_format = " . esc($data['shipping_address_format']) . ", shipping_custom_field = " . esc(isset($data['shipping_custom_field']) ? json_encode($data['shipping_custom_field']) : '') . ", shipping_method = " . esc($data['shipping_method']) . ", shipping_code = " . esc($data['shipping_code']) . ", comment = " . esc($data['comment']) . ", total = '" . (float)$data['total'] . "', affiliate_id = " . (int)$data['affiliate_id'] . ", commission = '" . (float)$data['commission'] . "', marketing_id = " . (int)$data['marketing_id'] . ", tracking = " . esc($data['tracking']) . ", language_id = " . (int)$data['language_id'] . ", currency_id = " . (int)$data['currency_id'] . ", currency_code = " . esc($data['currency_code']) . ", currency_value = '" . (float)$data['currency_value'] . "', ip = " . esc($data['ip']) . ", forwarded_ip = '" .  db::escape($data['forwarded_ip']) . "', user_agent = " . esc($data['user_agent']) . ", accept_language = " . esc($data['accept_language']) . ", date_added = NOW(), date_modified = NOW()");

		$order_id = db::getLastId();

		// Products
		if (isset($data['products'])) {
			foreach ($data['products'] as $product) {
				db::query("INSERT INTO order_product SET order_id = " . (int)$order_id . ", product_id = " . (int)$product['product_id'] . ", name = " . esc($product['name']) . ", model = " . esc($product['model']) . ", quantity = " . (int)$product['quantity'] . ", price = '" . (float)$product['price'] . "', total = '" . (float)$product['total'] . "', tax = '" . (float)$product['tax'] . "', reward = " . (int)$product['reward']);

				$order_product_id = db::getLastId();

				foreach ($product['option'] as $option) {
					db::query("INSERT INTO order_option SET order_id = " . (int)$order_id . ", order_product_id = " . (int)$order_product_id . ", product_option_id = " . (int)$option['product_option_id'] . ", product_option_value_id = " . (int)$option['product_option_value_id'] . ", name = " . esc($option['name']) . ", `value` = " . esc($option['value']) . ", `type` = " . esc($option['type']));
				}
			}
		}

		// Gift Voucher

		// Vouchers
		if (isset($data['vouchers'])) {
			foreach ($data['vouchers'] as $voucher) {
				db::query("INSERT INTO order_voucher SET order_id = " . (int)$order_id . ", description = " . esc($voucher['description']) . ", code = " . esc($voucher['code']) . ", from_name = " . esc($voucher['from_name']) . ", from_email = " . esc($voucher['from_email']) . ", to_name = " . esc($voucher['to_name']) . ", to_email = " . esc($voucher['to_email']) . ", voucher_theme_id = " . (int)$voucher['voucher_theme_id'] . ", message = " . esc($voucher['message']) . ", amount = '" . (float)$voucher['amount'] . "'");

				$order_voucher_id = db::getLastId();

				$voucher_id = extension_total_voucher::addVoucher($order_id, $voucher);

				db::query("UPDATE order_voucher SET voucher_id = " . (int)$voucher_id . " WHERE order_voucher_id = " . (int)$order_voucher_id);
			}
		}

		// Totals
		if (isset($data['totals'])) {
			foreach ($data['totals'] as $total) {
				db::query("INSERT INTO order_total SET order_id = " . (int)$order_id . ", code = " . esc($total['code']) . ", title = " . esc($total['title']) . ", `value` = '" . (float)$total['value'] . "', sort_order = " . (int)$total['sort_order']);
			}
		}

		return $order_id;
	}

	public static function editOrder($order_id, $data) {
		// Void the order first
		self::addOrderHistory($order_id, 0);

		db::query("UPDATE `order` SET invoice_prefix = " . esc($data['invoice_prefix']) . ", store_id = " . (int)$data['store_id'] . ", store_name = " . esc($data['store_name']) . ", store_url = " . esc($data['store_url']) . ", customer_id = " . (int)$data['customer_id'] . ", customer_group_id = " . (int)$data['customer_group_id'] . ", firstname = " . esc($data['firstname']) . ", lastname = " . esc($data['lastname']) . ", email = " . esc($data['email']) . ", telephone = " . esc($data['telephone']) . ", custom_field = " . esc(json_encode($data['custom_field'])) . ", payment_firstname = " . esc($data['payment_firstname']) . ", payment_lastname = " . esc($data['payment_lastname']) . ", payment_company = " . esc($data['payment_company']) . ", payment_address_1 = " . esc($data['payment_address_1']) . ", payment_address_2 = " . esc($data['payment_address_2']) . ", payment_city = " . esc($data['payment_city']) . ", payment_postcode = " . esc($data['payment_postcode']) . ", payment_country = " . esc($data['payment_country']) . ", payment_country_id = " . (int)$data['payment_country_id'] . ", payment_zone = " . esc($data['payment_zone']) . ", payment_zone_id = " . (int)$data['payment_zone_id'] . ", payment_address_format = " . esc($data['payment_address_format']) . ", payment_custom_field = " . esc(json_encode($data['payment_custom_field'])) . ", payment_method = " . esc($data['payment_method']) . ", payment_code = " . esc($data['payment_code']) . ", shipping_firstname = " . esc($data['shipping_firstname']) . ", shipping_lastname = " . esc($data['shipping_lastname']) . ", shipping_company = " . esc($data['shipping_company']) . ", shipping_address_1 = " . esc($data['shipping_address_1']) . ", shipping_address_2 = " . esc($data['shipping_address_2']) . ", shipping_city = " . esc($data['shipping_city']) . ", shipping_postcode = " . esc($data['shipping_postcode']) . ", shipping_country = " . esc($data['shipping_country']) . ", shipping_country_id = " . (int)$data['shipping_country_id'] . ", shipping_zone = " . esc($data['shipping_zone']) . ", shipping_zone_id = " . (int)$data['shipping_zone_id'] . ", shipping_address_format = " . esc($data['shipping_address_format']) . ", shipping_custom_field = " . esc(json_encode($data['shipping_custom_field'])) . ", shipping_method = " . esc($data['shipping_method']) . ", shipping_code = " . esc($data['shipping_code']) . ", comment = " . esc($data['comment']) . ", total = '" . (float)$data['total'] . "', affiliate_id = " . (int)$data['affiliate_id'] . ", commission = '" . (float)$data['commission'] . "', date_modified = NOW() WHERE order_id = " . (int)$order_id);

		db::query("DELETE FROM order_product WHERE order_id = " . (int)$order_id);
		db::query("DELETE FROM order_option WHERE order_id = " . (int)$order_id);

		// Products
		if (isset($data['products'])) {
			foreach ($data['products'] as $product) {
				db::query("INSERT INTO order_product SET order_id = " . (int)$order_id . ", product_id = " . (int)$product['product_id'] . ", name = " . esc($product['name']) . ", model = " . esc($product['model']) . ", quantity = " . (int)$product['quantity'] . ", price = '" . (float)$product['price'] . "', total = '" . (float)$product['total'] . "', tax = '" . (float)$product['tax'] . "', reward = " . (int)$product['reward']);

				$order_product_id = db::getLastId();

				foreach ($product['option'] as $option) {
					db::query("INSERT INTO order_option SET order_id = " . (int)$order_id . ", order_product_id = " . (int)$order_product_id . ", product_option_id = " . (int)$option['product_option_id'] . ", product_option_value_id = " . (int)$option['product_option_value_id'] . ", name = " . esc($option['name']) . ", `value` = " . esc($option['value']) . ", `type` = " . esc($option['type']));
				}
			}
		}

		// Gift Voucher

		extension_total_voucher::disableVoucher($order_id);

		// Vouchers
		db::query("DELETE FROM order_voucher WHERE order_id = " . (int)$order_id);

		if (isset($data['vouchers'])) {
			foreach ($data['vouchers'] as $voucher) {
				db::query("INSERT INTO order_voucher SET order_id = " . (int)$order_id . ", description = " . esc($voucher['description']) . ", code = " . esc($voucher['code']) . ", from_name = " . esc($voucher['from_name']) . ", from_email = " . esc($voucher['from_email']) . ", to_name = " . esc($voucher['to_name']) . ", to_email = " . esc($voucher['to_email']) . ", voucher_theme_id = " . (int)$voucher['voucher_theme_id'] . ", message = " . esc($voucher['message']) . ", amount = '" . (float)$voucher['amount'] . "'");

				$order_voucher_id = db::getLastId();

				$voucher_id = extension_total_voucher::addVoucher($order_id, $voucher);

				db::query("UPDATE order_voucher SET voucher_id = " . (int)$voucher_id . " WHERE order_voucher_id = " . (int)$order_voucher_id);
			}
		}

		// Totals
		db::query("DELETE FROM order_total WHERE order_id = " . (int)$order_id);

		if (isset($data['totals'])) {
			foreach ($data['totals'] as $total) {
				db::query("INSERT INTO order_total SET order_id = " . (int)$order_id . ", code = " . esc($total['code']) . ", title = " . esc($total['title']) . ", `value` = '" . (float)$total['value'] . "', sort_order = " . (int)$total['sort_order']);
			}
		}
	}

	public static function deleteOrder($order_id) {
		// Void the order first
		self::addOrderHistory($order_id, 0);

		db::query("DELETE FROM `order` WHERE order_id = " . (int)$order_id);
		db::query("DELETE FROM `order_product` WHERE order_id = " . (int)$order_id);
		db::query("DELETE FROM `order_option` WHERE order_id = " . (int)$order_id);
		db::query("DELETE FROM `order_voucher` WHERE order_id = " . (int)$order_id);
		db::query("DELETE FROM `order_total` WHERE order_id = " . (int)$order_id);
		db::query("DELETE FROM `order_history` WHERE order_id = " . (int)$order_id);
		db::query("DELETE `or`, ort FROM `order_recurring` `or`, `order_recurring_transaction` `ort` WHERE order_id = " . (int)$order_id . " AND ort.order_recurring_id = `or`.order_recurring_id");
		db::query("DELETE FROM `customer_transaction` WHERE order_id = " . (int)$order_id);

		// Gift Voucher

		extension_total_voucher::disableVoucher($order_id);
	}

	public static function getOrder($order_id) {
		$order_query = db::query("SELECT *, (SELECT os.name FROM `order_status` os WHERE os.order_status_id = o.order_status_id AND os.language_id = o.language_id) AS order_status FROM `order` o WHERE o.order_id = " . (int)$order_id);

		if ($order_query->num_rows) {
			$country_query = db::query("SELECT * FROM `country` WHERE country_id = " . (int)$order_query->row['payment_country_id']);

			if ($country_query->num_rows) {
				$payment_iso_code_2 = $country_query->row['iso_code_2'];
				$payment_iso_code_3 = $country_query->row['iso_code_3'];
			} else {
				$payment_iso_code_2 = '';
				$payment_iso_code_3 = '';
			}

			$zone_query = db::query("SELECT * FROM `zone` WHERE zone_id = " . (int)$order_query->row['payment_zone_id']);

			if ($zone_query->num_rows) {
				$payment_zone_code = $zone_query->row['code'];
			} else {
				$payment_zone_code = '';
			}

			$country_query = db::query("SELECT * FROM `country` WHERE country_id = " . (int)$order_query->row['shipping_country_id']);

			if ($country_query->num_rows) {
				$shipping_iso_code_2 = $country_query->row['iso_code_2'];
				$shipping_iso_code_3 = $country_query->row['iso_code_3'];
			} else {
				$shipping_iso_code_2 = '';
				$shipping_iso_code_3 = '';
			}

			$zone_query = db::query("SELECT * FROM `zone` WHERE zone_id = " . (int)$order_query->row['shipping_zone_id']);

			if ($zone_query->num_rows) {
				$shipping_zone_code = $zone_query->row['code'];
			} else {
				$shipping_zone_code = '';
			}


			$language_info = localisation_language::getLanguage($order_query->row['language_id']);

			if ($language_info) {
				$language_code = $language_info['code'];
			} else {
				$language_code = config('language');
			}

			return array(
				'order_id'                => $order_query->row['order_id'],
				'invoice_no'              => $order_query->row['invoice_no'],
				'invoice_prefix'          => $order_query->row['invoice_prefix'],
				'store_id'                => $order_query->row['store_id'],
				'store_name'              => $order_query->row['store_name'],
				'store_url'               => $order_query->row['store_url'],
				'customer_id'             => $order_query->row['customer_id'],
				'firstname'               => $order_query->row['firstname'],
				'lastname'                => $order_query->row['lastname'],
				'email'                   => $order_query->row['email'],
				'telephone'               => $order_query->row['telephone'],
				'custom_field'            => json_decode($order_query->row['custom_field'], true),
				'payment_firstname'       => $order_query->row['payment_firstname'],
				'payment_lastname'        => $order_query->row['payment_lastname'],
				'payment_company'         => $order_query->row['payment_company'],
				'payment_address_1'       => $order_query->row['payment_address_1'],
				'payment_address_2'       => $order_query->row['payment_address_2'],
				'payment_postcode'        => $order_query->row['payment_postcode'],
				'payment_city'            => $order_query->row['payment_city'],
				'payment_zone_id'         => $order_query->row['payment_zone_id'],
				'payment_zone'            => $order_query->row['payment_zone'],
				'payment_zone_code'       => $payment_zone_code,
				'payment_country_id'      => $order_query->row['payment_country_id'],
				'payment_country'         => $order_query->row['payment_country'],
				'payment_iso_code_2'      => $payment_iso_code_2,
				'payment_iso_code_3'      => $payment_iso_code_3,
				'payment_address_format'  => $order_query->row['payment_address_format'],
				'payment_custom_field'    => json_decode($order_query->row['payment_custom_field'], true),
				'payment_method'          => $order_query->row['payment_method'],
				'payment_code'            => $order_query->row['payment_code'],
				'shipping_firstname'      => $order_query->row['shipping_firstname'],
				'shipping_lastname'       => $order_query->row['shipping_lastname'],
				'shipping_company'        => $order_query->row['shipping_company'],
				'shipping_address_1'      => $order_query->row['shipping_address_1'],
				'shipping_address_2'      => $order_query->row['shipping_address_2'],
				'shipping_postcode'       => $order_query->row['shipping_postcode'],
				'shipping_city'           => $order_query->row['shipping_city'],
				'shipping_zone_id'        => $order_query->row['shipping_zone_id'],
				'shipping_zone'           => $order_query->row['shipping_zone'],
				'shipping_zone_code'      => $shipping_zone_code,
				'shipping_country_id'     => $order_query->row['shipping_country_id'],
				'shipping_country'        => $order_query->row['shipping_country'],
				'shipping_iso_code_2'     => $shipping_iso_code_2,
				'shipping_iso_code_3'     => $shipping_iso_code_3,
				'shipping_address_format' => $order_query->row['shipping_address_format'],
				'shipping_custom_field'   => json_decode($order_query->row['shipping_custom_field'], true),
				'shipping_method'         => $order_query->row['shipping_method'],
				'shipping_code'           => $order_query->row['shipping_code'],
				'comment'                 => $order_query->row['comment'],
				'total'                   => $order_query->row['total'],
				'order_status_id'         => $order_query->row['order_status_id'],
				'order_status'            => $order_query->row['order_status'],
				'affiliate_id'            => $order_query->row['affiliate_id'],
				'commission'              => $order_query->row['commission'],
				'language_id'             => $order_query->row['language_id'],
				'language_code'           => $language_code,
				'currency_id'             => $order_query->row['currency_id'],
				'currency_code'           => $order_query->row['currency_code'],
				'currency_value'          => $order_query->row['currency_value'],
				'ip'                      => $order_query->row['ip'],
				'forwarded_ip'            => $order_query->row['forwarded_ip'],
				'user_agent'              => $order_query->row['user_agent'],
				'accept_language'         => $order_query->row['accept_language'],
				'date_added'              => $order_query->row['date_added'],
				'date_modified'           => $order_query->row['date_modified']
			);
		} else {
			return false;
		}
	}
	
	public static function getOrderProducts($order_id) {
		$query = db::query("SELECT * FROM order_product WHERE order_id = " . (int)$order_id);
		
		return $query->rows;
	}
	
	public static function getOrderOptions($order_id, $order_product_id) {
		$query = db::query("SELECT * FROM order_option WHERE order_id = " . (int)$order_id . " AND order_product_id = " . (int)$order_product_id);
		
		return $query->rows;
	}
	
	public static function getOrderVouchers($order_id) {
		$query = db::query("SELECT * FROM order_voucher WHERE order_id = " . (int)$order_id);
	
		return $query->rows;
	}
	
	public static function getOrderTotals($order_id) {
		$query = db::query("SELECT * FROM `order_total` WHERE order_id = " . (int)$order_id . " ORDER BY sort_order ASC");
		
		return $query->rows;
	}	
			
	public static function addOrderHistory($order_id, $order_status_id, $comment = '', $notify = false, $override = false) {
		$order_info = self::getOrder($order_id);
		
		if ($order_info) {
			// Fraud Detection

			$customer_info = account_customer::getCustomer($order_info['customer_id']);

			if ($customer_info && $customer_info['safe']) {
				$safe = true;
			} else {
				$safe = false;
			}

			// Only do the fraud check if the customer is not on the safe list and the order status is changing into the complete or process order status
			if (!$safe && !$override && in_array($order_status_id, array_merge(config('processing_status'), config('complete_status')))) {
				// Anti-Fraud

				$extensions = setting_extension::getExtensions('fraud');

				foreach ($extensions as $extension) {
					if (config::get('fraud_' . $extension['code'] . '_status')) {

						if (model_method_exists('extension_fraud_' . $extension['code'], 'check')) {
							$fraud_status_id = call_model_method('extension_fraud_' . $extension['code'], 'check', $order_info);
	
							if ($fraud_status_id) {
								$order_status_id = $fraud_status_id;
							}
						}
					}
				}
			}

			// If current order status is not processing or complete but new status is processing or complete then commence completing the order
			if (!in_array($order_info['order_status_id'], array_merge(config('processing_status'), config('complete_status'))) && in_array($order_status_id, array_merge(config('processing_status'), config('complete_status')))) {
				// Redeem coupon, vouchers and reward points
				$order_totals = self::getOrderTotals($order_id);

				foreach ($order_totals as $order_total) {

					if (model_method_exists('extension_total_' . $order_total['code'], 'confirm')) {
						// Confirm coupon, vouchers and reward points
						$fraud_status_id = call_model_method('extension_total_' . $order_total['code'], 'confirm', $order_info, $order_total);
						
						// If the balance on the coupon, vouchers and reward points is not enough to cover the transaction or has already been used then the fraud order status is returned.
						if ($fraud_status_id) {
							$order_status_id = $fraud_status_id;
						}
					}
				}

				// Stock subtraction
				$order_products = self::getOrderProducts($order_id);

				foreach ($order_products as $order_product) {
					db::query("UPDATE product SET quantity = (quantity - " . (int)$order_product['quantity'] . ") WHERE product_id = " . (int)$order_product['product_id'] . " AND subtract = '1'");

					$order_options = self::getOrderOptions($order_id, $order_product['order_product_id']);

					foreach ($order_options as $order_option) {
						db::query("UPDATE product_option_value SET quantity = (quantity - " . (int)$order_product['quantity'] . ") WHERE product_option_value_id = " . (int)$order_option['product_option_value_id'] . " AND subtract = '1'");
					}
				}
				
				// Add commission if sale is linked to affiliate referral.
				if ($order_info['affiliate_id'] && config('affiliate_auto')) {

					if (!account_customer::getTotalTransactionsByOrderId($order_id)) {
						account_customer::addTransaction($order_info['affiliate_id'], language::get('text_order_id') . ' #' . $order_id, $order_info['commission'], $order_id);
					}
				}
			}

			// Update the DB with the new statuses
			db::query("UPDATE `order` SET order_status_id = " . (int)$order_status_id . ", date_modified = NOW() WHERE order_id = " . (int)$order_id);

			db::query("INSERT INTO order_history SET order_id = " . (int)$order_id . ", order_status_id = " . (int)$order_status_id . ", notify = " . (int)$notify . ", comment = " . esc($comment) . ", date_added = NOW()");

			// If old order status is the processing or complete status but new status is not then commence restock, and remove coupon, voucher and reward history
			if (in_array($order_info['order_status_id'], array_merge(config('processing_status'), config('complete_status'))) && !in_array($order_status_id, array_merge(config('processing_status'), config('complete_status')))) {
				// Restock
				$order_products = self::getOrderProducts($order_id);

				foreach($order_products as $order_product) {
					db::query("UPDATE `product` SET quantity = (quantity + " . (int)$order_product['quantity'] . ") WHERE product_id = " . (int)$order_product['product_id'] . " AND subtract = '1'");

					$order_options = self::getOrderOptions($order_id, $order_product['order_product_id']);

					foreach ($order_options as $order_option) {
						db::query("UPDATE product_option_value SET quantity = (quantity + " . (int)$order_product['quantity'] . ") WHERE product_option_value_id = " . (int)$order_option['product_option_value_id'] . " AND subtract = '1'");
					}
				}

				// Remove coupon, vouchers and reward points history
				$order_totals = self::getOrderTotals($order_id);
				
				foreach ($order_totals as $order_total) {

					if (model_method_exists('extension_total_' . $order_total['code'], 'unconfirm')) {
						call_model_method('extension_total_' . $order_total['code'], 'unconfirm', $order_id);
					}
				}

				// Remove commission if sale is linked to affiliate referral.
				if ($order_info['affiliate_id']) {
					
					account_customer::deleteTransactionByOrderId($order_id);
				}
			}

			cache::delete('product');
		}
	}
}