<?php
class extension_payment_alipay_cross {
	var $https_verify_url = 'https://mapi.alipay.com/gateway.do?service=notify_verify&';
	var $https_verify_url_test = 'https://openapi.alipaydev.com/gateway.do?service=notify_verify&';
	var $alipay_config;

	public static function getMethod($address, $total) {
		load::language('extension/payment/alipay_cross');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_alipay_cross_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_alipay_cross_total') > 0 && config::get('payment_alipay_cross_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_alipay_cross_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'alipay_cross',
				'title'      => language::get('text_title'),
				'terms'      => '',
				'sort_order' => config::get('payment_alipay_cross_sort_order')
			);
		}

		return $method_data;
	}

	static function buildRequestMysign($para_sort) {
		$prestr = self::createLinkstring($para_sort);

		$mysign = "";
		switch (strtoupper(trim(self::$alipay_config['sign_type']))) {
			case "MD5" :
				$mysign = self::md5Sign($prestr, self::$alipay_config['key']);
				break;
			default :
				$mysign = "";
		}

		return $mysign;
	}


	static function buildRequestPara($alipay_config, $para_temp) {
		self::$alipay_config = $alipay_config;

		$para_filter = self::paraFilter($para_temp);

		$para_sort = self::argSort($para_filter);

		$mysign = self::buildRequestMysign($para_sort);

		$para_sort['sign'] = $mysign;
		$para_sort['sign_type'] = strtoupper(trim(self::$alipay_config['sign_type']));

		return $para_sort;
	}

	static function verifyNotify($alipay_config){
		self::$alipay_config = $alipay_config;

		if(empty($_POST)) {
			return false;
		}
		else {
			$isSign = self::getSignVeryfy($_POST, $_POST["sign"]);

			$responseTxt = 'false';
			if (! empty($_POST["notify_id"])) {
				$responseTxt = self::getResponse($_POST["notify_id"]);
			}

			//Veryfy
			if (preg_match("/true$/i",$responseTxt) && $isSign) {
				return true;
			} else {
				log::write($responseTxt);
				return false;
			}
		}
	}

	static function getSignVeryfy($para_temp, $sign) {
		$para_filter = self::paraFilter($para_temp);

		$para_sort = self::argSort($para_filter);

		$prestr = self::createLinkstring($para_sort);

		switch (strtoupper(trim(self::$alipay_config['sign_type']))) {
			case "MD5" :
				$isSgin = self::md5Verify($prestr, $sign, self::$alipay_config['key']);
				break;
			default :
				$isSgin = false;
		}

		return $isSgin;
	}

	static function getResponse($notify_id) {
		$partner = trim(self::$alipay_config['partner']);
		$veryfy_url = config::get('payment_alipay_cross_test') == "sandbox" ? self::$https_verify_url_test : self::$https_verify_url;
		$veryfy_url .= "partner=" . $partner . "&notify_id=" . $notify_id;
		$responseTxt = self::getHttpResponseGET($veryfy_url, self::$alipay_config['cacert']);

		return $responseTxt;
	}

	static function createLinkstring($para) {
		$arg  = "";
		while (list ($key, $val) = each ($para)) {
			$arg .= $key . "=" . $val . "&";
		}
		//remove the last char '&'
		$arg = substr($arg, 0, count($arg)-2);

		return $arg;
	}

	static function paraFilter($para) {
		$para_filter = array();
		while (list ($key, $val) = each ($para)) {
			if($key == "sign" || $key == "sign_type" || $val == "")continue;
			else	$para_filter[$key] = $para[$key];
		}
		return $para_filter;
	}

	static function argSort($para) {
		ksort($para);
		reset($para);
		return $para;
	}

	static function getHttpResponseGET($url,$cacert_url) {
		$curl = curl_init($url);
		curl_setopt($curl, CURLOPT_HEADER, 0 );
		curl_setopt($curl,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
		curl_setopt($curl, CURLOPT_CAINFO,$cacert_url);
		$responseText = curl_exec($curl);
		if (!$responseText) {
			log::write('ALIPAY NOTIFY CURL_ERROR: ' . var_export(curl_error($curl), true));
		}
		curl_close($curl);

		return $responseText;
	}

	static function md5Sign($prestr, $key) {
		$prestr = $prestr . $key;
		return md5($prestr);
	}

	static function md5Verify($prestr, $sign, $key)
	{
		$prestr = $prestr . $key;
		$mysgin = md5($prestr);

		if ($mysgin == $sign) {
			return true;
		} else {
			return false;
		}
	}
}

