<?php

class extension_payment_bluepay_hosted {

	public static function getMethod($address, $total) {
		load::language('extension/payment/bluepay_hosted');

		$query = db::query("SELECT * FROM `zone_to_geo_zone` WHERE geo_zone_id = " . (int)config::get('payment_bluepay_hosted_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_bluepay_hosted_total') > 0 && config::get('payment_bluepay_hosted_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_bluepay_hosted_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code' => 'bluepay_hosted',
				'title' => language::get('text_title'),
				'terms' => '',
				'sort_order' => config::get('payment_bluepay_hosted_sort_order')
			);
		}

		return $method_data;
	}

	public static function addOrder($order_info, $response_data) {
		if (config::get('payment_bluepay_hosted_transaction') == 'SALE') {
			$release_status = 1;
		} else {
			$release_status = null;
		}

		db::query("INSERT INTO `bluepay_hosted_order` SET `order_id` = " . (int)$order_info['order_id'] . ", `transaction_id` = " . esc($response_data['RRNO']) . ", `date_added` = now(), `date_modified` = now(), `release_status` = " . (int)$release_status . ", `currency_code` = " . esc($order_info['currency_code']) . ", `total` = '" . currency::format($order_info['total'], $order_info['currency_code'], false, false) . "'");

		return db::getLastId();
	}

	public static function addTransaction($bluepay_hosted_order_id, $type, $order_info) {
		db::query("INSERT INTO `bluepay_hosted_order_transaction` SET `bluepay_hosted_order_id` = " . (int)$bluepay_hosted_order_id . ", `date_added` = now(), `type` = " . esc($type) . ", `amount` = '" . currency::format($order_info['total'], $order_info['currency_code'], false, false) . "'");
	}

	public static function logger($message) {
		if (config::get('payment_bluepay_hosted_debug') == 1) {
			$log = new Log('bluepay_hosted.log');
			$log::write($message);
		}
	}

}
