<?php
use Cardinity\Client;
use Cardinity\Method\Payment;
use Cardinity\Exception as CardinityException;

class extension_payment_cardinity {
	public static function addOrder($data) {
		db::query("INSERT INTO `cardinity_order` SET `order_id` = " . (int)$data['order_id'] . ", `payment_id` = " . esc($data['payment_id']));
	}

	public static function getOrder($order_id) {
		$query = db::query("SELECT * FROM `cardinity_order` WHERE `order_id` = " . (int)$order_id . " LIMIT 1");

		return $query->row;
	}

	public static function createPayment($key, $secret, $payment_data) {
		$client = Client::create(array(
			'consumerKey'    => $key,
			'consumerSecret' => $secret,
		));

		$method = new Payment\Create($payment_data);

		try {
			$payment = $client::call($method);

			return $payment;
		} catch (Exception $exception) {
			self::exception($exception);

			throw $exception;
		}
	}

	public static function finalizePayment($key, $secret, $payment_id, $pares) {
		$client = Client::create(array(
			'consumerKey'    => $key,
			'consumerSecret' => $secret,
		));

		$method = new Payment\Finalize($payment_id, $pares);

		try {
			$payment = $client::call($method);

			return $payment;
		} catch (Exception $exception) {
			self::exception($exception);

			return false;
		}
	}

	public static function getMethod($address, $total) {
		load::language('extension/payment/cardinity');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_cardinity_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_cardinity_total') > 0 && config::get('payment_cardinity_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_cardinity_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		if (!in_array(session::$data['currency'], self::getSupportedCurrencies())) {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'		 => 'cardinity',
				'title'		 => language::get('text_title'),
				'terms'		 => '',
				'sort_order' => config::get('payment_cardinity_sort_order')
			);
		}

		return $method_data;
	}

	public static function getSupportedCurrencies() {
		return array(
			'USD',
			'GBP',
			'EUR'
		);
	}

	public static function log($data, $class_step = 6, $function_step = 6) {
		if (config::get('payment_cardinity_debug')) {
			$backtrace = debug_backtrace();
			$log = new Log('cardinity.log');
			$log::write('(' . $backtrace[$class_step]['class'] . '::$' . $backtrace[$function_step]['function'] . ') - ' . print_r($data, true));
		}
	}

	private static function exception(Exception $exception) {
		self::log($exception::getMessage(), 1, 2);

		switch (true) {
			case $exception instanceof CardinityException\Request:
				if ($exception::getErrorsAsString()) {
					self::log($exception::getErrorsAsString(), 1, 2);
				}

				break;
			case $exception instanceof CardinityException\InvalidAttributeValue:
				foreach ($exception::getViolations() as $violation) {
					self::log($violation::getMessage(), 1, 2);
				}

				break;
		}
	}
}