<?php
class extension_payment_firstdata {
	public static function getMethod($address, $total) {
		load::language('extension/payment/firstdata');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_firstdata_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_firstdata_total') > 0 && config::get('payment_firstdata_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_firstdata_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'firstdata',
				'title'      => language::get('text_title'),
				'terms'      => '',
				'sort_order' => config::get('payment_firstdata_sort_order')
			);
		}

		return $method_data;
	}

	public static function addOrder($order_info, $order_ref, $transaction_date) {
		if (config::get('payment_firstdata_auto_settle') == 1) {
			$settle_status = 1;
		} else {
			$settle_status = 0;
		}

		db::query("INSERT INTO `firstdata_order` SET `order_id` = " . (int)$order_info['order_id'] . ", `order_ref` = " . esc($order_ref) . ", `tdate` = " . esc($transaction_date) . ", `date_added` = now(), `date_modified` = now(), `capture_status` = " . (int)$settle_status . ", `currency_code` = " . esc($order_info['currency_code']) . ", `total` = '" . currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false) . "'");

		return db::getLastId();
	}

	public static function getOrder($order_id) {
		$order = db::query("SELECT * FROM `firstdata_order` WHERE `order_id` = " . (int)$order_id . " LIMIT 1");

		return $order->row;
	}

	public static function addTransaction($fd_order_id, $type, $order_info = array()) {
		if (!empty($order_info)) {
			$amount = currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		} else {
			$amount = 0.00;
		}

		db::query("INSERT INTO `firstdata_order_transaction` SET `firstdata_order_id` = " . (int)$fd_order_id . ", `date_added` = now(), `type` = " . esc($type) . ", `amount` = '" . (float)$amount . "'");
	}

	public static function addHistory($order_id, $order_status_id, $comment) {
		db::query("INSERT INTO order_history SET order_id = " . (int)$order_id . ", order_status_id = " . (int)$order_status_id . ", notify = '0', comment = " . esc($comment) . ", date_added = NOW()");
	}

	public static function logger($message) {
		if (config::get('payment_firstdata_debug') == 1) {
			$log = new Log('firstdata.log');
			$log::write($message);
		}
	}

	public static function mapCurrency($code) {
		$currency = array(
			'GBP' => 826,
			'USD' => 840,
			'EUR' => 978,
		);

		if (array_key_exists($code, $currency)) {
			return $currency[$code];
		} else {
			return false;
		}
	}

	public static function getStoredCards() {
		$customer_id = customer::getId();

		$query = db::query("SELECT * FROM `firstdata_card` WHERE `customer_id` = " . (int)$customer_id);

		return $query->rows;
	}

	public static function storeCard($token, $customer_id, $month, $year, $digits) {
		$existing_card = db::query("SELECT * FROM `firstdata_card` WHERE `token` = " . esc($token) . " AND `customer_id` = " . (int)$customer_id . " LIMIT 1");

		if ($existing_card->num_rows > 0) {
			db::query("UPDATE `firstdata_card` SET `expire_month` = " . esc($month) . ", `expire_year` = " . esc($year) . ", `digits` = " . esc($digits));
		} else {
			db::query("INSERT INTO `firstdata_card` SET `customer_id` = " . (int)$customer_id . ", `date_added` = now(), `token` = " . esc($token) . ", `expire_month` = " . esc($month) . ", `expire_year` = " . esc($year) . ", `digits` = " . esc($digits));
		}
	}

	public static function responseHash($total, $currency, $txn_date, $approval_code) {
		$tmp = $total . config::get('payment_firstdata_secret') . $currency . $txn_date . config::get('payment_firstdata_merchant_id') . $approval_code;

		$ascii = bin2hex($tmp);

		return sha1($ascii);
	}

	public static function updateVoidStatus($order_id, $status) {
		db::query("UPDATE `firstdata_order` SET `void_status` = " . (int)$status . " WHERE `order_id` = " . (int)$order_id);
	}

	public static function updateCaptureStatus($order_id, $status) {
		db::query("UPDATE `firstdata_order` SET `capture_status` = " . (int)$status . " WHERE `order_id` = " . (int)$order_id);
	}
}