<?php
class extension_payment_g2apay {

	public static function getMethod($address, $total) {
		load::language('extension/payment/g2apay');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_g2apay_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_g2apay_total') > 0 && config::get('payment_g2apay_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_g2apay_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code' => 'g2apay',
				'title' => language::get('text_title'),
				'terms' => '',
				'sort_order' => config::get('payment_g2apay_sort_order')
			);
		}

		return $method_data;
	}

	public static function addG2aOrder($order_info) {
		db::query("INSERT INTO `g2apay_order` SET `order_id` = " . (int)$order_info['order_id'] . ", `date_added` = now(), `modified` = now(), `currency_code` = " . esc($order_info['currency_code']) . ", `total` = '" . currency::format($order_info['total'], $order_info['currency_code'], false, false) . "'");
	}

	public static function updateOrder($g2apay_order_id, $g2apay_transaction_id, $type, $order_info) {
		db::query("UPDATE `g2apay_order` SET `g2apay_transaction_id` = " . esc($g2apay_transaction_id) . ", `modified` = now() WHERE `order_id` = " . (int)$order_info['order_id']);

		self::addTransaction($g2apay_order_id, $type, $order_info);

	}

	public static function addTransaction($g2apay_order_id, $type, $order_info) {
		db::query("INSERT INTO `g2apay_order_transaction` SET `g2apay_order_id` = " . (int)$g2apay_order_id . ", `date_added` = now(), `type` = " . esc($type) . ", `amount` = '" . currency::format($order_info['total'], $order_info['currency_code'], false, false) . "'");
	}

	public static function getG2aOrder($order_id) {
		$qry = db::query("SELECT * FROM `g2apay_order` WHERE `order_id` = " . (int)$order_id . " LIMIT 1");

		if ($qry->num_rows) {
			return $qry->row;
		} else {
			return false;
		}
	}

	public static function sendCurl($url, $fields) {
		$curl = curl_init($url);

		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $fields);
		$response = curl_exec($curl);

		curl_close($curl);

		return json_decode($response);
	}

	public static function logger($message) {
		if (config::get('payment_g2apay_debug') == 1) {
			$log = new Log('g2apay.log');
			$backtrace = debug_backtrace();
			$log::write('Origin: ' . $backtrace[6]['class'] . '::$' . $backtrace[6]['function']);
			$log::write(print_r($message, 1));
		}
	}
}