<?php
class extension_payment_laybuy {
	public static function addTransaction($data = array(), $status) {
		self::log('Report: ' . print_r($data, true), '1');

		self::log('Status: ' . $status, '1');

		db::query("INSERT INTO `laybuy_transaction` SET `order_id` = " . (int)$data['order_id'] . ", `firstname` = " . esc($data['firstname']) . ", `lastname` = " . esc($data['lastname']) . ", `address` = " . esc($data['address']) . ", `suburb` = " . esc($data['suburb']) . ", `state` = " . esc($data['state']) . ", `country` = " . esc($data['country']) . ", `postcode` = " . esc($data['postcode']) . ", `email` = " . esc($data['email']) . ", `amount` = '" . (float)$data['amount'] . "', `currency` = " . esc($data['currency']) . ", `downpayment` = " . esc($data['downpayment']) . ", `months` = " . (int)$data['months'] . ", `downpayment_amount` = '" . (float)$data['downpayment_amount'] . "', `payment_amounts` = '" . (float)$data['payment_amounts'] . "', `first_payment_due` = " . esc($data['first_payment_due']) . ", `last_payment_due` = " . esc($data['last_payment_due']) . ", `store_id` = " . (int)$data['store_id'] . ", `status` = " . (int)$status . ", `report` = " . esc($data['report']) . ", `paypal_profile_id` = " . esc($data['paypal_profile_id']) . ", `laybuy_ref_no` = " . (int)$data['laybuy_ref_no'] . ", `date_added` = NOW()");
	}

	public static function deleteRevisedTransaction($id) {
		db::query("DELETE FROM `laybuy_revise_request` WHERE `laybuy_revise_request_id` = " . (int)$id);
	}

	public static function deleteTransactionByOrderId($order_id) {
		db::query("DELETE FROM `laybuy_transaction` WHERE `order_id` = " . (int)$order_id);

		db::query("DELETE FROM `laybuy_revise_request` WHERE `order_id` = " . (int)$order_id);
	}

	public static function getInitialPayments() {
		$minimum = config::get('payment_laybuy_min_deposit') ? config::get('payment_laybuy_min_deposit') : 20;

		$maximum = config::get('payment_laybuy_max_deposit') ? config::get('payment_laybuy_max_deposit') : 50;

		$initial_payments = array();

		for ($i = $minimum; $i <= $maximum; $i += 10) {
			$initial_payments[] = $i;
		}

		return $initial_payments;
	}

	public static function getMethod($address, $total) {
		load::language('extension/payment/laybuy');

		$query = db::query("SELECT * FROM `zone_to_geo_zone` WHERE `geo_zone_id` = " . (int)config::get('payment_laybuy_geo_zone_id') . " AND `country_id` = " . (int)$address['country_id'] . " AND (`zone_id` = " . (int)$address['zone_id'] . " OR `zone_id` = '0')");

		if (config::get('payment_laybuy_total') > 0 && config::get('payment_laybuy_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_laybuy_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		/* Condition for customer group */
		if ($status && config::get('payment_laybuy_customer_group')) {
			if (isset(session::$data['guest']) && in_array(0, config::get('payment_laybuy_customer_group'))) {
				$status = true;
			} elseif (customer::isLogged() && session::$data['customer_id']) {

				$customer = account_customer::getCustomer(session::$data['customer_id']);

				if (in_array($customer['customer_group_id'], config::get('payment_laybuy_customer_group'))) {
					session::$data['customer_group_id'] = $customer['customer_group_id'];

					$status = true;
				} else {
					$status = false;
				}
			} else {
				$status = false;
			}
		}

		/* Condition for categories and products */
		if ($status && config::get('payment_laybuy_category')) {
			$allowed_categories = config::get('payment_laybuy_category');

			$xproducts = explode(',', config::get('payment_laybuy_xproducts'));

			$cart_products = cart::getProducts();

			foreach ($cart_products as $cart_product) {
				$product = array();

				if ($xproducts && in_array($cart_product['product_id'], $xproducts)) {
					$status = false;
					break;
				} else {
					$product = db::query("SELECT GROUP_CONCAT(`category_id`) as `categories` FROM `product_to_category` WHERE `product_id` = " . (int)$cart_product['product_id']);

					$product = $product->row;

					$product = explode(',', $product['categories']);

					if ($product && count(array_diff($product, $allowed_categories)) > 0) {
						$status = false;
						break;
					}
				}
			}
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'			=> 'laybuy',
				'title'			=> language::get('text_title'),
				'terms'			=> '',
				'sort_order'	=> config::get('payment_laybuy_sort_order')
			);
		}

		return $method_data;
	}

	public static function getMonths() {
		load::language('extension/payment/laybuy');

		$max_months = config::get('payment_laybuy_max_months');

		if (!$max_months) {
			$max_months = 3;
		}

		if ($max_months < 1) {
			$max_months = 1;
		}

		$months = array();

		for ($i = 1; $i <= $max_months; $i++) {
			$months[] = array(
				'value' => $i,
				'label' => $i . ' ' . (($i > 1) ? language::get('text_months') : language::get('text_month'))
			);
		}

		return $months;
	}

	public static function getPayPalProfileIds() {
		$query = db::query("SELECT `paypal_profile_id` FROM `laybuy_transaction` WHERE `status` = '1'");

		return $query->rows;
	}

	public static function getRevisedTransaction($id) {
		$query = db::query("SELECT * FROM `laybuy_revise_request` WHERE `laybuy_revise_request_id` = " . (int)$id);

		return $query->row;
	}

	public static function getTransaction($id) {
		$query = db::query("SELECT * FROM `laybuy_transaction` WHERE `laybuy_transaction_id` = " . (int)$id);

		return $query->row;
	}

	public static function getTransactionByLayBuyRefId($laybuy_ref_id) {
		$query = db::query("SELECT * FROM `laybuy_transaction` WHERE `laybuy_ref_no` = " . (int)$laybuy_ref_id);

		return $query->row;
	}

	public static function log($data, $step = 6) {
		if (config::get('payment_laybuy_logging')) {
			$backtrace = debug_backtrace();

			$log = new Log('laybuy.log');

			$log::write('(' . $backtrace[$step]['class'] . '::$' . $backtrace[$step]['function'] . ') - ' . $data);
		}
	}

	public static function prepareTransactionReport($post_data) {

		load::language('extension/payment/laybuy');

		$data = array_change_key_case($post_data, CASE_LOWER);

		$data['order_id'] = $data['custom'];

		$order_info = checkout_order::getOrder($data['order_id']);

		$date_added = date(language::get('date_format_short'), strtotime($order_info['date_added']));

		$data['store_id'] = $order_info['store_id'];

		$data['date_added'] = $order_info['date_added'];

		$data['first_payment_due'] = date('Y-m-d h:i:s', strtotime(str_replace('/', '-', $data['first_payment_due'])));

		$data['last_payment_due'] = date('Y-m-d h:i:s', strtotime(str_replace('/', '-', $data['last_payment_due'])));

		$months = (int)$data['months'];

		$report_content = array();

		$report_content[] = array(
			'instalment'	=> 0,
			'amount'		=> currency::format($data['downpayment_amount'], $data['currency']),
			'date'			=> $date_added,
			'pp_trans_id'	=> $data['dp_paypal_txn_id'],
			'status'		=> 'Completed'
		);

		for ($month = 1; $month <= $months; $month++) {
			$date = date("Y-m-d h:i:s", strtotime($data['first_payment_due'] . " +" . ($month -1) . " month"));
			$date = date(language::get('date_format_short'), strtotime($date));

			$report_content[] = array(
			'instalment'	=> $month,
			'amount'		=> currency::format($data['payment_amounts'], $data['currency']),
			'date'			=> $date,
			'pp_trans_id'	=> '',
			'status'		=> 'Pending'
			);
		}

		$data['report'] = json_encode($report_content);

		return $data;
	}

	public static function updateCronRunTime() {
		db::query("DELETE FROM `setting` WHERE `key` = 'laybuy_cron_time'");

		db::query("INSERT INTO `setting` SET `store_id` = '0', `code` = 'laybuy', `key` = 'laybuy_cron_time', `value` = NOW(), `serialized` = '0'");
	}

	public static function updateTransaction($id, $status, $report, $transaction) {
		db::query("UPDATE `laybuy_transaction` SET `status` = " . (int)$status . ", `report` = " . esc($report) . ", `transaction` = " . (int)$transaction . " WHERE `laybuy_transaction_id` = " . (int)$id);
	}
}