<?php
class extension_payment_pilibaba {
	public static function getMethod($address, $total) {
		load::language('extension/payment/pilibaba');

		$status = true;

		if (!isset(session::$data['shipping_method']['code']) || session::$data['shipping_method']['code'] != 'pilibaba.pilibaba') {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'			=> 'pilibaba',
				'title'			=> language::get('text_title'),
				'terms'			=> '',
				'sort_order'	=> config::get('payment_pilibaba_sort_order')
			);
		}

		return $method_data;
	}

	public static function getOrderTaxAmount($order_id) {
		$query = db::query("SELECT SUM(`value`) AS `value` FROM `order_total` WHERE `order_id` = " . (int)$order_id . " AND `code` = 'tax'");

		if ($query->num_rows) {
			return intval(round($query->row['value'], 2) * 100);
		} else {
			return 0;
		}
	}

	public static function addPilibabaOrder($response_data) {
		db::query("INSERT INTO `pilibaba_order` SET `order_id` = " . (int)$response_data['orderNo'] . ", `amount` = '" . (float)$response_data['orderAmount'] . "', `fee` = '" . (float)$response_data['fee'] . "', `tracking` = '', `date_added` = NOW()");
	}

	public static function getConsumerInfo($order_id) {
		$sign_msg = strtoupper(md5(config::get('payment_pilibaba_merchant_number') . $order_id . 'MD5' . config::get('payment_pilibaba_secret_key')));

		if (config::get('payment_pilibaba_environment') == 'live') {
			$url = 'https://www.pilibaba.com/pilipay/consumerInfo';
		} else {
			$url = 'http://pre.pilibaba.com/pilipay/consumerInfo';
		}

		$url .= '?merchantNo=' . config::get('payment_pilibaba_merchant_number') . '&orderNo=' . $order_id . '&signType=' . 'MD5' . '&signMsg=' . $sign_msg;

		self::log('URL: ' . $url);

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HEADER, false);
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$response = curl_exec($ch);
		if (curl_errno($ch)) {
			self::log('cURL error: ' . curl_errno($ch));
		}
		curl_close($ch);

		self::log('Response: ' . print_r($response, true));

		return json_decode($response, true);
	}

	public static function updateOrderInfo($data, $order_id) {
		$parts = explode(' ', $data['name']);

		$data['lastname'] = array_pop($parts);

		$data['firstname'] = implode(' ', $parts);

		db::query("UPDATE `order` SET `firstname` = " . esc($data['firstname']) . ", `lastname` = " . esc($data['lastname']) . ", `email` = " . esc($data['email']) . ", `telephone` = " . esc($data['mobile']) . ", `payment_firstname` = " . esc($data['firstname']) . ", `payment_lastname` = " . esc($data['lastname']) . ", `payment_address_1` = " . esc($data['address']) . ", `payment_city` = " . esc($data['city']) . ", `payment_postcode` = " . esc($data['zipcode']) . ", `payment_country` = " . esc($data['country']) . ", `payment_zone` = " . esc($data['district']) . ", `shipping_firstname` = " . esc($data['firstname']) . ", `shipping_lastname` = " . esc($data['lastname']) . ", `shipping_address_1` = " . esc($data['address']) . ", `shipping_city` = " . esc($data['city']) . ", `shipping_postcode` = " . esc($data['zipcode']) . ", `shipping_country` = " . esc($data['country']) . ", `shipping_zone` = " . esc($data['district']) . ", `date_modified` = NOW() WHERE `order_id` = " . (int)$order_id);
	}

	public static function log($data) {
		if (config::get('payment_pilibaba_logging')) {
			$log = new Log('pilibaba.log');

			$log::write($data);
		}
	}
}