<?php
class extension_payment_pp_payflow_iframe {
	public static function getMethod($address, $total) {
		load::language('extension/payment/pp_payflow_iframe');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_pp_payflow_iframe_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_pp_payflow_iframe_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_pp_payflow_iframe_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code' => 'pp_payflow_iframe',
				'title' => language::get('text_title'),
				'terms'      => '',
				'sort_order' => config::get('payment_pp_payflow_iframe_sort_order')
			);
		}

		return $method_data;
	}

	public static function getOrderId($secure_token_id) {
		$result = db::query("SELECT `order_id` FROM `paypal_payflow_iframe_order` WHERE `secure_token_id` = " . esc($secure_token_id))->row;

		if ($result) {
			$order_id = $result['order_id'];
		} else {
			$order_id = false;
		}

		return $order_id;
	}

	public static function addOrder($order_id, $secure_token_id) {
		db::query("INSERT INTO `paypal_payflow_iframe_order` SET `order_id` = " . (int)$order_id . ", `secure_token_id` = " . esc($secure_token_id));
	}

	public static function updateOrder($data) {
		db::query("
			UPDATE `paypal_payflow_iframe_order`
			SET `transaction_reference` = " . esc($data['transaction_reference']) . ",
				`transaction_type` = " . esc($data['transaction_type']) . ",
				`complete` = " . (int)$data['complete'] . "
			WHERE `secure_token_id` = " . esc($data['secure_token_id']) . "
		");
	}

	public static function call($data) {
		$default_parameters = array(
			'USER' => config::get('payment_pp_payflow_iframe_user'),
			'VENDOR' => config::get('payment_pp_payflow_iframe_vendor'),
			'PWD' => config::get('payment_pp_payflow_iframe_password'),
			'PARTNER' => config::get('payment_pp_payflow_iframe_partner'),
			'BUTTONSOURCE' => 'OpenCart_Cart_PFP',
		);

		$call_parameters = array_merge($data, $default_parameters);

		if (config::get('payment_pp_payflow_iframe_test')) {
			$url = 'https://pilot-payflowpro.paypal.com';
		} else {
			$url = 'https://payflowpro.paypal.com';
		}

		$query_params = array();

		foreach ($call_parameters as $key => $value) {
			$query_params[] = $key . '=' . utf8_decode($value);
		}

		self::log('Call data: ' . implode('&', $query_params));

		$curl = curl_init($url);

		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, implode('&', $query_params));
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_HEADER, false);
		curl_setopt($curl, CURLOPT_TIMEOUT, 30);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

		$response = curl_exec($curl);

		self::log('Response data: ' . $response);

		$response_params = array();
		parse_str($response, $response_params);

		return $response_params;
	}

	public static function addTransaction($data) {
		db::query("
			INSERT INTO paypal_payflow_iframe_order_transaction
			SET order_id = " . (int)$data['order_id'] . ",
				transaction_reference = " . esc($data['transaction_reference']) . ",
				transaction_type = " . esc($data['type']) . ",
				`time` = NOW(),
				`amount` = '" . db::escape($data['amount']) .  "'
		");
	}

	public static function log($message) {
		if (config::get('payment_pp_payflow_iframe_debug')) {
			$log = new Log('payflow-iframe.log');
			$log::write($message);
		}
	}
}