<?php
class extension_payment_realex {
	public static function getMethod($address, $total) {
		load::language('extension/payment/realex');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_realex_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_realex_total') > 0 && config::get('payment_realex_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_realex_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'realex',
				'title'      => language::get('text_title'),
				'terms'      => '',
				'sort_order' => config::get('payment_realex_sort_order')
			);
		}

		return $method_data;
	}

	public static function addOrder($order_info, $pas_ref, $auth_code, $account, $order_ref) {
		if (config::get('payment_realex_auto_settle') == 1) {
			$settle_status = 1;
		} else {
			$settle_status = 0;
		}

		db::query("INSERT INTO `realex_order` SET `order_id` = " . (int)$order_info['order_id'] . ", `settle_type` = " . (int)config::get('payment_realex_auto_settle') . ", `order_ref` = " . esc($order_ref) . ", `order_ref_previous` = " . esc($order_ref) . ", `date_added` = now(), `date_modified` = now(), `capture_status` = " . (int)$settle_status . ", `currency_code` = " . esc($order_info['currency_code']) . ", `pasref` = " . esc($pas_ref) . ", `pasref_previous` = " . esc($pas_ref) . ", `authcode` = " . esc($auth_code) . ", `account` = " . esc($account) . ", `total` = '" . currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false) . "'");

		return db::getLastId();
	}

	public static function addTransaction($realex_order_id, $type, $order_info) {
		db::query("INSERT INTO `realex_order_transaction` SET `realex_order_id` = " . (int)$realex_order_id . ", `date_added` = now(), `type` = " . esc($type) . ", `amount` = '" . currency::format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false) . "'");
	}

	public static function addHistory($order_id, $order_status_id, $comment) {
		db::query("INSERT INTO order_history SET order_id = " . (int)$order_id . ", order_status_id = " . (int)$order_status_id . ", notify = '0', comment = " . esc($comment) . ", date_added = NOW()");
	}

	public static function logger($message) {
		if (config::get('payment_realex_debug') == 1) {
			$log = new Log('realex.log');
			$log::write($message);
		}
	}
}