<?php
class extension_payment_securetrading_pp {
	public static function getMethod($address, $total) {
		load::language('extension/payment/securetrading_pp');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_securetrading_pp_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_securetrading_pp_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_securetrading_pp_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'securetrading_pp',
				'title'      => language::get('text_title'),
				'terms'      => '',
				'sort_order' => config::get('payment_securetrading_pp_sort_order')
			);
		}

		return $method_data;
	}

	public static function getOrder($order_id) {
		$qry = db::query("SELECT * FROM `securetrading_pp_order` WHERE `order_id` = " . (int)$order_id . " LIMIT 1");

		return $qry->row;
	}

	public static function editOrder($order_id, $order) {
		db::query("UPDATE `order` SET shipping_firstname = " . esc($order['shipping_firstname']) . ", shipping_lastname = " . esc($order['shipping_lastname']) . ", shipping_address_1 = " . esc($order['shipping_address_1']) . ", shipping_address_2 = " . esc($order['shipping_address_2']) . ", shipping_city = " . esc($order['shipping_city']) . ", shipping_zone = " . esc($order['shipping_zone']) . ", shipping_zone_id = " . (int)$order['shipping_zone_id'] . ", shipping_country = " . esc($order['shipping_country']) . ", shipping_country_id = " . (int)$order['shipping_country_id'] . ", shipping_postcode = " . esc($order['shipping_postcode']) . ",  payment_firstname = " . esc($order['payment_firstname']) . ", payment_lastname = " . esc($order['payment_lastname']) . ", payment_address_1 = " . esc($order['payment_address_1']) . ", payment_address_2 = " . esc($order['payment_address_2']) . ", payment_city = " . esc($order['payment_city']) . ", payment_zone = " . esc($order['payment_zone']) . ", payment_zone_id = " . (int)$order['payment_zone_id'] . ", payment_country = " . esc($order['payment_country']) . ", payment_country_id = " . (int)$order['payment_country_id'] . ", payment_postcode = " . esc($order['payment_postcode']) . " WHERE order_id = " . (int)$order_id);
	}

	public static function addReference($order_id, $reference) {
		db::query("REPLACE INTO securetrading_pp_order SET order_id = " . (int)$order_id . ", transaction_reference = " . esc($reference) . ", `created` = now()");
	}

	public static function confirmOrder($order_id, $order_status_id, $comment = '', $notify = false) {

		self::logger('confirmOrder');


		db::query("UPDATE `order` SET order_status_id = 0 WHERE order_id = "  . (int)$order_id);

		checkout_order::addOrderHistory($order_id, $order_status_id, $comment, $notify);

		$order_info = checkout_order::getOrder($order_id);

		$securetrading_pp_order = self::getOrder($order_id);

		$amount = currency::format($order_info['total'], $order_info['currency_code'], false, false);

		switch(config::get('payment_securetrading_pp_settle_status')){
			case 0:
				$trans_type = 'auth';
				break;
			case 1:
				$trans_type = 'auth';
				break;
			case 2:
				$trans_type = 'suspended';
				break;
			case 100:
				$trans_type = 'payment';
				break;
			default :
				$trans_type = 'default';
		}

		db::query("UPDATE `securetrading_pp_order` SET `settle_type` = '" . config::get('payment_securetrading_pp_settle_status') . "', `modified` = now(), `currency_code` = " . esc($order_info['currency_code']) . ", `total` = '" . $amount . "' WHERE order_id = " . (int)$order_info['order_id']);

		db::query("INSERT INTO `securetrading_pp_order_transaction` SET `securetrading_pp_order_id` = " . (int)$securetrading_pp_order['securetrading_pp_order_id'] . ", `amount` = '" . $amount . "', type = '" . $trans_type . "',  `created` = now()");

	}

	public static function updateOrder($order_id, $order_status_id, $comment = '', $notify = false) {

		db::query("UPDATE `order` SET order_status_id = " . (int)$order_status_id . " WHERE order_id = " . (int)$order_id);

		checkout_order::addOrderHistory($order_id, $order_status_id, $comment, $notify);
	}

	public static function getCountry($iso_code_2) {
		return db::query("SELECT * FROM country WHERE LOWER(iso_code_2) = " . esc($iso_code_2))->row;
	}

	public static function logger($message) {
		$log = new Log('secure.log');
		$log::write($message);
	}
}