<?php
/**
 * @package		OpenCart
 * @author		Meng Wenbin
 * @copyright	Copyright (c) 2010 - 2017, Chengdu Guangda Network Technology Co. Ltd. (https://www.opencart.cn/)
 * @license		https://opensource.org/licenses/GPL-3.0
 * @link		https://www.opencart.cn
 */

class extension_payment_wechat_pay {
	public static function getMethod($address, $total) {
		load::language('extension/payment/wechat_pay');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('payment_wechat_pay_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (config::get('payment_wechat_pay_total') > 0 && config::get('payment_wechat_pay_total') > $total) {
			$status = false;
		} elseif (!config::get('payment_wechat_pay_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'wechat_pay',
				'title'      => language::get('text_title'),
				'terms'      => '',
				'sort_order' => config::get('payment_wechat_pay_sort_order')
			);
		}

		return $method_data;
	}
}
