<?php
class ModelExtensionShippingMeest2 extends Model {

    public function getResults($type_id, $search) {
		$parasits = array(
			'вул', 'ул','st',
			'пров','пер',
			'шоссе','шосе',
			'просп','ave',
			'blvd','бул'
		);
		$searches = preg_split("/[\s,.]+/", $search);
		$searches = array_diff($searches,$parasits);
		$searches = array_filter($searches);
		$relevant = "( ";
		$relevant .= "IF (`num` LIKE '" . $this->db->escape($search) . "%', 40, 0)"; 

		foreach ($searches as $word) {
			if ($word) {

		$relevant .= "+ IF (
		(`city_ua` LIKE '%" . $this->db->escape($word) . "%' 
		OR `city_ru` LIKE '%" . $this->db->escape($word) . "%' 
		OR `city_en` LIKE '%" . $this->db->escape($word) . "%' ), 30, 0) ";
		$relevant .= "+ IF (
		(`street_ua` LIKE '%" . $this->db->escape($word) . "%' 
		OR `street_ru` LIKE '%" . $this->db->escape($word) . "%' 
		OR `street_en` LIKE '%" . $this->db->escape($word) . "%'),10,0) 
	 ";
			}
		}
		$relevant .= " ) AS `relevant`,";
        $sql = "SELECT " . $relevant . " br_id, num, city_ua as city, street_ua as street, street_number, type_public_ua as type_public, lng,lat FROM " . DB_PREFIX . "meest2_branch WHERE  1";
		if (is_array($type_id)) {
			$sql .= " AND type_id IN ('" . implode("','", $type_id) . "')";
		} else {
			$sql .= " AND type_id = '" . $this->db->escape($type_id) . "'";
		}
		$sql .= " AND ( ";
			$sqls = array();
			$sqls[] = "num LIKE '" . $this->db->escape($search) . "%'";

			foreach ($searches as $word) {
				$sqls[] = "city_ua LIKE '%" . $this->db->escape($word) . "%'";
				$sqls[] = "city_ru LIKE '%" . $this->db->escape($word) . "%'";
				$sqls[] = "city_en LIKE '%" . $this->db->escape($word) . "%'";
				$sqls[] = "street_ua LIKE '%" . $this->db->escape($word) . "%'";
				$sqls[] = "street_ru LIKE '%" . $this->db->escape($word) . "%'";
				$sqls[] = "street_en LIKE '%" . $this->db->escape($word) . "%'";
			}
		$sql .= implode(' OR ', $sqls);
		$sql .= " ) ";
		$sql .= " ORDER BY relevant DESC, city_ua";
		$sql .= " LIMIT 20";

		$results = $this->db->query($sql);
		return $results->rows;
		
	}
		
    public function getQuote($address) {
        $data = $this->load->language('extension/shipping/meest2');

        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int) $this->config->get('free_geo_zone_id') . "' AND country_id = '" . (int) $address['country_id'] . "' AND (zone_id = '" . (int) $address['zone_id'] . "' OR zone_id = '0')");

        if (!$this->config->get('shipping_meest2_geo_zone_id')) {
            $status = true;
        } elseif ($query->num_rows) {
            $status = true;
        } else {
            $status = false;
        }

        if ($this->cart->getSubTotal() < $this->config->get('free_total')) {
            $status = false;
        }
        $image = 'image/catalog/meest2/meest_logo.svg';
        $image_html = '<img style="width:70px" src="image/catalog/meest2/meest_logo.svg" alt="' . $this->language->get('text_title') . '" title="'. $this->language->get('text_title') .'">';
        $image_html_service = '<img style="width:20px" src="image/catalog/meest2/meest-strilka.svg" alt="" title="">';

        $method_data = [];

        if ($status) {
            $quote_data = [];
			$shipping_meest_service = $this->config->get('shipping_meest2_service');

			if ($shipping_meest_service) {
				$length = count($shipping_meest_service);
				$costs = $this->config->get('shipping_meest2_cost');

				foreach ($shipping_meest_service as $key=>$service) {
					$quote_data[$service] = [
						'code'         => 'meest2.' . $service,
						'title'        => $image_html_service ." Meest: " . $this->language->get('text_title_' . $service),
						'cost'         => !empty($costs[$service])?$costs[$service]:0,
						'tax_class_id' => $this->config->get('shipping_meest2_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate((isset($costs[$service])?$costs[$service]:0), $this->config->get('meest2_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					];

					if ($key == $length-1) {
                        $html = $this->load->controller('extension/module/meest2',$data);
					    $quote_data[$service]['text'] .= '</label>' . $html;
					}
				}
	
				$method_data = [
					'code'       => 'meest2.meest2',
					'title'      => $image_html . $this->language->get('text_title'),
					'quote'      => $quote_data,
					'sort_order' => $this->config->get('shipping_meest2_sort_order'),
					'error'      => false
				];

			}
        }

        return $method_data;
    }

}
