<?php
class extension_shipping_parcelforce_48 {
	static function getQuote($address) {
		load::language('extension/shipping/parcelforce_48');

		$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)config::get('shipping_parcelforce_48_geo_zone_id') . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

		if (!config::get('shipping_parcelforce_48_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$cost = 0;
			$weight = cart::getWeight();
			$sub_total = cart::getSubTotal();

			$rates = explode(',', config::get('shipping_parcelforce_48_rate'));

			foreach ($rates as $rate) {
				$data = explode(':', $rate);

				if ($data[0] >= $weight) {
					if (isset($data[1])) {
						$cost = $data[1];
					}

					break;
				}
			}

			$rates = explode(',', config::get('shipping_parcelforce_48_insurance'));

			foreach ($rates as $rate) {
				$data = explode(':', $rate);

				if ($data[0] >= $sub_total) {
					if (isset($data[1])) {
						$insurance = $data[1];
					}

					break;
				}
			}

			$quote_data = array();

			if ((float)$cost) {
				$text = language::get('text_description');

				if (config::get('shipping_parcelforce_48_display_weight')) {
					$text .= ' (' . language::get('text_weight') . ' ' . weight::format($weight, config('weight_class_id')) . ')';
				}

				if (config::get('shipping_parcelforce_48_display_insurance') && (float)$insurance) {
					$text .= ' (' . language::get('text_insurance') . ' ' . currency::format($insurance, session::$data['currency']) . ')';
				}

				if (config::get('shipping_parcelforce_48_display_time')) {
					$text .= ' (' . language::get('text_time') . ')';
				}

				$quote_data['parcelforce_48'] = array(
					'code'         => 'parcelforce_48.parcelforce_48',
					'title'        => $text,
					'cost'         => $cost,
					'tax_class_id' => config::get('shipping_parcelforce_48_tax_class_id'),
					'text'         => currency::format(tax::calculate($cost, config::get('shipping_parcelforce_48_tax_class_id'), config('tax')), session::$data['currency'])
				);

				$method_data = array(
					'code'       => 'parcelforce_48',
					'title'      => language::get('text_title'),
					'quote'      => $quote_data,
					'sort_order' => config::get('shipping_parcelforce_48_sort_order'),
					'error'      => false
				);
			}
		}

		return $method_data;
	}
}