<?php
class extension_shipping_weight {
	public static function getQuote($address) {
		load::language('extension/shipping/weight');

		$quote_data = array();

		$query = db::query("SELECT * FROM geo_zone ORDER BY name");

        $weight = cart::getWeight();

		foreach ($query->rows as $result) {
			if (config::get('shipping_weight_' . $result['geo_zone_id'] . '_status')) {
				$query = db::query("SELECT * FROM zone_to_geo_zone WHERE geo_zone_id = " . (int)$result['geo_zone_id'] . " AND country_id = " . (int)$address['country_id'] . " AND (zone_id = " . (int)$address['zone_id'] . " OR zone_id = '0')");

				if ($query->num_rows) {
					$status = true;
				} else {
					$status = false;
				}
			} else {
				$status = false;
			}

			if ($status) {
				$cost = '';

				$rates = explode(',', config::get('shipping_weight_' . $result['geo_zone_id'] . '_rate'));

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				if ((string)$cost != '') {
					$quote_data['weight_' . $result['geo_zone_id']] = array(
						'code'         => 'weight.weight_' . $result['geo_zone_id'],
						'title'        => $result['name'] . '  (' . language::get('text_weight') . ' ' . weight::format($weight, config('weight_class_id')) . ')',
						'cost'         => $cost,
						'tax_class_id' => config::get('shipping_weight_tax_class_id'),
						'text'         => currency::format(tax::calculate($cost, config::get('shipping_weight_tax_class_id'), config('tax')), session::$data['currency'])
					);
				}
			}
		}

		$method_data = array();

		if ($quote_data) {
			$method_data = array(
				'code'       => 'weight',
				'title'      => language::get('text_title'),
				'quote'      => $quote_data,
				'sort_order' => config::get('shipping_weight_sort_order'),
				'error'      => false
			);
		}

		return $method_data;
	}
}
