<?php
class extension_total_handling {
	public static function getTotal($total) {
		if ((cart::getSubTotal() > config::get('total_handling_total')) && (cart::getSubTotal() > 0) && (cart::hasDownload() == false) && cart::hasShipping() == true) {
			load::language('extension/total/handling');

			$total['totals'][] = array(
				'code'       => 'handling',
				'title'      => language::get('text_handling'),
				'value'      => config::get('total_handling_fee'),
				'sort_order' => config::get('total_handling_sort_order')
			);

			if (config::get('total_handling_tax_class_id')) {
				$tax_rates = tax::getRates(config::get('total_handling_fee'), config::get('total_handling_tax_class_id'));

				foreach ($tax_rates as $tax_rate) {
					if (!isset($total['taxes'][$tax_rate['tax_rate_id']])) {
						$total['taxes'][$tax_rate['tax_rate_id']] = $tax_rate['amount'];
					} else {
						$total['taxes'][$tax_rate['tax_rate_id']] += $tax_rate['amount'];
					}
				}
			}

			$total['total'] += config::get('total_handling_fee');
		}
	}
}