<?php
class extension_total_klarna_fee {
	public static function getTotal($totals) {
		extract($totals);
		
		load::language('extension/total/klarna_fee');

		$status = true;

		$klarna_fee = config::get('klarna_fee');

		if (isset(session::$data['payment_address_id'])) {

			$address = account_address::getAddress(session::$data['payment_address_id']);
		} elseif (isset(session::$data['guest']['payment'])) {
			$address = session::$data['guest']['payment'];
		}

		if (!isset($address)) {
			$status = false;
		} elseif (!isset(session::$data['payment_method']['code']) || session::$data['payment_method']['code'] != 'klarna_invoice') {
			$status = false;
		} elseif (!isset($klarna_fee[$address['iso_code_3']])) {
			$status = false;
		} elseif (!$klarna_fee[$address['iso_code_3']]['status']) {
			$status = false;
		} elseif (cart::getSubTotal() >= $klarna_fee[$address['iso_code_3']]['total']) {
			$status = false;
		}

		if ($status) {
			$total['totals'][] = array(
				'code'       => 'klarna_fee',
				'title'      => language::get('text_klarna_fee'),
				'value'      => $klarna_fee[$address['iso_code_3']]['fee'],
				'sort_order' => $klarna_fee[$address['iso_code_3']]['sort_order']
			);

			$tax_rates = tax::getRates($klarna_fee[$address['iso_code_3']]['fee'], $klarna_fee[$address['iso_code_3']]['tax_class_id']);

			foreach ($tax_rates as $tax_rate) {
				if (!isset($total['taxes'][$tax_rate['tax_rate_id']])) {
					$total['taxes'][$tax_rate['tax_rate_id']] = $tax_rate['amount'];
				} else {
					$total['taxes'][$tax_rate['tax_rate_id']] += $tax_rate['amount'];
				}
			}

			$total['total'] += $klarna_fee[$address['iso_code_3']]['fee'];
		}
	}
}