<?php
class extension_total_reward {
	public static function getTotal($total) {
		if (isset(session::$data['reward'])) {
			load::language('extension/total/reward', 'reward');

			$points = customer::getRewardPoints();

			if (session::$data['reward'] <= $points) {
				$discount_total = 0;

				$points_total = 0;

				foreach (cart::getProducts() as $product) {
					if ($product['points']) {
						$points_total += $product['points'];
					}
				}

				$points = min($points, $points_total);

				foreach (cart::getProducts() as $product) {
					$discount = 0;

					if ($product['points']) {
						$discount = $product['total'] * (session::$data['reward'] / $points_total);

						if ($product['tax_class_id']) {
							$tax_rates = tax::getRates($product['total'] - ($product['total'] - $discount), $product['tax_class_id']);

							foreach ($tax_rates as $tax_rate) {
								if ($tax_rate['type'] == 'P') {
									$total['taxes'][$tax_rate['tax_rate_id']] -= $tax_rate['amount'];
								}
							}
						}
					}

					$discount_total += $discount;
				}

				$total['totals'][] = array(
					'code'       => 'reward',
					'title'      => sprintf(language::get('reward')::get('text_reward'), session::$data['reward']),
					'value'      => -$discount_total,
					'sort_order' => config::get('total_reward_sort_order')
				);

				$total['total'] -= $discount_total;
			}
		}
	}

	public static function confirm($order_info, $order_total) {
		load::language('extension/total/reward');

		$points = 0;

		$start = strpos($order_total['title'], '(') + 1;
		$end = strrpos($order_total['title'], ')');

		if ($start && $end) {
			$points = substr($order_total['title'], $start, $end - $start);
		}


		if (account_customer::getRewardTotal($order_info['customer_id']) >= $points) {
			db::query("INSERT INTO customer_reward SET customer_id = " . (int)$order_info['customer_id'] . ", order_id = " . (int)$order_info['order_id'] . ", description = " . esc(sprintf(language::get('text_order_id'), (int)$order_info['order_id'])) . ", points = '" . (float)-$points . "', date_added = NOW()");
		} else {
			return config('fraud_status_id');
		}
	}

	public static function unconfirm($order_id) {
		db::query("DELETE FROM customer_reward WHERE order_id = " . (int)$order_id . " AND points < 0");
	}
}
