<?php
class extension_total_shipping {
	public static function getTotal($total) {
		if (cart::hasShipping() && isset(session::$data['shipping_method'])) {
			$total['totals'][] = array(
				'code'       => 'shipping',
				'title'      => session::$data['shipping_method']['title'],
				'value'      => session::$data['shipping_method']['cost'],
				'sort_order' => config::get('total_shipping_sort_order')
			);

			if (session::$data['shipping_method']['tax_class_id']) {
				$tax_rates = tax::getRates(session::$data['shipping_method']['cost'], session::$data['shipping_method']['tax_class_id']);

				foreach ($tax_rates as $tax_rate) {
					if (!isset($total['taxes'][$tax_rate['tax_rate_id']])) {
						$total['taxes'][$tax_rate['tax_rate_id']] = $tax_rate['amount'];
					} else {
						$total['taxes'][$tax_rate['tax_rate_id']] += $tax_rate['amount'];
					}
				}
			}

			$total['total'] += session::$data['shipping_method']['cost'];
		}
	}
}