<?php
class extension_total_voucher {
	public static function addVoucher($order_id, $data) {
		db::query("INSERT INTO voucher SET order_id = " . (int)$order_id . ", code = " . esc($data['code']) . ", from_name = " . esc($data['from_name']) . ", from_email = " . esc($data['from_email']) . ", to_name = " . esc($data['to_name']) . ", to_email = " . esc($data['to_email']) . ", voucher_theme_id = " . (int)$data['voucher_theme_id'] . ", message = " . esc($data['message']) . ", amount = '" . (float)$data['amount'] . "', status = '1', date_added = NOW()");

		return db::getLastId();
	}

	public static function disableVoucher($order_id) {
		db::query("UPDATE voucher SET status = '0' WHERE order_id = " . (int)$order_id);
	}

	public static function getVoucher($code) {
		$status = true;

		$voucher_query = db::query("SELECT *, vtd.name AS theme FROM voucher v LEFT JOIN voucher_theme vt ON (v.voucher_theme_id = vt.voucher_theme_id) LEFT JOIN voucher_theme_description vtd ON (vt.voucher_theme_id = vtd.voucher_theme_id) WHERE v.code = " . esc($code) . " AND vtd.language_id = " . config('language_id') . " AND v.status = '1'");

		if ($voucher_query->num_rows) {
			if ($voucher_query->row['order_id']) {
				$implode = array();

				foreach (config('complete_status') as $order_status_id) {
					$implode[] = "" . (int)$order_status_id;
				}

				$order_query = db::query("SELECT order_id FROM `order` WHERE order_id = " . (int)$voucher_query->row['order_id'] . " AND order_status_id IN(" . implode(",", $implode) . ")");

				if (!$order_query->num_rows) {
					$status = false;
				}

				$order_voucher_query = db::query("SELECT order_voucher_id FROM `order_voucher` WHERE order_id = " . (int)$voucher_query->row['order_id'] . " AND voucher_id = " . (int)$voucher_query->row['voucher_id']);

				if (!$order_voucher_query->num_rows) {
					$status = false;
				}
			}

			$voucher_history_query = db::query("SELECT SUM(amount) AS total FROM `voucher_history` vh WHERE vh.voucher_id = " . (int)$voucher_query->row['voucher_id'] . " GROUP BY vh.voucher_id");

			if ($voucher_history_query->num_rows) {
				$amount = $voucher_query->row['amount'] + $voucher_history_query->row['total'];
			} else {
				$amount = $voucher_query->row['amount'];
			}

			if ($amount <= 0) {
				$status = false;
			}
		} else {
			$status = false;
		}

		if ($status) {
			return array(
				'voucher_id'       => $voucher_query->row['voucher_id'],
				'code'             => $voucher_query->row['code'],
				'from_name'        => $voucher_query->row['from_name'],
				'from_email'       => $voucher_query->row['from_email'],
				'to_name'          => $voucher_query->row['to_name'],
				'to_email'         => $voucher_query->row['to_email'],
				'voucher_theme_id' => $voucher_query->row['voucher_theme_id'],
				'theme'            => $voucher_query->row['theme'],
				'message'          => $voucher_query->row['message'],
				'image'            => $voucher_query->row['image'],
				'amount'           => $amount,
				'status'           => $voucher_query->row['status'],
				'date_added'       => $voucher_query->row['date_added']
			);
		}
	}

	public static function getTotal($total) {
		if (isset(session::$data['voucher'])) {
			load::language('extension/total/voucher', 'voucher');

			$voucher_info = self::getVoucher(session::$data['voucher']);

			if ($voucher_info) {
				$amount = min($voucher_info['amount'], $total['total']);
				
				if ($amount > 0) {
					$total['totals'][] = array(
						'code'       => 'voucher',
						'title'      => sprintf(language::get('voucher')::get('text_voucher'), session::$data['voucher']),
						'value'      => -$amount,
						'sort_order' => config::get('total_voucher_sort_order')
					);

					$total['total'] -= $amount;
				} else {
					unset(session::$data['voucher']);
				}
			} else {
				unset(session::$data['voucher']);
			}
		}
	}

	public static function confirm($order_info, $order_total) {
		$code = '';

		$start = strpos($order_total['title'], '(') + 1;
		$end = strrpos($order_total['title'], ')');

		if ($start && $end) {
			$code = substr($order_total['title'], $start, $end - $start);
		}

		if ($code) {
			$voucher_info = self::getVoucher($code);

			if ($voucher_info) {
				db::query("INSERT INTO `voucher_history` SET voucher_id = " . (int)$voucher_info['voucher_id'] . ", order_id = " . (int)$order_info['order_id'] . ", amount = '" . (float)$order_total['value'] . "', date_added = NOW()");
			} else {
				return config('fraud_status_id');
			}
		}
	}

	public static function unconfirm($order_id) {
		db::query("DELETE FROM `voucher_history` WHERE order_id = " . (int)$order_id);
	}
}
