<?php
/**
 * @package		OpenCart
 * @author		Daniel Kerr
 * @copyright	Copyright (c) 2005 - 2017, OpenCart, Ltd. (https://www.opencart.com/)
 * @license		https://opensource.org/licenses/GPL-3.0
 * @link		https://www.opencart.com
 */

/**
 * Action class
 */
class Action {

	static function execute(string $action, array $args = array()) {
		if (is_file(DIR_APPLICATION . "controller/$action.php")) {
			$route = $action;
			$method = 'index';
		}
		else {
			$p = strrpos($action, '/');
			$route = substr($action, 0, $p);
			$method = substr($action, $p + 1);
		}

		$file  = DIR_APPLICATION . 'controller/' . $route . '.php';
		$class = 'Controller' . preg_replace('/[^a-zA-Z0-9]/', '', $route);

		// Initialize the class
		if (is_file($file)) {
			include_once($file);
		} else {
			return new \Exception('Error: Could not call ' . $route . '/' . $method . '!');
		}

		$rm = new ReflectionMethod($class, $method);
		if ($rm->isStatic()) return call_user_func_array("$class::$method", $args);
		$object = new $class();
		return $object->$method($args);

		//return new \Exception('Error: Could not call ' . $route . '/' . $method . '!');
	}
}
