<?php
/**
 * @package		OpenCart
 * @author		Daniel Kerr
 * @copyright	Copyright (c) 2005 - 2017, OpenCart, Ltd. (https://www.opencart.com/)
 * @license		https://opensource.org/licenses/GPL-3.0
 * @link		https://www.opencart.com
*/

/**
* Router class
*/
final class Route {
	private static $pre_action = array();
	private static $error;
	
	/**
	 * Constructor
	 *
	 * @param	object	$route
 	*/
	static function init() {
	}
	
	/**
	 * 
	 *
	 * @param	object	$pre_action
 	*/	
	static function addPreAction(string $pre_action) {
		self::$pre_action[] = $pre_action;
	}

	/**
	 * 
	 *
	 * @param	object	$action
	 * @param	object	$error
 	*/		
	static function dispatch(string $action, string $error) {
		self::$error = $error;

		foreach (self::$pre_action as $pre_action) {
			$result = action::execute($pre_action);

			if ($result) {
				$action = $result;

				break;
			}
		}

		while ($action) {
			$action = action::execute($action);
		}
	}
	
	/**
	 * 
	 *
	 * @param	object	$action
	 * @return	object
 	*/
	private static function execute(string $action) {
		$result = $action::execute();

		if ($result) {
			return $result;
		} 
		
		if ($result instanceof Exception) {
			$action = self::$error;
			
			self::$error = null;
			
			return $action;
		}
	}
}