<?php
namespace Cache;
class APC {
	private static $expire;
	private static $active = false;

	public static function init($expire) {
		self::$expire = $expire;
		self::$active = function_exists('apc_cache_info') && ini_get('apc.enabled');
	}

	public static function get($key) {
		return self::$active ? apc_fetch(CACHE_PREFIX . $key) : false;
	}

	public static function set($key, $value) {
		return self::$active ? apc_store(CACHE_PREFIX . $key, $value, self::$expire) : false;
	}

	public static function delete($key) {
		if (!self::$active) {
			return false;
		}
		
		$cache_info = apc_cache_info('user');
		$cache_list = $cache_info['cache_list'];
		foreach ($cache_list as $entry) {
			if (strpos($entry['info'], CACHE_PREFIX . $key) === 0) {
				apcu_delete($entry['info']);
			}
		}
	}
}
