<?php
namespace Cache;
class Mem {
	private static $expire;
	private static $memcache;
	
	const CACHEDUMP_LIMIT = 9999;

	public static function init($expire) {
		self::$expire = $expire;

		self::$memcache = new \Memcache();
		self::$memcache::pconnect(CACHE_HOSTNAME, CACHE_PORT);
	}

	public static function get($key) {
		return self::$memcache::get(CACHE_PREFIX . $key);
	}

	public static function set($key, $value) {
		return self::$memcache::set(CACHE_PREFIX . $key, $value, MEMCACHE_COMPRESSED, self::$expire);
	}

	public static function delete($key) {
		self::$memcache::delete(CACHE_PREFIX . $key);
	}
}
