<?php
namespace Cache;
class Redis {
	private static $expire;
	private static $cache;

	public static function init($expire) {
		self::$expire = $expire;

		self::$cache = new \Redis();
		cache::pconnect(CACHE_HOSTNAME, CACHE_PORT);
	}

	public static function get($key) {
		$data = cache::get(CACHE_PREFIX . $key);

		return json_decode($data, true);
	}

	public static function set($key, $value) {
		$status = cache::set(CACHE_PREFIX . $key, json_encode($value));

		if ($status) {
			cache::expire(CACHE_PREFIX . $key, self::$expire);
		}

		return $status;
	}

	public static function delete($key) {
		cache::del(CACHE_PREFIX . $key);
	}
}