<?php
class Customer {
	private static $customer_id;
	private static $firstname;
	private static $lastname;
	private static $customer_group_id;
	private static $email;
	private static $telephone;
	private static $newsletter;
	private static $address_id;

	public static function init() {
		if (isset(session::$data['customer_id'])) {
			$customer_query = db::query("SELECT * FROM customer WHERE customer_id = " . (int)session::$data['customer_id'] . " AND status = '1'");

			if ($customer_query->num_rows) {
				self::$customer_id = $customer_query->row['customer_id'];
				self::$firstname = $customer_query->row['firstname'];
				self::$lastname = $customer_query->row['lastname'];
				self::$customer_group_id = $customer_query->row['customer_group_id'];
				self::$email = $customer_query->row['email'];
				self::$telephone = $customer_query->row['telephone'];
				self::$newsletter = $customer_query->row['newsletter'];
				self::$address_id = $customer_query->row['address_id'];

				db::query("UPDATE customer SET language_id = " . config('language_id') . ", ip = " . esc(request::$server['REMOTE_ADDR']) . " WHERE customer_id = " . (int)self::$customer_id);

				$query = db::query("SELECT * FROM customer_ip WHERE customer_id = " . (int)session::$data['customer_id'] . " AND ip = " . esc(request::$server['REMOTE_ADDR']));

				if (!$query->num_rows) {
					db::query("INSERT INTO customer_ip SET customer_id = " . (int)session::$data['customer_id'] . ", ip = " . esc(request::$server['REMOTE_ADDR']) . ", date_added = NOW()");
				}
			} else {
				self::logout();
			}
		}
	}

  public static function login($email, $password, $override = false) {
		if ($override) {
			$customer_query = db::query("SELECT * FROM customer WHERE LOWER(email) = " . esc(utf8_strtolower($email)) . " AND status = '1'");
		} else {
			$customer_query = db::query("SELECT * FROM customer WHERE LOWER(email) = " . esc(utf8_strtolower($email)) . " AND (password = SHA1(CONCAT(salt, SHA1(CONCAT(salt, SHA1(" . esc($password) . "))))) OR password = " . esc(md5($password)) . ") AND status = '1'");
		}

		if ($customer_query->num_rows) {
			session::$data['customer_id'] = $customer_query->row['customer_id'];

			self::$customer_id = $customer_query->row['customer_id'];
			self::$firstname = $customer_query->row['firstname'];
			self::$lastname = $customer_query->row['lastname'];
			self::$customer_group_id = $customer_query->row['customer_group_id'];
			self::$email = $customer_query->row['email'];
			self::$telephone = $customer_query->row['telephone'];
			self::$newsletter = $customer_query->row['newsletter'];
			self::$address_id = $customer_query->row['address_id'];
		
			db::query("UPDATE customer SET language_id = " . config('language_id') . ", ip = " . esc(request::$server['REMOTE_ADDR']) . " WHERE customer_id = " . (int)self::$customer_id);

			return true;
		} else {
			return false;
		}
	}

	public static function logout() {
		unset(session::$data['customer_id']);

		self::$customer_id = '';
		self::$firstname = '';
		self::$lastname = '';
		self::$customer_group_id = '';
		self::$email = '';
		self::$telephone = '';
		self::$newsletter = '';
		self::$address_id = '';
	}

	public static function isLogged() {
		return self::$customer_id;
	}

	public static function getId() {
		return self::$customer_id;
	}

	public static function getFirstName() {
		return self::$firstname;
	}

	public static function getLastName() {
		return self::$lastname;
	}

	public static function getGroupId() {
		return self::$customer_group_id;
	}

	public static function getEmail() {
		return self::$email;
	}

	public static function getTelephone() {
		return self::$telephone;
	}

	public static function getNewsletter() {
		return self::$newsletter;
	}

	public static function getAddressId() {
		return self::$address_id;
	}

	public static function getBalance() {
		$query = db::query("SELECT SUM(amount) AS total FROM customer_transaction WHERE customer_id = " . (int)self::$customer_id);

		return $query->row['total'];
	}

	public static function getRewardPoints() {
		$query = db::query("SELECT SUM(points) AS total FROM customer_reward WHERE customer_id = " . (int)self::$customer_id);

		return $query->row['total'];
	}
}
