<?php
class Length {
	private static $lengths = array();

	public static function init() {

		$length_class_query = db::query("SELECT * FROM length_class mc LEFT JOIN length_class_description mcd ON (mc.length_class_id = mcd.length_class_id) WHERE mcd.language_id = " . config('language_id'));

		foreach ($length_class_query->rows as $result) {
			self::$lengths[$result['length_class_id']] = array(
				'length_class_id' => $result['length_class_id'],
				'title'           => $result['title'],
				'unit'            => $result['unit'],
				'value'           => $result['value']
			);
		}
	}

	public static function convert($value, $from, $to) {
		if ($from == $to) {
			return $value;
		}

		if (isset(self::$lengths[$from])) {
			$from = self::$lengths[$from]['value'];
		} else {
			$from = 1;
		}

		if (isset(self::$lengths[$to])) {
			$to = self::$lengths[$to]['value'];
		} else {
			$to = 1;
		}

		return $value * ($to / $from);
	}

	public static function format($value, $length_class_id, $decimal_point = '.', $thousand_point = ',') {
		if (isset(self::$lengths[$length_class_id])) {
			return number_format($value, 2, $decimal_point, $thousand_point) . self::$lengths[$length_class_id]['unit'];
		} else {
			return number_format($value, 2, $decimal_point, $thousand_point);
		}
	}

	public static function getUnit($length_class_id) {
		if (isset(self::$lengths[$length_class_id])) {
			return self::$lengths[$length_class_id]['unit'];
		} else {
			return '';
		}
	}
}
