<?php
class Weight {
	private static $weights = array();

	public static function init() {

		$weight_class_query = db::query("SELECT * FROM weight_class wc LEFT JOIN weight_class_description wcd ON (wc.weight_class_id = wcd.weight_class_id) WHERE wcd.language_id = " . config('language_id'));

		foreach ($weight_class_query->rows as $result) {
			self::$weights[$result['weight_class_id']] = array(
				'weight_class_id' => $result['weight_class_id'],
				'title'           => $result['title'],
				'unit'            => $result['unit'],
				'value'           => $result['value']
			);
		}
	}

	public static function convert($value, $from, $to) {
		if ($from == $to) {
			return $value;
		}

		if (isset(self::$weights[$from])) {
			$from = self::$weights[$from]['value'];
		} else {
			$from = 1;
		}

		if (isset(self::$weights[$to])) {
			$to = self::$weights[$to]['value'];
		} else {
			$to = 1;
		}

		return $value * ($to / $from);
	}

	public static function format($value, $weight_class_id, $decimal_point = '.', $thousand_point = ',') {
		if (isset(self::$weights[$weight_class_id])) {
			return number_format($value, 2, $decimal_point, $thousand_point) . self::$weights[$weight_class_id]['unit'];
		} else {
			return number_format($value, 2, $decimal_point, $thousand_point);
		}
	}

	public static function getUnit($weight_class_id) {
		if (isset(self::$weights[$weight_class_id])) {
			return self::$weights[$weight_class_id]['unit'];
		} else {
			return '';
		}
	}
}