<?php
/**
 * @package		OpenCart
 * @author		Daniel Kerr
 * @copyright	Copyright (c) 2005 - 2017, OpenCart, Ltd. (https://www.opencart.com/)
 * @license		https://opensource.org/licenses/GPL-3.0
 * @link		https://www.opencart.com
*/

/**
* Config class
*/
class Config {
	private static $data = array();
    
	/**
     * 
     *
     * @param	string	$key
	 * 
	 * @return	mixed
     */
	public static function get($key) {
		return (isset(self::$data[$key]) ? self::$data[$key] : null);
	}
	
    /**
     * 
     *
     * @param	string	$key
	 * @param	string	$value
     */
	public static function set($key, $value) {
		self::$data[$key] = $value;
	}

    /**
     * 
     *
     * @param	string	$key
	 *
	 * @return	mixed
     */
	public static function has($key) {
		return isset(self::$data[$key]);
	}
	
    /**
     * 
     *
     * @param	string	$filename
     */
	public static function load($filename) {
		$file = DIR_CONFIG . $filename . '.php';

		if (file_exists($file)) {
			$_ = array();

			require($file);

			self::$data = array_merge(self::$data, $_);
		} else {
			trigger_error('Error: Could not load config ' . $filename . '!');
			exit();
		}
	}
}

function config($config_key) {
	if (str_ends_with($config_key, '_id'))
		return (int) config::get("config_$config_key");

	return config::get("config_$config_key");
}