<?php
/**
 * @package		OpenCart
 * @author		Daniel Kerr
 * @copyright	Copyright (c) 2005 - 2017, OpenCart, Ltd. (https://www.opencart.com/)
 * @license		https://opensource.org/licenses/GPL-3.0
 * @link		https://www.opencart.com
*/

/**
* Document class
*/
class Document {
	private static $title;
	private static $description;
	private static $keywords;

	private static $links = array();
	private static $styles = array();
	private static $scripts = array();

	/**
     * 
     *
     * @param	string	$title
     */
	public static function setTitle($title) {
		self::$title = $title;
	}

	/**
     * 
	 * 
	 * @return	string
     */
	public static function getTitle() {
		return self::$title;
	}

	/**
     * 
     *
     * @param	string	$description
     */
	public static function setDescription($description) {
		self::$description = $description;
	}

	/**
     * 
     *
     * @param	string	$description
	 * 
	 * @return	string
     */
	public static function getDescription() {
		return self::$description;
	}

	/**
     * 
     *
     * @param	string	$keywords
     */
	public static function setKeywords($keywords) {
		self::$keywords = $keywords;
	}

	/**
     *
	 * 
	 * @return	string
     */
	public static function getKeywords() {
		return self::$keywords;
	}
	
	/**
     * 
     *
     * @param	string	$href
	 * @param	string	$rel
     */
	public static function addLink($href, $rel) {
		self::$links[$href] = array(
			'href' => $href,
			'rel'  => $rel
		);
	}

	/**
     * 
	 * 
	 * @return	array
     */
	public static function getLinks() {
		return self::$links;
	}

	/**
     * 
     *
     * @param	string	$href
	 * @param	string	$rel
	 * @param	string	$media
     */
	public static function addStyle($href, $rel = 'stylesheet', $media = 'screen', $position = 'header') {
		self::$styles[$position][$href] = array(
			'href'  => $href,
			'rel'   => $rel,
			'media' => $media
		);
	}

	/**
     * 
	 * 
	 * @return	array
     */
	public static function getStyles($position = 'header') {
		if (isset(self::$styles[$position])) {
			return self::$styles[$position];
		} else {
			return array();
		}
	}

	/**
     * 
     *
     * @param	string	$href
	 * @param	string	$position
     */
	public static function addScript($href, $position = 'header') {
		self::$scripts[$position][$href] = $href;
	}

	/**
     * 
     *
     * @param	string	$position
	 * 
	 * @return	array
     */
	public static function getScripts($position = 'header') {
		if (isset(self::$scripts[$position])) {
			return self::$scripts[$position];
		} else {
			return array();
		}
	}
}