<?php

namespace googleshopping;

/**
* Log class
*/
class Log {
    private static $handle;
    
    /**
     * Constructor
     *
     * @param   string  $filename
    */
    public static function init($filename, $max_size = 8388608) {
        $file = DIR_LOGS . $filename;

        clearstatcache(true);

        if ((!file_exists($file) && !is_writable(DIR_LOGS)) || (file_exists($file) && !is_writable($file))) {
            // Do nothing, as we have no permissions
            return;
        }

        if (file_exists($file) && filesize($file) >= $max_size) {
            $mode = 'wb';
        } else {
            $mode = 'ab';
        }

        self::$handle = @fopen(DIR_LOGS . $filename, $mode);
    }
    
    /**
     * 
     *
     * @param   string  $message
     */
    public static function write($message) {
        if (is_resource(self::$handle)) {
            fwrite(self::$handle, date('Y-m-d G:i:s') . ' - ' . print_r($message, true) . "\n");
        }
    }
    
    /**
     * 
     *
     */
    public static function finish() {
        if (is_resource(self::$handle)) {
            fclose(self::$handle);
        }
    }
}
