<?php
/**
 * @package		OpenCart
 * @author		Daniel Kerr
 * @copyright	Copyright (c) 2005 - 2017, OpenCart, Ltd. (https://www.opencart.com/)
 * @license		https://opensource.org/licenses/GPL-3.0
 * @link		https://www.opencart.com
*/

/**
* Language class
*/
class Language {
	private static $default = 'en-gb';
	private static $directory;
	public static $data = array();
	
	/**
	 * Constructor
	 *
	 * @param	string	$file
	 *
 	*/
	public static function init($directory = '') {
		self::$directory = $directory;
	}
	
	/**
     * 
     *
     * @param	string	$key
	 * 
	 * @return	string
     */
	public static function get($key) {
		return (isset(self::$data[$key]) ? self::$data[$key] : $key);
	}
	
	public static function set($key, $value) {
		self::$data[$key] = $value;
	}
	
	/**
     * 
     *
	 * @return	array
     */	
	public static function all() {
		return self::$data;
	}
	
	public static function setAll($data) {
		self::$data = $data;
	}	
	
	/**
     * 
     *
     * @param	string	$filename
	 * @param	string	$key
	 * 
	 * @return	array
     */	
	public static function load($filename, $key = '') {
		if (!$key) {
			$_ = array();
	
			$file = DIR_LANGUAGE . self::$default . '/' . $filename . '.php';
	
			if (is_file($file)) {
				require($file);
			}
	
			$file = DIR_LANGUAGE . self::$directory . '/' . $filename . '.php';
			
			if (is_file($file)) {
				require($file);
			} 
	
			self::$data = array_merge(self::$data, $_);
		} else {
			// Put the language into a sub key
			self::$data[$key] = new Language(self::$directory);
			self::$data[$key]::load($filename);
		}
		
		return self::$data;
	}
}