<?php
/**
 * @package		OpenCart
 * @author		Daniel Kerr
 * @copyright	Copyright (c) 2005 - 2017, OpenCart, Ltd. (https://www.opencart.com/)
 * @license		https://opensource.org/licenses/GPL-3.0
 * @link		https://www.opencart.com
*/

/**
* Pagination class
*/
class Pagination {
	public static $total = 0;
	public static $page = 1;
	public static $limit = 20;
	public static $num_links = 8;
	public static $url = '';
	public static $text_first = '|&lt;';
	public static $text_last = '&gt;|';
	public static $text_next = '&gt;';
	public static $text_prev = '&lt;';

	/**
     * 
     *
     * @return	text
     */
	public static function render() {
		$total = self::$total;

		if (self::$page < 1) {
			$page = 1;
		} else {
			$page = self::$page;
		}

		if (!(int)self::$limit) {
			$limit = 10;
		} else {
			$limit = self::$limit;
		}

		$num_links = self::$num_links;
		$num_pages = ceil($total / $limit);

		self::$url = str_replace('%7Bpage%7D', '{page}', self::$url);

		$output = '<ul class="pagination">';

		if ($page > 1) {
			$output .= '<li><a href="' . str_replace(array('&amp;page={page}', '?page={page}', '&page={page}'), '', self::$url) . '">' . self::$text_first . '</a></li>';
			
			if ($page - 1 === 1) {
				$output .= '<li><a href="' . str_replace(array('&amp;page={page}', '?page={page}', '&page={page}'), '', self::$url) . '">' . self::$text_prev . '</a></li>';
			} else {
				$output .= '<li><a href="' . str_replace('{page}', $page - 1, self::$url) . '">' . self::$text_prev . '</a></li>';
			}
		}

		if ($num_pages > 1) {
			if ($num_pages <= $num_links) {
				$start = 1;
				$end = $num_pages;
			} else {
				$start = $page - floor($num_links / 2);
				$end = $page + floor($num_links / 2);

				if ($start < 1) {
					$end += abs($start) + 1;
					$start = 1;
				}

				if ($end > $num_pages) {
					$start -= ($end - $num_pages);
					$end = $num_pages;
				}
			}

			for ($i = $start; $i <= $end; $i++) {
				if ($page == $i) {
					$output .= '<li class="active"><span>' . $i . '</span></li>';
				} else {
					if ($i === 1) {
						$output .= '<li><a href="' . str_replace(array('&amp;page={page}', '?page={page}', '&page={page}'), '', self::$url) . '">' . $i . '</a></li>';
					} else {
						$output .= '<li><a href="' . str_replace('{page}', $i, self::$url) . '">' . $i . '</a></li>';
					}
				}
			}
		}

		if ($page < $num_pages) {
			$output .= '<li><a href="' . str_replace('{page}', $page + 1, self::$url) . '">' . self::$text_next . '</a></li>';
			$output .= '<li><a href="' . str_replace('{page}', $num_pages, self::$url) . '">' . self::$text_last . '</a></li>';
		}

		$output .= '</ul>';

		if ($num_pages > 1) {
			return $output;
		} else {
			return '';
		}
	}
}
