<?php
/**
 * @package		OpenCart
 * @author		Daniel Kerr
 * @copyright	Copyright (c) 2005 - 2017, OpenCart, Ltd. (https://www.opencart.com/)
 * @license		https://opensource.org/licenses/GPL-3.0
 * @link		https://www.opencart.com
*/

/**
* Request class
*/
class Request {
	public static $get = array();
	public static $post = array();
	public static $request = array();
	public static $cookie = array();
	public static $files = array();
	public static $server = array();
	
	/**
	 * Constructor
 	*/
	public static function init() {
		self::$get = self::clean($_GET);
		self::$post = self::clean($_POST);
		self::$request = self::clean($_REQUEST);
		self::$cookie = self::clean($_COOKIE);
		self::$files = self::clean($_FILES);
		self::$server = self::clean($_SERVER);
	}
	
	/**
     * 
	 * @param	array	$data
	 *
     * @return	array
     */
	public static function clean($data) {
		if (is_array($data)) {
			foreach ($data as $key => $value) {
				unset($data[$key]);

				$data[self::clean($key)] = self::clean($value);
			}
		} else {
			$data = htmlspecialchars($data, ENT_COMPAT, 'UTF-8');
		}

		return $data;
	}
}