<?php
namespace Session;

final class DB {
	public $maxlifetime;
	public $db;

	public function __construct() {

		$this->maxlifetime = ini_get('session.gc_maxlifetime') !== null ? (int)ini_get('session.gc_maxlifetime') : 1440;

		$this->gc();
	}

	public function read($session_id) {
		$query = \db::query("SELECT `data` FROM `session` WHERE `session_id` = " . esc($session_id) . " AND `expire` > " . esc(date('Y-m-d H:i:s', time())));

		if ($query->num_rows) {
			return json_decode($query->row['data'], true);
		} else {
			return array();
		}
	}

	public function write($session_id, $data) {
		if ($session_id) {
			\db::query("REPLACE INTO `session` SET `session_id` = " . esc($session_id) . ", `data` = " . esc(json_encode($data)) . ", `expire` = " . esc(date('Y-m-d H:i:s', time() + (int)$this->maxlifetime)));
		}

		return true;
	}

	public function destroy($session_id) {
		\db::query("DELETE FROM `session` WHERE `session_id` = " . esc($session_id));

		return true;
	}

	public function gc() {
		if (ini_get('session.gc_divisor') && $gc_divisor = (int)ini_get('session.gc_divisor')) {
			$gc_divisor = $gc_divisor === 0 ? 100 : $gc_divisor;
		} else {
			$gc_divisor = 100;
		}

		if (ini_get('session.gc_probability')) {
			$gc_probability = (int)ini_get('session.gc_probability');
		} else {
			$gc_probability = 1;
		}

		if (mt_rand() / mt_getrandmax() < $gc_probability / $gc_divisor) {
			\db::query("DELETE FROM `session` WHERE `expire` < " . esc(date('Y-m-d H:i:s', time())));

			return true;
		}
	}
}
